Package: COTAN
Type: Package
Title: COexpression Tables ANalysis
Version: 2.12.0
Authors@R: c(
  person("Galfrè", "Silvia Giulia",email = "silvia.galfre@di.unipi.it", role=c("aut","cre"),comment = c(ORCID = "0000-0002-2770-0344")),
  person("Morandin","Francesco", email = "francesco.morandin@unipr.it", role = "aut",comment = c(ORCID = "0000-0002-2022-2300")),
  person("Fantozzi", "Marco", email = "marco.fantozzi@gmail.com", role = "aut", comment = c(ORCID = "0000-0002-0708-5495")),
  person("Pietrosanto","Marco", role = "aut",comment = c(ORCID = "0000-0001-5129-6065")),
  person("Puttini","Daniel", role = "aut", comment = c(ORCID = "0009-0006-8401-9949")),
  person("Priami","Corrado", role = "aut", comment = c(ORCID = "0000-0002-3261-6235")),
  person("Cremisi","Federico", role = "aut",comment = c(ORCID = "0000-0003-4925-2703")),
  person("Helmer-Citterich","Manuela", role = "aut",comment = c(ORCID = "0000-0001-9530-7504"))
  )
Description: Statistical and computational method to analyze the co-expression of 
    gene pairs at single cell level. It provides the foundation for single-cell gene 
    interactome analysis. The basic idea is studying the zero UMI counts' distribution 
    instead of focusing on positive counts; this is done with a generalized contingency 
    tables framework. COTAN can effectively assess the correlated or anti-correlated 
    expression of gene pairs. It provides a numerical index related to the correlation and an 
    approximate p-value for the associated independence test. COTAN can also evaluate whether 
    single genes are differentially expressed, scoring them with a newly defined global 
    differentiation index. Moreover, this approach provides ways to plot and cluster genes
    according to their co-expression pattern with other genes, effectively helping the study 
    of gene interactions and becoming a new tool to identify cell-identity marker genes.
URL: https://github.com/seriph78/COTAN
BugReports: https://github.com/seriph78/COTAN/issues
Depends: R (>= 4.3)
License: GPL-3
Encoding: UTF-8
RoxygenNote: 7.3.3
Roxygen: list(markdown = TRUE)
Imports: stats, methods, grDevices, Matrix, ggplot2, ggrepel, ggdist,
        ggthemes, graphics, parallel, parallelly, tibble, tidyr, dplyr,
        BiocSingular, parallelDist, ComplexHeatmap, circlize, grid,
        scales, RColorBrewer, utils, rlang, Rfast, stringr, Seurat,
        dendextend, zeallot, assertthat, withr, SummarizedExperiment,
        SingleCellExperiment, proxy, RSpectra
Suggests: testthat (>= 3.2.0), proto, spelling, knitr, ragg, Cairo,
        conflicted, data.table, gsubfn, R.utils, tidyverse, rmarkdown,
        htmlwidgets, MASS, Rtsne, plotly, BiocStyle, cowplot, qpdf,
        GEOquery, sf, torch, S4Vectors
Config/testthat/edition: 3
Language: en-US
biocViews: SystemsBiology, Transcriptomics, GeneExpression, SingleCell,
        DifferentialExpression, Clustering, GPU
VignetteBuilder: knitr
LazyData: false
git_url: https://git.bioconductor.org/packages/COTAN
git_branch: RELEASE_3_23
git_last_commit: c7bfb93
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 21:35:52 UTC; biocbuild
Author: Galfrè Silvia Giulia [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-2770-0344>),
  Morandin Francesco [aut] (ORCID:
    <https://orcid.org/0000-0002-2022-2300>),
  Fantozzi Marco [aut] (ORCID: <https://orcid.org/0000-0002-0708-5495>),
  Pietrosanto Marco [aut] (ORCID:
    <https://orcid.org/0000-0001-5129-6065>),
  Puttini Daniel [aut] (ORCID: <https://orcid.org/0009-0006-8401-9949>),
  Priami Corrado [aut] (ORCID: <https://orcid.org/0000-0002-3261-6235>),
  Cremisi Federico [aut] (ORCID: <https://orcid.org/0000-0003-4925-2703>),
  Helmer-Citterich Manuela [aut] (ORCID:
    <https://orcid.org/0000-0001-9530-7504>)
Maintainer: Galfrè Silvia Giulia <silvia.galfre@di.unipi.it>

# COTAN v2

This package provides a *comprehensive* and *versatile* framework for single-cell **gene Co-Expression** studies and cell type identification.

## About

The estimation of gene *co-expression* in single-cell RNA sequencing (scRNA-seq) is a critical step in the analysis of scRNA-seq data. The low efficiency of scRNA-seq methodologies makes sensitive computational approaches crucial to accurately infer transcription profiles in a cell population.

`COTAN` is a statistical and computational method that analyzes the co-expression of gene pairs at the single-cell level. It employs an innovative mathematical model that leads to a generalized contingency table framework. `COTAN` relies on the zero *Unique Molecular Identifier* (`UMI`) counts distribution instead of focusing on positive counts to evaluate or extract different scores and information for gene correlation studies and gene or cell clustering.

`COTAN` assesses whether gene pairs are *correlated* or *anti-correlated*, providing a new correlation index with an approximate `p-value` for the associated test of independence. It also checks whether single genes are differentially expressed, scoring them with a newly defined *Global Differentiation Index* (`GDI`). `COTAN` plots and clusters genes according to their co-expression pattern with other genes to study gene interactions and identify cell-identity markers.

`COTAN` introduces a novel feature that uses gene `GDI` values to assess the biological *uniformity* of a cell cluster. This feature allows researchers to apply an iterative cell clustering pipeline and achieve a finer resolution of uniform clusters. `COTAN` shows high sensitivity in extracting information from small clusters and lowly expressed genes. Furthermore, `COTAN` leverages its contingency table framework to directly identify genes that are over-represented or under-represented in the cluster with respect to the rest of the data-set. `COTAN` computes an enrichment score for a given list of marker genes, which can be used to identify and merge small uniform clusters and to check a final cluster identification.

In recent versions new functions and plots to check and clean the data-set were included along several visualization tools to help users explore and interpret their data. `COTAN` has a user-friendly interface that is easy to use and does not require extensive programming skills. The strength of `COTAN` is its ability to help researchers better understand scRNA-seq data. By identifying gene modules, cell types, and new marker genes, researchers gain insights into the underlying biology of their samples. This helps disease diagnosis, drug discovery, and other applications. In summary, `COTAN` is a powerful and versatile tool for the analysis of scRNA-seq data, with the potential to facilitate the discovery of new cell types and biological insights.

## Examples

Main source of examples for the `COTAN v2` are the *vignettes*:

1.  [Cleaning](https://bioc.r-universe.dev/COTAN/doc/Cleaning_GuidedTutorial.html)
2.  [Genes' clustering](https://bioc.r-universe.dev/COTAN/doc/GenesClustering_GuidedTutorial.html)
3.  [Uniform cells' clustering](https://bioc.r-universe.dev/COTAN/doc/UniformClustering_GuidedTutorial.html)
4.  [Differential Expression Analysis](https://bioc.r-universe.dev/COTAN/doc/DiffExprAnalysis_GuidedTutorial.html)

There are illustrated the preparatory cleaning steps, various analysis results and plots done on the data-set `"Mouse Cortex E17.5, <GEO:GSM2861514>"`

Further more it is possible to look at some other examples on real data-sets at [COTAN paper](https://seriph78.github.io/Cotan_paper/index.html) and more extensively at [COTAN Datasets analysis](https://seriph78.github.io/COTAN_Datasets_analysis/).

The first link shows how to handle the genes' clustering while the second shows how to use the new cells' clustering functions to obtain **uniform clusterizations** [Please note: the first link has not been upgraded to the version 2, so, while it is possible to reproduce all the steps there described, they need to be manually adapted to the new interface to be executed]

## Installation

| Build | Status |
|----|----|
| BioConductor (release) | [![BioConductor-release](https://images.weserv.nl/?url=bioconductor.org/shields/build/release/bioc/COTAN.svg)](https://bioconductor.org/checkResults/release/bioc-LATEST/COTAN) |
| BioConductor (devel) | [![BioConductor-devel](https://images.weserv.nl/?url=bioconductor.org/shields/build/devel/bioc/COTAN.svg)](https://bioconductor.org/checkResults/devel/bioc-LATEST/COTAN/) |

Check out the user guide on the Bioconductor landing pages for more details

-   [`release`](https://bioc-release.r-universe.dev/COTAN)
-   [`devel`](https://bioc.r-universe.dev/COTAN)

The latest snapshot can be installed directly as `R` package using `devtools`. The installation was tested on *Linux*, *Windows* and *Mac* but please note that due to lack of multi-core support under *Windows* it might run slower. `devtools::install_github("seriph78/COTAN")`

From version 2.5.0 `COTAN` can optionally use the `torch` library and thus, in case, use the `GPU` for some of its calculations, with substantial speed-ups. However this implies a possibly more complicated installation process: see the specific help page [Installing torch](https://github.com/seriph78/COTAN/blob/devel/man/Installing_torch.Rd) for some pointers.

#' @details `reorderClusterization()` takes in a *clusterizations* and reorder
#'   its labels so that in the new order near labels indicate near clusters
#'   according to a *DEA* (or *Zero-One*) based distance
#'
#' @param objCOTAN a `COTAN` object
#' @param clName The name of the *clusterization*. If not given the last
#'   available *clusterization* will be used, as it is probably the most
#'   significant!
#' @param clusters A *clusterization* to use. If given it will take precedence
#'   on the one indicated by `clName`
#' @param coexDF a `data.frame` where each column indicates the `COEX` for each
#'   of the *clusters* of the *clusterization*
#' @param reverse a flag to the output order
#' @param keepMinusOne a flag to decide whether to keep the cluster `"-1"`
#'   (representing the non-clustered cells) untouched
#' @param useDEA Boolean indicating whether to use the *DEA* to define the
#'   distance; alternatively it will use the average *Zero-One* counts, that is
#'   faster but less precise.
#' @param distance type of distance to use. Default is `"cosine"` for *DEA* and
#'   `"euclidean"` for *Zero-One*. Can be chosen among those supported by
#'   [parallelDist::parDist()]
#' @param hclustMethod It defaults is `"ward.D2"` but can be any of the methods
#'   defined by the [stats::hclust()] function.
#'
#' @returns `reorderClusterization()` returns a `list` with 3 elements:
#'   * `"clusters"` the newly reordered cluster labels array
#'   * `"coex"` the associated `COEX` `data.frame`
#'   * `"permMap"` the reordering mapping
#'
#' @export
#'
#' @importFrom rlang set_names
#' @importFrom rlang is_null
#'
#' @importFrom stats hclust
#' @importFrom stats as.dist
#'
#' @rdname HandlingClusterizations
#'

reorderClusterization <- function(objCOTAN,
                                  clName = "", clusters = NULL, coexDF = NULL,
                                  reverse = FALSE, keepMinusOne = TRUE,
                                  useDEA = TRUE, distance = NULL,
                                  hclustMethod = "ward.D2") {
  # picks up the last clusterization if none was given
  c(clName, clusters) %<-%
    normalizeNameAndLabels(objCOTAN, name = clName,
                           labels = clusters, isCond = FALSE)

  clDist <- distancesBetweenClusters(objCOTAN, clName = clName,
                                     clusters = clusters, coexDF = coexDF,
                                     useDEA = useDEA, distance = distance)

  dummyList <- list("clusters" = factor(clusters), "coex" = coexDF,
                    "permMap" = set_names(labels(clDist), labels(clDist)))

  minuOnePos <- 0L
  if (keepMinusOne && any(clusters == "-1")) {
    minuOnePos <- which(labels(clDist) == "-1")
    # drop cluster '-1' from the distances
    clDist <- as.dist(as.matrix(clDist)[-minuOnePos, -minuOnePos, drop = FALSE])
  }

  if (length(labels(clDist)) <= 1L) {
    # too few clusters, nothing to reorder: return input as is
    return(dummyList)
  } else {
    rm(dummyList)
  }

  hc <- hclust(clDist, method = hclustMethod)

  # we exploit the rank(x) == order(order(x))
  perm <- order(hc[["order"]])

  if (isTRUE(reverse)) {
    perm <- (length(perm) + 1L) - perm
  }

  clNames <- hc[["labels"]]
  clMap <- set_names(clNames[perm], clNames)

  # handle cluster "-1" separately
  if (minuOnePos != 0L) {
    clMap[["-1"]] <- "-1"
  }

  logThis("Applied reordering to clusterization is:", logLevel = 1L)
  logThis(paste(paste0(names(clMap)), " -> ", paste0(clMap),
                collapse = ", "), logLevel = 1L)

  outputClusters <- factorToVector(factor(clusters))
  outputClusters <- set_names(clMap[outputClusters], names(outputClusters))

  if (is_empty(coexDF) && clName %in% getClusterizations(objCOTAN)) {
    coexDF <- getClusterizationData(objCOTAN, clName = clName)[["coex"]]
  }

  outputCoexDF <- coexDF
  if (!is_empty(coexDF)) {

    minusOnePosInCoex <- 0L
    if (minuOnePos != 0L) {
      minusOnePosInCoex <- which(colnames(coexDF) == "-1")
      outputCoexDF <- coexDF[, -minusOnePosInCoex]
    }

    colnames(outputCoexDF) <- clMap[colnames(outputCoexDF)]

    # Reorder the columns to match wanted order
    outputCoexDF <- outputCoexDF[, hc[["order"]]]

    if (minuOnePos != 0L) {
      outputCoexDF <- setColumnInDF(df = outputCoexDF, colName = "-1",
                                    colToSet = coexDF[, minusOnePosInCoex])
    }
  }

  return(list("clusters" = factor(outputClusters),
              "coex" = outputCoexDF, "permMap" = clMap))
}

## ----knitr options, echo = FALSE, include = FALSE-----------------------------
plotDev <- if (requireNamespace("ragg", quietly = TRUE)) {
  "ragg_png"
} else if (requireNamespace("Cairo", quietly = TRUE)) {
  "cairo_png"
} else {
  "png"
}

knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  fig.width = 7L,
  fig.height = 5L,
  dev = plotDev,
  fig.crop = FALSE,
  dpi = 100L
)

## ----preamble, message=FALSE, warning=FALSE-----------------------------------
library(COTAN)
library(zeallot)

# necessary to solve precedence of overloads
conflicted::conflict_prefer("%<-%", "zeallot")

# enable multi-processing (not on Windows)
prevOptState <- options(parallelly.fork.enable = TRUE)

## ----setup-and-log------------------------------------------------------------
dataDir <- file.path(tempdir(), "COTAN_vignette_data")
dir.create(dataDir, recursive = TRUE, showWarnings = FALSE)

print(dataDir)

outDir <- dataDir

# Log-level 2 was chosen to showcase better how the package works
# In normal usage a level of 0 or 1 is more appropriate
setLoggingLevel(2L)

# This file will contain all the logs produced by the package
# as if at the highest logging level
setLoggingFile(file.path(outDir, "vignette_dataset_cleaning.log"))

## ----download-data------------------------------------------------------------
GEO <- "GSM2861514"

dir.create(file.path(dataDir, GEO), showWarnings = FALSE)

datasetFileName <-
  file.path(dataDir, GEO, "GSM2861514_E175_All_Cells_DGE.txt.gz")

# retries up to 5 times to get the dataset
attempts <- 0L
maxAttempts <- 5L
ok <- FALSE

while (attempts < maxAttempts && !ok) {
  attempts <- attempts + 1L

  if (!file.exists(datasetFileName)) {
    res <- try(
      GEOquery::getGEOSuppFiles(
        GEO = GEO,
        makeDirectory = TRUE,
        baseDir = dataDir,
        filter_regex = base::basename(datasetFileName),
        fetch_files = TRUE
      ),
      silent = TRUE
    )
  }

  ok <- file.exists(datasetFileName)

  if (!ok && attempts < maxAttempts) {
    Sys.sleep(1)
  }
}

assertthat::assert_that(
  ok,
  msg = paste0(
    "Failed to retrieve file '", datasetFileName,
    "' after ", maxAttempts, " attempts."
  )
)

rawDataset <- read.csv(datasetFileName, sep = "\t", row.names = 1L)

print(dim(rawDataset))

## ----create-cotan-object------------------------------------------------------
cond <- "mouse_cortex_E17.5"

obj <- COTAN(raw = rawDataset)
obj <-
  initializeMetaDataset(
    obj,
    GEO = GEO,
    sequencingMethod = "Drop_seq",
    sampleCondition = cond
  )

logThis(paste0("Condition ", getMetadataElement(obj, datasetTags()[["cond"]])),
        logLevel = 1L)

## ----conversions-to-and-from-sce----------------------------------------------
sceObj <- convertToSingleCellExperiment(obj)

obj2 <- convertFromSingleCellExperiment(
  sceObj,
  assayName = "counts",   # the assay that contains the raw counts
  genesNamesPattern = "", # reg-exp to identify genes' names column
  cellsIDsPattern = "",   # reg-exp to identify cells' ID column
  clNamesPattern = "",    # reg-exp to identify clusterizations columns
  condNamesPattern = ""   # reg-exp to identify cells' conditions columns
)

rm(sceObj, obj2)

## ----add-origin-to-the-cotan-object-------------------------------------------
# mark cells origin
data(vignette.cells.origin)
head(vignette.cells.origin, 18)

obj <- 
  addCondition(obj, condName = "origin", conditions = vignette.cells.origin)

rm(vignette.cells.origin)

# Sometimes the condition is encoded in the cells ID using some separator
# so it is useful to use the following function to retrieve it
if (FALSE) { # This is not the case with the dataset currently in use
  batch <- COTAN::conditionsFromNames(
    names = getCells(obj), splitPattern = "_", fragmentNum = 2L)
  names(batch) <- getCells(obj)
  obj <- addCondition(obj, condName = "batch", conditions = batch)
}

## ----ecd-plot-----------------------------------------------------------------
plot(ECDPlot(obj, condName = "origin"))

## ----cells-size-plot----------------------------------------------------------
plot(cellSizePlot(obj, condName = "origin"))

## ----number-detected-genes----------------------------------------------------
plot(genesSizePlot(obj, condName = "origin"))

## ----scatter-plot-------------------------------------------------------------
plot(scatterPlot(obj, condName = "origin"))

## ----cull-probable-doublets---------------------------------------------------
# Store the used threshold in the COTAN object for later reference
cellsSizeThr <- 6000L
obj <- addElementToMetaDataset(obj, "Cells size threshold", cellsSizeThr)

cellsToRem <- getCells(obj)[getCellsSize(obj) > cellsSizeThr]
obj <- dropGenesCells(obj, cells = cellsToRem)

plot(cellSizePlot(obj, condName = "origin"))

## ----cull-probable-doublets_2-------------------------------------------------
# Store the used threshold in the COTAN object for later reference
genesSizeHighThr <- 3000L
obj <-
  addElementToMetaDataset(obj, "Num genes high threshold", genesSizeHighThr)

cellsToRem <- getCells(obj)[getNumExpressedGenes(obj) > genesSizeHighThr]
obj <- dropGenesCells(obj, cells = cellsToRem)

plot(genesSizePlot(obj, condName = "origin"))

## ----cull-probable-dead-cells-------------------------------------------------
# Store the used threshold in the COTAN object for later reference
genesSizeLowThr <- 500L
obj <- addElementToMetaDataset(obj, "Num genes low threshold", genesSizeLowThr)

cellsToRem <- getCells(obj)[getNumExpressedGenes(obj) < genesSizeLowThr]
obj <- dropGenesCells(obj, cells = cellsToRem)

plot(genesSizePlot(obj, condName = "origin"))

## ----calculate-mitochondrial-genes-percentage---------------------------------
c(mitPlot, mitSizes) %<-%
  mitochondrialPercentagePlot(obj, genePrefix = "^mt-", condName = "origin")

plot(mitPlot)

## ----cull-probable-dead-cells_2-----------------------------------------------
# Store the used threshold in the COTAN object for later reference
mitPercThr <- 3.5
obj <- addElementToMetaDataset(obj, "Mitoc. perc. threshold", mitPercThr)

cellsToRem <- rownames(mitSizes)[mitSizes[["mit.percentage"]] > mitPercThr]
obj <- dropGenesCells(obj, cells = cellsToRem)

c(mitPlot, mitSizes) %<-%
  mitochondrialPercentagePlot(obj, genePrefix = "^mt-", condName = "origin")

plot(mitPlot)

## ----scatter-plot_2-----------------------------------------------------------
plot(scatterPlot(obj, condName = "origin"))

## ----log-current-dataset-status-----------------------------------------------
logThis(paste("n cells", getNumCells(obj)), logLevel = 1L)

getDims(obj)

## ----calculate-b-group-from-pca-----------------------------------------------
obj <- addElementToMetaDataset(obj, "Num drop B group", 0L)

obj <- clean(obj)

c(pcaCellsPlot, pcaCellsData, genesPlot,
  UDEPlot, nuPlot, zoomedNuPlot) %<-% cleanPlots(obj)

plot(pcaCellsPlot)

## ----show-most-expressed-genes-b-group----------------------------------------
plot(genesPlot)

## ----cells-efficiency-pca-plot------------------------------------------------
plot(UDEPlot)

## ----cells-efficiency-plot----------------------------------------------------
plot(nuPlot)

## ----cells-efficiency-plot_low-tail-------------------------------------------
plot(zoomedNuPlot)

## ----cull-b-group-and-recalculate---------------------------------------------
cellsToRem <- rownames(pcaCellsData)[pcaCellsData[["groups"]] == "B"]
obj <- dropGenesCells(obj, cells = cellsToRem)

# Store how many times the B group was dropped
obj <- addElementToMetaDataset(obj, "Num drop B group", 1L)

## ----cull-low-efficiency-cells------------------------------------------------
udeLowThr <- 0.34
obj <- addElementToMetaDataset(obj, "Low UDE cells' threshold", udeLowThr)

obj <- estimateNuLinear(obj)

cellsToRem <- getCells(obj)[getNu(obj) < udeLowThr]
obj <- dropGenesCells(obj, cells = cellsToRem)

## ----raw-plots----------------------------------------------------------------
plot(ECDPlot(obj, condName = "origin"))

plot(cellSizePlot(obj, condName = "origin"))

plot(genesSizePlot(obj, condName = "origin"))

plot(scatterPlot(obj, condName = "origin"))

c(mitPlot, mitSizes) %<-%
  mitochondrialPercentagePlot(obj, genePrefix = "^mt-", condName = "origin")

plot(mitPlot)

## ----recalculate-clean-plots--------------------------------------------------
obj <- clean(obj)

c(pcaCellsPlot, pcaCellsData, genesPlot,
  UDEPlot, nuPlot, zoomedNuPlot) %<-% cleanPlots(obj)

## ----show-clean-plots---------------------------------------------------------
plot(pcaCellsPlot)

plot(genesPlot)

plot(UDEPlot)

plot(nuPlot)
plot(zoomedNuPlot)

# It is also possible to directly plot the PCA results
plot(pcaCellsData)

## ----log-updated-dataset-status-----------------------------------------------
logThis(paste("n cells", getNumCells(obj)), logLevel = 1L)

table(getCondition(obj, condName = "origin"))

## ----final-clean-up-----------------------------------------------------------
if (file.exists(file.path(outDir, paste0(cond, ".cotan.RDS")))) {
  # delete file if it exists
  file.remove(file.path(outDir, paste0(cond, ".cotan.RDS")))
}
if (file.exists(file.path(outDir, paste0(cond, "_times.csv")))) {
  # delete file if it exists
  file.remove(file.path(outDir, paste0(cond, "_times.csv")))
}
if (dir.exists(file.path(outDir, cond))) {
  unlink(file.path(outDir, cond), recursive = TRUE)
}
# if (dir.exists(file.path(outDir, GEO))) {
#   unlink(file.path(outDir, GEO), recursive = TRUE)
# }

# stop logging to file
setLoggingFile("")
file.remove(file.path(outDir, "vignette_dataset_cleaning.log"))

options(prevOptState)

## ----closure------------------------------------------------------------------
Sys.time()

sessionInfo()

#' @aliases clean
#'
#' @details `clean()` is the main method that can be used to check and clean the
#'   dataset. It will discard any genes that has less than 3 non-zero counts per
#'   thousand cells and all cells expressing less than 2 per thousand genes.
#'   also produces and stores the estimators for `nu`
#'
#' @param objCOTAN a `COTAN` object
#' @param cellsCutoff `clean()` will delete from the `raw` data any gene that is
#'   expressed in less cells than threshold times the total number of cells.
#'   Default cutoff is \eqn{0.003 \; (0.3\%)}
#' @param genesCutoff `clean()` will delete from the `raw` data any cell that is
#'   expressing less genes than threshold times the total number of genes.
#'   Default cutoff is \eqn{0.002 \; (0.2\%)}
#' @param cellsThreshold any gene that is expressed in more cells than threshold
#'   times the total number of cells will be marked as **fully-expressed**.
#'   Default threshold is \eqn{0.99 \; (99.0\%)}
#' @param genesThreshold any cell that is expressing more genes than threshold
#'   times the total number of genes will be marked as **fully-expressing**.
#'   Default threshold is \eqn{0.99 \; (99.0\%)}
#'
#' @returns `clean()` returns the updated `COTAN` object
#'
#' @importFrom rlang is_empty
#'
#' @export
#'
#' @rdname RawDataCleaning
#'
setMethod(
  "clean",
  "COTAN",
  function(objCOTAN, cellsCutoff = 0.003, genesCutoff = 0.002,
           cellsThreshold = 0.99, genesThreshold = 0.99) {

    # We want to discard genes having less than given cutoff
    # default: less than 3 non-zero counts per 1000 cells
    cutoff <- round(getNumCells(objCOTAN) * cellsCutoff, digits = 0L)
    genesToDrop <-
      getGenes(objCOTAN)[getNumOfExpressingCells(objCOTAN) <= cutoff]

    if (!is_empty(genesToDrop)) {
      objCOTAN <- dropGenesCells(objCOTAN, genes = genesToDrop)
    }

    # We want to discard cells having less than given cutoff
    # default: less than 2 non-zero counts per 1000 genes
    cutoff <- round(getNumGenes(objCOTAN) * genesCutoff, digits = 0L)
    cellsToDrop <-
      getCells(objCOTAN)[getNumExpressedGenes(objCOTAN) <= cutoff]

    if (!is_empty(cellsToDrop)) {
      objCOTAN <- dropGenesCells(objCOTAN, cells = cellsToDrop)
    }

    logThis(paste0("Genes/cells selection done:",
                   " dropped [", length(genesToDrop), "] genes",
                   " and [", length(cellsToDrop), "] cells"),
            logLevel = 2L)

    logThis(paste0("Working on [", getNumGenes(objCOTAN), "]",
                   " genes and [", getNumCells(objCOTAN), "] cells"),
            logLevel = 1L)

    objCOTAN <- findFullyExpressedGenes(objCOTAN,
                                        cellsThreshold = cellsThreshold)
    objCOTAN <- findFullyExpressingCells(objCOTAN,
                                         genesThreshold = genesThreshold)

    objCOTAN <- estimateNuLinear(objCOTAN)

    return(objCOTAN)
  }
)

# ------------ Metadata handling ------------

# EXTREMELY IMPORTANT: DO NOT CHANGE THE LIST UP TO ELEMENT 8!!

#' @details `datasetTags()` defines a list of short names associated to an
#'   enumeration. It also defines the relative long names as they appear in the
#'   meta-data
#'
#' @returns `datasetTags()` a named `character array` with the standard labels
#'   used in the `metaDataset` of the `COTAN` objects
#'
#' @export
#'
#' @rdname HandleMetaData
#'
datasetTags <- function() {
  return(c("GEO"   = "GEO:"                                             # 1
         , "sc.m"  = "scRNAseq method:"                                 # 2
         , "cond"  = "condition sample:"                                # 3
         , "cells" = "starting n. of cells:"                            # 4
         , "gsync" = "genes' COEX is in sync:"                          # 5
         , "csync" = "cells' COEX is in sync:"                          # 6
         , "gbad"  = "genes' pairs fraction with small expected count:" # 7
         , "cbad"  = "cells' pairs fraction with small expected count:" # 8
         ))
}


#' @aliases initializeMetaDataset
#'
#' @details `initializeMetaDataset()` initializes meta-data data-set
#'
#' @param objCOTAN the `COTAN` object
#' @param GEO a code reporting the GEO identification or other specific data-set
#'   code
#' @param sequencingMethod a string reporting the method used for the sequencing
#' @param sampleCondition a string reporting the specific sample condition or
#'   time point
#'
#' @returns `initializeMetaDataset()` returns the given `COTAN` object with the
#'   updated `metaDataset`
#'
#' @export
#'
#' @rdname HandleMetaData
#'
setMethod(
  "initializeMetaDataset",
  "COTAN",
  function(objCOTAN, GEO, sequencingMethod, sampleCondition) {
    logThis("Initializing `COTAN` meta-data", logLevel = 2L)

    tags <- datasetTags()

    meta <- objCOTAN@metaDataset

    meta <- updateMetaInfo(meta, tags[["GEO"]],   GEO)
    meta <- updateMetaInfo(meta, tags[["sc.m"]],  sequencingMethod)
    meta <- updateMetaInfo(meta, tags[["cond"]],  sampleCondition)
    meta <- updateMetaInfo(meta, tags[["cells"]], getNumCells(objCOTAN))
    meta <- updateMetaInfo(meta, tags[["gsync"]], FALSE)
    meta <- updateMetaInfo(meta, tags[["csync"]], FALSE)

    objCOTAN@metaDataset <- meta

    return(objCOTAN)
  }
)

#' @aliases addElementToMetaDataset
#'
#' @details `addElementToMetaDataset()` is used to add a line of information to
#'   the meta-data `data.frame`. If the tag was already used it will update the
#'   associated value(s) instead
#'
#' @param objCOTAN a `COTAN` object
#' @param tag the new information tag
#' @param value a value (or an array) containing the information
#'
#' @returns `addElementToMetaDataset()` returns the updated `COTAN` object
#'
#' @export
#'
#' @rdname HandleMetaData
#'
setMethod(
  "addElementToMetaDataset",
  "COTAN",
  function(objCOTAN, tag, value) {
    objCOTAN@metaDataset <- updateMetaInfo(objCOTAN@metaDataset, tag, value)

    return(objCOTAN)
  }
)


# ------------ Raw data cleaning --------------

#' @aliases findFullyExpressedGenes
#'
#' @details `findFullyExpressedGenes()` determines the fully-expressed genes
#'   inside the raw data
#'
#' @param objCOTAN a `COTAN` object
#' @param cellsThreshold any gene that is expressed in more cells than threshold
#'   times the total number of cells will be marked as **fully-expressed**.
#'   Default threshold is \eqn{0.99 \; (99.0\%)}
#'
#' @returns `findFullyExpressedGenes()` returns the given `COTAN` object with
#'   updated **fully-expressed** genes' information
#'
#' @export
#'
#' @rdname RawDataCleaning
#'
setMethod(
  "findFullyExpressedGenes",
  "COTAN",
  function(objCOTAN, cellsThreshold = 0.99) {

    threshold <- cellsThreshold * getNumCells(objCOTAN)
    feGenes <- getNumOfExpressingCells(objCOTAN) >= threshold

    objCOTAN@metaGenes <-
      setColumnInDF(objCOTAN@metaGenes, feGenes, "feGenes", getGenes(objCOTAN))

    return(objCOTAN)
  }
)


#' @aliases findFullyExpressingCells
#'
#' @details `findFullyExpressingCells()` determines the cells that are
#'   expressing all genes in the dataset
#'
#' @param objCOTAN a `COTAN` object
#' @param genesThreshold any cell that is expressing more genes than threshold
#'   times the total number of genes will be marked as **fully-expressing**.
#'   Default threshold is \eqn{0.99 \; (99.0\%)}
#'
#' @returns `findFullyExpressingCells()` returns the given `COTAN` object  with
#'   updated **fully-expressing** cells' information
#'
#' @export
#'
#' @rdname RawDataCleaning
#'
setMethod(
  "findFullyExpressingCells",
  "COTAN",
  function(objCOTAN, genesThreshold = 0.99) {

    threshold <- genesThreshold * getNumGenes(objCOTAN)
    feCells <- getNumExpressedGenes(objCOTAN) >= threshold

    objCOTAN@metaCells <-
      setColumnInDF(objCOTAN@metaCells, feCells,
                    "feCells", getCells(objCOTAN))

    return(objCOTAN)
  }
)

#' @aliases setLambda
#'
#' @details `setLambda()` adds a column to the genes' metadata with the lambda
#'   (genes' counts averages) for the given batch
#'
#' @param objCOTAN a `COTAN` object
#' @param lambda a named array that gives the values for lambda
#'
#' @returns `setLambda()` returns the updated `COTAN` object
#'
#' @importFrom assertthat assert_that
#'
#' @export
#'
#' @rdname RawDataCleaning
#'
setMethod(
  "setLambda",
  "COTAN",
  function(objCOTAN, lambda) {
    assert_that(length(lambda) == getNumGenes(objCOTAN))

    if (TRUE) {
      oldLambda <- getMetadataGenes(objCOTAN)[["lambda"]]
      if (!identical(lambda, oldLambda)) {
        # flag the COEX slots are out of sync (if any)!
        objCOTAN@metaDataset <- updateMetaInfo(objCOTAN@metaDataset,
                                               datasetTags()[["gsync"]], FALSE)
        objCOTAN@metaDataset <- updateMetaInfo(objCOTAN@metaDataset,
                                               datasetTags()[["csync"]], FALSE)
      }
    }

    objCOTAN@metaGenes <-
      setColumnInDF(objCOTAN@metaGenes, lambda,
                    "lambda", getGenes(objCOTAN))

    return(objCOTAN)
  }
)


#' @aliases setDispersion
#'
#' @details `setDispersion()` adds a column to the genes' metadata with the
#'   negative binomial dispersion factor for the given batch
#'
#' @param objCOTAN a `COTAN` object
#' @param dispersion a named array that gives the values for the dispersion
#'
#' @returns `setDispersion()` returns the updated `COTAN` object
#'
#' @importFrom assertthat assert_that
#'
#' @export
#'
#' @rdname RawDataCleaning
#'
setMethod(
  "setDispersion",
  "COTAN",
  function(objCOTAN, dispersion) {
    assert_that(length(dispersion) == getNumGenes(objCOTAN))

    if (TRUE) {
      oldDispersion <-  getMetadataGenes(objCOTAN)[["dispersion"]]
      if (!identical(dispersion, oldDispersion)) {
        # flag the COEX slots are out of sync (if any)!
        objCOTAN@metaDataset <- updateMetaInfo(objCOTAN@metaDataset,
                                               datasetTags()[["gsync"]], FALSE)
        objCOTAN@metaDataset <- updateMetaInfo(objCOTAN@metaDataset,
                                               datasetTags()[["csync"]], FALSE)
      }
    }

    objCOTAN@metaGenes <-
      setColumnInDF(objCOTAN@metaGenes, dispersion,
                    "dispersion", getGenes(objCOTAN))

    return(objCOTAN)
  }
)

#' @aliases setNu
#'
#' @details `setNu()`
#'
#' @param objCOTAN a `COTAN` object
#' @param nu A named array that gives
#'
#' @returns `setNu()` returns the updated `COTAN` object
#'
#' @importFrom assertthat assert_that
#'
#' @export
#'
#' @rdname RawDataCleaning
#'
setMethod(
  "setNu",
  "COTAN",
  function(objCOTAN, nu) {
    assert_that(length(nu) == getNumCells(objCOTAN))

    if (TRUE) {
      oldNu <- getMetadataCells(objCOTAN)[["nu"]]
      if (!identical(nu, oldNu)) {
        # flag the COEX slots are out of sync (if any)!
        objCOTAN@metaDataset <- updateMetaInfo(objCOTAN@metaDataset,
                                               datasetTags()[["gsync"]], FALSE)
        objCOTAN@metaDataset <- updateMetaInfo(objCOTAN@metaDataset,
                                               datasetTags()[["csync"]], FALSE)
      }
    }

    objCOTAN@metaCells <-
      setColumnInDF(objCOTAN@metaCells, nu,
                    "nu", getCells(objCOTAN))

    return(objCOTAN)
  }
)


#' @aliases storeGDI
#'
#' @details `storeGDI()` stored and already calculated genes' `GDI` `array` in a
#'   `COTAN` object. It can be retrieved using the method [getGDI()]
#'
#' @param objCOTAN a `COTAN` object
#' @param genesGDI the named genes' `GDI` `array` to store or the output
#'   `data.frame` of the function [calculateGDI()]
#'
#' @returns `storeGDI()` returns the given `COTAN` object  with updated `GDI`
#'   genes' information
#'
#' @importFrom assertthat assert_that
#'
#' @export
#'
#' @rdname GenesStatistics
#'
setMethod(
  "storeGDI",
  "COTAN",
  function(objCOTAN, genesGDI) {
    if (isa(genesGDI, "data.frame")) {
      assert_that("GDI" %in% colnames(genesGDI),
                  msg = "Passed data.frame has no GDI column")
      genesGDI <- getColumnFromDF(genesGDI, colName = "GDI")
    }

    allGenes <- getGenes(objCOTAN)
    assert_that(setequal(names(genesGDI), allGenes),
                msg = paste("Passed GDI array must be named",
                            "and aligned to the object genes' list"))

    objCOTAN@metaGenes <-
      setColumnInDF(objCOTAN@metaGenes, genesGDI[allGenes], "GDI", allGenes)

    return(objCOTAN)
  }
)


#' @aliases dropGenesCells
#'
#' @details `dropGenesCells()` removes an array of genes and/or cells from the
#'   current `COTAN` object.
#'
#' @param objCOTAN a `COTAN` object
#' @param genes an array of gene names
#' @param cells an array of cell names
#'
#' @returns `dropGenesCells()` returns a completely new `COTAN` object with the
#'   new raw data obtained after the indicated genes/cells were expunged. All
#'   remaining data is dropped too as no more relevant with the restricted
#'   matrix. Exceptions are:
#'   * the meta-data for the data-set that gets kept unchanged
#'   * the meta-data of genes/cells that gets restricted to the remaining
#'     elements. The columns calculated via `estimate` and `find` methods are
#'     dropped too
#'
#' @export
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom methods validObject
#'
#' @rdname RawDataCleaning
#'
setMethod(
  "dropGenesCells",
  "COTAN",
  function(objCOTAN, genes, cells) {
    assert_that((all(genes %in% getGenes(objCOTAN)) &&
                 all(cells %in% getCells(objCOTAN))),
                msg = paste0("Asked to drop genes and/or cells",
                             " that were not present in the 'COTAN' object"))

    genesPosToKeep <- which(!(getGenes(objCOTAN) %in% genes))
    cellsPosToKeep <- which(!(getCells(objCOTAN) %in% cells))

    assert_that(length(genesPosToKeep) != 0L,
                length(cellsPosToKeep) != 0L,
                msg = "Asked to drop all genes and/or cells")

    if (length(genesPosToKeep) == getNumGenes(objCOTAN) &&
        length(cellsPosToKeep) == getNumCells(objCOTAN)) {
      logThis("Asked to drop no genes or cells", logLevel = 2L)
      # return original object
      return(objCOTAN)
    }

    logThis(paste("Asked to drop", length(genes), "genes and",
                  length(cells), "cells"), logLevel = 3L)

    # As all estimates would be wrong, a completely new object is created
    output <- COTAN(objCOTAN@raw[genesPosToKeep, cellsPosToKeep, drop = FALSE])

    # Copy the meta data for the data-set thus erasing the sync bits
    output@metaDataset <- getMetadataDataset(objCOTAN)
    output <- addElementToMetaDataset(output, datasetTags()[["gsync"]], FALSE)
    output <- addElementToMetaDataset(output, datasetTags()[["csync"]], FALSE)

    # Filter the meta data for genes keeping those not related to estimates
    colsToKeep <- !(names(getMetadataGenes(objCOTAN)) %in%
                      c("feGenes", "lambda", "dispersion", "GDI"))
    if (any(colsToKeep)) {
      output@metaGenes <-
        getMetadataGenes(objCOTAN)[genesPosToKeep, colsToKeep, drop = FALSE]
    }

    # Filter the meta data for cells keeping those not related to estimates
    colsToKeep <- !(names(getMetadataCells(objCOTAN)) %in%
                      c("feCells", "nu"))
    if (any(colsToKeep)) {
      output@metaCells <-
        getMetadataCells(objCOTAN)[cellsPosToKeep, colsToKeep, drop = FALSE]
    }

    # Drop all clusterizations' data.frames, but ensure object validity
    for (internalName in names(getClustersCoex(objCOTAN))) {
      output@clustersCoex[[internalName]] <- data.frame()
    }

    validObject(output)

    return(output)
  }
)


# -------------- Clusterization handling ---------------

#' @aliases addClusterization
#'
#' @details `addClusterization()` adds a *clusterization* to the current `COTAN`
#'   object, by adding a new column in the `metaCells` `data.frame` and adding a
#'   new element in the `clustersCoex` `list` using the passed in `COEX`
#'   `data.frame` or an empty `data.frame` if none were passed in.
#'
#' @param objCOTAN a `COTAN` object
#' @param clName the name of the *clusterization* to be added. It cannot match
#'   an existing name unless `override = TRUE` is used
#' @param clusters a (factors) array of *cluster* **labels**
#' @param coexDF a `data.frame` where each column indicates the `COEX` for each
#'   of the *clusters* of the *clusterization*
#' @param override When `TRUE` silently allows overriding data for an existing
#'   *clusterization* name. Otherwise the default behavior will avoid potential
#'   data losses
#'
#' @returns `addClusterization()` returns the updated `COTAN` object
#'
#' @importFrom rlang is_empty
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom methods validObject
#'
#' @export
#'
#' @rdname HandlingClusterizations
#'
setMethod(
  "addClusterization",
  "COTAN",
  function(objCOTAN, clName, clusters,
           coexDF = data.frame(), override = FALSE) {
    internalName <- clName
    if (!startsWith(internalName, "CL_")) {
      internalName <- paste0("CL_", clName)
    }

    clusters <- factor(clusters)

    assert_that(nchar(internalName) >= 4L,
                msg = "Given an empty name for the new clusterization.")

    assert_that(isTRUE(override) ||
                  !(internalName %in% colnames(getMetadataCells(objCOTAN))),
                msg = paste0("A clusterization with name '",
                             clName, "' already exists."))

    assert_that(length(clusters) == getNumCells(objCOTAN),
                msg = paste0("The passed clusterization has the ",
                             "wrong number of elements [", length(clusters),
                             "] instead of the expected number of cells [",
                             getNumCells(objCOTAN), "]."))

    assert_that(identical(names(clusters), getCells(objCOTAN)),
                msg = paste0("The passed clusterization must be named ",
                             "and aligned to the cells' list"))

    if (!is_empty(coexDF)) {
      assert_that(isa(coexDF, "data.frame"),
                  msg = paste0("'coexDF' is supposedly composed of ",
                               "data.frames. A '", class(coexDF),
                               "' was given  instead for clusterization '",
                               clName, "'."))

      assert_that(identical(rownames(coexDF), getGenes(objCOTAN)),
                  setequal(colnames(coexDF), levels(clusters)),
                  msg = "COEX is not aligned to the given clusterization")
    }

    objCOTAN@metaCells <- setColumnInDF(objCOTAN@metaCells, clusters,
                                        internalName, getCells(objCOTAN))

    # this add a new entry in the list for the new name!
    objCOTAN@clustersCoex[[internalName]] <- coexDF

    validObject(objCOTAN)

    return(objCOTAN)
  }
)

#' @aliases addClusterizationCoex
#'
#' @details `addClusterizationCoex()` adds a *clusterization* `COEX`
#'   `data.frame` to the current `COTAN` object. It requires the named
#'   *clusterization* to be already present.
#'
#' @param objCOTAN a `COTAN` object
#' @param clName the name of an existing *clusterization*
#' @param coexDF a `data.frame` where each column indicates the `COEX` for each
#'   of the *clusters* of the *clusterization*
#'
#' @returns `addClusterizationCoex()` returns the updated `COTAN` object
#'
#' @export
#'
#' @importFrom assertthat assert_that
#'
#' @rdname HandlingClusterizations
#'
setMethod(
  "addClusterizationCoex",
  "COTAN",
  function(objCOTAN, clName, coexDF) {
    internalName <- getClusterizationName(objCOTAN, clName = clName,
                                          keepPrefix = TRUE)

    if (!is_empty(coexDF)) {
      assert_that(isa(coexDF, "data.frame"),
                  msg = paste0("'coexDF' is supposedly composed of ",
                               "data.frames. A '", class(coexDF),
                               "' was given  instead for clusterization '",
                               clName, "'."))

      assert_that(identical(rownames(coexDF), getGenes(objCOTAN)),
                  setequal(colnames(coexDF),
                           getClusters(objCOTAN, clName = internalName)),
                  msg = "COEX is not aligned to the given clusterization")
    }

    # this should not add any new elements to the list!
    objCOTAN@clustersCoex[[internalName]] <- coexDF

    return(objCOTAN)
  }
)

#' @aliases dropClusterization
#'
#' @details `dropClusterization()` drops a *clusterization* from the current
#'   `COTAN` object, by removing the corresponding column in the `metaCells`
#'   `data.frame` and the corresponding `COEX` `data.frame` from the
#'   `clustersCoex` `list`.
#'
#' @param objCOTAN a `COTAN` object
#' @param clName the name of an existing *clusterization*.
#'
#' @returns `dropClusterization()` returns the updated `COTAN` object
#'
#' @export
#'
#' @importFrom assertthat assert_that
#'
#' @rdname HandlingClusterizations
#'
setMethod(
  "dropClusterization",
  "COTAN",
  function(objCOTAN, clName) {
    internalName <- clName
    if (!startsWith(internalName, "CL_")) {
      internalName <- paste0("CL_", clName)
    }

    assert_that(internalName %in% colnames(getMetadataCells(objCOTAN)),
                msg = paste0("No clusterization with name '",
                             clName, "' is present."))

    keptCols <- !colnames(objCOTAN@metaCells) %in% internalName
    objCOTAN@metaCells <- objCOTAN@metaCells[, keptCols, drop = FALSE]

    # assign NULL to drop elements from list
    objCOTAN@clustersCoex[[internalName]] <- NULL

    return(objCOTAN)
  }
)


# -------------- Conditions handling ---------------

#' @aliases addCondition
#'
#' @details `addCondition()` adds a *condition* to the current `COTAN` object,
#'   by adding a new column in the `metaCells` `data.frame`
#'
#' @param objCOTAN a `COTAN` object
#' @param condName the name of the *condition* to be added. It cannot match an
#'   existing name unless `override = TRUE` is used
#' @param conditions a (factors) array of *condition* **labels**
#' @param override When `TRUE` silently allows overriding data for an existing
#'   *condition* name. Otherwise the default behavior will avoid potential
#'   data losses
#'
#' @returns `addCondition()` returns the updated `COTAN` object
#'
#' @importFrom rlang is_empty
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom methods validObject
#'
#' @export
#'
#' @rdname HandlingConditions
#'
setMethod(
  "addCondition",
  "COTAN",
  function(objCOTAN, condName, conditions, override = FALSE) {
    internalName <- condName
    if (!startsWith(internalName, "COND_")) {
      internalName <- paste0("COND_", condName)
    }

    assert_that(nchar(internalName) >= 6L,
                msg = "Given an empty name for the new condition")

    assert_that(isTRUE(override) ||
                  !(internalName %in% colnames(getMetadataCells(objCOTAN))),
                msg = paste0("A condition with name '",
                             condName, "' already exists."))

    assert_that(length(conditions) == getNumCells(objCOTAN),
                msg = paste0("The passed condition has the wrong ",
                             "number of elements [", length(conditions),
                             "] instead ofthe expected number of cells [",
                             getNumCells(objCOTAN), "]."))

    assert_that(identical(names(conditions), getCells(objCOTAN)),
                msg = paste0("The passed condition must be named ",
                             "and aligned to the cells' list"))

    objCOTAN@metaCells <- setColumnInDF(objCOTAN@metaCells, factor(conditions),
                                        internalName, getCells(objCOTAN))

    validObject(objCOTAN)

    return(objCOTAN)
  }
)


#' @aliases dropCondition
#'
#' @details `dropCondition()` drops a *condition* from the current `COTAN`
#'   object, by removing the corresponding column in the `metaCells`
#'   `data.frame`
#'
#' @param objCOTAN a `COTAN` object
#' @param condName the name of an existing *condition*.
#'
#' @returns `dropCondition()` returns the updated `COTAN` object
#'
#' @importFrom assertthat assert_that
#'
#' @export
#'
#' @rdname HandlingConditions
#'
setMethod(
  "dropCondition",
  "COTAN",
  function(objCOTAN, condName) {
    internalName <- condName
    if (!startsWith(internalName, "COND_")) {
      internalName <- paste0("COND_", condName)
    }

    assert_that(internalName %in% colnames(getMetadataCells(objCOTAN)),
                msg = paste0("No condition with name '",
                             condName, "' is present."))

    keptCols <- !colnames(objCOTAN@metaCells) %in% internalName
    objCOTAN@metaCells <- objCOTAN@metaCells[, keptCols, drop = FALSE]

    return(objCOTAN)
  }
)


# ------------ COEX erasers ---------------

#' @aliases dropGenesCoex
#'
#' @details `dropGenesCoex()` drops the `genesCoex` member from the given
#'   `COTAN` object
#'
#' @param objCOTAN a `COTAN` object
#'
#' @returns `dropGenesCoex()` returns the updated `COTAN` object
#'
#' @importFrom rlang is_empty
#'
#' @export
#'
#' @rdname CalculatingCOEX
#'
setMethod(
  "dropGenesCoex",
  "COTAN",
  function(objCOTAN) {
    if (!is_empty(objCOTAN@genesCoex)) {
      objCOTAN@genesCoex <- emptySymmetricMatrix()
    }

    return(objCOTAN)
  }
)


#' @aliases dropCellsCoex
#'
#' @details `dropCellsCoex()` drops the `cellsCoex` member from the given
#'   `COTAN` object
#'
#' @param objCOTAN A `COTAN` object
#'
#' @returns `dropCellsCoex()` returns the updated `COTAN` object
#'
#' @importFrom rlang is_empty
#'
#' @export
#'
#' @rdname CalculatingCOEX
#'
setMethod(
  "dropCellsCoex",
  "COTAN",
  function(objCOTAN) {
    if (!is_empty(objCOTAN@cellsCoex)) {
      objCOTAN@cellsCoex <- emptySymmetricMatrix()
    }

    return(objCOTAN)
  }
)

prevOptState <- options(parallelly.fork.enable = TRUE)

test_that("Linear estimates", {
  raw <- matrix(c(1L,  0L, 4L, 2L, 11L, 0L, 6L, 7L, 0L, 9L,
                  10L, 8L, 0L, 0L,  0L, 3L, 0L, 0L, 2L, 0L),
                nrow = 10L, ncol = 20L)
  rownames(raw) <- LETTERS[1L:10L]
  colnames(raw) <- letters[1L:20L]

  obj <- COTAN(raw = raw)
  obj <-
    addCondition(obj, condName = "batch",
                 conditions = rlang::rep_named(getCells(obj), c("TA", "TB")))

  obj <- estimateLambdaLinear(obj)

  expect_identical(getLambda(obj), rowMeans(getRawData(obj), dims = 1L))
  expect_equal(getMetadataDataset(obj)[[1L]], datasetTags()[5L:6L],
               ignore_attr = TRUE)
  expect_identical(getMetadataDataset(obj)[[2L]], c("FALSE", "FALSE"))

  obj <- estimateNuLinear(obj)

  expect_identical(getNu(obj),
                   Matrix::colMeans(getRawData(obj)) /
                     mean(Matrix::colMeans(getRawData(obj))))

  clusters <- set_names(rep(1L:2L, times = 10L), getCells(obj))
  obj <- estimateNuLinearByCluster(obj, clusters = clusters)

  expect_identical(getNu(obj), set_names(rep_len(1.0, getNumCells(obj)),
                                         getCells(obj)))
})


test_that("Bisection estimates", {
  raw <- matrix(c(1L,  0L, 4L, 2L, 11L, 0L, 6L, 7L, 0L, 9L,
                  10L, 8L, 0L, 0L,  0L, 3L, 0L, 0L, 2L, 0L),
                nrow = 10L, ncol = 20L)
  rownames(raw) <- LETTERS[1L:10L]
  colnames(raw) <- letters[1L:20L]

  obj <- COTAN(raw = raw)
  obj <- clean(obj)

  obj <- estimateLambdaLinear(obj)
  obj <- estimateDispersionViaSolver(obj, cores = 3L, chunkSize = 2L)

  expect_length(getDispersion(obj), getNumGenes(obj))
  expect_equal(getDispersion(obj)[[1L]], -Inf, ignore_attr = TRUE)

  expect_equal(rowSums(getZeroOneProj(obj) + getProbabilityOfZero(obj)),
               rep(getNumCells(obj), getNumGenes(obj)),
               tolerance = 0.001, ignore_attr = TRUE)

  obj <- estimateNuBisection(obj, cores = 6L, chunkSize = 3L)

  expect_length(getNu(obj), getNumCells(obj))

  expect_equal(colSums(getZeroOneProj(obj) + getProbabilityOfZero(obj)),
               rep(getNumGenes(obj), getNumCells(obj)),
               tolerance = 0.001, ignore_attr = TRUE)

  obj <- estimateDispersionNuBisection(obj, enforceNuAverageToOne = TRUE)

  expect_length(getDispersion(obj), getNumGenes(obj))
  expect_equal(getDispersion(obj)[[1L]], -Inf, ignore_attr = TRUE)
  expect_length(getNu(obj), getNumCells(obj))
  expect_equal(mean(getNu(obj)), 1.0, tolerance = 1.0e-12)

  expect_equal(rowSums(getZeroOneProj(obj) + getProbabilityOfZero(obj)),
               rep(getNumCells(obj), getNumGenes(obj)),
               tolerance = 0.001, ignore_attr = TRUE)

  expect_equal(colSums(getZeroOneProj(obj) + getProbabilityOfZero(obj)),
               rep(getNumGenes(obj), getNumCells(obj)),
               tolerance = 0.001, ignore_attr = TRUE)

  expect_error(estimateDispersionNuNlminb(obj))
})

options(prevOptState)

.onLoad <- function(libname, pkgname) {
  if (requireNamespace("zeallot") &&
      utils::packageVersion("zeallot") >= "2.0.0") {
    zeallot::zeallous()
  }
}

#' @importFrom rlang .data
utils::globalVariables(c(".data", ".x"))

# ----------- Contingency tables --------------

#'
#' @title Calculating the `COEX` matrix
#'
#' @description These are the functions and methods used to calculate the
#'   `COEX` matrices according to the `COTAN` model. From there it is possible
#'   to calculate the associated `p-value` and the `GDI` (*Global Differential
#'   Expression*)
#'
#' @description The `COEX` matrix is defined by following formula:
#'
#'   \deqn{\frac{\sum_{i,j \in \{\text{Y, N}\}}{
#'                     (-1)^{\#\{i,j\}}\frac{O_{ij}-E_{ij}}{1 \vee E_{ij}}}}
#'              {\sqrt{n \sum_{i,j \in \{\text{Y, N}\}}{
#'                             \frac{1}{1 \vee E_{ij}}}}}}
#'
#'   where \eqn{O} and \eqn{E} are the observed and expected contingency tables
#'   and \eqn{n} is the relevant number of genes/cells (depending on given
#'   `actOnCells` flag).
#'
#'   The formula can be more effectively implemented as:
#'
#'   \deqn{\sqrt{\frac{1}{n}\sum_{i,j \in \{\text{Y, N}\}}{
#'                                \frac{1}{1 \vee E_{ij}}}}
#'         \, \bigl(O_\text{YY}-E_\text{YY}\bigr)}
#'
#'   once one notices that \eqn{O_{ij} - E_{ij} = (-1)^{\#\{i,j\}} \, r} for
#'   some constant \eqn{r} for all \eqn{i,j \in \{\text{Y, N}\}}.
#'
#'   The latter follows from the fact that the relevant marginal sums of the
#'   expected contingency tables were enforced to match the marginal sums of the
#'   observed ones.
#'
#' @description The new implementation of the function relies on the `torch`
#'   package. This implies that it is potentially able to use the system `GPU`
#'   to run the heavy duty calculations required by this method. However
#'   installing the `torch` package on a system can be *finicky*, so we
#'   tentatively provide a short help page [Installing_torch] hoping that it
#'   will help...
#'
#' @seealso [ParametersEstimations] for more details.
#'
#' @seealso [Installing_torch] about the `torch` package
#'
#' @name CalculatingCOEX
#'
#' @rdname CalculatingCOEX
#'
#' @note The sum of the matrices returned by the function
#'   `observedContingencyTables()` and `expectedContingencyTables()` will have
#'   the same value on all elements. This value is the number of genes/cells
#'   depending on the parameter `actOnCells` being `TRUE/FALSE`.
#'
NULL

#' @details `calculateLikelihoodOfObserved()` gives for each cell and each gene
#'   the likelihood of the observed zero/one data
#'
#' @param objCOTAN a `COTAN` object
#' @param formula a string indicating which function of the likelihood is
#'   actually returned. Supported formulas are:
#'   * `"raw"` just the likelihood (default):
#'     \eqn{p^{(1-z)} \times (1-p)^z = (1.0 - z) p + z (1.0 - p)}
#'   * `"log"` the log of the likelihood:
#'     \eqn{(1.0 - z) \log(p) + z \log(1.0 - p)}
#'   * `"der"` the derivative of the log of the likelihood:
#'     \eqn{(1.0 - z) / p - z / (1.0 - p)}
#'   * `"sLog"` the *signed* log of the likelihood:
#'     \eqn{(1.0 - z) \log(p) - z \log(1.0 - p)}
#'
#'   where \eqn{z} is the *binarized projection* and \eqn{p} is the *probability
#'   of zero*
#'
#' @returns `calculateLikelihoodOfObserved()` returns a `matrix` with the
#'   selected *formula* of the likelihood of the observed zero/one
#'
#' @export
#'
#' @examples
#' signedLikelhood <- calculateLikelihoodOfObserved(objCOTAN, formula = "sLog")
#'
#' @rdname CalculatingCOEX
#'
calculateLikelihoodOfObserved <- function(objCOTAN,
                                          formula = "raw") {
  rawData <- getRawData(objCOTAN)

  # bound the probabilities to avoid exact zero or one
  probZero <- pmin(pmax(getProbabilityOfZero(objCOTAN), 1.0e-8), 1.0 - 1.0e-8)

  #nolint start: infix_space_linter, spaces_left_parentheses_linter
  res <-
    switch(formula,
           raw  = ifelse(rawData != 0L,       1.0-probZero,       probZero),
           log  = ifelse(rawData != 0L,    log1p(-probZero),  log(probZero)),
           der  = ifelse(rawData != 0L, -1.0/(1.0-probZero),  1.0/probZero),
           sLog = ifelse(rawData != 0L,   -log1p(-probZero),  log(probZero)),
           stop("Unknown formula: ", formula))
  #nolint end

  rm(probZero)

  dim(res) <- dim(rawData)
  dimnames(res) <- dimnames(rawData)

  return(res)
}

#' @details `getDataMatrix()` gives for each cell and each gene the result of
#'   the selected formula as function of the observed counts and their expected
#'   value
#'
#' @param objCOTAN a `COTAN` object
#' @param dataMethod selects the method to use to create the `data.frame` to
#'   pass to the [UMAPPlot()]. To calculate, for each cell, a statistic for each
#'   gene based on available data/model, the following methods are supported:
#'   * `"RW", "Raw", "RawData"` uses the *raw* counts
#'   * `"NN", "NuNorm", "Normalized"` uses the \eqn{\nu}*-normalized* counts
#'   * `"LN", "LogNorm", "LogNormalized"` uses the *log-normalized* counts
#'   (default)
#'   * `"BI", "Bin", "Binarized"` uses the *binarized* data matrix
#'   * `"BD", "BinDiscr", "BinarizedDiscrepancy"` uses the *difference* between
#'   the *binarized* data matrix and the estimated *probability of one*
#'   * `"AB", "AdjBin", "AdjBinarized"` uses the absolute value of
#'   the *binarized discrepancy* above
#'   * `"LH", "Like", "Likelihood"` uses the *likelihood* of *binarized*
#'   data matrix
#'   * `"LL", "LogLike", "LogLikelihood"` uses the *log-likelihood*
#'   of *binarized* data matrix
#'   * `"DL", "DerLogL", "DerivativeLogLikelihood"` uses the *derivative* of
#'   the *log-likelihood* of *binarized* data matrix
#'   * `"SL", "SignLogL", "SignedLogLikelihood"` uses the *signed
#'   log-likelihood* of *binarized* data matrix
#'
#'   For the last four options see [calculateLikelihoodOfObserved()] for more
#'   details
#'
#' @returns `getDataMatrix()` returns a `matrix` with the same shape as the
#'   *raw* data
#'
#' @export
#'
#' @rdname CalculatingCOEX
#'
getDataMatrix <- function(objCOTAN,
                          dataMethod = "") {
  if (isEmptyName(dataMethod)) {
    dataMethod <- "LogNormalized"
  }

  # A little helper to do non trivial binarized in less memory
  binDiscr <- function(objCOTAN, formula) {
    rawData <- getRawData(objCOTAN)
    probZero <- getProbabilityOfZero(objCOTAN)

    res <- switch(formula,
                  raw  = ifelse(rawData != 0L, 1.0, 0.0),
                  dis  = ifelse(rawData != 0L, probZero, probZero - 1.0),
                  abs  = ifelse(rawData != 0L, probZero, 1.0 - probZero),
                  stop("Unknown formula: ", formula))

    rm(probZero)

    dim(res) <- dim(rawData)
    dimnames(res) <- dimnames(rawData)

    return(res)
  }

  getLH <- function(objCOTAN, formula) {
    return(calculateLikelihoodOfObserved(objCOTAN, formula))
  }

  dataMatrix <- as.matrix(switch(
    dataMethod,
    RW = , Raw      = , RawData                 = getRawData(objCOTAN),
    NN = , NuNorm   = , Normalized              = getNuNormData(objCOTAN),
    LN = , LogNorm  = , LogNormalized           = getLogNormData(objCOTAN),
    BI = , Bin      = , Binarized               = getZeroOneProj(objCOTAN),
    BD = , BinDiscr = , BinarizedDiscrepancy    = binDiscr(objCOTAN, "dis"),
    AB = , AdjBin   = , AdjBinarized            = binDiscr(objCOTAN, "abs"),
    LH = , Like     = , Likelihood              = getLH(objCOTAN, "raw"),
    LL = , LogLike  = , LogLikelihood           = getLH(objCOTAN, "log"),
    DL = , DerLogL  = , DerivativeLogLikelihood = getLH(objCOTAN, "der"),
    SL = , SignLogL = , SignedLogLikelihood     = getLH(objCOTAN, "sLog"),
    stop("Unrecognised `dataMethod` passed in: ", dataMethod)
  ))

  gc()

  return(dataMatrix)
}


#' @details `observedContingencyTablesYY()` calculates observed *Yes/Yes* field
#'   of the contingency table
#'
#' @param objCOTAN a `COTAN` object
#' @param actOnCells Boolean - when `TRUE` the function works for the cells,
#'   otherwise for the genes
#' @param asDspMatrices Boolean - when `TRUE` the function will return only
#'   packed dense symmetric matrices
#'
#' @returns `observedContingencyTablesYY()` returns a `list` with:
#'   * `observedYY` the *Yes/Yes* observed contingency table as `matrix`
#'   * `observedY`  the full *Yes* observed `vector`
#'
#' @importFrom rlang is_empty
#'
#' @importFrom Matrix t
#' @importFrom Matrix crossprod
#' @importFrom Matrix tcrossprod
#' @importFrom Matrix colSums
#' @importFrom Matrix rowSums
#'
#' @importClassesFrom Matrix dgeMatrix
#' @importClassesFrom Matrix dsyMatrix
#'
#' @export
#'
#' @rdname CalculatingCOEX
#'
observedContingencyTablesYY <- function(objCOTAN,
                                        actOnCells = FALSE,
                                        asDspMatrices = FALSE) {
  logThis("calculating YY..", logLevel = 3L, appendLF = FALSE)

  zeroOne <- getZeroOneProj(objCOTAN)

  if (isTRUE(actOnCells)) {
    # for cells
    observedYY <- crossprod(zeroOne)
    observedY  <- colSums(zeroOne)
  } else {
    # for genes
    observedYY <- tcrossprod(zeroOne)
    observedY  <- rowSums(zeroOne)
  }
  rm(zeroOne)

  observedYY <- forceSymmetric(as(observedYY, "denseMatrix"))

  if (isTRUE(asDspMatrices)) {
    observedYY <- pack(observedYY)
  }

  logThis(" done", logLevel = 3L)

  return(list("observedYY" = observedYY, "observedY" = observedY))
}


#' @details `observedPartialContingencyTablesYY()` calculates observed *Yes/Yes*
#'   field of the contingency table
#'
#' @param objCOTAN a `COTAN` object
#' @param columnsSubset a sub-set of the columns of the matrices that will be
#'   returned
#' @param zeroOne the raw count matrix projected to `0` or `1`. If not given the
#'   appropriate one will be calculated on the fly
#' @param actOnCells Boolean - when `TRUE` the function works for the cells,
#'   otherwise for the genes
#' @param asDspMatrices Boolean - when `TRUE` the function will return only
#'   packed dense symmetric matrices
#'
#' @returns `observedPartialContingencyTablesYY()` returns a `list` with:
#'   * `observedYY` the *Yes/Yes* observed contingency table as `matrix`,
#'     restricted to the selected columns as named `list` with elements
#'   * `observedY`  the full *Yes* observed `vector`
#'
#' @importFrom rlang is_empty
#'
#' @importFrom Matrix t
#' @importFrom Matrix crossprod
#' @importFrom Matrix tcrossprod
#' @importFrom Matrix colSums
#' @importFrom Matrix rowSums
#'
#' @export
#'
#' @rdname CalculatingCOEX
#'
observedPartialContingencyTablesYY <-
  function(objCOTAN,
           columnsSubset,
           zeroOne = NULL,
           actOnCells = FALSE) {
  logThis("calculating partial YY..", logLevel = 3L, appendLF = FALSE)

  if (is_empty(zeroOne)) {
    # get zero/one projection with internal function get
    zeroOne <- getZeroOneProj(objCOTAN)
  }
  assert_that(identical(dim(zeroOne), dim(getRawData(objCOTAN))))
  assert_that(!anyNA(zeroOne),
              msg = paste0("Error: some NA in matrix of probability",
                           " of zero UMI counts"))
  gc()

  if (is.character(columnsSubset)) {
    if (isTRUE(actOnCells)) {
      allColumns <- getCells(objCOTAN)
    } else {
      allColumns <- getGenes(objCOTAN)
    }
    columnsSubset <- which(allColumns %in% columnsSubset)
  } else {
    columnsSubset <- sort(columnsSubset)
  }

  if (isTRUE(actOnCells)) {
    # for cells
    observedYY <- crossprod(zeroOne,
                            zeroOne[, columnsSubset, drop = FALSE])
    observedY  <- colSums(zeroOne)
  } else {
    # for genes
    observedYY <- tcrossprod(zeroOne,
                             zeroOne[columnsSubset, , drop = FALSE])
    observedY  <- rowSums(zeroOne)
  }
  rm(zeroOne)

  logThis(" done", logLevel = 3L)

  return(list("observedYY" = observedYY, "observedY" = observedY))
}


#' @details `observedContingencyTables()` calculates the observed contingency
#'   tables. When the parameter `asDspMatrices == TRUE`, the method will
#'   effectively throw away the lower half from the returned `observedYN` and
#'   `observedNY` matrices, but, since they are transpose one of another, the
#'   full information is still available.
#'
#' @param objCOTAN a `COTAN` object
#' @param actOnCells Boolean; when `TRUE` the function works for the cells,
#'   otherwise for the genes
#' @param asDspMatrices Boolean; when `TRUE` the function will return only
#'   packed dense symmetric matrices
#'
#' @returns `observedContingencyTables()` returns the observed contingency
#'   tables as named `list` with elements:
#'   * `"observedNN"`
#'   * `"observedNY"`
#'   * `"observedYN"`
#'   * `"observedYY"`
#'
#' @importFrom Matrix t
#' @importClassesFrom Matrix symmetricMatrix
#'
#' @importFrom zeallot %<-%
#' @importFrom zeallot %->%
#'
#' @export
#'
#' @rdname CalculatingCOEX
#'
observedContingencyTables <- function(objCOTAN,
                                      actOnCells = FALSE,
                                      asDspMatrices = FALSE) {
  numGenes <- getNumGenes(objCOTAN)
  numCells <- getNumCells(objCOTAN)

  c(observedYY, observedY) %<-%
    observedContingencyTablesYY(objCOTAN,
                                actOnCells = actOnCells,
                                asDspMatrices = FALSE)
  gc()

  if (isTRUE(actOnCells)) {
    # dimension m x m (m number of cells)
    logThis("calculating NY..", logLevel = 3L, appendLF = FALSE)

    # Any/Yes vector [cycled] = Yes/Yes + No/Yes
    #observedNY <- observedY - observedYY

    logThis("YN..", logLevel = 3L, appendLF = FALSE)
    observedYN <- t(observedY - observedYY)

    logThis("NN..", logLevel = 3L, appendLF = FALSE)
    observedNN <- numGenes - observedY - observedYN

    observedYN <- as(observedYN, "denseMatrix")
  } else {
    # dimension n x n (n number of genes)
    logThis("calculating YN..", logLevel = 3L, appendLF = FALSE)

    # Yes/Any vector [cycled] = Yes/Yes + Yes/No
    #observedYN <- observedY - observedYY

    logThis("NY..", logLevel = 3L, appendLF = FALSE)
    observedNY <- t(observedY - observedYY)

    logThis("NN..", logLevel = 3L, appendLF = FALSE)
    observedNN <- numCells - observedY - observedNY

    observedNY <- as(observedNY, "denseMatrix")
  }
  gc()
  logThis("t()..", logLevel = 3L, appendLF = FALSE)

  observedNN <- forceSymmetric(as(observedNN, "denseMatrix"))

  if (isTRUE(asDspMatrices)) {
    observedNN <- pack(observedNN)
    observedYY <- pack(observedYY)
    # these operation drops the lower triangle values
    # but the other matrix contains them anyway
    # nolint start: spaces_inside_linter
    if (isTRUE(actOnCells)) {
      observedNY <- pack(forceSymmetric(t(observedYN)))
      observedYN <- pack(forceSymmetric(  observedYN) )
    } else {
      observedYN <- pack(forceSymmetric(t(observedNY)))
      observedNY <- pack(forceSymmetric(  observedNY) )
    }
    #nolint end
  } else {
    if (isTRUE(actOnCells)) {
      observedNY <- t(observedYN)
    } else {
      observedYN <- t(observedNY)
    }
  }
  logThis(" done", logLevel = 3L)

  return(list("observedNN" = observedNN,
              "observedNY" = observedNY,
              "observedYN" = observedYN,
              "observedYY" = observedYY))
}


#' @details `observedPartialContingencyTables()` calculates the observed
#'   contingency tables.
#'
#' @param objCOTAN a `COTAN` object
#' @param columnsSubset a sub-set of the columns of the matrices that will be
#'   returned
#' @param zeroOne the raw count matrix projected to `0` or `1`. If not given the
#'   appropriate one will be calculated on the fly
#' @param actOnCells Boolean; when `TRUE` the function works for the cells,
#'   otherwise for the genes
#'
#' @returns `observedPartialContingencyTables()` returns the observed
#'   contingency tables, restricted to the selected columns, as named `list`
#'   with elements:
#'   * `"observedNN"`
#'   * `"observedNY"`
#'   * `"observedYN"`
#'   * `"observedYY"`
#'
#' @importFrom zeallot %<-%
#' @importFrom zeallot %->%
#'
#' @export
#'
#' @rdname CalculatingCOEX
#'
observedPartialContingencyTables <-
  function(objCOTAN,
           columnsSubset,
           zeroOne = NULL,
           actOnCells = FALSE) {
  numGenes <- getNumGenes(objCOTAN)
  numCells <- getNumCells(objCOTAN)

  if (is.character(columnsSubset)) {
    if (isTRUE(actOnCells)) {
      allColumns <- getCells(objCOTAN)
    } else {
      allColumns <- getGenes(objCOTAN)
    }
    columnsSubset <- which(allColumns %in% columnsSubset)
  } else {
    columnsSubset <- sort(columnsSubset)
  }

  c(observedYY, observedY) %<-%
    observedPartialContingencyTablesYY(objCOTAN,
                                       columnsSubset = columnsSubset,
                                       zeroOne = zeroOne,
                                       actOnCells = actOnCells)
  gc()

  if (isTRUE(actOnCells)) {
    # dimension m x m (m number of cells)
    logThis("calculating partial NY..", logLevel = 3L, appendLF = FALSE)

    # Any/Yes vector [cycled] = Yes/Yes + No/Yes
    observedNY <- observedY - observedYY

    logThis("YN..", logLevel = 3L, appendLF = FALSE)
    observedYN <- t(observedY[columnsSubset] - t(observedYY))

    logThis("NN..", logLevel = 3L, appendLF = FALSE)
    observedNN <- numGenes - observedY - observedYN
  } else {
    # dimension n x n (n number of genes)
    logThis("calculating partial YN..", logLevel = 3L, appendLF = FALSE)

    # Yes/Any vector [cycled] = Yes/Yes + Yes/No
    observedYN <- observedY - observedYY

    logThis("NY..", logLevel = 3L, appendLF = FALSE)
    observedNY <- t(observedY[columnsSubset] - t(observedYY))

    logThis("NN..", logLevel = 3L, appendLF = FALSE)
    observedNN <- numCells - observedY - observedNY
  }
  logThis(" done", logLevel = 3L)

  gc()

  return(list("observedNN" = observedNN,
              "observedNY" = observedNY,
              "observedYN" = observedYN,
              "observedYY" = observedYY))
}


#' @details `expectedContingencyTablesNN()` calculates the expected *No/No*
#'   field of the contingency table
#'
#' @param objCOTAN a `COTAN` object
#' @param actOnCells Boolean; when `TRUE` the function works for the cells,
#'   otherwise for the genes
#' @param asDspMatrices Boolean; when `TRUE` the function will return only
#'   packed dense symmetric matrices
#' @param optimizeForSpeed Boolean; deprecated: always TRUE
#'
#' @returns `expectedContingencyTablesNN()` returns a `list` with:
#'   * `expectedNN` the *No/No* expected contingency table as `matrix`
#'   * `expectedN`  the *No* expected `vector`
#'
#' @importFrom Matrix t
#' @importFrom Matrix colSums
#'
#' @importClassesFrom Matrix dgeMatrix
#' @importClassesFrom Matrix dsyMatrix
#'
#' @importFrom Rfast Crossprod
#' @importFrom Rfast Tcrossprod
#' @importFrom Rfast rowsums
#' @importFrom Rfast colsums
#'
#' @importFrom assertthat assert_that
#'
#' @export
#'
#' @rdname CalculatingCOEX
#'
expectedContingencyTablesNN <- function(objCOTAN,
                                        actOnCells = FALSE,
                                        asDspMatrices = FALSE,
                                        optimizeForSpeed = TRUE) {
  logThis("calculating NN..", logLevel = 3L, appendLF = FALSE)

  # estimate Probabilities of 0 with internal function funProbZero
  probZero <- getProbabilityOfZero(objCOTAN)
  gc()

  assert_that(!anyNA(probZero),
              msg = paste0("Error: some NA in matrix of probability",
                           " of zero UMI counts"))

  if (isTRUE(actOnCells)) {
    # dimension m x m (m number of cells)
    expectedNN <- Crossprod(probZero, probZero)
    expectedN  <- colsums(probZero, parallel = TRUE)
    rownames(expectedNN) <- colnames(expectedNN) <- getCells(objCOTAN)
  } else {
    # dimension n x n (n number of genes)
    expectedNN <- Tcrossprod(probZero, probZero)
    expectedN  <- rowsums(probZero, parallel = TRUE)
    rownames(expectedNN) <- colnames(expectedNN) <- getGenes(objCOTAN)
  }
  rm(probZero)

  expectedNN <- forceSymmetric(as(expectedNN, "denseMatrix"))

  if (isTRUE(asDspMatrices)) {
    expectedNN <- pack(expectedNN)
  }

  logThis(" done", logLevel = 3L)

  return(list("expectedNN" = expectedNN, "expectedN" = expectedN))
}


#' @details `expectedPartialContingencyTablesNN()` calculates the expected
#'   *No/No* field of the contingency table
#'
#' @param objCOTAN a `COTAN` object
#' @param columnsSubset a sub-set of the columns of the matrices that will be
#'   returned
#' @param probZero is the expected **probability of zero** for each gene/cell
#'   pair. If not given the appropriate one will be calculated on the fly
#' @param actOnCells Boolean; when `TRUE` the function works for the cells,
#'   otherwise for the genes
#' @param optimizeForSpeed Boolean; deprecated: always TRUE
#'
#' @returns `expectedPartialContingencyTablesNN()` returns a `list` with:
#'   * `expectedNN` the *No/No* expected contingency table as `matrix`,
#'     restricted to the selected columns, as named `list` with elements
#'   * `expectedN`  the full *No* expected `vector`
#'
#' @importFrom Rfast Crossprod
#' @importFrom Rfast Tcrossprod
#' @importFrom Rfast rowsums
#' @importFrom Rfast colsums
#'
#' @importFrom assertthat assert_that
#'
#' @export
#'
#' @rdname CalculatingCOEX
#'
expectedPartialContingencyTablesNN <-
  function(objCOTAN,
           columnsSubset,
           probZero = NULL,
           actOnCells = FALSE,
           optimizeForSpeed = TRUE) {
  logThis("calculating partial NN..", logLevel = 3L, appendLF = FALSE)

  if (is_empty(probZero)) {
    # estimate Probabilities of 0 with internal function funProbZero
    probZero <- getProbabilityOfZero(objCOTAN)
  }
  assert_that(identical(dim(probZero), dim(getRawData(objCOTAN))))
  assert_that(!anyNA(probZero),
              msg = paste0("Error: some NA in matrix of probability",
                           " of zero UMI counts"))
  gc()


  if (is.character(columnsSubset)) {
    if (isTRUE(actOnCells)) {
      allColumns <- getCells(objCOTAN)
    } else {
      allColumns <- getGenes(objCOTAN)
    }
    columnsSubset <- which(allColumns %in% columnsSubset)
  } else {
    columnsSubset <- sort(columnsSubset)
  }

  if (isTRUE(actOnCells)) {
    # dimension m x m (m number of cells)
    expectedNN <- Crossprod(probZero,
                            probZero[, columnsSubset, drop = FALSE])
    expectedN  <- colsums(probZero, parallel = TRUE)
    rownames(expectedNN) <- getCells(objCOTAN)
    colnames(expectedNN) <- getCells(objCOTAN)[columnsSubset]
  } else {
    # dimension n x n (n number of genes)
    expectedNN <- Tcrossprod(probZero,
                             probZero[columnsSubset, , drop = FALSE])
    expectedN  <- rowsums(probZero, parallel = TRUE)
    rownames(expectedNN) <- getGenes(objCOTAN)
    colnames(expectedNN) <- getGenes(objCOTAN)[columnsSubset]
  }
  rm(probZero)

  logThis(" done", logLevel = 3L)

  return(list("expectedNN" = expectedNN, "expectedN" = expectedN))
}


#' @details `expectedContingencyTables()` calculates the expected values of
#'   contingency tables. When the parameter `asDspMatrices == TRUE`, the method
#'   will effectively throw away the lower half from the returned `expectedYN`
#'   and `expectedNY` matrices, but, since they are transpose one of another,
#'   the full information is still available.
#'
#' @param objCOTAN a `COTAN` object
#' @param actOnCells Boolean; when `TRUE` the function works for the cells,
#'   otherwise for the genes
#' @param asDspMatrices Boolean; when `TRUE` the function will return only
#'   packed dense symmetric matrices
#' @param optimizeForSpeed Boolean; deprecated: always TRUE
#'
#' @return `expectedContingencyTables()` returns the expected contingency tables
#'   as named `list` with elements:
#'   * `"expectedNN"`
#'   * `"expectedNY"`
#'   * `"expectedYN"`
#'   * `"expectedYY"`
#'
#' @importFrom Rfast Crossprod
#' @importFrom Rfast Tcrossprod
#' @importFrom Rfast rowsums
#' @importFrom Rfast colsums
#'
#' @importFrom Matrix t
#'
#' @importClassesFrom Matrix symmetricMatrix
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom zeallot %<-%
#' @importFrom zeallot %->%
#'
#' @export
#'
#' @rdname CalculatingCOEX
#'
expectedContingencyTables <- function(objCOTAN,
                                      actOnCells = FALSE,
                                      asDspMatrices = FALSE,
                                      optimizeForSpeed = TRUE) {
  numGenes <- getNumGenes(objCOTAN)
  numCells <- getNumCells(objCOTAN)

  c(expectedNN, expectedN) %<-%
    expectedContingencyTablesNN(objCOTAN,
                                actOnCells = actOnCells,
                                asDspMatrices = FALSE,
                                optimizeForSpeed = TRUE)

  gc()

  if (isTRUE(actOnCells)) {
    # dimension m x m (m number of cells)
    logThis("calculating YN..", logLevel = 3L, appendLF = FALSE)

    # Any/No vector [cycled] = No/No + Yes/No
    #expectedYN <- expectedN - expectedNN

    logThis("NY..", logLevel = 3L, appendLF = FALSE)
    expectedNY <- t(expectedN - expectedNN)

    logThis("YY..", logLevel = 3L, appendLF = FALSE)
    expectedYY <- numGenes - expectedN - expectedNY

    expectedNY <- as(expectedNY, "denseMatrix")
  } else {
    # dimension n x n (n number of genes)
    logThis("calculating NY..", logLevel = 3L, appendLF = FALSE)

    # No/Any vector [cycled] = No/No + No/Yes
    #expectedNY <- expectedN - expectedNN

    logThis("YN..", logLevel = 3L, appendLF = FALSE)
    expectedYN <- t(expectedN - expectedNN)

    logThis("YY..", logLevel = 3L, appendLF = FALSE)
    expectedYY <- numCells - expectedN - expectedYN

    expectedYN <- as(expectedYN, "denseMatrix")
  }
  gc()
  logThis("t()..", logLevel = 3L, appendLF = FALSE)

  expectedYY <- forceSymmetric(as(expectedYY, "denseMatrix"))

  if (isTRUE(asDspMatrices)) {
    expectedNN <- pack(expectedNN)
    expectedYY <- pack(expectedYY)
    # these operation drops the lower triangle values
    # but the other matrix contains them anyway
    # nolint start: spaces_inside_linter
    if (isTRUE(actOnCells)) {
      expectedYN <- pack(forceSymmetric(t(expectedNY)))
      expectedNY <- pack(forceSymmetric(  expectedNY) )
    } else {
      expectedNY <- pack(forceSymmetric(t(expectedYN)))
      expectedYN <- pack(forceSymmetric(  expectedYN) )
    }
    # nolint end
  } else {
    if (isTRUE(actOnCells)) {
      expectedYN <- t(expectedNY)
    } else {
      expectedNY <- t(expectedYN)
    }
  }
  logThis(" done", logLevel = 3L)

  return(list("expectedNN" = expectedNN,
              "expectedNY" = expectedNY,
              "expectedYN" = expectedYN,
              "expectedYY" = expectedYY))
}


#' @details `expectedPartialContingencyTables()` calculates the expected values
#'   of contingency tables, restricted to the specified column sub-set
#'
#' @param objCOTAN a `COTAN` object
#' @param columnsSubset a sub-set of the columns of the matrices that will be
#'   returned
#' @param probZero is the expected **probability of zero** for each gene/cell
#'   pair. If not given the appropriate one will be calculated on the fly
#' @param actOnCells Boolean; when `TRUE` the function works for the cells,
#'   otherwise for the genes
#' @param optimizeForSpeed Boolean; deprecated: always TRUE
#'
#' @return `expectedPartialContingencyTables()` returns the expected contingency
#'   tables, restricted to the selected columns, as named `list` with elements:
#'   * `"expectedNN"`
#'   * `"expectedNY"`
#'   * `"expectedYN"`
#'   * `"expectedYY"`
#'
#' @importFrom Rfast Crossprod
#' @importFrom Rfast Tcrossprod
#' @importFrom Rfast rowsums
#' @importFrom Rfast colsums
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom zeallot %<-%
#' @importFrom zeallot %->%
#'
#' @export
#'
#' @rdname CalculatingCOEX
#'
expectedPartialContingencyTables <-
  function(objCOTAN,
           columnsSubset,
           probZero = NULL,
           actOnCells = FALSE,
           optimizeForSpeed = TRUE) {
  numGenes <- getNumGenes(objCOTAN)
  numCells <- getNumCells(objCOTAN)

  if (is.character(columnsSubset)) {
    if (isTRUE(actOnCells)) {
      allColumns <- getCells(objCOTAN)
    } else {
      allColumns <- getGenes(objCOTAN)
    }
    columnsSubset <- which(allColumns %in% columnsSubset)
  } else {
    columnsSubset <- sort(columnsSubset)
  }

  c(expectedNN, expectedN) %<-%
    expectedPartialContingencyTablesNN(objCOTAN, columnsSubset, probZero,
                                       actOnCells = actOnCells,
                                       optimizeForSpeed = TRUE)

  gc()

  if (isTRUE(actOnCells)) {
    # dimension m x m (m number of cells)
    logThis("calculating partial YN..", logLevel = 3L, appendLF = FALSE)

    # Any/No vector [cycled] = No/No + Yes/No
    expectedYN <- expectedN - expectedNN

    logThis("NY..", logLevel = 3L, appendLF = FALSE)
    expectedNY <- t(expectedN[columnsSubset] - t(expectedNN))

    logThis("YY..", logLevel = 3L, appendLF = FALSE)
    expectedYY <- numGenes - expectedN - expectedNY
  } else {
    # dimension n x n (n number of genes)
    logThis("calculating partial NY..", logLevel = 3L, appendLF = FALSE)

    # No/Any vector [cycled] = No/No + No/Yes
    expectedNY <- expectedN - expectedNN

    logThis("YN..", logLevel = 3L, appendLF = FALSE)
    expectedYN <- t(expectedN[columnsSubset] - t(expectedNN))

    logThis("YY..", logLevel = 3L, appendLF = FALSE)
    expectedYY <- numCells - expectedN - expectedYN
  }
  gc()

  logThis(" done", logLevel = 3L)

  return(list("expectedNN" = expectedNN,
              "expectedNY" = expectedNY,
              "expectedYN" = expectedYN,
              "expectedYY" = expectedYY))
}


#' @details `contingencyTables()` returns the observed and expected contingency
#'   tables for a given pair of genes. The implementation runs the same
#'   algorithms used to calculate the full observed/expected contingency tables,
#'   but restricted to only the relevant genes and thus much faster and less
#'   memory intensive
#'
#' @param objCOTAN a `COTAN` object
#' @param g1 a gene
#' @param g2 another gene
#'
#' @return `contingencyTables()` returns a list containing the observed and
#'   expected contingency tables
#'
#' @importFrom Matrix rowSums
#'
#' @importFrom assertthat assert_that
#'
#' @export
#'
#' @rdname CalculatingCOEX
#'
contingencyTables <- function(objCOTAN, g1, g2) {
  genes <- getGenes(objCOTAN)
  numCells <- getNumCells(objCOTAN)

  assert_that(c(g1) %in% genes, msg = "the first gene is unknown")
  assert_that(c(g2) %in% genes, msg = "the second gene is unknown")

  dimNames <- list(c(paste(g2, "yes", sep = "."), paste(g2, "no", sep = ".")),
                   c(paste(g1, "yes", sep = "."), paste(g1, "no", sep = ".")))

  # observed

  zeroOne <- sign(getRawData(objCOTAN)[c(g1, g2), ])
  rownames(zeroOne) <- c(g1, g2)

  observedYY <- tcrossprod(zeroOne)
  observedY  <- rowSums(zeroOne)

  rm(zeroOne)
  gc()

  observedNY <- t(observedY - observedYY)
  observedNN <- numCells - observedY - observedNY

  observedCT <- matrix(c(observedYY[g1, g2], observedNY[g2, g1],
                         observedNY[g1, g2], observedNN[g1, g2]),
                       ncol = 2L, nrow = 2L, dimnames = dimNames)

  # estimated
  lambda <- suppressWarnings(getLambda(objCOTAN))
  assert_that(!is_empty(lambda),
              msg = "`lambda` must not be empty, estimate it")

  nu <- suppressWarnings(getNu(objCOTAN))
  assert_that(!is_empty(nu),
              msg = "`nu` must not be empty, estimate it")

  dispersion <- suppressWarnings(getDispersion(objCOTAN))
  assert_that(!is_empty(dispersion),
              msg = "`dispersion` must not be empty, estimate it")

  probZero <- funProbZero(dispersion[c(g1, g2)], lambda[c(g1, g2)] %o% nu)
  rownames(probZero) <- c(g1, g2)

  if (anyNA(probZero)) {
    warning("Some NA in estimated probability of zero matrix")
  }

  expectedNN <- tcrossprod(probZero)
  expectedN <- rowSums(probZero)

  rm(probZero)
  gc()

  expectedYN <- t(expectedN - expectedNN)
  expectedYY <- numCells - expectedN - expectedYN

  expectedCT <- matrix(c(expectedYY[g1, g2], expectedYN[g1, g2],
                         expectedYN[g2, g1], expectedNN[g1, g2]),
                       ncol = 2L, nrow = 2L, dimnames = dimNames)


  return(list("observed" = observedCT, "expected" = expectedCT))
}




# --------------- COEX and related matrices -----------

## ------ Legacy implementation ------

calculateCoex_Legacy <- function(objCOTAN, actOnCells, returnPPFract) {
  startTime <- Sys.time()

  if (isTRUE(actOnCells)) {
    kind <- "cells'"
  } else {
    kind <- "genes'"
  }

  logThis(paste("Calculate", kind, "COEX (legacy): START"), logLevel = 1L)

  logThis(paste("Retrieving expected", kind, "contingency table"),
          logLevel = 3L)

  # four estimators:
  c(expectedNN, expectedNY, expectedYN, expectedYY) %<-%
    expectedContingencyTables(objCOTAN,
                              actOnCells = actOnCells,
                              asDspMatrices = TRUE,
                              optimizeForSpeed = TRUE)

  expectedTime <- Sys.time()
  logThis(paste("Expected", kind, "contingency table elapsed time:",
                difftime(expectedTime, startTime, units = "secs")),
          logLevel = 3L)

  logThis(paste("Calculating", kind, "COEX normalization factor"),
          logLevel = 3L)

  if (isTRUE(actOnCells)) {
    relNames <- getCells(objCOTAN)
    normFact <- 1.0 / sqrt(getNumGenes(objCOTAN)) # divided by sqrt(n)
  } else {
    relNames <- getGenes(objCOTAN)
    normFact <- 1.0 / sqrt(getNumCells(objCOTAN)) # divided by sqrt(m)
  }

  thresholdForPP <- 0.5
  problematicPairsFraction <- NA
  if (isTRUE(returnPPFract)) {
    problematicPairsFraction <-
      sum(pmin(expectedYY@x, expectedYN@x, expectedNY@x, expectedNN@x) <
            thresholdForPP) / length(expectedYY@x)

    logThis(paste("Fraction of", kind, "with very low",
                  "expected contingency tables:",
                  problematicPairsFraction), logLevel = 3L)
  }

  coex <- normFact * sqrt(1.0 / pmax(1.0, expectedYY@x) +
                          1.0 / pmax(1.0, expectedYN@x) +
                          1.0 / pmax(1.0, expectedNY@x) +
                          1.0 / pmax(1.0, expectedNN@x))

  rm(expectedYN, expectedNY, expectedNN)

  sqrtTime <- Sys.time()
  logThis(paste("Calculate", kind, "normalization factor elapsed time:",
                difftime(sqrtTime, expectedTime, units = "secs")),
          logLevel = 3L)

  logThis(paste("Retrieving observed", kind, "yes/yes contingency table"),
          logLevel = 3L)

  c(observedYY, .) %<-%
    observedContingencyTablesYY(objCOTAN,
                                actOnCells = actOnCells,
                                asDspMatrices = TRUE)

  observedTime <- Sys.time()
  logThis(paste("Observed", kind, "contingency table elapsed time:",
                difftime(observedTime, sqrtTime, units = "secs")),
          logLevel = 3L)

  # COEX estimation
  logThis(paste("Estimating", kind, "COEX"), logLevel = 3L)

  coex <- coex * (observedYY@x - expectedYY@x)

  assert_that(2L * length(coex) == length(relNames) * (length(relNames) + 1L),
              msg = "Output coex@x has the wrong size")

  coex <- new("dspMatrix", Dim = dim(expectedYY), x = coex)
  rownames(coex) <- colnames(coex) <- relNames

  gc()

  endTime <- Sys.time()
  logThis(paste("Calculate", kind, "COEX elapsed time:",
                difftime(endTime, observedTime, units = "secs")),
          logLevel = 3L)

  logThis(paste("Total calculations elapsed time:",
                difftime(endTime, startTime, units = "secs")),
          logLevel = 2L)

  logThis(paste("Calculate", kind, "COEX (legacy): DONE"), logLevel = 1L)

  return(list("coex" = coex, "ppf" = problematicPairsFraction))
}


## ------ Torch implementation ------

calculateCoex_Torch <- function(objCOTAN, returnPPFract, deviceStr) {
  startTime <- Sys.time()

  logThis(paste0("Calculate genes COEX (torch) on device ", deviceStr,
                 ": START"), logLevel = 1L)

  logThis("Retrieving expected genes contingency table", logLevel = 3L)

  useCuda <- startsWith(deviceStr, "cuda")

  dType <- torch::torch_float32()

  device <- torch::torch_device(deviceStr)

  nCel <- getNumCells(objCOTAN)

  probOne <- function(lambda, nu, disp) {
    # Always process in cells‑blocks (rows) of size `numGenes`
    numCells <- nu$size(1L)
    numGenes <- lambda$size(1L)

    # comparison masks
    mif <- disp == -Inf
    pif <- disp == +Inf
    neg <- disp < 1.0e-5 & !mif # use neg expr for very small disp
    pos <- !neg & !mif & !pif

    # prepare output
    out <- torch::torch_empty(c(numCells, numGenes),
                              device = device, dtype = dType)

    for (i in seq.int(1L, numCells, by = numGenes)) {
      iEnd  <- min(i + numGenes - 1L, numCells)

      # outer product
      muBlk <- torch::torch_ger(nu[i:iEnd], lambda)

      out[i:iEnd, mif] <- -Inf
      out[i:iEnd, neg] <- muBlk[, neg] * (disp[neg] - 1.0)
      out[i:iEnd, pos] <-
        -torch::torch_reciprocal(disp[pos]) *
          torch::torch_log1p(muBlk[, pos] * disp[pos])
      out[i:iEnd, pif] <- 0.0

      out[i:iEnd, ] <- torch::torch_exp(out[i:iEnd, ])

      # copy to output
      rm(muBlk)
    }

    # finalize in place
    invisible(out$sub_(1.0)$neg_())

    return(out)
  }

  lambda <- suppressWarnings(getLambda(objCOTAN))
  assert_that(!is_empty(lambda),
              msg = "`lambda` must not be empty, estimate it")

  nu <- suppressWarnings(getNu(objCOTAN))
  assert_that(!is_empty(nu),
              msg = "`nu` must not be empty, estimate it")

  disp <- suppressWarnings(getDispersion(objCOTAN))
  assert_that(!is_empty(disp),
              msg = "`dispersion` must not be empty, estimate it")

  # Build all three in dtype_calc:
  lambda_t <- torch::torch_tensor(lambda, device = device, dtype = dType)
  nu_t     <- torch::torch_tensor(nu,     device = device, dtype = dType)
  disp_t   <- torch::torch_tensor(disp,   device = device, dtype = dType)

  # Toss the originals to free CPU RAM:
  rm(lambda, nu, disp)

  expectedYY <- probOne(lambda_t, nu_t, disp_t)

  rm(lambda_t, nu_t, disp_t)

  expectedY <- torch::torch_sum(expectedYY, 1L, dtype = dType)

  expectedYY <- torch::torch_mm(torch::torch_t(expectedYY), expectedYY)

  expectedTime <- Sys.time()
  logThis(paste("Expected genes contingency table elapsed time:",
                difftime(expectedTime, startTime, units = "secs")),
          logLevel = 3L)


  logThis("Calculating genes COEX normalization factor", logLevel = 3L)

  thresholdForPP <- 0.5
  problematicPairs <- NULL

  # expectedYY
  if (isTRUE(returnPPFract)) {
    problematicPairs <-
      torch::torch_tensor(expectedYY < thresholdForPP,
                          dtype = torch::torch_bool(), device = device)
  }
  # 1.0 / max(1.0, eYY)  [new tensor]
  coex <- expectedYY$clamp_min(1.0)
  invisible(coex$reciprocal_())

  # expectedYN
  tmp <- expectedY$view(c(-1L, 1L)) - expectedYY
  if (isTRUE(returnPPFract)) {
    mask <- tmp$lt(thresholdForPP)
    invisible(problematicPairs$bitwise_or_(mask))
    rm(mask)
  }
  # 1.0 / max(1.0, eYN) [in-place]
  tmp <- tmp$clamp_min_(1.0)$reciprocal_()
  invisible(coex$add_(tmp))

  rm(tmp)

  # expectedNY
  tmp <- expectedY$view(c(1L, -1L)) - expectedYY
  if (isTRUE(returnPPFract)) {
    mask <- tmp$lt(thresholdForPP)
    invisible(problematicPairs$bitwise_or_(mask))
    rm(mask)
  }
  # 1.0 / max(1.0, eNY) [in-place]
  tmp <- tmp$clamp_min_(1.0)$reciprocal_()
  invisible(coex$add_(tmp))

  rm(tmp)

  # expectedNN
  tmp <- expectedYY - expectedY$view(c(-1L, 1L))
  invisible(expectedY$sub_(nCel))
  invisible(tmp$sub_(expectedY$view(c(1L, -1L))))
  if (isTRUE(returnPPFract)) {
    mask <- tmp$lt(thresholdForPP)
    invisible(problematicPairs$bitwise_or_(mask))
    rm(mask)
  }
  # 1.0 / max(1.0, eNN) [in-place]
  tmp <- tmp$clamp_min_(1.0)$reciprocal_()
  invisible(coex$add_(tmp))

  rm(tmp, expectedY)
  gc()

  invisible(coex$div_(nCel)$sqrt_())

  # count problematic pairs
  problematicPairsFraction <- NA
  if (isTRUE(returnPPFract)) {
    numDiagPP <- torch::torch_diag(problematicPairs)$sum()$item()
    problematicPairsFraction <-
      ((problematicPairs$sum()$item() + numDiagPP) /
         (problematicPairs$size(1L) * (problematicPairs$size(1L) + 1L)))

    logThis(paste("Fraction of genes with very low",
                  "expected contingency tables:",
                  problematicPairsFraction), logLevel = 3L)

    rm(problematicPairs)
  }

  sqrtTime <- Sys.time()
  logThis(paste("Calculating genes COEX normalization factor elapsed time:",
                difftime(sqrtTime, expectedTime, units = "secs")),
          logLevel = 3L)

  logThis("Retrieving observed genes yes/yes contingency table", logLevel = 3L)

  # observedYY
  observedYY <-
    torch::torch_tensor(suppressWarnings(as.matrix(getZeroOneProj(objCOTAN))),
                        device = device, dtype = dType)

  observedYY <- torch::torch_mm(observedYY, torch::torch_t(observedYY))

  observedTime <- Sys.time()
  logThis(paste("Observed genes contingency table elapsed time:",
                difftime(observedTime, sqrtTime, units = "secs")),
          logLevel = 3L)

  invisible(observedYY$sub_(expectedYY))

  invisible(coex$mul_(observedYY))

  rm(expectedYY, observedYY)

  ret <- pack(forceSymmetric(as(as.matrix(coex$cpu()), "denseMatrix")))
  rownames(ret) <- colnames(ret) <- getGenes(objCOTAN)

  rm(coex, device)
  gc()
  if (useCuda) {
    torch::cuda_empty_cache()
  }

  endTime <- Sys.time()
  logThis(paste("Calculate genes COEX elapsed time:",
                difftime(endTime, observedTime, units = "secs")),
          logLevel = 3L)
  logThis(paste("Total calculations elapsed time:",
                difftime(endTime, startTime, units = "secs")),
          logLevel = 2L)

  logThis(paste0("Calculate genes COEX (torch) on device ", deviceStr,
                 ": DONE"), logLevel = 1L)

  return(list("coex" = ret, "ppf" = problematicPairsFraction))
}


## ---- Calculate COEX ----

#' @aliases calculateCoex
#'
#' @details `calculateCoex()` estimates and stores the `COEX` matrix in the
#'   `cellCoex` or `genesCoex` field depending on given `actOnCells` flag. It
#'   also calculates the percentage of *problematic* genes/cells pairs. A pair
#'   is *problematic* when one or more of the expected counts were significantly
#'   smaller than 1 (\eqn{< 0.5}). These small expected values signal that scant
#'   information is present for such a pair.
#'
#' @param objCOTAN a `COTAN` object
#' @param actOnCells Boolean; when `TRUE` the function works for the cells,
#'   otherwise for the genes
#' @param returnPPFract Boolean; when `TRUE` the function returns the fraction
#'   of genes/cells pairs for which the *expected contingency table* is smaller
#'   than \eqn{0.5}. Default is FALSE
#' @param optimizeForSpeed Boolean; when `TRUE` `COTAN` tries to use the `torch`
#'   library to run the matrix calculations. Otherwise, or when the library is
#'   not available will run the slower legacy code
#' @param deviceStr On the `torch` library enforces which device to use to run
#'   the calculations. Possible values are `"cpu"` to us the system *CPU*,
#'   `"cuda"` to use the system *GPUs* or something like `"cuda:0"` to restrict
#'   to a specific device
#'
#' @returns `calculateCoex()` returns the updated `COTAN` object
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom zeallot %<-%
#' @importFrom zeallot %->%
#'
#' @importFrom methods new
#'
#' @export
#'
#' @rdname CalculatingCOEX
#'
setMethod(
  "calculateCoex",
  "COTAN",
  function(objCOTAN, actOnCells = FALSE, returnPPFract = FALSE,
           optimizeForSpeed = TRUE, deviceStr = "cuda") {
    coex <- NULL
    problematicPairsFraction <- NA

    if (isTRUE(actOnCells)) {
      if (isTRUE(optimizeForSpeed)) {
        warning("The 'torch' package is not supported yet for cells' COEX:",
                " falling back to legacy code")
      }
      c(coex, problematicPairsFraction) %<-%
        calculateCoex_Legacy(objCOTAN, actOnCells = TRUE,
                             returnPPFract = returnPPFract)

      objCOTAN@cellsCoex <- coex
      objCOTAN@metaDataset <- updateMetaInfo(objCOTAN@metaDataset,
                                             datasetTags()[["csync"]], TRUE)
      objCOTAN@metaDataset <- updateMetaInfo(objCOTAN@metaDataset,
                                             datasetTags()[["cbad"]],
                                             problematicPairsFraction)
    } else {
      c(useTorch, deviceStr) %<-% canUseTorch(optimizeForSpeed, deviceStr)

      if (useTorch) {
        c(coex, problematicPairsFraction) %<-%
          calculateCoex_Torch(objCOTAN, deviceStr = deviceStr,
                              returnPPFract = returnPPFract)
      } else {
        c(coex, problematicPairsFraction) %<-%
          calculateCoex_Legacy(objCOTAN, actOnCells = FALSE,
                               returnPPFract = returnPPFract)
      }

      objCOTAN@genesCoex <- coex
      objCOTAN@metaDataset <- updateMetaInfo(objCOTAN@metaDataset,
                                             datasetTags()[["gsync"]], TRUE)
      objCOTAN@metaDataset <- updateMetaInfo(objCOTAN@metaDataset,
                                             datasetTags()[["gbad"]],
                                             problematicPairsFraction)
    }

    return(objCOTAN)
  }
)


#' @details `calculatePartialCoex()` estimates a sub-section of the `COEX`
#'   matrix in the `cellCoex` or `genesCoex` field depending on given
#'   `actOnCells` flag. It also calculates the percentage of *problematic*
#'   genes/cells pairs. A pair is *problematic* when one or more of the expected
#'   counts were significantly smaller than 1 (\eqn{< 0.5}). These small
#'   expected values signal that scant information is present for such a pair.
#'
#' @param objCOTAN a `COTAN` object
#' @param columnsSubset a sub-set of the columns of the matrices that will be
#'   returned
#' @param probZero is the expected **probability of zero** for each gene/cell
#'   pair. If not given the appropriate one will be calculated on the fly
#' @param actOnCells Boolean; when `TRUE` the function works for the cells,
#'   otherwise for the genes
#' @param optimizeForSpeed Boolean; deprecated: always TRUE
#'
#' @returns `calculatePartialCoex()` returns the asked section of the `COEX`
#'   matrix
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom zeallot %<-%
#' @importFrom zeallot %->%
#'
#' @export
#'
#' @rdname CalculatingCOEX
#'
calculatePartialCoex <- function(objCOTAN,
                                 columnsSubset,
                                 probZero = NULL,
                                 zeroOne = NULL,
                                 actOnCells = FALSE,
                                 optimizeForSpeed = TRUE) {
  startTime <- Sys.time()

  if (isTRUE(actOnCells)) {
      kind <- "cells'"
    } else {
      kind <- "genes'"
    }
    logThis(paste("Calculate", kind, "partial COEX: START"), logLevel = 1L)

    logThis(paste("Retrieving expected", kind, "partial contingency table"),
            logLevel = 3L)

    # four estimators:
    c(expectedNN, expectedNY, expectedYN, expectedYY) %<-%
      expectedPartialContingencyTables(objCOTAN, columnsSubset,
                                       probZero = probZero,
                                       actOnCells = actOnCells,
                                       optimizeForSpeed = TRUE)

    gc()

    logThis(paste("Calculating", kind, "partial COEX normalization factor"),
            logLevel = 3L)

    if (isTRUE(actOnCells)) {
      normFact <- 1.0 / sqrt(getNumGenes(objCOTAN)) # divided by sqrt(n)
    } else {
      normFact <- 1.0 / sqrt(getNumCells(objCOTAN)) # divided by sqrt(m)
    }

    problematicPairsFraction <-
      sum(pmin(expectedYY, expectedYN,
               expectedNY, expectedNN) < 0.5) / length(expectedYY)

    logThis(paste0("Fraction of genes with very low",
                   " expected contingency tables: ",
                   problematicPairsFraction), logLevel = 3L)

    coex <- normFact * sqrt(1.0 / pmax(1.0, expectedYY) +
                            1.0 / pmax(1.0, expectedYN) +
                            1.0 / pmax(1.0, expectedNY) +
                            1.0 / pmax(1.0, expectedNN))

    rm(expectedYN, expectedNY, expectedNN)
    gc()

    logThis(paste("Retrieving observed", kind,
                  "yes/yes partial contingency table"),
            logLevel = 3L)

    c(observedYY, .) %<-%
      observedPartialContingencyTablesYY(objCOTAN,
                                         columnsSubset = columnsSubset,
                                         zeroOne = zeroOne,
                                         actOnCells = actOnCells)

    gc()

    # COEX estimation
    logThis(paste("Estimating", kind, "partial COEX"), logLevel = 3L)

    coex <- coex * (observedYY - expectedYY)

    rm(observedYY, expectedYY)
    gc()

    endTime <- Sys.time()

    logThis(paste("Total calculations elapsed time:",
                  difftime(endTime, startTime, units = "secs")),
            logLevel = 2L)

    logThis(paste("Calculate", kind, "partial COEX: DONE"), logLevel = 1L)

    return(coex)
  }


#' @details `calculateS()` calculates the statistics **S** for genes contingency
#'   tables. It always has the diagonal set to zero.
#'
#' @param objCOTAN a `COTAN` object
#' @param geneSubsetCol an array of genes. It will be put in columns. If left
#'   empty the function will do it genome-wide.
#' @param geneSubsetRow an array of genes. It will be put in rows. If left empty
#'   the function will do it genome-wide.
#'
#' @returns `calculateS()` returns the `S` matrix
#'
#' @export
#'
#' @importFrom rlang is_empty
#'
#' @importFrom assertthat assert_that
#'
#' @rdname CalculatingCOEX
#'
calculateS <- function(objCOTAN,
                       geneSubsetCol = vector(mode = "character"),
                       geneSubsetRow = vector(mode = "character")) {
  logThis("Calculating S: START", logLevel = 3L)

  geneSubsetCol <- handleNamesSubsets(getGenes(objCOTAN), geneSubsetCol)
  geneSubsetRow <- handleNamesSubsets(getGenes(objCOTAN), geneSubsetRow)

  assert_that(isCoexAvailable(objCOTAN), msg = "Coex is missing")

  coex <- getGenesCoex(objCOTAN, zeroDiagonal = TRUE)
  if (!identical(geneSubsetRow, getGenes(objCOTAN)) ||
      !identical(geneSubsetCol, getGenes(objCOTAN))) {
    coex <- coex[geneSubsetRow, geneSubsetCol, drop = FALSE]
  }

  assert_that(!is_empty(coex), msg = "Genes subset result in empty matrix")

  S <- coex^2L * getNumCells(objCOTAN)

  logThis("Calculating S: DONE", logLevel = 3L)

  return(S)
}


#' @details `calculateG()` calculates the statistics *G-test* for genes
#'   contingency tables. It always has the diagonal set to zero. It is
#'   proportional to the genes' presence mutual information.
#'
#' @param objCOTAN a `COTAN` object
#' @param geneSubsetCol an array of genes. It will be put in columns. If left
#'   empty the function will do it genome-wide.
#' @param geneSubsetRow an array of genes. It will be put in rows. If left empty
#'   the function will do it genome-wide.
#'
#' @returns `calculateG()` returns the G matrix
#'
#' @importFrom zeallot %<-%
#' @importFrom zeallot %->%
#'
#' @export
#'
#' @rdname CalculatingCOEX
#'
calculateG <- function(objCOTAN, geneSubsetCol = vector(mode = "character"),
                       geneSubsetRow = vector(mode = "character")) {
  startTime <- Sys.time()

  logThis("Calculating G: START", logLevel = 2L)

  geneSubsetCol <- handleNamesSubsets(getGenes(objCOTAN), geneSubsetCol)
  geneSubsetRow <- handleNamesSubsets(getGenes(objCOTAN), geneSubsetRow)

  c(observedNN, observedNY, observedYN, observedYY) %<-%
    observedContingencyTables(objCOTAN, actOnCells = FALSE)

  c(expectedNN, expectedNY, expectedYN, expectedYY) %<-%
    expectedContingencyTables(objCOTAN, actOnCells = FALSE)

  logThis("Estimating G", logLevel = 3L)

  tNN <- observedNN * log(observedNN / pmax(1.0, expectedNN))
  tNN[observedNN == 0L] <- 0.0
  diag(tNN) <- 0.0
  tNN <- tNN[geneSubsetRow, geneSubsetCol, drop = FALSE]
  rm(observedNN, expectedNN)

  tNY <- observedNY * log(observedNY / pmax(1.0, expectedNY))
  tNY[observedNY == 0L] <- 0.0
  diag(tNY) <- 0.0
  tNY <- tNY[geneSubsetRow, geneSubsetCol, drop = FALSE]
  rm(observedNY, expectedNY)

  tYN <- observedYN * log(observedYN / pmax(1.0, expectedYN))
  tYN[observedYN == 0L] <- 0.0
  diag(tYN) <- 0.0
  tYN <- tYN[geneSubsetRow, geneSubsetCol, drop = FALSE]
  rm(observedYN, expectedYN)

  tYY <- observedYY * log(observedYY / pmax(1.0, expectedYY))
  tYY[observedYY == 0L] <- 0.0
  diag(tYY) <- 0.0
  tYY <- tYY[geneSubsetRow, geneSubsetCol, drop = FALSE]
  rm(observedYY, expectedYY)
  gc()

  G <- 2.0 * (tNN + tNY + tYN + tYY)

  if (identical(geneSubsetRow, getGenes(objCOTAN)) &&
      identical(geneSubsetCol, getGenes(objCOTAN))) {
    G <- pack(forceSymmetric(G))
  }

  rm(tNN, tNY, tYN, tYY)
  gc()

  endTime <- Sys.time()

  logThis(paste("Total calculations elapsed time:",
                difftime(endTime, startTime, units = "secs")),
          logLevel = 2L)

  logThis("Calculating G: DONE", logLevel = 2L)

  return(G)
}



## -------- Genes selector -------

#' @details `getSelectedGenes()` selects the *most representative* genes of the
#'   `data.set`
#'
#' @param objCOTAN a `COTAN` object
#' @param genesSel Decides whether and how to perform the gene-selection. used
#'   for the clustering and the `UMAP`. It is a string indicating one of the
#'   following selection methods:
#'   * `"HGDI"` Will pick-up the genes with highest `GDI` (default)
#'   * `"HVG_Seurat"` Will pick-up the genes with the highest variability
#'   via the \pkg{Seurat} package
#'   * `"HVG_Scanpy"` Will pick-up the genes with the highest variability
#'   according to the `Scanpy` package (using the \pkg{Seurat} implementation)
#' @param numGenes the number of genes to select using the above method. Will be
#'   ignored when an explicit list of genes has been passed in
#'
#' @returns `getSelectedGenes()` returns an array with the genes' names
#'
#' @export
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom Seurat CreateSeuratObject
#' @importFrom Seurat NormalizeData
#' @importFrom Seurat FindVariableFeatures
#' @importFrom Seurat VariableFeatures
#'
#' @rdname CalculatingCOEX

getSelectedGenes <- function(objCOTAN, genesSel = "", numGenes = 2000L) {
  logThis("Running genes' selection: START", logLevel = 2L)

  numGenes <- min(numGenes, getNumGenes(objCOTAN))
  selectedGenes <- NULL

  getHighestGDIGenes <- function(objCOTAN, numGenes) {
    gdi <- suppressWarnings(getGDI(objCOTAN))
    if (is_empty(gdi)) {
      gdi <- getColumnFromDF(calculateGDI(objCOTAN, statType = "S",
                                          rowsFraction = 0.05), "GDI")
    }

    sortedCandidates <- names(gdi)[order(gdi, decreasing = TRUE)]
    if (gdi[sortedCandidates[numGenes]] < 1.3) {
      numLowGDIGenes <- sum(gdi[sortedCandidates[seq_len(numGenes)]] < 1.3)
      logThis(paste("Included", numLowGDIGenes, "genes with GDI below 1.3"),
              logLevel = 1L)
    }
    return(sortedCandidates[seq_len(numGenes)])
  }

  getHighestVariableGenes <- function(objCOTAN, numGenes, useVST) {
    srat <- CreateSeuratObject(counts = getRawData(objCOTAN),
                               project = "genes_selections")
    srat <- NormalizeData(srat)

    srat <- FindVariableFeatures(
      srat, nfeatures = numGenes,
      selection.method = ifelse(useVST, "vst", "mean.var.plot"))

    return(VariableFeatures(object = srat))
  }

  selectedGenes <- NULL
  if (length(genesSel) > 1L) {
    assert_that(all(genesSel %in% getGenes(objCOTAN)),
                msg = "Passed genes are not a subset of the relevant ones")

    selectedGenes <- genesSel

    logThis(paste("Given", length(selectedGenes), "genes as input"),
            logLevel = 2L)
  } else {
    if (isEmptyName(genesSel)) {
      genesSel <- "HGDI"
    }

    selectedGenes <- switch(
      genesSel,
      HGDI = getHighestGDIGenes(objCOTAN, numGenes),
      HVG_Seurat = , vst =
        getHighestVariableGenes(objCOTAN, numGenes, TRUE),
      HVG_Scanpy = , mean.var.plot =
        getHighestVariableGenes(objCOTAN, numGenes, FALSE),
      stop("Unrecognised `genesSel` passed in: ", genesSel)
    )

    logThis(paste("Selected", length(selectedGenes), "genes using",
                  genesSel, "selector"), logLevel = 3L)
  }

  # align to sequence in input data
  selectedGenes <- getGenes(objCOTAN)[getGenes(objCOTAN) %in% selectedGenes]

  logThis("Running genes' selection: DONE", logLevel = 2L)

  return(selectedGenes)
}


#' @details `calculateReducedDataMatrix()` calculates the reduced data-matrix to
#'   be used for *clusterizations* or `UMAP` plots.
#'
#'   It uses the given `dataMethod` to determine with which data to start, then,
#'   depending on the value of `useCoexEigen`, either uses the `genesSel` to
#'   restrict evaluation to the relevant genes' before the `PCA` is run, or it
#'   calculates the first **COEX** eigenvectors and projects the data matrix to
#'   their sub-space.
#'
#' @param objCOTAN a `COTAN` object
#' @param useCoexEigen Boolean to determine whether to project the data `matrix`
#'   onto the first eigenvectors of the **COEX** `matrix` or instead restrict
#'   the data `matrix` to the selected genes before applying the `PCA` reduction
#' @param dataMethod selects the method to use to create the `data.frame` to
#'   pass to the [UMAPPlot()]. To calculate, for each cell, a statistic for each
#'   gene based on available data/model, the following methods are supported:
#'   * `"RW", "Raw", "RawData"` uses the *raw* counts
#'   * `"NN", "NuNorm", "Normalized"` uses the \eqn{\nu}*-normalized* counts
#'   * `"LN", "LogNorm", "LogNormalized"` uses the *log-normalized* counts
#'   (default)
#'   * `"BI", "Bin", "Binarized"` uses the *binarized* data matrix
#'   * `"BD", "BinDiscr", "BinarizedDiscrepancy"` uses the *difference* between
#'   the *binarized* data matrix and the estimated *probability of one*
#'   * `"AB", "AdjBin", "AdjBinarized"` uses the absolute value of
#'   the *binarized discrepancy* above
#'   * `"LH", "Like", "Likelihood"` uses the *likelihood* of *binarized*
#'   data matrix
#'   * `"LL", "LogLike", "LogLikelihood"` uses the *log-likelihood*
#'   of *binarized* data matrix
#'   * `"DL", "DerLogL", "DerivativeLogLikelihood"` uses the *derivative* of
#'   the *log-likelihood* of *binarized* data matrix
#'   * `"SL", "SignLogL", "SignedLogLikelihood"` uses the *signed
#'   log-likelihood* of *binarized* data matrix
#'
#'   For the last four options see [calculateLikelihoodOfObserved()] for more
#'   details
#' @param numComp Number of components of the reduced `matrix`, it defaults to
#'   25L.
#' @param genesSel Decides whether and how to perform the gene-selection. used
#'   for the clustering and the `UMAP`. It is a string indicating one of the
#'   following selection methods:
#'   * `"HGDI"` Will pick-up the genes with highest `GDI` (default)
#'   * `"HVG_Seurat"` Will pick-up the genes with the highest variability
#'   via the \pkg{Seurat} package
#'   * `"HVG_Scanpy"` Will pick-up the genes with the highest variability
#'   according to the `Scanpy` package (using the \pkg{Seurat} implementation)
#' @param numGenes the number of genes to select using the above method. Will be
#'   ignored when an explicit list of genes has been passed in
#'
#' @returns `calculateReducedDataMatrix()` returns the reduced matrix. The
#'   returned `matrix` has dimensions: (number of cells, number of components)
#'
#' @importFrom zeallot %<-%
#' @importFrom zeallot %->%
#'
#' @importFrom RSpectra eigs_sym
#'
#' @importFrom BiocSingular runPCA
#'
#' @export
#'
#' @rdname CalculatingCOEX
#'
calculateReducedDataMatrix <-
  function(objCOTAN, useCoexEigen = FALSE,
           dataMethod = "", numComp = 25L,
           genesSel = "", numGenes = 2000L) {
  startTime <- Sys.time()

  logThis("Elaborating Reduced dimensionality Data Matrix - START",
          logLevel = 2L)

  numComp <- min(numComp, getNumGenes(objCOTAN))

  cellsRDM <- NULL
  if (isTRUE(useCoexEigen)) {
    logThis("Elaborating COEX Eigen Vectors - START", logLevel = 3L)

    # calculate the most relenvat eigen-vectors of the COEX matrix
    res <- eigs_sym(as.matrix(getGenesCoex(objCOTAN, zeroDiagonal = FALSE)),
                    k = numComp, which = "LM")
    eigenVectors <- res$vectors[, seq_len(numComp)]
    rm(res)
    gc()

    logThis("Elaborating COEX Eigen Vectors - DONE", logLevel = 3L)

    # retrieve the the data matrix and project it onto the coex eigen-space
    dataMatrix <- t(eigenVectors) %*%
                    getDataMatrix(objCOTAN, dataMethod = dataMethod)

    # re-scale in the cells direction
    cellsRDM <- t(scale(dataMatrix, center = FALSE, scale = TRUE))
    rm(dataMatrix)

    colnames(cellsRDM) <- paste0("EC_", seq_len(ncol(cellsRDM)))
  } else {
    selectedGenes <- getSelectedGenes(objCOTAN, genesSel = genesSel,
                                      numGenes = numGenes)
    cellsMatrix <-
      t(getDataMatrix(objCOTAN, dataMethod = dataMethod)[selectedGenes, ])

    # re-scale so that all the genes have mean 0.0 and stdev 1.0
    cellsMatrix <- scale(cellsMatrix, center = TRUE, scale = TRUE)

    logThis("Elaborating PCA - START", logLevel = 3L)

    cellsRDM <- runPCA(x = cellsMatrix,
                       rank = min(numComp, ncol(cellsMatrix)),
                       BSPARAM = IrlbaParam(),
                       get.rotation = FALSE)[["x"]]
    rm(cellsMatrix)

    logThis("Elaborating PCA - DONE", logLevel = 3L)
  }
  gc()

  assert_that(nrow(cellsRDM) == getNumCells(objCOTAN),
              ncol(cellsRDM) <= numComp)

  endTime <- Sys.time()

  logThis(paste("Total calculations elapsed time:",
                difftime(endTime, startTime, units = "secs")),
          logLevel = 2L)

  logThis("Elaborating Reduced dimensionality Data Matrix - DONE",
          logLevel = 2L)

  return(cellsRDM)
}

prevOptState <- options(parallelly.fork.enable = TRUE)
options(COTAN.TorchWarning = NULL)

test_that("COTAN getters", {
  raw <- matrix(c(1L,  0L, 4L, 2L, 11L, 0L, 6L, 7L, 0L, 9L,
                  10L, 8L, 0L, 0L,  0L, 3L, 0L, 0L, 2L, 0L),
                nrow = 10L, ncol = 20L)
  rownames(raw) <- LETTERS[1L:10L]
  colnames(raw) <- letters[1L:20L]

  obj <- COTAN(raw = raw)
  obj <- initializeMetaDataset(obj, GEO = "V", sequencingMethod = "10X",
                               sampleCondition = "Test")
  obj <- clean(obj)

  obj <- estimateLambdaLinear(obj)
  obj <- estimateDispersionViaSolver(obj, cores = 2L)

  # add second column to global meta-data
  obj <- addElementToMetaDataset(
    obj, tag = datasetTags()[["sc.m"]], value = c("10X", "V3"))

  # set tag label as legacy value
  row <- getMetaInfoRow(getMetadataDataset(obj), datasetTags()[["gsync"]])
  obj@metaDataset[row, 1L:2L] <- c("genes' coex is in sync:", FALSE)

  suppressWarnings({
    obj <- calculateCoex(obj, actOnCells = FALSE, returnPPFract = TRUE,
                         optimizeForSpeed = TRUE, deviceStr = "cpu")
  })
  expect_no_warning({
    obj <- calculateCoex(obj, actOnCells = TRUE, returnPPFract = TRUE,
                         optimizeForSpeed = FALSE)
  })

  obj <- storeGDI(obj, genesGDI = calculateGDI(obj))

  obj <- addClusterization(obj, clName = "Test",
                           clusters = set_names(rep(c(1L, 2L), 10L),
                                                colnames(raw)))
  obj <- addClusterization(obj, clName = "Test2",
                           clusters = set_names(rep(c(2L, 1L), 10L),
                                                colnames(raw)))

  obj <- addCondition(obj, condName = "Test",
                      conditions = set_names(rep(c("F", "M"), 10L),
                                             colnames(raw)))
  obj <- addCondition(obj, condName = "Test", override = TRUE,
                      conditions = set_names(c(rep(c("F", "M"), 9L), "M", "F"),
                                             colnames(raw)))

  metaInfo <- c("V", "10X", "Test", "20", "TRUE", "TRUE",
                paste0(10.0 / 55.0), paste0(0L))

  zeroOne <- sign(getRawData(obj))
  probZero <- funProbZero(getDispersion(obj), getLambda(obj) %o% getNu(obj))

  expect_identical(getRawData(obj), as(as(raw, "Matrix"), "dgCMatrix"))
  expect_identical(getNumGenes(obj), 10L)
  expect_identical(getNumCells(obj), 20L)
  expect_identical(getGenes(obj), head(LETTERS, getNumGenes(obj)))
  expect_identical(getCells(obj), head(letters, getNumCells(obj)))
  expect_identical(getCellsSize(obj), colSums(getRawData(obj)))
  expect_identical(getNumExpressedGenes(obj), colSums(getRawData(obj) != 0L))
  expect_identical(getGenesSize(obj), rowSums(getRawData(obj)))
  expect_identical(getNumOfExpressingCells(obj), rowSums(getRawData(obj) != 0L))
  expect_identical(
    getNuNormData(obj),
    t(t(getRawData(obj)) * (1.0 / getNu(obj)))
  )
  expect_identical(
    getLogNormData(obj),
    log1p(t(t(getRawData(obj)) * (1.0e4 / getCellsSize(obj)))) / log(10.0)
  )
  expect_equal(getMetadataDataset(obj)[[1L]], datasetTags()[1L:8L],
               ignore_attr = TRUE)
  expect_identical(getMetadataDataset(obj)[[2L]], metaInfo)
  expect_identical(
    getMetaInfoRow(getMetadataDataset(obj), "genes' COEX is in sync:"), 5L)
  expect_identical(
    as.list(getMetadataElement(obj, tag = "genes' coex is in sync:")),
    list(V2 = "TRUE", V3 = NA_character_)
  )
  expect_true(isCoexAvailable(obj, actOnCells = FALSE))
  expect_true(isCoexAvailable(obj, actOnCells = FALSE, ignoreSync = TRUE))
  expect_true(isCoexAvailable(obj, actOnCells = TRUE))
  expect_true(isCoexAvailable(obj, actOnCells = TRUE, ignoreSync = TRUE))
  expect_setequal(colnames(getMetadataGenes(obj)),
                  c("lambda", "feGenes", "dispersion", "GDI"))
  expect_identical(rownames(getMetadataGenes(obj)), getGenes(obj))
  expect_setequal(colnames(getMetadataCells(obj)),
                  c("nu", "feCells", names(getClustersCoex(obj)),
                    getAllConditions(obj, keepPrefix = TRUE)))
  expect_identical(rownames(getMetadataCells(obj)), getCells(obj))
  expect_length(getClustersCoex(obj), 2L)
  expect_named(getClustersCoex(obj), paste0("CL_", getClusterizations(obj)))
  expect_identical(getClustersCoex(obj)[["CL_Test"]], data.frame())

  expect_equal(getNu(obj), getMetadataCells(obj)[["nu"]],
               ignore_attr = TRUE)
  expect_equal(getLambda(obj), getMetadataGenes(obj)[["lambda"]],
               ignore_attr = TRUE)
  expect_equal(getDispersion(obj), getMetadataGenes(obj)[["dispersion"]],
               ignore_attr = TRUE)
  expect_identical(flagNotFullyExpressedGenes(obj),
                   c(FALSE, rep(TRUE, getNumGenes(obj) - 1L)))
  expect_identical(getFullyExpressedGenes(obj), LETTERS[[1L]])
  expect_identical(flagNotFullyExpressingCells(obj),
                   rep(TRUE, getNumCells(obj)))
  expect_identical(getFullyExpressingCells(obj), vector(mode = "character"))
  expect_identical(dim(getGenesCoex(obj)),
                   as.integer(c(getNumGenes(obj), getNumGenes(obj))))
  expect_identical(dim(getCellsCoex(obj)),
                   as.integer(c(getNumCells(obj), getNumCells(obj))))
  expect_identical(getGDI(obj), getColumnFromDF(calculateGDI(obj), "GDI"))
  expect_identical(getClusterizations(obj), c("Test", "Test2"))
  expect_identical(getClusterizationName(obj), "Test2")
  expect_identical(getClusterizationName(obj, clName = "Test",
                                         keepPrefix = TRUE), "CL_Test")
  expect_setequal(names(getClusterizationData(obj)), c("coex", "clusters"))
  expect_equal(getClusterizationData(obj)[["clusters"]],
               getMetadataCells(obj)[["CL_Test2"]], ignore_attr = TRUE)
  expect_identical(getClusters(obj), getClusterizationData(obj)[["clusters"]])
  expect_identical(getClusterizationData(obj)[["coex"]], data.frame())
  expect_identical(getAllConditions(obj), "Test")
  expect_identical(getConditionName(obj), "")
  expect_identical(getConditionName(obj, condName = "Test",
                                    keepPrefix = TRUE), "COND_Test")
  expect_identical(levels(getCondition(obj)), "NoCond")
  expect_identical(factorToVector(getCondition(obj,
                                               condName = "Test"))[19L:20L],
                   set_names(c("M", "F"), letters[19L:20L]))
  expect_length(getDims(obj), 7L)
  expect_identical(getDims(obj)[["raw"]], dim(getRawData(obj)))
  expect_identical(getDims(obj)[["metaCells"]], ncol(getMetadataCells(obj)))
  expect_null(getDims(obj)[["clusterCoex"]])

  # getting data matrices
  expect_identical(getZeroOneProj(obj), zeroOne)
  expect_identical(getProbabilityOfZero(obj), probZero)

  ## bound probablitities to avoid extremes
  bProbZero <- pmax(1.0e-8, pmin(1.0 - 1.0e-8, probZero))

  getLH <- function(objCOTAN, formula) {
    return(calculateLikelihoodOfObserved(objCOTAN, formula))
  }

  asDataMatrix <- function(objCOTAN, array) {
    matrix(array, nrow = getNumGenes(objCOTAN),
           dimnames = list(getGenes(objCOTAN), getCells(objCOTAN)))
  }

  binDiscr <- function(objCOTAN) {
    rawData <- getRawData(objCOTAN)
    probZero <- getProbabilityOfZero(objCOTAN)
    return(asDataMatrix(objCOTAN,
                        ifelse(rawData != 0L, probZero, probZero - 1.0)))
  }
  ## check default
  expect_identical(
    calculateLikelihoodOfObserved(obj),
    getLH(obj, formula = "raw")
  )

  expect_identical(
    getLH(obj, formula = "raw"),
    asDataMatrix(obj, ifelse(zeroOne, (1.0 - bProbZero), bProbZero))
  )
  expect_identical(
    getLH(obj, formula = "log"),
    asDataMatrix(obj, ifelse(zeroOne, log1p(-bProbZero), log(bProbZero)))
  )
  expect_identical(
    getLH(obj, formula = "der"),
    asDataMatrix(
      obj,
      ifelse(zeroOne, -1.0 / (1.0 - bProbZero), 1.0 / bProbZero)
    )
  )
  expect_identical(
    getLH(obj, formula = "sLog"),
    asDataMatrix(obj, ifelse(zeroOne, -log1p(-bProbZero), log(bProbZero)))
  )

  ## strings are case sensitive
  expect_error(getLH(obj, formula = "SLog"))

  # general data retrieval

  ## check default
  expect_identical(getDataMatrix(obj), as.matrix(getLogNormData(obj)))

  # nolint start: line_length_linter
  expect_identical(getDataMatrix(obj, dataMethod = "RW"),                      as.matrix(getRawData(obj)))
  expect_identical(getDataMatrix(obj, dataMethod = "Raw"),                     as.matrix(getRawData(obj)))
  expect_identical(getDataMatrix(obj, dataMethod = "RawData"),                 as.matrix(getRawData(obj)))
  expect_identical(getDataMatrix(obj, dataMethod = "NN"),                      as.matrix(getNuNormData(obj)))
  expect_identical(getDataMatrix(obj, dataMethod = "NuNorm"),                  as.matrix(getNuNormData(obj)))
  expect_identical(getDataMatrix(obj, dataMethod = "Normalized"),              as.matrix(getNuNormData(obj)))
  expect_identical(getDataMatrix(obj, dataMethod = "LN"),                      as.matrix(getLogNormData(obj)))
  expect_identical(getDataMatrix(obj, dataMethod = "LogNorm"),                 as.matrix(getLogNormData(obj)))
  expect_identical(getDataMatrix(obj, dataMethod = "LogNormalized"),           as.matrix(getLogNormData(obj)))
  expect_identical(getDataMatrix(obj, dataMethod = "BI"),                      as.matrix(zeroOne))
  expect_identical(getDataMatrix(obj, dataMethod = "Bin"),                     as.matrix(zeroOne))
  expect_identical(getDataMatrix(obj, dataMethod = "Binarized"),               as.matrix(zeroOne))
  expect_identical(getDataMatrix(obj, dataMethod = "BD"),                      as.matrix(    binDiscr(obj)))
  expect_identical(getDataMatrix(obj, dataMethod = "BinDiscr"),                as.matrix(    binDiscr(obj)))
  expect_identical(getDataMatrix(obj, dataMethod = "BinarizedDiscrepancy"),    as.matrix(    binDiscr(obj)))
  expect_identical(getDataMatrix(obj, dataMethod = "AB"),                      as.matrix(abs(binDiscr(obj))))
  expect_identical(getDataMatrix(obj, dataMethod = "AdjBin"),                  as.matrix(abs(binDiscr(obj))))
  expect_identical(getDataMatrix(obj, dataMethod = "AdjBinarized"),            as.matrix(abs(binDiscr(obj))))
  expect_identical(getDataMatrix(obj, dataMethod = "LH"),                      as.matrix(getLH(obj, "raw")))
  expect_identical(getDataMatrix(obj, dataMethod = "Like"),                    as.matrix(getLH(obj, "raw")))
  expect_identical(getDataMatrix(obj, dataMethod = "Likelihood"),              as.matrix(getLH(obj, "raw")))
  expect_identical(getDataMatrix(obj, dataMethod = "LL"),                      as.matrix(getLH(obj, "log")))
  expect_identical(getDataMatrix(obj, dataMethod = "LogLike"),                 as.matrix(getLH(obj, "log")))
  expect_identical(getDataMatrix(obj, dataMethod = "LogLikelihood"),           as.matrix(getLH(obj, "log")))
  expect_identical(getDataMatrix(obj, dataMethod = "DL"),                      as.matrix(getLH(obj, "der")))
  expect_identical(getDataMatrix(obj, dataMethod = "DerLogL"),                 as.matrix(getLH(obj, "der")))
  expect_identical(getDataMatrix(obj, dataMethod = "DerivativeLogLikelihood"), as.matrix(getLH(obj, "der")))
  expect_identical(getDataMatrix(obj, dataMethod = "SL"),                      as.matrix(getLH(obj, "sLog")))
  expect_identical(getDataMatrix(obj, dataMethod = "SignLogL"),                as.matrix(getLH(obj, "sLog")))
  expect_identical(getDataMatrix(obj, dataMethod = "SignedLogLikelihood"),     as.matrix(getLH(obj, "sLog")))
  # nolint end

  ## strings are case sensitive
  expect_error(getDataMatrix(obj, dataMethod = "signLogl"))

  expect_message(getSelectedGenes(obj))
  expect_identical(getSelectedGenes(obj),
                   getSelectedGenes(obj, genesSel = "HGDI", numGenes = 2000L))

  expect_identical(getSelectedGenes(obj, genesSel = "HGDI", numGenes = 5L),
                   c("C", "D", "F", "G", "I"))
  suppressWarnings(expect_warning(
      getSelectedGenes(obj, genesSel = "HVG_Seurat", numGenes = 5L)
  ))
  expect_error(getSelectedGenes(obj, genesSel = "HVG_Scanpy", numGenes = 5L))
  expect_identical(getSelectedGenes(obj, genesSel = c("C", "A", "D", "E", "B")),
                   LETTERS[1L:5L])

  calcRDM <- function(objCOTAN, useCoexEigen, dataMethod,
                      numComp, genesSel = "", numGenes = 2000L) {
    return(suppressWarnings(
      calculateReducedDataMatrix(objCOTAN = objCOTAN,
                                 useCoexEigen = useCoexEigen,
                                 dataMethod = dataMethod,
                                 numComp = numComp,
                                 genesSel = genesSel,
                                 numGenes = numGenes)))
  }

  expect_equal(suppressWarnings(abs(calculateReducedDataMatrix(obj))),
               abs(calcRDM(obj, useCoexEigen = FALSE,
                           dataMethod = "LogNormalized", numComp = 50L,
                           genesSel = "HGDI", numGenes = 2000L)),
               tolerance = 1.0e-12)

  m1 <- as.matrix(cbind(rep(2.756809750418045, times = 20L),
                        rep(0.0, times = 20L), rep(0.0, times = 20L),
                        rep(0.0, times = 20L), rep(0.0, times = 20L)))
  colnames(m1) <- paste0("PC", 1L:5L)
  rownames(m1) <- letters[1L:20L]

  expect_equal(abs(calcRDM(obj, useCoexEigen = FALSE,
                           dataMethod = "AdjBinarized", numComp = 5L,
                           genesSel = "HGDI", numGenes = 8L)),
               m1, tolerance = 1.0e-12)

  expect_equal(abs(calcRDM(obj, useCoexEigen = FALSE,
                           dataMethod = "LogLikelihood", numComp = 5L,
                           genesSel = "HVG_Seurat", numGenes = 8L)),
               m1, tolerance = 1.0e-12)

  # nolint start: spaces_inside_linter
  m2 <- cbind(
    rep(c(1.991509612121359,     -1.991510865753923    ), times = 10L),
    rep(c(4.556799230950100e-05, -4.815389335445746e-05), times = 10L),
    rep(c(5.701730287707164e-05, -8.375641609457851e-05), times = 10L))
  colnames(m2) <- paste0("EC_", 1L:3L)
  rownames(m2) <- letters[1L:20L]

  expect_equal(calcRDM(obj, useCoexEigen = TRUE,
                       dataMethod = "BinDiscr", numComp = 5L)[, 1L:3L],
               m2, tolerance = 5.0e-5)

  m3 <- cbind(
    rep(c(-1.96537974590724,    1.96547022027574     ), times = 10L),
    rep(c(-5.14674535931154e-4, 2.4124745673443485e-2), times = 10L),
    rep(c( 0.227956910102598,   0.226238243931497    ), times = 10L))
  colnames(m3) <- paste0("EC_", 1L:3L)
  rownames(m3) <- letters[1L:20L]
  if (FALSE) {
    attr(m3, "scaled:scale") <-
      set_names(rep(c(3.020580325047483, 3.020462711979378), times = 10L),
                letters[1L:20L])
  }
  expect_equal(calcRDM(obj, useCoexEigen = TRUE,
                       dataMethod = "DerLogL", numComp = 5L)[, 1L:3L],
               m3, tolerance = 5.0e-4)
  # nolint end
})

options(prevOptState)

library(rlang)
library(zeallot)

prevOptState <- options(parallelly.fork.enable = TRUE)
options(COTAN.TorchWarning = NULL)

crossEntrVector <- function(zeroOne, probZero) {
  crossEntr <- rep_len(0.0, nrow(zeroOne))
  for (r in seq_len(nrow(zeroOne))) {
    for (c in seq_len(ncol(zeroOne))) {
      if (probZero[r, c] != 0.0) {
        crossEntr[r] <- crossEntr[r] -
          (1.0 - zeroOne[r, c]) * log(probZero[r, c]) -
          zeroOne[r, c] * log(1.0 - probZero[r, c])
      }
    }
    crossEntr[r] <- crossEntr[r] / ncol(zeroOne)
  }

  return(crossEntr)
}

# nolint start: spaces_inside_linter
coexPoint <- function(o, e, n) {
  num <- ( ((o[[1L]] - e[[1L]]) / max(1.0, e[[1L]])) -
           ((o[[2L]] - e[[2L]]) / max(1.0, e[[2L]])) -
           ((o[[3L]] - e[[3L]]) / max(1.0, e[[3L]])) +
           ((o[[4L]] - e[[4L]]) / max(1.0, e[[4L]])) )
  den <- sqrt(n * ( (1.0 / max(1.0, e[[1L]])) +
                    (1.0 / max(1.0, e[[2L]])) +
                    (1.0 / max(1.0, e[[3L]])) +
                    (1.0 / max(1.0, e[[4L]])) ))
  return(num / den)
}
# nolint end

coexMatrix <- function(obs, exp, n, s) {
  coex <- matrix(NA, s, s)
  for (i in (1L:s)) for (j in (i:s)) {
    o <- c(obs[[1L]][i, j], obs[[2L]][i, j], obs[[3L]][i, j], obs[[4L]][i, j])
    e <- c(exp[[1L]][i, j], exp[[2L]][i, j], exp[[3L]][i, j], exp[[4L]][i, j])
    coex[i, j] <- coexPoint(o, e, n)
  }
  return(as.matrix(forceSymmetric(coex)))
}

test_that("Calculations on genes", {
  set.seed(137L)

  raw <- matrix(c(1L,  0L, 4L, 2L, 11L, 0L, 6L, 7L, 0L, 9L,
                  10L, 8L, 0L, 0L,  0L, 3L, 0L, 0L, 2L, 0L),
                nrow = 10L, ncol = 20L)
  rownames(raw) <- LETTERS[1L:10L]
  colnames(raw) <- letters[1L:20L]

  obj <- COTAN(raw = raw)
  obj <- clean(obj)

  obj <- estimateLambdaLinear(obj)

  lambda <- getLambda(obj)
  mu <- getMu(obj)

  expect_identical(dim(mu), dim(getRawData(obj)))
# nolint start: spaces_inside_linter
  expect_equal(mu[ 1L,  1L], lambda[[ 1L]] * getNu(obj)[[ 1L]],
               ignore_attr = TRUE)
  expect_equal(mu[10L,  1L], lambda[[10L]] * getNu(obj)[[ 1L]],
               ignore_attr = TRUE)
  expect_equal(mu[ 1L, 20L], lambda[[ 1L]] * getNu(obj)[[20L]],
               ignore_attr = TRUE)
  expect_equal(mu[10L, 10L], lambda[[10L]] * getNu(obj)[[10L]],
               ignore_attr = TRUE)
  # nolint end

  c(observedYY, observedY) %<-%
    observedContingencyTablesYY(obj, actOnCells = FALSE, asDspMatrices = FALSE)

  expect_s4_class(observedYY, "dsyMatrix")
  expect_identical(dim(observedYY), rep(getNumGenes(obj), 2L))
  expect_identical(diag(as.matrix(observedYY)), observedY)
  expect_length(observedY, getNumGenes(obj))
  expect_equal(observedY, c(20L, rep(10L, 9L)), ignore_attr = TRUE)

  observed <- observedContingencyTables(obj, actOnCells = FALSE,
                                        asDspMatrices = FALSE)
  c(observedNN, observedNY, observedYN, .) %<-% observed

  expect_identical(unlist(lapply(c(observedNN, observedNY, observedYN), dim)),
                   rep(dim(observedYY), 3L))
  expect_equal(diag(as.matrix(observedNN)), c(0L, rep(10L, 9L)),
               ignore_attr = TRUE)
  expect_identical(observedNY, t(observedYN))
  expect_equal(diag(as.matrix(observedNY)), rep(0L, 10L), ignore_attr = TRUE)
  expect_equal(as.matrix(observedNN + observedNY + observedYN + observedYY),
               matrix(getNumCells(obj), nrow = getNumGenes(obj),
                      ncol = getNumGenes(obj)),
               ignore_attr = TRUE)

  obj <- estimateDispersionViaSolver(obj, cores = 4L, chunkSize = 4L)

  c(expectedNN, expectedN) %<-%
    expectedContingencyTablesNN(obj, actOnCells = FALSE, asDspMatrices = TRUE)

  expect_s4_class(expectedNN, "dspMatrix")
  expect_identical(dim(expectedNN), rep(getNumGenes(obj), 2L))
  expect_length(expectedN, getNumGenes(obj))
  expect_equal(expectedN, c(0L, rep(10L, 9L)),
               ignore_attr = TRUE, tolerance = 1e-4)

  expected <- expectedContingencyTables(obj, actOnCells = FALSE,
                                        asDspMatrices = TRUE)
  c(., expectedNY, expectedYN, expectedYY) %<-% expected

  expect_identical(substring(names(observed), 9L),
                   substring(names(expected), 9L))
  expect_identical(unlist(lapply(c(expectedYY, expectedNY, expectedYN), dim)),
                   rep(dim(expectedNN), 3L))
  expect_equal(as.matrix(expectedNN + expectedNY + expectedYN + expectedYY),
               matrix(getNumCells(obj), nrow = getNumGenes(obj),
                      ncol = getNumGenes(obj)),
               ignore_attr = TRUE)

  # take a gene pair ensuring to poll only the upper triangle side of the
  # matrices as the flag 'asDspMatrices = TRUE' makes them incorrect on the
  # other side
  e1 <- sample(getNumGenes(obj), 1L)
  e2 <- sample(getNumGenes(obj), 1L)
  g1 <- getGenes(obj)[[min(e1, e2)]]
  g2 <- getGenes(obj)[[max(e1, e2)]]
  c(gpObs, gpExp) %<-% contingencyTables(obj, g1, g2)

  expect_identical(as.vector(gpObs), c(observedYY[g1, g2], observedYN[g1, g2],
                                       observedNY[g1, g2], observedNN[g1, g2]))
  expect_equal(as.vector(gpExp), c(expectedYY[g1, g2], expectedYN[g1, g2],
                                   expectedNY[g1, g2], expectedNN[g1, g2]),
               tolerance = 1.0e-12)

  zeroOne <- getZeroOneProj(obj)
  probZero <- getProbabilityOfZero(obj)

  gce <- calculateGenesCE(obj)

  expect_named(gce, getGenes(obj))
  expect_identical(gce[[1L]], 0.0)
  expect_equal(gce, crossEntrVector(zeroOne, probZero), ignore_attr = TRUE)

  expect_no_warning({
    obj <- calculateCoex(obj, actOnCells = FALSE, optimizeForSpeed = FALSE,
                         returnPPFract = TRUE)
  })
  expect_null(getOption("COTAN.TorchWarning"))

  legacyCoex <- getGenesCoex(obj, zeroDiagonal = FALSE)

  expect_true(isCoexAvailable(obj, actOnCells = FALSE, ignoreSync = FALSE))
  expect_identical(dim(legacyCoex), rep(getNumGenes(obj), 2L))
  expect_identical(getGenesCoex(obj)[1L, 1L], 0.0)
  expect_equal(abs(as.vector(legacyCoex[-1L, -1L])),
               rep(1.0, 81L), tolerance = 0.01)

  expect_equal(as.matrix(legacyCoex),
               coexMatrix(observed, expected,
                          getNumCells(obj), getNumGenes(obj)),
               tolerance = 0.001, ignore_attr = TRUE)

  expect_equal(getMetadataDataset(obj)[[1L]], datasetTags()[c(5L, 6L, 7L)],
               ignore_attr = TRUE)
  expect_identical(getMetadataElement(obj, datasetTags()[["gbad"]]),
                   paste0(10.0 / 55.0))

  suppressWarnings({
    obj <- calculateCoex(obj, actOnCells = FALSE, optimizeForSpeed = TRUE)
  })

  torchCoex <- getGenesCoex(obj, zeroDiagonal = FALSE)

  expect_true(isCoexAvailable(obj, actOnCells = FALSE, ignoreSync = FALSE))
  expect_identical(dim(torchCoex), rep(getNumGenes(obj), 2L))
  expect_identical(getGenesCoex(obj)[1L, 1L], 0.0)
  expect_equal(abs(as.vector(torchCoex[-1L, -1L])),
               rep(1.0, 81L), tolerance = 0.01)

  expect_equal(as.matrix(torchCoex),
               coexMatrix(observed, expected,
                          getNumCells(obj), getNumGenes(obj)),
               tolerance = 0.001, ignore_attr = TRUE)

  expect_equal(getMetadataDataset(obj)[[1L]], datasetTags()[c(5L, 6L, 7L)],
               ignore_attr = TRUE)
  expect_identical(getMetadataElement(obj, datasetTags()[["gbad"]]),
                   paste0(NA))

  genesSample1 <- sample(getNumGenes(obj), 3L)
  partialCoex1 <- calculatePartialCoex(obj, genesSample1)

  # These need tolerance
  expect_equal(partialCoex1,
               legacyCoex[, sort(genesSample1)],
               tolerance = 1e-12)

  genesSample2 <- getGenes(obj)[sample(getNumGenes(obj), 3L)]
  partialCoex2 <- calculatePartialCoex(obj, genesSample2,
                                       optimizeForSpeed = FALSE)

  expect_equal(partialCoex2, legacyCoex[, sort(genesSample2), drop = FALSE],
               tolerance = 1e-12)
})


test_that("Calculations on cells", {
  set.seed(137L)

  raw <- matrix(c(1L,  0L, 4L, 2L, 11L, 0L, 6L, 7L, 0L, 9L,
                  10L, 8L, 0L, 0L,  0L, 3L, 0L, 0L, 2L, 0L),
                nrow = 10L, ncol = 20L)
  rownames(raw) <- LETTERS[1L:10L]
  colnames(raw) <- letters[1L:20L]

  obj <- COTAN(raw = raw)
  obj <- clean(obj)

  c(observedYY, observedY) %<-%
    observedContingencyTablesYY(obj, actOnCells = TRUE, asDspMatrices = TRUE)

  expect_s4_class(observedYY, "dspMatrix")
  expect_identical(dim(observedYY), rep(getNumCells(obj), 2L))
  expect_identical(diag(as.matrix(observedYY)), observedY)
  expect_length(observedY, getNumCells(obj))
  expect_equal(observedY, rep(c(7L, 4L), 10L), ignore_attr = TRUE)

  observed <- observedContingencyTables(obj, actOnCells = TRUE,
                                        asDspMatrices = TRUE)
  c(observedNN, observedNY, observedYN, .) %<-% observed

  expect_identical(unlist(lapply(c(observedNN, observedNY, observedYN), dim)),
                   rep(dim(observedYY), 3L))
  expect_equal(diag(as.matrix(observedNN)), rep(c(3L, 6L), 10L),
               ignore_attr = TRUE)
  expect_equal(diag(as.matrix(observedNY)), rep(0L, 20L), ignore_attr = TRUE)
  expect_equal(as.matrix(observedNN + observedNY + observedYN + observedYY),
               matrix(getNumGenes(obj), nrow = getNumCells(obj),
                      ncol = getNumCells(obj)),
               ignore_attr = TRUE)

  obj <- estimateLambdaLinear(obj)
  obj <- estimateDispersionNuBisection(obj, cores = 4L, chunkSize = 4L,
                                       enforceNuAverageToOne = FALSE)

  c(expectedNN, expectedN) %<-%
    expectedContingencyTablesNN(obj, actOnCells = TRUE, asDspMatrices = FALSE)

  expect_s4_class(expectedNN, "dsyMatrix")
  expect_identical(dim(expectedNN), rep(getNumCells(obj), 2L))
  expect_length(expectedN, getNumCells(obj))
  expect_equal(expectedN, rep(c(3L, 6L), 10L),
               ignore_attr = TRUE, tolerance = 1e-3)

  expected <- expectedContingencyTables(obj, actOnCells = TRUE,
                                        asDspMatrices = FALSE)
  c(., expectedNY, expectedYN, expectedYY) %<-% expected

  expect_identical(unlist(lapply(c(expectedYY, expectedNY, expectedYN), dim)),
                   rep(dim(expectedNN), 3L))
  expect_identical(expectedNY, t(expectedYN))
  expect_equal(as.matrix(expectedNN + expectedNY + expectedYN + expectedYY),
               matrix(getNumGenes(obj), nrow = getNumCells(obj),
                      ncol = getNumCells(obj)),
               ignore_attr = TRUE)

  expect_warning({
    obj <- calculateCoex(obj, actOnCells = TRUE,
                         optimizeForSpeed = TRUE,
                         returnPPFract = TRUE)
  })

  genesCoexInSync <- getMetadataElement(obj, datasetTags()[["gsync"]])
  cellsCoexInSync <- getMetadataElement(obj, datasetTags()[["csync"]])

  expect_identical(c(genesCoexInSync, cellsCoexInSync), c("FALSE", "TRUE"))

  expect_true(isCoexAvailable(obj, actOnCells = TRUE))
  expect_identical(dim(getCellsCoex(obj)), rep(getNumCells(obj), 2L))

  # as all cells are repeated altenating
  expect_true(
    all(abs(getCellsCoex(obj, zeroDiagonal = FALSE)[, seq_len(getNumCells(obj))
                                                        %% 2L == 1L] -
              getCellsCoex(obj, zeroDiagonal = FALSE)[, 1L]) < 1e-12))
  expect_true(
    all(abs(getCellsCoex(obj, zeroDiagonal = FALSE)[, seq_len(getNumCells(obj))
                                                        %% 2L == 0L] -
            getCellsCoex(obj, zeroDiagonal = FALSE)[, 2L]) < 1e-12))

  expect_equal(as.matrix(getCellsCoex(obj, zeroDiagonal = FALSE)),
               coexMatrix(observed, expected, getNumGenes(obj),
                          getNumCells(obj)),
               tolerance = 0.001, ignore_attr = TRUE)

  expect_equal(getMetadataDataset(obj)[[1L]], datasetTags()[c(5L, 6L, 8L)],
               ignore_attr = TRUE)
  expect_identical(getMetadataElement(obj, datasetTags()[["cbad"]]), paste0(0L))

  cellsSample1 <- sample(getNumCells(obj), 3L)
  partialCoex1 <- calculatePartialCoex(obj, cellsSample1,
                                       actOnCells = TRUE)

  # These need tolerance
  expect_equal(partialCoex1,
               getCellsCoex(obj, zeroDiagonal = FALSE)[, sort(cellsSample1)],
               tolerance = 1e-12)

  cellsSample2 <- getCells(obj)[sample(getNumCells(obj), 3L)]
  partialCoex2 <- calculatePartialCoex(obj, cellsSample2, actOnCells = TRUE,
                                       optimizeForSpeed = FALSE)

  expect_equal(partialCoex2,
               getCellsCoex(obj, cellsSample2, zeroDiagonal = FALSE),
               tolerance = 1e-12)
})


test_that("Coex", {
  raw <- matrix(c(1L,  0L, 4L, 2L, 11L, 0L, 6L, 7L, 0L, 9L,
                  10L, 8L, 0L, 0L,  0L, 3L, 0L, 0L, 2L, 0L),
                nrow = 10L, ncol = 20L)
  rownames(raw) <- LETTERS[1L:10L]
  colnames(raw) <- letters[1L:20L]

  obj <- COTAN(raw = raw)
  obj <- clean(obj)

  obj <- estimateLambdaLinear(obj)
  obj <- estimateDispersionNuBisection(obj, cores = 4L, chunkSize = 4L,
                                       enforceNuAverageToOne = FALSE)

  expect_no_warning({
    obj <- calculateCoex(obj, actOnCells = FALSE, optimizeForSpeed = FALSE)
  })
  expect_true(isCoexAvailable(obj))
  expect_identical(dim(getGenesCoex(obj)), rep(getNumGenes(obj), 2L))

  S <- as.matrix(calculateS(obj))
  G <- as.matrix(calculateG(obj))

  expect_identical(dim(S), dim(getGenesCoex(obj)))
  expect_identical(dim(G), dim(getGenesCoex(obj)))
  expect_equal(diag(S), rep(0L, nrow(S)), ignore_attr = TRUE)
  expect_identical(diag(S), diag(G))
  diag(S) <- 1.0
  diag(G) <- 1.4
  # Not true due to numerical noise when dispersion is too precise
  # expect_equal(S[-1L, 1L] / G[-1L, 1L], rep(11L, 9L), tolerance = 1e-3,
  #              ignore_attr = TRUE)
  expect_true(all(((1.4 * S[-1L, -1L]) / G[-1L, -1L]) < 1.2))
  expect_true(all((G[-1L, -1L] / (1.4 * S[-1L, -1L])) < 1.2))

  pVS <- calculatePValue(obj, statType = "S")[2L:5L, 6L:9L]
  pVG <- calculatePValue(obj, statType = "G",
                         geneSubsetCol = getGenes(obj)[6L:9L],
                         geneSubsetRow = getGenes(obj)[2L:5L])

  expect_identical(dim(pVS), dim(pVG))
  expect_true(all((pVS / (pVG * 50.0)) < 1.1))
  expect_true(all(((pVG * 50.0) / pVS) < 2.5))

  # nolint start: object_name_linter
  GDI_S <- calculateGDI(obj, statType = "S")
  GDI_G <- calculateGDI(obj, statType = "G")

  expect_identical(dim(GDI_S), as.integer(c(getNumGenes(obj), 3L)))
  expect_identical(dim(GDI_S), dim(GDI_G))
  expect_identical(colnames(GDI_S), c("sum.raw.norm", "GDI", "exp.cells"))
  expect_identical(colnames(GDI_S), colnames(GDI_G))
  expect_identical(GDI_S[[1L]], GDI_G[[1L]])
  expect_equal(GDI_S[[2L]], GDI_G[[2L]], tolerance = 0.1)
  expect_identical(GDI_S[[3L]], GDI_G[[3L]])
  expect_equal(GDI_S[[3L]],
               c(100L, rep(50L, getNumGenes(obj) - 1L)), ignore_attr = TRUE)

  GDI_S_2 <- calculateGDIGivenS(calculateS(obj))
  GDI_S_3 <- calculateGDIGivenCorr(getGenesCoex(obj),
                                   numDegreesOfFreedom = getNumCells(obj))

  expect_equal(GDI_S[["GDI"]], GDI_S_2, ignore_attr = TRUE)
  expect_identical(GDI_S_2, GDI_S_3)
  # nolint end
})


test_that("Coex vs saved results", {
  utils::data("test.dataset", package = "COTAN")

  tolerance <- 5.0e-6

  obj <- COTAN(raw = test.dataset)
  obj <- initializeMetaDataset(obj, GEO = " ",
                               sequencingMethod = "artificial",
                               sampleCondition = "test")

  obj <- proceedToCoex(obj,
                       cores = 6L,
                       optimizeForSpeed = TRUE,
                       deviceStr = "cuda",
                       saveObj = FALSE)

  genesCoexInSync <- getMetadataElement(obj, datasetTags()[["gsync"]])
  cellsCoexInSync <- getMetadataElement(obj, datasetTags()[["csync"]])

  expect_identical(c(genesCoexInSync, cellsCoexInSync), c("TRUE", "FALSE"))

  # Torch GPU
  suppressWarnings({
    obj2 <- automaticCOTANObjectCreation(raw = test.dataset,
                                         GEO = " ",
                                         sequencingMethod = "artificial",
                                         sampleCondition = "test",
                                         cores = 6L,
                                         optimizeForSpeed = TRUE,
                                         deviceStr = "cuda",
                                         saveObj = FALSE)
  })

  expect_identical(obj2, obj)

  genesNamesTest <- readRDS(file.path(getwd(), "genes.names.test.RDS"))

  coexTest <- readRDS(file.path(getwd(), "coex.test.RDS"))

  expect_true(isCoexAvailable(obj))
  expect_equal(getGenesCoex(obj, genes = genesNamesTest,
                            zeroDiagonal = FALSE),
               coexTest, tolerance = tolerance)

  pval <- calculatePValue(obj,
                          geneSubsetCol = genesNamesTest,
                          geneSubsetRow = genesNamesTest,
                          cores = 3L)

  pValExp <- readRDS(file.path(getwd(), "pvalues.test.RDS"))
  expect_equal(pval, pValExp, tolerance = tolerance)

  GDI <- calculateGDI(obj)[genesNamesTest, ]

  gdiExp <- readRDS(file.path(getwd(), "GDI.test.RDS"))

  expect_equal(GDI, gdiExp, tolerance = tolerance)

  # Torch CPU
  suppressWarnings({
    obj3 <- automaticCOTANObjectCreation(raw = test.dataset,
                                         GEO = " ",
                                         sequencingMethod = "artificial",
                                         sampleCondition = "test",
                                         cores = 6L,
                                         optimizeForSpeed = TRUE,
                                         deviceStr = "cpu",
                                         saveObj = FALSE)
  })

  expect_equal(obj3@genesCoex, obj@genesCoex, tolerance = tolerance)

  expect_true(isCoexAvailable(obj3))
  expect_equal(getGenesCoex(obj3, genes = genesNamesTest,
                            zeroDiagonal = FALSE),
               coexTest, tolerance = tolerance)

  pval <- calculatePValue(obj3, geneSubsetRow = genesNamesTest, cores = 3L)

  expect_equal(pval[, genesNamesTest], pValExp, tolerance = tolerance)

  GDI <- calculateGDI(obj3)[genesNamesTest, ]

  expect_equal(GDI, gdiExp, tolerance = tolerance)

  # Legacy CPU
  suppressWarnings({
    obj4 <- automaticCOTANObjectCreation(raw = test.dataset,
                                         GEO = " ",
                                         sequencingMethod = "artificial",
                                         sampleCondition = "test",
                                         cores = 6L,
                                         optimizeForSpeed = TRUE,
                                         deviceStr = "cuda",
                                         saveObj = FALSE)
  })

  expect_equal(obj4@genesCoex, obj@genesCoex, tolerance = tolerance)

  expect_true(isCoexAvailable(obj4))
  expect_equal(getGenesCoex(obj4, genes = genesNamesTest,
                            zeroDiagonal = FALSE),
               coexTest, tolerance = tolerance)

  pval <- calculatePValue(obj4,
                          geneSubsetCol = genesNamesTest,
                          geneSubsetRow = genesNamesTest)

  expect_equal(pval, pValExp, tolerance = tolerance)

  GDI <- calculateGDI(obj4)[genesNamesTest, ]

  expect_equal(GDI, gdiExp, tolerance = tolerance)
})


test_that("Coex with negative dispersion genes", {
  utils::data("test.dataset", package = "COTAN")

  obj <- COTAN(raw = test.dataset)
  obj <- initializeMetaDataset(obj, GEO = " ",
                               sequencingMethod = "artificial",
                               sampleCondition = "test")

  cellsNamesTest <- readRDS(file.path(getwd(), "cells.names.test.RDS"))
  cellsToDrop <- getCells(obj)[!getCells(obj) %in% cellsNamesTest]
  obj <- dropGenesCells(obj, cells = cellsToDrop)

  obj <- proceedToCoex(obj, cores = 6L, calcCoex = FALSE, saveObj = FALSE)

  expect_true(any(getDispersion(obj) < 0.0))

  expect_no_warning({
    obj <- calculateCoex(obj, optimizeForSpeed = FALSE, deviceStr = "cpu")
  })
  coex1 <- getGenesCoex(obj, zeroDiagonal = FALSE)

  suppressWarnings({
    obj <- calculateCoex(obj, optimizeForSpeed = TRUE, deviceStr = "cpu")
  })
  coex2 <- getGenesCoex(obj, zeroDiagonal = FALSE)

  suppressWarnings({
    obj <- calculateCoex(obj, optimizeForSpeed = TRUE, deviceStr = "cuda")
  })
  coex3 <- getGenesCoex(obj, zeroDiagonal = FALSE)

  expect_equal(coex1, coex2, tolerance = 1.0e-6)
  expect_equal(coex1, coex3, tolerance = 1.0e-6)
  expect_equal(coex2, coex3, tolerance = 1.0e-6)

  groupMarkers <- list(G1 = c("g-000010", "g-000030", "g-000138"),
                       G2 = c("g-000300", "g-000330", "g-000660"),
                       G3 = c("g-000510", "g-000530", "g-000550",
                              "g-000570", "g-000590"))

  hmDF <- singleHeatmapDF(obj, genesLists = groupMarkers, sets = 2L:3L,
                          pValueThreshold = 0.05, cores = 3L)

  numOtherGenes <- sum(lengths(groupMarkers)[2L:3L])
  expectedColNames <- c("g2", "g1", "coex", "pValue",
                        "cond", "type", "absent", "fe_genes")
  expect_identical(nrow(hmDF), numOtherGenes * length(groupMarkers[[1L]]))
  expect_setequal(hmDF[["g1"]], groupMarkers[[1L]])
  expect_setequal(hmDF[["g2"]], unlist(groupMarkers[2L:3L]))
  expect_setequal(hmDF[["type"]], names(groupMarkers)[2L:3L])
  expect_setequal(hmDF[["cond"]], "test")
  expect_identical(colnames(hmDF), expectedColNames)
  expect_identical(hmDF[["absent"]], hmDF[["g2"]] == "g-000660")
  expect_true(all(hmDF[["pValue"]] > 0.05))
  expect_true(all(hmDF[["coex"]] == 0.0))
})

options(prevOptState)

#' @details `checkClusterUniformity()` takes a `COTAN` object and a cells'
#'   *cluster* and checks whether the latter is **uniform** by looking at the
#'   genes' `GDI` distribution. The function runs [checkObjIsUniform()] on the
#'   given input checker
#'
#' @param objCOTAN a `COTAN` object
#' @param clusterName the tag of the *cluster*
#' @param cells the cells belonging to the *cluster*
#' @param checker the object that defines the method and the threshold to
#'   discriminate whether a *cluster* is *uniform transcript*. See
#'   [UniformTranscriptCheckers] for more details
#' @param cores number of cores to use. Default is 1.
#' @param optimizeForSpeed Boolean; when `TRUE` `COTAN` tries to use the `torch`
#'   library to run the matrix calculations. Otherwise, or when the library is
#'   not available will run the slower legacy code
#' @param deviceStr On the `torch` library enforces which device to use to run
#'   the calculations. Possible values are `"cpu"` to us the system *CPU*,
#'   `"cuda"` to use the system *GPUs* or something like `"cuda:0"` to restrict
#'   to a specific device
#' @param saveObj Boolean flag; when `TRUE` saves intermediate analyses and
#'   plots to file(s)
#' @param outDir an existing directory for the analysis output. The effective
#'   output will be paced in a sub-folder.
#'
#' @returns `checkClusterUniformity` returns a checker object of the same type
#'   as the input one, that contains both threshold and results of the check:
#'   see [UniformTranscriptCheckers] for more details
#'
#' @importFrom utils head
#'
#' @importFrom grDevices pdf
#' @importFrom grDevices dev.off
#' @importFrom grDevices dev.cur
#'
#' @importFrom withr local_options
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom zeallot %<-%
#' @importFrom zeallot %->%
#'
#' @export
#'
#' @rdname UniformClusters
#'

checkClusterUniformity <- function(
    objCOTAN,
    clusterName,
    cells,
    checker,
    cores = 1L,
    optimizeForSpeed = TRUE,
    deviceStr = "cuda",
    saveObj = TRUE,
    outDir = ".") {
  assert_that(is(checker, "BaseUniformityCheck"))

  cellsToDrop <- getCells(objCOTAN)[!getCells(objCOTAN) %in% cells]

  objCOTAN <- dropGenesCells(objCOTAN, cells = cellsToDrop)

  if (!is_empty(cellsToDrop) || !isCoexAvailable(objCOTAN)) {
    objCOTAN <- proceedToCoex(objCOTAN, cores = cores, calcCoex = TRUE,
                              optimizeForSpeed = optimizeForSpeed,
                              deviceStr = deviceStr, saveObj = FALSE)
    gc()
  }

  checker@clusterSize <- getNumCells(objCOTAN)

  logThis(paste0("Checking uniformity for the cluster '", clusterName,
                 "' with ", checker@clusterSize, " cells"), logLevel = 2L)

  if (is_empty(suppressWarnings(getGDI(objCOTAN)))) {
    GDIData <- calculateGDI(objCOTAN, cores = cores)
    objCOTAN <- storeGDI(objCOTAN, GDIData)
  }

  # Plots
  if (isTRUE(saveObj) && !dir.exists(outDir)) {
    saveObj <- FALSE
    warning("Asked to save check results,",
            " but given output folder does not exist")
  }

  if (isTRUE(saveObj)) tryCatch({
      # this will be restored to previous value on function exit
      local_options(list(ggrepel.max.overlaps = Inf))

      pdf(file.path(outDir, paste0("cluster_", clusterName, "_plots.pdf")))

      c(pcaCellsPlot, ., bGroupGenesPlot, UDEPLot, nuPlot, zoomedNuPlot) %<-%
        cleanPlots(objCOTAN, includePCA = FALSE)

      genesToLabel <-
        head(rownames(GDIData[order(GDIData[["GDI"]],
                                    decreasing = TRUE), ]), n = 10L)
      gdiPlot <- GDIPlot(objCOTAN, GDIIn = GDIData,
                         GDIThreshold = getCheckerThreshold(checker),
                         genes = list("top 10 GDI genes" = genesToLabel))

      plot(nuPlot)
      plot(zoomedNuPlot)
      plot(gdiPlot)

      rm(nuPlot, zoomedNuPlot, gdiPlot)
    }, error = function(err) {
      logThis(paste("While saving cluster plots", err), logLevel = 0L)
    }, finally = {
      # Check for active device
      if (dev.cur() > 1L) {
        dev.off()
      }
    })

  checker <- checkObjIsUniform(currentC = checker, previousC = NULL,
                               objCOTAN = objCOTAN)
  rm(objCOTAN)
  gc()

  logThis(paste0("Cluster ", clusterName, ", with size ",
                 checker@clusterSize, ", is ",
                 ifelse(checker@isUniform, "", "not "), "uniform"),
          logLevel = 1L)
  logThis(paste0("Cluster ", clusterName, "'s shift to uniformity: ",
                 calculateThresholdShiftToUniformity(checker = checker)),
          logLevel = 2L)

  if (TRUE) {
    tempDF <- checkersToDF(checker)
    logThis(paste0(colnames(tempDF), " = ", unlist(tempDF[1L, ]),
                   collapse = ", "), logLevel = 3L)
    rm(tempDF)
  }

  if (isTRUE(saveObj)) tryCatch({
      outFile <- file.path(outDir,
                           paste0(ifelse(checker@isUniform, "", "non-"),
                                  "uniform_cluster_", clusterName, ".csv"))
      write.csv(cells, file = outFile)
    },
    error = function(err) {
      logThis(paste("While saving current clusterization", err),
              logLevel = 0L)
    }
  )

  return(checker)
}

#' @title Calculations of genes statistics
#'
#' @description A collection of functions returning various statistics
#'   associated to the genes. In particular the *discrepancy* between the
#'   expected probabilities of zero and their actual occurrences, both at single
#'   gene level or looking at genes' pairs
#'
#' @description To make the `GDI` more specific, it may be desirable to restrict
#'   the set of genes against which `GDI` is computed to a selected subset, with
#'   the recommendation to include a consistent fraction of cell-identity genes,
#'   and possibly focusing on markers specific for the biological question of
#'   interest (for instance neural cortex layering markers). In this case we
#'   denote it as *Local Differentiation Index* (`LDI`) relative to the selected
#'   subset.
#'
#' @name GenesStatistics
NULL

#' @details `genesCoexSpace()` calculates genes groups based on the primary
#'   markers and uses them to prepare the genes' `COEX` space `data.frame`.
#'
#' @param objCOTAN a `COTAN` object.
#' @param primaryMarkers A vector of primary marker names.
#' @param numGenesPerMarker The number of genes correlated with the primary
#'   markers that we want to consider. By default this is set to 25.
#'
#' @returns `genesCoexSpace()` returns a `list` with:
#'  * `"SecondaryMarkers"` a named `list` that for each secondary marker,
#'    gives the `list` of primary markers that selected for it
#'  * `"GCS"` the relevant subset of `COEX` `matrix`
#'  * `"rankGenes"` a `data.frame` with the rank of each gene according to its
#'    *p-value*
#'
#' @export
#'
#' @importFrom rlang set_names
#'
#' @importFrom stats quantile
#' @importFrom stats pchisq
#'
#' @importFrom tibble rownames_to_column
#'
#' @importFrom Rfast rowsums
#'
#' @examples
#' data("test.dataset")
#' objCOTAN <- COTAN(raw = test.dataset)
#' objCOTAN <- proceedToCoex(objCOTAN, cores = 6L, saveObj = FALSE)
#'
#' markers <- getGenes(objCOTAN)[sample(getNumGenes(objCOTAN), 10)]
#' gCS <- genesCoexSpace(objCOTAN, primaryMarkers = markers,
#'                       numGenesPerMarker = 15)
#'
#' @rdname GenesStatistics
#'
genesCoexSpace <-
  function(objCOTAN, primaryMarkers, numGenesPerMarker = 25L) {
    startTime <- Sys.time()

    logThis("Calculating gene co-expression space - START", logLevel = 2L)

  if (TRUE) {
    genesBelong <- primaryMarkers %in% getGenes(objCOTAN)
    if (!all(genesBelong)) {
      warning("Genes [", toString(primaryMarkers[!genesBelong]),
              "] are not present in the 'COTAN' object!")
      primaryMarkers <- primaryMarkers[genesBelong]
    }
    rm(genesBelong)
  }

  pValue <- calculatePValue(objCOTAN, geneSubsetCol = primaryMarkers)

  secondaryMarkers <- primaryMarkers

  for (marker in primaryMarkers) {
    lowestPValueGenesPos <-
      order(pValue[, marker, drop = TRUE])[1L:numGenesPerMarker]
    secondaryMarkers <- c(secondaryMarkers,
                          getGenes(objCOTAN)[lowestPValueGenesPos])
  }
  # now the secondary markers are unique and sorted accordingly
  # to the original genes' list
  secondaryMarkers <-
    getGenes(objCOTAN)[getGenes(objCOTAN) %in% unique(secondaryMarkers)]

  logThis(paste("Number of selected secondary markers:",
                length(secondaryMarkers)), logLevel = 1L)

  pValue <- pValue[secondaryMarkers, , drop = FALSE]

  rankGenes <- data.frame()
  for (marker in primaryMarkers) {
    rankGenes <- setColumnInDF(rankGenes,
                               colToSet = rank(pValue[, marker, drop = TRUE],
                                               ties.method = "first"),
                               colName = marker,
                               rowNames = secondaryMarkers)
  }
  rm(pValue)

  # put on the left the smalles log(-log(pValues)) for each row
  S <- calculateS(objCOTAN, geneSubsetRow = secondaryMarkers)
  LDI <- calculateGDIGivenS(S = S, rowsFraction = 0.1)

  rm(S)
  gc()

  lowLDIGenes <- LDI >= quantile(LDI, probs = 0.9)
  goodGenes <- getGenes(objCOTAN) %in% names(LDI)[lowLDIGenes]

  gCS <- as.matrix(getGenesCoex(objCOTAN,
                                genes = secondaryMarkers))[goodGenes, ]
  gCS <- tanh(gCS * sqrt(getNumCells(objCOTAN)))

  logThis(paste0("Number of columns (V set - secondary markers): ",
                 dim(gCS)[[2L]]), logLevel = 3L)
  logThis(paste0("Number of rows (U set): ", dim(gCS)[[1L]]), logLevel = 3L)

  endTime <- Sys.time()

  logThis(paste("Total calculations elapsed time:",
                difftime(endTime, startTime, units = "secs")),
          logLevel = 2L)

  logThis("Calculating gene co-expression space - DONE", logLevel = 2L)

  return(list("SecondaryMarkers" = secondaryMarkers, "GCS" = gCS,
              "rankGenes" = rankGenes))
}


#' @details `establishGenesClusters()` perform the genes' clustering based on a
#'   pool of gene markers, using the genes' `COEX` space

#' @param objCOTAN a `COTAN` object
#' @param groupMarkers a named `list` with an element for each group comprised
#'   of one or more marker genes
#' @param numGenesPerMarker the number of correlated genes to keep as other
#'   markers (default 25)
#' @param kCuts the number of estimated *cluster* (this defines the height for
#'   the tree cut)
#' @param distance type of distance to use. Default is `"cosine"`. Can be chosen
#'   among those supported by [parallelDist::parDist()]
#' @param hclustMethod default is "ward.D2" but can be any method defined by
#'   [stats::hclust()] function
#'
#' @returns `establishGenesClusters()` a `list` of:
#'   * `"g.space"` the genes' `COEX` space `data.frame`
#'   * `"plot.eig"` the eigenvalues plot
#'   * `"pca_clusters"` the `PCA` components `data.frame`
#'   * `"tree_plot"` the tree plot for the genes' `COEX` space
#'
#' @export
#'
#' @importFrom rlang set_names
#'
#' @importFrom dendextend set
#' @importFrom dendextend color_labels
#' @importFrom dendextend color_branches
#'
#' @importFrom stats hclust
#' @importFrom stats cutree
#' @importFrom stats as.dendrogram
#' @importFrom stats order.dendrogram
#'
#' @importFrom BiocSingular runPCA
#' @importFrom BiocSingular IrlbaParam
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom zeallot %<-%
#' @importFrom zeallot %->%
#'
#' @examples
#' groupMarkers <- list(G1 = c("g-000010", "g-000020", "g-000138"),
#'                      G2 = c("g-000300"),
#'                      G3 = c("g-000510", "g-000530", "g-000550",
#'                             "g-000570", "g-000590"))
#'
#' resList <-  establishGenesClusters(objCOTAN, groupMarkers = groupMarkers,
#'                                    numGenesPerMarker = 11)
#'
#' @rdname GenesStatistics
#'
establishGenesClusters <-
  function(objCOTAN, groupMarkers, numGenesPerMarker = 25L,
           kCuts = 6L, distance = "cosine", hclustMethod = "ward.D2") {
  startTime <- Sys.time()

  logThis("Establishing gene clusters - START", logLevel = 2L)

  assert_that(!is.null(names(groupMarkers)),
              msg = "Group markers must have names for each group")

  colVector <- getColorsVector(kCuts)

  # Dropping the genes not present
  filterGenes <- function(markers, genes) {
    markers[markers %in% genes]
  }
  groupMarkers <- lapply(groupMarkers, filterGenes, getGenes(objCOTAN))
  groupMarkers <- groupMarkers[!is.na(groupMarkers)]

  primaryMarkers <- unlist(groupMarkers)

  c(secondaryMarkers, gCS, rankGenes) %<-%
    genesCoexSpace(objCOTAN,
                   numGenesPerMarker = numGenesPerMarker,
                   primaryMarkers = primaryMarkers)

  gCSPca <- runPCA(x = gCS, rank = 10L,
                   BSPARAM = IrlbaParam(), get.rotation = FALSE)
  assert_that(identical(rownames(gCSPca[["x"]]), rownames(gCS)),
              (ncol(gCSPca[["x"]]) == 10L), msg = "Issues with PCA output")

  sMRelevance <- matrix(nrow = length(secondaryMarkers),
                        ncol = length(groupMarkers),
                        dimnames = list(secondaryMarkers, names(groupMarkers)))

  for (name in names(groupMarkers)) {
    sMRelevance[, name] <- rowSums(rankGenes[, groupMarkers[[name]],
                                             drop = FALSE])
    sMRelevance[groupMarkers[[name]], name] <- 1L
  }

  tempCoex <-
    getGenesCoex(objCOTAN, genes = primaryMarkers)[secondaryMarkers, ,
                                                   drop = FALSE]

  for (name in names(groupMarkers)) {
    antiCorrelated <- tempCoex[, groupMarkers[[name]], drop = FALSE] < 0.0
    toChange <- rownames(tempCoex)[rowSums(antiCorrelated) > 0L]
    sMRelevance[toChange, name] <- 100000.0
  }

  posLink <- set_names(vector("list", length(groupMarkers)),
                        names(groupMarkers))

  for (g in secondaryMarkers) {
    w <- which(sMRelevance[g, ] == min(sMRelevance[g, ]))
    if (length(w) != 1L) {
      next
    }
    posLink[[w]] <- c(posLink[[w]], g)
  }

  plotEigen <- screePlot(gCSPca[["sdev"]])

  coexDist <- calcDist(gCS, method = distance)

  hcNorm <- hclust(coexDist, method = hclustMethod)

  dend <- as.dendrogram(hcNorm)

  pca1 <- as.data.frame(gCSPca[["x"]])
  pca1 <- pca1[order.dendrogram(dend), ]

  highlight <- rep("not_marked", nrow(pca1))
  for (n in names(posLink)) {
    highlight[rownames(pca1) %in% posLink[[n]]] <-
      paste0("Genes related to ", n)
  }
  pca1[["highlight"]] <- highlight

  hClust <- cutree(hcNorm, k = kCuts)[rownames(pca1)]
  pca1[["hclust"]] <- hClust

  pca1[["sec_markers"]] <- 0.0
  pca1[["sec_markers"]][rownames(pca1) %in% secondaryMarkers] <- 1.0

  pcaColors <- rep("#B09C85FF", nrow(pca1))
  pos <- 1L
  for (to.color in unique(highlight)) {
    if (to.color == "not_marked") {
      next
    }
    pcaColors[highlight == to.color] <- colVector[pos]
    pos <- pos + 1L
  }
  pca1[["colors"]] <- pcaColors

  pca1 <- pca1[labels(dend), ]

  colBranches <- rep("#B09C85FF", nrow(pca1))
  groupLabels  <- hClust
  for (cl in unique(hClust)) {
    clPos <- (hClust == cl)
    for (groupName in names(groupMarkers)) {
      for (marker in groupMarkers[[groupName]]) {
        if (!marker %in% rownames(pca1[clPos, ])) {
          next
        }
        colBranches[clPos] <- pcaColors[rownames(pca1) %in% marker]
        groupLabels[clPos] <- groupName
      }
    }
  }

  pca1[["col_branches"]] <- colBranches
  pca1[["groupLabels"]]  <- groupLabels

  uniquePos <- !duplicated(hClust)
  dend <- color_branches(dend, k = kCuts,
                         col         = colBranches[uniquePos],
                         groupLabels = groupLabels[uniquePos])

  dend <- color_labels(dend, labels = rownames(pca1), col = pcaColors)

  relPos <- rownames(pca1) %in% colnames(gCS)
  dend <-
    dendextend::set(
      dend,
      "labels",
      ifelse(labels(dend) %in% rownames(pca1)[relPos], labels(dend), "")
    )

  endTime <- Sys.time()

  logThis(paste("Total calculations elapsed time:",
                difftime(endTime, startTime, units = "secs")),
          logLevel = 2L)

  logThis("Establishing gene clusters - DONE", logLevel = 2L)

  return(list("g.space" = gCS, "plot.eig" = plotEigen,
              "pca_clusters" = pca1, "tree_plot" = dend))
}

library(zeallot)

prevOptState <- options(parallelly.fork.enable = TRUE)

test_that("Establish genes clusters", {
  data("test.dataset")
  objCOTAN <- COTAN(raw = test.dataset)
  objCOTAN <- proceedToCoex(objCOTAN, cores = 6L,
                            optimizeForSpeed = TRUE, saveObj = FALSE)

  c(secondaryMarkers, gCS, rankGenes) %<-%
    genesCoexSpace(objCOTAN = objCOTAN,
                   primaryMarkers = "g-000300",
                   numGenesPerMarker = 5L)

  expect_gt(length(secondaryMarkers), 1L)
  expect_equal(colnames(rankGenes), "g-000300", ignore_attr = TRUE)
  expect_identical(rownames(rankGenes), secondaryMarkers)

  expect_identical(colnames(gCS), secondaryMarkers)
  expect_lte(max(abs(gCS)), 1L)

  groupMarkers <- list(G1 = c("g-000010", "g-000020", "g-000138"),
                       G2 = c("g-000300", "g-000330", "g-000660"),
                       G3 = c("g-000510", "g-000530", "g-000550",
                              "g-000570", "g-000590"))

  expect_warning(
    c(secondaryMarkers, gCS, rankGenes) %<-%
    genesCoexSpace(objCOTAN = objCOTAN,
                   primaryMarkers = unlist(groupMarkers),
                   numGenesPerMarker = 11L))

  expect_gt(length(secondaryMarkers), length(unlist(groupMarkers)))
  expect_equal(colnames(rankGenes), unlist(groupMarkers)[-6L],
               ignore_attr = TRUE)
  expect_identical(rownames(rankGenes), secondaryMarkers)

  expect_identical(colnames(gCS), secondaryMarkers)
  expect_lte(max(abs(gCS)), 1L)

  if (TRUE) {
    gcsOld <-
      as.matrix(readRDS(file.path(getwd(), "genes.coex.space.test.RDS")))
    expect_equal(gCS, gcsOld, tolerance = 5.0e-6)
  }

  c(gSpace, plotEigen, pcaClusters, treePlot) %<-%
    establishGenesClusters(objCOTAN = objCOTAN,
                           groupMarkers = groupMarkers,
                           numGenesPerMarker = 11L,
                           kCuts = 6L,
                           distance = "cosine",
                           hclustMethod = "ward.D2")

  pcaExtraCols <- c("highlight", "hclust", "sec_markers",
                    "colors", "col_branches", "groupLabels")

  expect_s3_class(pcaClusters, "data.frame")
  expect_identical(ncol(pcaClusters), 16L)
  expect_identical(colnames(pcaClusters),
                   c(paste0("PC", (1L:10L)), pcaExtraCols))

  if (TRUE) {
    pcaClustersExp <- readRDS(file.path(getwd(), "pca.genes.clusters.test.RDS"))
    expect_identical(dim(pcaClusters), dim(pcaClustersExp))
    expect_identical(colnames(pcaClusters), colnames(pcaClustersExp))
    expect_identical(rownames(pcaClusters), rownames(pcaClustersExp))
    expect_identical(ncol(pcaClusters), 16L)
    expect_equal(abs(pcaClusters[, 1L:8L]),
                 abs(pcaClustersExp[, 1L:8L]), tolerance = 5.0e-5)
    expect_equal(abs(pcaClusters[, 9L:10L]),
                 abs(pcaClustersExp[, 9L:10L]), tolerance = 5.0e-4)
    expect_identical(pcaClusters[, 11L:13L], pcaClustersExp[, 11L:13L])
    expect_identical(pcaClusters[, 16L],     pcaClustersExp[, 16L])
  }

  expect_identical(nrow(gSpace), nrow(pcaClusters))
  expect_identical(gCS, gSpace)

  expect_s3_class(plotEigen, "ggplot")
  expect_identical(dim(plotEigen[["data"]]), c(10L, 2L))

  expect_s3_class(treePlot, "dendrogram")
})

options(prevOptState)

# ----- `COTAN` parameters' estimates methods -----

#'
#' @title Estimation of the `COTAN` model's parameters
#'
#' @description These functions are used to estimate the `COTAN` model's
#'   parameters. That is the average count for each gene (`lambda`) the average
#'   count for each cell (`nu`) and the `dispersion` parameter for each gene to
#'   match the probability of zero.
#'
#'   The estimator methods are named `Linear` if they can be calculated as a
#'   linear statistic of the raw data or `Bisection` if they are found via a
#'   parallel bisection solver.
#'
#' @name ParametersEstimations
NULL


### ------ estimateLambdaLinear -----

#'
#' @aliases estimateLambdaLinear
#'
#' @details `estimateLambdaLinear()` does a linear estimation of `lambda`
#'   (genes' counts averages)
#'
#' @param objCOTAN a `COTAN` object
#'
#' @returns `estimateLambdaLinear()` returns the updated `COTAN` object
#'
#' @importFrom Matrix mean
#' @importFrom Matrix rowMeans
#'
#' @export
#'
#' @examples
#' data("test.dataset")
#' objCOTAN <- COTAN(raw = test.dataset)
#'
#' objCOTAN <- estimateLambdaLinear(objCOTAN)
#' lambda <- getLambda(objCOTAN)
#'
#' @rdname ParametersEstimations
#'
setMethod(
  "estimateLambdaLinear",
  "COTAN",
  function(objCOTAN) {
    lambda <- rowMeans(getRawData(objCOTAN), dims = 1L)

    objCOTAN <- setLambda(objCOTAN, lambda = lambda)

    return(objCOTAN)
  }
)


### ------ estimateNuLinear -----

#' @aliases estimateNuLinear
#'
#' @details `estimateNuLinear()` does a linear estimation of `nu` (normalized
#'   cells' counts averages)
#'
#' @param objCOTAN a `COTAN` object
#'
#' @returns `estimateNuLinear()` returns the updated `COTAN` object
#'
#' @importFrom Matrix colSums
#'
#' @export
#'
#' @examples
#' objCOTAN <- estimateNuLinear(objCOTAN)
#' nu <- getNu(objCOTAN)
#'
#' @rdname ParametersEstimations
#'
setMethod(
  "estimateNuLinear",
  "COTAN",
  function(objCOTAN) {
    # raw column sums divided by global average
    nu <- colSums(getRawData(objCOTAN), dims = 1L)
    nu <- nu / mean(nu)

    objCOTAN <- setNu(objCOTAN, nu)

    return(objCOTAN)
  }
)


# ------- `COTAN` clusterization data accessors ------

#' @title Handling cells' *clusterization* and related functions
#'
#' @description These functions manage the *clusterizations* and their
#'   associated *cluster* `COEX` `data.frame`s.
#'
#'   A *clusterization* is any partition of the cells where to each cell it is
#'   assigned a **label**; a group of cells with the same label is called
#'   *cluster*.
#'
#'   For each *cluster* is also possible to define a `COEX` value for each gene,
#'   indicating its increased or decreased expression in the *cluster* compared
#'   to the whole background. A `data.frame` with these values listed in a
#'   column for each *cluster* is stored separately for each *clusterization* in
#'   the `clustersCoex` member.
#'
#'   The formulae for this *In/Out* `COEX` are similar to those used in the
#'   [calculateCoex()] method, with the **role** of the second gene taken by the
#'   *In/Out* status of the cells with respect to each *cluster*.
#'
#' @name HandlingClusterizations
NULL


### ------ estimateNuLinearByCluster -----

#' @aliases estimateNuLinearByCluster
#'
#' @details `estimateNuLinearByCluster()` does a linear estimation of `nu`:
#'   cells' counts averages normalized *cluster* by *cluster*
#'
#' @param objCOTAN a `COTAN` object
#' @param clName The name of the *clusterization*. If not given the last
#'   available *clusterization* will be used, as it is probably the most
#'   significant!
#' @param clusters A *clusterization* to use. If given it will take precedence
#'   on the one indicated by `clName`
#'
#' @returns `estimateNuLinearByCluster()` returns the updated `COTAN` object
#'
#' @importFrom rlang is_empty
#' @importFrom rlang set_names
#'
#' @importFrom Matrix colSums
#'
#' @export
#'
#' @rdname HandlingClusterizations
#'
setMethod(
  "estimateNuLinearByCluster",
  "COTAN",
  function(objCOTAN, clName = "", clusters = NULL) {
    c(clName, clusters) %<-%
      normalizeNameAndLabels(objCOTAN, name = clName,
                             labels = clusters, isCond = FALSE)

    # raw column sums divided by cluster average
    nu <- colSums(getRawData(objCOTAN), dims = 1L)

    for (cl in levels(clusters)) {
      pos <- clusters == cl
      nu[pos] <- nu[pos] / mean(nu[pos])
    }

    objCOTAN <- setNu(objCOTAN, nu)

    return(objCOTAN)
  }
)


# local utility wrapper for parallel estimation of dispersion
runDispSolver <- function(genesBatches, sumZeros, lambda, nu,
                          threshold, maxIterations, cores, useBisection) {

  ## forward caller that allows for logging progress
  worker <- function(genesBatch, sumZeros, lambda, nu,
                     threshold, maxIterations, useBisection) {
    tryCatch({
      if (useBisection) {
        return(parallelDispersionBisection(
            genes         = genesBatch,
            sumZeros      = sumZeros,
            lambda        = lambda,
            nu            = nu,
            threshold     = threshold,
            maxIterations = maxIterations
          ))
      } else {
        return(parallelDispersionNewton(
            genes         = genesBatch,
            sumZeros      = sumZeros,
            lambda        = lambda,
            nu            = nu,
            threshold     = threshold,
            maxIterations = maxIterations
          ))
      }
    }, error = function(e) {
      # do not “fallback” on user interrupt
      if (inherits(e, "interrupt")) stop(e)
      structure(list(e), class = "try-error")
    })
  }

  if (cores != 1L) {
    ## create a tiny private env `mini` and a worker within it:
    ## this reduces spawning memory foot-print
    mini <- new.env(parent = baseenv())

    mini$parallelDispersionNewton     <- parallelDispersionNewton
    mini$parallelDispersionBisection  <- parallelDispersionBisection
    mini$rowsums                      <- Rfast::rowsums
    mini$funProbZero                  <- funProbZero
    mini$logThis                      <- logThis
    mini$worker                       <- worker

    ## set on the copy in `mini` to only use `mini`
    environment(mini$parallelDispersionNewton)    <- mini
    environment(mini$parallelDispersionBisection) <- mini
    environment(mini$worker)                      <- mini

    res <- parallel::mclapply(
      genesBatches,
      worker,
      sumZeros       = sumZeros,
      lambda         = lambda,
      nu             = nu,
      threshold      = threshold,
      maxIterations  = maxIterations,
      useBisection   = useBisection,
      mc.cores       = cores,
      mc.preschedule = TRUE, # default
      mc.cleanup     = TRUE, # default
      mc.set.seed    = TRUE  # default
    )
  } else {
    res <- lapply(
      genesBatches,
      worker,
      sumZeros      = sumZeros,
      lambda        = lambda,
      nu            = nu,
      threshold     = threshold,
      maxIterations = maxIterations,
      useBisection  = useBisection
    )
  }

  # spawned errors are stored as try-error classes
  resError <- vapply(res, inherits, logical(1L), "try-error")
  if (any(resError)) {
    first <- which(resError)[[1L]]
    stop(sprintf(
      "Dispersion solver failed on batch %d/%d (%s): %s",
      first, length(res), ifelse(useBisection, "bisection", "newton"),
      conditionMessage(res[[first]][[1L]])
    ), call. = FALSE)
  }

  return(res)
}


### ------ estimateDispersionViaSolver -----

#' @aliases estimateDispersionViaSolver
#' @aliases estimateDispersionBisection
#'
#' @details `estimateDispersionViaSolver()` estimates the negative binomial
#'   dispersion factor for each gene (`dispersion`). Determines the value such
#'   that, for each gene, the probability of zero count matches the number of
#'   observed zeros. It assumes [estimateNuLinear()] being already run.
#'
#' @param objCOTAN a `COTAN` object
#' @param threshold minimal solution precision
#' @param cores number of cores to use. Default is 1.
#' @param maxIterations max number of iterations (avoids infinite loops)
#' @param chunkSize number of elements to solve in batch in a single core.
#'   Default is 1024.
#'
#' @returns `estimateDispersionViaSolver()` returns the updated `COTAN` object
#'
#' @importFrom rlang is_null
#' @importFrom rlang is_empty
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom parallel mclapply
#' @importFrom parallel splitIndices
#'
#' @importFrom parallelly supportsMulticore
#' @importFrom parallelly availableCores
#'
#' @importFrom zeallot %<-%
#' @importFrom zeallot %->%
#'
#' @export
#'
#' @examples
#' objCOTAN <- estimateDispersionViaSolver(objCOTAN, cores = 6L)
#' dispersion <- getDispersion(objCOTAN)
#'
#' @rdname ParametersEstimations
#'
setMethod(
  "estimateDispersionViaSolver",
  "COTAN",
  function(objCOTAN, threshold = 0.001, cores = 1L,
           maxIterations = 100L, chunkSize = 1024L) {
    startTime <- Sys.time()

    logThis("Estimate `dispersion`: START", logLevel = 2L)

    cores <- handleMultiCore(cores)

    genes <- getGenes(objCOTAN)
    sumZeros <- getNumCells(objCOTAN) - getNumOfExpressingCells(objCOTAN)[genes]

    lambda <- suppressWarnings(getLambda(objCOTAN))
    assert_that(!is_empty(lambda),
                msg = "`lambda` must not be empty, estimate it")

    nu <- suppressWarnings(getNu(objCOTAN))
    assert_that(!is_empty(nu),
                msg = "`nu` must not be empty, estimate it")

    dispList <- list()

    spIdx <- parallel::splitIndices(length(genes),
                                    ceiling(length(genes) / chunkSize))

    spGenes <- lapply(spIdx, \(x) genes[x])

    cores <- min(cores, length(spGenes))

    logThis(paste0("Executing ", length(spGenes), " genes batches"),
            logLevel = 3L)

    dispList <- tryCatch(
      runDispSolver(
        spGenes,
        sumZeros      = sumZeros,
        lambda        = lambda,
        nu            = nu,
        threshold     = threshold,
        maxIterations = maxIterations,
        cores         = cores,
        useBisection  = FALSE
      ),
      error = function(eNewton) {
        if (inherits(eNewton, "interrupt")) stop(eNewton)
        msg <- paste0("Newton dispersion solver failed: ",
                      conditionMessage(eNewton), " | retrying with bisection")
        warning(msg)
        logThis(msg, logLevel = 3L)

        runDispSolver(
          spGenes,
          sumZeros      = sumZeros,
          lambda        = lambda,
          nu            = nu,
          threshold     = threshold,
          maxIterations = maxIterations,
          cores         = cores,
          useBisection  = TRUE
        )
      }
    )

    gc()

    endTime <- Sys.time()

    logThis(paste("Total calculations elapsed time:",
                  difftime(endTime, startTime, units = "secs")),
            logLevel = 2L)

    logThis("Estimate `dispersion`: DONE", logLevel = 2L)

    dispersion <- unlist(dispList, recursive = TRUE, use.names = FALSE)

    objCOTAN <- setDispersion(objCOTAN, dispersion = dispersion)

    logThis("Estimate `dispersion`: DONE", logLevel = 2L)

    goodPos <- is.finite(getDispersion(objCOTAN))
    logThis(paste("`dispersion`",
                  "| min:", min(getDispersion(objCOTAN)[goodPos]),
                  "| max:", max(getDispersion(objCOTAN)[goodPos]),
                  "| % negative:", (sum(getDispersion(objCOTAN) < 0.0) * 100.0 /
                                    getNumGenes(objCOTAN))),
            logLevel = 1L)

    return(objCOTAN)
  }
)

# backward compatibility alias
estimateDispersionBisection <-
  function(objCOTAN, threshold = 0.001, cores = 1L,
           maxIterations = 100L, chunkSize = 1024L) {
    return(estimateDispersionViaSolver(objCOTAN = objCOTAN,
                                       threshold = threshold,
                                       cores = cores,
                                       maxIterations = maxIterations,
                                       chunkSize = chunkSize))
  }



# local utility wrapper for parallel estimation of nu
runNuSolver <- function(cellsBatches, sumZeros, lambda, dispersion,
                        initialGuess, threshold, maxIterations, cores) {

  ## forward caller that allows for logging progress
  worker <- function(batch, sumZeros, lambda, dispersion,
                     initialGuess, threshold, maxIterations) {
    tryCatch({
      return(parallelNuBisection(batch,
                                 sumZeros      = sumZeros,
                                 lambda        = lambda,
                                 dispersion    = dispersion,
                                 initialGuess  = initialGuess,
                                 threshold     = threshold,
                                 maxIterations = maxIterations))
    }, error = function(e) {
      # do not “fallback” on user interrupt
      if (inherits(e, "interrupt")) stop(e)
      structure(list(e), class = "try-error")
    })
  }

  if (cores != 1L) {
    # create a tiny private env and a worker within:
    # it reduces spawning memory foot-print
    mini <- new.env(parent = baseenv())
    mini$parallelNuBisection <- parallelNuBisection
    mini$assert_that         <- assertthat::assert_that
    mini$colsums             <- Rfast::colsums
    mini$funProbZero         <- funProbZero
    mini$logThis             <- logThis
    mini$worker              <- worker

    ## set on the copy in `mini` to only use `mini`
    environment(mini$parallelNuBisection) <- mini
    environment(mini$worker)              <- mini

    res <- parallel::mclapply(
      cellsBatches,
      worker,
      sumZeros       = sumZeros,
      lambda         = lambda,
      dispersion     = dispersion,
      initialGuess   = initialGuess,
      threshold      = threshold,
      maxIterations  = maxIterations,
      mc.cores       = cores,
      mc.preschedule = TRUE, # default
      mc.cleanup     = TRUE, # default
      mc.set.seed    = TRUE # default
    )
  } else {
    res <- lapply(
      cellsBatches,
      worker,
      sumZeros      = sumZeros,
      lambda        = lambda,
      dispersion    = dispersion,
      initialGuess  = initialGuess,
      threshold     = threshold,
      maxIterations = maxIterations
    )
  }

  # spawned errors are stored as try-error classes
  resError <- vapply(res, inherits, logical(1L), "try-error")
  if (any(resError)) {
    first <- which(resError)[[1L]]
    stop(sprintf(
      "Nu solver failed on batch %d/%d: %s",
      first, length(res), conditionMessage(res[[first]][[1L]])
    ), call. = FALSE)
  }

  return(res)
}


### ------ estimateNuBisection -----

#' @aliases estimateNuBisection
#'
#' @details `estimateNuBisection()` estimates the `nu` vector of a `COTAN`
#'   object by bisection. It determines the `nu` parameters such that, for each
#'   cell, the probability of zero counts matches the number of observed zeros.
#'   It assumes [estimateDispersionViaSolver()] being already run. Since this
#'   breaks the assumption that the average `nu` is one, it is recommended not
#'   to run this in isolation but use [estimateDispersionNuBisection()] instead.
#'
#' @param objCOTAN a `COTAN` object
#' @param threshold minimal solution precision
#' @param cores number of cores to use. Default is 1.
#' @param maxIterations max number of iterations (avoids infinite loops)
#' @param chunkSize number of elements to solve in batch in a single core.
#'   Default is 1024.
#'
#' @returns `estimateNuBisection()` returns the updated `COTAN` object
#'
#' @importFrom rlang is_null
#' @importFrom rlang is_empty
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom parallel mclapply
#' @importFrom parallel splitIndices
#'
#' @importFrom parallelly supportsMulticore
#' @importFrom parallelly availableCores
#'
#' @importFrom stats median
#'
#' @importFrom zeallot %<-%
#' @importFrom zeallot %->%
#'
#' @rdname ParametersEstimations
#'
setMethod(
  "estimateNuBisection",
  "COTAN",
  function(objCOTAN, threshold = 0.001, cores = 1L,
           maxIterations = 100L, chunkSize = 1024L) {
    startTime <- Sys.time()

    logThis("Estimate `nu`: START", logLevel = 2L)

    cores <- handleMultiCore(cores)

    # parameters estimation

    cells <- getCells(objCOTAN)
    sumZeros <- getNumGenes(objCOTAN) - getNumExpressedGenes(objCOTAN)

    lambda <- suppressWarnings(getLambda(objCOTAN))
    assert_that(!is_empty(lambda),
                msg = "`lambda` must not be empty, estimate it")

    nu <- suppressWarnings(getNu(objCOTAN))
    assert_that(!is_empty(nu),
                msg = "`nu` must not be empty, estimate it")

    dispersion <- suppressWarnings(getDispersion(objCOTAN))
    assert_that(!is_empty(dispersion),
                msg = "`dispersion` must not be empty, estimate it")

    initialGuess <- nu

    nuList <- list()

    spIdx <- parallel::splitIndices(length(cells),
                                    ceiling(length(cells) / chunkSize))

    spCells <- lapply(spIdx, \(x) cells[x])

    cores <- min(cores, length(spCells))

    logThis(paste0("Executing ", length(spCells), " cells batches"),
            logLevel = 3L)

    nuList <- runNuSolver(spCells,
                          sumZeros = sumZeros,
                          lambda = lambda,
                          dispersion = dispersion,
                          initialGuess = initialGuess,
                          threshold = threshold,
                          maxIterations = maxIterations,
                          cores = cores)

    gc()

    endTime <- Sys.time()

    logThis(paste("Total calculations elapsed time:",
                  difftime(endTime, startTime, units = "secs")),
            logLevel = 2L)

    logThis("Estimate `nu`: DONE", logLevel = 2L)

    nu <- unlist(nuList, recursive = TRUE, use.names = FALSE)

    objCOTAN <- setNu(objCOTAN, nu = nu)

    if (TRUE) {
      nuChange <- abs(nu - initialGuess)
      logThis(paste("`nu` change (abs)",
                    "| max:",     max(nuChange),
                    "| median: ", median(nuChange),
                    "| mean: ",   mean(nuChange)),
              logLevel = 1L)
    }

    return(objCOTAN)
  }
)


### ------ estimateDispersionNuBisection -----

#' @aliases estimateDispersionNuBisection
#'
#' @details `estimateDispersionNuBisection()` estimates the `dispersion` and
#'   `nu` field of a `COTAN` object by running sequentially a bisection for each
#'   parameter.
#'
#' @param objCOTAN a `COTAN` object
#' @param threshold minimal solution precision
#' @param cores number of cores to use. Default is 1.
#' @param maxIterations max number of iterations (avoids infinite loops)
#' @param chunkSize number of elements to solve in batch in a single core.
#'   Default is 1024.
#' @param enforceNuAverageToOne a Boolean on whether to keep the average `nu`
#'   equal to 1
#'
#' @returns `estimateDispersionNuBisection()` returns the updated `COTAN` object
#'
#' @export
#'
#' @importFrom rlang is_empty
#'
#' @importFrom Rfast rowsums
#'
#' @importFrom assertthat assert_that
#'
#' @examples
#' objCOTAN <- estimateDispersionNuBisection(objCOTAN, cores = 6L,
#'                                           enforceNuAverageToOne = TRUE)
#' nu <- getNu(objCOTAN)
#' dispersion <- getDispersion(objCOTAN)
#'
#' @rdname ParametersEstimations
#'
setMethod(
  "estimateDispersionNuBisection",
  "COTAN",
  function(objCOTAN, threshold = 0.001, cores = 1L,
           maxIterations = 100L, chunkSize = 1024L,
           enforceNuAverageToOne = TRUE) {
    startTime <- Sys.time()

    logThis("Estimate `dispersion`/`nu`: START", logLevel = 2L)

    # getNu() would show a warning when no `nu` present
    if (is_empty(suppressWarnings(getNu(objCOTAN)))) {
      objCOTAN <- estimateNuLinear(objCOTAN)
    }

    sumZeros <- getNumCells(objCOTAN) - getNumOfExpressingCells(objCOTAN)

    iter <- 1L
    repeat {
      # a smaller threshold is used in order to ensure the global convergence
      objCOTAN <- estimateDispersionViaSolver(objCOTAN,
                                              threshold = threshold / 10.0,
                                              cores = cores,
                                              maxIterations = maxIterations,
                                              chunkSize = chunkSize)

      gc()

      objCOTAN <- estimateNuBisection(objCOTAN,
                                      threshold = threshold / 10.0,
                                      cores = cores,
                                      maxIterations = maxIterations,
                                      chunkSize = chunkSize)

      gc()

      meanNu <- mean(getNu(objCOTAN))
      logThis(paste("`nu` mean:", meanNu), logLevel = 2L)

      if (isTRUE(enforceNuAverageToOne)) {
        if (is.finite(meanNu)) {
          objCOTAN@metaCells <-
            setColumnInDF(objCOTAN@metaCells, getNu(objCOTAN) / meanNu, "nu")
        } else {
          assert_that(iter == 1L,
                      msg = paste("It can happen to have infinite mean `nu`",
                                  "only after the first loop"))
          warning("Infinite `nu` found: one of the cells expressed all genes\n",
                  " Setting 'enforceNuAverageToOne <- FALSE'")
          enforceNuAverageToOne <- FALSE
        }
      }

      if (iter >= maxIterations) {
        warning("Max number of outer iterations", maxIterations,
                "reached while finding the solution")
        break
      }

      genesMarginals <- rowsums(getProbabilityOfZero(objCOTAN),
                                parallel = TRUE)

      marginalsErrors <- abs(genesMarginals - sumZeros)

      logThis(paste("Marginal errors | max:", max(marginalsErrors),
                    "| median", median(marginalsErrors),
                    "| mean:", mean(marginalsErrors)), logLevel = 2L)

      gc()

      if (max(marginalsErrors) < threshold &&
          (isFALSE(enforceNuAverageToOne) || abs(meanNu - 1.0) < threshold)) {
        break
      }

      iter <- iter + 1L
    }

    endTime <- Sys.time()

    logThis(paste("Total calculations elapsed time:",
                  difftime(endTime, startTime, units = "secs")),
            logLevel = 2L)

    logThis("Estimate `dispersion`/`nu`: DONE", logLevel = 2L)

    return(objCOTAN)
  }
)


### ------ estimateDispersionNuNlminb -----

#' @aliases estimateDispersionNuNlminb
#'
#' @details `estimateDispersionNuNlminb()` estimates the `nu` and
#'   `dispersion` parameters to minimize the discrepancy between the observed
#'   and expected probability of zero. It uses the [stats::nlminb()] solver,
#'   but since the joint parameters have too high dimensionality, it converges
#'   too slowly to be actually useful in real cases.
#'
#' @param objCOTAN a `COTAN` object
#' @param threshold minimal solution precision
#' @param maxIterations max number of iterations (avoids infinite loops)
#' @param chunkSize number of elements to solve in batch in a single core.
#'   Default is 1024.
#' @param enforceNuAverageToOne a Boolean on whether to keep the average `nu`
#'   equal to 1
#'
#' @returns `estimateDispersionNuNlminb()` returns the updated `COTAN` object
#'
#' @importFrom rlang is_null
#' @importFrom rlang is_empty
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom Rfast rowsums
#' @importFrom Rfast colsums
#'
#' @importFrom stats nlminb
#'
#' @rdname ParametersEstimations
#'
setMethod(
  "estimateDispersionNuNlminb",
  "COTAN",
  function(objCOTAN, threshold = 0.001,
           maxIterations = 50L, chunkSize = 1024L,
           enforceNuAverageToOne = TRUE) {
    startTime <- Sys.time()

    logThis("Estimate `dispersion`/`nu`: START", logLevel = 2L)

    lambda <- suppressWarnings(getLambda(objCOTAN))
    assert_that(!is_empty(lambda),
                msg = "`lambda` must not be empty, estimate it")

    nu <- suppressWarnings(getNu(objCOTAN))
    if (is_empty(nu)) {
      objCOTAN <- estimateNuLinear(objCOTAN)
      nu <- getNu(objCOTAN)
    }

    zeroGenes <- getNumCells(objCOTAN) - getNumOfExpressingCells(objCOTAN)
    zeroCells <- getNumGenes(objCOTAN) - getNumExpressedGenes(objCOTAN)

    assert_that(all(zeroGenes != 0L), all(zeroCells != 0L),
                msg = paste("Method cannot handle fully-expressed genes",
                            "or fully-expressing cells yet"))


    errorFunction <- function(params, lambda, zeroGenes,
                              zeroCells, enforceNuAverageToOne) {
      numGenes <- length(lambda)
      dispersion <- params[1L:numGenes]
      nu <- exp(params[(numGenes + 1L):length(params)])

      probZero <- funProbZero(dispersion, lambda %o% nu)

      diffGenes <- rowsums(probZero, parallel = TRUE) - zeroGenes
      diffCells <- colsums(probZero, parallel = TRUE) - zeroCells

      diffNu <- 0.0
      if (enforceNuAverageToOne) {
        diffNu <- mean(nu) - 1.0
      }

      diffs <- c(diffGenes, diffCells, diffNu)
      error <- sqrt(sum(diffs^2L) / length(diffs))
      return(error)
    }

    solution <- nlminb(
      start = c(rep(0.0, getNumGenes(objCOTAN)), log(getNu(objCOTAN))),
      lambda = lambda, zeroGenes = zeroGenes, zeroCells = zeroCells,
      enforceNuAverageToOne = enforceNuAverageToOne,
      objective = errorFunction,
      control = list(iter.max = maxIterations, abs.tol = threshold,
                     trace = 2L, step.min = 0.001, step.max = 0.1))

    numGenes <- length(lambda)
    dispersion <- solution[["par"]][1L:numGenes]
    nu <- exp(solution[["par"]][(numGenes + 1L):length(solution[["par"]])])

    objCOTAN <- setDispersion(objCOTAN, dispersion = dispersion)
    objCOTAN <- setNu(objCOTAN, nu = nu)

    endTime <- Sys.time()

    logThis(paste("Total calculations elapsed time:",
                  difftime(endTime, startTime, units = "secs")),
            logLevel = 2L)

    logThis("Estimate `dispersion`/`nu`: DONE", logLevel = 2L)

    return(objCOTAN)
  }
)

## ----- Genes percentage plot -----

#' @details `genesPercentagePlot()` plots the percentage of expression of the
#'   passed-in genes against the overall cell's library size
#'
#' @param objCOTAN a `COTAN` object
#' @param genes an array of gene names
#' @param title The title of the plot; it defaults to `"Genes' percentage of
#'   reads"`
#' @param condName The name of a condition in the `COTAN` object to further
#'   separate the cells in more sub-groups. When no condition is given it is
#'   assumed to be the same for all cells (no further sub-divisions)
#' @param conditions The *conditions* to use. If given it will take precedence
#'   on the one indicated by `condName` that will only indicate the relevant
#'   column name in the returned `data.frame`
#'
#' @importFrom ggplot2 ggplot
#' @importFrom ggplot2 geom_point
#' @importFrom ggplot2 position_jitter
#' @importFrom ggplot2 geom_boxplot
#' @importFrom ggplot2 labs
#' @importFrom ggplot2 scale_y_continuous
#' @importFrom ggplot2 coord_cartesian
#' @importFrom ggplot2 after_stat
#'
#' @importFrom ggdist stat_slabinterval
#'
#' @importFrom Matrix rowSums
#'
#' @importFrom rlang is_empty
#'
#' @importFrom stringr str_detect
#'
#' @returns `genesPercentagePlot()` returns a `list` with:
#'   * `"plot"` a `half-violin-boxplot` object
#'   * `"sizes"` a sizes `data.frame`
#'
#' @export
#'
#' @examples
#' genes <- getGenes(objCOTAN)[1:30]
#' genesPercPlot <-
#'   genesPercentagePlot(objCOTAN, genes = genes)[["plot"]]
#' plot(genesPercPlot)
#'
#' @rdname RawDataCleaning
#'
genesPercentagePlot <- function(objCOTAN,
                                genes,
                                title = "Genes' percentage of reads",
                                condName = "",
                                conditions = NULL) {
  clDf <- data.frame()
  clDf <-
    setColumnInDF(clDf, colToSet = getCellsSize(objCOTAN), colName = "sizes")
  clDf <-
    setColumnInDF(clDf, colToSet = seq_len(nrow(clDf)),    colName = "n")
  assert_that(identical(rownames(clDf), getCells(objCOTAN)))

  c(., conditions) %<-%
    normalizeNameAndLabels(objCOTAN, name = condName,
                           labels = conditions, isCond = TRUE)
  assert_that(!is_empty(conditions),
              identical(rownames(clDf), names(conditions)))

  clDf <- setColumnInDF(clDf, colToSet = conditions, colName = "sample")

  genesInObj <- genes %in% getGenes(objCOTAN)
  genes <- genes[genesInObj]
  if (is_empty(genes)) {
    stop("passed genes are not part of the overall genes' list")
  }
  if (!all(genesInObj)) {
    warning("some of passed genes are not part of the overall genes' list")
  }

  genesData <-
    getRawData(objCOTAN)[getGenes(objCOTAN) %in% genes, , drop = FALSE]
  if (!identical(colnames(genesData), rownames(clDf))) {
    warning("Problem with cells' order!")
  }
  clDf <- setColumnInDF(clDf, colToSet = colSums(genesData), colName = "sum")

  perc <- round(100.0 * clDf[["sum"]] / clDf[["sizes"]], digits = 2L)
  clDf <- setColumnInDF(clDf, colToSet = perc, colName = "percentage")

  gPPl <-
    ggplot(
      clDf,
      aes(x = .data$sample, y = .data$percentage, fill = .data$sample)
    ) +
    ggdist::stat_slabinterval(
      aes(thickness = after_stat(pdf)),
      side = "right",                 # half-violin to the right
      show_point = FALSE,             # slab only
      show_interval = FALSE,          # no intervals
      position = position_nudge(x = 0.15),
      normalize = "groups",
      adjust = 2.0,
      trim = TRUE,
      alpha = 0.5,
      slab_colour = "black",      # outline color
      slab_linewidth = 0.6,       # outline width (ggplot2 ≥ 3.4)
      slab_alpha = 0.5            # fill alpha only; leaves stroke opaque
    ) +
    geom_point(
      position = position_jitter(width = 0.1),
      size = 0.4, color = "black", alpha = 0.5
    ) +
    geom_boxplot(
      aes(x = .data$sample, y = .data$percentage, fill = .data$sample),
      outlier.shape = NA, alpha = 0.8,
      width = 0.15, colour = "gray65", size = 0.6
    ) +
    labs(
      title = title,
      y     = "% (genes reads / tot reads * 100)",
      x     = ""
    ) +
    scale_y_continuous(expand = c(0.0, 0.0)) +
    coord_cartesian(ylim = c(0.0, max(clDf[["percentage"]]))) +
    plotTheme("size-plot")

  return(list("plot" = gPPl, "sizes" = clDf))
}



## ----- Mitochondrial percentage plot -----

#' @details `mitochondrialPercentagePlot()` plots the percentage of expression
#'   of the mitochondrial genes against the overall cell's library size
#'
#' @param objCOTAN a `COTAN` object
#' @param genePrefix Prefix for the mitochondrial genes; use `"^MT-"` for
#'   Human (default) and `"^mt-"` for Mouse
#' @param condName The name of a condition in the `COTAN` object to further
#'   separate the cells in more sub-groups. When no condition is given it is
#'   assumed to be the same for all cells (no further sub-divisions)
#' @param conditions The *conditions* to use. If given it will take precedence
#'   on the one indicated by `condName` that will only indicate the relevant
#'   column name in the returned `data.frame`
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom rlang is_empty
#'
#' @importFrom stringr str_detect
#'
#' @returns `mitochondrialPercentagePlot()` returns a `list` with:
#'   * `"plot"` a `half-violin-boxplot` object
#'   * `"sizes"` a sizes `data.frame`
#'
#' @export
#'
#' @examples
#' mitPercPlot <-
#'   mitochondrialPercentagePlot(objCOTAN, genePrefix = "g-0000")[["plot"]]
#' plot(mitPercPlot)
#'
#' @rdname RawDataCleaning
#'
mitochondrialPercentagePlot <- function(objCOTAN,
                                        genePrefix = "^MT-",
                                        condName = "",
                                        conditions = NULL) {
  isMitoch <- str_detect(getGenes(objCOTAN), pattern = genePrefix)
  mitGenes <- getGenes(objCOTAN)[isMitoch]
  if (is_empty(mitGenes)) {
    stop("gene prefix resulted in no matches")
  }

  plTitle <- "Mitochondrial percentage of reads"

  res <- genesPercentagePlot(objCOTAN, genes = mitGenes, title = plTitle,
                             condName = condName, conditions = conditions)
  assert_that(identical(colnames(res[["sizes"]]),
                        c("sizes", "n", "sample", "sum", "percentage")))

  # ensures backward compatibility
  colnames(res[["sizes"]]) <-
    c("sizes", "n", "sample", "sum.mit", "mit.percentage")

  return(res)
}

## ----knitr options, echo = FALSE, include = FALSE-----------------------------
plotDev <- if (requireNamespace("ragg", quietly = TRUE)) {
  "ragg_png"
} else if (requireNamespace("Cairo", quietly = TRUE)) {
  "cairo_png"
} else {
  "png"
}

knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  fig.width = 7L,
  fig.height = 5L,
  dev = plotDev,
  fig.crop = FALSE,
  dpi = 100L
)

## ----preamble, message=FALSE, warning=FALSE-----------------------------------
library(COTAN)
library(zeallot)

# necessary to solve precedence of overloads
conflicted::conflict_prefer("%<-%", "zeallot")

# enable multi-processing (not on Windows)
prevOptState <- options(parallelly.fork.enable = TRUE)

## ----setup-and-log------------------------------------------------------------
dataDir <- file.path(tempdir(), "COTAN_vignette_data")
dir.create(dataDir, recursive = TRUE, showWarnings = FALSE)

print(dataDir)

outDir <- dataDir

# Log-level 2 was chosen to showcase better how the package works
# In normal usage a level of 0 or 1 is more appropriate
setLoggingLevel(2L)

# This file will contain all the logs produced by the package
# as if at the highest logging level
setLoggingFile(file.path(outDir, "vignette_DEA.log"))

## ----download-data------------------------------------------------------------
GEO <- "GSM2861514"

dir.create(file.path(dataDir, GEO), showWarnings = FALSE)

datasetFileName <-
  file.path(dataDir, GEO, "GSM2861514_E175_All_Cells_DGE.txt.gz")


# retries up to 5 times to get the dataset
attempts <- 0L
maxAttempts <- 5L
ok <- FALSE

while (attempts < maxAttempts && !ok) {
  attempts <- attempts + 1L

  if (!file.exists(datasetFileName)) {
    res <- try(
      GEOquery::getGEOSuppFiles(
        GEO = GEO,
        makeDirectory = TRUE,
        baseDir = dataDir,
        filter_regex = base::basename(datasetFileName),
        fetch_files = TRUE
      ),
      silent = TRUE
    )
  }

  ok <- file.exists(datasetFileName)

  if (!ok && attempts < maxAttempts) {
    Sys.sleep(1)
  }
}

assertthat::assert_that(
  ok,
  msg = paste0(
    "Failed to retrieve file '", datasetFileName,
    "' after ", maxAttempts, " attempts."
  )
)

rawDataset <- read.csv(datasetFileName, sep = "\t", row.names = 1L)

print(dim(rawDataset))

## ----create-cotan-object------------------------------------------------------
cond <- "mouse_cortex_E17.5"

obj <- COTAN(raw = rawDataset)
obj <-
  initializeMetaDataset(
    obj,
    GEO = GEO,
    sequencingMethod = "Drop_seq",
    sampleCondition = cond
  )

logThis(paste0("Condition ", getMetadataElement(obj, datasetTags()[["cond"]])),
        logLevel = 1L)

## ----add-origin-to-the-cotan-object-------------------------------------------
# mark cells origin
data(vignette.cells.origin)
head(vignette.cells.origin, 18)

obj <- 
  addCondition(obj, condName = "origin", conditions = vignette.cells.origin)

rm(vignette.cells.origin)

## ----drop-low-quality-cells---------------------------------------------------
# use previously established results to determine
# which cells were dropped in the cleaning stage
data(vignette.split.clusters)

cellsToDrop <-
  getCells(obj)[!(getCells(obj) %in% names(vignette.split.clusters))]

obj <- dropGenesCells(obj, cells = cellsToDrop)

# Log the remaining number of cells

logThis(paste("n cells", getNumCells(obj)), logLevel = 1L)

table(getCondition(obj, condName = "origin"))

rm(vignette.split.clusters)

## ----calculate-and-store-coex-matrix------------------------------------------
obj <-
  proceedToCoex(
    obj,
    calcCoex = FALSE,
    optimizeForSpeed = TRUE,
    cores = 3L,
    deviceStr = "cuda"
  )

## ----load-pre-calculated-clusterizations--------------------------------------
data("vignette.split.clusters", package = "COTAN")
data("vignette.merge.clusters", package = "COTAN")

vignette.split.clusters <-
  asClusterization(
    vignette.split.clusters, # a named vector/factor/data.frame
    allCells = getCells(obj) # used only to check names are coherent
  )
vignette.merge.clusters <-
  asClusterization(
    vignette.merge.clusters, # a named vector/factor/data.frame
    allCells = getCells(obj) # used only to check names are coherent
  )

# explicitly calculate the DEA of the clusterization to store it
vignette.split.coexDF <-
  DEAOnClusters(obj, clusters = vignette.split.clusters)
vignette.merge.coexDF <-
  DEAOnClusters(obj, clusters = vignette.merge.clusters)

obj <-
  addClusterization(
    obj,
    clName = "split",
    clusters = vignette.split.clusters,
    coexDF = vignette.split.coexDF,
    override = FALSE
  )

obj <-
  addClusterization(
    obj,
    clName = "merge",
    clusters = vignette.merge.clusters,
    coexDF = vignette.merge.coexDF,
    override = FALSE
  )

# these will be recovered from the COTAN obj as needed
rm(vignette.split.clusters, vignette.split.coexDF)
rm(vignette.merge.clusters, vignette.merge.coexDF)

## ----extract-clusterizations--------------------------------------------------
# COTAn always stores clusterizations as factors.
splitClusters <- getClusters(obj, clName = "split")

# Use the utility factorToVector() to properly decay any named factor
# to a named char array
# splitClusters <- factorToVector(splitClusters)

# In this case the following calls are no-op since the clusterization
# were created by COTAN and so they already made nice and reordered

splitClusters <- niceFactorLevels(splitClusters)

c(splitClusters, splitCoexDF, perm) %<-% 
  reorderClusterization(
    obj,
    clName = "split",
    reverse = FALSE, 
    coexDF = NULL,
    useDEA = TRUE, # T: Cosine dist. on DEA, F: Eucl. dist. on avg. zero/one
    distance = NULL,
    hclustMethod = "ward.D2"
  )

mergeClusters <- getClusters(obj, clName = "merge")

table(splitClusters, mergeClusters)

## ----clusterization-manipulation----------------------------------------------
# this has an inverse `fromClustersList()`
splitClustersAsList <- toClustersList(splitClusters)

assertthat::assert_that(length(splitClustersAsList) == nlevels(splitClusters))

splitClustersOrigin <-
  rlang::set_names(
    rlang::rep_along(x = NA_character_, along = splitClustersAsList),
    names(splitClustersAsList)
  )

origin <- getCondition(obj, "origin")

for (clName in names(splitClustersAsList)) {
  cluster <- splitClustersAsList[[clName]]

  # assign most common origin to the cluster
  splitClustersOrigin[[clName]] <- names(which.max(table(origin[cluster])))

  # print the average non-zero expression in the cluster
  clRawData <- getRawData(obj)[, cluster, drop = FALSE]
  clRawData <- clRawData[clRawData > 0.0]

  cat(
    paste("Cluster", clName, "of", splitClustersOrigin[[clName]],
          "\torigin - average non-zero expression:", mean(clRawData)), "\n")

  rm(clRawData)
}

# If one needs to reorder the cells by cluster,
# labels are ordered as in the clusterization
orderCellsByMergeCluster <- groupByClusters(mergeClusters)

plot(getNumExpressedGenes(obj)[orderCellsByMergeCluster],
     ylab = "Num expressed genes", xlab = NA_character_)

mergeClustersAsList <- toClustersList(mergeClusters)

mergeClustersOrigin <- 
  vapply(
    mergeClustersAsList,
    \(cluster, origin) {
      names(which.max(table(origin[cluster])))
    },
    FUN.VALUE = character(1L),
    origin
  )
names(mergeClustersOrigin) <- names(mergeClustersAsList)


# It is also possible to reorder a subset of cells using
orderCellsBySomeMergeClusters <- 
  groupByClustersList(
    getCells(obj),
    mergeClustersAsList[c(2, 4, 6)]
  )

plot(getNumExpressedGenes(obj)[orderCellsBySomeMergeClusters],
     ylab = "Library Size", xlab = NA_character_)

## ----clusters-in-a-tree-------------------------------------------------------
treePlot <-
  clustersTreePlot(
    obj,
    kCuts = 2L,
    clName = "split",
    useDEA = TRUE  # T: Cosine dist. on DEA, F: Eucl. dist. on avg. zero/one
  )[["dend"]]

plot(treePlot)

# use origin to mark the clusters
dendextend::labels(treePlot) <- splitClustersOrigin[base::labels(treePlot)]

plot(treePlot)

## ----define-specific-genes-lists----------------------------------------------
# these are some genes associated to each cortical layer
layersGenes <- list(
  "L1"   = c("Reln",   "Lhx5"),
  "L2/3" = c("Cux1",   "Satb2"),
  "L4"   = c("Rorb",   "Sox5"),
  "L5/6" = c("Bcl11b", "Fezf2"),
  "Prog" = c("Hes1",    "Vim")
)

neuralTypeGenes <- list(
  # Neural Progenitor Genes
  "NPGs" = c("Nes", "Vim", "Sox2", "Sox1", "Notch1", "Hes1", "Hes5", "Pax6"),
  # Pan Neural Genes
  "PNGs" = c("Map2", "Tubb3", "Neurod1", "Nefm", "Nefl", "Dcx", "Tbr1"),
  # House Keeping
  "hk"   = c("Calm1", "Cox6b1", "Ppia", "Rpl18", "Cox7c", "Erh", "H3f3a",
             "Taf1", "Taf2", "Gapdh", "Actb", "Golph3", "Zfr", "Sub1",
             "Tars", "Amacr")
)

## ----clusterization-data-visualization, fig.height=8, fig.width=20------------
c(splitHeatmap, splitScoreDF, splitPValueDF) %<-%
  clustersMarkersHeatmapPlot(
    obj,
    groupMarkers = layersGenes,
    clName = "split",
    kCuts = 2L,
    adjustmentMethod = "bonferroni",
    condNameList = list("origin")
  )

ComplexHeatmap::draw(splitHeatmap)

c(mergeHeatmap, mergeScoreDF, mergePValueDF) %<-%
  clustersMarkersHeatmapPlot(
    obj,
    groupMarkers = neuralTypeGenes,
    clName = "merge",
    kCuts = 3L,
    adjustmentMethod = "bonferroni",
    condNameList = list("origin")
  )

ComplexHeatmap::draw(mergeHeatmap)

## ----find-marge-markers-------------------------------------------------------
mergeClusterMarkers <-
  findClustersMarkers(
    obj,
    clName = "merge",
    n = 5L,
    markers = unlist(layersGenes),
    adjustmentMethod = "bonferroni"
  )

foundMarkers <- list()

# All relevant genes with strong `p-values`
geneIsEnriched <- mergeClusterMarkers[, "adjPVal"] < 1e-10

for (clName in levels(mergeClusters)) {
  geneIsInCluster <- mergeClusterMarkers[, "CL"] == clName
  foundMarkers[[clName]] <-
    mergeClusterMarkers[geneIsEnriched & geneIsInCluster, "Gene", drop = TRUE]
}

# number of genes per cluster
lengths(foundMarkers)

## ----cl-data-visualization_found-markers, fig.height=8, fig.width=20----------
c(mergeHeatmap, ..) %<-%
  clustersMarkersHeatmapPlot(
    obj,
    groupMarkers = foundMarkers,
    clName = "merge",
    condNameList = list("origin")
  )

ComplexHeatmap::draw(mergeHeatmap)

## ----create-sub-object--------------------------------------------------------
# We will focus on the clusters `03` (likely part of layers 5/6) and
# `05` (likely part of layers 2/3) of the `split` clusterization

cellsToDrop <- getCells(obj)[!(splitClusters %in% c("03", "05"))]

obj2 <- dropGenesCells(obj, cells = cellsToDrop)

obj2 <- proceedToCoex(obj2, calcCoex = FALSE)

table(getClusters(obj2, clName = "split"))

## ----plot-sub-object-cluster-data, eval=FALSE, include=TRUE-------------------
# # this does not give more information than the same full-plot above
# 
# c(splitHeatmap2, ., .) %<-%
#   clustersMarkersHeatmapPlot(
#     obj2,
#     groupMarkers = layersGenes,
#     clName = "split",
#     kCuts = 2L,
#     adjustmentMethod = "bonferroni"
#   )
# 
# ComplexHeatmap::draw(splitHeatmap2)

## ----find-sub-object-markers--------------------------------------------------
deaMarkers <- findClustersMarkers(
  obj2,
  n = 10L,
  clName = "split",
  adjustmentMethod = "bonferroni",
  markers = layersGenes[c("L2/3", "L5/6")]
)

# over-expressed genes follow the under-expressed ones
deaMarkers[11:20, ]
deaMarkers[31:40, ]

## ----clean-up-----------------------------------------------------------------
if (file.exists(file.path(outDir, paste0(cond, ".cotan.RDS")))) {
  # delete file if it exists
  file.remove(file.path(outDir, paste0(cond, ".cotan.RDS")))
}
if (file.exists(file.path(outDir, paste0(cond, "_times.csv")))) {
  # delete file if it exists
  file.remove(file.path(outDir, paste0(cond, "_times.csv")))
}
if (dir.exists(file.path(outDir, cond))) {
  unlink(file.path(outDir, cond), recursive = TRUE)
}
# if (dir.exists(file.path(outDir, GEO))) {
#   unlink(file.path(outDir, GEO), recursive = TRUE)
# }

# stop logging to file
setLoggingFile("")
file.remove(file.path(outDir, "vignette_uniform_clustering.log"))

options(prevOptState)

## ----closure------------------------------------------------------------------
Sys.time()

sessionInfo()

# ---- checkObjIsUniform ----

#' @aliases checkObjIsUniform
#'
#' @details `checkObjIsUniform()` performs the check whether the given object is
#'   uniform according to the given checker
#'
#' @param currentC the object that defines the method and the threshold to
#'   discriminate whether a *cluster* is *uniform transcript*.
#' @param previousC the optional result object of an already done check
#' @param objCOTAN an optional `COTAN` object
#'
#' @returns a copy of `currentC` with the results of the check. Note that the
#'   slot `clusterSize` will be set to zero if it is not possible to get the
#'   result of the check
#'
#' @importFrom zeallot %<-%
#' @importFrom zeallot %->%
#'
#' @importFrom rlang is_empty
#'
#' @importFrom methods is
#' @importFrom methods validObject
#'
#' @importFrom assertthat assert_that
#'
#' @rdname UniformTranscriptCheckers

setMethod(
  "checkObjIsUniform",
  signature(currentC  = "SimpleGDIUniformityCheck",
            previousC = "ANY",
            objCOTAN  = "ANY"),
  function(currentC, previousC = NULL, objCOTAN = NULL) {
    checkerIsOK <- function(checker) {
      invisible(validObject(checker))
      return(!checker@check@isCheckAbove &&
              checker@check@maxRankBeyond  == 0L)
    }

    assert_that(
      checkerIsOK(currentC),
      is.null(previousC) || is(previousC, "SimpleGDIUniformityCheck"),
      is.null(objCOTAN)  || is(objCOTAN, "COTAN")
    )

    previousCheckIsSufficient <- FALSE
    currentC@clusterSize <- ifelse(is.null(objCOTAN), 0L, getNumCells(objCOTAN))

    cCheck <- currentC@check

    if (!is.null(previousC)) {
      assert_that(checkerIsOK(previousC))

      # in this case we assume previousC is the result of a previous check,
      # maybe with different thresholds: if possible we try to avoid using the
      # GDI to determine the check result

      if (currentC@clusterSize == 0L) {
        currentC@clusterSize <- previousC@clusterSize
      } else {
        assert_that(currentC@clusterSize == previousC@clusterSize)
      }

      pCheck <- previousC@check

      if (is.finite(pCheck@fractionBeyond) &&
          (pCheck@GDIThreshold == cCheck@GDIThreshold)) {
        cCheck@fractionBeyond <- pCheck@fractionBeyond
        previousCheckIsSufficient <- TRUE
      }

      if (is.finite(pCheck@quantileAtRatio) &&
          (pCheck@maxRatioBeyond == cCheck@maxRatioBeyond)) {
        cCheck@quantileAtRatio <- pCheck@quantileAtRatio
        previousCheckIsSufficient <- TRUE
      }

      # if neither threshold match previous check we cannot avoid re-doing the
      # check via the GDI, so fall-back from here
    }

    # run the check via pre-calculated GDI if possible
    if (!previousCheckIsSufficient && !is.null(objCOTAN)
        && getNumCells(objCOTAN) == currentC@clusterSize
        && isCoexAvailable(objCOTAN)) {
      gdi <- getGDI(objCOTAN)
      if (is_empty(gdi)) {
        # if GDI was not stored recalculate it now
        gdi <- getColumnFromDF(calculateGDI(objCOTAN), colName = "GDI")
      }

      assert_that(!is_empty(gdi))

      cCheck@quantileAtRatio <-
        quantile(gdi, probs = 1.0 - cCheck@maxRatioBeyond, names = FALSE)

      cCheck@fractionBeyond <-
        sum(gdi >= cCheck@GDIThreshold) / length(gdi)
    }

    if (is.finite(cCheck@fractionBeyond)) {
      currentC@isUniform <-
        (cCheck@fractionBeyond <= cCheck@maxRatioBeyond)
    } else if (is.finite(cCheck@quantileAtRatio)) {
      currentC@isUniform <-
        (cCheck@quantileAtRatio <= cCheck@GDIThreshold)
    } else {
      # signal no check result can be established
      currentC@clusterSize <- 0L
    }

    currentC@check <- cCheck

    return(currentC)
  })

#' @importFrom zeallot %<-%
#' @importFrom zeallot %->%
#'
#' @importFrom rlang is_empty
#'
#' @importFrom methods is
#' @importFrom methods validObject
#'
#' @importFrom assertthat assert_that
#'
#' @export
#'
#' @rdname UniformTranscriptCheckers

setMethod(
  "checkObjIsUniform",
  signature(currentC  = "AdvancedGDIUniformityCheck",
            previousC = "ANY",
            objCOTAN  = "ANY"),
  function(currentC, previousC = NULL, objCOTAN = NULL) {
    checkerIsOK <- function(checker) {
      invisible(validObject(checker))
      return(!checker@firstCheck@isCheckAbove  &&
              checker@secondCheck@isCheckAbove &&
             !checker@thirdCheck@isCheckAbove  &&
             !checker@fourthCheck@isCheckAbove &&
             checker@firstCheck@maxRankBeyond  == 0L &&
             checker@secondCheck@maxRankBeyond == 0L &&
             checker@thirdCheck@maxRankBeyond  == 0L &&
             !is.finite(checker@fourthCheck@maxRatioBeyond))
    }
    assert_that(
      checkerIsOK(currentC),
      is.null(previousC) || is(previousC, "AdvancedGDIUniformityCheck"),
      is.null(objCOTAN)  || is(objCOTAN, "COTAN")
    )

    previousCheckIsSufficient <- FALSE
    currentC@clusterSize <- ifelse(is.null(objCOTAN), 0L, getNumCells(objCOTAN))

    cCheck1 <- currentC@firstCheck
    cCheck2 <- currentC@secondCheck
    cCheck3 <- currentC@thirdCheck
    cCheck4 <- currentC@fourthCheck

    if (!is.null(previousC)) {
      assert_that(checkerIsOK(previousC))

      # in this case we assume previousC is the result of a previous check,
      # maybe with different thresholds: if possible we try to avoid using the
      # GDI to determine the check result

      if (currentC@clusterSize == 0L) {
        currentC@clusterSize <- previousC@clusterSize
      } else {
        assert_that(currentC@clusterSize == previousC@clusterSize)
      }

      pCheck1 <- previousC@firstCheck
      pCheck2 <- previousC@secondCheck
      pCheck3 <- previousC@thirdCheck
      pCheck4 <- previousC@fourthCheck

      if (is.finite(pCheck1@fractionBeyond) &&
          is.finite(pCheck2@fractionBeyond) &&
          is.finite(pCheck3@fractionBeyond) &&
          pCheck4@thresholdRank > 0L &&
          pCheck1@GDIThreshold == cCheck1@GDIThreshold &&
          pCheck2@GDIThreshold == cCheck2@GDIThreshold &&
          pCheck3@GDIThreshold == cCheck3@GDIThreshold &&
          pCheck4@GDIThreshold == cCheck4@GDIThreshold) {
        cCheck1@fractionBeyond <- pCheck1@fractionBeyond
        cCheck2@fractionBeyond <- pCheck2@fractionBeyond
        cCheck3@fractionBeyond <- pCheck3@fractionBeyond
        cCheck4@thresholdRank  <- pCheck4@thresholdRank

        previousCheckIsSufficient <- TRUE
      }

      if (is.finite(pCheck1@quantileAtRatio) &&
          is.finite(pCheck2@quantileAtRatio) &&
          is.finite(pCheck3@quantileAtRatio) &&
          is.finite(pCheck4@quantileAtRank)  &&
          pCheck1@maxRatioBeyond == cCheck1@maxRatioBeyond &&
          pCheck2@maxRatioBeyond == cCheck2@maxRatioBeyond &&
          pCheck3@maxRatioBeyond == cCheck3@maxRatioBeyond &&
          pCheck4@maxRankBeyond  == cCheck4@maxRankBeyond) {
        cCheck1@quantileAtRatio <- pCheck1@quantileAtRatio
        cCheck2@quantileAtRatio <- pCheck2@quantileAtRatio
        cCheck3@quantileAtRatio <- pCheck3@quantileAtRatio
        cCheck4@quantileAtRank  <- pCheck4@quantileAtRank

        previousCheckIsSufficient <- TRUE
      }

      # if neither threshold match previous check we cannot avoid re-doing the
      # check via the GDI, so fall-back from here
    }
    # run the check via pre-calculated GDI if possible
    if (!previousCheckIsSufficient && !is.null(objCOTAN) &&
        getNumCells(objCOTAN) == currentC@clusterSize &&
        isCoexAvailable(objCOTAN)) {
      gdi <- getGDI(objCOTAN)
      if (is_empty(gdi)) {
        # if GDI was not stored recalculate it now
        gdi <- getColumnFromDF(calculateGDI(objCOTAN), colName = "GDI")
      }

      assert_that(!is_empty(gdi))

      cCheck1@quantileAtRatio <-
        quantile(gdi, probs = 1.0 - cCheck1@maxRatioBeyond, names = FALSE)

      cCheck1@fractionBeyond <-
        sum(gdi >= cCheck1@GDIThreshold) / length(gdi)

      cCheck2@quantileAtRatio <-
        quantile(gdi, probs = 1.0 - cCheck2@maxRatioBeyond, names = FALSE)

      cCheck2@fractionBeyond <-
        sum(gdi >= cCheck2@GDIThreshold) / length(gdi)

      cCheck3@quantileAtRatio <-
        quantile(gdi, probs = 1.0 - cCheck3@maxRatioBeyond, names = FALSE)

      cCheck3@fractionBeyond <-
        sum(gdi >= cCheck3@GDIThreshold) / length(gdi)

      cCheck4@quantileAtRank <-
        sort(gdi, decreasing = TRUE)[[cCheck4@maxRankBeyond]]

      cCheck4@thresholdRank <- sum(gdi >= cCheck4@GDIThreshold)
    }

    firstCheckOK <- FALSE
    if (is.finite(cCheck1@fractionBeyond)) {
      firstCheckOK <-
        (cCheck1@fractionBeyond <= cCheck1@maxRatioBeyond)
    } else if (is.finite(cCheck1@quantileAtRatio)) {
      firstCheckOK <-
        (cCheck1@quantileAtRatio <= cCheck1@GDIThreshold)
    } else {
      # signal no check result can be established
      currentC@clusterSize <- 0L
    }

    secondCheckOK <- FALSE
    if (is.finite(cCheck2@fractionBeyond)) {
      secondCheckOK <-
        (cCheck2@fractionBeyond >= cCheck2@maxRatioBeyond)
    } else if (is.finite(cCheck2@quantileAtRatio)) {
      secondCheckOK <-
        (cCheck2@quantileAtRatio >= cCheck2@GDIThreshold)
    } else {
      # signal no check result can be established
      currentC@clusterSize <- 0L
    }

    thirdCheckOK <- FALSE
    if (is.finite(cCheck3@fractionBeyond)) {
      thirdCheckOK <-
        (cCheck3@fractionBeyond <= cCheck3@maxRatioBeyond)
    } else if (is.finite(cCheck3@quantileAtRatio)) {
      thirdCheckOK <-
        (cCheck3@quantileAtRatio <= cCheck3@GDIThreshold)
    } else {
      # signal no check result can be established
      currentC@clusterSize <- 0L
    }

    fourthCheckOK <- FALSE
    if (cCheck4@thresholdRank > 0L) {
      fourthCheckOK <-
        (cCheck4@thresholdRank < cCheck4@maxRankBeyond)
    } else if (is.finite(cCheck4@quantileAtRank)) {
      fourthCheckOK <-
        (cCheck4@quantileAtRank <= cCheck4@GDIThreshold)
    } else {
      # signal no check result can be established
      currentC@clusterSize <- 0L
    }

    currentC@isUniform <- firstCheckOK &&
      ((secondCheckOK && thirdCheckOK) || fourthCheckOK)

    currentC@firstCheck  <- cCheck1
    currentC@secondCheck <- cCheck2
    currentC@thirdCheck  <- cCheck3
    currentC@fourthCheck <- cCheck4

    return(currentC)
  })


# ------  serialization ------

#' @details `checkersToDF()` converts a `list` of checkers (i.e. objects that
#'   derive from `BaseUniformityCheck`) into a `data.frame` with the values of
#'   the members
#'
#' @param checkers a `list` of objects that defines the method, the thresholds
#'   and the results of the checks to discriminate whether a *cluster* is deemed
#'   *uniform transcript*.
#'
#' @returns a `data.frame` with col-names being the member names and row-names
#'   the names attached to each checker
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom rlang is_list
#'
#' @importFrom methods is
#' @importFrom methods slot
#' @importFrom methods slot<-
#' @importFrom methods slotNames
#'
#' @export
#'
#' @rdname UniformTranscriptCheckers
#'
checkersToDF <- function(checkers) {
  if (!is_list(checkers)) {
    checkers <- list(checkers)
  }
  chDf <- data.frame()
  for (checker in checkers) {
    # check argument is a checker
    assert_that(is(checker, "BaseUniformityCheck"))


    checkerAsList <- list(class(checker)[[1L]])
    names(checkerAsList)[[1L]] <- "class"

    for (name in slotNames(checker)) {
      member <- slot(checker, name)
      membersList <- list()
      if (is(member, "GDICheck")) {
        membersList <- lapply(slotNames(member),
                              function(subName) slot(member, subName))
        names(membersList) <- paste0(name, ".", slotNames(member))
      } else {
        membersList <- list(member)
        names(membersList)[[1L]] <- name
      }
      checkerAsList <- append(checkerAsList, membersList)
    }

    # Convert checkerAsList to a data frame row
    checkerDF <- as.data.frame(checkerAsList)

    # Bind the data frame row to the main data frame
    if (is_empty(chDf)) {
      chDf <- checkerDF
    } else {
      assert_that(identical(colnames(chDf), colnames(checkerDF)))
      chDf <- rbind(chDf, checkerDF)
    }
  }

  rownames(chDf) <- names(checkers)

  return(chDf)
}


#' @details `dfToCheckers()` converts a `data.frame` of checkers values into an
#'   array of checkers ensuring given `data.frame` is compatible with member
#'   types
#'
#' @param df a `data.frame` with col-names being the member names and row-names
#'   the names attached to each checker
#' @param checkerClass the type of the checker to be reconstructed from the
#'   given `data.frame`
#'
#' @returns `dfToCheckers()` returns a `list` of checkers of the requested type,
#'   each created from one of `data.frame` rows
#'
#' @importFrom zeallot %<-%
#' @importFrom zeallot %->%
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom rlang is_empty
#' @importFrom rlang is_character
#'
#' @importFrom stringr str_split_i
#' @importFrom stringr fixed
#'
#' @importFrom methods new
#'
#' @export
#'
#' @rdname UniformTranscriptCheckers
#'
dfToCheckers <- function(df, checkerClass = "") {
  checkers <- list()

  if (is_empty(df)) {
    return(checkers)
  }

  assert_that(is_character(checkerClass),
              msg = "A valid checker type must be given")

  if (isEmptyName(checkerClass)) {
    assert_that(nrow(df) != 0L,
                "class" %in% colnames(df),
                msg = paste("Cannot recover checker type: not present",
                            "in data.frame and not given by user"))

    checkerClass <- df[1L, "class"]

    assert_that(all(df[["class"]] == checkerClass),
                msg = "All checks in the data.frame must be of the same type")
  }

  checker <- new(checkerClass)
  assert_that(is(checker, "BaseUniformityCheck"))

  dfRootNames <- str_split_i(colnames(df), fixed("."), 1L)
  assert_that(all(slotNames(checker) %in% dfRootNames),
              msg = paste0("Given checkerClass [", class(checker), "] is ",
                           "inconsistent with the data.frame column names"))

  for (r in seq_len(nrow(df))) {
    checker <- new(checkerClass)

    # Assign values from the data.frame row to the corresponding slots
    for (name in slotNames(checker)) {
      member <- slot(checker, name)
      if (is(member, "GDICheck")) {
        subNames <- slotNames(member)
        if (TRUE) {
          relCols <- dfRootNames == name
          dfSubNames <- str_split_i(colnames(df)[relCols], fixed("."), 2L)
          assert_that(all(subNames %in% dfSubNames),
                      msg = paste0("Given checkerClass [", class(checker),
                                   "] is inconsistent with the data.frame",
                                   "column names"))
          rm(relCols, dfSubNames)
        }
        for (subName in subNames) {
          slot(member, subName) <- df[r, paste0(name, ".", subName)]
        }
      } else {
        member <- df[r, name]
      }

      slot(checker, name) <- member
    }

    checkers <- append(checkers, checker)
  }

  names(checkers) <- rownames(df)

  return(checkers)
}


# ------  getCheckerThreshold ------

#' @aliases getCheckerThreshold
#'
#' @description `getCheckerThreshold()` extracts the main `GDI` threshold
#'   from the given checker object
#'
#' @param checker An checker object that defines how to check for *uniform
#'   transcript*. It is derived from [BaseUniformityCheck-class]
#'
#' @returns `getCheckerThreshold()` returns the appropriate member of the
#'   checker object representing the main `GDI` threshold
#'
#' @export
#'
#' @importFrom methods validObject
#'
#' @rdname UniformTranscriptCheckers
#'
setMethod(
  "getCheckerThreshold",
  signature(checker = "SimpleGDIUniformityCheck"),
  function(checker) {
    invisible(validObject(checker))
    return(checker@check@GDIThreshold)
  })

#' @export
#'
#' @importFrom methods validObject
#'
#' @rdname UniformTranscriptCheckers
#'
setMethod(
  "getCheckerThreshold",
  signature(checker = "AdvancedGDIUniformityCheck"),
  function(checker) {
    invisible(validObject(checker))
    return(checker@firstCheck@GDIThreshold)
  })


# ------  calculateThresholdShiftToUniformity ------

#' @aliases calculateThresholdShiftToUniformity
#'
#' @description `calculateThresholdShiftToUniformity()` calculates by how much
#'   the `GDI` thresholds in the given checker must be increased in order to
#'   have that the relevant cluster is deemed **uniform transcript**
#'
#' @param checker An checker object that defines how to check for *uniform
#'   transcript*. It is derived from [BaseUniformityCheck-class]
#'
#' @returns `calculateThresholdShiftToUniformity()` returns the positive shift
#'   that would make the `@isUniform` slot `TRUE` in the checker. It returns
#'   zero if the result is already `TRUE` and `NaN` in case no such shift can
#'   exist (e.g. the check have been not done yet)
#'
#' @export
#'
#' @importFrom methods validObject
#'
#' @rdname UniformTranscriptCheckers
#'
setMethod(
  "calculateThresholdShiftToUniformity",
  signature(checker = "SimpleGDIUniformityCheck"),
  function(checker) {
    invisible(validObject(checker))
    if (checker@clusterSize == 0L ||
        !is.finite(checker@check@quantileAtRatio)) {
      return(NaN)
    }
    return(checker@check@quantileAtRatio - checker@check@GDIThreshold)
  })

#' @export
#'
#' @importFrom methods validObject
#'
#' @rdname UniformTranscriptCheckers
#'
setMethod(
  "calculateThresholdShiftToUniformity",
  signature(checker = "AdvancedGDIUniformityCheck"),
  function(checker) {
    invisible(validObject(checker))
    if (checker@clusterSize == 0L ||
        !is.finite(checker@firstCheck@quantileAtRatio)  ||
        !is.finite(checker@secondCheck@quantileAtRatio) ||
        !is.finite(checker@thirdCheck@quantileAtRatio) ||
        !is.finite(checker@fourthCheck@quantileAtRank)) {
      return(NaN)
    }
    delta1 <- checker@firstCheck@quantileAtRatio -
                checker@firstCheck@GDIThreshold
    delta2 <- checker@secondCheck@quantileAtRatio -
                checker@secondCheck@GDIThreshold
    delta3 <- checker@thirdCheck@quantileAtRatio -
                checker@thirdCheck@GDIThreshold
    delta4 <- checker@fourthCheck@quantileAtRank -
                checker@fourthCheck@GDIThreshold

    # delta14 is always sufficient to make the cluster UT,
    # if delta13 is lower and delta2 collaborates then delta13 can be used.
    # We use delta13^+ against delta2 as we never lower
    # the secondCheck@GDIThreshold!

    delta13 <- max(delta1, delta3)
    delta14 <- max(delta1, delta4)

    if (delta13 < delta14 && delta2 > max(0.0, delta13)) {
      return(delta13)
    } else {
      return(delta14)
    }
  })

# ------  shiftCheckerThresholds ------

#' @aliases shiftCheckerThresholds
#'
#' @description `shiftCheckerThresholds()` returns a new checker object where
#'   the `GDI` thresholds where increased in order to *relax* the conditions to
#'   achieve **uniform transcript**
#'
#' @param checker An checker object that defines how to check for *uniform
#'   transcript*. It is derived from [BaseUniformityCheck-class]
#'
#' @param shift The amount by which to shift the `GDI` thresholds in the checker
#'
#' @returns `shiftCheckerThresholds()` returns a copy of the checker object
#'   where all `GDI` thresholds have been shifted by the same given `shift`
#'   amount
#'
#' @export
#'
#' @importFrom methods new
#' @importFrom methods validObject
#'
#' @rdname UniformTranscriptCheckers
#'
setMethod(
  "shiftCheckerThresholds",
  signature(checker = "SimpleGDIUniformityCheck",
            shift = "numeric"),
  function(checker, shift) {
    invisible(validObject(checker))
    assert_that(is.finite(shift), shift >= 0.0,
                msg = "Given shift must be a non negative number")

    return(new("SimpleGDIUniformityCheck",
               check = new("GDICheck",
                           isCheckAbove   = checker@check@isCheckAbove,
                           GDIThreshold   = checker@check@GDIThreshold + shift,
                           maxRatioBeyond = checker@check@maxRatioBeyond,
                           maxRankBeyond  = checker@check@maxRankBeyond)))
  })

#' @export
#'
#' @importFrom methods new
#' @importFrom methods validObject
#'
#' @rdname UniformTranscriptCheckers
#'
setMethod(
  "shiftCheckerThresholds",
  signature(checker = "AdvancedGDIUniformityCheck",
            shift = "numeric"),
  function(checker, shift) {
    invisible(validObject(checker))
    assert_that(is.finite(shift), shift >= 0.0,
                msg = "Given shift must be a non negative number")

    return(new("AdvancedGDIUniformityCheck",
               firstCheck =
                 new("GDICheck",
                     isCheckAbove   = checker@firstCheck@isCheckAbove,
                     GDIThreshold   = checker@firstCheck@GDIThreshold + shift,
                     maxRatioBeyond = checker@firstCheck@maxRatioBeyond,
                     maxRankBeyond  = checker@firstCheck@maxRankBeyond),
               secondCheck =
                 new("GDICheck",
                     isCheckAbove   = checker@secondCheck@isCheckAbove,
                     GDIThreshold   = checker@secondCheck@GDIThreshold + shift,
                     maxRatioBeyond = checker@secondCheck@maxRatioBeyond,
                     maxRankBeyond  = checker@secondCheck@maxRankBeyond),
               thirdCheck =
                 new("GDICheck",
                     isCheckAbove   = checker@thirdCheck@isCheckAbove,
                     GDIThreshold   = checker@thirdCheck@GDIThreshold + shift,
                     maxRatioBeyond = checker@thirdCheck@maxRatioBeyond,
                     maxRankBeyond  = checker@thirdCheck@maxRankBeyond),
               fourthCheck =
                 new("GDICheck",
                     isCheckAbove   = checker@fourthCheck@isCheckAbove,
                     GDIThreshold   = checker@fourthCheck@GDIThreshold + shift,
                     maxRatioBeyond = checker@fourthCheck@maxRatioBeyond,
                     maxRankBeyond  = checker@fourthCheck@maxRankBeyond)))
  })

#'
#' @title Numeric Utilities
#'
#' @description A set of function helper related to the statistical model
#'   underlying the `COTAN` package
#'
#' @name NumericUtilities
NULL

#------------------- negative binomial ----------

#'
#' @details `funProbZero` is a private function that gives the probability that
#'   a sample gene's reads are zero, given the `dispersion` and `mu` parameters.
#'
#' @details Using \eqn{d}{`disp`} for `disp` and \eqn{\mu}{`mu`} for `mu`,
#'   it returns:
#'   \eqn{(1 + d \mu)^{-\frac{1}{d}}}{(1 + `disp` * `mu`)^(-1 / `disp`)}
#'   when \eqn{d > 0}{`disp > 0`} and
#'   \eqn{\exp{((d - 1) \mu)}}{exp((`disp` - 1) * `mu`)} otherwise.
#'   The function is continuous in \eqn{d = 0}{`disp = 0`},
#'   increasing in \eqn{d}{`disp`} and decreasing in \eqn{\mu}{`mu`}.
#'   It returns 0 when \eqn{d = -\infty}{`disp = -Inf`} or
#'   \eqn{\mu = \infty}{`mu = Inf`}.
#'   It returns 1 when \eqn{\mu = 0}{`mu = 0`}.
#'
#' @param dispersion the estimated `dispersion` (a \eqn{n}-sized vector)
#' @param mu the `lambda` times `nu` values (a \eqn{n \times m} matrix)
#'
#' @returns the probability `matrix` that a *read count* is identically zero
#'
#' @rdname NumericUtilities
#'
funProbZero <- function(dispersion, mu) {
  disp <- as.numeric(dispersion)
  numGenes <- length(disp)

  assert_that(numGenes != 0L, msg = "empty input given")

  returnArray <- is.null(dim(mu))

  if (returnArray) {
    mu <- matrix(mu, nrow = numGenes)
  }

  # if mu is a matrix
  assert_that(nrow(mu) == numGenes,
              msg = "misaligned dimensions between given `mu` and `dispersion`")

  eps <- 1.0e-5

  mifIdx <- which(disp == -Inf)
  negIdx <- which(disp <  eps & disp != -Inf)
  posIdx <- which(disp >= eps & disp != +Inf)
  pifIdx <- which(disp == +Inf)

  out <- disp * mu

  if (length(mifIdx)) {
    out[mifIdx, ] <- -Inf
  }
  if (length(negIdx)) {
    # out = dispersion * mu - mu
    out[negIdx, ] <-
      out[negIdx, , drop = FALSE] - mu[negIdx, , drop = FALSE]
  }
  if (length(posIdx)) {
    # out = -(1/disp)*log1p(disp*mu)
    out[posIdx, ] <-
      -(1.0 / disp[posIdx]) * log1p(out[posIdx, , drop = FALSE])
  }
  if (length(pifIdx)) {
    out[pifIdx, ] <- 0.0
  }

  out <- exp(out)

  if (returnArray) {
    out <- as.vector(out)
  }

  return(out)
}


#--------------------- dispersion solvers ----------------

#' @details `dispersionBisection` is a private function for the estimation of
#'   `dispersion` slot of a `COTAN` object via a bisection solver
#'
#' @details The goal is to find a `dispersion` value that reduces to zero the
#'   difference between the number of estimated and counted zeros
#'
#' @param sumZeros the number of cells that didn't express the gene
#' @param lambda the estimated `lambda` (a \eqn{n}-sized vector)
#' @param nu the estimated `nu` (a \eqn{m}-sized vector)
#' @param threshold minimal solution precision
#' @param maxIterations max number of iterations (avoids infinite loops)
#'
#' @returns the `dispersion` value
#'
#' @rdname NumericUtilities
#'
dispersionBisection <-
  function(sumZeros,
           lambda,
           nu,
           threshold = 0.001,
           maxIterations = 100L) {
    if (sumZeros == 0L) {
      # cannot match exactly zero prob of zeros with finite values
      return(-Inf)
    } else if (sumZeros == length(nu)) {
      # in case of zero lambda dispersion is irrelevant. We return 1.0
      return(1.0)
    }
    mu <- lambda * nu

    # we look for two dispersion values where the first leads to a
    # diffZeros negative and the second positive
    disp1 <- 0.0
    diff1 <- sum(funProbZero(disp1, mu)) - sumZeros
    if (abs(diff1) <= threshold) {
      return(disp1)
    }

    # we assume error is an increasing function of disp
    disp2 <- -1.0 * sign(diff1)
    iter <- 1L
    repeat {
      diff2 <- sum(funProbZero(disp2, mu)) - sumZeros

      if (diff2 * diff1 < 0.0) {
        break
      }

      if (iter >= maxIterations) {
        stop("Max number of iterations reached ",
             "while finding the solution straddling intervals")
      }
      iter <- iter + 1L

      disp1 <- disp2 # disp2 is closer to producing 0.0

      disp2 <- 2.0 * disp2 # we double at each step
    }
    logThis(paste("Dispersion bisection: straddling used",
                  iter, "iterations"), logLevel = 3L)

    # once we have found the two bounds to the dispersion value we use bisection
    iter <- 1L
    repeat {
      disp3 <- (disp1 + disp2) / 2.0

      diff3 <- sum(funProbZero(disp3, mu)) - sumZeros

      if (abs(diff3) <= threshold) {
        logThis(paste("Dispersion bisection: used",
                      iter, "iterations"), logLevel = 3L)
        return(disp3)
      }

      if (iter >= maxIterations) {
        stop("Max number of iterations reached ",
             "while finding the solution straddling intervals")
      }
      iter <- iter + 1L

      # drop same sign diff point
      if (diff3 * diff2 > 0.0) {
        disp2 <- disp3
      } else {
        disp1 <- disp3
      }
    }
  }


#' @details `parallelDispersionBisection` is a private function that was invoked
#'   by [estimateDispersionViaSolver()] for the estimation of the `dispersion`
#'   slot of a `COTAN` object via a parallel bisection solver. It is now
#'   deprecated
#'
#' @details The goal is to find a `dispersion` `array` that reduces to zero the
#'   difference between the number of estimated and counted zeros
#'
#' @param genes names of the relevant genes
#' @param sumZeros the number of cells that didn't express the relevant gene (a
#'   \eqn{n}-sized vector)
#' @param lambda the estimated `lambda` (a \eqn{n}-sized vector)
#' @param nu the estimated `nu` (a \eqn{m}-sized vector)
#' @param threshold minimal solution precision
#' @param maxIterations max number of iterations (avoids infinite loops)
#'
#' @returns the dispersion values
#'
#' @importFrom Rfast rowsums
#'
#' @rdname NumericUtilities
#'
parallelDispersionBisection <-
  function(genes,
           sumZeros,
           lambda,
           nu,
           threshold = 0.001,
           maxIterations = 100L) {
    sumZeros <- sumZeros[genes]
    lambda <- lambda[genes]

    # cannot match exactly zero prob of zeros with finite values
    # so we ignore the rows with no zeros from the solver and return -Inf
    output <- rep(-Inf, length(sumZeros))

    # in case of zero lambda dispersion is irrelevant. We return 1.0
    goodPos <- sumZeros != length(nu)
    output[!goodPos] <- 1.0

    goodPos <- goodPos & sumZeros != 0L

    if (!any(goodPos)) {
      return(output)
    }

    sumZeros <- sumZeros[goodPos]
    lambda <- lambda[goodPos]

    mu <- lambda %o% nu

    # we look for two dispersion values where the first leads to a
    # diffZeros negative and the second positive
    disps1 <- rep(0.0, length(sumZeros))
    diffs1 <- rowsums(funProbZero(disps1, mu)) - sumZeros
    if (all(abs(diffs1) <= threshold)) {
      output[goodPos] <- disps1
      return(output)
    }

    # we assume error is an increasing function of the dispersion
    disps2 <- -1.0 * sign(diffs1)
    diffs2 <- diffs1
    runPos <- rep(TRUE, length(diffs1))
    iter <- 1L
    repeat {
      diffs2[runPos] <- (rowsums(funProbZero(disps2[runPos],
                                             mu[runPos, , drop = FALSE])) -
                           sumZeros[runPos])

      runPos <- (diffs2 * diffs1 >= 0.0)

      if (!any(runPos)) {
        break
      }

      if (iter >= maxIterations) {
        stop("Max number of iterations reached while finding",
             " the solution straddling intervals")
      }
      iter <- iter + 1L

      disps1[runPos] <- disps2[runPos] # disps2 are closer to producing 0

      disps2[runPos] <- 2.0 * disps2[runPos] # we double at each step
    }
    logThis(paste("parallel dispersion bisection: straddling used up to",
                  iter, "iterations"), logLevel = 3L)

    # once we have found the two bounds to the dispersion value we use bisection
    runNum <- length(diffs1)
    runPos <- rep(TRUE, runNum)
    disps <- disps1
    diffs <- diffs1
    iter <- 1L
    repeat {
      disps[runPos] <- (disps1[runPos] + disps2[runPos]) / 2.0

      diffs[runPos] <- (rowsums(funProbZero(disps[runPos],
                                            mu[runPos, , drop = FALSE])) -
                          sumZeros[runPos])

      runPos <- abs(diffs) > threshold
      if (!any(runPos)) {
        break
      }

      if (iter >= maxIterations) {
        stop("Max number of iterations reached while finding the solutions")
      }
      iter <- iter + 1L

      # drop same sign diff point
      pPos <- runPos & (diffs * diffs2 > 0.0)
      disps2[pPos] <- disps[pPos]

      nPos <- runPos & !pPos
      disps1[nPos] <- disps[nPos]
    }
    logThis(paste("Parallel dispersion bisection: used up to",
                  iter, "iterations"), logLevel = 3L)

    rm(mu)
    gc()

    output[goodPos] <- disps
    return(output)
  }


#' @details `dispersionNewton` is a private function for the estimation of
#'   `dispersion` slot of a `COTAN` object via a Newton-Raphson solver
#'
#' @details The goal is to find a `dispersion` value that reduces to zero the
#'   difference between the number of estimated and counted zeros
#'
#' @param sumZeros the number of cells that didn't express the gene
#' @param lambda the estimated `lambda` (a \eqn{n}-sized vector)
#' @param nu the estimated `nu` (a \eqn{m}-sized vector)
#' @param threshold minimal solution precision
#' @param maxIterations max number of iterations (avoids infinite loops)
#'
#' @returns the `dispersion` value
#'
#' @rdname NumericUtilities
#'
dispersionNewton <-
  function(sumZeros,
           lambda,
           nu,
           threshold = 0.001,
           maxIterations = 100L) {
    if (sumZeros == 0L) {
      # cannot match exactly zero prob of zeros with finite values
      return(-Inf)
    } else if (sumZeros == length(nu)) {
      # in case of zero lambda dispersion is irrelevant. We return 1.0
      return(1.0)
    }
    mu <- lambda * nu

    # we look for two dispersion values where the first leads to a
    # diffZeros negative and the second positive
    disp1 <- 0.0
    diff1 <- sum(funProbZero(disp1, mu)) - sumZeros
    if (abs(diff1) <= threshold) {
      return(disp1)
    }

    # we assume error is an increasing function of disp1
    dispIsNeg <- sign(diff1) >= 0.0
    disp1 <- ifelse(dispIsNeg, -1.0, 1.0)
    iter <- 1L
    repeat {
      dispMu <- as.matrix(disp1 * mu)

      if (dispIsNeg) {
        logProbZero <- dispMu - mu
      } else {
        logProbZero <- -1.0 * log1p(dispMu) / disp1
      }

      probZero <- exp(logProbZero)

      diff1 <- sum(probZero) - sumZeros

      if (abs(diff1) <= threshold) {
        logThis(paste("Dispersion Newton-Raphson: used up to",
                      iter, "iterations"), logLevel = 3L)
        return(disp1)
      }

      if (iter >= maxIterations) {
        stop("Max number of iterations reached ",
             "while finding the solution straddling intervals")
      }
      iter <- iter + 1L

      denom <- ifelse(dispIsNeg,
                      sum(dispMu * probZero),
                      sum((mu / (dispMu + 1.0) + logProbZero) * probZero))

      fact <-
        max((denom + ifelse(dispIsNeg, -1.0, 1.0) * diff1) / denom, 1.0e-8)

      disp1 <- disp1 * fact
    }
  }




#' @details `parallelDispersionNewton` is a private function invoked by
#'   [parallelDispersionNewton()] for the estimation of the `dispersion` slot
#'   of a `COTAN` object via a parallel Newton-Raphson solver
#'
#' @details The goal is to find a `dispersion` `array` that reduces to zero the
#'   difference between the number of estimated and counted zeros
#'
#' @param genes names of the relevant genes
#' @param sumZeros the number of cells that didn't express the relevant gene (a
#'   \eqn{n}-sized vector)
#' @param lambda the estimated `lambda` (a \eqn{n}-sized vector)
#' @param nu the estimated `nu` (a \eqn{m}-sized vector)
#' @param threshold minimal solution precision
#' @param maxIterations max number of iterations (avoids infinite loops)
#'
#' @returns the dispersion values
#'
#' @importFrom Rfast rowsums
#'
#' @rdname NumericUtilities
#'
parallelDispersionNewton <-
  function(genes,
           sumZeros,
           lambda,
           nu,
           threshold = 0.001,
           maxIterations = 100L) {
    sumZeros <- sumZeros[genes]
    lambda <- lambda[genes]

    # cannot match exactly zero prob of zeros with finite values
    # so we ignore the rows with no zeros from the solver and return -Inf
    output <- rep(-Inf, length(sumZeros))

    # in case of zero lambda dispersion is irrelevant. We return 1.0
    goodPos <- sumZeros != length(nu)
    output[!goodPos] <- 1.0

    goodPos <- goodPos & sumZeros != 0L

    if (!any(goodPos)) {
      return(output)
    }

    sumZeros <- sumZeros[goodPos]
    lambda <- lambda[goodPos]

    mu <- lambda %o% nu

    # we look for two dispersion values where the first leads to a
    # diffZeros negative and the second positive
    disps <- rep(0.0, length(sumZeros))
    diffs <- rowsums(funProbZero(disps, mu)) - sumZeros
    if (all(abs(diffs) <= threshold)) {
      output[goodPos] <- disps
      return(output)
    }

    # we assume error is an increasing function of the dispersion
    dispsIsNeg <- sign(diffs) >= 0.0
    disps <- ifelse(dispsIsNeg, -1.0, 1.0)
    runPos <- rep(TRUE, length(disps))
    iter <- 1L
    repeat {
      dispsMu <- disps[runPos] * mu[runPos, , drop = FALSE]

      isNeg <- dispsIsNeg[runPos]

      logProbsZero <- matrix(NaN, nrow(dispsMu), ncol(dispsMu))
      logProbsZero[ isNeg, ] <-
        (dispsMu[isNeg, , drop = FALSE] -
           mu[runPos & dispsIsNeg, , drop = FALSE])
      logProbsZero[!isNeg, ] <-
        ((-1.0 / disps[runPos & !dispsIsNeg]) *
           log1p(dispsMu[!isNeg, , drop = FALSE]))

      probsZero <- exp(logProbsZero)

      diffs[runPos] <- rowsums(probsZero) - sumZeros[runPos]

      denoms <- rep(1.0, length(disps))
      denoms[runPos &  dispsIsNeg] <-
        rowsums(dispsMu[isNeg, , drop = FALSE] *
                  probsZero[isNeg, , drop = FALSE])
      denoms[runPos & !dispsIsNeg] <-
        rowsums(((mu[runPos & !dispsIsNeg, , drop = FALSE] /
                    (dispsMu[!isNeg, , drop = FALSE] + 1.0)) +
                   logProbsZero[!isNeg, , drop = FALSE]) *
                  probsZero[!isNeg, , drop = FALSE])

      rm(dispsMu, logProbsZero, probsZero)

      diffs[runPos & dispsIsNeg] <- -1.0 * diffs[runPos & dispsIsNeg]

      runPos <- abs(diffs) > threshold
      if (!any(runPos)) {
        break
      }

      if (iter >= maxIterations) {
        stop("Max number of iterations reached while finding the solutions")
      }
      iter <- iter + 1L

      factors <- pmax((denoms + diffs) / denoms, 1e-8)

      disps[runPos] <- disps[runPos] * factors[runPos]
    }
    logThis(paste("Parallel dispersion Newton-Raphson: used up to",
                  iter, "iterations"), logLevel = 3L)
    rm(mu)
    gc()

    output[goodPos] <- disps
    return(output)
  }


#------------------------- nu solvers ---------------------

#' @details `nuBisection` is a private function for the estimation of `nu` slot
#'   of a `COTAN` object via a bisection solver
#'
#' @details The goal is to find a `nu` value that reduces to zero the difference
#'   between the number of estimated and counted zeros
#'
#' @param sumZeros the number non expressed genes in the cell
#' @param lambda the estimated `lambda` (a \eqn{n}-sized vector)
#' @param dispersion the estimated `dispersion` (a \eqn{n}-sized vector)
#' @param initialGuess the initial guess for `nu`
#' @param threshold minimal solution precision
#' @param maxIterations max number of iterations (avoids infinite loops)
#'
#' @returns the nu value
#'
#' @rdname NumericUtilities
#'
nuBisection <-
  function(sumZeros,
           lambda,
           dispersion,
           initialGuess,
           threshold = 0.001,
           maxIterations = 100L) {
    if (sumZeros == 0L) {
      # cannot match exactly zero prob of zeros with finite values
      return(Inf)
    }

    # we look for two dispersion values where the first leads to a
    # diffZeros negative and the second positive
    nu1 <- initialGuess
    diff1 <- sum(funProbZero(dispersion, nu1 * lambda)) - sumZeros
    if (abs(diff1) <= threshold) {
      return(nu1)
    }

    fact <- 2.0 ^ sign(diff1)
    nu2 <- nu1 * fact # we assume error is an decreasing function of nu
    iter <- 1L
    repeat {
      diff2 <- sum(funProbZero(dispersion, nu2 * lambda)) - sumZeros

      if (diff2 * diff1 < 0.0) {
        break
      }

      if (iter >= maxIterations) {
        stop("Max number of iterations reached while ",
             "finding the solution straddling intervals")
      }
      iter <- iter + 1L

      nu1 <- nu2 # nu2 is closer to producing 0

      nu2 <- nu2 * fact # we double/half at each step
    }

    # once we have found the two bounds to the dispersion value we use bisection
    iter <- 1L
    repeat {
      nu3 <- (nu1 + nu2) / 2.0

      diff3 <- sum(funProbZero(dispersion, nu3 * lambda)) - sumZeros

      if (abs(diff3) <= threshold) {
        return(nu3)
      }

      if (iter >= maxIterations) {
        stop("Max number of iterations reached while ",
             "finding the solution straddling intervals")
      }
      iter <- iter + 1L

      # drop same sign diff point
      if (diff3 * diff2 > 0L) {
        nu2 <- nu3
      } else {
        nu1 <- nu3
      }
    }
  }


#' @details `parallelNuBisection` is a private function invoked by
#'   [estimateNuBisection()] for the estimation of `nu` slot of a `COTAN` object
#'   via a parallel bisection solver
#'
#' @details The goal is to find a `nu` `array` that reduces to zero the
#'   difference between the number of estimated and counted zeros
#'
#' @param cells names of the relevant cells
#' @param sumZeros the number of genes not expressed in the relevant cell (a
#'   \eqn{m}-sized vector)
#' @param lambda the estimated `lambda` (a \eqn{n}-sized vector)
#' @param dispersion the estimated `dispersion` (a \eqn{n}-sized vector)
#' @param initialGuess the initial guess for `nu`  (a \eqn{m}-sized vector)
#' @param threshold minimal solution precision
#' @param maxIterations max number of iterations (avoids infinite loops)
#'
#' @returns the dispersion values
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom Rfast colsums
#'
#' @rdname NumericUtilities
#'
parallelNuBisection <-
  function(cells,
           sumZeros,
           lambda,
           dispersion,
           initialGuess,
           threshold = 0.001,
           maxIterations = 100L) {
    sumZeros <- sumZeros[cells]
    initialGuess <- initialGuess[cells]

    assert_that(all(initialGuess > 0.0),
                msg = "initialGuess must hold only positive values")

    goodPos <- sumZeros != 0L

    # cannot match exactly zero prob of zeros with finite values
    output <- rep(Inf, length(initialGuess))

    if (sum(goodPos) == 0L) {
      return(output)
    }

    sumZeros <- sumZeros[goodPos]

    # we look for two dispersion values where the first leads to a
    # diffZeros negative and the second positive
    nus1 <- initialGuess[goodPos]

    diffs1 <- colsums(funProbZero(dispersion, lambda %o% nus1)) - sumZeros
    if (all(abs(diffs1) <= threshold)) {
      output[goodPos] <- nus1
      return(output)
    }

    # we assume error is an increasing function of the dispersion
    factors <- 2.0 ^ sign(diffs1)
    nus2 <- nus1 * factors
    diffs2 <- diffs1
    runPos <- rep(TRUE, length(diffs1))
    iter <- 1L
    repeat {
      diffs2[runPos] <- (colsums(funProbZero(dispersion,
                                             lambda %o% nus2[runPos])) -
                           sumZeros[runPos])

      runPos <- (diffs2 * diffs1 >= 0.0)

      if (!any(runPos)) {
        break
      }

      if (iter >= maxIterations) {
        stop("Max number of iterations reached while ",
             "finding the solution straddling intervals")
      }
      iter <- iter + 1L


      # nus2 are closer to producing 0
      nus1[runPos] <- nus2[runPos]

      # we double (or half) at each step
      nus2[runPos] <- nus2[runPos] * factors[runPos]
    }

    # once we have found the two bounds to the dispersion value we use bisection
    runNum <- length(diffs1)
    runPos <- rep(TRUE, runNum)
    nus <- nus1
    diffs <- diffs1
    iter <- 1L
    repeat {
      nus[runPos] <- (nus1[runPos] + nus2[runPos]) / 2.0

      diffs[runPos] <- (colsums(funProbZero(dispersion,
                                            lambda %o% nus[runPos])) -
                          sumZeros[runPos])

      runPos <- (abs(diffs) > threshold)
      if (!any(runPos)) {
        break
      }

      if (iter >= maxIterations) {
        stop("Max number of iterations reached while finding the solutions")
      }
      iter <- iter + 1L

      # drop same sign diff point
      pPos <- runPos & (diffs * diffs2 > 0.0)
      nus2[pPos] <- nus[pPos]

      nPos <- runPos & !pPos
      nus1[nPos] <- nus[nPos]
    }

    output[goodPos] <- nus
    return(output)
  }


#----------------- distance functions --------------------


#' @details `calcDist` is a wrapper function that invokes
#'   [parallelDist::parDist()]: the main goal is to recover and finish the
#'   calculations via a fallback when there is a problem with the main algorithm
#'
#' @param data a matrix or a data.frame of which we want to calculate the
#'   distance between columns
#' @param method type of distance to use. Can be chosen among those supported by
#'   [parallelDist::parDist()]
#' @param diag logical value indicating whether the diagonal of the distance
#'   matrix should be printed by print.dist.upper
#' @param upper logical value indicating whether the upper triangle of the
#'   distance matrix should be printed by print.dist
#'
#' @returns a `dist` object with all distances
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom rlang is_null
#'
#' @importFrom parallelDist parDist
#'
#' @importFrom proxy dist
#'
#' @rdname NumericUtilities
#'

calcDist <- function(data, method, diag = FALSE, upper = FALSE) {
  data <- as.matrix(data)

  ret <- NULL

  sI <- Sys.info()
  if (!grepl("Linux", sI[["sysname"]], ignore.case = TRUE) ||
      !grepl("aarch64", sI[["machine"]], ignore.case = TRUE)) {
    ret <- tryCatch(parDist(data, method = method,
                            diag = diag, upper = upper),
                    error = function(err) {
                      logThis(paste("While calculating distance", err),
                              logLevel = 1L)
                      logThis("Falling back to single threaded algo",
                              logLevel = 1L)
                      return(NULL)
                    })
  }

  if (is_null(ret)) {
    ret <- dist(data, method = method, diag = diag, upper = upper)
  }

  return(ret)
}

#----------------- Matrix utilities --------------------

coerceToDgCMatrix <- function(x) {
  if (is.data.frame(x)) {
    x <- as.matrix(x)
  }

  # DelayedArray / HDF5-backed etc.
  if (inherits(x, "DelayedMatrix")) {
    # prefer sparse realization if available
    x <- tryCatch(as(x, "dgCMatrix"),
                  error = function(e) as.matrix(x))
  }

  if (!inherits(x, "Matrix")) {
    x <- Matrix::Matrix(x, sparse = TRUE)
  }

  return(as(x, "dgCMatrix"))
}

validateRawCounts <- function(rawData) {
  if (!inherits(rawData, "dgCMatrix")) {
    stop("Input 'raw' data must be of type dgCMatrix for this check")
  }
  x <- rawData@x
  if (anyNA(x)) {
    stop("Input 'raw' data contains NA!")
  }
  if (any(x < 0.0)) {
    stop("Input 'raw' data must contain only non negative integers.")
  }
  # integer check on nonzeros only
  if (any(x != round(x))) {
    stop("Input 'raw' data contains non integer numbers.")
  }
  return(TRUE)
}


#----------------- depreacetd functions --------------------

#' @details This is a deprecated function related to old `scCOTAN` objects. Use
#'   the more appropriate `Matrix::dspMatrix` type for similar functionality.
#'
#'   `mat2vec_rfast` converts a compacted symmetric matrix (that is an array)
#'   into a symmetric matrix.
#'
#' @param mat a square (possibly symmetric) matrix with all genes as row and
#'   column names.
#'
#' @returns `mat2vec_rfast` returns a `list` formed by two arrays:
#'   * `"genes"` with the unique gene names,
#'   * `"values"` with all the values.
#'
#' @examples
#' v <- list("genes" = paste0("gene_", c(1:9)), "values" = c(1:45))
#'
#' M <- vec2mat_rfast(v)
#' all.equal(rownames(M), v[["genes"]])
#' all.equal(colnames(M), v[["genes"]])
#'
#' genes <- paste0("gene_", sample.int(ncol(M), 3))
#'
#' m <- vec2mat_rfast(v, genes)
#' all.equal(rownames(m), v[["genes"]])
#' all.equal(colnames(m), genes)
#'
#' v2 <- mat2vec_rfast(M)
#' all.equal(v, v2)
#'
#' @importFrom Rfast lower_tri.assign
#' @importFrom Rfast upper_tri.assign
#' @importFrom Rfast upper_tri
#' @importFrom Rfast transpose
#'
#' @export
#'
#' @rdname COTAN_Legacy
#'
vec2mat_rfast <- function(x, genes = "all") {
  if (!isa(x, "list") || !identical(names(x), c("genes", "values"))) {
    stop("Passed 'x' argument is not a list ",
         "with 2 elements 'genes' and 'values'")
  }

  numGenes <- length(x[["genes"]])
  if (genes[[1L]] == "all") {
    m <- matrix(0.0, numGenes, numGenes)

    m <- lower_tri.assign(m, diag = TRUE, v = x[["values"]])
    m <- upper_tri.assign(m, v = upper_tri(transpose(m)))
    rownames(m) <- x[["genes"]]
    colnames(m) <- x[["genes"]]
  } else {
    m <- matrix(0.0, nrow = numGenes, ncol = length(genes))
    rownames(m) <- x[["genes"]]
    colnames(m) <- genes

    for (posGene in match(genes, x[["genes"]])) {
      tempArray <- x[["values"]][posGene]
      p <- 1L
      l <- numGenes
      s <- posGene
      while (p < (posGene)) {
        l <- l - 1L
        s <- s + l
        tempArray <- c(tempArray, x[["values"]][s])
        p <- p + 1L
      }
      if (posGene < numGenes) {
        #linear part
        startReadingPos <- 1L
        i <- 1L
        while (i < (posGene)) {
          startReadingPos <- startReadingPos + (numGenes - (i - 1L))
          i <- i + 1L
        }
        startReadingPos <- startReadingPos + 1L

        endReadingPos <- 0L
        for (i in (0L:(posGene - 1L))) {
          endReadingPos <- endReadingPos + (numGenes - i)
        }

        tempArray <-
          c(tempArray, x[["values"]][startReadingPos:endReadingPos])
      }
      m[, x[["genes"]][posGene]] <- tempArray
    }
  }
  return(m)
}

#' @details This is a deprecated function related to old `scCOTAN` objects. Use
#'   the more appropriate `Matrix::dspMatrix` type for similar functionality.
#'
#'   `vec2mat_rfast` converts a symmetric matrix into a compacted symmetric
#'   matrix. It will forcibly make its argument symmetric.
#'
#' @param x a `list` formed by two arrays: `genes` with the unique gene names
#'   and `values` with all the values.
#' @param genes an array with all wanted genes or the string `"all"`. When equal
#'   to `"all"` (the default), it recreates the entire matrix.
#'
#' @returns `vec2mat_rfast` returns the reconstructed symmetric matrix
#'
#' @importFrom Rfast lower_tri
#'
#' @export
#'
#' @rdname COTAN_Legacy
#'
mat2vec_rfast <- function(mat) {
  mat <- as.matrix(mat)

  if (dim(mat)[[1L]] != dim(mat)[[2L]]) {
    stop("The matrix is not square!")
  }

  v <- lower_tri(mat, diag = TRUE)
  return(list("genes" = rownames(mat), "values" = v))
}

## ----knitr options, echo = FALSE, include = FALSE-----------------------------
plotDev <- if (requireNamespace("ragg", quietly = TRUE)) {
  "ragg_png"
} else if (requireNamespace("Cairo", quietly = TRUE)) {
  "cairo_png"
} else {
  "png"
}

knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  fig.width = 7L,
  fig.height = 5L,
  dev = plotDev,
  fig.crop = FALSE,
  dpi = 100L
)

## ----preamble, message=FALSE, warning=FALSE-----------------------------------
library(COTAN)
library(zeallot)

# necessary to solve precedence of overloads
conflicted::conflict_prefer("%<-%", "zeallot")

# enable multi-processing (not on Windows)
prevOptState <- options(parallelly.fork.enable = TRUE)

## ----setup-and-log------------------------------------------------------------
dataDir <- file.path(tempdir(), "COTAN_vignette_data")
dir.create(dataDir, recursive = TRUE, showWarnings = FALSE)

print(dataDir)

outDir <- dataDir

# Log-level 2 was chosen to showcase better how the package works
# In normal usage a level of 0 or 1 is more appropriate
setLoggingLevel(2L)

# This file will contain all the logs produced by the package
# as if at the highest logging level
setLoggingFile(file.path(outDir, "vignette_genes_clustering.log"))

## ----download-data------------------------------------------------------------
GEO <- "GSM2861514"

dir.create(file.path(dataDir, GEO), showWarnings = FALSE)

datasetFileName <-
  file.path(dataDir, GEO, "GSM2861514_E175_All_Cells_DGE.txt.gz")


# retries up to 5 times to get the dataset
attempts <- 0L
maxAttempts <- 5L
ok <- FALSE

while (attempts < maxAttempts && !ok) {
  attempts <- attempts + 1L

  if (!file.exists(datasetFileName)) {
    res <- try(
      GEOquery::getGEOSuppFiles(
        GEO = GEO,
        makeDirectory = TRUE,
        baseDir = dataDir,
        filter_regex = base::basename(datasetFileName),
        fetch_files = TRUE
      ),
      silent = TRUE
    )
  }

  ok <- file.exists(datasetFileName)

  if (!ok && attempts < maxAttempts) {
    Sys.sleep(1)
  }
}

assertthat::assert_that(
  ok,
  msg = paste0(
    "Failed to retrieve file '", datasetFileName,
    "' after ", maxAttempts, " attempts."
  )
)

rawDataset <- read.csv(datasetFileName, sep = "\t", row.names = 1L)

print(dim(rawDataset))

## ----create-cotan-object------------------------------------------------------
cond <- "mouse_cortex_E17.5"

obj <- COTAN(raw = rawDataset)
obj <-
  initializeMetaDataset(
    obj,
    GEO = GEO,
    sequencingMethod = "Drop_seq",
    sampleCondition = cond
  )

logThis(paste0("Condition ", getMetadataElement(obj, datasetTags()[["cond"]])),
        logLevel = 1L)

## ----add-origin-to-the-cotan-object-------------------------------------------
# mark cells origin
data(vignette.cells.origin)
head(vignette.cells.origin, 18)

obj <- 
  addCondition(obj, condName = "origin", conditions = vignette.cells.origin)

rm(vignette.cells.origin)

## ----drop-low-quality-cells---------------------------------------------------
# use previously established results to determine
# which cells were dropped in the cleaning stage
data(vignette.split.clusters)

cellsToDrop <-
  getCells(obj)[!(getCells(obj) %in% names(vignette.split.clusters))]

obj <- dropGenesCells(obj, cells = cellsToDrop)

# Log the remaining number of cells

logThis(paste("n cells", getNumCells(obj)), logLevel = 1L)

table(getCondition(obj, condName = "origin"))

rm(vignette.split.clusters)

## ----calculate-and-store-coex-matrix------------------------------------------
obj <-
  proceedToCoex(
    obj,
    calcCoex = TRUE,
    optimizeForSpeed = TRUE,
    cores = 3L,
    deviceStr = "cuda"
  )

## ----contingency-tables-and-coex-for-gene-pair--------------------------------
cat("Contingency Tables:")
print(contingencyTables(obj, g1 = "Satb2", g2 = "Bcl11b"))

cat(paste("Corresponding COEX value:",
          getGenesCoex(obj, zeroDiagonal = FALSE)["Satb2", "Bcl11b"]))

## ----display-small-chunk-of-coex-matrix---------------------------------------
# Extract the whole matrix
coex <- getGenesCoex(obj, zeroDiagonal = FALSE)
coex[1000L:1005L, 1000L:1005L]

## ----get-coex-sub-matrix------------------------------------------------------
# For a partial matrix
coex_sm <- getGenesCoex(obj, genes = c("Satb2", "Bcl11b", "Fezf2"),
                        zeroDiagonal = FALSE)
coex_sm[2001:2010, ]

## ----calculate-and-store-gdi--------------------------------------------------
gdiDF <- calculateGDI(obj, cores = 3L)

# Show the most *differentially expressed* genes
perm <- order(gdiDF[["GDI"]], decreasing = TRUE)
head(gdiDF[perm, ], n = 10)

# This will store only the $GDI column
obj <- storeGDI(obj, genesGDI = gdiDF)

## ----genes-list-definition----------------------------------------------------
genesLists <- list(
  # Neural Progenitor Genes
  "NPGs" = c("Nes", "Vim", "Sox2", "Sox1", "Notch1", "Hes1", "Hes5", "Pax6"),
  # Pan Neural Genes
  "PNGs" = c("Map2", "Tubb3", "Neurod1", "Nefm", "Nefl", "Dcx", "Tbr1"),
  # House Keeping
  "hk"   = c("Calm1", "Cox6b1", "Ppia", "Rpl18", "Cox7c", "Erh", "H3f3a",
             "Taf1", "Taf2", "Gapdh", "Actb", "Golph3", "Zfr", "Sub1",
             "Tars", "Amacr")
)

## ----gdi-plot-with-marked-genes-----------------------------------------------
GDIPlot(obj, genes = genesLists, GDIThreshold = 1.40)

## ----save-cotan-obj, eval=FALSE-----------------------------------------------
# # saving the structure
# saveRDS(obj, file = file.path(outDir, paste0(cond, ".cotan.RDS")))

## ----coex-heatmap-plot-for-selected-genes-------------------------------------
plot(heatmapPlot(obj, genesLists = genesLists, sets = 1L:3L, cores = 3L))

## ----define-layers-specific-genes---------------------------------------------
layersGenes <- list(
  "L1"   = c("Reln",   "Lhx5"),
  "L2/3" = c("Cux1",   "Satb2"),
  "L4"   = c("Rorb",   "Sox5"),
  "L5/6" = c("Bcl11b", "Fezf2"),
  "Prog" = c("Hes1",    "Vim", "Dummy")
)

## ----coex-heatmap-plot-for-primary-marker-genes-------------------------------
layersMarkers <- c("Satb2", "Bcl11b", "Vim", "Hes1")

genesHeatmapPlot(
  obj,
  primaryMarkers = layersMarkers,
  pValueThreshold = 0.0001,
  symmetric = TRUE,
  cores = 3L
)

## ----coex-heatmap-plot-two-genes-sets, eval=FALSE, include=TRUE---------------
# genesHeatmapPlot(
#   obj,
#   primaryMarkers = c("Satb2", "Bcl11b", "Fezf2"),
#   secondaryMarkers = c("Gabra3", "Meg3", "Cux1", "Neurod6"),
#   pValueThreshold = 0.001,
#   symmetric = FALSE,
#   cores = 3L
# )

## ----establish-genes-clusters-------------------------------------------------
c(gSpace, eigPlot, pcaGenesClDF, treePlot) %<-%
  establishGenesClusters(
    obj,
    groupMarkers = layersGenes,
    numGenesPerMarker = 25L,
    kCuts = 5L
  )

plot(eigPlot)

## ----genes-tree-plot----------------------------------------------------------
plot(treePlot)

## ----genes-umap-plot----------------------------------------------------------
colSelection <- vapply(pcaGenesClDF, is.numeric, logical(1L))

genesUmapPl <-
  UMAPPlot(
    pcaGenesClDF[, colSelection, drop = FALSE],
    clusters = getColumnFromDF(pcaGenesClDF, "hclust"),
    elements = layersGenes,
    title = "Genes' clusters UMAP Plot",
    numNeighbors = 32L,
    minPointsDist = 0.25
  )

plot(genesUmapPl)

## ----final-clean-up-----------------------------------------------------------
if (file.exists(file.path(outDir, paste0(cond, ".cotan.RDS")))) {
  # delete file if it exists
  file.remove(file.path(outDir, paste0(cond, ".cotan.RDS")))
}
if (file.exists(file.path(outDir, paste0(cond, "_times.csv")))) {
  # delete file if it exists
  file.remove(file.path(outDir, paste0(cond, "_times.csv")))
}
if (dir.exists(file.path(outDir, cond))) {
  unlink(file.path(outDir, cond), recursive = TRUE)
}
# if (dir.exists(file.path(outDir, GEO))) {
#   unlink(file.path(outDir, GEO), recursive = TRUE)
# }

# stop logging to file
setLoggingFile("")
file.remove(file.path(outDir, "vignette_genes_clustering.log"))

options(prevOptState)

## ----closure------------------------------------------------------------------
Sys.time()

sessionInfo()

#' @details `geneSetEnrichment()` returns a cumulative score of enrichment in a
#'   *cluster* over a gene set. In formulae it calculates
#'   \eqn{\frac{1}{n}\sum_i(1-e^{-\theta X_i})}, where the \eqn{X_i} are the
#'   positive values from [DEAOnClusters()] and \eqn{\theta = -\frac{1}{0.1}
#'   \ln(0.25)}
#'
#' @param clustersCoex the `COEX` `data.frame`
#' @param groupMarkers an optional named `list` with an element for each group
#'   comprised of one or more marker genes
#'
#' @returns `geneSetEnrichment()` returns a `data.frame` with the cumulative
#'   score
#'
#' @export
#'
#' @importFrom rlang set_names
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom stringr str_remove
#' @importFrom stringr fixed
#'
#' @rdname HandlingClusterizations
#'
geneSetEnrichment <- function(clustersCoex, groupMarkers = list()) {
  assert_that(isa(groupMarkers, "list"))

  # It might be possible that the column names have the old extra
  # prefix 'cl.'. It will be remove in such cases.
  clTagsMap <- set_names(colnames(clustersCoex),
                         str_remove(colnames(clustersCoex), fixed("cl.")))
  clustersTags <- names(clTagsMap)

  gDf <- as.data.frame(matrix(nrow = length(groupMarkers),
                              ncol = ncol(clustersCoex) + 2L))

  colnames(gDf) <- c(clustersTags, "N. detected", "N. total")
  rownames(gDf) <- names(groupMarkers)

  # TODO: add comment on this constant in the @details above!
  theta <- -1.0 / 0.1 * log(0.25) # ~ 13.86294

  # not_assigned_clusters <- NA
  for (groupName in names(groupMarkers)) {
    genes <- unlist(groupMarkers[[groupName]])

    ex <- clustersCoex[rownames(clustersCoex) %in% genes, , drop = FALSE]
    numDetected <- nrow(ex)

    logThis(paste0("In group ", groupName, " there are ", numDetected,
                   " detected over ", length(genes), " genes"), logLevel = 2L)

    # drop reductions
    ex[ex < 0.0 & !is.na(ex)] <- 0.0
    ex <- 1.0 - exp(-theta * ex)

    for (cl in clustersTags) {
      gDf[groupName, cl] <-
        sum(ex[, clTagsMap[cl], drop = TRUE], na.rm = TRUE) / length(genes)
    }

    gDf[groupName, "N. detected"] <- numDetected
    gDf[groupName, "N. total"] <- length(genes)
  }

  return(gDf)
}

# Creates the files to be reloaded by the tests for comparisons

# nolint start: object_name_linter
outputTestDatasetCreation <-
  function(testsDir = file.path("tests", "testthat")) {
  utils::data("test.dataset", package = "COTAN")
  prevOptState <- options(parallelly.fork.enable = TRUE)
  setLoggingLevel(3L)

  obj <- COTAN(raw = test.dataset)
  obj <- initializeMetaDataset(objCOTAN = obj, GEO = " ",
                               sequencingMethod = "artificial",
                               sampleCondition = "test")

  obj <- proceedToCoex(objCOTAN = obj, cores = 6L, saveObj = FALSE)

  if (FALSE) {
    saveRDS(obj, file = file.path(testsDir, "test.COTAN.RDS"))
  }

  cells.names.test <-
    getCells(objCOTAN = obj)[c(1L:10L, 591L:610L, 991L:1000L)]
  genes.names.test <-
    getGenes(objCOTAN = obj)[c(131L:140L, 291L:310L, 591L: 600L)]
  saveRDS(cells.names.test, file.path(testsDir, "cells.names.test.RDS"))
  saveRDS(genes.names.test, file.path(testsDir, "genes.names.test.RDS"))

  pcaRaw <- runPCA(x = getRawData(objCOTAN = obj), rank = 10L,
                   BSPARAM = IrlbaParam(), get.rotation = FALSE)[["x"]]

  pca.raw.test <- pcaRaw[genes.names.test, ]
  saveRDS(pca.raw.test, file.path(testsDir, "pca.raw.test.RDS"))

  dispersion.test <- getDispersion(objCOTAN = obj)[genes.names.test]
  saveRDS(dispersion.test, file.path(testsDir, "dispersion.test.RDS"))

  raw.norm.test <-
    getNuNormData(objCOTAN = obj)[genes.names.test, cells.names.test]
  saveRDS(raw.norm.test, file.path(testsDir, "raw.norm.test.RDS"))

  coex.test <-
    getGenesCoex(objCOTAN = obj, genes = genes.names.test, zeroDiagonal = FALSE)
  saveRDS(coex.test, file.path(testsDir, "coex.test.RDS"))

  lambda.test <- getLambda(objCOTAN = obj)[genes.names.test]
  saveRDS(lambda.test, file.path(testsDir, "lambda.test.RDS"))

  GDI.test <- calculateGDI(objCOTAN = obj)
  GDI.test <- GDI.test[genes.names.test, ]
  saveRDS(GDI.test, file.path(testsDir, "GDI.test.RDS"))

  nu.test <- getNu(objCOTAN = obj)[cells.names.test]
  saveRDS(nu.test, file.path(testsDir, "nu.test.RDS"))

  pvalues.test <- calculatePValue(objCOTAN = obj,
                                  geneSubsetCol = genes.names.test,
                                  geneSubsetRow = genes.names.test)
  saveRDS(pvalues.test, file.path(testsDir, "pvalues.test.RDS"))

  groupMarkers <- list(G1 = c("g-000010", "g-000020", "g-000138"),
                       G2 = c("g-000300", "g-000330", "g-000660"),
                       G3 = c("g-000510", "g-000530", "g-000550",
                              "g-000570", "g-000590"))

  gcsData <- genesCoexSpace(objCOTAN = obj,
                            primaryMarkers = unlist(groupMarkers),
                            numGenesPerMarker = 11L)

  genes.coex.space.test <- gcsData[["GCS"]]
  saveRDS(genes.coex.space.test,
          file.path(testsDir, "genes.coex.space.test.RDS"))

  genesClustersData <-
    establishGenesClusters(objCOTAN = obj,
                           groupMarkers = groupMarkers,
                           numGenesPerMarker = 11L,
                           kCuts = 6L, distance = "cosine",
                           hclustMethod = "ward.D2")

  pca.genes.clusters.test <- genesClustersData[["pca_clusters"]]
  saveRDS(pca.genes.clusters.test,
          file.path(testsDir, "pca.genes.clusters.test.RDS"))

  # Make it a less strict check as it is only for testing
  checker <- new("AdvancedGDIUniformityCheck")
  checker <- shiftCheckerThresholds(checker, 0.1)

  initialResolution <- 1.3
  splitData <- cellsUniformClustering(objCOTAN = obj,
                                      checker = checker,
                                      initialResolution = initialResolution,
                                      useCoexEigen = TRUE,
                                      dataMethod = "LL",
                                      numReducedComp = 50L,
                                      cores = 6L, optimizeForSpeed = TRUE,
                                      deviceStr = "cuda", saveObj = FALSE)

  split.clusters.test <- splitData[["clusters"]]
  saveRDS(split.clusters.test,
          file = file.path(testsDir, "split.clusters.test.RDS"))

  test.dataset.clusters1 <- split.clusters.test
  save(test.dataset.clusters1, compress = TRUE,
       file = file.path("data", "test.dataset.clusters1.rda"))

  obj <- addClusterization(objCOTAN = obj,
                           clName = "split",
                           clusters = splitData[["clusters"]],
                           coexDF = splitData[["coex"]])

  coex.clusters.test <- splitData[["coex"]][genes.names.test, ]
  saveRDS(coex.clusters.test, file.path(testsDir, "coex.clusters.test.RDS"))

  pvalDF <- pValueFromDEA(splitData[["coex"]],
                          getNumCells(objCOTAN = obj),
                          adjustmentMethod = "none")

  pvalues.clusters.test <- pvalDF[genes.names.test, ]
  saveRDS(pvalues.clusters.test,
          file.path(testsDir, "pvalues.clusters.test.RDS"))

  mergedData <- mergeUniformCellsClusters(objCOTAN = obj,
                                          clusters = splitData[["clusters"]],
                                          checkers = checker,
                                          batchSize = 1L,
                                          cores = 6L,
                                          distance = "cosine",
                                          hclustMethod = "ward.D2",
                                          saveObj = FALSE)

  merge.clusters.test <- mergedData[["clusters"]]
  saveRDS(merge.clusters.test,
          file = file.path(testsDir, "merge.clusters.test.RDS"))

  test.dataset.clusters2 <- merge.clusters.test
  save(test.dataset.clusters2, compress = TRUE,
       file = file.path("data", "test.dataset.clusters2.rda"))

  obj <- addClusterization(objCOTAN = obj,
                           clName = "merge",
                           clusters = mergedData[["clusters"]],
                           coexDF = mergedData[["coex"]])

  options(prevOptState)
}
# nolint end

## ----- Cells size plot -----

#' @details `cellSizePlot()` plots the raw library size for each cell and
#'   sample.
#'
#' @param objCOTAN a `COTAN` object
#' @param condName The name of a condition in the `COTAN` object to further
#'   separate the cells in more sub-groups. When no condition is given it is
#'   assumed to be the same for all cells (no further sub-divisions)
#' @param conditions The *conditions* to use. If given it will take precedence
#'   on the one indicated by `condName` that will only indicate the relevant
#'   column name in the returned `data.frame`
#'
#' @returns `cellSizePlot()` returns a `half-violin-boxplot` object
#'
#' @importFrom ggplot2 ggplot
#' @importFrom ggplot2 geom_point
#' @importFrom ggplot2 position_jitter
#' @importFrom ggplot2 geom_boxplot
#' @importFrom ggplot2 labs
#' @importFrom ggplot2 scale_y_continuous
#' @importFrom ggplot2 coord_cartesian
#' @importFrom ggplot2 after_stat
#'
#' @importFrom ggdist stat_slabinterval
#'
#' @export
#'
#' @examples
#' lsPlot <- cellSizePlot(objCOTAN)
#' plot(lsPlot)
#'
#' @rdname RawDataCleaning
#'
cellSizePlot <- function(objCOTAN, condName = "", conditions = NULL) {
  sizes <- sort(getCellsSize(objCOTAN))
  sizes <- as.data.frame(sizes)

  sizes <- setColumnInDF(sizes, colToSet = seq_len(nrow(sizes)), colName = "n")

  c(., conditions) %<-%
    normalizeNameAndLabels(objCOTAN, name = condName,
                           labels = conditions, isCond = TRUE)
  assert_that(!is_empty(conditions))

  sizes <- setColumnInDF(sizes, conditions[rownames(sizes)], colName = "sample")

  csPl <-
    ggplot(sizes, aes(x = sample, y = sizes, fill = sample)) +
    stat_slabinterval(
      aes(thickness = after_stat(pdf)),
      side = "right",                   # draw only the right half
      show_point = FALSE,               # slab only (no dot)
      show_interval = FALSE,            # slab only (no interval)
      position = position_nudge(x = 0.15),
      normalize = "groups",
      adjust = 2.0,
      trim = TRUE,
      alpha = 0.5,
      slab_colour = "black",      # outline color
      slab_linewidth = 0.6,       # outline width (ggplot2 ≥ 3.4)
      slab_alpha = 0.5            # fill alpha only; leaves stroke opaque
    ) +
    geom_point(
      position = position_jitter(width = 0.1),
      size = 0.4, color = "black", alpha = 0.5
    ) +
    geom_boxplot(
      aes(x = sample, y = sizes, fill = sample),
      outlier.shape = NA, alpha = 0.8, width = 0.15,
      colour = "gray65", size = 0.6
    ) +
    labs(
      title = "Cell library size",
      y = "Size (read number)",
      x = ""
    ) +
    coord_cartesian(ylim = c(0.0, max(sizes[["sizes"]]))) +
    plotTheme("size-plot")

  return(csPl)
}


## ----- Genes size plot -----

#' @details `genesSizePlot()` plots the raw gene number (reads > 0) for each
#'   cell and sample
#'
#' @param objCOTAN a `COTAN` object
#' @param condName The name of a condition in the `COTAN` object to further
#'   separate the cells in more sub-groups. When no condition is given it is
#'   assumed to be the same for all cells (no further sub-divisions)
#' @param conditions The *conditions* to use. If given it will take precedence
#'   on the one indicated by `condName` that will only indicate the relevant
#'   column name in the returned `data.frame`
#'
#' @returns `genesSizePlot()` returns a `half-violin-boxplot` object
#'
#' @importFrom ggplot2 ggplot
#' @importFrom ggplot2 position_nudge
#' @importFrom ggplot2 geom_point
#' @importFrom ggplot2 position_jitter
#' @importFrom ggplot2 geom_boxplot
#' @importFrom ggplot2 aes
#' @importFrom ggplot2 labs
#' @importFrom ggplot2 scale_y_continuous
#' @importFrom ggplot2 coord_cartesian
#' @importFrom ggplot2 after_stat
#'
#' @importFrom ggdist stat_slabinterval
#'
#' @export
#'
#' @examples
#' gsPlot <- genesSizePlot(objCOTAN)
#' plot(gsPlot)
#'
#' @rdname RawDataCleaning
#'
genesSizePlot <- function(objCOTAN, condName = "", conditions = NULL) {
  sizes <- sort(getNumExpressedGenes(objCOTAN))
  sizes <- as.data.frame(sizes)

  sizes <- setColumnInDF(sizes, seq_len(nrow(sizes)), colName = "n")

  c(., conditions) %<-%
    normalizeNameAndLabels(objCOTAN, name = condName,
                           labels = conditions, isCond = TRUE)
  assert_that(!is_empty(conditions))

  sizes <- setColumnInDF(sizes, conditions[rownames(sizes)], colName = "sample")

  gsPl <-
    ggplot(sizes, aes(x = sample, y = sizes, fill = sample)) +
    stat_slabinterval(
      aes(thickness = after_stat(pdf)),
      side = "right",                 # half-violin to the right
      show_point = FALSE,             # slab only
      show_interval = FALSE,          # no intervals
      position = position_nudge(x = 0.15),
      normalize = "groups",
      adjust = 2.0,
      trim = TRUE,
      alpha = 0.5,
      slab_colour = "black",      # outline color
      slab_linewidth = 0.6,       # outline width (ggplot2 ≥ 3.4)
      slab_alpha = 0.5            # fill alpha only; leaves stroke opaque
    ) +
    geom_point(
      position = position_jitter(width = 0.1),
      size = 0.4, color = "black", alpha = 0.5
    ) +
    geom_boxplot(
      aes(x = sample, y = sizes, fill = sample),
      outlier.shape = NA, alpha = 0.8, width = 0.15,
      colour = "gray65", size = 0.6
    ) +
    labs(
      title = "Detected gene number",
      y = "Size (number of genes)",
      x = ""
    ) +
    coord_cartesian(ylim = c(0.0, max(sizes[["sizes"]]))) +
    plotTheme("size-plot")

  return(gsPl)
}

#' @title emptySparseMatrix
#'
#' @description Useful to default initialize `COTAN` slots
#'
#' @returns an empty matrix of type `dgCMatrix`
#'
#' @importClassesFrom Matrix dgCMatrix
#'
#' @noRd
#'
emptySparseMatrix <- function() {
  return(as(matrix(0.0, 0L, 0L), "dgCMatrix"))
}

#' @title emptySymmetricMatrix
#'
#' @description Useful to default initialize `COTAN` slots
#'
#' @returns an empty matrix of type `dspMatrix`
#'
#' @importClassesFrom Matrix dspMatrix
#'
#' @noRd
#'
emptySymmetricMatrix <- function() {
  return(as(matrix(0.0, 0L, 0L), "packedMatrix"))
}

#---------- COTAN class --------------

#' @title The `COTAN` class
#'
#' @description Definition of the `COTAN` class
#'
#' @return A \code{\linkS4class{COTAN}} object.
#'
#' @slot raw `dgCMatrix` - the raw `UMI` count matrix \eqn{n \times m} (gene
#'   number × cell number)
#' @slot genesCoex `dspMatrix` - the correlation of `COTAN` between genes,
#'   \eqn{n \times n}
#' @slot cellsCoex `dspMatrix` - the correlation of `COTAN` between cells,
#'   \eqn{m \times m}
#' @slot metaDataset `data.frame`
#' @slot metaCells `data.frame`
#' @slot clustersCoex a `list` of `COEX` `data.frames` for each clustering in
#'   the `metaCells`
#'
#' @importFrom rlang is_empty
#'
#' @importFrom methods validObject
#'
#' @importClassesFrom Matrix dgCMatrix
#' @importClassesFrom Matrix dspMatrix
#'
setClass(
  "COTAN",
  slots = c(
    raw          = "dgCMatrix",
    genesCoex    = "dspMatrix",
    cellsCoex    = "dspMatrix",
    metaDataset  = "data.frame",
    metaGenes    = "data.frame",
    metaCells    = "data.frame",
    clustersCoex = "list" # of data.frames
  ),
  prototype = list(
    raw          = emptySparseMatrix(),
    genesCoex    = emptySymmetricMatrix(),
    cellsCoex    = emptySymmetricMatrix(),
    metaDataset  = data.frame(),
    metaGenes    = data.frame(),
    metaCells    = data.frame(),
    clustersCoex = vector(mode = "list")
  ),
  validity = function(object) {
    if (is_empty(object@raw)) {
      stop("'raw' is empty")
    }

    numGenes <- nrow(object@raw)
    numCells <- ncol(object@raw)

    if (length(unique(rownames(object@raw))) != numGenes) {
      stop("Input 'raw' data must have unique row names")
    }
    if (length(unique(colnames(object@raw))) != numCells) {
      stop("Input 'raw' data must have unique column names")
    }

    if (!is_empty(object@genesCoex)) {
      if (!isa(object@genesCoex, "dspMatrix")) {
        stop("'genesCoex' must be of type 'dspMatrix.")
      }
      if (nrow(object@genesCoex) != numGenes) {
        stop("'genesCoex' sizes should match the number of genes.")
      }
    }

    if (!is_empty(object@cellsCoex)) {
      if (!isa(object@cellsCoex, "dspMatrix")) {
        stop("'cellsCoex' must be of type 'dspMatrix.")
      }
      if (nrow(object@cellsCoex) != numCells) {
        stop("'cellsCoex' sizes should match the number of cells.")
      }
    }

    # metaDataset has no required fields as of now

    if (!is_empty(object@metaGenes) && nrow(object@metaGenes) != numGenes) {
      stop("The number of rows [", nrow(object@metaGenes), "] of 'metaGenes'",
           " must be the same as the number of rows [", numGenes, "] of 'raw'",
           " when not empty.")
    }

    if (!is_empty(object@metaCells) && nrow(object@metaCells) != numCells) {
      stop("The number of rows [", nrow(object@metaCells), "] of 'metaCells'",
           " must be the same as the number of cols [", numCells, "] of 'raw'",
           " when not empty.")
    }

    for (name in names(object@clustersCoex)) {
      if (!startsWith(name, "CL_")) {
        stop("The clusterization name '", name, "' does not start",
             " with 'CL_' as per conventions")
      }
      if (!name %in% colnames(object@metaCells)) {
        stop("The clusterization name '", name, "', found in 'clustersCoex',",
             " must be one of the column names of 'metaCells'.")
      }
      coexDF <- object@clustersCoex[[name]]
      if (!is_empty(coexDF)) {
        if (!isa(coexDF, "data.frame")) {
          stop("'clusterCoex' is supposedly composed of data.frames.",
               " A '", class(coexDF), "' was given instead.")
        }
        if (!identical(rownames(coexDF), rownames(object@raw))) {
          stop("The row-names of the non-empty data.frames in 'clustersCoex'",
               " must be the same as those of the raw data.")
        }
        if (!all(colnames(coexDF) %in% object@metaCells[[name]])) {
          badClustersTags <- colnames(coexDF)[!colnames(coexDF) %in%
                                                object@metaCells[[name]]]
          stop("The column names of the data.frames in 'clustersCoex' must be",
               " a subset of the tags in the clusterization.",
               " The data.frame for clusterization '", name, "' does not",
               " satisfy this condition with the names [",
               paste(badClustersTags, collapse = ","), "] vs cluster tags [",
               paste(unique(object@metaCells[[name]]), collapse = ","), "].")
        }
      }
    }

    for (name in colnames(object@metaCells)) {
      if (startsWith(name, "CL_")) {
        if (!inherits(object@metaCells[[name]], "factor")) {
          stop("Clusterization '", name, "' must be a factor.")
        }
        if (!name %in% names(object@clustersCoex)) {
          stop("Clusterization '", name, "' has no entry in 'clustersCoex'.")
        }
      } else if (startsWith(name, "COND_")) {
        if (!inherits(object@metaCells[[name]], "factor")) {
          stop("Condition '", name, "' must be a factor.")
        }
      }
    }

    return(TRUE)
  }
) #end class COTAN


#'
#' @title `COTAN` shortcuts
#'
#' @description These functions create a [COTAN-class] object and/or also run
#'   all the necessary steps until the genes' `COEX` matrix is calculated.
#'
#' @name COTAN_ObjectCreation
NULL

#' @details Constructor of the class `COTAN`
#'
#' @param raw any object that can be converted to a matrix, but with row (genes)
#'   and column (cells) names
#'
#' @returns a `COTAN` object
#'
#' @importFrom methods new
#'
#' @importFrom assertthat assert_that
#'
#' @importClassesFrom Matrix dgCMatrix
#'
#' @export
#'
#' @examples
#' data("test.dataset")
#' obj <- COTAN(raw = test.dataset)
#'
#' @rdname COTAN_ObjectCreation
#'
COTAN <- function(raw = "ANY") {
  raw <- coerceToDgCMatrix(raw)

  assert_that(!is_empty(rownames(raw)), !is_empty(colnames(raw)),
              msg = "Inputs must have both row and column names!")

  validateRawCounts(raw)

  new("COTAN", raw = raw)
}

#'
#' @title Handle legacy `scCOTAN`-class and related symmetric matrix <-> vector
#' conversions
#'
#' @description A class and some functions related to the `V1` version of the
#'   `COTAN` package
#'
#' @name COTAN_Legacy
NULL


#' @details Define the legacy `scCOTAN`-class
#'
#' @slot raw `ANY`. To store the raw data matrix
#' @slot raw.norm `ANY`. To store the raw data matrix divided for the cell
#'   efficiency estimated (nu)
#' @slot coex `ANY`. The `COEX` matrix
#' @slot nu `vector`.
#' @slot lambda `vector`.
#' @slot a `vector`.
#' @slot hk `vector`.
#' @slot n_cells `numeric`.
#' @slot meta `data.frame`.
#' @slot yes_yes `ANY`. Unused and deprecated. Kept for backward compatibility
#'   only
#' @slot clusters `vector`.
#' @slot cluster_data `data.frame`.
#'
#' @returns a `scCOTAN` object
#'
#' @export
#'
#' @rdname COTAN_Legacy
#'
setClass(
  "scCOTAN",
  slots = c(
    raw = "ANY",
    raw.norm = "ANY",
    coex = "ANY",
    nu = "vector",
    lambda = "vector",
    a = "vector",
    hk = "vector",
    n_cells = "numeric",
    meta = "data.frame",
    yes_yes = "ANY", # Unused and deprecated: for backward compatibility only
    clusters = "vector",
    cluster_data = "data.frame"
  )
)


#' @description Helper function to be shared by coerce() and replace()
#'
#' @param a `scCOTAN` object
#'
#' @returns a `list` with all non trivially converted slots of the equivalent
#'   `COTAN` class
#'
#' @importFrom rlang is_empty
#'
#' @importFrom stringr str_remove
#' @importFrom stringr fixed
#'
#' @importClassesFrom Matrix dgCMatrix
#' @importClassesFrom Matrix dspMatrix
#'
#' @importFrom Matrix forceSymmetric
#' @importFrom Matrix pack
#'
#' @noRd
#'
getCOTANSlots <- function(from) {
  if (!is_empty(from@yes_yes)) {
    warning("scCOTAN as COTAN: non-empty yes_yes member found -",
            " Will be discarded!",
            call. = FALSE)
  }

  if (from@n_cells != ncol(from@raw)) {
    warning("scCOTAN as COTAN: n_cells member misaligned",
            " with raw matrix member - Will be ignored!",
            call. = FALSE)
  }

  if (is_empty(from@raw)) {
    rawM <- emptySparseMatrix()
  } else if (isa(from@raw, "dgCMatrix")) {
    rawM <- from@raw
  } else if (is.data.frame(from@raw)) {
    rawM <- as(as.matrix(from@raw), "dgCMatrix")
  } else {
    rawM <- as(as(from@raw, "Matrix"), "dgCMatrix")
  }

  genesCoex <- emptySymmetricMatrix()
  if (!is_empty(from@coex)) {
    if (isa(from@coex, "list")) {
      genesCoex <- vec2mat_rfast(from@coex)
    } else if (isa(from@coex, "dMatrix")) {
      genesCoex <- as.matrix(from@coex)
    } else if (isa(from@coex, "matrix")) {
      genesCoex <- from@coex
    } else {
      warning("scCOTAN as COTAN: unsupported COEX type '", class(from@coex),
              "' - genes' COEX will be discarded!", call. = FALSE)
      genesCoex <- emptySymmetricMatrix()
    }
    # now 'COEX' is of type 'matrix'
    genesCoex <- pack(forceSymmetric(genesCoex))
  }

  cellsCoex <- emptySymmetricMatrix()

  metaGenes <- data.frame()

  if (!is_empty(from@hk)) {
    metaGenes <- setColumnInDF(metaGenes, rownames(from@raw) %in% from@hk,
                               "feGenes", rownames(from@raw))
  }

  if (!is_empty(from@lambda)) {
    metaGenes <- setColumnInDF(metaGenes, from@lambda,
                               "lambda", rownames(from@raw))
  }

  if (!is_empty(from@a)) {
    metaGenes <- setColumnInDF(metaGenes, from@a,
                               "dispersion", rownames(from@raw))
  }

  metaCells <- data.frame()

  if (!is_empty(from@nu)) {
    metaCells <- setColumnInDF(metaCells, from@nu,
                               "nu", colnames(from@raw))
  }

  clustersCoex <- vector(mode = "list")

  hasClusters <- !is_empty(from@clusters) && !all(is.na(from@clusters))
  if (hasClusters) {
    metaCells <- setColumnInDF(metaCells, factor(from@clusters),
                               "CL_clusters", colnames(from@raw))
  }

  if (TRUE) {
    clusterData <- from@cluster_data

    if (!hasClusters && !is_empty(clusterData)) {
      warning("scCOTAN as COTAN: cannot have 'cluster_data' along",
              " empty 'clusters' - genes' COEX will be discarded!",
              call. = FALSE)
      clusterData <- data.frame()
    }

    if (!is_empty(clusterData) &&
          !all(rownames(clusterData) %in% rownames(from@raw))) {
      warning("scCOTAN as COTAN: 'cluster_data' refers to unknown genes",
              " - clusters' COEX will be discarded!", call. = FALSE)
      clusterData <- data.frame()
    }

    if (!is_empty(clusterData)) {
      if (!all(colnames(clusterData) %in% from@clusters)) {
        # It might be possible that the column names have the old extra
        # prefix 'cl.'. It will be remove in such cases.
        colnames(clusterData) <- str_remove(colnames(clusterData),
                                            pattern = fixed("cl."))
      }

      if (!all(colnames(clusterData) %in% from@clusters)) {
        warning("scCOTAN as COTAN: 'cluster_data' refers to unknown",
                " clusters - clusters' COEX will be discarded!",
                call. = FALSE)
        clusterData <- data.frame()
      }
    }

    if (!is_empty(clusterData) &&
          !all(rownames(from@raw) %in% union(rownames(clusterData), from@hk))) {
      warning("scCOTAN as COTAN: 'cluster_data' has no information",
              " on some genes that are not fully-expressed",
              " - clusters' COEX will be discarded!", call. = FALSE)
      clusterData <- data.frame()
    }

    if (!is_empty(clusterData)) {
      missingGenes <- setdiff(rownames(from@raw), rownames(clusterData))
      if (!is_empty(missingGenes)) {
        # missing genes are fully-expressed thus have all zero COEX!
        missingData <- matrix(0.0, nrow = length(missingGenes),
                              ncol = ncol(clusterData),
                              dimnames = c(missingGenes, colnames(clusterData)))
        clusterData <- rbind(clusterData, as.data.frame(missingData))
        # reorder the rows to match original data
        clusterData <- clusterData[rownames(from@raw)]
      }
      clustersCoex <- list(CL_clusters = clusterData)
    } else if (hasClusters) {
      # keep aligned
      clustersCoex <- list("CL_clusters" = data.frame())
    }
  }

  return(list(rawM, genesCoex, cellsCoex, metaGenes, metaCells, clustersCoex))
}

#' @details Automatically converts an object from class `scCOTAN` into `COTAN`
#'
#' @importFrom zeallot %<-%
#' @importFrom zeallot %->%
#'
#' @importFrom methods setIs
#' @importFrom methods new
#'
#' @name scCotan_coerce_to_COTAN
#' @rdname COTAN_Legacy
#'
setIs(
  "scCOTAN",
  "COTAN",
  coerce = function(from) {
    c(raw, genesCoex, cellsCoex,
      metaGenes, metaCells, clustersCoex) %<-% getCOTANSlots(from)

      new("COTAN",
          raw          = raw,
          genesCoex    = genesCoex,
          cellsCoex    = cellsCoex,
          metaDataset  = from@meta,
          metaGenes    = metaGenes,
          metaCells    = metaCells,
          clustersCoex = clustersCoex)
  },
  # 'from' arg-name is convention: it is actually a destination!
  replace = function(from, value) {
    c(raw, genesCoex, cellsCoex,
      metaGenes, metaCells, clustersCoex) %<-% getCOTANSlots(value)

    # Update the existing scCOTAN object in place
    from@raw          <- raw
    from@genesCoex    <- genesCoex
    from@cellsCoex    <- cellsCoex
    from@metaDataset  <- value@meta
    from@metaGenes    <- metaGenes
    from@metaCells    <- metaCells
    from@clustersCoex <- clustersCoex

    # Return the modified object
    return(from)
  })


#'
#' @description Helper function to be shared by coerce() and replace()
#'
#' @param a `COTAN` object
#'
#' @returns a `list` with all non trivially converted slots of the equivalent
#'   `scCOTAN` class
#'
#' @importFrom rlang is_empty
#' @importFrom rlang set_names
#'
#' @importClassesFrom Matrix dgCMatrix
#' @importClassesFrom Matrix dspMatrix
#'
#' @importFrom Matrix forceSymmetric
#' @importFrom Matrix pack
#'
#' @noRd
#'
getScCOTANSlots <- function(from) {
  lambda <- vector(mode = "numeric")
  if (!is_empty(from@metaGenes[["lambda"]])) {
    lambda <- set_names(from@metaGenes[["lambda"]],
                        rownames(from@metaGenes))
  }

  a <- vector(mode = "numeric")
  if (!is_empty(from@metaGenes[["dispersion"]])) {
    a <- set_names(from@metaGenes[["dispersion"]],
                   rownames(from@metaGenes))
  }

  nu <- vector(mode = "numeric")
  if (!is_empty(from@metaCells[["nu"]])) {
    nu <- set_names(from@metaCells[["nu"]], rownames(from@metaCells))
  }

  hk <- vector(mode = "character")
  if (!is_empty(from@metaGenes[["feGenes"]])) {
    hk <- rownames(from@raw)[from@metaGenes[["feGenes"]]]
  }

  rawNorm <- emptySparseMatrix()
  if (!is_empty(nu)) {
    rawNorm <- t(t(from@raw) * (1.0 / nu))
  }

  if (!is_empty(from@clustersCoex)) {
    if (length(from@clustersCoex) > 1L) {
      warning("COTAN as scCOTAN: more than one clusterization found:",
              "picking up the last one as likely to be the most relevant")
    }
    clName <- names(from@clustersCoex)[length(from@clustersCoex)]
    clusterData <- from@clustersCoex[[clName]]
  } else {
    clName <- "CL_clusters"
    clusterData <- data.frame()
  }

  if (!is_empty(from@metaCells[[clName]])) {
    clusters <- from@metaCells[[clName]]
    clusters <- set_names(levels(clusters)[clusters], rownames(from@metaCells))
  } else {
    # ensure non-empty vector
    clusters <- set_names(rep(NA, ncol(from@raw)), colnames(from@raw))
  }

  if (!is_empty(from@cellsCoex)) {
    warning("COTAN as scCOTAN: 'cellsCoex' is not empty:",
            " will be lost in conversion")
  }

  return(list(rawNorm, nu, lambda, a, hk, clusters, clusterData))
}

#' @details Explicitly converts an object from class `COTAN` into `scCOTAN`
#'
#' @importFrom zeallot %<-%
#' @importFrom zeallot %->%
#'
#' @importFrom methods as
#' @importFrom methods setAs
#' @importFrom methods new
#'
#' @name COTAN_coerce_to_scCOTAN
#' @rdname COTAN_Legacy
#'
setAs(
  "COTAN",
  "scCOTAN",
  function(from) {
    c(rawNorm, nu, lambda, a,
      hk, clusters, clusterData) %<-% getScCOTANSlots(from)

      new("scCOTAN",
          raw          = from@raw,
          raw.norm     = rawNorm,
          coex         = from@genesCoex,
          nu           = nu,
          lambda       = lambda,
          a            = a,
          hk           = hk,
          n_cells      = ncol(from@raw),
          meta         = from@metaDataset,
          clusters     = clusters,
          cluster_data = clusterData)
  },
  # 'from' arg-name is convention: it is actually a destination!
  replace = function(from, value) {
    # Extract the slots needed for updating the scCOTAN object
    c(rawNorm, nu, lambda, a,
      hk, clusters, clusterData) %<-% getScCOTANSlots(value)

    # Update the existing scCOTAN object in place
    from@raw          <- value@raw
    from@raw.norm     <- rawNorm
    from@coex         <- value@genesCoex
    from@nu           <- nu
    from@lambda       <- lambda
    from@a            <- a
    from@hk           <- hk
    from@n_cells      <- ncol(value@raw)
    from@meta         <- value@metaDataset
    from@clusters     <- clusters
    from@cluster_data <- clusterData

    # Return the modified object
    return(from)
  })


#---------- Transcript Uniformity Check --------------

#' @title Definition of the **Transcript Uniformity Checker** classes
#'
#' @description A hierarchy of classes to specify the method for checking
#'   whether a **cluster** has the *Uniform Transcript* property. It also
#'   doubles as result object.
#'
#' @name UniformTranscriptCheckers
NULL

#' @details `BaseUniformityCheck` is the base class of the check methods
#'
#' @slot isUniform Logical. Output. The result of the check
#' @slot clusterSize Integer. Output. The number of cells in the checked
#'   cluster. When zero implies no check has been run yet
#'
#' @importFrom rlang is_logical
#' @importFrom rlang is_integer
#'
#' @rdname UniformTranscriptCheckers
#'
setClass(
  "BaseUniformityCheck",
  slots = c(
    isUniform = "logical",
    clusterSize = "integer"
  ),
  prototype = list(
    isUniform   = FALSE,
    clusterSize = 0L
  ),
  validity = function(object) {
    if (!is_logical(object@isUniform, n = 1L)) {
      stop("Given 'isUniform' data must be a Boolean")
    }
    if (!is_integer(object@clusterSize, n = 1L) || object@clusterSize < 0L) {
      stop("Given 'clusterSize' data must be a positive number")
    }
    return(TRUE)
  }
) # end Base Uniformity Check


#' @details `GDICheck` represents a single unit check using `GDI` data. It
#'   defaults to an *above* check with threshold \eqn{1.4} and ratio \eqn{1\%}
#'
#' @slot isCheckAbove Logical. Determines how to compare quantiles against given
#'   thresholds. It is deemed passed if the relevant quantile is above/below the
#'   given threshold
#' @slot GDIThreshold Numeric. The level of `GDI` beyond which the **cluster**
#'   is deemed not uniform. Defaults
#' @slot maxRatioBeyond Numeric. The maximum fraction of the empirical `GDI`
#'   distribution that sits beyond the `GDI` threshold
#' @slot maxRankBeyond Integer. The minimum rank in the empirical `GDI`
#'   distribution for the `GDI` threshold
#' @slot fractionBeyond Numeric. Output. The fraction of genes whose `GDI` is
#'   above the threshold
#' @slot thresholdRank Integer. Output. The rank that the `GDI` threshold would
#'   have in the genes' `GDI` `vector`
#' @slot quantileAtRatio Numeric. Output. The quantile in the genes' `GDI`
#'   corresponding at the given ratio
#' @slot quantileAtRatio Numeric. Output. The quantile in the genes' `GDI`
#'   corresponding at the given rank
#'
#' @importFrom rlang is_logical
#' @importFrom rlang is_integer
#' @importFrom rlang is_double
#'
#' @rdname UniformTranscriptCheckers
#'

setClass(
  "GDICheck",
  slots = c(
    isCheckAbove    = "logical",
    GDIThreshold    = "numeric",
    maxRatioBeyond  = "numeric",
    maxRankBeyond   = "integer",
    fractionBeyond  = "numeric",
    thresholdRank   = "integer",
    quantileAtRatio = "numeric",
    quantileAtRank  = "numeric"
  ),
  prototype = list(
    isCheckAbove    = FALSE,
    GDIThreshold    = 1.4,
    maxRatioBeyond  = 0.01,
    maxRankBeyond   = 0L,
    fractionBeyond  = NaN,
    thresholdRank   = 0L,
    quantileAtRatio = NaN,
    quantileAtRank  = NaN
  ),
  validity = function(object) {
    # deal with input parameters
    if (!is_double(object@GDIThreshold, n = 1L, finite = TRUE) ||
        object@GDIThreshold <= 1.0) {
      stop("Input 'GDIThreshold' must be a finite number above 1.0")
    }
    if (!is_double(object@maxRatioBeyond, n = 1L) ||
        (is.finite(object@maxRatioBeyond) &&
         (object@maxRatioBeyond <= 0.0 || object@maxRatioBeyond >= 1.0))) {
      stop("Input 'maxRatioBeyond' must be a finite number",
           " between 0.0 and 1.0 if given")
    }
    if (!is_integer(object@maxRankBeyond, n = 1L)
        || object@maxRankBeyond < 0L) {
      stop("Input check `rank` must be a non-negative integer")
    }
    if (is.finite(object@maxRatioBeyond) && object@maxRankBeyond > 0L) {
      stop("Cannot specify both a 'max ratio' and a 'max rank'")
    }

    # deal with output parameters
    if (!is_double(object@fractionBeyond, n = 1L) ||
        (is.finite(object@fractionBeyond) &&
         (object@fractionBeyond < 0.0 || object@fractionBeyond > 1.0))) {
      stop("Output 'fractionBeyond' must be a finite number",
           " between 0.0 and 1.0 if given")
    }
    if (!is_integer(object@thresholdRank, n = 1L)
        || object@thresholdRank < 0L) {
      stop("Output check `rank` must be a non-negative integer")
    }
    if (!is_double(object@quantileAtRatio, n = 1L) ||
        (is.finite(object@quantileAtRatio) && object@quantileAtRatio <= 0.0)) {
      stop("Output 'quantileAtRatio' must be a finite positive number",
           " if given")
    }
    if (!is_double(object@quantileAtRank, n = 1L) ||
        (is.finite(object@quantileAtRank) && object@quantileAtRank <= 0.0)) {
      stop("Output 'quantileAtRank' must be a finite positive number",
           " if given")
    }
    return(TRUE)
  }
)

#' @details `SimpleGDIUniformityCheck` represents the simplified (and legacy)
#'   mechanism to determine whether a cluster has the *Uniform Transcript*
#'   property
#'
#'   The method is based on checking whether the fraction of the genes' `GDI`
#'   below the given *threshold* is less than the given *ratio*
#'
#' @slot check `GDICheck`. The single threshold check used to determine whether
#'   the **cluster** is deemed not *uniform*. Threshold defaults to \eqn{1.4},
#'   `maxRatioBeyond` to \eqn{1\%}
#'
#' @importFrom methods new
#' @importFrom methods validObject
#'
#' @rdname UniformTranscriptCheckers
#'
setClass(
  "SimpleGDIUniformityCheck",
  contains = "BaseUniformityCheck",
  slots = c(
    check = "GDICheck"
  ),
  prototype = list(
    check = new("GDICheck")
  ),
  validity = function(object) {
    invisible(validObject(object@check))
    if (object@check@isCheckAbove) {
      stop("Given check direction must be below")
    }
    if (object@check@maxRankBeyond > 0L) {
      stop("Input check `rank` not supported for this case")
    }
    return(TRUE)
  }
) # end class SimpleGDIUniformityCheck


#' @details `AdvancedGDIUniformityCheck` represents the more precise and
#'   advanced mechanism to determine whether a cluster has the *Uniform
#'   Transcript* property
#'
#'   The method is based on checking the genes' `GDI` against three
#'   *thresholds*: if a cluster fails the first **below** check is deemed not
#'   *uniform*. Otherwise if it passes either of the other two checks (one above
#'   and one below) it is deemed *uniform*.
#'
#' @slot firstCheck `GDICheck`. Single threshold below check used to determine
#'   whether the **cluster** is deemed not *uniform*. Threshold defaults to
#'   \eqn{1.297}, `maxRatioBeyond` to \eqn{5\%}
#' @slot secondCheck `GDICheck`. Single threshold above check used to determine
#'   whether the **cluster** is deemed *uniform*. Threshold defaults to
#'   \eqn{1.307}, `maxRatioBeyond` to \eqn{2\%}
#' @slot thirdCheck `GDICheck`. Single threshold below check used to determine
#'   whether the **cluster** is deemed *uniform*. Threshold defaults to
#'   \eqn{1.4},   `maxRatioBeyond` to \eqn{1\%}
#' @slot fourthCheck `GDICheck`. Single threshold below check used to determine
#'   whether the **cluster** is deemed *uniform*. Threshold defaults to
#'   \eqn{1.4},   `maxRankBeyond` to \eqn{2}
#'
#' @importFrom methods new
#' @importFrom methods validObject
#'
#' @rdname UniformTranscriptCheckers
#'
setClass(
  "AdvancedGDIUniformityCheck",
  contains = "BaseUniformityCheck",
  slots = c(
    firstCheck  = "GDICheck",
    secondCheck = "GDICheck",
    thirdCheck  = "GDICheck",
    fourthCheck = "GDICheck"
  ),
  prototype = list(
    firstCheck  = new("GDICheck",
                      isCheckAbove   = FALSE,
                      GDIThreshold   = 1.297,
                      maxRatioBeyond = 0.05,
                      maxRankBeyond  = 0L),
    secondCheck = new("GDICheck",
                      isCheckAbove   = TRUE,
                      GDIThreshold   = 1.307,
                      maxRatioBeyond = 0.02,
                      maxRankBeyond  = 0L),
    thirdCheck  = new("GDICheck",
                      isCheckAbove   = FALSE,
                      GDIThreshold   = 1.4,
                      maxRatioBeyond = 0.01,
                      maxRankBeyond  = 0L),
    fourthCheck = new("GDICheck",
                      isCheckAbove   = FALSE,
                      GDIThreshold   = 1.4,
                      maxRatioBeyond = NaN,
                      maxRankBeyond  = 2L)
  ),
  validity = function(object) {
    invisible(validObject(object@firstCheck))
    invisible(validObject(object@secondCheck))
    invisible(validObject(object@thirdCheck))
    invisible(validObject(object@fourthCheck))
    if (object@firstCheck@isCheckAbove   ||
        !object@secondCheck@isCheckAbove ||
        object@thirdCheck@isCheckAbove   ||
        object@fourthCheck@isCheckAbove) {
      stop("The given checks' directions must be 'below, above, below, below'")
    }
    return(TRUE)
  }) # end class AdvancedGDIUniformityCheck

library(Matrix)

setLoggingLevel(4L)

options(COTAN.TorchWarning = NULL)

test_that("Empty matrices", {
  expect_identical(dim(emptySparseMatrix()), c(0L, 0L))
  expect_s4_class(emptySparseMatrix(), "dgCMatrix")

  expect_identical(dim(emptySymmetricMatrix()), c(0L, 0L))
  expect_s4_class(emptySymmetricMatrix(), "dspMatrix")
})

test_that("'COTAN' constructor", {
  utils::data("test.dataset", package = "COTAN")

  obj <- COTAN(raw = test.dataset)

  expect_s4_class(obj, "COTAN")

  expect_identical(obj@raw, as(as.matrix(test.dataset), "sparseMatrix"))
})

test_that("'scCOTAN' converters", {
  raw <- matrix(c(1L,  0L, 4L, 2L, 11L, 0L, 6L, 7L, 0L, 9L,
                  10L, 8L, 0L, 0L, 0L,  3L, 0L, 0L, 2L, 0L),
                nrow = 10L, ncol = 20L)
  rownames(raw) <- LETTERS[1L:10L]
  colnames(raw) <- letters[1L:20L]

  tags <- c("GEO:", "scRNAseq method:",
            "starting n. of cells:", "Condition sample:")

  obj <- COTAN(raw = raw)
  obj <- initializeMetaDataset(obj, GEO = "V", sequencingMethod = "10X",
                               sampleCondition = "Test")
  obj <- clean(obj)

  obj <- estimateLambdaLinear(obj)
  obj <- estimateDispersionViaSolver(obj)

  obj <- calculateCoex(obj, actOnCells = FALSE, optimizeForSpeed = FALSE)

  coexDF <-
    set_names(as.data.frame(atan(getNuNormData(obj)[, 1L:2L] - 0.5) / pi * 2.0),
              c(1L, 2L))

  obj <- addClusterization(obj, clName = "clusters",
                           clusters = set_names(rep(colnames(coexDF), 10L),
                                                colnames(raw)),
                           coexDF = coexDF)

  # coerce 'COTAN' -> 'scCOTAN'
  objSc <- as(obj, "scCOTAN")

  expect_identical(objSc@raw,      obj@raw)
  expect_identical(objSc@raw.norm, getNuNormData(obj))
  expect_identical(objSc@coex,     obj@genesCoex)
  expect_identical(objSc@nu,       getNu(obj))
  expect_identical(objSc@lambda,   getLambda(obj))
  expect_identical(objSc@nu,       getNu(obj))
  expect_identical(objSc@a,        getDispersion(obj))
  expect_identical(objSc@hk,       getFullyExpressedGenes(obj))
  expect_identical(objSc@meta,     obj@metaDataset)
  expect_null(objSc@yes_yes)
  expect_length(objSc@clusters, ncol(objSc@raw))
  if (!all(is.na(objSc@clusters))) {
    expect_identical(objSc@clusters, factorToVector(getClusters(obj)))
    expect_identical(objSc@cluster_data, getClusterizationData(obj)[["coex"]])
  } else {
    expect_length(objSc@cluster_data, 0L)
  }

  # coerce 'scCOTAN' -> 'COTAN'
  obj2 <- as(objSc, "COTAN")

  if (all(flagNotFullyExpressedGenes(obj))) {
    #drop the fe column as it won't appear in the obj2 in this case!
    obj@metaGenes[["feGenes"]] <- NULL
  }
  if (all(flagNotFullyExpressingCells(obj))) {
    #drop the fe column as it won't appear in the obj2 anyway!
    obj@metaCells[["feCells"]] <- NULL
  }

  expect_identical(obj2, obj)
})

gc()

prevOptState <- options(parallelly.fork.enable = TRUE)

test_that("clean COTAN object", {
  raw <- matrix(c(1L,  0L, 4L, 2L, 11L, 0L, 6L, 7L, 0L, 9L,
                  10L, 8L, 0L, 0L,  0L, 3L, 0L, 0L, 2L, 0L),
                nrow = 10L, ncol = 20L)
  rownames(raw) <- LETTERS[1L:10L]
  colnames(raw) <- letters[1L:20L]

  obj <- COTAN(raw = raw)
  obj <- clean(obj)

  expect_true(validObject(obj))

  expect_identical(colnames(getMetadataCells(obj)), c("feCells", "nu"))
  expect_identical(colnames(getMetadataGenes(obj)), "feGenes")
})

test_that("Clean on test dataset", {
  utils::data("test.dataset", package = "COTAN")

  obj <- COTAN(raw = test.dataset)
  obj <- initializeMetaDataset(obj, GEO = " ",
                               sequencingMethod = "artificial",
                               sampleCondition = "test")

  obj <- clean(obj)

  obj <- estimateLambdaLinear(obj)
  obj <- estimateDispersionViaSolver(obj, cores = 6L)

  rawNorm <- readRDS(file.path(getwd(), "raw.norm.test.RDS"))
  lambda <- readRDS(file.path(getwd(), "lambda.test.RDS"))
  dispersion <- readRDS(file.path(getwd(), "dispersion.test.RDS"))
  nu <- readRDS(file.path(getwd(), "nu.test.RDS"))

  genesNamesTest <- readRDS(file.path(getwd(), "genes.names.test.RDS"))
  cellsNamesTest <- readRDS(file.path(getwd(), "cells.names.test.RDS"))

  expect_equal(getNuNormData(obj)[genesNamesTest, cellsNamesTest],
               rawNorm, tolerance = 1.0e-14, ignore_attr = FALSE)
  expect_equal(getLambda(obj)[genesNamesTest],
               lambda, tolerance = 1.0e-14, ignore_attr = FALSE)
  expect_equal(getNu(obj)[cellsNamesTest],
               nu, tolerance = 1.0e-14, ignore_attr = FALSE)
  expect_equal(getDispersion(obj)[genesNamesTest],
               dispersion, tolerance = 1.0e-10, ignore_attr = FALSE)
})

options(prevOptState)

prevOptState <- options(parallelly.fork.enable = TRUE)

test_that("Convert COTAN to and from SCE on test dataset", {
  utils::data("test.dataset", package = "COTAN")

  obj <- COTAN(raw = test.dataset)
  obj <- initializeMetaDataset(obj, GEO = " ",
                               sequencingMethod = "artificial",
                               sampleCondition = "test")

  obj <- proceedToCoex(obj, calcCoex = FALSE, cores = 1L, saveObj = FALSE)

  coexTest <- readRDS(test_path("coex.test.RDS"))

  fold15 <- function(m) {
    mm <- cbind(m, m, m, m, m)
    return(cbind(mm, mm, mm))
  }
  coex <- cbind(fold15(coexTest[,  1L:10L]), fold15(coexTest[, 11L:20L]),
                fold15(coexTest[, 21L:30L]), fold15(coexTest[, 31L:40L]))
  colnames(coex) <- rownames(coex)
  coex <- pack(forceSymmetric(coex, uplo = "U"))

  obj@genesCoex <- coex
  obj@metaDataset <- updateMetaInfo(obj@metaDataset,
                                    datasetTags()[["gsync"]], TRUE)

  objSCE <- convertToSingleCellExperiment(objCOTAN = obj)

  genesMeta <- cbind(GenesNames = getGenes(obj), getMetadataGenes(obj))
  cellsMeta <- cbind(CellsIDs   = getCells(obj), getMetadataCells(obj))

  expect_identical(counts(objSCE), getRawData(obj))
  expect_identical(rowData(objSCE), S4Vectors::DataFrame(genesMeta))
  expect_identical(colData(objSCE), S4Vectors::DataFrame(cellsMeta))
  expect_named(S4Vectors::metadata(objSCE),
               c("genesCoex", "cellsCoex", "datasetMetadata"))
  expect_identical(S4Vectors::metadata(objSCE)[["datasetMetadata"]],
                   getMetadataDataset(obj))
  expect_identical(S4Vectors::metadata(objSCE)[["genesCoex"]], coex)
  expect_identical(S4Vectors::metadata(objSCE)[["cellsCoex"]],
                   emptySymmetricMatrix())

  newObj <- convertFromSingleCellExperiment(objSCE = objSCE)

  expect_identical(getRawData(newObj), getRawData(obj))
  expect_identical(getMetadataGenes(newObj), genesMeta)
  expect_identical(getMetadataCells(newObj), cellsMeta)
  expect_identical(getMetadataDataset(newObj), getMetadataDataset(obj))
  expect_identical(getMetadataElement(obj, datasetTags()[["gsync"]]),
                   getMetadataElement(newObj, datasetTags()[["gsync"]]))
  expect_identical(getGenesCoex(newObj), getGenesCoex(obj))

  rawNorm <- readRDS(file.path(getwd(), "raw.norm.test.RDS"))
  lambda <- readRDS(file.path(getwd(), "lambda.test.RDS"))
  dispersion <- readRDS(file.path(getwd(), "dispersion.test.RDS"))
  nu <- readRDS(file.path(getwd(), "nu.test.RDS"))

  genesNamesTest <- readRDS(file.path(getwd(), "genes.names.test.RDS"))
  cellsNamesTest <- readRDS(file.path(getwd(), "cells.names.test.RDS"))

  expect_equal(getNuNormData(newObj)[genesNamesTest, cellsNamesTest],
               rawNorm, tolerance = 1.0e-14, ignore_attr = FALSE)
  expect_equal(getLambda(newObj)[genesNamesTest],
               lambda, tolerance = 1.0e-14, ignore_attr = FALSE)
  expect_equal(getNu(newObj)[cellsNamesTest],
               nu, tolerance = 1.0e-14, ignore_attr = FALSE)
  expect_equal(getDispersion(newObj)[genesNamesTest],
               dispersion, tolerance = 1.0e-10, ignore_attr = FALSE)
  expect_identical(getGenesCoex(newObj, zeroDiagonal = FALSE), coex)
})


test_that("Convert COTAN to and from Seurat via SCE on test dataset", {
  utils::data("test.dataset", package = "COTAN")

  rawData <- as(as.matrix(test.dataset), "dgCMatrix")

  srat <- Seurat::CreateSeuratObject(counts = rawData,
                                     project = "conversion_test")
  srat <- Seurat::NormalizeData(srat)
  srat <- Seurat::FindVariableFeatures(srat,
                                       nfeatures = min(2000L, nrow(rawData)),
                                       selection.method = "vst")
  srat <- Seurat::ScaleData(srat, features = VariableFeatures(object = srat))
  srat <- Seurat::RunPCA(srat, npcs = 25L,
                         features = VariableFeatures(object = srat))
  srat <- Seurat::FindNeighbors(srat, dims = seq_len(25L))

  srat <- Seurat::FindClusters(srat, resolution = 0.8, algorithm = 2L)

  sce <- Seurat::as.SingleCellExperiment(srat)
  suppressWarnings({
    expect_warning(obj <- convertFromSingleCellExperiment(sce))
  })

  allDims <- set_names(c(600L, 1000L, 0L, 0L, 0L, 0L, 0L, 0L, 6L, 2L),
    c("raw1", "raw2", "genesCoex1", "genesCoex2", "cellsCoex1", "cellsCoex2",
      "metaDataset", "metaGenes", "metaCells", "clustersCoex"))
  expect_identical(unlist(getDims(obj)), allDims)
  expect_identical(getRawData(obj), rawData)
  expect_identical(getClusterizations(obj),
                   c("RNA_snn_res.0.8", "seurat_clusters"))
  expect_identical(getAllConditions(obj), "orig.ident")
  expect_identical(getClusters(obj, clName = "seurat_clusters"),
                   Seurat::Idents(srat))
  expect_identical(getCondition(obj, condName = "orig.ident"),
                   asClusterization(Seurat::FetchData(srat, var = "orig.ident"),
                                    getCells(obj)))

  obj <- proceedToCoex(obj, calcCoex = FALSE, cores = 1L, saveObj = FALSE)

  expect_identical(colnames(getMetadataGenes(obj)),
                   c("feGenes", "lambda", "dispersion"))
  expect_identical(colnames(getMetadataCells(obj)),
                   c("nCount_RNA", "nFeature_RNA", "ident",
                     "CL_RNA_snn_res.0.8", "CL_seurat_clusters",
                     "COND_orig.ident", "feCells", "nu"))
})

options(prevOptState)

# --------------------- Uniform Clusters ----------------------

#' @name UniformClusters
#'
#' @details `GDIPlot()` directly evaluates and plots the `GDI` for a sample.
#'
#' @param objCOTAN a `COTAN` object
#' @param genes a named `list` of genes to label. Each array will have different
#'   color.
#' @param condition a string corresponding to the condition/sample (it is used
#'   only for the title).
#' @param statType type of statistic to be used. Default is "S": Pearson's
#'   chi-squared test statistics. "G" is G-test statistics
#' @param GDIThreshold the threshold level that discriminates uniform clusters.
#'   It defaults to \eqn{1.43}
#' @param GDIIn when the `GDI` data frame was already calculated, it can be put
#'   here to speed up the process (default is `NULL`)
#'
#' @returns `GDIPlot()` returns a `ggplot2` object with a point got each gene,
#'   where on the ordinates are the `GDI` levels and on the abscissa are the
#'   average gene expression (log scaled). Also marked are the given *threshold*
#'   (in red) and the \eqn{50\%} and \eqn{75\%} quantiles (in blue).
#'
#' @importFrom ggplot2 ggplot
#' @importFrom ggplot2 geom_point
#' @importFrom ggplot2 geom_tile
#' @importFrom ggplot2 geom_hline
#' @importFrom ggplot2 aes
#' @importFrom ggplot2 ggtitle
#' @importFrom ggplot2 xlab
#' @importFrom ggplot2 ylab
#' @importFrom ggplot2 scale_color_manual
#' @importFrom ggplot2 scale_fill_manual
#'
#' @importFrom ggrepel geom_text_repel
#' @importFrom ggrepel geom_label_repel
#'
#' @importFrom dplyr filter
#'
#' @importFrom stats quantile
#'
#' @importFrom rlang set_names
#' @importFrom rlang is_empty
#'
#' @export
#'
#' @rdname UniformClusters
#'

# nolint start: object_name_linter
GDIPlot <- function(objCOTAN, genes, condition = "",
                    statType = "S", GDIThreshold = 1.43,
                    GDIIn = NULL) {
  logThis("GDI plot", logLevel = 2L)

  if (!is_empty(GDIIn)) {
    GDIDf <- GDIIn
  } else {
    gdi <- getGDI(objCOTAN)
    if (!is_empty(gdi) && statType == "S") {
      # complete the GDIDf
      GDIDf <- data.frame()
      GDIDf <- setColumnInDF(GDIDf, colToSet = gdi, colName = "GDI",
                             rowNames = getGenes(objCOTAN))
      sumRawNorm <- log(rowSums(getNuNormData(objCOTAN)))
      GDIDf <- setColumnInDF(GDIDf, colToSet = sumRawNorm,
                             colName = "sum.raw.norm")
    } else {
      GDIDf <- calculateGDI(objCOTAN, statType = statType)
    }
  }

  GDIDf[["colors"]] <- "none"
  for (n in names(genes)) {
    genesSelec <- rownames(GDIDf) %in% genes[[n]]
    if (any(genesSelec)) {
      GDIDf[genesSelec, "colors"] <- n
    } else {
      logThis(paste("GDIPlot - none of the genes in group", n,
                    "is present: will be ignored"), logLevel = 1L)
    }
  }

  # drop fully-expressed genes i.e. those that have GDI <= -5.0
  if (TRUE) {
    genesToKeep <- (GDIDf[["GDI"]] > -5.0)
    logThis(paste("Removed", sum(!genesToKeep), "low GDI genes",
                  "(such as the fully-expressed) in GDI plot"), logLevel = 1L)
    GDIDf <- GDIDf[genesToKeep, ]
  }

  myColours <- set_names(getColorsVector(length(names(genes))), names(genes))

  labelledGenes <- GDIDf[["colors"]] != "none"
# nolint end

  if (isEmptyName(condition)) {
    condition <- getMetadataElement(objCOTAN, datasetTags()[["cond"]])
  }

  gdiPl <-
    ggplot(
      filter(GDIDf, .data$colors == "none"),
      aes(x = .data$sum.raw.norm, y = .data$GDI)
    ) +
    geom_point(alpha = 0.3, color = "#8491B4B2", size = 2.5) +
    geom_point(
      data = filter(GDIDf, .data$colors != "none"),
      aes(x = .data$sum.raw.norm, y = .data$GDI, colour = .data$colors),
      size = 2.5,
      alpha = 0.8
    ) +
    geom_hline(
      yintercept = quantile(GDIDf[["GDI"]])[[4L]],
      linetype = "dashed",
      color = "darkblue"
    ) +
    geom_hline(
      yintercept = quantile(GDIDf[["GDI"]])[[3L]],
      linetype = "dashed",
      color = "darkblue"
    ) +
    geom_hline(
      yintercept = GDIThreshold,
      linetype = "dotted",
      color = "red",
      linewidth = 0.5
    ) +
    scale_color_manual("Status", values = myColours) +
    scale_fill_manual( "Status", values = myColours) +
    xlab("log normalized counts") +
    ylab("GDI") +
    geom_label_repel(
      data = GDIDf[labelledGenes, ],
      aes(x = .data$sum.raw.norm, y = .data$GDI, fill = .data$colors),
      label = rownames(GDIDf)[labelledGenes],
      label.size = NA,
      max.overlaps = 40L,
      alpha = 0.8,
      direction = "both",
      na.rm = TRUE,
      seed = 1234L
    ) +
    ggtitle(paste0("GDI plot - ", condition)) +
    plotTheme("GDI", textSize = 10L)

  return(gdiPl)
}

runSingleDEA <- function(clName, cellsInList,
                         probZero, rowSumsProbZero, zeroOne) {
  logThis("*", appendLF = FALSE, logLevel = 1L)

  cellsIn <- cellsInList[[clName]]
  if (!any(cellsIn)) {
    warning("Cluster '", clName, "' has no cells assigned to it!")
  }
  logThis(paste0(" DEA on cluster '", clName,
                 "' with ", sum(cellsIn), " cells"), logLevel = 3L)

  numCells <- ncol(zeroOne)
  numCellsIn  <- sum(cellsIn)

  observedYI <- rowSums(zeroOne [, cellsIn, drop = FALSE])

  expectedNI <- rowsums(probZero[, cellsIn, drop = FALSE], parallel = TRUE)
  expectedNO <- rowSumsProbZero - expectedNI
  expectedYI <- numCellsIn  - expectedNI
  expectedYO <- (numCells - numCellsIn) - expectedNO

  clCoex <- (observedYI  - expectedYI) / sqrt(numCells) *
    sqrt(1.0 / pmax(1.0, expectedNI) +
         1.0 / pmax(1.0, expectedNO) +
         1.0 / pmax(1.0, expectedYI) +
         1.0 / pmax(1.0, expectedYO))

  return(clCoex)
}


#'
#'
#' @details `DEAOnClusters()` is used to run the Differential Expression
#'   analysis using the `COTAN` contingency tables on each *cluster* in the
#'   given *clusterization*
#'
#' @param objCOTAN a `COTAN` object
#' @param clName The name of the *clusterization*. If not given the last
#'   available *clusterization* will be used, as it is probably the most
#'   significant!
#' @param clusters A *clusterization* to use. If given it will take precedence
#'   on the one indicated by `clName`
#'
#' @return `DEAOnClusters()` returns the co-expression `data.frame` for the
#'   genes in each *cluster*
#'
#' @export
#'
#' @importFrom rlang is_empty
#' @importFrom rlang is_null
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom zeallot %<-%
#' @importFrom zeallot %->%
#'
#' @importFrom Rfast rowsums
#' @importFrom Matrix rowSums
#'
#' @rdname HandlingClusterizations
#'
DEAOnClusters <- function(objCOTAN, clName = "", clusters = NULL) {
  startTime <- Sys.time()

  logThis("Differential Expression Analysis - START", logLevel = 2L)

  # picks up the last clusterization if none was given
  c(clName, clusters) %<-%
    normalizeNameAndLabels(objCOTAN, name = clName,
                           labels = clusters, isCond = FALSE)

  assert_that(estimatorsAreReady(objCOTAN),
              msg = paste("Estimators `lambda`, `nu`, `dispersion` are not",
                          "ready: Use proceedToCoex() to prepare them"))

  clustersList <- toClustersList(clusters)

  zeroOne <- getZeroOneProj(objCOTAN)

  probZero <- getProbabilityOfZero(objCOTAN)

  rowSumsProbZero <- rowsums(probZero, parallel = TRUE)

  cellsInList <- lapply(clustersList, \(cl) getCells(objCOTAN) %in% cl)

  coexCls <- lapply(names(cellsInList), runSingleDEA,
                    cellsInList = cellsInList,
                    probZero = probZero, rowSumsProbZero = rowSumsProbZero,
                    zeroOne = zeroOne)

  logThis("", logLevel = 1L)

  coexDF <- as.data.frame(coexCls)
  colnames(coexDF) <- names(cellsInList)

  endTime <- Sys.time()

  logThis(paste("Total calculations elapsed time:",
                difftime(endTime, startTime, units = "secs")),
          logLevel = 2L)

  logThis("Differential Expression Analysis - DONE", logLevel = 2L)

  return(coexDF)
}

#' @details `clusterGeneContingencyTables()` returns the observed and expected
#'   contingency tables for a given gene and a given set of cells (a cluster).
#'   The implementation runs the same algorithms used to calculate the full
#'   observed/expected contingency tables used for DEA, but restricted to only
#'   the relevant gene and cluster, thus much faster and less memory intensive
#'
#' @param objCOTAN a `COTAN` object
#' @param gene a gene
#' @param cells a sub-set of the cells
#'
#' @return `clusterGeneContingencyTables()` returns a list containing the
#'   observed and expected contingency tables
#'
#' @importFrom Matrix rowSums
#'
#' @importFrom assertthat assert_that
#'
#' @export
#'
#' @rdname HandlingClusterizations
#'
clusterGeneContingencyTables <- function(objCOTAN, gene, cells) {
  allGenes <- getGenes(objCOTAN)
  allCells <- getCells(objCOTAN)

  assert_that(c(gene) %in% allGenes, msg = "the given gene is unknown")
  assert_that(all(cells %in% allCells),
              msg = "some of the given cells are unknown")

  dimNames <- list(c(paste(gene, "yes", sep = "."),
                     paste(gene, "no", sep = ".")),
                   c("cells.in", "cells.out"))

  # reorder and standardize cells list
  cellsIn <- allCells %in% cells

  # observed

  zeroOne <- sign(getRawData(objCOTAN)[gene, ])

  numCells    <- length(zeroOne)
  numCellsIn  <- sum(cellsIn)
  numCellsOut <- numCells - numCellsIn

  observedY  <- sum(zeroOne)

  observedYI <- sum(zeroOne[cellsIn])
  observedYO <- observedY   - observedYI
  observedNI <- numCellsIn  - observedYI
  observedNO <- numCellsOut - observedYO

  observedCT <- matrix(c(observedYI, observedNI, observedYO, observedNO),
                       ncol = 2L, nrow = 2L, dimnames = dimNames)

  # estimated
  lambda <- suppressWarnings(getLambda(objCOTAN))
  assert_that(!is_empty(lambda),
              msg = "`lambda` must not be empty, estimate it")

  nu <- suppressWarnings(getNu(objCOTAN))
  assert_that(!is_empty(nu),
              msg = "`nu` must not be empty, estimate it")

  dispersion <- suppressWarnings(getDispersion(objCOTAN))
  assert_that(!is_empty(dispersion),
              msg = "`dispersion` must not be empty, estimate it")

  probZero <- funProbZero(dispersion[gene], lambda[gene] * nu)

  if (anyNA(probZero)) {
    warning("Some NA in estimated probability of zero matrix")
  }

  expectedN  <- sum(probZero)

  expectedNI <- sum(probZero[cellsIn])
  expectedNO <- expectedN   - expectedNI
  expectedYI <- numCellsIn  - expectedNI
  expectedYO <- numCellsOut - expectedNO

  expectedCT <- matrix(c(expectedYI, expectedNI, expectedYO, expectedNO),
                       ncol = 2L, nrow = 2L, dimnames = dimNames)

  return(list("observed" = observedCT, "expected" = expectedCT))
}


#'
#'
#' @details `pValueFromDEA()` is used to convert to *p-value* the Differential
#'   Expression analysis using the `COTAN` contingency tables on each *cluster*
#'   in the given *clusterization*
#'
#' @param coexDF a `data.frame` where each column indicates the `COEX` for each
#'   of the *clusters* of the *clusterization*
#' @param numCells the number of overall cells in all *clusters*
#' @param adjustmentMethod *p-value* multi-test adjustment method, see
#'   [stats::p.adjust.methods()]. Defaults to `"none"` (i.e. no adjustment)
#'
#' @return `pValueFromDEA()` returns a `data.frame` containing the *p-values*
#'   corresponding to the given `COEX` adjusted for *multi-test*
#'
#' @export
#'
#' @importFrom rlang is_empty
#'
#' @importFrom Matrix rowSums
#'
#' @importFrom stats pchisq
#' @importFrom stats p.adjust
#'
#' @importFrom assertthat assert_that
#'
#' @rdname HandlingClusterizations
#'
pValueFromDEA <- function(coexDF, numCells, adjustmentMethod) {
  pValue <- pchisq(as.matrix(coexDF^2L * numCells),
                             df = 1L, lower.tail = FALSE)

  if (anyNA(pValue)) {
    warning("Got some NA in the p-value",
            toString(which(is.na(pValue), arr.ind = TRUE)))
  }

  if (adjustmentMethod != "none") {
    for (cl in colnames(pValue)) {
      pValue[, cl] <- p.adjust(pValue[, cl],
                               method = adjustmentMethod, n = nrow(coexDF))
    }
  }

  if (anyNA(pValue)) {
    warning("Got some NA in the adjusted p-value",
            toString(which(is.na(pValue), arr.ind = TRUE)))
  }

  return(as.data.frame(pValue))
}


#
#
#' @details `logFoldChangeOnClusters()` is used to get the log difference of the
#'   expression levels for each *cluster* in the given *clusterization* against
#'   the rest of the data-set
#'
#' @param objCOTAN a `COTAN` object
#' @param clName The name of the *clusterization*. If not given the last
#'   available *clusterization* will be used, as it is probably the most
#'   significant!
#' @param clusters A *clusterization* to use. If given it will take precedence
#'   on the one indicated by `clName`
#' @param floorLambdaFraction Indicates the lower bound to the average count
#'   sums inside or outside the cluster for each gene as fraction of the
#'   relevant `lambda` parameter. Default is \eqn{5\%}
#'
#' @return `logFoldChangeOnClusters()` returns the log-expression-change
#'   `data.frame` for the genes in each *cluster*
#'
#' @export
#'
#' @importFrom rlang is_empty
#'
#' @importFrom Matrix rowSums
#'
#' @importFrom assertthat assert_that
#'
#' @rdname HandlingClusterizations
#'
logFoldChangeOnClusters <- function(objCOTAN, clName = "", clusters = NULL,
                                    floorLambdaFraction = 0.05) {
  startTime <- Sys.time()

  logThis("Log Fold Change Analysis - START", logLevel = 2L)

  # picks up the last clusterization if none was given
  c(clName, clusters) %<-%
    normalizeNameAndLabels(objCOTAN, name = clName,
                           labels = clusters, isCond = FALSE)

  clustersList <- toClustersList(clusters)

  numCells <- getNumCells(objCOTAN)

  normData <- getNuNormData(objCOTAN)

  lambda <- suppressWarnings(getLambda(objCOTAN))
  assert_that(!is_empty(lambda),
              msg = "`lambda` must not be empty, estimate it")

  floorAverage <- lambda * floorLambdaFraction

  allSums <- rowSums(normData)

  lfcDF <- data.frame()

  for (cl in names(clustersList)) {
    logThis("*", appendLF = FALSE, logLevel = 1L)
    logThis(paste0(" Analysis of cluster: '", cl, "'"), logLevel = 3L)

    cellsIn <- getCells(objCOTAN) %in%  clustersList[[cl]]

    numCellsIn  <- sum(cellsIn)
    numCellsOut <- numCells - numCellsIn

    if (numCellsIn == 0L) {
      warning("Cluster '", cl, "' has no cells assigned to it!")
    }

    # log of average expression inside/outside the cluster
    inSums <- rowSums(normData[,  cellsIn, drop = FALSE])

    averageIn  <- inSums             / max(numCellsIn,  1L)
    averageOut <- (allSums - inSums) / max(numCellsOut, 1L)

    logAverageIn  <- log10(pmax(averageIn,  floorAverage))
    logAverageOut <- log10(pmax(averageOut, floorAverage))

    lfc <- logAverageIn - logAverageOut

    rm(averageIn, averageOut, logAverageIn, logAverageOut)
    gc()

    lfcDF <- setColumnInDF(lfcDF, colToSet = lfc,
                           colName = cl, rowNames = rownames(normData))
  }
  logThis("", logLevel = 1L)

  endTime <- Sys.time()

  logThis(paste("Total calculations elapsed time:",
                difftime(endTime, startTime, units = "secs")),
          logLevel = 2L)

  logThis("Log Fold Change Analysis - DONE", logLevel = 2L)

  return(lfcDF)
}


#'
#'
#' @details `distancesBetweenClusters()` is used to obtain a distance between
#'   the clusters. Depending on the value of the `useDEA` flag will base the
#'   distance on the *DEA* columns or the averages of the *Zero-One* matrix.
#'
#' @param objCOTAN a `COTAN` object
#' @param clName The name of the *clusterization*. If not given the last
#'   available *clusterization* will be used, as it is probably the most
#'   significant!
#' @param clusters A *clusterization* to use. If given it will take precedence
#'   on the one indicated by `clName`
#' @param coexDF a `data.frame` where each column indicates the `COEX` for each
#'   of the *clusters* of the *clusterization*
#' @param useDEA Boolean indicating whether to use the *DEA* to define the
#'   distance; alternatively it will use the average *Zero-One* counts, that is
#'   faster but less precise.
#' @param distance type of distance to use. Default is `"cosine"` for *DEA* and
#'   `"euclidean"` for *Zero-One*. Can be chosen among those supported by
#'   [parallelDist::parDist()]
#'
#' @return `distancesBetweenClusters()` returns a `dist` object
#'
#' @export
#'
#' @importFrom Matrix rowSums
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom rlang is_empty
#' @importFrom rlang is_null
#'
#' @rdname HandlingClusterizations
#'
distancesBetweenClusters <- function(objCOTAN, clName = "",
                                     clusters = NULL, coexDF = NULL,
                                     useDEA = TRUE, distance = NULL) {
  # picks up the last clusterization if none was given
  c(clName, clusters) %<-%
    normalizeNameAndLabels(objCOTAN, name = clName,
                           labels = clusters, isCond = FALSE)

  clList <- toClustersList(clusters)

  if (isTRUE(useDEA) && is_empty(coexDF) && !estimatorsAreReady(objCOTAN)) {
    logThis("cannot calculate DEA - falling back to case 'useDEA = FALSE'",
            logLevel = 1L)
    useDEA <- FALSE
  }

  if (isTRUE(useDEA)) {
    if (is_null(distance)) {
      distance <- "cosine"
    }

    if (is_empty(coexDF) && (clName %in% getClusterizations(objCOTAN))) {
        coexDF <- getClusterizationData(objCOTAN, clName = clName)[["coex"]]
    }

    if (is_empty(coexDF)) {
      coexDF <- DEAOnClusters(objCOTAN, clusters = clusters)
    }

    # merge small cluster based on distances
    return(calcDist(t(as.matrix(coexDF)), method = distance,
                    diag = TRUE, upper = TRUE))
  } else {
    if (is.null(distance)) {
      distance <- "euclidean"
    }

    zeroOne <- getZeroOneProj(objCOTAN)

    zeroOneClAvg <- data.frame(row.names = getGenes(objCOTAN))
    for (cluster in clList) {
      zeroOneClAvg <- cbind(zeroOneClAvg, rowMeans(zeroOne[, cluster]))
    }

    # ensure no zeros in the matrix
    zeroOneClAvg[zeroOneClAvg == 0.0] <- 1.0e-6
    colnames(zeroOneClAvg) <- names(clList)

    return(calcDist(t(zeroOneClAvg), method = distance,
                    diag = TRUE, upper = TRUE))
  }
}

tm <- tempdir()
stopifnot(file.exists(tm))

library(zeallot)

prevOptState <- options(parallelly.fork.enable = TRUE)

test_that("Cell Uniform Clustering", {
  utils::data("test.dataset", package = "COTAN")

  obj <- COTAN(raw = test.dataset)
  obj <- initializeMetaDataset(objCOTAN = obj, GEO = " ",
                               sequencingMethod = "artificial",
                               sampleCondition = "test")

  obj <- proceedToCoex(objCOTAN = obj, calcCoex = TRUE,
                       cores = 6L, saveObj = TRUE, outDir = tm)

  initialResolution <- 1.3
  c(sClusters, cellsRDM, resolution, usedMaxResolution) %<-%
    seuratClustering(objCOTAN = obj,
                     initialResolution = initialResolution,
                     resolutionStep = 0.5,
                     minNumClusters = 3L,
                     useCoexEigen = TRUE,
                     dataMethod = "AdjBin",
                     numReducedComp = 25L,
                     genesSel = "",
                     numGenes = -1L)

  expect_identical(nlevels(sClusters), 4L)
  expect_identical(as.vector(table(sClusters)), c(321L, 284L, 214L, 181L))
  expect_identical(dim(cellsRDM), c(1000L, 25L + 15L))
  expect_identical(resolution, 1.3)
  expect_false(usedMaxResolution)

  # Make it a less strict check as it is only for testing
  checker <- new("AdvancedGDIUniformityCheck")
  checker <- shiftCheckerThresholds(checker, 0.1)

  suppressWarnings({
    splitData <-
      cellsUniformClustering(objCOTAN = obj,
                             checker = checker,
                             initialResolution = initialResolution,
                             dataMethod = "LogLikelihood",
                             useCoexEigen = TRUE,
                             genesSel = "HGDI",
                             numGenes = 2000L,
                             numReducedComp = 50L,
                             cores = 6L, optimizeForSpeed = TRUE,
                             deviceStr = "cuda", saveObj = TRUE, outDir = tm)
  })

  expect_true(file.exists(file.path(tm, "test", "reclustering",
                                    "pdf_umap_1.pdf")))
  expect_true(file.exists(file.path(tm, "test", "reclustering",
                                    "partial_clusterization_1.csv")))
  expect_true(file.exists(file.path(tm, "test", "reclustering",
                                    "all_check_results_1.csv")))
  expect_true(file.exists(file.path(tm, "test", "split_check_results.csv")))
  expect_true(file.exists(file.path(tm, "test", "split_clusterization.csv")))

  gc()

  clusters <- splitData[["clusters"]]
  coexDF <- splitData[["coex"]]
  expect_identical(nlevels(clusters), 4L)
  expect_setequal(levels(clusters), colnames(coexDF))

  obj <- addClusterization(objCOTAN = obj, clName = "clusters",
                           clusters = clusters, coexDF = coexDF)

  expect_equal(getClusters(objCOTAN = obj), clusters, ignore_attr = TRUE)
  expect_identical(reorderClusterization(objCOTAN = obj)[["clusters"]],
                   clusters)

  firstCl <- clusters[[1L]]

  suppressWarnings({
      checkerRes <- checkClusterUniformity(
        objCOTAN = obj, checker = checker,
        clusterName = paste0("Cluster_", firstCl),
        cells = names(clusters)[clusters == firstCl],
        optimizeForSpeed = TRUE, deviceStr = "cuda",
        saveObj = TRUE, outDir = tm)
  })

  expect_true(checkerRes@isUniform)
  expect_lte(checkerRes@firstCheck@fractionBeyond,
             checkerRes@firstCheck@maxRatioBeyond)
  expect_lte(checkerRes@firstCheck@quantileAtRatio,
             checkerRes@firstCheck@GDIThreshold)
  expect_true(((checkerRes@secondCheck@fractionBeyond >=
                  checkerRes@secondCheck@maxRatioBeyond) &&
               (checkerRes@thirdCheck@fractionBeyond <=
                  checkerRes@thirdCheck@maxRatioBeyond)) ||
              (checkerRes@fourthCheck@thresholdRank <=
                 checkerRes@fourthCheck@maxRankBeyond))
  expect_true(((checkerRes@secondCheck@quantileAtRatio >=
                 checkerRes@secondCheck@GDIThreshold) &&
               (checkerRes@thirdCheck@quantileAtRatio <=
                 checkerRes@thirdCheck@GDIThreshold)) ||
              (checkerRes@fourthCheck@quantileAtRank <=
                 checkerRes@fourthCheck@GDIThreshold))
  expect_identical(checkerRes@clusterSize, sum(clusters == firstCl))
  expect_identical(checkerRes@firstCheck@GDIThreshold,
                   checker@firstCheck@GDIThreshold)
  expect_identical(checkerRes@secondCheck@maxRatioBeyond,
                   checker@secondCheck@maxRatioBeyond)
  expect_identical(checkerRes@thirdCheck@maxRatioBeyond,
                   checker@thirdCheck@maxRatioBeyond)
  expect_identical(checkerRes@fourthCheck@maxRankBeyond,
                   checker@fourthCheck@maxRankBeyond)

  clusters2 <- factor(clusters, levels = c("-1", levels(clusters)))
  clusters2[1L:50L] <- "-1"
  coexDF2 <- DEAOnClusters(objCOTAN = obj, clusters = clusters2)
  reorderRes2 <-
    reorderClusterization(objCOTAN = obj, reverse = TRUE, keepMinusOne = TRUE,
                          clusters = clusters2, coexDF = coexDF2)
  rClusters2 <- reorderRes2[["clusters"]]

  expect_identical(levels(rClusters2)[rClusters2[1L:50L]],
                   levels(clusters2)[clusters2[1L:50L]])
  expect_identical(rClusters2 == "-1", clusters2 == "-1")
  # this is an happenstance
  expect_identical(colnames(reorderRes2[["coex"]]), rev(levels(rClusters2)))
  expect_identical(reorderRes2[["permMap"]],
                   set_names(paste0(c(4L:1L, -1L)),
                             nm = paste0(c(1L:4L, -1L))))

  clusters3 <- factor(clusters, levels = c(levels(clusters), "-1"))
  clusters3[51L:100L] <- "-1"
  reorderRes3 <-
    reorderClusterization(objCOTAN = obj, useDEA = FALSE,
                          reverse = FALSE, keepMinusOne = TRUE,
                          clusters = clusters3, coexDF = coexDF2)
  clusters3 <- reorderRes3[["clusters"]]

  expect_identical(levels(clusters3)[clusters3[51L:100L]],
                   levels(clusters2)[clusters2[1L:50L]])
  expect_identical((clusters3 == "-1")[51L:150L], (clusters2 == "-1")[1L:100L])
  # this is an happenstance
  expect_identical(colnames(reorderRes3[["coex"]])[-5L], levels(clusters3)[-1L])
  expect_identical(reorderRes3[["permMap"]],
                   set_names(paste0(c(1L:4L, -1L)),
                             nm = paste0(c(1L:4L, -1L))))

  clSize <- getNumCells(obj) / 2L
  exactClusters <- set_names(rep(1L:2L, each = clSize), nm = getCells(obj))

  suppressWarnings({
    splitData2 <-
      cellsUniformClustering(objCOTAN = obj,
                             checker = checker,
                             initialResolution = initialResolution,
                             initialClusters = exactClusters,
                             cores = 6L,
                             optimizeForSpeed = TRUE,
                             deviceStr = "cuda",
                             saveObj = TRUE,
                             outDir = tm)
  })

  expect_identical(splitData2[["clusters"]], factor(exactClusters))

  clMarkersDF <- findClustersMarkers(objCOTAN = obj)

  expect_identical(colnames(clMarkersDF),
                   c("CL", "Gene", "DEA", "adjPVal", "IsMarker", "logFoldCh"))
  expect_identical(nrow(clMarkersDF), 10L * 2L * length(unique(clusters)))
  expect_type(clMarkersDF[["Gene"]],     "character")
  expect_type(clMarkersDF[["IsMarker"]], "integer")
  expect_identical(sum(clMarkersDF[["IsMarker"]]), 0L)
  expect_gt(min(clMarkersDF[["DEA"]] * clMarkersDF[["logFoldCh"]]), 0.0)

  topGenesNum <- as.integer(substring(clMarkersDF[["Gene"]], 6L))
  expect_gt(min(topGenesNum), 150L)

  primaryMarkers <-
    c("g-000010", "g-000020", "g-000138", "g-000300", "g-000330",
      "g-000510", "g-000530", "g-000550", "g-000579", "g-000590")
  clMarkersDF2 <- findClustersMarkers(objCOTAN = obj, markers = primaryMarkers)

  expect_identical(colnames(clMarkersDF2), colnames(clMarkersDF))
  expect_identical(clMarkersDF2[, -5L], clMarkersDF[, -5L])
  expect_gt(sum(clMarkersDF2[["IsMarker"]]), 0L)

  clMarkersDF3 <- findClustersMarkers(objCOTAN = obj, clusters = clusters)

  expect_identical(clMarkersDF3, clMarkersDF)

  # Test cluster/gene contingency tables
  contingencyTables <-
    clusterGeneContingencyTables(objCOTAN = obj, gene = "g-000138",
                                 cells = toClustersList(exactClusters)[[1L]])
  observedCT <- contingencyTables[["observed"]]
  expectedCT <- contingencyTables[["expected"]]

  expect_identical(rownames(observedCT), rownames(expectedCT))
  expect_identical(rownames(observedCT), c("g-000138.yes", "g-000138.no"))
  expect_identical(colSums(observedCT),
                   set_names(c(clSize, clSize), c("cells.in", "cells.out")))
  expect_identical(colSums(expectedCT),
                   set_names(c(clSize, clSize), c("cells.in", "cells.out")))
  expect_equal(rowSums(observedCT), rowSums(expectedCT), tolerance = 5e-6)
  expect_identical(observedCT < expectedCT,
                   matrix(c(TRUE, FALSE, FALSE, TRUE), nrow = 2L,
                          dimnames = dimnames(observedCT)))
  expect_identical(observedCT[1L, 1L],
                   sum(getZeroOneProj(objCOTAN = obj)["g-000138", 1L:clSize]))
  expect_equal(expectedCT[2L, 1L],
               sum(getProbabilityOfZero(objCOTAN = obj)["g-000138", 1L:clSize]),
               tolerance = 5e-6)

  # Test the low GDI (homogeneity) for each defined clusters
  simpleChecker <- checker@thirdCheck
  for (cl in levels(clusters)[[1L]]) {
    cat(paste("Tested cluster:", cl))

    cellsToDrop <- names(clusters)[clusters != cl]

    tmpObj <- dropGenesCells(objCOTAN = obj, cells = cellsToDrop)

    suppressWarnings({
      tmpObj <- proceedToCoex(objCOTAN = tmpObj, cores = 6L, saveObj = FALSE)
    })

    gdiData <- calculateGDI(objCOTAN = tmpObj)

    expect_lte(sum(gdiData[["GDI"]] >= simpleChecker@GDIThreshold),
               simpleChecker@maxRatioBeyond * nrow(gdiData))
  }

  rm(obj, splitData, splitData2)

  gc()
})

options(prevOptState)

tm <- tempdir()
stopifnot(file.exists(tm))

library(stringr)
library(zeallot)

prevOptState <- options(parallelly.fork.enable = TRUE)

test_that("Merge Uniform Cells Clusters", {
  utils::data("test.dataset", package = "COTAN")

  obj <- COTAN(raw = test.dataset)
  obj <- initializeMetaDataset(objCOTAN = obj, GEO = " ",
                               sequencingMethod = "artificial",
                               sampleCondition = "test")

  obj <- proceedToCoex(objCOTAN = obj,
                       calcCoex = FALSE, cores = 6L, saveObj = FALSE)

  clusters <- factor(readRDS(file.path(getwd(), "split.clusters.test.RDS")))
  genesNamesTest <- readRDS(file.path(getwd(), "genes.names.test.RDS"))

  obj <- addClusterization(objCOTAN = obj,
                           clName = "clusters", clusters = clusters)

  coexDF <- DEAOnClusters(objCOTAN = obj)

  obj <- addClusterizationCoex(objCOTAN = obj,
                               clName = "clusters", coexDF = coexDF)

  expect_setequal(colnames(coexDF), levels(clusters))
  expect_identical(rownames(coexDF), getGenes(objCOTAN = obj))

  lfcDF <- logFoldChangeOnClusters(objCOTAN = obj,
                                   clusters = clusters,
                                   floorLambdaFraction = 0.01)

  expect_setequal(colnames(lfcDF), clusters)
  expect_identical(rownames(lfcDF), getGenes(objCOTAN = obj))
  expect_gte(min(colSums(lfcDF > 0.0)), 260L)
  expect_lte(max(colSums(lfcDF > 0.0)), 340L)
  expect_lt(max(colMeans(lfcDF)),  0.0)
  expect_gt(min(colMeans(lfcDF)), -0.28)

  adjustmentMethod <- "bonferroni"

  pValDF <- pValueFromDEA(coexDF, numCells = getNumCells(objCOTAN = obj),
                          adjustmentMethod = "none")
  adjPValDF <- pValueFromDEA(coexDF, numCells = getNumCells(objCOTAN = obj),
                             adjustmentMethod = adjustmentMethod)

  expect_setequal(colnames(pValDF), levels(clusters))
  expect_identical(rownames(pValDF), getGenes(objCOTAN = obj))
  expect_setequal(colnames(adjPValDF), levels(clusters))
  expect_identical(rownames(adjPValDF), getGenes(objCOTAN = obj))

  coexDfExp <- readRDS(file.path(getwd(), "coex.clusters.test.RDS"))
  pValDfExp <- readRDS(file.path(getwd(), "pvalues.clusters.test.RDS"))

  expect_equal(coexDF[genesNamesTest, ], coexDfExp, tolerance = 1.0e-8)
  expect_equal(pValDF[genesNamesTest, ], pValDfExp, tolerance = 1.0e-8)

  deltaExpression <- clustersDeltaExpression(objCOTAN = obj)

  expect_identical(rownames(deltaExpression), getGenes(objCOTAN = obj))
  expect_setequal(colnames(deltaExpression), levels(clusters))

  groupMarkers <- list(G1 = c("g-000010", "g-000020", "g-000138"),
                       G2 = c("g-000300", "g-000330", "g-000660"),
                       G3 = c("g-000510", "g-000530", "g-000550",
                              "g-000570", "g-000590"))

  eDf <- geneSetEnrichment(clustersCoex = coexDF, groupMarkers = groupMarkers)

  expect_identical(nrow(eDf), length(groupMarkers))
  expect_identical(ncol(eDf), ncol(coexDF) + 2L)
  expect_lte(max(eDf[, 1L:(ncol(eDf) - 2L)]), 1L)
  expect_gte(min(eDf[, 1L:(ncol(eDf) - 2L)]), 0L)
  expect_gte(min(eDf[["N. total"]] - eDf[["N. detected"]]), 0L)
  expect_equal(eDf[["N. total"]], lengths(groupMarkers), ignore_attr = TRUE)

  checker <- new("AdvancedGDIUniformityCheck")
  checkers <- list(checker, shiftCheckerThresholds(checker, 0.1))

  suppressWarnings({
    c(mergedClusters, mergedCoexDF) %<-%
      mergeUniformCellsClusters(
        objCOTAN = obj, clusters = clusters,
        checkers = checkers, allCheckResults = data.frame(),
        batchSize = 1L, distance = "cosine", hclustMethod = "ward.D2",
        cores = 6L, optimizeForSpeed = TRUE, deviceStr = "cuda",
        saveObj = TRUE, outDir = tm)
  })
  expect_true(file.exists(file.path(tm, "test", "leafs_merge",
                                    "merge_clusterization_1.csv")))
  expect_true(file.exists(file.path(tm, "test", "leafs_merge",
                                    "merge_clusterization_4.csv")))
  expect_true(file.exists(file.path(tm, "test", "leafs_merge",
                                    "all_check_results_1.csv")))
  expect_true(file.exists(file.path(tm, "test", "leafs_merge",
                                    "all_check_results_4.csv")))
  expect_true(file.exists(file.path(tm, "test", "merge_check_results.csv")))
  expect_true(file.exists(file.path(tm, "test", "merge_clusterization.csv")))

  allCheckDF <- read.csv(file.path(tm, "test", "leafs_merge",
                                   "all_check_results_4.csv"),
                         header = TRUE, row.names = 1L)
  expect_identical(nrow(allCheckDF), 4L)
  expect_identical(ncol(allCheckDF), 35L)

  allCheckRes <- dfToCheckers(allCheckDF)

  expect_length(allCheckRes, nrow(allCheckDF))
  expect_named(allCheckRes)
  expect_true(all(stringr::str_ends(names(allCheckRes), fixed("-merge"))))
  expect_true(all(vapply(allCheckRes, methods::is,
                         logical(1L), "AdvancedGDIUniformityCheck")))
  expect_false(allCheckRes[[3L]]@isUniform)
  expect_true(is.finite(allCheckRes[[3L]]@firstCheck@fractionBeyond))
  expect_true(is.finite(allCheckRes[[3L]]@firstCheck@quantileAtRatio))

  expect_identical(nlevels(mergedClusters), 2L)
  expect_setequal(colnames(mergedCoexDF), mergedClusters)
  expect_identical(rownames(mergedCoexDF), getGenes(objCOTAN = obj))

  obj <- addClusterization(objCOTAN = obj,
                           clName = "merge", clusters = mergedClusters,
                           coexDF = mergedCoexDF, override = FALSE)

  expect_identical(reorderClusterization(objCOTAN = obj)[1L:2L],
                   list("clusters" = mergedClusters, "coex" = mergedCoexDF))

  mergedLfcDF <- logFoldChangeOnClusters(objCOTAN = obj, clName = "merge")

  expect_setequal(colnames(mergedLfcDF), mergedClusters)
  expect_identical(rownames(mergedLfcDF), getGenes(objCOTAN = obj))
  # with 2 clusters the changes are symmetric
  expect_equal(mergedLfcDF[[1L]], -mergedLfcDF[[2L]], tolerance = 1.0e-12)

  # Test the low GDI (homogeneity) for each defined clusters
  simpleChecker <- checkers[[2L]]@thirdCheck
  for (cl in levels(mergedClusters)[[1L]]) {
    cat(paste("Tested cluster:", cl))

    cellsToDrop <- names(clusters)[mergedClusters != cl]

    tmpObj <- dropGenesCells(objCOTAN = obj, cells = cellsToDrop)

    suppressWarnings({
      tmpObj <- proceedToCoex(objCOTAN = tmpObj, cores = 6L, saveObj = FALSE)
    })

    gdiData <- calculateGDI(objCOTAN = tmpObj)

    expect_lte(sum(gdiData[["GDI"]] >= simpleChecker@GDIThreshold),
               simpleChecker@maxRatioBeyond * nrow(gdiData))
  }

  gc()
})

options(prevOptState)

# ------ UMAPPlot -------

#' @details `UMAPPlot()` plots the given `data.frame` containing genes
#'   information related to clusters after applying the `umap` transformation
#'   via [Seurat::RunUMAP()]
#'
#' @param dataIn The `matrix` to plot. It must have a row names containing the
#'   given elements (the columns are features)
#' @param clusters The **clusterization**. Must be a named `array` aligned to
#'   the rows in the `matrix`.
#' @param elements a named `list` of elements to label. Each array in the list
#'   will be shown with a different color
#' @param title a string giving the plot title. Will default to `UMAP` Plot if
#'   not specified
#' @param colors an `array` of colors to use in the plot. If not sufficient
#'   colors are given it will complete the list using colors from
#'   [getColorsVector()]
#' @param numNeighbors Overrides the default `n_neighbors` value
#' @param minPointsDist Overrides the default `min_dist` value
#'
#' @returns `UMAPPlot()` returns a `ggplot2` object
#'
#' @importFrom ggplot2 ggplot
#' @importFrom ggplot2 geom_point
#' @importFrom ggplot2 geom_tile
#' @importFrom ggplot2 aes
#' @importFrom ggplot2 labs
#' @importFrom ggplot2 ggtitle
#' @importFrom ggplot2 scale_color_manual
#' @importFrom ggplot2 scale_fill_manual
#'
#' @importFrom ggrepel geom_text_repel
#' @importFrom ggrepel geom_label_repel
#'
#' @importFrom stats quantile
#'
#' @importFrom Seurat RunUMAP
#' @importFrom Seurat Embeddings
#'
#' @importFrom rlang set_names
#' @importFrom rlang is_empty
#'
#' @importFrom withr with_options
#'
#' @export
#'
#' @rdname HandlingClusterizations
#'
UMAPPlot <- function(dataIn,
                     clusters = NULL,
                     elements = NULL,
                     title = "",
                     colors = NULL,
                     numNeighbors = 0L,
                     minPointsDist = NaN) {
  startTime <- Sys.time()

  logThis("UMAP plot: START", logLevel = 2L)

  assert_that(!is_empty(rownames(dataIn)),
              msg = "UMAPPlot - input matrix must have proper row-names")

  assert_that(is_empty(clusters) ||
                identical(names(clusters), rownames(dataIn)),
              msg = paste("UMAPPlot - clusters' names must be the same",
                          "as the row-names of the input matrix"))

  # empty title
  if (isEmptyName(title)) {
    title <- "UMAP Plot"
  }

  entryType <- rep_len("none", nrow(dataIn))

  # assign a different color to each list of elements
  for (nm in names(elements)) {
    selec <- rownames(dataIn) %in% elements[[nm]]
    if (any(selec)) {
      entryType[selec] <- nm
    } else {
      logThis(paste("UMAPPlot - none of the elements in group", nm,
                    "is present: will be ignored"), logLevel = 1L)
    }
  }

  labelled <- entryType != "none"

  # assign a different color to each cluster
  clusters <- factor(clusters)
  for (cl in levels(clusters)) {
    selec <- !labelled & clusters == cl
    if (any(selec)) {
      entryType[selec] <- cl
    } else {
      logThis(paste("UMAPPlot - none of the elements of the cluster", cl,
                    "is present unlabelled: cluster will be ignored"),
              logLevel = 1L)
    }
    rm(selec)
  }

  clustered <- !labelled & entryType != "none"

  if (numNeighbors == 0L) {
    numNeighbors <- 30L
  }
  if (!is.finite(minPointsDist)) {
    minPointsDist <- 0.3
  }

  logThis("Calculating UMAP: START", logLevel = 3L)

  umap <- with_options(list(Seurat.warn.umap.uwot = FALSE),
    Embeddings(RunUMAP(as.matrix(dataIn),
                       assay = "Generic",
                       reduction.key = "UMAP_",
                       umap.method = "uwot",
                       n.neighbors = numNeighbors, #30L
                       n.components = 2L,
                       metric = "cosine",
                       learning.rate = 1.0,
                       min.dist = minPointsDist, # 0.3
                       uwot.sgd = FALSE,
                       seed.use = 42L,
                       verbose = TRUE)))

  plotDF <- data.frame(x = umap[, 1L],
                       y = umap[, 2L],
                       types = entryType)

  logThis("Calculating UMAP: DONE", logLevel = 3L)

  # add the centroids to the data.frame
  centroids <- rep(FALSE, times = nrow(plotDF))

  if (!is_empty(clusters)) {
    clList <- toClustersList(clusters)

    numericDF <- plotDF[, -3L]
    for (clName in names(clList)) {
      subsetDF <- as.matrix(numericDF[clList[[clName]], , drop = FALSE])
      plotDF <- rbind(plotDF, c(colMeans(subsetDF), clName))
      rownames(plotDF)[nrow(plotDF)] <- clName
    }

    numCl <- length(clList)
    centroids <- c(centroids, rep(TRUE, numCl))
    entryType <- c(as.character(entryType), rep("centroid", numCl))
    labelled <- c(labelled,  rep(FALSE, numCl))
    clustered <- c(clustered,  rep(FALSE, numCl))
    rm(numericDF, subsetDF, clList, clName, numCl)
  }

  # Ensure x and y columns are numeric
  plotDF[["x"]] <- as.numeric(plotDF[["x"]])
  plotDF[["y"]] <- as.numeric(plotDF[["y"]])
  plotDF[["types"]] <- factor(plotDF[["types"]])

  generic <- (!labelled & !clustered & !centroids)

  allTypes  <- c(unique(setdiff(entryType, c("none", "centroid"))),
                        "none", "centroid")
  myColours <- colors
  if (length(colors) < length(allTypes)) {
    if (!is_empty(colors)) {
      warning("UMAPPlot - not enough colors passed in")
    }
    numMissing <- length(allTypes) - length(myColours)
    myColours <- c(myColours, getColorsVector(numMissing))
    names(myColours) <- allTypes
    if (numMissing > 1L) {
      myColours[["none"]] <- "#8491B4B2"
    }
    myColours[["centroid"]] <- "#000000"
  } else {
    myColours <- myColours[seq_along(allTypes)]
    names(myColours) <- allTypes
  }

  assert_that(setequal(c(entryType, "none", "centroid"), names(myColours)))

  pointSize <- min(max(0.33, 5000.0 / nrow(plotDF)), 2.0)

  umapPl <-
    ggplot() +
    scale_color_manual("Status", values = myColours) +
    labs(x = "UMAP 1", y = "UMAP 2") +
    ggtitle(title) +
    plotTheme("UMAP", textSize = 10L)

  if (any(generic)) {
    umapPl <- umapPl +
      geom_point(data = plotDF[generic, , drop = FALSE],
                 aes(.data$x, .data$y, colour = .data$types),
                 size = pointSize, alpha = 0.3)
  }

  if (any(clustered | centroids)) {
    umapPl <- umapPl +
      geom_point(data = plotDF[clustered, , drop = FALSE],
                 aes(.data$x, .data$y, colour = .data$types),
                 size = pointSize, alpha = 0.5) +
      geom_text_repel(data = plotDF[centroids, , drop = FALSE],
                      aes(.data$x, .data$y, colour = "centroid"),
                      label = rownames(plotDF)[centroids],
                      max.overlaps = 40L, fontface = "bold",
                      show.legend = FALSE, alpha = 0.8)
  }
  if (any(labelled | clustered | centroids)) {
    umapPl <- umapPl +
      scale_fill_manual("Status", values = myColours)
  }

  if (any(labelled)) {
    umapPl <- umapPl +
      geom_point(data = plotDF[labelled, , drop = FALSE],
                 aes(.data$x, .data$y, colour = .data$types),
                 size = 1.2 * pointSize, alpha = 0.8) +
      geom_label_repel(data = plotDF[labelled, , drop = FALSE],
                       aes(.data$x, .data$y, fill = .data$types,
                           label = rownames(plotDF)[labelled]),
                       label.size = NA, show.legend = FALSE, force = 2.0,
                       box.padding = 0.25,
                       max.overlaps = 40L, alpha = 0.8,
                       direction = "both", na.rm = TRUE, seed = 1234L)
  } else {
    umapPl <- umapPl +
      theme(legend.position = "none")
  }

  endTime <- Sys.time()

  logThis(paste("Total calculations elapsed time:",
                difftime(endTime, startTime, units = "secs")),
          logLevel = 2L)

  logThis("UMAP plot: DONE", logLevel = 2L)

  return(umapPl)
}


# ------ cellsUMAPPlot -------

#' @details `cellsUMAPPlot()` returns a `ggplot2` plot where the given
#'   *clusters* are placed on the base of their relative distance. Also if
#'   needed calculates and stores the `DEA` of the relevant *clusterization*.
#'
#' @param objCOTAN a `COTAN` object
#' @param clName The name of the *clusterization*. If not given the last
#'   available *clusterization* will be returned, as it is probably the most
#'   significant!
#' @param clusters A *clusterization* to use. If given it will take precedence
#'   on the one indicated by `clName` that will only indicate the relevant
#'   column name in the returned `data.frame`
#' @param useCoexEigen Boolean to determine whether to project the data `matrix`
#'   onto the first eigenvectors of the **COEX** `matrix` or instead restrict
#'   the data `matrix` to the selected genes before applying the `PCA` reduction
#' @param dataMethod selects the method to use to create the `data.frame` to
#'   pass to the [UMAPPlot()]. See [getDataMatrix()] for more details.
#' @param numComp Number of components of the reduced `matrix`, it defaults to
#'   25L.
#' @param genesSel Decides whether and how to perform gene-selection. See
#'   [getSelectedGenes()] for more details.
#' @param numGenes the number of genes to select using the above method. Will be
#'   ignored when an explicit list of genes has been passed in
#' @param colors an `array` of colors to use in the plot. If not sufficient
#'   colors are given it will complete the list using colors from
#'   [getColorsVector()]
#' @param numNeighbors Overrides the default `n_neighbors` value
#' @param minPointsDist Overrides the default `min_dist` value
#'
#' @returns `cellsUMAPPlot()` returns a list with 2 objects:
#'  * `"plot"` a `ggplot2` object representing the `umap` plot
#'  * `"cellsRDM"` the *Reduced Data Matrix* used to create the plot
#'
#' @importFrom rlang is_empty
#'
#' @importFrom dplyr case_when
#'
#' @importFrom zeallot %<-%
#' @importFrom zeallot %->%
#'
#' @export
#'
#' @rdname HandlingClusterizations
#'
cellsUMAPPlot <- function(objCOTAN,
                          clName = "",
                          clusters = NULL,
                          useCoexEigen = FALSE,
                          dataMethod = "",
                          numComp = 25L,
                          genesSel = "",
                          numGenes = 200L,
                          colors = NULL,
                          numNeighbors = 0L,
                          minPointsDist = NA) {
  # pick last if no name was given
  # picks up the last clusterization if none was given
  c(clName, clusters) %<-%
    normalizeNameAndLabels(objCOTAN, name = clName,
                           labels = clusters, isCond = FALSE)

  if (is.null(clusters)) {
    logThis("No clusters given: using all dataset as one")
    clName <- "AllCells"
    clusters <- factor(set_names(rep("1", getNumCells(objCOTAN)),
                                 getCells(objCOTAN)))
  }

  assert_that(inherits(clusters, "factor"),
              msg = "Internal error - clusters must be factors")

  if (isEmptyName(genesSel)) {
    genesSel <- "HGDI" # this default could differ from the one in the selector
  }

  if (isEmptyName(dataMethod)) {
    dataMethod <- "LogNormalized"
  }

  cellsRDM <- calculateReducedDataMatrix(
    objCOTAN, useCoexEigen = useCoexEigen,
    dataMethod = dataMethod, numComp = numComp,
    genesSel = genesSel, numGenes = numGenes)

  tailMsg <-
    case_when(
      useCoexEigen           ~ "COEX eigenvectors projection",
      length(genesSel) == 1L ~ paste(genesSel, "genes selector"),
      .default =               "user provided genes"
    )

  umapTitle <- paste("UMAP of clusterization", clName,
                     "using", dataMethod, "matrix with", tailMsg)

  umapPlot <- UMAPPlot(cellsRDM,
                       clusters = clusters,
                       colors = colors,
                       numNeighbors = numNeighbors,
                       minPointsDist = minPointsDist,
                       title = umapTitle)

  return(list("plot" = umapPlot, "cellsRDM" = cellsRDM))
}

# ------- `COTAN` raw data accessors --------

#' @title Raw data `COTAN` accessors
#'
#' @description These methods extract information out of a just created `COTAN`
#'   object. The accessors have **read-only** access to the object.
#'
#' @name RawDataGetters
NULL


## -------- getRawData --------

#' @aliases getRawData
#'
#' @details `getRawData()` extracts the raw count table.
#'
#' @param objCOTAN a `COTAN` object
#'
#' @returns `getRawData()` returns the raw count sparse matrix
#'
#' @export
#'
#' @examples
#' data("test.dataset")
#' objCOTAN <- COTAN(raw = test.dataset)
#'
#' rawData <- getRawData(objCOTAN)
#'
#' @rdname RawDataGetters
#'
setMethod(
  "getRawData",
  "COTAN",
  function(objCOTAN) {
    return(objCOTAN@raw)
  }
)


## -------- getNumCells --------

#' @aliases getNumCells
#'
#' @details `getNumCells()` extracts the number of cells in the sample (\eqn{m})
#'
#' @param objCOTAN a `COTAN` object
#'
#' @returns `getNumCells()` returns the number of cells in the sample (\eqn{m})
#'
#' @export
#'
#' @examples
#' numCells <- getNumCells(objCOTAN)
#'
#' @rdname RawDataGetters
#'
setMethod(
  "getNumCells",
  "COTAN",
  function(objCOTAN) {
    return(ncol(objCOTAN@raw))
  }
)


## -------- getNumGenes --------

#' @aliases getNumGenes
#'
#' @details `getNumGenes()` extracts the number of genes in the sample (\eqn{n})
#'
#' @param objCOTAN a `COTAN` object
#'
#' @returns `getNumGenes()` returns the number of genes in the sample (\eqn{n})
#'
#' @export
#'
#' @examples
#' numGenes <- getNumGenes(objCOTAN)
#'
#' @rdname RawDataGetters
#'
setMethod(
  "getNumGenes",
  "COTAN",
  function(objCOTAN) {
    return(nrow(objCOTAN@raw))
  }
)


## -------- getCells --------

#' @aliases getCells
#'
#' @details `getCells()` extract all cells in the dataset.
#'
#' @param objCOTAN a `COTAN` object
#'
#' @returns `getCells()` returns a character array with the cells' names
#'
#' @export
#'
#' @examples
#' cellsNames <- getCells(objCOTAN)
#'
#' @rdname RawDataGetters
#'
setMethod(
  "getCells",
  "COTAN",
  function(objCOTAN) {
    return(colnames(objCOTAN@raw))
  }
)


## -------- getGenes --------

#' @aliases getGenes
#'
#' @details `getGenes()` extract all genes in the dataset.
#'
#' @param objCOTAN a `COTAN` object
#'
#' @returns `getGenes()` returns a character array with the genes' names
#'
#' @export
#'
#' @examples
#' genesNames <- getGenes(objCOTAN)
#'
#' @rdname RawDataGetters
#'
setMethod(
  "getGenes",
  "COTAN",
  function(objCOTAN) {
    return(rownames(objCOTAN@raw))
  }
)


## -------- getZeroOneProj --------

#' @aliases getZeroOneProj
#'
#' @details `getZeroOneProj()` extracts the raw count table where any
#'   positive number has been replaced with `1`
#'
#' @param objCOTAN a `COTAN` object
#'
#' @returns `getZeroOneProj()` returns the raw count matrix projected to `0` or
#'   `1`
#'
#' @export
#'
#' @examples
#' zeroOne <- getZeroOneProj(objCOTAN)
#'
#' @rdname RawDataGetters
#'
setMethod(
  "getZeroOneProj",
  "COTAN",
  function(objCOTAN) {
    return(sign(objCOTAN@raw))
  }
)


## -------- getCellsSize --------

#' @aliases getCellsSize
#'
#' @details `getCellsSize()` extracts the cell raw library size.
#'
#' @param objCOTAN a `COTAN` object
#'
#' @return `getCellsSize()` returns an array with the library sizes
#'
#' @export
#'
#' @importFrom Matrix colSums
#'
#' @examples
#' cellsSize <- getCellsSize(objCOTAN)
#'
#' @rdname RawDataGetters
#'
setMethod(
  "getCellsSize",
  "COTAN",
  function(objCOTAN) {
    return(colSums(objCOTAN@raw))
  }
)


## -------- getNumExpressedGenes --------

#' @aliases getNumExpressedGenes
#'
#' @details `getNumExpressedGenes()` extracts the number of genes expressed for
#'   each cell. Exploits a feature of [Matrix::CsparseMatrix-class]
#'
#' @param objCOTAN a `COTAN` object
#'
#' @return `getNumExpressedGenes()` returns an array with the library sizes
#'
#' @export
#'
#' @examples
#' numExpGenes <- getNumExpressedGenes(objCOTAN)
#'
#' @rdname RawDataGetters
#'
setMethod(
  "getNumExpressedGenes",
  "COTAN",
  function(objCOTAN) {
    # We expliot CsparseMatrix feature
    ret <- diff(objCOTAN@raw@p)
    names(ret) <- getCells(objCOTAN)
    return(ret)
  }
)


## -------- getGenesSize --------

#' @aliases getGenesSize
#'
#' @details `getGenesSize()` extracts the genes raw library size.
#'
#' @param objCOTAN a `COTAN` object
#'
#' @return `getGenesSize()` returns an array with the library sizes
#'
#' @export
#'
#' @importFrom Matrix rowSums
#'
#' @examples
#' genesSize <- getGenesSize(objCOTAN)
#'
#' @rdname RawDataGetters
#'
setMethod(
  "getGenesSize",
  "COTAN",
  function(objCOTAN) {
    return(rowSums(objCOTAN@raw))
  }
)


## -------- getNumOfExpressingCells --------

#' @aliases getNumOfExpressingCells
#'
#' @details `getNumOfExpressingCells()` extracts, for each gene, the number of
#'   cells that are expressing it. Exploits a feature of
#'   [Matrix::CsparseMatrix-class]
#'
#' @param objCOTAN a `COTAN` object
#'
#' @return `getNumOfExpressingCells()` returns an array with the library sizes
#'
#' @export
#'
#' @examples
#' numExpCells <- getNumOfExpressingCells(objCOTAN)
#'
#' @rdname RawDataGetters
#'
setMethod(
  "getNumOfExpressingCells",
  "COTAN",
  function(objCOTAN) {
    # We exploit CsparseMatrix feature
    ret <- diff(t(objCOTAN@raw)@p)
    names(ret) <- getGenes(objCOTAN)
    return(ret)
  }
)


# ---------- Handle meta-data --------

#' @title Handling *meta-data* in `COTAN` objects
#'
#' @description Much of the information stored in the `COTAN` object is
#'   compacted into three `data.frame`s:
#'   * `"metaDataset"` - contains all general information about the data-set
#'   * `"metaGenes"` - contains genes' related information along the `lambda`
#'     and `dispersion` vectors and the fully-expressed flag
#'   * `"metaCells"` - contains cells' related information along the `nu`
#'     vector, the fully-expressing flag, the *clusterizations* and the
#'     *conditions*
#'
#' @name HandleMetaData
NULL

## -------- getMetadataDataset --------

#' @aliases getMetadataDataset
#'
#' @details `getMetadataDataset()` extracts the meta-data stored for the
#'   current data-set.
#'
#' @param objCOTAN a `COTAN` object
#'
#' @returns `getMetadataDataset()` returns the meta-data `data.frame`
#'
#' @export
#'
#' @examples
#' options(parallelly.fork.enable = TRUE)
#'
#' data("test.dataset")
#' objCOTAN <- COTAN(raw = test.dataset)
#'
#' objCOTAN <- initializeMetaDataset(objCOTAN, GEO = "test_GEO",
#'                                   sequencingMethod = "distribution_sampling",
#'                                   sampleCondition = "reconstructed_dataset")
#'
#' objCOTAN <- addElementToMetaDataset(objCOTAN, "Test",
#'                                     c("These are ", "some values"))
#'
#' dataSetInfo <- getMetadataDataset(objCOTAN)
#'
#' @rdname HandleMetaData
#'
setMethod(
  "getMetadataDataset",
  "COTAN",
  function(objCOTAN) {
    return(objCOTAN@metaDataset)
  }
)

## -------- getMetadataElement --------

#' @aliases getMetadataElement
#'
#' @details `getMetadataElement()` extracts the value associated with the
#'   given tag if present or an empty string otherwise.
#'
#' @param objCOTAN a `COTAN` object
#' @param tag The tag associated to the wanted value
#'
#' @returns `getMetadataElement()` returns a string with the relevant value
#'
#' @export
#'
#' @examples
#' numInitialCells <- getMetadataElement(objCOTAN, datasetTags()[["cells"]])
#'
#' @rdname HandleMetaData
#'
setMethod(
  "getMetadataElement",
  "COTAN",
  function(objCOTAN, tag) {
    meta <- getMetadataDataset(objCOTAN)
    rowPos <- getMetaInfoRow(meta, tag)
    if (rowPos == 0L) {
      return("")
    } else {
      return(meta[, -1L, drop = FALSE][rowPos, ])
    }
  }
)

## -------- getMetadataGenes --------

#' @aliases getMetadataGenes
#'
#' @details `getMetadataGenes()` extracts the meta-data stored for the genes
#'
#' @param objCOTAN a `COTAN` object
#'
#' @returns `getMetadataGenes()` returns the genes' meta-data `data.frame`
#'
#' @export
#'
#' @examples
#' metaGenes <- getMetadataGenes(objCOTAN)
#'
#' @rdname HandleMetaData
#'
setMethod(
  "getMetadataGenes",
  "COTAN",
  function(objCOTAN) {
    return(objCOTAN@metaGenes)
  }
)


## -------- getMetadataCells --------

#' @aliases getMetadataCells
#'
#' @details `getMetadataCells()` extracts the meta-data stored for the cells
#'
#' @param objCOTAN a `COTAN` object
#'
#' @returns `getMetadataCells()` returns the cells' meta-data `data.frame`
#'
#' @export
#'
#' @examples
#' metaCells <- getMetadataCells(objCOTAN)
#'
#' @rdname HandleMetaData
#'
setMethod(
  "getMetadataCells",
  "COTAN",
  function(objCOTAN) {
    return(objCOTAN@metaCells)
  }
)


## -------- getDims --------

#' @aliases getDims
#'
#' @details `getDims()` extracts the sizes of all slots of the `COTAN` object
#'
#' @param objCOTAN a `COTAN` object
#'
#' @returns `getDims()` returns a named `list` with the sizes of the slots
#'
#' @export
#'
#' @examples
#' allSizes <- getDims(objCOTAN)
#'
#' @rdname HandleMetaData
#'
setMethod(
  "getDims",
  "COTAN",
  function(objCOTAN) {
    return(list("raw"          = dim(objCOTAN@raw),
                "genesCoex"    = dim(objCOTAN@genesCoex),
                "cellsCoex"    = dim(objCOTAN@cellsCoex),
                "metaDataset"  = nrow(objCOTAN@metaDataset),
                "metaGenes"    = ncol(objCOTAN@metaGenes),
                "metaCells"    = ncol(objCOTAN@metaCells),
                "clustersCoex" = length(objCOTAN@clustersCoex)))
  }
)


# ------- `COTAN` estimated data accessors ------

## -------- getNu --------

#' @aliases getNu
#'
#' @details `getNu()` extracts the `nu` array (normalized cells' counts
#'   averages)
#'
#' @param objCOTAN a `COTAN` object
#'
#' @returns `getNu()` returns the `nu` array
#'
#' @importFrom rlang is_empty
#'
#' @export
#'
#' @rdname ParametersEstimations
#'
setMethod(
  "getNu",
  "COTAN",
  function(objCOTAN) {
    nu <- getMetadataCells(objCOTAN)[["nu"]]

    if (is_empty(nu)) {
      warning("`nu` is empty")
    } else {
      names(nu) <- getCells(objCOTAN)
    }

    return(nu)
  }
)


## -------- getLambda --------

#' @aliases getLambda
#'
#' @details `getLambda()` extracts the `lambda` array (mean expression for each
#'   gene)
#'
#' @param objCOTAN a `COTAN` object
#'
#' @returns `getLambda()` returns the `lambda` array
#'
#' @importFrom rlang is_empty
#'
#' @export
#'
#' @rdname ParametersEstimations
#'
setMethod(
  "getLambda",
  "COTAN",
  function(objCOTAN) {
    lambda <- getMetadataGenes(objCOTAN)[["lambda"]]

    if (is_empty(lambda)) {
      warning("`lambda` is empty")
    } else {
      names(lambda) <- getGenes(objCOTAN)
    }

    return(lambda)
  }
)


## -------- getDispersion --------

#' @aliases getDispersion
#'
#' @details `getDispersion()` extracts the `dispersion` array (one value for
#'   each gene)
#'
#' @param objCOTAN a `COTAN` object
#'
#' @returns `getDispersion()` returns the `dispersion` array
#'
#' @importFrom rlang is_empty
#'
#' @export
#'
#' @rdname ParametersEstimations
#'
setMethod(
  "getDispersion",
  "COTAN",
  function(objCOTAN) {
    dispersion <- getMetadataGenes(objCOTAN)[["dispersion"]]

    if (is_empty(dispersion)) {
      warning("`dispersion` is empty")
    } else {
      names(dispersion) <- getGenes(objCOTAN)
    }

    return(dispersion)
  }
)


## -------- estimatorsAreReady --------

#' @details `estimatorsAreReady()` checks whether the estimators arrays
#'   `lambda`, `nu`, `dispersion` are available
#'
#' @param objCOTAN a `COTAN` object
#'
#' @returns `estimatorsAreReady()` returns a boolean specifying whether all
#'   three arrays are non-empty
#'
#' @importFrom rlang is_empty
#'
#' @export
#'
#' @rdname ParametersEstimations
#'
estimatorsAreReady <- function(objCOTAN) {
  anyEmptyArrays <- is_empty(getLambda(objCOTAN)) ||
                    is_empty(getNu(objCOTAN)) ||
                    is_empty(getDispersion(objCOTAN))
  if (anyEmptyArrays) {
    logThis(paste0("Estimators are not ready - array sizes: `lambda` ",
                   length(getLambda(objCOTAN)), ", `nu` ",
                   length(getNu(objCOTAN)), ", `dispersion` ",
                   length(getDispersion(objCOTAN))), logLevel = 2L)
  }
  return(!anyEmptyArrays)
}


## -------- getMu --------

#' @aliases getMu
#' @aliases calculateMu
#'
#' @details `getMu()` calculates the vector \eqn{\mu = \lambda \times
#'   \nu^T}
#'
#' @param objCOTAN a `COTAN` object
#'
#' @returns `getMu()` returns the `mu` matrix
#'
#' @importFrom rlang is_empty
#'
#' @export
#'
#' @rdname CalculatingCOEX
#'
getMu <- function(objCOTAN) {
  lambda <- suppressWarnings(getLambda(objCOTAN))
  assert_that(!is_empty(lambda),
              msg = "`lambda` must not be empty, estimate it")

  nu <- suppressWarnings(getNu(objCOTAN))
  assert_that(!is_empty(nu),
              msg = "`nu` must not be empty, estimate it")

  return(lambda %o% nu)
}


## -------- getNuNormData --------

#' @details `getNuNormData()` extracts the \eqn{\nu}*-normalized* count table
#'   (i.e. where each column is divided by `nu`) and returns it
#'
#' @param objCOTAN a `COTAN` object
#'
#' @returns `getNuNormData()` returns the \eqn{\nu}*-normalized* count
#'   `data.frame`
#'
#' @importFrom rlang is_empty
#'
#' @export
#'
#' @examples
#' nuNorm <- getNuNormData(objCOTAN)
#'
#' @rdname ParametersEstimations
#'
getNuNormData <- function(objCOTAN) {
  nu <- suppressWarnings(getNu(objCOTAN))
  assert_that(!is_empty(nu),
              msg = "`nu` must not be empty, estimate it")

  return(t(t(getRawData(objCOTAN)) * (1.0 / nu)))
}


## -------- getLogNormData --------

#' @details `getLogNormData()` extracts the *log-normalized* count table (i.e.
#'   where each column is divided by the [getCellsSize()]), takes its `log10`
#'   and returns it.
#'
#' @param objCOTAN a `COTAN` object
#' @param retLog When `TRUE` returns
#'
#' @returns `getLogNormData()` returns a `data.frame` after applying the formula
#'   \eqn{\log_{10}{(10^4 * x + 1)}} to the raw counts normalized by
#'   *cells-size*
#'
#' @export
#'
#' @examples
#' logNorm <- getLogNormData(objCOTAN)
#'
#' @rdname ParametersEstimations
#'
getLogNormData <- function(objCOTAN) {
  normData <- t(t(getRawData(objCOTAN)) * (1.0e4 / getCellsSize(objCOTAN)))

  return(log1p(normData) / log(10.0))
}


## -------- getNormalizedData --------

#' @details `getNormalizedData()` is deprecated: please use [getNuNormData()] or
#'   [getLogNormData()] directly as appropriate
#'
#' @param objCOTAN a `COTAN` object
#' @param retLog When `TRUE` calls [getLogNormData()], calls [getNuNormData()]
#'
#' @returns `getNormalizedData()` returns a `data.frame`
#'
#' @export
#'
#' @examples
#' logNorm <- getNormalizedData(objCOTAN, retLog = TRUE)
#'
#' @rdname ParametersEstimations
#'
getNormalizedData <- function(objCOTAN, retLog = FALSE) {
  if (retLog) {
    return(getLogNormData(objCOTAN))
  } else {
    return(getNuNormData(objCOTAN))
  }
}


## -------- getProbabilityOfZero --------

#' @details `getProbabilityOfZero()` gives for each cell and each gene the
#'   probability of observing zero reads
#'
#' @param objCOTAN a `COTAN` object
#'
#' @returns `getProbabilityOfZero()` returns a `data.frame` with the
#'   probabilities of zero
#'
#' @importFrom rlang is_empty
#'
#' @export
#'
#' @examples
#' probZero <- getProbabilityOfZero(objCOTAN)
#'
#' @rdname ParametersEstimations
#'
getProbabilityOfZero <- function(objCOTAN) {
  dispersion <- suppressWarnings(getDispersion(objCOTAN))
  assert_that(!is_empty(dispersion),
              msg = "`dispersion` must not be empty, estimate it")

  # estimate Probabilities of 0 with internal function funProbZero
  return(funProbZero(dispersion, getMu(objCOTAN)))
}


# ----------- Raw data cleaning ------------

#' @title Raw data cleaning
#'
#' @description These methods are to be used to clean the raw data. That is drop
#'   any number of genes/cells that are too sparse or too present to allow
#'   proper calibration of the `COTAN` model.
#'
#'   We call genes that are expressed in all cells *Fully-Expressed* while cells
#'   that express all genes in the data are called *Fully-Expressing*. In case
#'   it has been made quite easy to exclude the flagged genes/cells in the user
#'   calculations.
#'
#' @name RawDataCleaning
NULL

#' @aliases flagNotFullyExpressedGenes
#'
#' @details `flagNotFullyExpressedGenes()` returns a Boolean array with TRUE for
#'   those genes that are not fully-expressed.
#'
#' @param objCOTAN a `COTAN` object
#'
#' @returns `flagNotFullyExpressedGenes()` returns a Booleans array with TRUE
#'   for genes that are not fully-expressed
#'
#' @importFrom rlang is_empty
#' @importFrom rlang set_names
#'
#' @export
#'
#' @examples
#' library(zeallot)
#'
#' data("test.dataset")
#' objCOTAN <- COTAN(raw = test.dataset)
#'
#' genes.to.rem <- getGenes(objCOTAN)[grep('^MT', getGenes(objCOTAN))]
#' cells.to.rem <- getCells(objCOTAN)[which(getCellsSize(objCOTAN) == 0)]
#' objCOTAN <- dropGenesCells(objCOTAN, genes.to.rem, cells.to.rem)
#'
#' objCOTAN <- clean(objCOTAN)
#'
#' objCOTAN <- findFullyExpressedGenes(objCOTAN)
#' goodPos <- flagNotFullyExpressedGenes(objCOTAN)
#'
#' @rdname RawDataCleaning
#'
setMethod(
  "flagNotFullyExpressedGenes",
  "COTAN",
  function(objCOTAN) {
    if (is_empty(getMetadataGenes(objCOTAN)[["feGenes"]])) {
      return(set_names(rep(TRUE, getNumGenes(objCOTAN)), getGenes(objCOTAN)))
    } else {
      return(!getMetadataGenes(objCOTAN)[["feGenes"]])
    }
  }
)


#' @aliases flagNotFullyExpressingCells
#'
#' @details `flagNotFullyExpressingCells()`returns a Boolean vector with TRUE
#'   for those cells that are not expressing all genes
#'
#' @param objCOTAN a `COTAN` object
#'
#' @returns `flagNotFullyExpressingCells()` returns an array of Booleans with
#'   TRUE for cells that are not expressing all genes
#'
#' @importFrom rlang is_empty
#' @importFrom rlang set_names
#'
#' @export
#'
#' @examples
#' objCOTAN <- findFullyExpressingCells(objCOTAN)
#' goodPos <- flagNotFullyExpressingCells(objCOTAN)
#'
#' @rdname RawDataCleaning
#'
setMethod(
  "flagNotFullyExpressingCells",
  "COTAN",
  function(objCOTAN) {
    if (is_empty(getMetadataCells(objCOTAN)[["feCells"]])) {
      return(set_names(rep(TRUE, getNumCells(objCOTAN)), getCells(objCOTAN)))
    } else {
      return(!getMetadataCells(objCOTAN)[["feCells"]])
    }
  }
)


#' @aliases getFullyExpressedGenes
#'
#' @details `getFullyExpressedGenes()` returns the genes expressed in all cells
#'   of the dataset
#'
#' @param objCOTAN a `COTAN` object
#'
#' @returns `getFullyExpressedGenes()` returns an array containing all genes
#'   that are expressed in all cells
#'
#' @export
#'
#' @examples
#' feGenes <- getFullyExpressedGenes(objCOTAN)
#'
#' @rdname RawDataCleaning
#'
setMethod(
  "getFullyExpressedGenes",
  "COTAN",
  function(objCOTAN) {
    return(getGenes(objCOTAN)[!flagNotFullyExpressedGenes(objCOTAN)])
  }
)


#' @aliases getFullyExpressingCells
#'
#' @details `getFullyExpressingCells()` returns the cells that did express
#'   all genes of the dataset
#'
#' @param objCOTAN a `COTAN` object
#'
#' @returns `getFullyExpressingCells()` returns an array containing all cells
#'   that express all genes
#'
#' @export
#'
#' @examples
#' feCells <- getFullyExpressingCells(objCOTAN)
#'
#' @rdname RawDataCleaning
#'
setMethod(
  "getFullyExpressingCells",
  "COTAN",
  function(objCOTAN) {
    return(getCells(objCOTAN)[!flagNotFullyExpressingCells(objCOTAN)])
  }
)

# ------- `COTAN` coex data accessors ------

#' Calculating the COEX matrix for genes and cells
#'
#' @name CalculatingCOEX
NULL

## -------- getGenesCoex --------

#' @aliases getGenesCoex
#'
#' @details `getGenesCoex()` extracts a complete (or a partial after genes
#'   dropping) genes' `COEX` matrix from the `COTAN` object.
#'
#' @param objCOTAN a `COTAN` object
#' @param genes The given genes' names to select the wanted `COEX` columns. If
#'   missing all columns will be returned. When not empty a proper result is
#'   provided by calculating the partial `COEX` matrix on the fly
#' @param zeroDiagonal When TRUE the `COEX` of any element with itself is set to
#'   zero
#' @param ignoreSync When `TRUE` ignores whether the `lambda`/`nu`/`dispersion`
#'   have been updated since the `COEX` matrix was calculated.
#'
#' @returns `getGenesCoex()` returns the genes' `COEX` values
#'
#' @importFrom rlang is_empty
#'
#' @importFrom assertthat assert_that
#'
#' @export
#'
#' @examples
#' options(parallelly.fork.enable = TRUE)
#'
#' data("test.dataset")
#' objCOTAN <- COTAN(raw = test.dataset)
#' objCOTAN <- initializeMetaDataset(objCOTAN, GEO = "test_GEO",
#'                                   sequencingMethod = "distribution_sampling",
#'                                   sampleCondition = "reconstructed_dataset")
#' objCOTAN <- clean(objCOTAN)
#'
#' objCOTAN <- estimateLambdaLinear(objCOTAN)
#' objCOTAN <- estimateDispersionViaSolver(objCOTAN, cores = 6L)
#'
#' ## Now the `COTAN` object is ready to calculate the genes' `COEX`
#'
#' ## mu <- getMu(objCOTAN)
#' ## observedY <- observedContingencyTablesYY(objCOTAN, asDspMatrices = TRUE)
#' obs <- observedContingencyTables(objCOTAN, asDspMatrices = TRUE)
#'
#' ## expectedN <- expectedContingencyTablesNN(objCOTAN, asDspMatrices = TRUE)
#' exp <- expectedContingencyTables(objCOTAN, asDspMatrices = TRUE)
#'
#' objCOTAN <- calculateCoex(objCOTAN, actOnCells = FALSE)
#'
#' stopifnot(isCoexAvailable(objCOTAN))
#' genesCoex <- getGenesCoex(objCOTAN)
#' genesSample <- sample(getNumGenes(objCOTAN), 10)
#' partialGenesCoex <- calculatePartialCoex(objCOTAN, genesSample,
#'                                          actOnCells = FALSE)
#'
#' stopifnot(all(5.0e-6 >
#'                 abs(partialGenesCoex -
#'                       getGenesCoex(objCOTAN,
#'                                    getGenes(objCOTAN)[sort(genesSample)],
#'                                    zeroDiagonal = FALSE))))
#'
#' ## S <- calculateS(objCOTAN)
#' ## G <- calculateG(objCOTAN)
#' ## pValue <- calculatePValue(objCOTAN)
#' gdiDF <- calculateGDI(objCOTAN)
#' objCOTAN <- storeGDI(objCOTAN, genesGDI = gdiDF)
#'
#' ## Touching any of the `lambda`/`nu`/`dispersion` parameters invalidates the
#' ## `COEX` matrix and derivatives, so it can be dropped it from the `COTAN`
#' ## object
#' objCOTAN <- dropGenesCoex(objCOTAN)
#' stopifnot(!isCoexAvailable(objCOTAN))
#'
#'
#' objCOTAN <- estimateDispersionNuBisection(objCOTAN, cores = 6L)
#'
#' ## Now the `COTAN` object is ready to calculate the cells' `COEX`
#' ## In case one needs to calculate both, it is more sensible to run the above
#' ## before any `COEX` evaluation
#'
#' g1 <- getGenes(objCOTAN)[sample(getNumGenes(objCOTAN), 1)]
#' g2 <- getGenes(objCOTAN)[138L]
#' tables <- contingencyTables(objCOTAN, g1 = g1, g2 = g2)
#' tables
#'
#' objCOTAN <- calculateCoex(objCOTAN, actOnCells = TRUE,
#'                           optimizeForSpeed = FALSE)
#' stopifnot(isCoexAvailable(objCOTAN, actOnCells = TRUE, ignoreSync = TRUE))
#' cellsCoex <- getCellsCoex(objCOTAN, zeroDiagonal = FALSE)
#'
#' cellsSample <- sample(getNumCells(objCOTAN), 10)
#' partialCellsCoex <- calculatePartialCoex(objCOTAN, cellsSample,
#'                                          actOnCells = TRUE)
#'
#' stopifnot(all(1e-6 >
#'                 abs(partialCellsCoex - cellsCoex[, sort(cellsSample)])))
#'
#' objCOTAN <- dropCellsCoex(objCOTAN)
#' stopifnot(!isCoexAvailable(objCOTAN, actOnCells = TRUE))
#'
#' @rdname CalculatingCOEX
#'
setMethod(
  "getGenesCoex",
  "COTAN",
  function(objCOTAN, genes = vector(mode = "character"),
           zeroDiagonal = TRUE, ignoreSync = FALSE) {
    coexIsReady <- isCoexAvailable(objCOTAN, ignoreSync = ignoreSync)

    if (is_empty(genes)) {
      assert_that(coexIsReady,
                  msg = paste0("Cannot return genes' COEX as the matrix was ",
                               "never calculated or is out-of-sync with the ",
                               "estimators."))

      ret <- objCOTAN@genesCoex
      if (isTRUE(zeroDiagonal)) {
        diag(ret) <- 0.0
        ret <- pack(forceSymmetric(ret))
      }
      return(ret)
    } else {
      genes <- handleNamesSubsets(getGenes(objCOTAN), genes)

      ret <- objCOTAN@genesCoex

      if (!coexIsReady) {
        warning("Missing or out-of-sync genes' COEX:",
                "calculating the required subset now!")
        ret <- calculatePartialCoex(objCOTAN, columnsSubset = genes,
                                    actOnCells = FALSE)
      } else {
        ret <- ret[, genes, drop = FALSE]
      }

      if (isTRUE(zeroDiagonal)) {
        diag(ret[genes, , drop = FALSE]) <- 0.0
      }

      return(ret)
    }
  }
)


## -------- getCellsCoex --------

#' @aliases getCellsCoex
#'
#' @details `getCellsCoex()` extracts a complete (or a partial after cells
#'   dropping) cells' `COEX` matrix from the `COTAN` object.
#'
#' @param objCOTAN a `COTAN` object
#' @param cells The given cells' names to select the wanted `COEX` columns. If
#'   missing all columns will be returned. When not empty a proper result is
#'   provided by calculating the partial `COEX` matrix on the fly
#' @param zeroDiagonal When `TRUE` sets the diagonal to zero.
#' @param ignoreSync When `TRUE` ignores whether the `lambda`/`nu`/`dispersion`
#'   have been updated since the `COEX` matrix was calculated.
#'
#' @returns `getCellsCoex()` returns the cells' `COEX` values
#'
#' @importFrom rlang is_empty
#'
#' @export
#'
#' @rdname CalculatingCOEX
#'
setMethod(
  "getCellsCoex",
  "COTAN",
  function(objCOTAN, cells = vector(mode = "character"),
           zeroDiagonal = TRUE, ignoreSync = FALSE) {
    coexIsReady <- isCoexAvailable(objCOTAN, actOnCells = TRUE,
                                   ignoreSync = ignoreSync)

    if (is_empty(cells)) {
      assert_that(coexIsReady,
                  msg = paste0("Cannot return cells' COEX as the matrix was ",
                               "never calculated or is out-of-sync with the ",
                               "estimators."))

      ret <- objCOTAN@cellsCoex
      if (isTRUE(zeroDiagonal)) {
        diag(ret) <- 0.0
        ret <- pack(forceSymmetric(ret))
      }
      return(ret)
    } else {
      cells <- handleNamesSubsets(getCells(objCOTAN), cells)

      ret <- objCOTAN@cellsCoex

      if (!coexIsReady) {
        warning("Missing or out-of-sync cells' COEX:",
                "calculating the required subset now!")
        ret <- calculatePartialCoex(objCOTAN, columnsSubset = cells,
                                    actOnCells = TRUE)
      } else {
        ret <- ret[, cells, drop = FALSE]
      }

      if (isTRUE(zeroDiagonal)) {
        diag(ret[cells, , drop = FALSE]) <- 0.0
      }

      return(ret)
    }
  }
)


## -------- isCoexAvailable --------

#' @aliases isCoexAvailable
#'
#' @details `isCoexAvailable()` allows to query whether the relevant `COEX`
#'   matrix from the `COTAN` object is available to use
#'
#' @param objCOTAN a `COTAN` object
#' @param actOnCells Boolean; when `TRUE` the function works for the cells,
#'   otherwise for the genes
#' @param ignoreSync When `TRUE` ignores whether the `lambda`/`nu`/`dispersion`
#'   have been updated since the `COEX` matrix was calculated.
#'
#' @returns `isCoexAvailable()` returns whether relevant `COEX` matrix has been
#'   calculated and, in case, if it is still aligned to the estimators.
#'
#' @importFrom rlang is_empty
#'
#' @export
#'
#' @rdname CalculatingCOEX
#'
setMethod(
  "isCoexAvailable",
  "COTAN",
  function(objCOTAN, actOnCells = FALSE, ignoreSync = FALSE) {
    if (isTRUE(actOnCells)) {
      isInSync <-
        as.logical(getMetadataElement(objCOTAN, datasetTags()[["csync"]])[[1L]])

      return(!is_empty(objCOTAN@cellsCoex) &&
               (isTRUE(ignoreSync) || isTRUE(isInSync)))
    } else {
      isInSync <-
        as.logical(getMetadataElement(objCOTAN, datasetTags()[["gsync"]])[[1L]])

      return(!is_empty(objCOTAN@genesCoex) &&
               (isTRUE(ignoreSync) || isTRUE(isInSync)))
    }
  }
)


## -------- getGDI --------

#' @aliases getGDI
#'
#' @details `getGDI()` extracts the genes' `GDI` array as it was stored by the
#'   method [storeGDI()]
#'
#' @param objCOTAN a `COTAN` object
#'
#' @returns `getGDI()` returns the genes' `GDI`` array if available or `NULL`
#'   otherwise
#'
#' @importFrom rlang is_empty
#'
#' @export
#'
#' @rdname GenesStatistics
#'
setMethod(
  "getGDI",
  "COTAN",
  function(objCOTAN) {
    gdi <- getMetadataGenes(objCOTAN)[["GDI"]]

    if (is_empty(gdi)) {
      warning("no GDI data has been stored")
    } else {
      names(gdi) <- getGenes(objCOTAN)
    }

    return(gdi)
  }
)


## -------- getClusterizations --------

#' @aliases getClusterizations
#'
#' @details `getClusterizations()` extracts the list of the *clusterizations*
#'   defined in the `COTAN` object.
#'
#' @param objCOTAN a `COTAN` object
#' @param dropNoCoex When `TRUE` drops the names from the *clusterizations* with
#'   empty associated `COEX` `data.frame`
#' @param keepPrefix When `TRUE` returns the internal name of the
#'   *clusterization*: the one with the `CL_` prefix.
#'
#' @returns `getClusterizations()` returns a vector of *clusterization* names,
#'   usually without the `CL_` prefix
#'
#' @importFrom rlang is_empty
#'
#' @importFrom methods validObject
#'
#' @export
#'
#' @examples
#' data("test.dataset")
#' objCOTAN <- COTAN(raw = test.dataset)
#' objCOTAN <- proceedToCoex(objCOTAN, cores = 6L, calcCoex = TRUE,
#'                           optimizeForSpeed = TRUE, saveObj = FALSE)
#'
#' data("test.dataset.clusters1")
#' clusters <- test.dataset.clusters1
#'
#' coexDF <- DEAOnClusters(objCOTAN, clusters = clusters)
#'
#' groupMarkers <- list(G1 = c("g-000010", "g-000020", "g-000138",
#'                             "g-000150", "g-000160", "g-000170"),
#'                      G2 = c("g-000300", "g-000330", "g-000450",
#'                             "g-000460", "g-000470"),
#'                      G3 = c("g-000510", "g-000530", "g-000550",
#'                             "g-000570", "g-000590"))
#'
#' geneClusters <- rep(1:3, each = 240)[1:600]
#' names(geneClusters) <- getGenes(objCOTAN)
#'
#' umapPlot <- UMAPPlot(coexDF, clusters = NULL, elements = groupMarkers)
#' plot(umapPlot)
#'
#' objCOTAN <- addClusterization(objCOTAN, clName = "first_clusterization",
#'                               clusters = clusters, coexDF = coexDF)
#'
#' lfcDF <- logFoldChangeOnClusters(objCOTAN, clusters = clusters)
#' umapPlot2 <- UMAPPlot(lfcDF, clusters = geneClusters)
#' plot(umapPlot2)
#'
#' if (FALSE) {
#'   objCOTAN <- estimateNuLinearByCluster(objCOTAN, clusters = clusters)
#' }
#'
#' clSummaryPlotAndData <-
#'   clustersSummaryPlot(objCOTAN, clName = "first_clusterization",
#'                       plotTitle = "first clusterization")
#' plot(clSummaryPlotAndData[["plot"]])
#'
#' if (FALSE) {
#'   objCOTAN <- dropClusterization(objCOTAN, "first_clusterization")
#' }
#'
#' clusterizations <- getClusterizations(objCOTAN, dropNoCoex = TRUE)
#' stopifnot(length(clusterizations) == 1)
#'
#' cellsUmapPlotAndDF <- cellsUMAPPlot(objCOTAN, dataMethod = "LogLikelihood",
#'                                     useCoexEigen = TRUE, numComp = 25L,
#'                                     clName = "first_clusterization")
#' plot(cellsUmapPlotAndDF[["plot"]])
#'
#' enrichment <- geneSetEnrichment(clustersCoex = coexDF,
#'                                 groupMarkers = groupMarkers)
#'
#' clHeatmapPlotAndData <- clustersMarkersHeatmapPlot(objCOTAN, groupMarkers)
#' clHeatmapPlotAndData[["heatmapPlot"]]
#'
#' conditions <- as.integer(substring(getCells(objCOTAN), 3L))
#' conditions <- factor(ifelse(conditions <= 600, "L", "H"))
#' names(conditions) <- getCells(objCOTAN)
#'
#' objCOTAN <- addCondition(objCOTAN, condName = "High/Low",
#'                          conditions = conditions)
#'
#' clHeatmapPlotAndData2 <-
#'   clustersMarkersHeatmapPlot(objCOTAN, groupMarkers, kCuts = 2,
#'                              condNameList = list("High/Low"))
#' clHeatmapPlotAndData2[["heatmapPlot"]]
#'
#' @rdname HandlingClusterizations
#'
setMethod(
  "getClusterizations",
  "COTAN",
  function(objCOTAN, dropNoCoex = FALSE, keepPrefix = FALSE) {
    validObject(objCOTAN)

    clsCoex <- getClustersCoex(objCOTAN)

    if (isTRUE(dropNoCoex)) {
      emptyClsCoex <- vapply(clsCoex, is_empty, logical(1L))
      out <- names(clsCoex[!emptyClsCoex])
    } else {
      out <- names(clsCoex)
    }

    # drop the internal 'CL_' prefix
    if (isFALSE(keepPrefix)) {
      out <- substring(out, 4L)
    }

    return(out)
  }
)


## -------- getClusterizationName --------

#' @aliases getClusterizationName
#'
#' @details `getClusterizationName()` normalizes the given *clusterization* name
#'   or, if none were given, returns the name of last available *clusterization*
#'   in the `COTAN` object. It can return the *clusterization* **internal name**
#'   if needed
#'
#' @param objCOTAN a `COTAN` object
#' @param clName The name of the *clusterization*. If not given the last
#'   available
#'   *clusterization* will be returned, as it is probably the most significant!
#' @param keepPrefix When `TRUE` returns the internal name of the
#'   *clusterization*: the one with the `CL_` prefix.
#'
#' @returns `getClusterizationName()` returns the normalized *clusterization*
#'   name or `NULL` if no *clusterizations* are present
#'
#' @export
#'
#' @examples
#' clName <- getClusterizationName(objCOTAN)
#'
#' @rdname HandlingClusterizations
#'
setMethod(
  "getClusterizationName",
  "COTAN",
  function(objCOTAN, clName = "", keepPrefix = FALSE) {
    allClustNames <- getClusterizations(objCOTAN, keepPrefix = TRUE)

    if (isEmptyName(clName)) {
      # pick last clusterization
      outName <- allClustNames[length(allClustNames)]
    } else {
      outName <- clName
      if (!startsWith(clName, "CL_")) {
        outName <- paste0("CL_", clName)
      }
      assert_that(outName %in% allClustNames,
                  msg = paste0("Given cluster name '", clName,
                               "' is not among the stored clusterizations"))
    }

    # drop the internal 'CL_' prefix
    if (isFALSE(keepPrefix)) {
      outName <- substring(outName, 4L)
    }

    return(outName)
  }
)


## -------- getClusterizationData --------

#' @aliases getClusterizationData
#'
#' @details `getClusterizationData()` extracts the asked *clusterization* and
#'   its associated `COEX` `data.frame` from the `COTAN` object
#'
#' @param objCOTAN a `COTAN` object
#' @param clName The name of the *clusterization*. If not given the last
#'   available *clusterization* will be returned, as it is probably the most
#'   significant!
#'
#' @returns `getClusterizationData()` returns a `list` with 2 elements:
#'   * `"clusters"` the named cluster labels array
#'   * `"coex"` the associated `COEX` `data.frame`. This will be an **empty**
#'     `data.frame` when not specified for the relevant *clusterization*
#'
#' @export
#'
#' @importFrom rlang is_empty
#' @importFrom rlang set_names
#'
#' @examples
#' clusterDataList <- getClusterizationData(objCOTAN, clName = clName)
#'
#' @rdname HandlingClusterizations
#'
setMethod(
  "getClusterizationData",
  "COTAN",
  function(objCOTAN, clName = "") {
    internalName <- getClusterizationName(objCOTAN, clName = clName,
                                          keepPrefix = TRUE)

    # clName can still be empty if no clusterization was store in the objCOTAN
    assert_that(!isEmptyName(internalName),
                msg = "No clusterizations are present in the 'COTAN' object")

    clusters <- factor(set_names(getMetadataCells(objCOTAN)[[internalName]],
                                 getCells(objCOTAN)))

    coexDF <- getClustersCoex(objCOTAN)[[internalName]]

    return(list("clusters" = clusters, "coex" = coexDF))
  }
)


## -------- getClusters --------

#' @details `getClusters()` extracts the asked *clusterization* from the `COTAN`
#'   object
#'
#' @param objCOTAN a `COTAN` object
#' @param clName The name of the *clusterization*. If not given the last
#'   available *clusterization* will be returned, as it is probably the most
#'   significant!
#'
#' @returns `getClusters()` returns the named cluster labels array
#'
#' @export
#'
#' @examples
#' clusters <- getClusters(objCOTAN, clName = clName)
#'
#' @rdname HandlingClusterizations
#'
getClusters <- function(objCOTAN, clName = "") {
  return(getClusterizationData(objCOTAN, clName = clName)[["clusters"]])
}


## -------- getClustersCoex --------

#' @aliases getClustersCoex
#'
#' @details `getClustersCoex()` extracts the full `clusterCoex` member `list`
#'
#' @param objCOTAN a `COTAN` object
#'
#' @returns `getClustersCoex()` returns the list with a `COEX` `data.frame` for
#'   each *clusterization*. When not empty, each `data.frame` contains a `COEX`
#'   column for each *cluster*.
#'
#' @export
#'
#' @examples
#' allClustersCoexDF <- getClustersCoex(objCOTAN)
#'
#' @rdname HandlingClusterizations
#'
setMethod(
  "getClustersCoex",
  "COTAN",
  function(objCOTAN) {
    return(objCOTAN@clustersCoex)
  }
)


# ------- `COTAN` conditions data accessors ------

#' @title Handling cells' *conditions* and related functions
#'
#' @description These functions manage the *conditions*.
#'
#'   A *condition* is a set of **labels** that can be assigned to cells:
#'   one **label** per cell. This is especially useful in cases when the
#'   `data-set` is the result of merging multiple experiments' raw data
#'
#' @name HandlingConditions
NULL


## -------- getAllConditions --------

#' @aliases getAllConditions
#'
#' @details `getAllConditions()` extracts the list of the *conditions* defined
#'   in the `COTAN` object.
#'
#' @param objCOTAN a `COTAN` object
#' @param keepPrefix When `TRUE` returns the internal name of the
#'   *condition*: the one with the `COND_` prefix.
#'
#' @returns `getAllConditions()` returns a vector of *conditions* names,
#'   usually without the `COND_` prefix
#'
#' @importFrom rlang is_empty
#'
#' @importFrom methods validObject
#'
#' @export
#'
#' @examples
#' data("test.dataset")
#' objCOTAN <- COTAN(raw = test.dataset)
#'
#' cellLine <- rep(c("A", "B"), getNumCells(objCOTAN) / 2)
#' names(cellLine) <- getCells(objCOTAN)
#' objCOTAN <- addCondition(objCOTAN, condName = "Line", conditions = cellLine)
#'
#' if (FALSE) {
#'   objCOTAN <- dropCondition(objCOTAN, "Genre")
#' }
#'
#' conditionsNames <- getAllConditions(objCOTAN)
#'
#' @rdname HandlingConditions
#'
setMethod(
  "getAllConditions",
  "COTAN",
  function(objCOTAN, keepPrefix = FALSE) {
    validObject(objCOTAN)

    cNames <- colnames(getMetadataCells(objCOTAN))
    areCondNames <- vapply(cNames, startsWith, logical(1L), "COND_")
    out <- cNames[areCondNames]

    # drop the internal 'COND_' prefix
    if (isFALSE(keepPrefix)) {
      out <- substring(out, 6L)
    }

    return(out)
  }
)


## -------- getConditionName --------

#' @aliases getConditionName
#'
#' @details `getConditionName()` normalizes the given *condition* name or, if
#'   none were given, returns the name of last available *condition* in the
#'   `COTAN` object. It can return the *condition* **internal name** if needed
#'
#' @param objCOTAN a `COTAN` object
#' @param condName The name of the *condition*. If not given an empty string
#'   will be returned!
#' @param keepPrefix When `TRUE` returns the internal name of the
#'   *condition*: the one with the `COND_` prefix.
#'
#' @returns `getConditionName()` returns the normalized *condition* name or
#'   `NULL` if no *conditions* are present
#'
#' @export
#'
#' @examples
#' condName <- getConditionName(objCOTAN)
#'
#' @rdname HandlingConditions
#'
setMethod(
  "getConditionName",
  "COTAN",
  function(objCOTAN, condName = "", keepPrefix = FALSE) {
    allCondNames <- getAllConditions(objCOTAN, keepPrefix = TRUE)

    if (isEmptyName(condName)) {
      # return a default name
      outName <- "COND_"
    } else {
      outName <- condName
      if (!startsWith(condName, "COND_")) {
        outName <- paste0("COND_", condName)
      }
      assert_that(outName %in% allCondNames,
                  msg = paste0("Given condition name '", condName,
                               "' is not among the stored conditions"))
    }

    # drop the internal 'COND_' prefix
    if (isFALSE(keepPrefix)) {
      outName <- substring(outName, 6L)
    }

    return(outName)
  }
)


## -------- getCondition --------

#' @aliases getCondition
#'
#' @details `getCondition()` extracts the asked *condition* from the `COTAN`
#'   object
#'
#' @param objCOTAN a `COTAN` object
#' @param condName The name of the *condition*. If not given a dummy constant
#'   **label** *condition* will be returned.
#'
#' @returns `getCondition()` returns a named `factor` with the *condition*
#'
#' @export
#'
#' @importFrom rlang is_empty
#' @importFrom rlang set_names
#'
#' @examples
#' condition <- getCondition(objCOTAN, condName = condName)
#' isa(condition, "factor")
#'
#' @rdname HandlingConditions
#'
setMethod(
  "getCondition",
  "COTAN",
  function(objCOTAN, condName = "") {
    internalName <- getConditionName(objCOTAN, condName = condName,
                                     keepPrefix = TRUE)

    if (internalName == "COND_") {
      # no corresponding condition
      conditions <- factor(rep_len("NoCond", getNumCells(objCOTAN)))
    } else {
      conditions <- getMetadataCells(objCOTAN)[[internalName]]
    }

    return(set_names(conditions, getCells(objCOTAN)))
  }
)


## -------- normalizeNameAndLabels --------

#' @details `normalizeNameAndLabels()` takes a pair of name/labels and
#'   normalize them based on the available information in the `COTAN` object
#'
#' @param objCOTAN a `COTAN` object
#' @param name the name of the *clusterization*/*condition*. If not given the
#'   last available *clusterization* will be used, or no *conditions*
#' @param labels a *clusterization*/*condition* to use. If given it will take
#'   precedence on the one indicated by `name`
#' @param isCond a Boolean to indicate whether the function is dealing with
#'   *clusterizations* [`FALSE`] or *conditions* [`TRUE`]
#'
#' @returns `normalizeNameAndLabels()` returns a `list` with:
#'   * `"name"` the relevant name
#'   * `"labels"` the relevant *clusterization*/*condition*
#'
#' @export
#'
#' @importFrom rlang is_empty
#' @importFrom rlang set_names
#'
#' @importFrom assertthat assert_that
#'
#' @examples
#' nameAndCond <- normalizeNameAndLabels(objCOTAN, name = condName,
#'                                       isCond = TRUE)
#' isa(nameAndCond[["labels"]], "factor")
#'
#' @rdname HandlingConditions
#'
normalizeNameAndLabels <- function(objCOTAN, name = "",
                                   labels = NULL, isCond = FALSE) {
  if (is_empty(labels)) {
    if (isFALSE(isCond)) {
      name <- getClusterizationName(objCOTAN, clName = name)
      labels <- getClusters(objCOTAN, clName = name)
    } else {
      name <- getConditionName(objCOTAN, condName = name)
      labels <- getCondition(objCOTAN, condName = name)
    }
  } else {
    assert_that(!is_empty(names(labels)),
                msg = "No names attached to the given labels")
    assert_that(setequal(names(labels), getCells(objCOTAN)),
                msg = "Non compatible labels")

    if (isEmptyName(name)) {
      name <- "DummyName"
    }

    if (!inherits(labels, "factor")) {
      labels <- factor(labels)
    }
  }
  return(list("name" = name, "labels" = labels))
}

prevOptState <- options(parallelly.fork.enable = TRUE)

test_that("metaDataset", {
  raw <- matrix(c(1L,  0L, 4L, 2L, 11L, 0L, 6L, 7L, 0L, 9L,
                  10L, 8L, 0L, 0L,  0L, 3L, 0L, 0L, 2L, 0L),
                nrow = 10L, ncol = 20L)
  rownames(raw) <- LETTERS[1L:10L]
  colnames(raw) <- letters[1L:20L]

  obj <- COTAN(raw = raw)
  obj <- initializeMetaDataset(obj, GEO = "V", sequencingMethod = "10X",
                               sampleCondition = "Test")

  genesCoexInSync <- getMetadataElement(obj, datasetTags()[["gsync"]])
  cellsCoexInSync <- getMetadataElement(obj, datasetTags()[["csync"]])

  expect_identical(c(genesCoexInSync, genesCoexInSync), c("FALSE", "FALSE"))

  meta <- getMetadataDataset(obj)

  expect_equal(meta[[1L]], head(datasetTags(), 6L), ignore_attr = TRUE)
  expect_identical(meta[[2L]], c("V", "10X", "Test", "20",
                                 genesCoexInSync, cellsCoexInSync))

  obj <- addElementToMetaDataset(obj, tag = "Tag_1", value = 1L)
  obj <- addElementToMetaDataset(obj, tag = "Tag_2", value = "Test")
  obj <- addElementToMetaDataset(obj, tag = "Tag_3",
                                 value = c("Array", "of", "strings"))

  meta <- getMetadataDataset(obj)

  expect_identical(meta[nrow(meta) - 2L, 2L], "1")
  expect_identical(meta[nrow(meta) - 1L, 2L], "Test")
  expect_equal(getMetadataElement(obj, "Tag_3"),
               list("Array", "of", "strings"), ignore_attr = TRUE)
})


test_that("Fully-expressed Genes and Fully-expressing Cells", {
  raw <- matrix(c(1L,  0L, 4L, 2L, 11L, 0L, 6L, 7L, 0L, 9L,
                  10L, 8L, 0L, 0L,  0L, 3L, 0L, 0L, 2L, 0L),
                nrow = 10L, ncol = 20L)
  rownames(raw) <- LETTERS[1L:10L]
  colnames(raw) <- letters[1L:20L]

  obj <- COTAN(raw = raw)

  obj <- findFullyExpressedGenes(obj)

  expect_identical(flagNotFullyExpressedGenes(obj),
                   c(FALSE, rep(TRUE, getNumGenes(obj) - 1L)))
  expect_identical(getFullyExpressedGenes(obj), LETTERS[[1L]])

  obj <- findFullyExpressingCells(obj)

  expect_identical(flagNotFullyExpressingCells(obj),
                   rep(TRUE, getNumCells(obj)))
  expect_identical(getFullyExpressingCells(obj), vector(mode = "character"))
})


test_that("dropGenesCells", {
  raw <- matrix(c(1L,  0L, 4L, 2L, 11L, 0L, 6L, 7L, 0L, 9L,
                  10L, 8L, 0L, 0L,  0L, 3L, 0L, 0L, 2L, 0L),
                nrow = 10L, ncol = 20L)
  rownames(raw) <- LETTERS[1L:10L]
  colnames(raw) <- letters[1L:20L]

  tags <- c("GEO:", "scRNAseq method:",
            "starting n. of cells:", "Condition sample:")

  obj <- COTAN(raw = raw)
  obj <- initializeMetaDataset(obj, GEO = "V", sequencingMethod = "10X",
                               sampleCondition = "Test")
  obj <- clean(obj)

  obj <- estimateLambdaLinear(obj)
  obj <- estimateDispersionNuBisection(obj, cores = 4L,
                                       enforceNuAverageToOne = TRUE)
  suppressWarnings({
    obj <- calculateCoex(obj, actOnCells = FALSE, optimizeForSpeed = TRUE)
  })
  expect_no_warning({
    obj <- calculateCoex(obj, actOnCells = TRUE, optimizeForSpeed = FALSE)
  })

  gdiDF <- calculateGDI(obj)
  obj <- storeGDI(obj, getColumnFromDF(gdiDF, "GDI"))
  expect_equal(gdiDF[, "GDI"], getGDI(obj), ignore_attr = TRUE)

  obj <- dropGenesCoex(obj)

  expect_error(getGenesCoex(obj))
  genesSel <- c("F", "D", "A", "C")
  expect_identical(dim(suppressWarnings(getGenesCoex(obj, genes = genesSel))),
                   c(getNumGenes(obj), 4L))
  expect_false(is_empty(getCellsCoex(obj)))

  obj <- dropCellsCoex(obj)

  expect_error(getCellsCoex(obj))
  cellsSel <- c("f", "d", "a", "c")
  expect_identical(dim(suppressWarnings(getCellsCoex(obj, cells = cellsSel))),
                   c(getNumCells(obj), 4L))

  obj <- dropGenesCells(obj, genes = LETTERS[8L:9L])

  expect_identical(getNumGenes(obj), 8L)
  expect_false(any(getGenes(obj) %in% LETTERS[8L:9L]))
  expect_identical(getCells(obj), letters[1L:20L])

  obj <- dropGenesCells(obj, cells = c(letters[8L:9L], letters[18L:19L]))

  expect_identical(getNumCells(obj), 16L)
  expect_false(any(getCells(obj) %in% c(letters[8L:9L], letters[18L:19L])))
  expect_false(any(getGenes(obj) %in% LETTERS[8L:9L]))

  obj <- dropGenesCells(obj, genes = LETTERS[6L:7L], cells = letters[6L:7L])

  expect_identical(getNumGenes(obj), 6L)
  expect_false(any(getGenes(obj) %in% LETTERS[6L:9L]))
  expect_identical(getNumCells(obj), 14L)
  expect_false(any(getCells(obj) %in% c(letters[6L:9L], letters[18L:19L])))
})


test_that("Managed clusterizations and conditions", {
  raw <- matrix(c(1L,  0L, 4L, 2L, 11L, 0L, 6L, 7L, 0L, 9L,
                  10L, 8L, 0L, 0L,  0L, 3L, 0L, 0L, 2L, 0L),
                nrow = 10L, ncol = 20L)
  rownames(raw) <- LETTERS[1L:10L]
  colnames(raw) <- letters[1L:20L]

  obj <- COTAN(raw = raw)

  clusters <- factor(set_names(rep(1L:2L, 10L), getCells(obj)))
  obj <- addClusterization(obj, clName = "Test",
                           clusters = clusters)

  expect_identical(getClusterizations(obj), "Test")
  expect_length(getClusterizations(obj, dropNoCoex = TRUE), 0L)
  expect_identical(colnames(getMetadataCells(obj)), "CL_Test")
  expect_identical(rownames(getMetadataCells(obj)), getCells(obj))
  expect_identical(getClusters(obj), clusters)

  obj <- estimateNuLinear(obj)

  expect_identical(colnames(getMetadataCells(obj)), c("CL_Test", "nu"))

  coexDF <-
    set_names(as.data.frame(atan(getNuNormData(obj)[, 1L:2L] - 0.5) / pi * 2.0),
              1L:2L)

  obj <- addClusterizationCoex(obj, clName = "Test", coexDF)

  expect_identical(getClusterizations(obj, dropNoCoex = TRUE,
                                      keepPrefix = TRUE), "CL_Test")
  expect_identical(getClusterizationData(obj)[["coex"]], coexDF)

  clusters2 <- factor(set_names(rep(c("2", "1"), 10L), getCells(obj)))
  coexDF2 <-
    set_names(as.data.frame(atan(getNuNormData(obj)[, 1L:2L] - 0.7) / pi * 2.0),
              c("1", "2"))

  obj <- addClusterization(obj, clName = "Test2",
                           clusters = clusters2,
                           coexDF = coexDF2)

  expect_named(getClustersCoex(obj), c("CL_Test", "CL_Test2"))
  expect_identical(getClusterizations(obj), c("Test", "Test2"))
  expect_identical(colnames(getMetadataCells(obj)),
                   c("CL_Test", "nu", "CL_Test2"))
  expect_identical(getClusterizationData(obj),
                   list("clusters" = clusters2, "coex" = coexDF2))
  expect_identical(getClusterizationData(obj, clName = "Test"),
                   list("clusters" = clusters, "coex" = coexDF))

  obj <- dropClusterization(obj, "Test")

  expect_named(getClustersCoex(obj), "CL_Test2")
  expect_identical(getClusterizations(obj), "Test2")
  expect_identical(colnames(getMetadataCells(obj)), c("nu", "CL_Test2"))
  expect_identical(getClusterizationData(obj),
                   list("clusters" = clusters2, "coex" = coexDF2))

  genre <- factor(set_names(rep(c("F", "M"), 10L), getCells(obj)))

  obj <- addCondition(obj, condName = "Test", conditions = genre)

  expect_identical(getAllConditions(obj), "Test")
  expect_identical(colnames(getMetadataCells(obj)),
                   c("nu", "CL_Test2", "COND_Test"))
  expect_identical(levels(getCondition(obj)), "NoCond")
  expect_identical(getCondition(obj, condName = "Test"), genre)

  obj <- dropCondition(obj, condName = "Test")

  expect_identical(getAllConditions(obj), vector(mode = "character"))
  expect_identical(colnames(getMetadataCells(obj)), c("nu", "CL_Test2"))

  # no such clusterization/condition
  expect_error(getClusterizationData(obj, clName = "Test"))
  expect_error(getClusters(obj, clName = "Test"))
  expect_error(getCondition(obj, condName = "Test"))

  # empty name clusterization/condition
  expect_error(addClusterization(obj, clName = "", clusters = rep(0L, 20L)))
  expect_error(addCondition(obj, condName = "", conditions = rep(0L, 20L)))

  # no names in clusterization
  expect_error(addClusterization(obj, clName = "Test", clusters = rep(0L, 20L)))
  expect_error(addCondition(obj, condName = "Cond", conditions = rep(0L, 20L)))

  # already existing clusterization
  expect_error(addClusterization(obj, clName = "Test2",
                                 clusters = clusters2))

  # wrong clusters/conditions size
  expect_error(addClusterization(obj, clName = "Test", clusters = rep(0L, 17L)))
  expect_error(addCondition(obj, condName = "Test", conditions = rep("A", 17L)))

  # wrong COEX data.frame size
  expect_error(addClusterization(obj, clName = "Test",
                                 clusters = clusters,
                                 coexDF = coexDF[1L:8L, ]))

  # wrong COEX data.frame column names
  expect_error(addClusterization(obj, clName = "Test",
                                 clusters = rep(c("3", "4"), 20L),
                                 coexDF = coexDF))
})

options(prevOptState)

#'
#' @aliases proceedToCoex
#'
#' @details `proceedToCoex()` takes a newly created `COTAN` object (or the
#'   result of a call to `dropGenesCells()`) and runs [calculateCoex()]
#'
#' @param objCOTAN a newly created `COTAN` object
#' @param calcCoex a Boolean to determine whether to calculate the genes' `COEX`
#'   or stop just before at the [estimateDispersionViaSolver()] step
#' @param optimizeForSpeed Boolean; when `TRUE` `COTAN` tries to use the `torch`
#'   library to run the matrix calculations. Otherwise, or when the library is
#'   not available will run the slower legacy code
#' @param deviceStr On the `torch` library enforces which device to use to run
#'   the calculations. Possible values are `"cpu"` to us the system *CPU*,
#'   `"cuda"` to use the system *GPUs* or something like `"cuda:0"` to restrict
#'   to a specific device
#' @param cores number of cores to use. Default is 1.
#' @param cellsCutoff `clean()` will delete from the `raw` data any gene that is
#'   expressed in less cells than threshold times the total number of cells.
#'   Default cutoff is \eqn{0.003 \; (0.3\%)}
#' @param genesCutoff `clean()` will delete from the `raw` data any cell that is
#'   expressing less genes than threshold times the total number of genes.
#'   Default cutoff is \eqn{0.002 \; (0.2\%)}
#' @param cellsThreshold any gene that is expressed in more cells than threshold
#'   times the total number of cells will be marked as **fully-expressed**.
#'   Default threshold is \eqn{0.99 \; (99.0\%)}
#' @param genesThreshold any cell that is expressing more genes than threshold
#'   times the total number of genes will be marked as **fully-expressing**.
#'   Default threshold is \eqn{0.99 \; (99.0\%)}
#' @param saveObj Boolean flag; when `TRUE` saves intermediate analyses and
#'   plots to file
#' @param outDir an existing directory for the analysis output.
#'
#' @returns `proceedToCoex()` returns the updated `COTAN` object with genes'
#'   `COEX` calculated. If asked to, it will also store the object, along all
#'   relevant clean-plots, in the output directory.
#'
#' @export
#'
#' @importFrom utils write.csv
#'
#' @importFrom stats time
#'
#' @importFrom grDevices pdf
#' @importFrom grDevices dev.off
#' @importFrom grDevices dev.cur
#'
#' @importFrom ggplot2 annotate
#'
#' @examples
#' options(parallelly.fork.enable = TRUE)
#'
#' #
#' # In case one needs to run more steps to clean the datatset
#' # the following might apply
#' if (FALSE) {
#'   objCOTAN <- initializeMetaDataset(objCOTAN,
#'                                     GEO = "test",
#'                                     sequencingMethod = "artificial",
#'                                     sampleCondition = "test dataset")
#' #
#' # doing all the cleaning...
#' #
#' # in case the genes' `COEX` is not needed it can be skipped
#' # (e.g. when calling [cellsUniformClustering()])
#'   objCOTAN <- proceedToCoex(objCOTAN, calcCoex = FALSE,
#'                             cores = 6L, optimizeForSpeed = TRUE,
#'                             deviceStr = "cuda", saveObj = FALSE)
#' }
#'
#' @rdname COTAN_ObjectCreation
#'
setMethod(
  "proceedToCoex",
  "COTAN",
  function(objCOTAN,
           calcCoex = TRUE,
           optimizeForSpeed = TRUE,
           deviceStr = "cuda",
           cores = 1L,
           cellsCutoff = 0.003,
           genesCutoff = 0.002,
           cellsThreshold = 0.99,
           genesThreshold = 0.99,
           saveObj = FALSE,
           outDir = ".") {
    startTime <- Sys.time()

    logThis("COTAN dataset analysis: START", logLevel = 1L)

    objCOTAN <- clean(objCOTAN, cellsCutoff, genesCutoff,
                      cellsThreshold, genesThreshold)

    if (isTRUE(saveObj)) tryCatch({
      if (!dir.exists(outDir)) {
        dir.create(file.path(outDir))
      }

      cond <- getMetadataElement(objCOTAN, datasetTags()[["cond"]])

      outDirCond <- file.path(outDir, cond)
      if (!dir.exists(outDirCond)) {
        dir.create(outDirCond)
      }

      outDirCleaning <- file.path(outDirCond, "cleaning")
      if (!dir.exists(outDirCleaning)) {
        dir.create(outDirCleaning)
      }

      plots <- cleanPlots(objCOTAN)

      if (TRUE) {
        numIter <- 1L
        pdf(file.path(outDirCleaning,
                      paste0(cond, "_", numIter,
                             "_plots_without_cleaning.pdf")))
        plot(plots[["pcaCells"]])
        plot(plots[["genes"]])
        dev.off()
      }

      if (TRUE) {
        pdf(file.path(outDirCleaning,
                      paste0(cond, "_plots_PCA_efficiency_colored.pdf")))
        plot(plots[["UDE"]])
        dev.off()
      }

      if (TRUE) {
        pdf(file.path(outDirCleaning,
                      paste0(cond, "_plots_efficiency.pdf")))
        plot(plots[["nu"]] +
               annotate(geom = "text", x = 50L, y = 0.25,
                        label = "nothing to remove ", color = "darkred"))
        dev.off()
      }

      rm(plots)
    }, error = function(err) {
      logThis(paste("While saving the clean plots", err), logLevel = 1L)
    }, finally = {
      # Check for active device
      if (dev.cur() > 1L) {
        dev.off()
      }
    })

    gc()

    startEstimTime <- Sys.time()
    cleanTime <- difftime(startEstimTime, startTime, units = "secs")
    logThis(paste("Dataset cleaning elapsed time:", cleanTime),
            logLevel = 3L)

    objCOTAN <- estimateLambdaLinear(objCOTAN)
    objCOTAN <- estimateDispersionViaSolver(objCOTAN, cores = cores)

    gc()

    startCoexTime <- Sys.time()
    analysisTime <- difftime(startCoexTime, startEstimTime, units = "secs")
    logThis(paste("Model parameter estimation elapsed time:", analysisTime),
            logLevel = 3L)

    if (isTRUE(calcCoex)) {
      logThis("COTAN genes' COEX estimation: START", logLevel = 2L)

      objCOTAN <- calculateCoex(objCOTAN, actOnCells = FALSE,
                                optimizeForSpeed = optimizeForSpeed,
                                deviceStr = deviceStr)

    } else {
      logThis("COTAN genes' COEX estimation not requested", logLevel = 2L)
    }

    gc()

    endTime <- Sys.time()
    genesCoexTime <- difftime(endTime, startCoexTime, units = "secs")
    logThis(paste("Only genes' COEX elapsed time:", genesCoexTime),
            logLevel = 3L)

    totalTime <- difftime(endTime, startTime, units = "secs")
    logThis(paste("Dataset analysis elapsed time:", totalTime), logLevel = 3L)

    logThis("COTAN dataset analysis: DONE", logLevel = 1L)

    if (saveObj) {
      utils::write.csv(data.frame("type"  = c("total_time",
                                              "clean_time",
                                              "analysis_time",
                                              "genes_coex_time"),
                                  "times" = c(as.numeric(totalTime),
                                              as.numeric(cleanTime),
                                              as.numeric(analysisTime),
                                              as.numeric(genesCoexTime)),
                                  "n.cells" = getNumCells(objCOTAN),
                                  "n.genes" = getNumGenes(objCOTAN)),
                       file = file.path(outDir, paste0(cond, "_times.csv")))

      logThis(paste("Saving elaborated data locally at:",
                    file.path(outDir, paste0(cond, ".cotan.RDS"))),
              logLevel = 1L)
      saveRDS(objCOTAN, file = file.path(outDir, paste0(cond, ".cotan.RDS")))
    }


    return(objCOTAN)
  }
)

#' @details `automaticCOTANObjectCreation()` takes a raw dataset, creates and
#'   initializes a `COTAN` object and runs [proceedToCoex()]
#'
#' @param raw a matrix or dataframe with the raw counts
#' @param GEO a code reporting the GEO identification or other specific dataset
#'   code
#' @param sequencingMethod a string reporting the method used for the sequencing
#' @param sampleCondition a string reporting the specific sample condition or
#'   time point.
#' @param calcCoex a Boolean to determine whether to calculate the genes' `COEX`
#'   or stop just after the [estimateDispersionViaSolver()] step
#' @param optimizeForSpeed Boolean; when `TRUE` `COTAN` tries to use the `torch`
#'   library to run the matrix calculations. Otherwise, or when the library is
#'   not available will run the slower legacy code
#' @param deviceStr On the `torch` library enforces which device to use to run
#'   the calculations. Possible values are `"cpu"` to us the system *CPU*,
#'   `"cuda"` to use the system *GPUs* or something like `"cuda:0"` to restrict
#'   to a specific device
#' @param cores number of cores to use. Default is 1.
#' @param cellsCutoff `clean()` will delete from the `raw` data any gene that is
#'   expressed in less cells than threshold times the total number of cells.
#'   Default cutoff is \eqn{0.003 \; (0.3\%)}
#' @param genesCutoff `clean()` will delete from the `raw` data any cell that is
#'   expressing less genes than threshold times the total number of genes.
#'   Default cutoff is \eqn{0.002 \; (0.2\%)}
#' @param cellsThreshold any gene that is expressed in more cells than threshold
#'   times the total number of cells will be marked as **fully-expressed**.
#'   Default threshold is \eqn{0.99 \; (99.0\%)}
#' @param genesThreshold any cell that is expressing more genes than threshold
#'   times the total number of genes will be marked as **fully-expressing**.
#'   Default threshold is \eqn{0.99 \; (99.0\%)}
#' @param saveObj Boolean flag; when `TRUE` saves intermediate analyses and
#'   plots to file
#' @param outDir an existing directory for the analysis output.
#'
#' @returns `automaticCOTANObjectCreation()` returns the new `COTAN` object with
#'   genes' `COEX` calculated. When asked, it will also store the object, along
#'   all relevant clean-plots, in the output directory.
#'
#' @export
#'
#' @examples
#'
#' ## Otherwise it is possible to run all at once.
#' objCOTAN <- automaticCOTANObjectCreation(
#'   raw = test.dataset,
#'   GEO = "code",
#'   sequencingMethod = "10X",
#'   sampleCondition = "mouse_dataset",
#'   calcCoex = TRUE,
#'   saveObj = FALSE,
#'   outDir = tempdir(),
#'   cores = 6L)
#'
#' @rdname COTAN_ObjectCreation

automaticCOTANObjectCreation <- function(raw,
                                         GEO,
                                         sequencingMethod,
                                         sampleCondition,
                                         calcCoex = TRUE,
                                         optimizeForSpeed = TRUE,
                                         deviceStr = "cuda",
                                         cores = 1L,
                                         cellsCutoff = 0.003,
                                         genesCutoff = 0.002,
                                         cellsThreshold = 0.99,
                                         genesThreshold = 0.99,
                                         saveObj = FALSE,
                                         outDir = ".") {
    objCOTAN <- COTAN(raw = raw)
    objCOTAN <- initializeMetaDataset(objCOTAN, GEO = GEO,
                                      sequencingMethod = sequencingMethod,
                                      sampleCondition = sampleCondition)

    logThis(paste0("Condition ", sampleCondition), logLevel = 2L)
    logThis(paste("n cells", getNumCells(objCOTAN)), logLevel = 2L)

    objCOTAN <- proceedToCoex(objCOTAN,
                              calcCoex = calcCoex,
                              optimizeForSpeed = optimizeForSpeed,
                              deviceStr = deviceStr,
                              cores = cores,
                              cellsCutoff = cellsCutoff,
                              genesCutoff = genesCutoff,
                              cellsThreshold = cellsThreshold,
                              genesThreshold = genesThreshold,
                              saveObj = saveObj,
                              outDir = outDir)

    return(objCOTAN)
  }

#' @details `calculateGenesCE()` is used to calculate the discrepancy between
#'   the expected probability of zero and the observed zeros across all cells
#'   for each gene as *cross-entropy*: \eqn{-\sum_{c}{\mathbb{1}_{X_c == 0}
#'    \log(p_c) - \mathbb{1}_{X_c != 0} \log(1 - p_c)}} where \eqn{X_c} is the
#'   observed count and \eqn{p_c} the probability of zero
#'
#' @param objCOTAN a `COTAN` object
#'
#' @return `calculateGenesCE()` returns a named `array` with the *cross-entropy*
#'   of each gene
#'
#' @importFrom Rfast rowsums
#'
#' @export
#'
#' @rdname GenesStatistics
#'
calculateGenesCE <- function(objCOTAN) {
  # estimate Probabilities of 0 with internal function funProbZero
  probZero <- getProbabilityOfZero(objCOTAN)

  zeroOne <- as.matrix(getZeroOneProj(objCOTAN))

  feg <- getNumOfExpressingCells(objCOTAN) == getNumCells(objCOTAN)

  minusEntrM <- matrix(0.0, nrow = getNumGenes(objCOTAN),
                       ncol = getNumCells(objCOTAN))
  minusEntrM[!feg, ] <- (zeroOne[!feg, ] * log1p(-probZero[!feg, ])) +
                        ((1.0 - zeroOne[!feg, ]) * log(probZero[!feg, ]))

  return(set_names(-rowsums(minusEntrM, parallel = TRUE) /
                     getNumCells(objCOTAN), getGenes(objCOTAN)))
}


# local utility wrapper for parallel estimation of dispersion
runGDICalc <- function(genesBatches, S, topRows, cores) {

  ##  worker: operate on one batch of columns
  worker <- function(geneBatch, S, topRows) {
    tryCatch({
      ## slice columns (single read avoids copying the rest)
      subS <- as.matrix(S[, geneBatch, drop = FALSE])

      ## 1. sort each column descending
      subS <- colSort(subS, descending = TRUE)

      ## 2. keep only the top rows
      subS <- subS[seq_len(topRows), , drop = FALSE]

      ## 3. p-value of χ²₁ for each entry
      subS <- stats::pchisq(subS, df = 1L, lower.tail = FALSE)

      ## 4. mean p-value per column → transform
      gdi <- log(-log(colMeans(subS)))

      rm(subS)

      return(gdi)
    }, error = function(e) {
      structure(list(e), class = "try-error")
    })
  }

  if (cores != 1L) {
    ##  tiny sandbox env to keep each worker lean
    mini <- new.env(parent = baseenv())
    mini$colSort <- Rfast::colSort
    mini$colmeans <- Rfast::colmeans
    mini$logThis <- logThis
    mini$worker <- worker

    environment(mini$worker) <- mini

    ##  fork once, stream tasks
    res <- parallel::mclapply(genesBatches,
                              worker,
                              S = S,
                              topRows = topRows,
                              mc.cores       = cores,
                              mc.preschedule = TRUE, # default
                              mc.cleanup     = TRUE, # default
                              mc.set.seed    = TRUE) # default

    # spawned errors are stored as try-error classes
    resError <- unlist(lapply(res, inherits, "try-error"))
    if (any(resError)) {
      stop(res[[which(resError)[[1L]]]], call. = FALSE)
    }

    return(res)
  } else {
    res <- lapply(genesBatches,
                  worker,
                  S = S,
                  topRows = topRows)

    return(res)
  }
}


#' @details `calculateGDIGivenS()` produces a `vector` with the `GDI` for each
#'   column based on the `S` matrix (*Pearson's *\eqn{\chi^{2}}* test*)
#'
#' @param S a `matrix` object
#' @param rowsFraction The fraction of rows that will be averaged to calculate
#'   the `GDI`. Defaults to \eqn{5\%}
#' @param cores number of cores to use. Default is 1.
#' @param chunkSize number of elements to solve in batch in a single core.
#'   Default is 1024.
#'
#' @returns `calculateGDIGivenS()` returns a `vector` with the `GDI` data for
#'   each column of the input
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom stats pchisq
#'
#' @importFrom Rfast colSort
#' @importFrom Rfast colmeans
#'
#' @importFrom parallel mclapply
#' @importFrom parallel splitIndices
#'
#' @rdname GenesStatistics
#'

calculateGDIGivenS  <- function(S,
                                rowsFraction = 0.05,
                                cores        = 1L,
                                chunkSize    = 1024L) {
  startTime <- Sys.time()

  logThis("Calculate `GDI`: START", logLevel = 2L)

  # Beware S might not be square!
  assert_that(length(dim(S)) == 2L)
  assert_that(rowsFraction > 0.0, rowsFraction <= 1.0)

  cores <- handleMultiCore(cores)

  genes <- colnames(S)

  ## rows to retain per column
  topRows <- max(1L, round(nrow(S) * rowsFraction))

  ##  split genes into batches
  spIdx <- parallel::splitIndices(length(genes),
                                  ceiling(length(genes) / chunkSize))

  spGenes <- lapply(spIdx, \(x) genes[x])

  cores <- min(cores, length(spGenes))

  logThis(paste0("Executing ", length(spGenes), " genes batches"),
          logLevel = 3L)

  gdiList <- runGDICalc(genesBatches = spGenes, S = S,
                        topRows = topRows, cores = cores)

  ## glue result and reorder to original gene order
  GDI <- unlist(gdiList, use.names = FALSE, recursive = TRUE)

  names(GDI) <- genes

  endTime <- Sys.time()

  logThis(paste("Total calculations elapsed time:",
                difftime(endTime, startTime, units = "secs")),
          logLevel = 2L)

  logThis("Calculate `GDI`: DONE", logLevel = 2L)

  return(GDI)
}


#' @details `calculateGDIGivenCorr()` produces a `vector` with the `GDI` for
#'   each column based on the given correlation matrix, using the *Pearson's
#'   *\eqn{\chi^{2}}* test*
#'
#' @param corr a `matrix` object, possibly a subset of the columns of the full
#'   symmetric matrix
#' @param numDegreesOfFreedom a `int` that determines the number of degree of
#'   freedom to use in the \eqn{\chi^{2}} test
#' @param rowsFraction The fraction of rows that will be averaged to calculate
#'   the `GDI`. Defaults to \eqn{5\%}
#'
#' @returns `calculateGDIGivenCorr()` returns a `vector` with the `GDI` data for
#'   each column of the input
#'
#' @export
#'
#' @rdname GenesStatistics
#'

calculateGDIGivenCorr <-
  function(corr, numDegreesOfFreedom, rowsFraction = 0.05) {
  return(calculateGDIGivenS(corr^2L * numDegreesOfFreedom,
                            rowsFraction = rowsFraction))
}


#' @details `calculateGDI()` produces a `data.frame` with the `GDI` for each
#'   gene based on the `COEX` matrix
#'
#' @param objCOTAN a `COTAN` object
#' @param statType Which statistics to use to compute the p-values. By default
#'   it will use the `S` (*Pearson's *\eqn{\chi^{2}}* test*) otherwise the `G`
#'   (*G-test*)
#' @param rowsFraction The fraction of rows that will be averaged to calculate
#'   the `GDI`. Defaults to \eqn{5\%}
#' @param cores number of cores to use. Default is 1.
#' @param chunkSize number of elements to solve in batch in a single core.
#'   Default is 1024.
#'
#' @returns `calculateGDI()` returns a `data.frame` with:
#'  * `"sum.raw.norm"` the sum of the normalized data rows
#'  * `"GDI"` the `GDI` data
#'  * `"exp.cells"` the percentage of cells expressing the gene
#'
#' @export
#'
#' @importFrom rlang set_names
#'
#' @importFrom Matrix rowSums
#'
#' @importFrom tibble column_to_rownames
#'
#' @rdname GenesStatistics
#'

calculateGDI <- function(objCOTAN,
                         statType     = "S",
                         rowsFraction = 0.05,
                         cores        = 1L,
                         chunkSize    = 1024L) {
  startTime <- Sys.time()

  logThis("Calculate GDI dataframe: START", logLevel = 2L)

  if (statType == "S") {
    logThis("Using S", logLevel = 3L)
    S <- calculateS(objCOTAN)
  } else if (statType == "G") {
    logThis("Using G", logLevel = 3L)
    S <- calculateG(objCOTAN)
  } else {
    stop("Unrecognised stat type: must be either 'S' or 'G'")
  }

  GDI <- calculateGDIGivenS(S, rowsFraction = rowsFraction,
                            cores = cores, chunkSize = chunkSize)

  gc()

  # GDI <- set_names(as.data.frame(GDI), )
  sumRawNorm <- log10(rowSums(getNuNormData(objCOTAN)))
  expCells <- getNumOfExpressingCells(objCOTAN) / getNumCells(objCOTAN) * 100.0

  gdiDF <- as.data.frame(list(
    "sum.raw.norm" = sumRawNorm,
    "GDI" = GDI,
    "exp.cells" = expCells
  ))
  assert_that(identical(colnames(gdiDF),
                        c("sum.raw.norm", "GDI", "exp.cells")))

  endTime <- Sys.time()

  logThis(paste("Total calculations elapsed time:",
                difftime(endTime, startTime, units = "secs")),
          logLevel = 2L)

  logThis("Calculate GDI dataframe: DONE", logLevel = 2L)

  return(gdiDF)
}


# local utility wrapper for parallel estimation of dispersion
runPValueCalc <- function(genesBatches, S, cores) {

  ##  worker: operate on one batch of columns
  worker <- function(geneBatch, S) {
    tryCatch({

      ## slice columns (single read avoids copying the rest)
      subPVals <- as.matrix(S[, geneBatch, drop = FALSE])

      ## 3. p-value of χ²₁ for each entry
      subPVals <- stats::pchisq(subPVals, df = 1L, lower.tail = FALSE)

      return(subPVals)
    }, error = function(e) {
      structure(list(e), class = "try-error")
    })
  }

  if (cores != 1L) {
    ##  tiny sandbox env to keep each worker lean
    mini <- new.env(parent = baseenv())
    mini$logThis <- logThis
    mini$worker <- worker

    environment(mini$worker) <- mini

    ##  fork once, stream tasks
    res <- parallel::mclapply(genesBatches,
                              worker,
                              S = S,
                              mc.cores       = cores,
                              mc.preschedule = TRUE, # default
                              mc.cleanup     = TRUE, # default
                              mc.set.seed    = TRUE) # default

    # spawned errors are stored as try-error classes
    resError <- unlist(lapply(res, inherits, "try-error"))
    if (any(resError)) {
      stop(res[[which(resError)[[1L]]]], call. = FALSE)
    }
  } else {
    res <- lapply(genesBatches,
                  worker,
                  S = S)

  }

  ## glue results
  res <- do.call(cbind, res)

  rownames(res) <- rownames(S)
  colnames(res) <- colnames(S)

  return(res)
}

#' @details `calculatePValue()` computes the p-values for genes in the `COTAN`
#'   object. It can be used genome-wide or by setting some specific genes of
#'   interest. By default it computes the *p-values* using the `S` statistics
#'   (\eqn{\chi^{2}})
#'
#' @param objCOTAN a `COTAN` object
#' @param statType Which statistics to use to compute the p-values. By default
#'   it will use the "S" (Pearson's \eqn{\chi^{2}} test) otherwise the "G"
#'   (G-test)
#' @param geneSubsetCol an array of genes. It will be put in columns. If left
#'   empty the function will do it genome-wide.
#' @param geneSubsetRow an array of genes. It will be put in rows. If left empty
#'   the function will do it genome-wide.
#' @param cores number of cores to use. Default is 1.
#' @param chunkSize number of elements to solve in batch in a single core.
#'   Default is 1024.
#'
#' @return `calculatePValue()` returns a *p-value* `matrix` as `dspMatrix`
#'
#' @export
#'
#' @importFrom Matrix forceSymmetric
#' @importFrom Matrix pack
#'
#' @importClassesFrom Matrix dspMatrix
#'
#' @rdname GenesStatistics
#'
calculatePValue <- function(objCOTAN,
                            statType      = "S",
                            geneSubsetCol = vector(mode = "character"),
                            geneSubsetRow = vector(mode = "character"),
                            cores         = 1L,
                            chunkSize     = 1024L) {
  startTime <- Sys.time()

  geneSubsetCol <- handleNamesSubsets(getGenes(objCOTAN), geneSubsetCol)
  geneSubsetRow <- handleNamesSubsets(getGenes(objCOTAN), geneSubsetRow)

  if (statType == "S") {
    logThis("Using S", logLevel = 3L)
    S <- calculateS(objCOTAN,
                    geneSubsetCol = geneSubsetCol,
                    geneSubsetRow = geneSubsetRow)
  } else if (statType == "G") {
    logThis("Using G", logLevel = 3L)
    S <- calculateG(objCOTAN,
                    geneSubsetCol = geneSubsetCol,
                    geneSubsetRow = geneSubsetRow)
  } else {
    stop("Unrecognised stat type: must be either 'S' or 'G'")
  }

  logThis("calculating PValues: START", logLevel = 2L)

  allCols <- identical(geneSubsetCol, getGenes(objCOTAN))
  allRows <- identical(geneSubsetRow, getGenes(objCOTAN))

  strCol <- if (allCols) "genome wide" else "on a set of genes"
  strRow <- if (allRows) "genome wide" else "on a set of genes"
  logThis(paste("Get p-values", strCol, "on columns and", strRow, "on rows"),
          logLevel = 2L)

  cores <- handleMultiCore(cores)

  ##  split genes into batches
  spIdx <- parallel::splitIndices(length(geneSubsetCol),
                                  ceiling(length(geneSubsetCol) / chunkSize))

  spGenes <- lapply(spIdx, \(x) geneSubsetCol[x])

  cores <- min(cores, length(spGenes))

  logThis(paste0("Executing ", length(spGenes), " genes batches"),
          logLevel = 3L)

  pValues <- runPValueCalc(genesBatches = spGenes,
                           S = S,
                           cores = cores)

  if (allCols && allRows) {
    pValues <- pack(forceSymmetric(pValues))
  }

  endTime <- Sys.time()

  logThis(paste("Total calculations elapsed time:",
                difftime(endTime, startTime, units = "secs")),
          logLevel = 2L)

  logThis("calculating PValues: DONE", logLevel = 2L)

  return(pValues)
}


#' @details `calculatePDI()` computes the p-values for genes in the `COTAN`
#'   object using [calculatePValue()] and takes their
#'   \eqn{\log{({-\log{(\cdot)}})}} to calculate the genes' *Pair Differential
#'   Index*
#'
#' @param objCOTAN a `COTAN` object
#' @param statType Which statistics to use to compute the p-values. By default
#'   it will use the "S" (Pearson's \eqn{\chi^{2}} test) otherwise the "G"
#'   (G-test)
#' @param geneSubsetCol an array of genes. It will be put in columns. If left
#'   empty the function will do it genome-wide.
#' @param geneSubsetRow an array of genes. It will be put in rows. If left empty
#'   the function will do it genome-wide.
#'
#' @return `calculatePDI()` returns a *Pair Differential Index* `matrix` as
#'   `dspMatrix`
#'
#' @export
#'
#' @rdname GenesStatistics
#'
calculatePDI <- function(objCOTAN, statType = "S",
                         geneSubsetCol = vector(mode = "character"),
                         geneSubsetRow = vector(mode = "character")) {
  pValues <- calculatePValue(objCOTAN, statType = statType,
                             geneSubsetCol = geneSubsetCol,
                             geneSubsetRow = geneSubsetRow)
  return(log(-log(pValues)))
}

#----------------- log functions --------------------

#' @title Logging in the `COTAN` package
#'
#' @description Logging is currently supported for all `COTAN` functions. It is
#'   possible to see the output on the terminal and/or on a log file. The level
#'   of output on terminal is controlled by the  `COTAN.LogLevel` option while
#'   the logging on file is always at its maximum verbosity
#'
#' @name LoggingFunctions
NULL

#' @details `setLoggingLevel()` sets the `COTAN` logging level. It set the
#'   `COTAN.LogLevel` options to one of the following values:
#'    * 0 - Always on log messages
#'    * 1 - Major log messages
#'    * 2 - Minor log messages
#'    * 3 - All log messages
#'
#' @param newLevel the new default logging level. It defaults to 1
#'
#' @returns `setLoggingLevel()` returns the old logging level or default level
#'   if not set yet.
#'
#' @export
#'
#' @examples
#' setLoggingLevel(3) # for debugging purposes only
#'
#' @rdname LoggingFunctions
#'
setLoggingLevel <- function(newLevel = 1L) {
  message("Setting new log level to ", newLevel)
  oldLevel <- unlist(options(COTAN.LogLevel = newLevel))
  if (is.null(oldLevel)) {
    oldLevel <- 1L
  }
  return(invisible(oldLevel))
}


#' @details `setLoggingFile()` sets the log file for all `COTAN` output logs. By
#'   default no logging happens on a file (only on the console). Using this
#'   function `COTAN` will use the indicated file to dump the logs produced by
#'   all [logThis()] commands, independently from the log level. It stores the
#'   `connection` created by the call to [bzfile()] in the option:
#'   `COTAN.LogFile`
#'
#' @param logFileName the log file.
#'
#' @export
#'
#' @examples
#' logFile <- file.path(".", "COTAN_Test1.log")
#' setLoggingFile(logFile)
#' logThis("Some log message")
#' setLoggingFile("") # closes the log file
#' file.remove(logFile)
#'
#' @rdname LoggingFunctions
#'
setLoggingFile <- function(logFileName) {
  currentFile <- getOption("COTAN.LogFile")
  if (!is.null(currentFile)) {
    message("Closing previous log file - ", appendLF = FALSE)
    tryCatch({
      flush(currentFile)
      close(currentFile)
    }, error = function(e) {
      message("Connection to previous log file broken, will be discarded")
      options(COTAN.LogFile = NULL)
    })
  }

  message("Setting log file to be: ", logFileName)
  if (isEmptyName(logFileName)) {
    options(COTAN.LogFile = NULL)
  } else {
    options(COTAN.LogFile = file(logFileName, open = "at"))
  }
}


#' @details `logThis()` prints the given message string if the current log level
#'   is greater or equal to the given log level (it always prints its message on
#'   file if active). It uses [message()] to actually print the messages on the
#'   [stderr()] connection, so it is subject to [suppressMessages()]
#'
#' @param msg the message to print
#' @param logLevel the logging level of the current message. It defaults to 2
#' @param appendLF whether to add a new-line character at the end of the message
#'
#' @returns `logThis()` returns TRUE if the message has been printed on the
#'   terminal
#'
#' @export
#'
#' @examples
#' logThis("LogLevel 0 messages will always show, ",
#'         logLevel = 0, appendLF = FALSE)
#' suppressMessages(logThis("unless all messages are suppressed",
#'                          logLevel = 0))
#'
#' @rdname LoggingFunctions
#'
logThis <- function(msg, logLevel = 2L, appendLF = TRUE) {
  # write to log file if any
  currentFile <- getOption("COTAN.LogFile")
  if (!is.null(currentFile)) {
    tryCatch({
      tsMsg <- paste0(format(Sys.time(), "[%Y-%m-%d %H:%M:%S] "), msg)
      writeLines(tsMsg, currentFile,
                 sep = ifelse(isTRUE(appendLF), "\n", ""))
      flush(currentFile)
    }, error = function(e) {
      setLoggingFile("")
    })
  }
  # set the logging level global variable
  if (is.null(getOption("COTAN.LogLevel"))) {
    setLoggingLevel() # to default
  }
  currentLevel <- getOption("COTAN.LogLevel")
  showMessage <- currentLevel >= logLevel
  if (showMessage) {
    message(msg, appendLF = appendLF)
  }
  return(invisible(showMessage))
}

#----------------- multi-threading --------------------

#' @title Handling Multi-Core and GPU environments
#'
#' @description Check whether session supports multi-core and/or GPU evaluation
#'   and utilities about their activation
#'
#' @name MultiThreading
#'
NULL

#' @details `handleMultiCore()` uses [parallelly::supportsMulticore()] and
#'   [parallelly::availableCores()] to actually check whether the session
#'   supports multi-core evaluation. Provides an effective upper bound to the
#'   number of cores.
#'
#' @seealso the help page of [parallelly::supportsMulticore()] about the flags
#'   influencing the multi-core support; e.g. the usage of `R` option
#'   `parallelly.fork.enable`.
#'
#' @param cores the number of cores asked for
#'
#' @returns `handleMultiCore()` returns the maximum sensible number of cores to
#'   use
#'
#' @importFrom parallelly availableCores
#' @importFrom parallelly supportsMulticore
#'
#' @rdname MultiThreading
#'
handleMultiCore <- function(cores) {
  cores <- max(1L, cores)

  if (!supportsMulticore() && cores != 1L) {
    if (is.null(getOption("COTAN.MultiCoreWarning"))) {
      warning("On this system multi-core is not currently supported;",
              " this can happen on some systems like 'windows'")
      warning("In case you might try 'options(parallelly.fork.enable = TRUE)'",
              " to enable multi-core support")
    }
    options(COTAN.MultiCoreWarning = "Published")
    warning("The number of cores used will be set 1!")
    cores <- 1L
  }

  cores <- min(cores, availableCores(omit = 1L))

  logThis(paste("Effective number of cores used:", cores), logLevel = 3L)

  return(cores)
}


#' @details `canUseTorch()` is an internal function to handle the torch library:
#'   it returns whether \pkg{torch} is ready to be used. It obeys the opt-out
#'   flag set via the `COTAN.UseTorch` option
#'
#' @param optimizeForSpeed A Boolean to indicate whether to try to use the
#'   faster torch library
#' @param deviceStr The name of the device to be used by torch
#'
#' @returns `canUseTorch()` returns a list with 2 elements:
#' * `"useTorch"`: a Boolean indicating whether the torch library can be used
#' * `"deviceStr"`: the updated name of the device to be used: if no `cuda` GPU
#'   is available it will fallback to CPU calculations
#'
#' @seealso [torch::install_torch()] and [torch::torch_is_installed()] for
#'   installation. Note the [torch::torch_set_num_threads()] has effect also on
#'   the \pkg{Rfast} package methods
#'
#' @export
#'
#' @rdname MultiThreading
#'
canUseTorch <- function(optimizeForSpeed, deviceStr) {
  warnedAboutTorch <- !is.null(getOption("COTAN.TorchWarning"))

  useTorch <- isTRUE(optimizeForSpeed)

  if (useTorch) {
    # if torch is not explicitly opted-out, we try using it as
    # there is a clean way to check if it is usable
    useTorchOpt <- getOption("COTAN.UseTorch")
    if (is.null(useTorchOpt)) {
      # default case: explicit opt-out only!
      useTorchOpt <- TRUE
    }
    if (is.character(useTorchOpt)) {
      useTorchOpt <- toupper(useTorchOpt)
      useTorchOpt <- !(useTorchOpt %in% c("FALSE", "F"))
    }
    useTorch <- isTRUE(useTorchOpt)

    if (!useTorch && !warnedAboutTorch) {
      warning("The `torch` library has been explicitly opted out")
      warning("In case you might try 'options(COTAN.UseTorch = TRUE)'",
              " to enable it")
      warnedAboutTorch <- TRUE
    }
  }

  if (useTorch) {
    tryCatch({
      if (!requireNamespace("torch", quietly = TRUE)) {
        stop("The `torch` library is not installed")
      }
      if (!torch::torch_is_installed()) {
        stop("The `torch` library is installed but the required",
             " additional libraries are not available yet")
      }
      # Call a simple torch function to check if it's working
      if (is.null(torch::torch_tensor(1L))) {
        stop("The `torch` library is installed but not working correctly")
      }
    },
    error = function(err) {
      logThis(paste("While trying to load the `torch` library", err),
              logLevel = 0L)
      if (!warnedAboutTorch) {
        warning("The `torch` library is installed,",
                " but might require further initialization")
        warning("Please look at the `torch` package installation guide",
                " to complete the installation")
      }
      useTorch <<- FALSE
    })
    warnedAboutTorch <- !useTorch
  }

  if (useTorch) {
    # Device configuration - fall-back to `cpu` if no `cuda` device is available
    if (startsWith(deviceStr, "cuda") && !torch::cuda_is_available()) {
      if (!warnedAboutTorch) {
        warning("The `torch` library could not find any `CUDA` device")
        warning("Falling back to CPU calculations")
        warnedAboutTorch <- TRUE
      }
      deviceStr <- "cpu"
    }
  } else {
    if (optimizeForSpeed) {
      if (!warnedAboutTorch) {
        warning("The `torch` library is not installed.")
        warnedAboutTorch <- TRUE
      }
      warning("Falling back to legacy [non-torch] code.")
    }
    deviceStr <- ""
  }

  if (warnedAboutTorch) {
    options(COTAN.TorchWarning = "Published")
  }

  return(list("useTorch" = useTorch, "deviceStr" = deviceStr))
}


#----------------- string related utilities --------------------

#' @title Handle names and factors' levels
#'
#' @description Internal functions dedicated to solve strings or factors related
#'   simple tasks
#'
#' @name HandleStrings
#'
NULL

#' @details `handleNamesSubsets()` returns the given subset or the full `list`
#'   of names if none were specified
#'
#' @param names The full `list` of the names to handle
#' @param subset The names' subset. When empty all names are returned instead!
#'
#' @returns `handleNamesSubsets()` returns the updated list of names' subset,
#'   reordered according to the given names' list
#'
#' @importFrom rlang is_empty
#'
#' @importFrom assertthat assert_that
#'
#' @rdname HandleStrings
#'
handleNamesSubsets <- function(names, subset = vector(mode = "character")) {
  if (is_empty(subset)) {
    subset <- names
  } else {
    assert_that(all(subset %in% names),
                msg = "Passed names are not a subset of the full list")

    subset <- names[names %in% subset]
  }
  return(subset)
}


#' @details `conditionsFromNames()` retrieves a condition from the given names
#'   by picking the asked fragment after having them split according to the
#'   given pattern
#'
#' @param names The full `list` of the names to handle
#' @param splitPattern the pattern to use to split the names
#' @param fragmentNum the string fragment to use as condition from the split
#'   names
#'
#' @returns `conditionsFromNames()` returns the extracted conditions
#'
#' @export
#'
#' @importFrom stringr str_split_i
#'
#' @rdname HandleStrings
#'
conditionsFromNames <-
  function(names, splitPattern = " ", fragmentNum = 2L) {
  numNames <- length(names)
  conditions <- str_split_i(names, pattern = splitPattern, fragmentNum)
  if (anyNA(conditions) ||
      length(unique(conditions)) == numNames) {
    warning("conditionsFromNames: no proper pattern has been recognized",
            " or given column number was too high")
    conditions <- rep("1", numNames)
  }
  names(conditions) <- names
  return(conditions)
}


#' @details `isEmptyName()` returns whether the passed name is not null and has
#'   non-zero characters
#'
#' @param name the name to check
#'
#' @returns `isEmptyName()` returns whether the passed name is equivalent to an
#'   empty string
#'
#' @importFrom assertthat assert_that
#'
#' @rdname HandleStrings
#'
isEmptyName <- function(name) {
  return(!(length(name) && any(nzchar(name))))
}


#' @details `niceFactorLevels()` provides **nicer** `factor` labels that have
#'   all the same number of characters
#'
#' @param v an `array` or `factor` object
#'
#' @returns `niceFactorLevels()` returns a `factor` that is preserving the
#'   *names* of the input with the new nicer levels
#'
#' @export
#'
#' @importFrom stringr str_pad
#'
#' @rdname HandleStrings
#'
niceFactorLevels <- function(v) {
  vNames <- names(v)
  if (is.factor(v)) {
    v <- factorToVector(v)
  }
  nv <- suppressWarnings(as.numeric(v))
  if (!anyNA(nv) && all(as.integer(nv) == nv)) {
    numDigits <- floor(log10(max(nv))) + 1L
    v <- formatC(nv, width = numDigits, flag = "0")
  } else if (is.character(v)) {
    numChars <- max(nchar(v))
    v <- str_pad(v, width = numChars, side = "left", pad = "_")
  }
  names(v) <- vNames
  return(factor(v))
}


#' @details `factorToVector()` converts a *named* `factor` to a *named*
#'   `character vector`
#'
#' @param f a `factor` object
#'
#' @returns `factorToVector()` returns a `character vector` that preserves the
#'   *names* of the input factor
#'
#' @export
#'
#' @importFrom rlang set_names
#'
#' @importFrom assertthat assert_that
#'
#' @rdname HandleStrings
#'
factorToVector <- function(f) {
  assert_that(inherits(f, "factor"), msg = "Passed object is not a factor")
  return(set_names(levels(f)[f], names(f)))
}


#-------------- metadata handling -----------

#' @details `getColumnFromDF()` is a function to extract a column from a
#'   `data.frame`, while keeping the `rowNames` as `vector` names
#'
#' @param df the `data.frame`
#' @param colName the name of the new or existing column in the `data.frame`. It
#'   can also be a column number
#'
#' @returns `getColumnFromDF()` returns the column in the `data.frame` as named
#'   `array`, `NULL` if the wanted column is not available
#'
#' @export
#'
#' @importFrom rlang is_empty
#' @importFrom rlang is_string
#' @importFrom rlang set_names
#'
#' @rdname HandleMetaData
#'
getColumnFromDF <- function(df, colName) {
  if (is_empty(df)) {
    return(NULL)
  }
  if ((is_string(colName) && !(colName %in% colnames(df)))
       || (is.numeric(colName) && colName > ncol(df))) {
    return(NULL)
  }

  # if colName is a number it can be used as such
  retArray <- df[[colName]]
  if (!is_empty(retArray)) {
    names(retArray) <- rownames(df)
  }
  return(retArray)
}


#' @details `setColumnInDF()` is a function to append, if missing, or resets, if
#'   present, a column into a `data.frame`, whether the `data.frame` is empty or
#'   not. The given `rowNames` are used only in the case the `data.frame` has
#'   only the default row numbers, so this function cannot be used to override
#'   row names
#'
#' @param df the `data.frame`
#' @param colToSet the column to add
#' @param colName the name of the new or existing column in the `data.frame`
#' @param rowNames when not empty, if the input `data.frame` has no real row
#'   names, the new row names of the resulting `data.frame`
#'
#' @returns `setColumnInDF()` returns the updated, or the newly created,
#'   `data.frame`
#'
#' @export
#'
#' @importFrom rlang is_empty
#' @importFrom rlang set_names
#'
#' @rdname HandleMetaData
#'
setColumnInDF <- function(df, colToSet, colName,
                          rowNames = vector(mode = "character")) {
  if (is_empty(df)) {
    df <- set_names(data.frame(colToSet), colName)
  } else {
    if (colName %in% colnames(df)) {
      df[[colName]] <- colToSet
    } else {
      df <- cbind(df, set_names(data.frame(colToSet), colName))
    }
  }

  # default assigned rownames are numbers...
  if (!is_empty(rowNames) && is.integer(attr(df, "row.names"))) {
    rownames(df) <- rowNames
  }

  return(df)
}

#' @details `getMetaInfoRow()` is an internal function: it extracts the row\
#'   associated with the given tag if present or zero otherwise.
#'
#' @param meta The information `data.frame` to update
#' @param tag The tag associated to the wanted value
#'
#' @returns `getMetaInfoRow()` returns the last relevant row position if any or
#'   zero otherwise.
#'
#' @importFrom rlang is_empty
#'
#' @importFrom stringr str_equal
#'
#' @rdname HandleMetaData
#'
getMetaInfoRow <- function(meta, tag) {
  # nothing to look into
  if (is_empty(meta)) {
    return(0L)
  }

  # get all matches
  matches <- str_equal(tag, meta[[1L]], ignore_case = TRUE)
  if (!any(matches)) {
    return(0L)
  }

  # get last match!
  rowPos <- which(matches)
  rowPos <- rowPos[[length(rowPos)]]
  return(rowPos)
}


#' @details `updateMetaInfo()` is an internal function: updates an information
#'   `data.frame`
#'
#' @param meta The information `data.frame` to update
#' @param tag The tag associated to the wanted value
#' @param value The value or the values to associate to the tag
#'
#' @returns `updateMetaInfo()` returns the updated `data.frame`
#'
#' @rdname HandleMetaData
#'
updateMetaInfo <- function(meta, tag, value) {
  # get relevant row or a new one if necessary
  rowPos <- getMetaInfoRow(meta, tag)
  if (rowPos == 0L) {
    # new tag: add a new entry
    rowPos <- nrow(meta) + 1L
  }

  # all values are converted to strings
  newLine <- c(tag, paste0(value))
  meta[rowPos, seq_along(newLine)] <- newLine

  return(meta)
}


#------------------- clusters utilities ----------

#' @title *Clusters* utilities
#'
#' @description Handle *clusterization* <-> *clusters* `list` conversions,
#'   *clusters* grouping and merge
#'
#' @name ClustersList
#'
#' @examples
#' ## create a clusterization
#' clusters <- paste0("",sample(7, 100, replace = TRUE))
#' names(clusters) <- paste0("E_",formatC(1:100,  width = 3, flag = "0"))
#'
#' ## create a clusters list from a clusterization
#' clustersList <- toClustersList(clusters)
#' head(clustersList, 1)
#'
#' ## recreate the clusterization from the cluster list
#' clusters2 <- fromClustersList(clustersList, names(clusters))
#' all.equal(factor(clusters), clusters2)
#'
#' cl1Size <- length(clustersList[["1"]])
#'
#' ## establish the permutation that groups clusters together
#' perm <- groupByClusters(clusters)
#' !is.unsorted(head(names(clusters)[perm],cl1Size))
#' head(clusters[perm], cl1Size)
#'
#' ## it is possible to have the list of the element names different
#' ## from the names in the clusters list
#' selectedNames <- paste0("E_",formatC(11:110,  width = 3, flag = "0"))
#' perm2 <- groupByClustersList(selectedNames, toClustersList(clusters))
#' all.equal(perm2[91:100], c(91:100))
#'
#' ## is is possible to merge a few clusters together
#' clustersMerged <- mergeClusters(clusters, names = c("7", "2"),
#'                                 mergedName = "7__2")
#' sum(table(clusters)[c(2, 7)]) == table(clustersMerged)[["7__2"]]
#'
#' ## it is also possible to do multiple merges at once!
#' ## Note the default new clusters' names
#' clustersMerged2 <-
#'   multiMergeClusters(clusters2, namesList = list(c("2", "7"),
#'                                                  c("1", "3", "5")))
#' table(clustersMerged2)
#'
#'
NULL

#' @details `asClusterization()` given a *clusterization* in the form of a
#'   `data.frame` or a `vector` or a `factor`, returns a named `factor`
#'
#' @param clusters A named `vector` or `factor` or `data.frame` that defines the
#'   *clusters*
#' @param allCells A `vector` of cells' names that should list the same names in
#'   the `clusters` in any order
#'
#' @returns `asClusterization()` returns the *clusterization* as a named
#'   `factor`
#'
#' @export
#'
#' @importFrom rlang is_null
#' @importFrom rlang is_vector
#' @importFrom rlang set_names
#'
#' @importFrom assertthat assert_that
#'
#' @rdname ClustersList
#'
asClusterization <- function(clusters, allCells = NULL) {
  assert_that(!is_null(clusters), msg = "Given empty clusterization")

  if (is.data.frame(clusters)) {
    # allow 2 data.frame kind: 2 columns with names and clusters or a single
    # column with row names
    numCols <- ncol(clusters)
    assert_that(numCols >= 1L, numCols <= 2L,
                msg = "Given a data.frame with unsupported number of columns")
    if (numCols == 2L) {
      clusters <- set_names(clusters[, 2L, drop = TRUE],
                            nm = clusters[, 1L, drop = TRUE])
    } else {
      clusters <- getColumnFromDF(clusters, colName = 1L)
    }
  }
  if (is_vector(clusters)) {
    clusters <- factor(clusters)
  }

  if (!is_null(allCells)) {
    assert_that(setequal(names(clusters), allCells),
                msg = "Given clusterization has the wrong set of cells")
  }

  return(clusters)
}


#' @details `toClustersList()` given a *clusterization*, creates a `list` of
#'   *clusters* (i.e. for each *cluster*, which elements compose the *cluster*)
#'
#' @param clusters A named `vector` or `factor` or `data.frame` that defines the
#'   *clusters*
#'
#' @returns `toClustersList()` returns a `list` of clusters
#'
#' @export
#'
#' @importFrom rlang is_empty
#' @importFrom rlang set_names
#'
#' @importFrom assertthat assert_that
#'
#' @rdname ClustersList
#'
toClustersList <- function(clusters) {
  assert_that(!is_empty(names(clusters)),
              msg = "passed clusterization has no names")

  clusters <- asClusterization(clusters)
  clustersNames <- levels(clusters)

  getCl <- function(cl, clusters) {
    names(clusters)[clusters %in% cl]
  }

  clustersList <- set_names(lapply(clustersNames, getCl, clusters),
                            clustersNames)

  return(clustersList)
}

#' @details `fromClustersList()` given a `list` of *clusters* returns a
#'   *clusterization* (i.e. a named `vector` that for each element indicates to
#'   which cluster it belongs)
#'
#' @param clustersList A named `list` whose elements define the various clusters
#' @param elemNames A `list` of names to which associate a cluster
#' @param throwOnOverlappingClusters When `TRUE`, in case of overlapping
#'   clusters, the function `fromClustersList` and `groupByClustersList` will
#'   throw. This is the default. When FALSE, instead, in case of overlapping
#'   clusters, `fromClustersList` will return the last cluster to which each
#'   element belongs, while `groupByClustersList` will return a vector of
#'   positions that is longer than the given `elemNames`
#'
#' @returns `fromClustersList()` returns a clusterization. If the given
#'   `elemNames` contain values not present in the `clustersList`, those will be
#'   marked as `"-1"`
#'
#' @export
#'
#' @importFrom rlang is_empty
#' @importFrom rlang set_names
#'
#' @importFrom assertthat assert_that
#'
#' @rdname ClustersList
#'
fromClustersList <- function(clustersList,
                             elemNames = vector(mode = "character"),
                             throwOnOverlappingClusters = TRUE) {
  clustersNames <- names(clustersList)

  assert_that(!is_empty(clustersNames),
              msg = "Passed clusterization has no names")

  if (is_empty(elemNames)) {
    elemNames <- unlist(clustersList, use.names = FALSE)
  }

  clusters <- set_names(rep.int("-1", length(elemNames)), elemNames)

  for (clName in clustersNames) {
    cluster <- clustersList[[clName]]
    cluster <- cluster[cluster %in% elemNames]
    assert_that((!throwOnOverlappingClusters ||
                   all(clusters[cluster] == "-1")),
                msg = "Found overlapping clusters")
    clusters[cluster] <- clName
  }

  return(asClusterization(clusters))
}

#' @details `groupByClusters()` given a *clusterization* returns a permutation,
#'   such that using the permutation on the input the *clusters* are grouped
#'   together
#'
#' @param elemNames A `list` of names to which associate a cluster
#' @param clustersList A named `list` whose elements define the various clusters
#' @param throwOnOverlappingClusters When `TRUE`, in case of overlapping
#'   clusters, the function `fromClustersList` and `groupByClustersList` will
#'   throw. This is the default. When FALSE, instead, in case of overlapping
#'   clusters, `fromClustersList` will return the last cluster to which each
#'   element belongs, while `groupByClustersList` will return a vector of
#'   positions that is longer than the given `elemNames`
#'
#' @returns `groupByClusters()` and `groupByClustersList()` return a permutation
#'   that groups the clusters together. For each cluster the positions are
#'   guaranteed to be in increasing order. In case, all elements not
#'   corresponding to any cluster are grouped together as the last group
#'
#' @export
#'
#' @importFrom rlang is_empty
#'
#' @importFrom assertthat assert_that
#'
#' @rdname ClustersList
#'
groupByClustersList <- function(elemNames, clustersList,
                                throwOnOverlappingClusters = TRUE) {
  assert_that(!is_empty(elemNames), msg = "passed no elemNames")
  assert_that(!is_empty(clustersList), msg = "passed no clustersList")

  positions <- vector(mode = "integer")

  for (cluster in clustersList) {
    clPos <- which(elemNames %in% cluster)
    # clPos should be already sorted
    assert_that(!throwOnOverlappingClusters || !any(clPos %in% positions),
                msg = "Found overlapping clusters")
    positions <- append(positions, clPos)
  }

  # add all non-clustered elements as tail group!
  positions <- append(positions, setdiff(seq_along(elemNames), positions))

  return(positions)
}

#' @details `groupByClustersList()` given the elements' names and a `list` of
#'   *clusters* returns a permutation, such that using the permutation on the
#'   given names the *clusters* are grouped together.
#'
#' @param clusters A named `vector` or `factor` that defines the *clusters*.
#'
#' @export
#'
#' @importFrom rlang is_empty
#'
#' @rdname ClustersList
#'
groupByClusters <- function(clusters) {
  return(groupByClustersList(names(clusters), toClustersList(clusters)))
}


#' @details `mergeClusters()` given a *clusterization*, creates a new one where
#'   the given *clusters* are merged.
#'
#' @param clusters A named `vector` or `factor` that defines the *clusters*
#' @param names A list of *clusters* names to be merged
#' @param mergedName The name of the new merged clusters
#'
#' @returns `mergeClusters()` returns a new *clusterization* with the wanted
#'   *clusters* being merged. If less than 2 *cluster* names were passed the
#'   function will emit a warning and return the initial *clusterization*
#'
#' @export
#'
#' @importFrom rlang is_empty
#'
#' @rdname ClustersList
#'
mergeClusters <- function(clusters, names, mergedName = "") {
  clusters <- asClusterization(clusters)

  effNames <- names[names %in% levels(clusters)]
  if (is_empty(effNames) || length(effNames) < 2L) {
    warning("Passed a list of clusters to merge with less than 2 elements",
            " actually present in the clusterization")
    # nothing to do...
    return(clusters)
  }

  if (isEmptyName(mergedName)) {
    effNames <- sort(effNames)
    mergedName <- paste0(paste(effNames, collapse = "_"), "-merge")
  }

  # new level must be last!
  levels(clusters) <- c(levels(clusters), mergedName)
  clusters[clusters %in% effNames] <- mergedName
  clusters <- droplevels(clusters)

  return(clusters)
}


#' @details `multiMergeClusters()` given a *clusterization*, creates a new one
#'   where the given sets of *clusters* are merged.
#'
#' @param clusters A named `vector` or `factor` that defines the *clusters*
#' @param namesList A `list` of `list`s of *clusters* names to be respectively
#'   merged
#' @param mergedNames The names of the new merged *clusters*
#'
#' @returns `multiMergeClusters()` returns a new *clusterization* with the
#'   wanted *clusters* being merged by consecutive iterations of
#'   [mergeClusters()] on the given `namesList`
#'
#' @export
#'
#' @importFrom rlang is_empty
#'
#' @rdname ClustersList
#'
multiMergeClusters <- function(clusters, namesList, mergedNames = NULL) {
  if (is_empty(namesList)) {
    warning("Passed no clusters lists to merge")
  }

  if (is_empty(mergedNames)) {
    mergedNames <- rep_len("", length(namesList))
  }

  assert_that(length(mergedNames) == length(namesList),
              msg = paste("When given 'mergedNames' must have",
                          "the same length as 'namesList'"))

  for (i in seq_along(namesList)) {
    clusters <- mergeClusters(clusters,
                              names = namesList[[i]],
                              mergedName = mergedNames[[i]])
  }

  return(clusters)
}

#----------------- plot utilities --------------------

#' @details `plotTheme()` returns the appropriate theme for the selected plot
#'   kind. Supported kinds are:  `"common"`, `"pca"`, `"genes"`, `"UDE"`,
#'   `"heatmap"`, `"GDI"`, `"UMAP"`, `"size-plot"`
#'
#' @seealso [ggplot2::theme()] and [ggplot2::ggplot()]
#'
#' @param plotKind a string indicating the plot kind
#' @param textSize axes and strip text size (default=14)
#'
#' @returns `plotTheme()` returns a `ggplot2::theme` object
#
#' @importFrom ggplot2 theme
#' @importFrom ggplot2 element_text
#' @importFrom ggplot2 element_blank
#' @importFrom ggplot2 element_rect
#' @importFrom ggplot2 unit
#'
#' @importFrom ggthemes theme_tufte
#'
#' @export
#'
#' @examples
#' theme <- plotTheme("pca")
#'
#' @rdname HeatmapPlots
#'
plotTheme <- function(plotKind = "common", textSize = 14L) {
  myDarkBlue <- "#3C5488FF"
  s <- textSize

  basicTheme <- theme(
    axis.text.x  = element_text(size = s, angle =  0L, hjust = 0.5, vjust = 0.5,
                                face = "plain", colour = myDarkBlue),
    axis.text.y  = element_text(size = s, angle =  0L, hjust = 0.0, vjust = 0.5,
                                face = "plain", colour = myDarkBlue),
    axis.title.x = element_text(size = s, angle =  0L, hjust = 0.5, vjust = 0.0,
                                face = "plain", colour = myDarkBlue),
    axis.title.y = element_text(size = s, angle = 90L, hjust = 0.5, vjust = 0.5,
                                face = "plain", colour = myDarkBlue))

  if (plotKind == "common") {
    return(basicTheme)
  }

  if (plotKind == "pca") {
    return(basicTheme +
           theme(legend.title = element_blank(),
                 legend.text = element_text(size = 12L, face = "italic",
                                            color = myDarkBlue),
                 legend.position = "bottom"))
  }

  if (plotKind == "genes") {
    return(
      basicTheme +
        theme(
          plot.title.position = "plot",  # title sits above the panel
          plot.title = element_text(
            size = 20L,
            hjust = 0.02,
            vjust = 1.0,                 # no negative vjust
            face = "italic",
            color = myDarkBlue
            #margin = margin(b = 8)       # spacing between title and panel
          )
          #plot.margin = margin(t = 8, r = 6, b = 6, l = 6)
        )
    )
  }

  if (plotKind == "UDE") {
    return(basicTheme +
           theme(plot.title   = element_text(size = 20L, color = myDarkBlue),
                 legend.title = element_text(size = 14L, color = myDarkBlue,
                                             face = "italic"),
                 legend.text  = element_text(size = 11L, color = myDarkBlue),
                 legend.key.width = unit(2.0, "mm"),
                 legend.position = "right"))
  }

  if (plotKind == "heatmap") {
    return(basicTheme +
           theme(axis.title.x = element_blank(),
                 axis.title.y = element_blank(),
                 panel.spacing = unit(0.0, "lines"),
                 strip.background = element_rect(fill = "#8491B44C"),
                 strip.text.y = element_text(size = s, colour = myDarkBlue),
                 strip.text.x = element_text(size = s, angle = 90L,
                                             colour = myDarkBlue),
                 legend.text = element_text(color = myDarkBlue,
                                            face = "italic"),
                 legend.position = "bottom",
                 legend.title = element_blank(),
                 legend.key.height = unit(2.0, "mm")))
  }

  if (plotKind == "GDI") {
    return(basicTheme +
           theme(legend.title = element_blank(),
                 plot.title = element_text(size = s + 2L,
                                           face = "bold.italic",
                                           color = myDarkBlue),
                 legend.text = element_text(color = myDarkBlue,
                                            face = "italic"),
                 legend.position = "bottom"))
  }

  if (plotKind == "UMAP") {
    return(basicTheme +
             theme(legend.title = element_blank(),
                   plot.title = element_text(size = s + 2L,
                                             face = "bold.italic",
                                             color = myDarkBlue),
                   legend.text = element_text(color = myDarkBlue,
                                              face = "italic"),
                   legend.position = "right"))
  }

  if (plotKind == "size-plot") {
    return(ggthemes::theme_tufte() +
           theme(legend.position = "none"))
  }

  warning("plotTheme: no match found in listed themes for: ", plotKind)
  return(basicTheme)
}

#' @title `getColorsVector`
#'
#' @description This function returns a list of colors based on the
#'   [RColorBrewer::brewer.pal()] function
#'
#' @details The colors are taken from the [RColorBrewer::brewer.pal.info()] sets
#'   with `Set1`, `Set2`, `Set3` placed first.
#'
#' @param numNeededColors The number of returned colors. If omitted it returns
#'   all available colors
#'
#' @returns an array of `RGB` colors of the wanted size
#'
#' @importFrom RColorBrewer brewer.pal
#' @importFrom RColorBrewer brewer.pal.info
#'
#' @importFrom utils head
#'
#' @export
#'
#' @examples
#' colorsVector <- getColorsVector(17)
#'
#' @rdname getColorsVector
#'
getColorsVector <- function(numNeededColors = 0L) {
  qualColPalets <- brewer.pal.info[brewer.pal.info[["category"]] == "qual", ]
  numColPalets <- nrow(qualColPalets)

  qualColPalets <- rbind(qualColPalets[(numColPalets - 2L):numColPalets, ],
                         qualColPalets[1L:(numColPalets - 3L), ])

  colVector <- unlist(Map(brewer.pal, qualColPalets[["maxcolors"]],
                          rownames(qualColPalets)))

  rm(qualColPalets, numColPalets)

  if (numNeededColors == 0L) {
    return(colVector)
  } else if (numNeededColors <= length(colVector)) {
    return(head(colVector, numNeededColors))
  } else {
    warning("Needed more colors than the number ",
            "of possible different colors:", length(colVector))
    return(head(rep(colVector, ceiling(numNeededColors / length(colVector))),
                numNeededColors))
  }
}

tm <- tempdir()
stopifnot(file.exists(tm))

library(Matrix)

prevOptState <- options(parallelly.fork.enable = TRUE)

test_that("Logging", {
  logPath <- file.path(tm, "COTAN_Test.log")

  suppressMessages({
    currentLevel <- setLoggingLevel(0L)
  })
  suppressMessages({
    currentFile  <- setLoggingFile(logPath)
  })

  expect_false(is.null(currentLevel[[1L]]))
  expect_null(currentFile[[1L]])
  expect_true(file.exists(logPath))

  expect_no_message(suppressMessages(logThis("This should not appear",
                                             logLevel = 0L, appendLF = FALSE)))

  # nolint start: space_inside_linter
  expect_message(   logThis("This should appear",     logLevel = 0L))
  expect_no_message(logThis("This should not appear", logLevel = 1L))

  suppressMessages(setLoggingLevel(1L))

  expect_message(   logThis("This should appear",     logLevel = 1L))
  expect_no_message(logThis("This should not appear"))
  # nolint end

  suppressMessages(setLoggingLevel(3L))
  suppressMessages(setLoggingFile(logPath))

  expect_message(logThis("This should appear",        logLevel = 3L))

  # restore logging status
  suppressMessages(setLoggingLevel(currentLevel))
  suppressMessages(setLoggingFile(""))

  expect_equal(R.utils::countLines(logPath), 5L, ignore_attr = TRUE)
  file.remove(logPath)
})


test_that("Clusterizations manipulations", {
  set.seed(1675787192L)
  elemValues <- paste0("", as.roman(sample.int(7L, 100L, replace = TRUE)))
  elemNames <- paste0("el_", 1L:100L)

  clusters <- as.data.frame(list("a" = elemNames, "b" = elemValues))
  clusters <- asClusterization(clusters, elemNames)

  expect_s3_class(clusters, "factor")
  expect_setequal(levels(clusters), paste0("", as.roman(1L:7L)))
  expect_named(clusters, elemNames)

  clustersList <- toClustersList(clusters)

  expect_length(clustersList, 7L)
  expect_setequal(lengths(clustersList), as.vector(table(clusters)))

  clusters2 <- fromClustersList(clustersList, elemNames)

  expect_identical(clusters2, clusters)

  clusters3 <- fromClustersList(clustersList, elemNames = NULL)
  expect_equal(table(clusters2), table(clusters3), ignore_attr = TRUE)

  positions <- groupByClusters(clusters)

  expect_identical(clusters2[positions], clusters3)

  expect_identical(groupByClusters(clusters2), positions)
  expect_identical(groupByClustersList(elemNames, clustersList), positions)

  # cause mismatches between the element names and the clusterization
  elemNames <- append(elemNames, paste0("el_", 201L:210L), after = 20L)[1L:100L]

  expect_setequal(fromClustersList(clustersList, elemNames)[21L:30L], "-1")

  expect_identical(groupByClustersList(elemNames, clustersList)[91L:100L],
                   (21L:30L))

  clusterM1 <- mergeClusters(clusters, names = as.roman(c(5L, 1L)),
                             mergedName = "I'V")

  expect_identical(levels(clusterM1)[[nlevels(clusterM1)]], "I'V")
  expect_identical(table(clusterM1)[["I'V"]], sum(table(clusters)[c(1L, 5L)]))

  clusterM2 <-
    multiMergeClusters(clusters3, namesList = list(as.roman(c(1L, 5L)),
                                                   as.roman(c(6L, 2L, 4L))))

  expect_setequal(levels(clusterM2),
                  c("I_V-merge", "II_IV_VI-merge", "III", "VII"))
  expect_identical(sum(clusterM2 == "I_V-merge"), sum(clusterM1 == "I'V"))

  niceClusters <- niceFactorLevels(clusters)
  expect_identical(max(nchar(factorToVector(niceClusters))), 3L)
  expect_identical(min(nchar(factorToVector(niceClusters))), 3L)
  expect_true(all(endsWith(factorToVector(niceClusters),
                           factorToVector(clusters))))

  levels(niceClusters) <- c(1L:3L, 11L:13L, 100L)
  niceClusters <- niceFactorLevels(niceClusters)
  expect_identical(max(nchar(factorToVector(niceClusters))), 3L)
  expect_identical(min(nchar(factorToVector(niceClusters))), 3L)
  expect_setequal(as.integer(levels(niceClusters)), c(1L:3L, 11L:13L, 100L))
})


test_that("Adding/extracting columns to/from data.frames", {
  df <- data.frame()

  df <- setColumnInDF(df, colName = "constant", colToSet = rep(1L, 10L))
  expect_identical(dim(df), c(10L, 1L))
  expect_setequal(df[["constant"]], 1L)

  df <- setColumnInDF(df, colToSet = (1L:10L),
                      colName = "sequence", rowNames = LETTERS[1L:10L])
  expect_identical(rownames(df), LETTERS[1L:10L])
  expect_identical(colnames(df), c("constant", "sequence"))
  expect_identical(getColumnFromDF(df, "constant"),
                   rlang::set_names(rep(1L, 10L), LETTERS[1L:10L]))
  expect_identical(getColumnFromDF(df, 2L),
                   rlang::set_names(seq_len(10L), LETTERS[1L:10L]))

  df <- setColumnInDF(df, colName = "constant", colToSet = rep(2L, 10L))
  expect_identical(colnames(df), c("constant", "sequence"))
  expect_setequal(df[["constant"]], 2L)
})

# nolint start: spaces_inside_linter
test_that("funProbZero", {
  # Cases with mu = 0 are not actually in use
  expect_identical(funProbZero(-Inf, 0.0), 0.0)
  expect_identical(funProbZero(-1.0, 0.0), 1.0)
  expect_identical(funProbZero( 0.0, 0.0), 1.0)
  expect_identical(funProbZero(1e-6, 0.0), 1.0)
  expect_identical(funProbZero( 1.0, 0.0), 1.0)
  expect_identical(funProbZero(10.0, 0.0), 1.0)
  expect_identical(funProbZero( Inf, 0.0), 1.0)

  # Cases with infinite disp can happen
  expect_identical(funProbZero(-Inf, 1.0),            0.0)
  expect_identical(funProbZero(-1.0, 1.0),      exp(-2.0))
  expect_identical(funProbZero( 0.0, 1.0),      exp(-1.0))
  expect_identical(funProbZero(1e-6, 1.0), exp(-0.999999))
  expect_identical(funProbZero( 1.0, 1.0),      1.0 / 2.0)
  expect_identical(funProbZero(10.0, 1.0),      11.0^-0.1)
  expect_identical(funProbZero( Inf, 1.0),            1.0)

  # Cases with mu = Inf are not actually in use
  expect_identical(funProbZero(-Inf, Inf), 0.0)
  expect_identical(funProbZero(-1.0, Inf), 0.0)
  expect_identical(funProbZero( 0.0, Inf), NaN)
  expect_identical(funProbZero(1e-6, Inf), NaN)
  expect_identical(funProbZero( 1.0, Inf), 0.0)
  expect_identical(funProbZero(10.0, Inf), 0.0)
  expect_identical(funProbZero( Inf, Inf), 1.0)
})
# nolint end


test_that("funProbZero with matrices", {
  mu <- matrix((1L:25L) / 7.0, nrow = 10L, ncol = 10L)
  disp <- c(-Inf, -1.0 / 3.0, 1e-6, (1L:6L) / 3.0, Inf)

  p <- funProbZero(disp, mu)

  expect_identical(dim(p), dim(mu))

  # nolint start: spaces_inside_linter
  expect_identical(p[ 1L,  1L], funProbZero(disp[[ 1L]], mu[ 1L,  1L]))
  expect_identical(p[ 1L, 10L], funProbZero(disp[[ 1L]], mu[ 1L, 10L]))

  expect_identical(p[ 2L,  2L], funProbZero(disp[[ 2L]], mu[ 2L,  2L]))
  expect_identical(p[ 3L,  7L], funProbZero(disp[[ 3L]], mu[ 3L,  7L]))
  expect_identical(p[ 6L,  4L], funProbZero(disp[[ 6L]], mu[ 6L,  4L]))

  expect_identical(p[10L,  1L], funProbZero(disp[[10L]], mu[10L,  1L]))
  expect_identical(p[10L, 10L], funProbZero(disp[[10L]], mu[10L, 10L]))
  # nolint end
})


test_that("dispersionSolvers", {
  lambda   <- c(3.0, 1.75, 2.0)
  nu       <- rep(c(0.5, 1.5), 5L)
  sumZeros <- c(0.0, 5.0, 1.0)

  d1 <- mapply(
    FUN       = dispersionBisection,
    lambda    = lambda,
    sumZeros  = sumZeros,
    MoreArgs  = list("nu" = nu),
    SIMPLIFY  = TRUE,    # collapse to atomic vector
    USE.NAMES = FALSE)

  expect_identical(d1, c(-Inf, 1.980468750, -0.646484375))

  expect_lt(max(abs(rowSums(funProbZero(d1, lambda %o% nu)) - sumZeros)),
            1.0e-3)

  d2 <- mapply(
    FUN       = dispersionNewton,
    lambda    = lambda,
    sumZeros  = sumZeros,
    MoreArgs  = list("nu" = nu),
    SIMPLIFY  = TRUE,    # collapse to atomic vector
    USE.NAMES = FALSE)

  expect_equal(d2, c(-Inf, 1.980664643877, -0.645937418860), tolerance = 1e-12)

  expect_lt(max(abs(rowSums(funProbZero(d2, lambda %o% nu)) - sumZeros)),
            2.0e-5)

  d1p <- parallelDispersionBisection(1L:3L, sumZeros, lambda, nu)

  expect_identical(d1p, d1)

  d2p <- parallelDispersionNewton(1L:3L, sumZeros, lambda, nu)

  expect_equal(d2p, d2, tolerance = 1e-12)
})

test_that("nuBisection", {
  lambda       <- c(5.5,  4.0, 2.0, 1.0, 5.5, 1.5, 3.0, 3.5, 1.0, 4.5)
  dispersion   <- c(-Inf, 4.0, 2.5, 0.9, 5.0, 1.9, 3.5, 4.0, 0.9, 4.5)
  sumZeros     <- c(3L, 6L)
  initialGuess <- c(1.0, 1.5)

  nu <- c(nuBisection(sumZeros = sumZeros[[1L]], lambda = lambda,
                      dispersion = dispersion,
                      initialGuess = initialGuess[[1L]]),
          nuBisection(sumZeros = sumZeros[[2L]], lambda = lambda,
                      dispersion = dispersion,
                      initialGuess = initialGuess[[2L]]))

  expect_identical(nu, c(3.1484375, 0.349365234375))
})


test_that("plotTheme", {
  expect_warning(
    plotTheme(plotKind = "Wrong", textSize = 12.0),
    regexp = "plotTheme"
  )
})


test_that("Raw data normalization", {
  utils::data("test.dataset", package = "COTAN")
  genesNamesTest <- readRDS(file.path(getwd(), "genes.names.test.RDS"))
  cellsNamesTest <- readRDS(file.path(getwd(), "cells.names.test.RDS"))

  raw <- test.dataset[genesNamesTest, cellsNamesTest]

  nu <- readRDS(file.path(getwd(), "nu.test.RDS"))
  rawNorm <- as.matrix(readRDS(file.path(getwd(), "raw.norm.test.RDS")))

  expect_identical(t(t(raw) * (1.0 / nu)), rawNorm)
})


test_that("parallelDist - cosine dissimilarity", {
  raw <- matrix(c(1L,  0L, 4L, 2L, 11L, 0L, 6L, 7L, 0L, 9L,
                  10L, 8L, 0L, 0L,  0L, 3L, 0L, 0L, 2L, 0L),
                nrow = 10L, ncol = 20L)
  rownames(raw) <- LETTERS[1L:10L]
  colnames(raw) <- letters[1L:20L]

  cd <- as.matrix(calcDist(t(raw), method = "cosine"))

  expect_equal(cd[(row(cd) + col(cd)) %% 2L == 1L], rep(cd[2L, 1L], 200L),
               tolerance = 1.0e-15)
  expect_equal(cd[(row(cd) + col(cd)) %% 2L == 0L], rep(cd[3L, 1L], 200L),
               tolerance = 1.0e-15)

  expect_error(expect_message(expect_message(calcDist(t(raw),
                                                      method = "dummy"))))
})


test_that("pca usage", {
  utils::data("test.dataset", package = "COTAN")

  pcaRaw <- runPCA(x = as.matrix(test.dataset), rank = 10L,
                   BSPARAM = IrlbaParam(), get.rotation = FALSE)[["x"]]

  expect_identical(rownames(pcaRaw), rownames(test.dataset))

  pcaExp <- readRDS(file.path(getwd(), "pca.raw.test.RDS"))

  pcaRaw <- pcaRaw[rownames(pcaExp), ]

  correlations <- c(cor(pcaRaw[, 1L], pcaExp[, 1L]),
                    cor(pcaRaw[, 2L], pcaExp[, 2L]))

  dists <- sqrt(c(sum((pcaRaw[, 1L] - correlations[[1L]] * pcaExp[, 1L])^2L),
                  sum((pcaRaw[, 2L] - correlations[[2L]] * pcaExp[, 2L])^2L)))

  expect_lt(max(dists), 10.0^(-4L))
})


# legacy
test_that("vec2mat_rfast", {
  mat <- matrix(0.0, nrow = 10L, ncol = 10L)
  mat <- Rfast::lower_tri.assign(mat, (1L:55L), diag = TRUE)
  mat <- Rfast::upper_tri.assign(mat,
                                 v = Rfast::upper_tri(Rfast::transpose(mat)))

  colnames(mat) <- paste0("row.", (1L:10L))
  rownames(mat) <- paste0("row.", (1L:10L))

  genes <- paste0("row.", c(1L, 2L, 9L, 10L))

  expect_identical(mat, vec2mat_rfast(mat2vec_rfast(mat)))
  expect_identical(mat[, genes],
                   vec2mat_rfast(mat2vec_rfast(mat), genes = genes))
})


test_that("mat2vec_rfast", {
  names.v <- paste0("raw", (1L:15L))

  vec <- list("genes" = names.v, "values" = 1L:120L)

  expect_equal(vec, mat2vec_rfast(vec2mat_rfast(vec)), ignore_attr = TRUE)
})

options(prevOptState)

## ----knitr options, echo = FALSE, include = FALSE-----------------------------
plotDev <- if (requireNamespace("ragg", quietly = TRUE)) {
  "ragg_png"
} else if (requireNamespace("Cairo", quietly = TRUE)) {
  "cairo_png"
} else {
  "png"
}

knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  fig.width = 7L,
  fig.height = 5L,
  dev = plotDev,
  fig.crop = FALSE,
  dpi = 100L
)

## ----preamble, message=FALSE, warning=FALSE-----------------------------------
library(COTAN)
library(zeallot)

# necessary to solve precedence of overloads
conflicted::conflict_prefer("%<-%", "zeallot")

# enable multi-processing (not on Windows)
prevOptState <- options(parallelly.fork.enable = TRUE)

## ----setup-and-log------------------------------------------------------------
dataDir <- file.path(tempdir(), "COTAN_vignette_data")
dir.create(dataDir, recursive = TRUE, showWarnings = FALSE)

print(dataDir)

outDir <- dataDir

# Log-level 2 was chosen to showcase better how the package works
# In normal usage a level of 0 or 1 is more appropriate
setLoggingLevel(2L)

# This file will contain all the logs produced by the package
# as if at the highest logging level
setLoggingFile(file.path(outDir, "vignette_uniform_clustering.log"))

## ----download-data------------------------------------------------------------
GEO <- "GSM2861514"

dir.create(file.path(dataDir, GEO), showWarnings = FALSE)

datasetFileName <-
  file.path(dataDir, GEO, "GSM2861514_E175_All_Cells_DGE.txt.gz")


# retries up to 5 times to get the dataset
attempts <- 0L
maxAttempts <- 5L
ok <- FALSE

while (attempts < maxAttempts && !ok) {
  attempts <- attempts + 1L

  if (!file.exists(datasetFileName)) {
    res <- try(
      GEOquery::getGEOSuppFiles(
        GEO = GEO,
        makeDirectory = TRUE,
        baseDir = dataDir,
        filter_regex = base::basename(datasetFileName),
        fetch_files = TRUE
      ),
      silent = TRUE
    )
  }

  ok <- file.exists(datasetFileName)

  if (!ok && attempts < maxAttempts) {
    Sys.sleep(1)
  }
}

assertthat::assert_that(
  ok,
  msg = paste0(
    "Failed to retrieve file '", datasetFileName,
    "' after ", maxAttempts, " attempts."
  )
)

rawDataset <- read.csv(datasetFileName, sep = "\t", row.names = 1L)

print(dim(rawDataset))

## ----create-cotan-object------------------------------------------------------
cond <- "mouse_cortex_E17.5"

obj <- COTAN(raw = rawDataset)
obj <-
  initializeMetaDataset(
    obj,
    GEO = GEO,
    sequencingMethod = "Drop_seq",
    sampleCondition = cond
  )

logThis(paste0("Condition ", getMetadataElement(obj, datasetTags()[["cond"]])),
        logLevel = 1L)

## ----add-origin-to-the-cotan-object-------------------------------------------
# mark cells origin
data(vignette.cells.origin)
head(vignette.cells.origin, 18)

obj <- 
  addCondition(obj, condName = "origin", conditions = vignette.cells.origin)

rm(vignette.cells.origin)

## ----drop-low-quality-cells---------------------------------------------------
# use previously established results to determine
# which cells were dropped in the cleaning stage
data(vignette.split.clusters)

cellsToDrop <-
  getCells(obj)[!(getCells(obj) %in% names(vignette.split.clusters))]

obj <- dropGenesCells(obj, cells = cellsToDrop)

# Log the remaining number of cells

logThis(paste("n cells", getNumCells(obj)), logLevel = 1L)

table(getCondition(obj, condName = "origin"))

rm(vignette.split.clusters)

## ----calculate-and-store-coex-matrix------------------------------------------
obj <-
  proceedToCoex(
    obj,
    calcCoex = FALSE,
    optimizeForSpeed = TRUE,
    cores = 3L,
    deviceStr = "cuda"
  )

## ----create-ut-clusterization, eval=FALSE, include=TRUE-----------------------
# # This code is a too computationally heavy to be used in a vignette [~20 min.]
# # So the result was stored and will be re-loaded in the next chunk
# 
# 
# initialClusters <- NULL
# 
# if (TRUE) {
#   # read from the last file among those named all_check_results_XX.csv
#   mergeDir <- file.path(outDir, cond, "reclustering")
# 
#   resFiles <-
#     list.files(
#       path = mergeDir,
#       pattern = "partial_clusterization_.*csv",
#       full.names = TRUE
#     )
# 
#   if (length(resFiles) != 0L) {
#     prevClustRes <-
#       read.csv(resFiles[length(resFiles)], header = TRUE, row.names = 1L)
#     initialClusters <- getColumnFromDF(prevClustRes, 1L)
#     initialClusters[is.na(initialClusters)] <- "-1"
#     initialClusters <- niceFactorLevels(initialClusters)
#   }
# }
# 
# 
# # default constructed checker is OK
# advChecker <- new("AdvancedGDIUniformityCheck")
# 
# c(splitClusters, splitCoexDF) %<-%
#   cellsUniformClustering(
#     obj,
#     initialResolution = 0.8,
#     checker = advChecker,
#     dataMethod = "LogLikelihood", # of observed against expected data
#     useCoexEigen = TRUE, # project on `COEX` eigenvectors instead doing a `PCA`
#     numReducedComp = 50L,
#     minimumUTClusterSize = 50L, # too large values imply many un-clustered cells
#     initialClusters = initialClusters,
#     initialIteration = 1L,
#     optimizeForSpeed = TRUE,
#     deviceStr = "cuda",
#     cores = 3L,
#     saveObj = TRUE, # save intermediate data for log and restart
#     outDir = outDir
#   )
# 
# # add the newly found clusterization to the `COTAN` object
# obj <-
#   addClusterization(
#     obj,
#     clName = "split",
#     clusters = splitClusters,
#     coexDF = splitCoexDF
#   )
# 
# table(splitClusters)

## ----load-pre-calculated-clusterization_split---------------------------------
data("vignette.split.clusters", package = "COTAN")
splitClusters <- vignette.split.clusters

# explicitly calculate the DEA of the clusterization to store it
splitCoexDF <- DEAOnClusters(obj, clusters = splitClusters)

obj <-
  addClusterization(
    obj,
    clName = "split",
    clusters = splitClusters,
    coexDF = splitCoexDF,
    override = FALSE
  )

## ----extract-clusterization-summary_split-------------------------------------
c(summaryData, summaryPlot) %<-%
  clustersSummaryPlot(
    obj,
    clName = "split",
    plotTitle = "split summary",
    condName = "origin"
  )

head(summaryData, n = 10L)

## ----summary-as-plot----------------------------------------------------------
plot(summaryPlot)

## ----define-layers-specific-genes---------------------------------------------
# these are some genes associated to each cortical layer
layersGenes <- list(
  "L1"   = c("Reln",   "Lhx5"),
  "L2/3" = c("Cux1",   "Satb2"),
  "L4"   = c("Rorb",   "Sox5"),
  "L5/6" = c("Bcl11b", "Fezf2"),
  "Prog" = c("Hes1",    "Vim")
)

## ----clusterization-data-visualization_split----------------------------------
c(splitHeatmap, splitScoreDF, splitPValueDF) %<-%
  clustersMarkersHeatmapPlot(
    obj,
    groupMarkers = layersGenes,
    clName = "split",
    kCuts = 2L,
    adjustmentMethod = "holm"
  )

ComplexHeatmap::draw(splitHeatmap)

## ----clusterization-umap-plot-via-drm_split, eval=FALSE, include=TRUE---------
# c(umapPlot, cellsRDM) %<-%
#   cellsUMAPPlot(
#     obj,
#     clName = "split",
#     clusters = NULL,
#     useCoexEigen = TRUE, # Aligning these to `split` generation gives best res.
#     dataMethod = "LogLikelihood", # "AdjBinarized" is also a good choice
#     numComp = 50L, # number of components of the data reduced matrix
#     colors = NULL, # a list of user defined colors for the various clusters
#     numNeighbors = 30L, # UMAP related parameters
#     minPointsDist = 0.3 # UMAP related parameters
#   )
# 
# plot(umapPlot)

## ----clusterization-umap-plot-via-drm_split_as-seurat-------------------------
c(umapPlot, cellsRDM) %<-%
  cellsUMAPPlot(
    obj,
    clName = "split",
    clusters = NULL,
    useCoexEigen = FALSE,
    dataMethod = "LogNormalized", 
    numComp = 50L, # number of components of the data reduced matrix
    genesSel = "HVG_Seurat",
    numGenes = 500L,
    colors = NULL, # a list of user defined colors for the various clusters
    numNeighbors = 30L, # UMAP related parameters
    minPointsDist = 0.3 # UMAP related parameters
  )

plot(umapPlot)

## ----merge-clusters-if-ut, eval=FALSE, include=TRUE---------------------------
# 
# checkersList <-
#   list(
#     advChecker,
#     shiftCheckerThresholds(advChecker, 0.01), # Sensible threshold shifts really
#     shiftCheckerThresholds(advChecker, 0.03)  # depend on the dataset
#   )
# 
# prevCheckRes <- data.frame()
# 
# # The following code shows the case when one wants to re-use the already
# # calculated checks from the saved intermediate outputs.
# # This can apply in cases one wants to add a new checker to the list above or
# # in the cases the execution is interrupted prematurely.
# #
# # Note that a similar facility exists for the `cellsUniformClustering()`
# # function above.
# #
# if (TRUE) {
#   # read from the last file among those named all_check_results_XX.csv
#   mergeDir <- file.path(outDir, cond, "leafs_merge")
# 
#   resFiles <-
#     list.files(
#       path = mergeDir,
#       pattern = "all_check_results_.*csv",
#       full.names = TRUE
#     )
# 
#   if (length(resFiles) != 0L) {
#     prevCheckRes <-
#       read.csv(resFiles[length(resFiles)], header = TRUE, row.names = 1L)
#   }
# }
# 
# c(mergedClusters, mergedCoexDF) %<-%
#   mergeUniformCellsClusters(
#     obj,
#     clusters = splitClusters,
#     checkers = checkersList,
#     allCheckResults = prevCheckRes,
#     optimizeForSpeed = TRUE,
#     deviceStr = "cuda",
#     cores = 6L,
#     useDEA = TRUE,
#     saveObj = TRUE,
#     outDir = outDir
#   )
# 
# # add the newly found clusterization to the `COTAN` object
# obj <-
#   addClusterization(
#     obj,
#     clName = "merge",
#     override = TRUE,
#     clusters = mergedClusters,
#     coexDF = mergedCoexDF
#   )
# 
# table(mergedClusters)

## ----load-pre-calculated-clusterization_merge---------------------------------
data("vignette.merge.clusters", package = "COTAN")
mergedClusters <- vignette.merge.clusters[getCells(obj)]

# explicitly calculate the DEA of the clusterization to store it
mergedCoexDF <- DEAOnClusters(obj, clusters = mergedClusters)

obj <-
  addClusterization(
    obj,
    clName = "merge",
    clusters = mergedClusters,
    coexDF = mergedCoexDF,
    override = FALSE
  )

# this gives immediate visual information about which clusters were merged
table(splitClusters, mergedClusters)

## ----extract-clusterization-summary_merge-------------------------------------
c(summaryData, summaryPlot) %<-%
  clustersSummaryPlot(
    obj,
    clName = "merge",
    plotTitle = "merge summary",
    condName = "origin"
  )

head(summaryData, n = 10L)

plot(summaryPlot)

## ----clusterization-data-visualization_merge----------------------------------
c(mergeHeatmap, mergeScoresDF, mergePValuesDF) %<-%
  clustersMarkersHeatmapPlot(
    obj,
    groupMarkers = layersGenes,
    clName = "merge",
    condNameList = list("origin")
  )

ComplexHeatmap::draw(mergeHeatmap)

## ----clusterization-data-visualization_merge-vs-split}------------------------
c(mergeVsSplitHeatmap, ..) %<-%
  clustersMarkersHeatmapPlot(
    obj,
    clName = "merge",
    condNameList = list("split"),
    conditionsList = list(splitClusters)
  )

ComplexHeatmap::draw(mergeVsSplitHeatmap)

## ----clusterization-umap-plot-via-drm_merge, eval=FALSE, include=TRUE---------
# c(umapPlot, .) %<-%
#   cellsUMAPPlot(
#     obj,
#     clName = "merge",
#     clusters = NULL,
#     useCoexEigen = TRUE,
#     dataMethod = "LogLikelihood", # "AdjBinarized" is also a good choice
#     numComp = 50L, # number of components of the data reduced matrix
#     colors = NULL, # a list of user defined colors for the various clusters
#     numNeighbors = 30L, # UMAP related parameters
#     minPointsDist = 0.3 # UMAP related parameters
#   )
# 
# plot(umapPlot)

## ----clusterization-umap-plot-via-drm_merge_as-seurat-------------------------
c(umapPlot, .) %<-%
  cellsUMAPPlot(
    obj,
    clName = "merge",
    clusters = NULL,
    useCoexEigen = FALSE,
    dataMethod = "LogNormalized", # "AdjBinarized" is also a good choice
    numComp = 50L, # number of components of the data reduced matrix
    genesSel = "HVG_Scanpy",
    numGenes = 500L,
    colors = NULL, # a list of user defined colors for the various clusters
    numNeighbors = 30L, # UMAP related parameters
    minPointsDist = 0.3 # UMAP related parameters
  )

plot(umapPlot)

## ----clean-up-----------------------------------------------------------------
if (file.exists(file.path(outDir, paste0(cond, ".cotan.RDS")))) {
  # delete file if it exists
  file.remove(file.path(outDir, paste0(cond, ".cotan.RDS")))
}
if (file.exists(file.path(outDir, paste0(cond, "_times.csv")))) {
  # delete file if it exists
  file.remove(file.path(outDir, paste0(cond, "_times.csv")))
}
if (dir.exists(file.path(outDir, cond))) {
  unlink(file.path(outDir, cond), recursive = TRUE)
}
# if (dir.exists(file.path(outDir, GEO))) {
#   unlink(file.path(outDir, GEO), recursive = TRUE)
# }

# stop logging to file
setLoggingFile("")
file.remove(file.path(outDir, "vignette_uniform_clustering.log"))

options(prevOptState)

## ----closure------------------------------------------------------------------
Sys.time()

sessionInfo()

## ------- Clean Plots --------

#' @details `cleanPlots()` creates the plots associated to the output of the
#'   [clean()] method.
#'
#' @param objCOTAN a `COTAN` object
#' @param includePCA a `Boolean` flag to determine whether to calculate the
#'   *PCA* associated with the normalized matrix. When `TRUE` the first four
#'   elements of the returned list will be `NULL`
#'
#' @returns `cleanPlots()` returns a `list` of `ggplot2` plots:
#'   * `"pcaCells"` is for `PCA` cells
#'   * `"pcaCellsData"` is the data of the `PCA` cells (can be plotted)
#'   * `"genes"` is for `B` group cells' genes
#'   * `"UDE"` is for cells' `UDE` against their `PCA`
#'   * `"nu"` is for cell `nu`
#'   * `"zoomedNu"` is the same but zoomed on the left and with an estimate
#'   for the low `nu` threshold that defines problematic cells
#'
#' @export
#'
#' @importFrom rlang set_names
#'
#' @importFrom tibble rownames_to_column
#' @importFrom tibble column_to_rownames
#'
#' @importFrom stats hclust
#' @importFrom stats cutree
#'
#' @importFrom utils head
#'
#' @importFrom Matrix t
#' @importFrom Matrix rowMeans
#'
#' @importFrom BiocSingular runPCA
#' @importFrom BiocSingular IrlbaParam
#'
#' @importFrom ggplot2 ggplot
#' @importFrom ggplot2 geom_point
#' @importFrom ggplot2 geom_tile
#' @importFrom ggplot2 geom_hline
#' @importFrom ggplot2 aes
#' @importFrom ggplot2 facet_grid
#' @importFrom ggplot2 ggtitle
#' @importFrom ggplot2 xlab
#' @importFrom ggplot2 ylab
#' @importFrom ggplot2 scale_color_gradient2
#' @importFrom ggplot2 scale_color_manual
#' @importFrom ggplot2 coord_cartesian
#' @importFrom ggrepel geom_text_repel
#'
#' @importFrom graphics par
#' @importFrom graphics title
#'
#' @importFrom dplyr filter
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom zeallot %<-%
#' @importFrom zeallot %->%
#'
#' @examples
#' # This creates many infomative plots useful to determine whether
#' # there is still something to drop...
#' # Here we use the tuple-like assignment feature of the `zeallot` package
#' clPlots <- cleanPlots(objCOTAN)
#' plot(clPlots[["pcaCells"]])
#' plot(clPlots[["UDE"]])
#' plot(clPlots[["zoomedNu"]])
#'
#' @rdname RawDataCleaning
#'
cleanPlots <- function(objCOTAN, includePCA = TRUE) {
  startTime <- Sys.time()
  logThis("Clean plots: START", logLevel = 2L)

  if (isTRUE(includePCA)) {
    logThis("PCA: START", logLevel = 2L)

    nuNormData <- getNuNormData(objCOTAN)

    # re-scale so that all the genes have mean 0.0 and stdev 1.0
    cellsRDM <- runPCA(x = t(nuNormData),
                       rank = 5L,
                       BSPARAM = IrlbaParam(),
                       get.rotation = FALSE)[["x"]]

    assert_that(identical(rownames(cellsRDM), getCells(objCOTAN)),
                msg = "Issues with pca output")

    logThis("PCA: DONE", logLevel = 2L)

    logThis("Hierarchical clustering: START", logLevel = 2L)

    distCells <- scale(cellsRDM)
    distCells <- calcDist(distCells, method = "euclidean") # mahlanobis

    cellsRDM <- as.data.frame(cellsRDM)

    # hclust cannot operate on more than 2^16 elements
    if (getNumCells(objCOTAN) <= 65500L) {
      hcCells <- hclust(distCells, method = "complete")
      groups <- cutree(hcCells, k = 2L)
    } else {
      groups <- set_names(rep(1L, times = getNumCells(objCOTAN)),
                          getCells(objCOTAN))
      # ensure B group is not empty picking the first cell
      groups[[1L]] <- 2L

      warning("cleanPlots() - More than 65500 cells in the COTAN object: ",
              "'B' group cannot be established and ",
              "is defaulted to include only the first cell", call. = FALSE)
      logThis("Too many cells: cannot establish 'B' group", logLevel = 3L)
    }
    rm(distCells)

    pos1 <- which(groups == 1L)
    pos2 <- which(groups == 2L)

    # ensure "A" group is the most numerous
    if (length(pos1) < length(pos2)) {
      # swap pos1 <-> pos2
      pos3 <- pos1
      pos1 <- pos2
      pos2 <- pos3
    }

    groups[pos1] <- "A"
    groups[pos2] <- "B"

    cellsRDM <- cbind(cellsRDM, groups)

    logThis("Hierarchical clustering: DONE", logLevel = 2L)
    gc()

    toClust <- as.matrix(round(nuNormData, digits = 4L))

    assert_that(identical(colnames(toClust), names(groups)),
                msg = "Error in the cell names")

    # ---- next: to check which genes are specific for the B group of cells
    B <- set_names(as.data.frame(toClust[, pos2]), colnames(toClust)[pos2])

    rm(toClust)

    bDf <- data.frame(means = rowMeans(B))
    rownames(bDf) <- rownames(B)

    rm(B)
    gc()

    ## keep only strctly positive means (so log10 is well-defined)
    bDf <- bDf[bDf[["means"]] > .Machine$double.eps, , drop = FALSE]

    ## sort by mean decreasing
    bDf <- bDf[order(bDf[["means"]], decreasing = TRUE), , drop = FALSE]

    ## add rank/index
    bDf[["n"]] <- seq_len(nrow(bDf))


    #check if the PCA plot is clean enough and from the printed genes,
    #if the smallest group of cells are characterized by particular genes

    cellsRDMa <- filter(cellsRDM, .data$groups == "A")
    cellsRDMb <- filter(cellsRDM, .data$groups != "A")

    cellsRDMPlot <-
      ggplot(
        cellsRDMa,
        aes(x = .data$PC1, y = .data$PC2, colour = .data$groups)
      ) +
      geom_point(alpha = 0.5, size = 1.0) +
      geom_point(
        data = cellsRDMb,
        aes(x = .data$PC1, y = .data$PC2, colour = .data$groups),
        alpha = 0.8,
        size = 1.5
      ) +
      scale_color_manual(
        name = "groups",
        values = c("A" = "#8491B4B2", "B" = "#E64B35FF")
      ) +
      plotTheme("pca")

    nLabel <- min(20L, nrow(bDf))
    labelDf <- bDf[seq_len(nLabel), , drop = FALSE]
    labelDf[["geneName"]] <- rownames(labelDf)

    genesPlot <-
      ggplot(
        bDf,
        aes(x = .data$n, y = .data$means)
      ) +
      geom_point() +
      ggtitle(
        label = "B cell group genes mean expression"
      ) +
      geom_label_repel(
        data = labelDf,
        aes(label = .data$geneName),
        min.segment.length = 0.0,
        box.padding = 0.35,
        point.padding = 0.2,
        max.overlaps = Inf
      ) +
      scale_y_log10() +
      plotTheme("genes")

    nuEst <- round(getNu(objCOTAN), digits = 7L)
    udePlot <-
      ggplot(
        cellsRDM,
        aes(x = .data$PC1, y = .data$PC2, colour = log(nuEst))
      ) +
      geom_point(size = 1L, alpha = 0.8) +
      scale_color_gradient2(
        low = "#E64B35B2",
        mid = "#4DBBD5B2",
        high = "#3C5488B2",
        midpoint = log(mean(nuEst)),
        name = "ln(nu)"
        ) +
      ggtitle("Cells PCA coloured by cells efficiency") +
      plotTheme("UDE")
  } else {
    cellsRDMPlot <- NULL
    cellsRDM <- NULL
    genesPlot <- NULL
    udePlot <- NULL
  }

  nuDf <- data.frame("nu" = sort(getNu(objCOTAN)),
                     "n" = seq_len(getNumCells(objCOTAN)))
  nuPlot <-
    ggplot(
      nuDf,
      aes(x = .data$n, y = .data$nu)
    ) +
    geom_point(colour = "#8491B4B2", size = 1L) +
    plotTheme("common")

  nuDf <- nuDf[seq_len(min(400L, nrow(nuDf))), ]
  zNuPlot <-
    ggplot(
      nuDf,
      aes(x = .data$n, y = .data$nu)
    ) +
    geom_point(colour = "#8491B4B2", size = 1L) +
    coord_cartesian(
      xlim = c(0L, nrow(nuDf)),
      ylim = c(0.0, round(max(nuDf[["nu"]]) + 0.05, digits = 2L))
    ) +
    plotTheme("common")

  # estimate the elbow point if any...
  secondDer <- diff(nuDf[seq_len(min(100L, nrow(nuDf))), "nu"],
                    differences = 2L)
  if (min(secondDer) < -0.01) {
    lowUDEThr <- nuDf[(max(which(secondDer < -0.01)) + 1L), "nu"] - 0.005
    zNuPlot <-
      zNuPlot +
      geom_hline(
        yintercept = lowUDEThr,
        linetype = "dashed",
        color = "darkred"
      ) +
      annotate(
        geom = "text",
        x = (nrow(nuDf) / 2.0),
        y = (lowUDEThr - 0.05),
        label = paste0("cells with nu < ", lowUDEThr,
                       " should probably be removed"),
        color = "darkred",
        size = 4.5
      )
  }

  endTime <- Sys.time()

  logThis(paste("Total calculations elapsed time:",
                difftime(endTime, startTime, units = "secs")),
          logLevel = 2L)

  logThis("Clean plots: DONE", logLevel = 2L)

  return(list("pcaCells" = cellsRDMPlot, "pcaCellsData" = cellsRDM,
              "genes" = genesPlot, "UDE" = udePlot,
              "nu" = nuPlot, "zoomedNu" = zNuPlot))
}

## ------- Scree Plots --------
##
#' @details `screePlot()` creates a plots showing the explained variance of the
#'   components of a PCA
#'
#' @param pcaStdDev a `vector` with the standard deviations of the various
#'  components
#'
#' @returns `screePlot()` returns a `ggplot2` plot for the explained variances
#'
#' @export
#'
#' @importFrom ggplot2 ggplot
#' @importFrom ggplot2 aes
#' @importFrom ggplot2 geom_bar
#' @importFrom ggplot2 geom_point
#' @importFrom ggplot2 geom_line
#' @importFrom ggplot2 labs
#'
#' @rdname RawDataCleaning
#'

screePlot <- function(pcaStdDev) {
  # Extract variance explained
  varExplained <- pcaStdDev^2L / sum(pcaStdDev^2L)

  # Convert to data frame for ggplot
  screeDF <- data.frame(PC = seq_along(varExplained), Variance = varExplained)

  # Create ggplot scree plot
  ggplot(
    screeDF,
    aes(x = .data$PC, y = .data$Variance)
  ) +
  geom_bar(stat = "identity", fill = "steelblue") +
  geom_point(color = "red", size = 3L) +
  geom_line(group = 1L, color = "red") +
  labs(
    title = "Scree Plot",
    x = "Principal Component",
    y = "Explained Variance"
  ) +
  plotTheme("pca")
}

#' Heatmap Plots
#'
#' @description These functions create heatmap `COEX` plots.
#'
#' @name HeatmapPlots
NULL

#' @details `singleHeatmapDF()` creates the `heatmap` `data.frame` of one
#'   `COTAN` object
#'
#' @param objCOTAN a `COTAN` object
#' @param genesLists A `list` of genes' `array`s. The first `array` defines the
#'   genes in the columns
#' @param sets A numeric array indicating which fields in the previous `list`
#'   should be used. Defaults to all fields
#' @param pValueThreshold The p-value threshold. Default is 0.01
#' @param cores number of cores to use. Default is 1.
#'
#' @returns `singleHeatmapDF()` returns a `data.frame`
#'
#' @importFrom tidyr pivot_longer
#'
#' @importFrom rlang is_empty
#' @importFrom rlang is_integer
#'
#' @importFrom assertthat assert_that
#'
#' @rdname HeatmapPlots
#'

singleHeatmapDF <- function(objCOTAN,
                            genesLists,
                            sets,
                            pValueThreshold = 0.01,
                            cores = 1L) {
  assert_that(!is_empty(genesLists), !is_empty(names(genesLists)),
              msg = "genesLists must be a named list of genes arrays")

  assert_that(!is_empty(sets), all(sets %% 1L == 0L),
              max(sets) <= length(genesLists),
              msg = "sets must be positions in the genes list")

  cond <- getMetadataElement(objCOTAN, datasetTags()[["cond"]])

  logThis(paste("Hangling COTAN object with condition:", cond), logLevel = 2L)

  allGenes <- getGenes(objCOTAN)

  colGenes <- genesLists[[1L]]
  genesLists <- genesLists[sets]

  askedGenes <- unique(unlist(genesLists))

  assert_that(any(colGenes %in% allGenes),
              msg = "none of primary markers are available in the COTAN object")

  #---------------------------------------------------------
  pValue <-
    calculatePValue(objCOTAN,
                    geneSubsetCol = allGenes[allGenes %in% colGenes],
                    geneSubsetRow = allGenes[allGenes %in% askedGenes],
                    cores = cores)
  pValue <- as.data.frame(pValue)

  pValue <- setColumnInDF(pValue, colToSet = rownames(pValue), colName = "g2")

  dfValue <- pivot_longer(pValue, cols = seq_len(ncol(pValue)) - 1L,
                          names_to = "g1", values_to = "pValue")
  rm(pValue)

  #---------------------------------------------------------
  coex <- getGenesCoex(objCOTAN, genes = allGenes[allGenes %in% colGenes])
  coex <- coex[allGenes %in% askedGenes, , drop = FALSE]
  coex <- as.data.frame(coex)

  coex <- setColumnInDF(coex, colToSet = rownames(coex), colName = "g2")
  dfCoex <- pivot_longer(coex, cols = seq_len(ncol(coex)) - 1L,
                         names_to = "g1", values_to = "coex")
  rm(coex)

  #---------------------------------------------------------
  assert_that(identical(colnames(dfValue)[-3L], colnames(dfCoex)[-3L]))

  dfMerge <- merge(dfCoex, dfValue)

  dfMerge[["cond"]] <- cond
  dfMerge[["type"]] <- NA
  dfMerge[["absent"]] <- FALSE

  rm(dfCoex, dfValue)
  #---------------------------------------------------------

  dfRet <- data.frame()
  for (genesType in names(genesLists)) {
    logThis(paste("Handling genes type:", genesType), logLevel = 3L)
    rowGenes <- genesLists[[genesType]]
    for (g1 in colGenes) {
      genesToUse <- (dfMerge[["g2"]] %in% rowGenes) & (dfMerge[["g1"]] == g1)
      dfSlice <- dfMerge[genesToUse, , drop = FALSE]

      # control if the subset is smaller than the number of wanted genes
      numMissingRows <- length(rowGenes) - nrow(dfSlice)
      if (numMissingRows > 0L) {
        extraRows <- as.data.frame(matrix(nrow = numMissingRows,
                                          ncol = ncol(dfSlice)))
        colnames(extraRows) <- colnames(dfSlice)
        extraRows[, "g1"] <- g1
        extraRows[, "cond"] <- cond
        extraRows[, "absent"] <- TRUE
        extraRows[, "pValue"] <- 1.0
        extraRows[, "g2"] <- rowGenes[!(rowGenes %in% dfSlice[["g2"]])]
        dfSlice <- rbind(dfSlice, extraRows)
      }
      # now dfSlice has the right number of rows
      assert_that(nrow(dfSlice) == length(rowGenes))

      dfSlice[["type"]] <- genesType
      dfRet <- rbind(dfRet, dfSlice)
    }
  }

  dfRet[["fe_genes"]] <- (dfRet[["g2"]] %in% getFullyExpressedGenes(objCOTAN)) |
                         (dfRet[["g1"]] %in% getFullyExpressedGenes(objCOTAN))

  dfRet[dfRet[["pValue"]] > pValueThreshold, "coex"] <- 0.0

  return(dfRet)
}


#' @details `heatmapPlot()` creates the `heatmap` of one or more `COTAN` objects
#'
#' @param objCOTAN a `COTAN` object
#' @param genesLists A `list` of genes' `array`s. The first `array` defines the
#'   genes in the columns
#' @param sets A numeric array indicating which fields in the previous `list`
#'   should be used. Defaults to all fields
#' @param pValueThreshold The \eqn{p}-value threshold. Default is \eqn{0.01}
#' @param cores number of cores to use. Default is 1.
#' @param conditions An `array` of prefixes indicating the different files
#' @param dir The directory in which are all `COTAN` files (corresponding to the
#'   previous prefixes)
#'
#' @returns `heatmapPlot()` returns a `ggplot2` object
#'
#' @importFrom ggplot2 ggplot
#' @importFrom ggplot2 aes
#' @importFrom ggplot2 geom_point
#' @importFrom ggplot2 facet_grid
#' @importFrom ggplot2 scale_fill_gradient2
#'
#' @importFrom dplyr filter
#'
#' @importFrom scales squish
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom rlang is_empty
#'
#' @export
#'
#' @examples
#' data("test.dataset")
#' objCOTAN <- COTAN(raw = test.dataset)
#' objCOTAN <- clean(objCOTAN)
#' objCOTAN <- estimateLambdaLinear(objCOTAN)
#' objCOTAN <- estimateDispersionNuBisection(objCOTAN, cores = 6L)
#' objCOTAN <- calculateCoex(objCOTAN, actOnCells = FALSE)
#' objCOTAN <- calculateCoex(objCOTAN, actOnCells = TRUE,
#'                           optimizeForSpeed = FALSE)
#'
#' ## some genes
#' primaryMarkers <- c("g-000010", "g-000020", "g-000138")
#'
#' ## an example of named list of different gene set
#' groupMarkers <- list(G1 = primaryMarkers,
#'                      G2 = c("g-000300", "g-000330"),
#'                      G3 = c("g-000510", "g-000530", "g-000550",
#'                             "g-000570", "g-000590"))
#'
#' hPlot <- heatmapPlot(objCOTAN, pValueThreshold = 0.05, cores = 3L,
#'                      genesLists = groupMarkers, sets = 2L:3L)
#' plot(hPlot)
#'
#' @rdname HeatmapPlots
#'
heatmapPlot <- function(objCOTAN = NULL,
                        genesLists,
                        sets = NULL,
                        pValueThreshold = 0.01,
                        cores = 1L,
                        conditions = NULL,
                        dir = ".") {
  startTime <- Sys.time()

  logThis("Heatmap plot: START", logLevel = 2L)

  assert_that(is.null(objCOTAN) != is_empty(conditions),
              msg = paste("Please pass either a COTAN object",
                          "or an array of conditions"))

  if (is_empty(sets)) {
    sets <- seq_along(genesLists)
  }

  dfToPrint <- data.frame()
  if (!is.null(objCOTAN)) {
    dfToPrint <-
      singleHeatmapDF(objCOTAN, genesLists = genesLists, cores = cores,
                      sets = sets, pValueThreshold = pValueThreshold)
  } else {
    for (cond in conditions) {
      logThis(paste0("Loading condition '", cond, "'"), logLevel = 3L)
      tempObj <- tryCatch({
          readRDS(file.path(dir, paste0(cond, ".cotan.RDS")))
        },
        error = function(err) {
          logThis(paste("While loading the COTAN object with file name",
                        paste0(cond, ".cotan.RDS"), "got an error:", err),
                  logLevel = 0L)
          return(NULL)
        })
      if (is.null(tempObj)) {
        next
      }
      dfTemp <-
        singleHeatmapDF(tempObj, genesLists = genesLists, cores = cores,
                        sets = sets, pValueThreshold = pValueThreshold)
      rm(tempObj)
      dfToPrint <- rbind(dfToPrint, dfTemp)
    }
  }

  logThis(paste("min COEX:", min(dfToPrint[["coex"]], na.rm = TRUE),
                "max COEX:", max(dfToPrint[["coex"]], na.rm = TRUE)),
          logLevel = 2L)

  filteredDF <-
    dfToPrint |>
    filter(.data$type %in% names(genesLists)[sets])

  heatMapPl <-
    ggplot(
      filteredDF,
      aes(
        x = .data$cond,
        y = factor(.data$g2, levels = rev(levels(factor(.data$g2))))
      )
    ) +
    geom_tile(
      aes(fill = .data$coex),
      colour = "black",
      show.legend = TRUE
    ) +
    facet_grid(
      rows = vars(.data$type),
      cols = vars(.data$g1),
      scales = "free",
      space = "free"
    ) +
    scale_fill_gradient2(
      low = "#E64B35FF",
      mid = "gray93",
      high = "#3C5488FF",
      midpoint = 0L,
      na.value = "grey80",
      space = "Lab",
      guide = "colourbar",
      aesthetics = "fill",
      oob = squish
    ) +
    plotTheme("heatmap", textSize = 9L)

  endTime <- Sys.time()

  logThis(paste("Total calculations elapsed time:",
                difftime(endTime, startTime, units = "secs")),
          logLevel = 2L)

  logThis("Heatmap plot: DONE", logLevel = 2L)

  return(heatMapPl)
}



#' @details `genesHeatmapPlot()` is used to plot an *heatmap* made using only
#'   some genes, as markers, and collecting all other genes correlated with
#'   these markers with a p-value smaller than the set threshold. Than all
#'   relations are plotted. Primary markers will be plotted as groups of rows.
#'   Markers list will be plotted as columns.
#'
#' @param objCOTAN a `COTAN` object
#' @param primaryMarkers A set of genes plotted as rows
#' @param secondaryMarkers A set of genes plotted as columns
#' @param pValueThreshold The p-value threshold. Default is 0.01
#' @param symmetric A Boolean: default `TRUE`. When `TRUE` the union of
#'   `primaryMarkers` and `secondaryMarkers` is used for both rows and column
#'   genes
#' @param cores number of cores to use. Default is 1.
#'
#' @returns `genesHeatmapPlot()` returns a `ggplot2` object
#'
#' @export
#'
#' @importFrom ComplexHeatmap Heatmap
#' @importFrom ComplexHeatmap Legend
#' @importFrom ComplexHeatmap draw
#'
#' @importFrom grid gpar
#'
#' @importFrom stats quantile
#'
#' @importFrom circlize colorRamp2
#'
#' @importFrom rlang is_empty
#'
#' @examples
#' ghPlot <- genesHeatmapPlot(objCOTAN, primaryMarkers = primaryMarkers,
#'                            secondaryMarkers = groupMarkers, cores = 3L,
#'                            pValueThreshold = 0.05, symmetric = FALSE)
#' plot(ghPlot)
#'
#' @rdname HeatmapPlots
#'
genesHeatmapPlot <-
  function(objCOTAN,
           primaryMarkers,
           secondaryMarkers = vector(mode = "character"),
           pValueThreshold = 0.01,
           symmetric = TRUE,
           cores = 1L) {
    if (isTRUE(symmetric)) {
      secondaryMarkers <- as.list(c(unlist(primaryMarkers),
                                    unlist(secondaryMarkers)))
    }

    if (is_empty(secondaryMarkers)) {
      secondaryMarkers <- as.list(primaryMarkers)
    } else {
      secondaryMarkers <- as.list(secondaryMarkers)
    }

    allMarkers <- unique(c(unlist(secondaryMarkers), unlist(primaryMarkers)))
    unexpressedGenes <- allMarkers[!allMarkers %in% getGenes(objCOTAN)]

    if (!is_empty(unexpressedGenes)) {
      warning("The markers ", toString(unexpressedGenes),
              " are not present in the COTAN object!")
    }

    pValue <- calculatePValue(objCOTAN, cores = cores)[, allMarkers]

    pvalFloored <- apply(pValue, 1.0, FUN = min)
    rowGenes <- names(pvalFloored)[pvalFloored < pValueThreshold]

    rowGenes <- unique(c(allMarkers, rowGenes))
    pValue <- as.data.frame(pValue)

    coex <- getGenesCoex(objCOTAN)[getGenes(objCOTAN) %in% rowGenes, ]
    if (isTRUE(symmetric)) {
      coex <- coex[, getGenes(objCOTAN) %in% rowGenes]
    }

    listRows <- list()
    for (m in unlist(secondaryMarkers)) {
      genes <- rownames(pValue[pValue[, m] < pValueThreshold, ])
      genes <- genes[genes %in% rownames(coex[coex[, m] > 0.0, ])]
      listRows[[m]] <- genes
    }

    clGenesRows <- data.frame()
    for (g in names(listRows)) {
      tmp <- data.frame("genes" = listRows[[g]],
                        "cl" = rep(g, length(listRows[[g]])))
      clGenesRows <- rbind(clGenesRows, tmp)
    }

    reorderIdxRow <- match(clGenesRows[["genes"]], rownames(coex))

    listCols <- list()
    for (m in primaryMarkers) {
      genes <- rownames(pValue[pValue[, m] < pValueThreshold, ])
      genes <- genes[genes %in% rownames(coex[coex[, m] > 0.0, ])]
      listCols[[m]] <- genes
    }

    if (isTRUE(symmetric)) {
      clGenesCols <- clGenesRows
    } else {
      clGenesCols <- data.frame()
      for (g in names(listCols)) {
        tmp <- data.frame("genes" = listCols[[g]],
                          "cl" = rep(g, length(listCols[[g]])))
        clGenesCols <- rbind(clGenesCols, tmp)
      }
    }

    clGenesCols <- clGenesCols[clGenesCols[["genes"]] %in% colnames(coex), ]

    reorderIdxCol <- match(clGenesCols[["genes"]], colnames(coex))

    coex <- coex[reorderIdxRow, reorderIdxCol]

    colorFunc <- colorRamp2(
      c(round(quantile(as.matrix(coex), probs = 0.001), digits = 3L),
        0.0,
        round(quantile(as.matrix(coex), probs = 0.999), digits = 3L)),
      c("#E64B35FF", "gray93", "#3C5488FF")
    )

    # The next line is to set the columns and raws order
    # need to be implemented
    part1 <- Heatmap(as.matrix(coex),
      cluster_rows = FALSE,
      cluster_columns = FALSE,
      row_split = clGenesRows[["cl"]],
      column_split = clGenesCols[["cl"]],
      col = colorFunc,
      show_row_names = FALSE,
      show_column_names = FALSE,
      column_title_gp = gpar(
        fill = "#8491B44C", font = 3L,
        col = "#3C5488FF"
      ),
      row_title_gp = gpar(fill = "#8491B44C", font = 3L, col = "#3C5488FF")
    )
    lgd <- Legend(
      col_fun = colorFunc, title = "COEX", grid_width = unit(0.3, "cm"),
      direction = "horizontal", title_position = "topcenter",
      title_gp = gpar(fontsize = 10L, fontface = "bold", col = "#3C5488FF"),
      labels_gp = gpar(col = "#3C5488FF", font = 3L)
    )
    invisible(
      draw(
        part1,
        show_heatmap_legend = FALSE,
        annotation_legend_list = lgd,
        annotation_legend_side = "bottom"
      )
    )
  }


#' @details `cellsHeatmapPlot()` creates the heatmap plot of the cells' `COEX`
#'   matrix
#'
#' @param objCOTAN a `COTAN` object
#' @param cells Which cells to plot (all if no argument is given)
#' @param clusters Use this clusterization to select/reorder the cells to plot
#'
#' @returns `cellsHeatmapPlot()` returns the cells' `COEX` *heatmap* plot
#'
#' @export
#'
#' @importFrom rlang is_empty
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom ComplexHeatmap Heatmap
#'
#' @examples
#' clusters <- c(rep_len("1", getNumCells(objCOTAN)/2),
#'               rep_len("2", getNumCells(objCOTAN)/2))
#' names(clusters) <- getCells(objCOTAN)
#'
#' chPlot <- cellsHeatmapPlot(objCOTAN, clusters = clusters)
#' ## plot(chPlot)
#'
#' @rdname HeatmapPlots
#'
cellsHeatmapPlot <- function(objCOTAN, cells = NULL, clusters = NULL) {
  coexMat <- as.matrix(getCellsCoex(objCOTAN))
  assert_that(!is_empty(coexMat), msg = "cells COEX not found in the COTAN")

  # if clustering is needed
  if (!is_empty(clusters)) {
    # identifier for each cluster
    clustersTags <- levels(factor(clusters))

    # size of each cluster
    clustersList <- toClustersList(clusters)
    clustersSize <- lengths(clustersList)

    # cell names grouped by the identifier of the cluster to which they belong
    cellNames <- unlist(clustersList)
    coexMat <- coexMat[cellNames, cellNames]
    colnames(coexMat) <- cellNames
    rownames(coexMat) <- cellNames

    Heatmap(coexMat,
            border = TRUE,
            column_split = factor(rep(clustersTags, clustersSize),
                                  levels = clustersTags),
            row_split = factor(rep(clustersTags, clustersSize),
                               levels = clustersTags),
            cluster_rows = FALSE,
            cluster_columns = FALSE)
  } else {
    cells <- handleNamesSubsets(getCells(objCOTAN), cells)

    Heatmap(coexMat[cells, cells],
            cluster_rows = FALSE,
            cluster_columns = FALSE)
  }
}

prevOptState <- options(parallelly.fork.enable = TRUE)

test_that("Raw and Clean plots", {
  utils::data("test.dataset", package = "COTAN")

  obj <- COTAN(raw = test.dataset)
  obj <- initializeMetaDataset(obj, GEO = " ",
                               sequencingMethod = "artificial",
                               sampleCondition = "test")

  expect_no_condition(plot(ECDPlot(obj)))
  expect_no_condition(plot(cellSizePlot(obj)))
  expect_no_condition(plot(genesSizePlot(obj)))
  expect_no_condition(plot(scatterPlot(obj)))

  gpp <- genesPercentagePlot(obj, genes = getGenes(obj)[1:30])
  expect_identical(dim(gpp[["sizes"]]), c(ncol(test.dataset), 5L))
  expect_identical(colnames(gpp[["sizes"]]),
                   c("sizes", "n", "sample", "sum", "percentage"))
  expect_no_condition(plot(gpp[["plot"]]))


  mpp <- mitochondrialPercentagePlot(obj, genePrefix = "g-0000")
  expect_identical(dim(mpp[["sizes"]]), c(ncol(test.dataset), 5L))
  expect_identical(colnames(mpp[["sizes"]]),
                   c("sizes", "n", "sample", "sum.mit", "mit.percentage"))
  expect_no_condition(plot(mpp[["plot"]]))

  obj <- clean(obj)
  clPlots <- cleanPlots(obj, includePCA = TRUE)

  expect_identical(names(clPlots),
                   c("pcaCells", "pcaCellsData", "genes",
                     "UDE", "nu", "zoomedNu"))
  expect_identical(dim(clPlots[["pcaCellsData"]]), c(ncol(test.dataset), 6L))
  expect_identical(colnames(clPlots[["pcaCellsData"]]),
                   c("PC1", "PC2", "PC3", "PC4", "PC5", "groups"))
  expect_no_condition(plot(clPlots[["pcaCells"]]))
  expect_no_condition(plot(clPlots[["pcaCellsData"]]))
  expect_no_condition(plot(clPlots[["genes"]]))
  expect_no_condition(plot(clPlots[["UDE"]]))
  expect_no_condition(plot(clPlots[["nu"]]))
  expect_no_condition(plot(clPlots[["zoomedNu"]]))

  batch <- factor(rep(c("L", "H"), each = getNumCells(obj) / 2L))
  names(batch) <- getCells(obj)
  obj <- addCondition(obj, condName = "H/L", conditions = batch)

  expect_no_condition(plot(ECDPlot(obj, condName = "H/L")))
  expect_no_condition(plot(cellSizePlot(obj, condName = "H/L")))
  expect_no_condition(plot(genesSizePlot(obj, condName = "H/L")))
  expect_no_condition(plot(scatterPlot(obj, condName = "H/L")))

  gpp <- genesPercentagePlot(obj, genes = getGenes(obj)[1:30], condName = "H/L")
  expect_identical(names(gpp), c("plot", "sizes"))
  expect_identical(dim(gpp[["sizes"]]), c(ncol(test.dataset), 5L))
  expect_identical(colnames(gpp[["sizes"]]),
                   c("sizes", "n", "sample", "sum", "percentage"))
  expect_no_condition(plot(gpp[["plot"]]))

  mpp <-
    mitochondrialPercentagePlot(obj, genePrefix = "g-0000", condName = "H/L")
  expect_identical(names(mpp), c("plot", "sizes"))
  expect_identical(dim(mpp[["sizes"]]), c(ncol(test.dataset), 5L))
  expect_identical(colnames(mpp[["sizes"]]),
                   c("sizes", "n", "sample", "sum.mit", "mit.percentage"))
  expect_no_condition(plot(mpp[["plot"]]))
})


test_that("Heatmap plots", {
  utils::data("test.dataset", package = "COTAN")

  obj <- COTAN(raw = test.dataset)
  obj <- initializeMetaDataset(obj, GEO = " ",
                               sequencingMethod = "artificial",
                               sampleCondition = "test")

  suppressWarnings(obj <- proceedToCoex(obj, calcCoex = TRUE, cores = 3L))

  groupMarkers <- list(G1 = c("g-000010", "g-000020", "g-000138",
                              "g-000150", "g-000160", "g-000170"),
                       G2 = c("g-000300", "g-000330", "g-000450",
                              "g-000460", "g-000470"),
                       G3 = c("g-000510", "g-000530", "g-000550",
                              "g-000570", "g-000590"))

  expect_no_error(suppressWarnings(
    plot(heatmapPlot(obj, cores = 3L, genesLists = groupMarkers))
  ))

  expect_no_error(suppressWarnings(
    genesHeatmapPlot(obj, symmetric = TRUE, cores = 3L,
                     primaryMarkers = lapply(groupMarkers, \(g) g[[1L]]))
  ))

  expect_no_error(suppressWarnings(
    genesHeatmapPlot(obj, symmetric = FALSE, cores = 3L,
                     primaryMarkers = lapply(groupMarkers, \(g) g[[1L]]))
  ))

  expect_no_error(suppressWarnings(
    genesHeatmapPlot(obj, symmetric = TRUE, cores = 3L,
                     primaryMarkers = lapply(groupMarkers, \(g) g[[1L]]),
                     secondaryMarkers = lapply(groupMarkers, \(g) g[[2L]]))
  ))

  expect_no_error(suppressWarnings(
    genesHeatmapPlot(obj, symmetric = TRUE, cores = 3L,
                     primaryMarkers = lapply(groupMarkers, \(g) g[[1L]]),
                     secondaryMarkers = lapply(groupMarkers, \(g) g[[2L]]))
  ))

  suppressWarnings(obj <- calculateCoex(obj, actOnCells = TRUE))
  expect_no_warning(
    plot(cellsHeatmapPlot(obj, getCells(obj)[seq.int(20, 1000, 20)]))
  )
})


test_that("Clusters plots", {
  utils::data("test.dataset", package = "COTAN")

  obj <- COTAN(raw = test.dataset)
  obj <- initializeMetaDataset(obj, GEO = " ",
                               sequencingMethod = "artificial",
                               sampleCondition = "test")

  suppressWarnings(obj <- proceedToCoex(obj, calcCoex = TRUE, cores = 3L))

  batch <- factor(rep(c("L", "H"), each = getNumCells(obj) / 2L))
  names(batch) <- getCells(obj)
  obj <- addCondition(obj, condName = "H/L", conditions = batch)
  obj <- addClusterization(obj, clName = "batch", batch)

  csdp1 <- clustersSummaryPlot(obj, clName = "batch",
                               plotTitle = "by batch")
  expect_identical(names(csdp1), c("data", "plot"))
  expect_identical(dim(csdp1[["data"]]), c(nlevels(batch), 8L))
  expect_identical(colnames(csdp1[["data"]]),
                   c("batch", "NoCond", "CellNumber", "CellPercentage",
                     "MeanUDE", "MedianUDE", "ExpGenes25", "ExpGenes"))
  expect_no_condition(plot(csdp1[["plot"]]))

  csdp2 <- clustersSummaryPlot(obj, clName = "batch", condName = "H/L",
                               plotTitle = "by batch")
  expect_identical(names(csdp2), c("data", "plot"))
  expect_identical(dim(csdp2[["data"]]), c(nlevels(batch) * nlevels(batch), 8L))
  expect_identical(colnames(csdp2[["data"]]),
                   c("batch", "H/L", "CellNumber", "CellPercentage",
                     "MeanUDE", "MedianUDE", "ExpGenes25", "ExpGenes"))
  expect_no_error(suppressWarnings(plot(csdp2[["plot"]])))

  groupMarkers <- list(G1 = c("g-000010", "g-000020", "g-000138",
                              "g-000150", "g-000160", "g-000170"),
                       G2 = c("g-000300", "g-000330", "g-000450",
                              "g-000460", "g-000470"),
                       G3 = c("g-000510", "g-000530", "g-000550",
                              "g-000570", "g-000590"))

  chpd1 <- clustersMarkersHeatmapPlot(obj, clName = "batch",
                                      groupMarkers = groupMarkers, kCuts = 2L)
  expect_identical(names(chpd1), c("heatmapPlot", "dataScore", "pValues"))
  expect_identical(dim(chpd1[["dataScore"]]),
                   c(length(unlist(groupMarkers)), 2L))
  expect_identical(dim(chpd1[["pValues"]]),
                   c(length(unlist(groupMarkers)), 2L))
  expect_no_warning(
    plot(chpd1[["heatmapPlot"]])
  )

  suppressWarnings(
    chpd2 <-
      clustersMarkersHeatmapPlot(obj, clName = "batch", condNameList = "H/L",
                                 groupMarkers = groupMarkers, kCuts = 2L)
  )
  expect_identical(names(chpd2), c("heatmapPlot", "dataScore", "pValues"))
  expect_identical(dim(chpd2[["dataScore"]]),
                   c(length(unlist(groupMarkers)), 2L))
  expect_identical(dim(chpd2[["pValues"]]),
                   c(length(unlist(groupMarkers)), 2L))
  expect_no_warning(
    plot(chpd2[["heatmapPlot"]])
  )

  cupd1 <- cellsUMAPPlot(obj, dataMethod = "LogLikelihood", clName = "batch",
                         useCoexEigen = TRUE, numComp = 5L)
  expect_identical(names(cupd1), c("plot", "cellsRDM"))
  expect_identical(dim(cupd1[["cellsRDM"]]), c(getNumCells(obj), 5L))
  expect_warning(
    plot(cupd1[["plot"]]),
    regexp = "No shared levels"
  )

  cupd2 <- cellsUMAPPlot(obj, dataMethod = "AdjBinarized",  clName = "batch",
                         useCoexEigen = FALSE, numComp = 5L,
                         genesSel = "HGDI", numGenes = 100)
  expect_identical(names(cupd2), c("plot", "cellsRDM"))
  expect_identical(dim(cupd2[["cellsRDM"]]), c(getNumCells(obj), 5L))
  expect_warning(
    plot(cupd2[["plot"]]),
    regexp = "No shared levels"
  )
})

options(prevOptState)

#' @details `clustersSummaryData()` calculates various statistics about each
#'   cluster (with an optional further `condition` to separate the cells).
#'
#' @param objCOTAN a `COTAN` object
#' @param clName The name of the *clusterization*. If not given the last
#'   available *clusterization* will be used, as it is probably the most
#'   significant!
#' @param clusters A *clusterization* to use. If given it will take precedence
#'   on the one indicated by `clName` that will only indicate the relevant
#'   column name in the returned `data.frame`
#' @param condName The name of a condition in the `COTAN` object to further
#'   separate the cells in more sub-groups. When no condition is given it is
#'   assumed to be the same for all cells (no further sub-divisions)
#' @param conditions The *conditions* to use. If given it will take precedence
#'   on the one indicated by `condName` that will only indicate the relevant
#'   column name in the returned `data.frame`
#'
#' @returns `clustersSummaryData()` returns a `data.frame`  with the following
#'   statistics: The calculated statistics are:
#'   * `"clName"` the *cluster* **labels**
#'   * `"condName"` the relevant condition (that sub-divides the *clusters*)
#'   * `"CellNumber"` the number of cells in the group
#'   * `"MeanUDE"` the average `UDE` in the group of cells
#'   * `"MedianUDE"` the median `UDE` in the group of cells
#'   * `"ExpGenes25"` the number of genes expressed in at the least 25% of the
#'     cells in the group
#'   * `"ExpGenes"` the number of genes expressed at the least once in any of
#'     the cells in the group
#'   * `"CellPercentage"` fraction of the cells with respect to the total cells
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom rlang is_empty
#'
#' @importFrom zeallot %<-%
#' @importFrom zeallot %->%
#'
#' @export
#'
#' @examples
#' summaryData <- clustersSummaryData(objCOTAN)
#'
#' @rdname HandlingClusterizations
#'
clustersSummaryData <- function(objCOTAN, clName = "", clusters = NULL,
                                condName = "", conditions = NULL) {
  # picks up the last clusterization if none was given
  c(clName, clusters) %<-%
    normalizeNameAndLabels(objCOTAN, name = clName,
                           labels = clusters, isCond = FALSE)

  # gets a dummy condition if none was given
  c(condName, conditions) %<-%
    normalizeNameAndLabels(objCOTAN, name = condName,
                           labels = conditions, isCond = TRUE)

  assert_that(!is_empty(clusters), !is_empty(conditions),
              msg = "Could not retrieve proper clusters or conditions")

  if (isEmptyName(condName)) {
    assert_that(levels(conditions) == "NoCond")
    condName <- "NoCond"
  }

  sDf <- as.data.frame(cbind(factorToVector(clusters),
                             factorToVector(conditions)))
  sDf <- as.data.frame(table(sDf))
  assert_that(ncol(sDf) == 3L, msg = "Internal error creating frequency table")

  colnames(sDf) <- c(clName, condName, "CellNumber")

  cellsPerc <- round(sDf[["CellNumber"]] / getNumCells(objCOTAN) * 100.0,
                     digits = 1L)

  sDf <- setColumnInDF(sDf, colToSet = cellsPerc, colName = "CellPercentage")

  sDf <- setColumnInDF(sDf, NA, colName = "MeanUDE")
  sDf <- setColumnInDF(sDf, NA, colName = "MedianUDE")
  sDf <- setColumnInDF(sDf, NA, colName = "ExpGenes25")
  sDf <- setColumnInDF(sDf, NA, colName = "ExpGenes")

  for (cond in levels(factor(sDf[[condName]]))) {
    condPosInDF <- sDf[[condName]] == cond
    condPosInMeta <- conditions == cond

    for (cl in levels(factor(sDf[[clName]]))) {
      posInDF   <- (sDf[[clName]] == cl) & condPosInDF
      posInMeta <- (clusters == cl) & condPosInMeta

      nu <- getNu(objCOTAN)[posInMeta]
      sDf[posInDF, "MeanUDE"]   <- round(mean(nu),   digits = 2L)
      sDf[posInDF, "MedianUDE"] <- round(median(nu), digits = 2L)

      numTimesGeneIsExpr <- rowSums(getZeroOneProj(objCOTAN)[, posInMeta,
                                                             drop = FALSE])

      sDf[posInDF, "ExpGenes25"] <- sum(numTimesGeneIsExpr > length(nu) * 0.25)
      sDf[posInDF, "ExpGenes"]   <- sum(numTimesGeneIsExpr > 0L)
    }
  }

  return(sDf)
}

#' @details `clustersSummaryPlot()` calculates various statistics about each
#'   cluster via [clustersSummaryData()] and puts them together into a plot.
#'
#' @param objCOTAN a `COTAN` object
#' @param clName The name of the *clusterization*. If not given the last
#'   available *clusterization* will be used, as it is probably the most
#'   significant!
#' @param clusters A *clusterization* to use. If given it will take precedence
#'   on the one indicated by `clName` that will only indicate the relevant
#'   column name in the returned `data.frame`
#' @param condName The name of a condition in the `COTAN` object to further
#'   separate the cells in more sub-groups. When no condition is given it is
#'   assumed to be the same for all cells (no further sub-divisions)
#' @param conditions The *conditions* to use. If given it will take precedence
#'   on the one indicated by `condName` that will only indicate the relevant
#'   column name in the returned `data.frame`
#' @param plotTitle The title to use for the returned plot
#'
#' @returns `clustersSummaryPlot()` returns a `list` with a `data.frame` and a
#'   `ggplot` objects
#'   * `"data"` contains the data,
#'   * `"plot"` is the returned plot
#'
#' @importFrom tidyr pivot_longer
#' @importFrom tidyr all_of
#'
#' @importFrom ggplot2 ggplot
#' @importFrom ggplot2 aes
#' @importFrom ggplot2 geom_bar
#' @importFrom ggplot2 geom_text
#' @importFrom ggplot2 position_dodge
#' @importFrom ggplot2 facet_wrap
#' @importFrom ggplot2 scale_y_continuous
#' @importFrom ggplot2 expansion
#' @importFrom ggplot2 coord_flip
#' @importFrom ggplot2 theme_classic
#' @importFrom ggplot2 ggtitle
#' @importFrom ggplot2 scale_fill_brewer
#'
#' @importFrom assertthat assert_that
#'
#' @export
#'
#' @rdname HandlingClusterizations
#'
clustersSummaryPlot <- function(objCOTAN, clName = "", clusters = NULL,
                                condName = "", conditions = NULL,
                                plotTitle = "") {

  clDf <- clustersSummaryData(objCOTAN, clName = clName, clusters = clusters,
                              condName = condName, conditions = conditions)

  clDfNames <- colnames(clDf)
  colRng <- (which(clDfNames == "CellNumber"):which(clDfNames == "ExpGenes"))
  plotDF <- clDf |>
    pivot_longer(
      cols      = all_of(clDfNames[colRng]),
      names_to  = "keys",
      values_to = "values"
    )

  # normalize col names
  cNames <- colnames(clDf)
  plotDF[["Cluster"]] <- plotDF[[cNames[[1L]]]]
  plotDF[["Condition"]] <- plotDF[[cNames[[2L]]]]

  cSPl <- ggplot(plotDF, aes(.data$Cluster, .data$values,
                             fill = .data$Condition)) +
    geom_bar(position = "dodge", stat = "identity", color = "black") +
    geom_text(aes(x = .data$Cluster, y = .data$values, label = .data$values,
                  vjust = 0.5, hjust = -0.1),
              position = position_dodge(width = 1.0)) +
    facet_wrap(~ keys, ncol = 6L, scales = "free") +
    scale_y_continuous(expand = expansion(mult = c(0.05, 0.4))) +
    coord_flip() +
    theme_classic() +
    ggtitle(plotTitle) +
    scale_fill_brewer(palette = "Accent")

  return(list("data" = clDf, "plot" = cSPl))
}



#' @details `clustersTreePlot()` returns the `dendogram` plot where the given
#'   *clusters* are placed on the base of their relative distance. Also if
#'   needed calculates and stores the `DEA` of the relevant *clusterization*.
#'
#' @param objCOTAN a `COTAN` object
#' @param kCuts the number of estimated *cluster* (this defines the height for
#'   the tree cut)
#' @param clName The name of the *clusterization*. If not given the last
#'   available *clusterization* will be returned, as it is probably the most
#'   significant!
#' @param clusters A *clusterization* to use. If given it will take precedence
#'   on the one indicated by `clName` that will only indicate the relevant
#'   column name in the returned `data.frame`
#' @param useDEA Boolean indicating whether to use the *DEA* to define the
#'   distance; alternatively it will use the average *Zero-One* counts, that is
#'   faster but less precise.
#' @param distance type of distance to use. Default is `"cosine"` for *DEA* and
#'   `"euclidean"` for *Zero-One*. Can be chosen among those supported by
#'   [parallelDist::parDist()]
#' @param hclustMethod default is "ward.D2" but can be any method defined by
#'   [stats::hclust()] function
#'
#' @returns `clustersTreePlot()` returns a list with 2 objects:
#'  * `"dend"` a `ggplot2` object representing the `dendrogram` plot
#'  * `"objCOTAN"` the updated `COTAN` object
#'
#' @importFrom rlang is_empty
#'
#' @importFrom dendextend set
#' @importFrom dendextend color_labels
#' @importFrom dendextend branches_color
#'
#' @importFrom stats hclust
#' @importFrom stats cutree
#' @importFrom stats as.dendrogram
#'
#' @importFrom zeallot %<-%
#' @importFrom zeallot %->%
#'
#' @export
#'
#' @examples
#' treePlotAndObj <- clustersTreePlot(objCOTAN, 2)
#' objCOTAN <- treePlotAndObj[["objCOTAN"]]
#' plot(treePlotAndObj[["dend"]])
#'
#' @rdname HandlingClusterizations
#'
clustersTreePlot <- function(objCOTAN,
                             kCuts,
                             clName = "",
                             clusters = NULL,
                             useDEA = TRUE,
                             distance = NULL,
                             hclustMethod = "ward.D2") {
  # pick last if no name was given
  # picks up the last clusterization if none was given
  c(clName, clusters) %<-%
    normalizeNameAndLabels(objCOTAN, name = clName,
                           labels = clusters, isCond = FALSE)
  assert_that(inherits(clusters, "factor"),
              msg = "Internal error - clusters must be factors")

  if (kCuts > nlevels(clusters)) {
    logThis("The number of cuts must be not more than the number of clusters",
            logLevel = 1L)
    kCuts <- nlevels(clusters)
  }

  colVector <- getColorsVector(kCuts)

  # merge small cluster based on distances
  clDist <- distancesBetweenClusters(objCOTAN,
                                     clName = clName, clusters = clusters,
                                     useDEA = useDEA, distance = distance)
  rm(clusters)

  hcNorm <- hclust(clDist, method = hclustMethod)

  dend <- as.dendrogram(hcNorm)
  dend <- branches_color(dend, k = kCuts, col = colVector, groupLabels = TRUE)
  dend <- color_labels(dend, k = kCuts)
  dend <- set(dend = dend, "branches_lwd", 4L)

  return(list("dend" = dend, "objCOTAN" = objCOTAN))
}

#' @details `ECDPlot()` plots the *Empirical Cumulative Distribution* function
#'   of library sizes (`UMI` number). It helps to define where to drop "cells"
#'   that are simple background signal.
#'
#' @param objCOTAN a `COTAN` object
#' @param yCut y threshold of library size to drop. Default is `NaN`
#' @param condName The name of a condition in the `COTAN` object to further
#'   separate the cells in more sub-groups. When no condition is given it is
#'   assumed to be the same for all cells (no further sub-divisions)
#' @param conditions The *conditions* to use. If given it will take precedence
#'   on the one indicated by `condName` that will only indicate the relevant
#'   column name in the returned `data.frame`
#'
#' @returns `ECDPlot()` returns an `ECD` plot
#'
#' @importFrom ggplot2 ggplot
#' @importFrom ggplot2 geom_point
#' @importFrom ggplot2 geom_hline
#'
#' @export
#'
#' @examples
#' ## These plots might help to identify genes/cells that need to be dropped
#' ecdPlot <- ECDPlot(objCOTAN, yCut = 100.0)
#' plot(ecdPlot)
#'
#' @rdname RawDataCleaning
#'
ECDPlot <- function(objCOTAN, yCut = NaN,
                    condName = "", conditions = NULL) {
  libSize <- sort(getCellsSize(objCOTAN), decreasing = TRUE)
  sizes <- setColumnInDF(data.frame(), colToSet = libSize, colName = "libSize")

  n <- seq_along(libSize)
  sizes <- setColumnInDF(sizes, colToSet = n, colName = "n")

  c(., conditions) %<-%
    normalizeNameAndLabels(objCOTAN, name = condName,
                           labels = conditions, isCond = TRUE)
  assert_that(!is_empty(conditions))

  sizes <- setColumnInDF(sizes, conditions[rownames(sizes)], colName = "sample")

  ecdPlot <-
    ggplot(
      sizes,
      aes(x = log(n), y = log(libSize), fill = sample, colour = sample)
    ) +
    geom_point()

  if (!is.nan(yCut)) {
    ecdPlot <- ecdPlot +
      geom_hline(yintercept = log(yCut), linetype = "dashed", color = "red")
  }
  return(ecdPlot)
}

# ---------- Dataset definitions ----------

#' @title Data-sets
#'
#' @description Simple data-sets included in the package
#'
#' @return Objects loaded by `data()`:
#'   - `raw.dataset`, `ERCCraw`, `test.dataset`: `data.frame`s
#'   - `test.dataset.clusters1`, `test.dataset.clusters2`:
#'     character vectors of cluster labels
#'   - `vignette.split.clusters`, `vignette.merge.clusters`,
#'     `vignette.cells.origin`: factors of cluster labels
#'
#' @name Datasets
NULL

# Raw sample dataset

#' @details `raw.dataset` is a sub-sample of a real *scRNA-seq* data-set
#'
#' @format `raw.dataset` is a data frame with \eqn{2000} genes and \eqn{815}
#'   cells
#'
#' @docType data
#'
#' @usage data(raw.dataset)
#'
#' @source `GEO` `GSM2861514`
#'
#' @rdname Datasets
#'
"raw.dataset"

# Raw `ERCC` dataset

#' @details `ERCCraw` dataset
#'
#' @format `ERCCraw` is a `data.frame`
#'
#' @docType data
#'
#' @usage data(ERCCraw)
#'
#' @source `ERCC`
#'
#' @rdname Datasets
#'
"ERCCraw"

#' @details `test.dataset` is an artificial data set obtained by sampling target
#'   negative binomial distributions on a set of \eqn{600} genes on \eqn{2} two
#'   cells *clusters* of \eqn{600} cells each. Each *clusters* has its own set
#'   of parameters for the distributions even, but a fraction of the genes has
#'   the same expression in both *clusters*.
#'
#' @format `test.dataset` is a `data.frame` with \eqn{600} genes and \eqn{1200}
#'   cells
#'
#' @docType data
#'
#' @usage data(test.dataset)
#'
#' @rdname Datasets
#'
"test.dataset"

#' @details `test.dataset.clusters1` is the *clusterization* obtained running
#'   `cellsUniformClustering()` on the `test.dataset`
#'
#' @format `test.dataset.clusters1` is a `character array`
#'
#' @docType data
#'
#' @usage data(test.dataset.clusters1)
#'
#' @rdname Datasets
#'
"test.dataset.clusters1"

#' @details `test.dataset.clusters2` is the *clusterization* obtained running
#'   `mergeUniformCellsClusters()` on the `test.dataset` using the previous
#'   *clusterization*
#'
#' @format `test.dataset.clusters2` is a `character array`
#'
#' @docType data
#'
#' @usage data(test.dataset.clusters2)
#'
#' @rdname Datasets
#'
"test.dataset.clusters2"


#' @details `vignette.cells.origin` is the factor discriminating between the
#'   *cortical* cells and the *other* cells. This was constructed from the
#'   following dataset: Mouse Cortex E17.5, `GEO`: `GSM2861514`
#'   \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSM2861514}
#'
#' @format `vignette.cells.origin` is a `factor`
#'
#' @docType data
#'
#' @usage data(vignette.cells.origin)
#'
#' @rdname Datasets
#'
"vignette.cells.origin"


#' @details `vignette.split.clusters` is the clusterization obtained running
#'   `cellsUniformClustering()` on the vignette dataset (mouse cortex E17.5,
#'   `GEO`: `GSM2861514`)
#'
#' @format `vignette.split.clusters` is a `factor`
#'
#' @docType data
#'
#' @usage data(vignette.split.clusters)
#'
#' @rdname Datasets
#'
"vignette.split.clusters"


#' @details `vignette.merge.clusters` is the clusterization obtained running
#'   `mergeUniformCellsClusters()` on the vignette dataset (mouse cortex E17.5,
#'   `GEO`: `GSM2861514`) starting from the `vignette.split.clusters`
#'   *clusterization*, with a sequence of progressively relaxed *UT* checks
#'
#' @format `vignette.merge.clusters` is a `factor`
#'
#' @docType data
#'
#' @usage data(vignette.merge.clusters)
#'
#' @rdname Datasets
#'
"vignette.merge.clusters"



# ---------- Torch library section ----------

# nolint start: line_length_linter

#' @title Installing `torch` `R` library (on `WSL-Linux`)
#'
#' @description A brief explanation of how to install the torch package on
#'   `WSL2` (`Windows Subsystem for Linux`), but it might work the same for
#'   other `Linux` systems. Naturally it makes a difference whether one wants to
#'   install support only for the `CPU` or also have the system `GPU` at the
#'   ready!
#'
#'   These are just *suggestions*, no guarantees are given:
#'   **try at your own peril!**
#'
#' @description The main resources to install `torch` is
#'   \url{https://torch.mlverse.org/docs/articles/installation.html} or
#'   \url{https://cran.r-project.org/web/packages/torch/vignettes/installation.html}
#'
#' @details For the `CPU`-only support one need to ensure that also numeric
#'   libraries are installed, like `BLAS` and `LAPACK` and/or `MKL` if your
#'   `CPU` is from *Intel*. Otherwise `torch` will be stuck at using a single
#'   core for all computations.
#'
#' @details For the `GPU`, currently only `cuda` devices are supported. Moreover
#'   only some specific versions of `cuda` (and corresponding `cudnn`) are
#'   effectively usable, so one needs to install them to actually use the `GPU`.
#'
#'   At the time of writing only `cuda` 12.8 is supported, but check the `torch`
#'   documentation for more up-to-date information. Before downgrading your
#'   `cuda` version, please be aware that it is possible to maintain separate
#'   main versions of `cuda` at the same time on the system.
#'
#'   Below a link to install `cuda` 12.8 for `WSL2` given: use a local installer
#'   to be sure the wanted `cuda` version is being installed, and not the latest
#'   one: [`cuda` 12.8 for `WSL2`](https://developer.nvidia.com/cuda-12-8-0-download-archive?target_os=Linux&target_arch=x86_64&Distribution=WSL-Ubuntu&target_version=2.0&target_type=deb_local)
#'
#'   It can happen that after the installation of the new `torch` version,
#'   including the dependencies, `torch` actually fails to run claiming that
#'   `lantern` dependency was not installed.
#'   This can happen due to presence of old cache files, so one can simply
#'   delete the relevant cache folder as in the example below...
#'
#' @examplesIf FALSE
#'   # find the relevant cache folder and delete it
#'   folder <- tools::R_user_dir("torch","cache")
#'   print(folder)
#'   unlink(folder, recursive = TRUE, force = TRUE)
#'
#'   # reinstall explicitly for the toolchain you want
#'   torch::install_torch(cuda_version = "12.8", reinstall = TRUE)
#'
#'   # run this only **AFTER** restarting `R`
#'   COTAN::canUseTorch(TRUE, "cuda")
#'
#' @references
#'   * `torch` installation guide:
#'     \url{https://torch.mlverse.org/docs/articles/installation.html}
#'   * CRAN `torch` installation vignette:
#'     \url{https://cran.r-project.org/web/packages/torch/vignettes/installation.html}
#'   * NVIDIA `CUDA 12.8` for `WSL2` download archive:
#'     \url{https://developer.nvidia.com/cuda-12-8-0-download-archive?target_os=Linux&target_arch=x86_64&Distribution=WSL-Ubuntu&target_version=2.0&target_type=deb_local}
#'
#' @return No return value. This topic is documentation-only.
#'
#' @name Installing_torch
#'
NULL

# nolint end

#'
#' @details `clustersDeltaExpression()` is a legacy function now superseded by
#'   [DEAOnClusters()]. It estimates the change in genes' expression inside the
#'   *cluster* compared to the average situation in the data set.
#'
#' @param objCOTAN a `COTAN` object
#' @param clName The name of the *clusterization*. If not given the last
#'   available *clusterization* will be used, as it is probably the most
#'   significant!
#' @param clusters A *clusterization* to use. If given it will take precedence
#'   on the one indicated by `clName`
#'
#' @returns `clustersDeltaExpression()` returns a `data.frame` with the
#'   \eqn{\nu} weighted discrepancy of the expression of each gene within the
#'   *cluster* against the corresponding model expectations
#'
#' @export
#'
#' @importFrom rlang is_empty
#'
#' @importFrom Matrix rowSums
#'
#' @importFrom Rfast rowsums
#'
#' @importFrom assertthat assert_that
#'
#' @rdname COTAN_Legacy
#'
clustersDeltaExpression <- function(objCOTAN, clName = "", clusters = NULL) {
  logThis("clustersDeltaExpression - START", logLevel = 2L)

  # picks up the last clusterization if none was given
  c(clName, clusters) %<-%
    normalizeNameAndLabels(objCOTAN, name = clName,
                           labels = clusters, isCond = FALSE)

  clustersList <- toClustersList(clusters)

  zeroOne <- getZeroOneProj(objCOTAN)
  probOne <- 1.0 - getProbabilityOfZero(objCOTAN)

  deltaExpression <- data.frame()
  for (cl in names(clustersList)) {
    logThis(paste0("Handling cluster '", cl, "'"),
            appendLF = FALSE, logLevel = 3L)

    cellsPos <- getCells(objCOTAN) %in% clustersList[[cl]]

    observedYI <- rowSums(zeroOne[, cellsPos])
    expectedYI <- rowsums(probOne[, cellsPos], parallel = TRUE)
    sumUDECluster <- sum(getNu(objCOTAN)[cellsPos])

    logThis(paste0(" with mean UDE ", sumUDECluster / sum(cellsPos)),
            logLevel = 3L)

    deltaE <- (observedYI - expectedYI) / sumUDECluster

    deltaExpression <- setColumnInDF(deltaExpression,
                                     colToSet = deltaE,
                                     colName = cl,
                                     rowNames = getGenes(objCOTAN))
  }

  logThis("clustersDeltaExpression - DONE", logLevel = 2L)

  return(deltaExpression)
}

#' @details `findClustersMarkers()` takes in a `COTAN` object and a
#'   *clusterization* and produces a `data.frame` with the `n` most positively
#'   enriched and the `n` most negatively enriched genes for each *cluster*. The
#'   function also provides whether and the found genes are in the given
#'   `markers` list or not. It also returns the *adjusted p-value* for
#'   multi-tests using the [stats::p.adjust()]
#'
#' @param objCOTAN a `COTAN` object
#' @param n the number of extreme `COEX` values to return
#' @param markers a `list` of marker genes
#' @param clName The name of the *clusterization*. If not given the last
#'   available *clusterization* will be used, as it is probably the most
#'   significant!
#' @param clusters A *clusterization* to use. If given it will take precedence
#'   on the one indicated by `clName`
#' @param coexDF a `data.frame` where each column indicates the `COEX` for each
#'   of the *clusters* of the *clusterization*
#' @param adjustmentMethod *p-value* multi-test adjustment method, see
#'   [stats::p.adjust.methods()]. Defaults to `"bonferroni"`; use `"none"` for
#'   no adjustment
#'
#' @returns `findClustersMarkers()` returns a `data.frame` containing `n` genes
#'   for each *cluster* scoring top/bottom `COEX` scores. The `data.frame` also
#'   contains:
#'   * `"CL"` the cluster
#'   * `"Gene"` the gene
#'   * `"Score"` the `COEX` score of the gene
#'   * `"adjPVal"` the *p-values* associated to the `COEX`
#'     adjusted for *multi-testing*
#'   * `"DEA"` the differential expression of the gene
#'   * `"IsMarker"` whether the gene is among the given markers
#'   * `"logFoldCh"` the *log-fold-change* of the gene expression inside versus
#'     outside the cluster from [logFoldChangeOnClusters()]
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom rlang is_empty
#'
#' @export
#'
#' @examples
#' clMarkers <- findClustersMarkers(objCOTAN, markers = list(),
#'                                  clusters = clusters)
#'
#' @rdname HandlingClusterizations
#'
findClustersMarkers <- function(
    objCOTAN, n = 10L, markers = NULL,
    clName = "", clusters = NULL,
    coexDF = NULL, adjustmentMethod = "bonferroni") {
  startTime <- Sys.time()

  logThis("findClustersMarkers - START", logLevel = 2L)

  marks <- unlist(markers)

  assert_that(is_empty(marks) || any(marks %in% getGenes(objCOTAN)),
              msg = "None of the given markers is present in the data")

  # picks up the last clusterization if none was given
  c(clName, clusters) %<-%
    normalizeNameAndLabels(objCOTAN, name = clName,
                           labels = clusters, isCond = FALSE)

  if (is_empty(coexDF)) {
    if (clName %in% getClusterizations(objCOTAN)) {
      coexDF <- getClusterizationData(objCOTAN, clName = clName)[["coex"]]
    }
    if (is_empty(coexDF)) {
      coexDF <- DEAOnClusters(objCOTAN, clusters = clusters)
    }
  }

  adjPValueDF <- pValueFromDEA(coexDF, numCells = getNumCells(objCOTAN),
                               adjustmentMethod = adjustmentMethod)

  lfcDF <- logFoldChangeOnClusters(objCOTAN, clusters = clusters)

  assert_that(identical(rownames(adjPValueDF), rownames(coexDF)),
              identical(getGenes(objCOTAN),    rownames(coexDF)),
              msg = paste("Inconsistent data-frames passed in",
                          "for `COEX` or `p-value`"))

  retDF <- as.data.frame(matrix(data = NA, nrow = 0L, ncol = 6L))
  colnames(retDF) <- c("CL", "Gene", "DEA", "adjPVal", "IsMarker", "logFoldCh")

  for (cl in unique(colnames(coexDF))) {
    for (type in c("min", "max")) {
      tmpDF <- as.data.frame(matrix(data = NA, nrow = n, ncol = ncol(retDF)))
      colnames(tmpDF) <- colnames(retDF)

      # Get the first n minimum/maximum scores for each cluster
      sortedPos <- order(coexDF[, cl], decreasing = (type == "max"))[1L:n]

      tmpDF[["CL"]]        <- cl
      tmpDF[["Gene"]]      <- rownames(coexDF)[sortedPos]
      tmpDF[["DEA"]]       <- coexDF[sortedPos, cl]
      tmpDF[["adjPVal"]]   <- adjPValueDF[sortedPos, cl]
      tmpDF[["IsMarker"]]  <- as.integer(tmpDF[["Gene"]] %in% marks)
      tmpDF[["logFoldCh"]] <- lfcDF[sortedPos, cl]

      retDF <- rbind(retDF, tmpDF)

      rm(tmpDF)
    }
  }

  endTime <- Sys.time()

  logThis(paste("Total calculations elapsed time:",
                difftime(endTime, startTime, units = "secs")),
          logLevel = 2L)

  logThis("findClustersMarkers - DONE", logLevel = 2L)

  return(retDF)
}

#' scatterPlot
#'
#' @details `scatterPlot()` creates a plot that check the relation between the
#'   library size and the number of genes detected.
#'
#' @param objCOTAN a `COTAN` object
#' @param condName The name of a condition in the `COTAN` object to further
#'   separate the cells in more sub-groups. When no condition is given it is
#'   assumed to be the same for all cells (no further sub-divisions)
#' @param conditions The *conditions* to use. If given it will take precedence
#'   on the one indicated by `condName` that will only indicate the relevant
#'   column name in the returned `data.frame`
#' @param splitSamples Boolean. Whether to plot each sample in a different panel
#'   (default `FALSE`)
#'
#' @returns `scatterPlot()` returns the scatter plot
#'
#' @importFrom ggplot2 ggplot
#' @importFrom ggplot2 geom_point
#' @importFrom ggplot2 labs
#' @importFrom ggplot2 scale_x_log10
#' @importFrom ggplot2 scale_y_log10
#' @importFrom ggplot2 facet_grid
#' @importFrom ggplot2 vars
#'
#' @importFrom scales trans_breaks
#' @importFrom scales math_format
#' @importFrom scales trans_format
#'
#' @export
#'
#' @examples
#' scPlot <- scatterPlot(objCOTAN)
#' plot(scPlot)
#'
#' @rdname RawDataCleaning
#'
scatterPlot <-
  function(objCOTAN, condName = "", conditions = NULL, splitSamples = TRUE) {
  cellsSize <- getCellsSize(objCOTAN)
  genesSize <- getNumExpressedGenes(objCOTAN)

  sizes <- cbind(cellsSize, genesSize)
  sizes <- as.data.frame(sizes)

  c(., conditions) %<-%
    normalizeNameAndLabels(objCOTAN, name = condName,
                           labels = conditions, isCond = TRUE)
  assert_that(!is_empty(conditions))

  sizes <- setColumnInDF(sizes, conditions[rownames(sizes)], colName = "sample")

  scPl <-
    ggplot(
      sizes,
      aes(x = cellsSize, y = genesSize, color = sample)
    ) +
    geom_point(size = 0.5, alpha = 0.8) +
    labs(
      title = "Scatter plot of library size VS gene detected for each cell",
      y = "Gene number",
      x = "Library size (UMI)"
    ) +
    # nolint start: implicit_integer_linter
    scale_x_log10(
      breaks = trans_breaks("log10", function(x) 10^x),
      labels = trans_format("log10", math_format(10^.x))
    ) +
    scale_y_log10(
      breaks = trans_breaks("log10", function(x) 10^x),
      labels = trans_format("log10", math_format(10^.x))
    ) +
    # nolint end
    plotTheme("size-plot")

  if (isTRUE(splitSamples)) {
    scPl <- scPl + facet_grid(cols = vars(sample))
  }

  return(scPl)
}

# --------------------- Uniform Clusters ----------------------

#' @title Uniform Clusters
#'
#' @description This group of functions takes in input a `COTAN` object and
#'   handle the task of dividing the dataset into **Uniform Clusters**, that is
#'   *clusters* that have an homogeneous genes' expression. This condition is
#'   checked by calculating the `GDI` of the *cluster* and verifying that no
#'   more than a small fraction of the genes have their `GDI` level above the
#'   given `GDIThreshold`
#'
#' @name UniformClusters
NULL


### ------ Seurat Clustering -------

#' @title Get a clusterization running the `Seurat` package
#'
#' @description The function uses the \pkg{Seurat} to clusterize the given
#'   counts raw data.
#'
#' @details The parameter resolution is set at 0.5 initially, but in case of too
#'   few clusters it can be raised up to 2.5.
#'
#' @param rawData The raw counts
#' @param initialResolution The resolution to use at first in the
#'   *clusterization* algorithm
#' @param resolutionStep How much to increase the resolution to retry a
#'   *clusterization* that does not respect the `minNumClusters`
#' @param minNumClusters The minimum number of *clusters* expected from this
#'   *clusterization*. In cases it is not reached, it will increase the
#'   resolution of the *clusterization*
#' @param useCoexEigen Boolean to determine whether to project the data `matrix`
#'   onto the first eigenvectors of the **COEX** `matrix` or instead restrict
#'   the data `matrix` to the selected genes before applying the `PCA` reduction
#' @param dataMethod selects the method to use to create the `data.frame` to
#'   pass to the [UMAPPlot()]. See [getDataMatrix()] for more details.
#' @param genesSel Decides whether and how to perform the gene-selection
#'   (defaults to `"HVG_Seurat"`). See [getSelectedGenes()] for more details.
#' @param numGenes the number of genes to select using the above method. Will be
#'   ignored when an explicit list of genes has been passed in
#' @param numReducedComp the number of calculated **RDM** components
#' @param cores number of cores to use. Default is 1.
#' @param chunkSize number of elements to solve in batch in a single core.
#'   Default is 1024.
#'
#' @returns a list with:
#'   * `"SeuratClusters"` a `Seurat` *clusterization*
#'   * `"CellsRDM"` the Reduced Data Matrix
#'   * `"Resolution"` the used resolution
#'   * `"UsedMaxResolution"` whether the maximum resolution has been reached
#'
#' @importFrom Seurat CreateSeuratObject
#' @importFrom Seurat CreateDimReducObject
#' @importFrom Seurat FindNeighbors
#' @importFrom Seurat FindClusters
#' @importFrom Seurat Idents
#'
#' @importFrom assertthat assert_that
#'
#' @noRd
#'

seuratClustering <- function(objCOTAN,
                             initialResolution,
                             resolutionStep,
                             minNumClusters,
                             useCoexEigen,
                             dataMethod,
                             genesSel,
                             numGenes,
                             numReducedComp,
                             cores = 1L,
                             chunkSize = 1024L) {
  tryCatch({
    startTime <- Sys.time()

    logThis("Creating new clusterization: START", logLevel = 2L)

    assert_that(numReducedComp <= getNumGenes(objCOTAN))

    numReducedCompToCalc <- numReducedComp + 15L
    cellsRDM <- calculateReducedDataMatrix(
      objCOTAN, useCoexEigen = useCoexEigen,
      dataMethod = dataMethod, numComp = numReducedCompToCalc,
      genesSel = genesSel, numGenes = numGenes)

    assert_that(nrow(cellsRDM) == getNumCells(objCOTAN),
                ncol(cellsRDM) <= numReducedCompToCalc,
                msg = "Returned PCA matrix has wrong dimensions")

    # Create the Seurat object
    srat <- CreateSeuratObject(counts = getRawData(objCOTAN),
                               project = "clusterization")

    # Add RDM manually
    srat[["pca"]] <-
      CreateDimReducObject(embeddings = cellsRDM,
                           key = "PC_",
                           assay = "RNA")

    srat <- FindNeighbors(srat, dims = seq_len(numReducedComp))

    resolution <- initialResolution
    maxResolution <- initialResolution + 30.0 * resolutionStep

    seuratClusters <- NULL
    usedMaxResolution <- FALSE
    repeat {
      seuratClusters <- Idents(FindClusters(
        srat,
        resolution = resolution,
        algorithm = 2L,      # Louvain (refined)
        random.seed = 137L   # controls igraph::cluster_louvain()
      ))

      # The next lines are necessary to make cluster smaller while
      # the number of residual cells decrease and to stop clustering
      # if the algorithm has gone for too long
      usedMaxResolution <- (resolution + 0.1 * resolutionStep) > maxResolution
      if (nlevels(seuratClusters) >= minNumClusters || usedMaxResolution) {
        break
      }

      logThis(paste("Number of clusters is too small.",
                    "Reclustering at resolution higher than:", resolution),
              logLevel = 3L)

      resolution <- resolution + resolutionStep
    }

    logThis(paste("Used resolution for Seurat clusterization is:", resolution),
            logLevel = 2L)

    endTime <- Sys.time()

    logThis(paste("Total calculations elapsed time:",
                  difftime(endTime, startTime, units = "secs")),
            logLevel = 2L)

    logThis("Creating new clusterization: DONE", logLevel = 2L)

    rm(srat)
    gc()

    # returned objects
    return(list("SeuratClusters" = seuratClusters, "CellsRDM" = cellsRDM,
                "Resolution" = resolution,
                "UsedMaxResolution" = usedMaxResolution))
  },
  error = function(e) {
    logThis(msg = paste("Clusterization failed with",
                        getNumCells(objCOTAN),
                        "cells with the following error:"), logLevel = 1L)
    logThis(msg = conditionMessage(e), logLevel = 1L)
    return(list("SeuratClusters" = NULL, "CellsRDM" = NULL,
                "Resolution" = NaN, "UsedMaxResolution" = FALSE))
  })
}

## -------- Cells Uniform Clustering --------

#' @details `cellsUniformClustering()` finds a **Uniform** *clusterizations* by
#'   means of the `GDI`. Once a preliminary *clusterization* is obtained from
#'   the `Seurat-package` methods, each *cluster* is checked for **uniformity**
#'   via the function [checkClusterUniformity()]. Once all *clusters* are
#'   checked, all cells from the **non-uniform** clusters are pooled together
#'   for another iteration of the entire process, until all *clusters* are
#'   deemed **uniform**. In the case only a few cells are left out (\eqn{\leq
#'   50}), those are flagged as `"-1"` and the process is stopped.
#'
#' @param objCOTAN a `COTAN` object
#' @param checker the object that defines the method and the threshold to
#'   discriminate whether a *cluster* is *uniform transcript*. See
#'   [UniformTranscriptCheckers] for more details
#' @param GDIThreshold legacy. The threshold level that is used in a
#'   [SimpleGDIUniformityCheck-class]. It defaults to \eqn{1.40}
#' @param initialResolution a number indicating how refined are the clusters
#'   before checking for **uniformity**. It defaults to \eqn{0.8}, the same as
#'   [Seurat::FindClusters()]
#' @param maxIterations max number of re-clustering iterations. It defaults to
#'   \eqn{25}
#' @param cores number of cores to use. Default is 1.
#' @param optimizeForSpeed Boolean; when `TRUE` `COTAN` tries to use the `torch`
#'   library to run the matrix calculations. Otherwise, or when the library is
#'   not available will run the slower legacy code
#' @param deviceStr On the `torch` library enforces which device to use to run
#'   the calculations. Possible values are `"cpu"` to us the system *CPU*,
#'   `"cuda"` to use the system *GPUs* or something like `"cuda:0"` to restrict
#'   to a specific device
#' @param useDEA Boolean indicating whether to use the *DEA* to define the
#'   distance; alternatively it will use the average *Zero-One* counts, that is
#'   faster but less precise
#' @param distance type of distance to use. Default is `"cosine"` for *DEA* and
#'   `"euclidean"` for *Zero-One*. Can be chosen among those supported by
#'   [parallelDist::parDist()]
#' @param useCoexEigen Boolean to determine whether to project the data `matrix`
#'   onto the first eigenvectors of the **COEX** `matrix` or instead restrict
#'   the data `matrix` to the selected genes before applying the `PCA` reduction
#' @param dataMethod selects the method to use to create the `data.frame` to
#'   pass to the [UMAPPlot()]. See [getDataMatrix()] for more details.
#' @param genesSel Decides whether and how to perform the gene-selection
#'   (defaults to `"HVG_Seurat"`). See [getSelectedGenes()] for more details.
#' @param numGenes the number of genes to select using the above method. Will be
#'   ignored when an explicit list of genes has been passed in
#' @param numReducedComp the number of calculated **RDM** components
#' @param hclustMethod It defaults is `"ward.D2"` but can be any of the methods
#'   defined by the [stats::hclust()] function.
#' @param minimumUTClusterSize the minimum number of cells for a cluster to be
#'   deemed potentially *uniform transcript*
#' @param initialClusters an existing *clusterization* to use as starting point:
#'   the *clusters* deemed **uniform** will be kept and the remaining cells will
#'   be processed as normal
#' @param initialIteration the number associated tot he first iteration; it
#'   defaults to 1. Useful in case of restart of the procedure to avoid
#'   intermediate data override
#' @param saveObj Boolean flag; when `TRUE` saves intermediate analyses and
#'   plots to file
#' @param outDir an existing directory for the analysis output. The effective
#'   output will be paced in a sub-folder.
#'
#' @returns `cellsUniformClustering()` returns a `list` with 2 elements:
#'   * `"clusters"` the newly found cluster labels array
#'   * `"coex"` the associated `COEX` `data.frame`
#'
#' @export
#'
#' @importFrom rlang set_names
#' @importFrom rlang is_null
#'
#' @importFrom stringr str_equal
#' @importFrom stringr str_detect
#' @importFrom stringr str_pad
#'
#' @importFrom utils as.roman
#'
#' @importFrom zeallot %<-%
#' @importFrom zeallot %->%
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom methods new
#' @importFrom methods validObject
#'
#' @importFrom grDevices pdf
#' @importFrom grDevices dev.off
#' @importFrom grDevices dev.cur
#'
#' @importFrom ggplot2 annotate
#'
#' @importFrom withr with_options
#'
#' @rdname UniformClusters
#'

cellsUniformClustering <- function(objCOTAN,
                                   checker = NULL,
                                   GDIThreshold = NaN,
                                   initialResolution = 0.8,
                                   maxIterations = 25L,
                                   cores = 1L,
                                   optimizeForSpeed = TRUE,
                                   deviceStr = "cuda",
                                   useDEA = TRUE,
                                   distance = NULL,
                                   useCoexEigen = FALSE,
                                   dataMethod = "",
                                   genesSel = "HVG_Seurat",
                                   numGenes = 2000L,
                                   numReducedComp = 25L,
                                   hclustMethod = "ward.D2",
                                   initialClusters = NULL,
                                   minimumUTClusterSize = 50L,
                                   initialIteration = 1L,
                                   saveObj = TRUE,
                                   outDir = ".") {
  startTime <- Sys.time()

  logThis("Creating cells' uniform clustering: START", logLevel = 2L)

  assert_that(estimatorsAreReady(objCOTAN),
              msg = paste("Estimators `lambda`, `nu`, `dispersion` are not",
                          "ready: Use proceedToCoex() to prepare them"))

  cond <- getMetadataElement(objCOTAN, datasetTags()[["cond"]])

  outDirCond <- file.path(outDir, cond)
  if (isTRUE(saveObj) && !dir.exists(outDirCond)) {
    dir.create(outDirCond)
  }

  splitOutDir <- file.path(outDirCond, "reclustering")
  if (isTRUE(saveObj) && !dir.exists(splitOutDir)) {
    dir.create(splitOutDir)
  }

  outputClusters <- set_names(rep(NA, length = getNumCells(objCOTAN)),
                              getCells(objCOTAN))

  if (!is.integer(initialIteration)) {
    initialIteration <- 1L
  }

  iter <- initialIteration - 1L
  iterReset <- -1L
  resolutionStep <- 0.5
  numClustersToRecluster <- 0L
  allCheckResults <- list()

  if (is.null(checker)) {
    GDIThreshold <- ifelse(is.finite(GDIThreshold), GDIThreshold, 1.40)
    checker <- new("SimpleGDIUniformityCheck",
                   check = new("GDICheck",
                               GDIThreshold = GDIThreshold,
                               maxRatioBeyond = 0.01))
  } else {
    assert_that(!is.finite(GDIThreshold),
                msg = paste("Either a `checker` object or",
                            "a legacy `GDIThreshold` must be given"))
  }

  if (isEmptyName(dataMethod)) {
    dataMethod <- "LogNormalized"
  }

  repeat {
    iter <- iter + 1L
    startLoopTime <- Sys.time()

    unassignedCells <- is.na(outputClusters)

    logThis(paste0("In iteration ", iter, " "), logLevel = 1L, appendLF = FALSE)
    logThis(paste("the number of cells to re-cluster is",
                  sum(unassignedCells), "cells belonging to",
                  numClustersToRecluster, "clusters"), logLevel = 2L)

    # create COTAN sub-object
    cellsToDrop <- getCells(objCOTAN)[!is.na(outputClusters)]
    subObj <- dropGenesCells(objCOTAN, cells = cellsToDrop)

    if ((str_equal(genesSel, "HGDI") || isTRUE(useCoexEigen)) &&
      !isCoexAvailable(subObj)) {
      subObj <-
        proceedToCoex(subObj, calcCoex = TRUE, cores = cores,
                      optimizeForSpeed = optimizeForSpeed,
                      deviceStr = deviceStr,
                      saveObj = FALSE, outDir = outDirCond)
    }

    #Step 1
    minNumClusters <- floor(1.2 * numClustersToRecluster) + 1L
    c(testClusters, cellsRDM, resolution, usedMaxResolution) %<-%
      seuratClustering(subObj,
                       initialResolution = initialResolution,
                       resolutionStep = resolutionStep,
                       minNumClusters = minNumClusters,
                       useCoexEigen = useCoexEigen,
                       dataMethod = dataMethod,
                       numReducedComp = numReducedComp,
                       genesSel = genesSel,
                       numGenes = numGenes,
                       cores = cores)

    if (is_null(testClusters)) {
      logThis(paste("NO new possible uniform clusters!",
                    "Unclustered cell left:", sum(unassignedCells)),
              logLevel = 1L)
      break
    }

    if (iter == initialIteration && !is_null(initialClusters)) {
      logThis("Using passed in clusterization", logLevel = 3L)
      testClusters <- asClusterization(initialClusters, getCells(objCOTAN))
    }

    ## print umap graph
    if (isTRUE(saveObj)) tryCatch({
      outFile <- file.path(splitOutDir, paste0("pdf_umap_", iter, ".pdf"))
      logThis(paste("Creating PDF UMAP in file: ", outFile), logLevel = 2L)
      pdf(outFile)

      allCondNames <- getAllConditions(subObj)
      condName <- ifelse(length(allCondNames) == 0L, "",
                         allCondNames[[length(allCondNames)]])
      colTitle <- paste0("Cells number: ", nrow(cellsRDM))
      plot(UMAPPlot(dataIn = cellsRDM, title = colTitle,
                    clusters = getCondition(subObj, condName)))

      colTitle <- paste0(colTitle, "\nCl. resolution: ", resolution,
                         ifelse(isTRUE(usedMaxResolution), " [max]", ""))
      plot(UMAPPlot(dataIn = cellsRDM, title = colTitle,
                    clusters = testClusters))
    }, error = function(err) {
      logThis(paste("While saving seurat UMAP plot", err), logLevel = 1L)
    }, finally = {
      # Check for active device
      if (dev.cur() > 1L) {
        dev.off()
      }
    })

    # Step 2

    # The next lines check for each new cell cluster if it is homogeneous.
    # In cases they are not, save the corresponding cells in cellsToRecluster

    numClustersToRecluster <- 0L
    cellsToRecluster <- vector(mode = "character")

    allCells <- names(testClusters)
    testClList <- toClustersList(testClusters)

    globalClName <- ""

    maxClusterSize <- max(lengths(testClList))

    if (maxClusterSize >= minimumUTClusterSize) {
      for (clName in names(testClList)) {
        logThis("*", logLevel = 1L, appendLF = FALSE)
        logThis(paste0(" checking uniformity of cluster '", clName,
                       "' of ", length(testClList), " clusters"),
                logLevel = 2L)

        globalClName <-
          paste0(str_pad(iter, width = 2L, pad = "0"), "_",
                 str_pad(clName, width = 4L, pad = "0"))

        cells <- testClList[[clName]]
        if (length(cells) < minimumUTClusterSize) {
          logThis(paste("cluster", globalClName, "has too few cells:",
                        "will be reclustered!"), logLevel = 2L)

          numClustersToRecluster <- numClustersToRecluster + 1L
          cellsToRecluster <- c(cellsToRecluster, cells)
        } else {
          checkResults <- tryCatch(
            checkClusterUniformity(objCOTAN = objCOTAN,
                                   clusterName = globalClName,
                                   cells = cells,
                                   checker = checker,
                                   cores = cores,
                                   optimizeForSpeed = optimizeForSpeed,
                                   deviceStr = deviceStr,
                                   saveObj = saveObj,
                                   outDir = splitOutDir),
            error = function(err) {
              logThis(paste("while checking cluster uniformity", err),
                      logLevel = 0L)
              logThis("marking cluster as not uniform", logLevel = 2L)
              return(checker)
            })

          invisible(validObject(checkResults))

          allCheckResults <- append(allCheckResults, checkResults)
          names(allCheckResults)[length(allCheckResults)] <- globalClName

          if (!checkResults@isUniform) {
            logThis(paste("cluster", globalClName, "has too high GDI:",
                          "will be reclustered!"), logLevel = 2L)

            numClustersToRecluster <- numClustersToRecluster + 1L
            cellsToRecluster <- c(cellsToRecluster, cells)
          } else {
            logThis(paste("cluster", globalClName, "is uniform"), logLevel = 2L)
          }
          logThis("", logLevel = 2L)

          rm(checkResults)
          gc()
        }
      }
    } else {
      # all clusters are too small: nothing to do
      logThis(paste("All clusters in iteration ", iter, "have too few cells"),
              logLevel = 2L)
      numClustersToRecluster <- length(testClList)
      cellsToRecluster <- allCells
    }

    logThis("", logLevel = 1L)
    logThis(paste("Found", length(testClList) - numClustersToRecluster,
                  "uniform and ", numClustersToRecluster,
                  "non-uniform clusters"), logLevel = 2L)

    if (numClustersToRecluster == length(testClList)) {
      warning("In iteration '", iter, "' no uniform clusters found!")
      # Another iteration can be attempted as the minimum number of clusters
      # will be higher. This happens unless the resolution already reached
      # its maximum. In the latter case we simply stop here, unless some UT
      # cluster was found. In the latter case we restart from the minimal
      # resolution, but with larger resolution steps and try to re-cluster with
      # no minimal number of clusters
      if (isTRUE(usedMaxResolution) || maxClusterSize < minimumUTClusterSize) {
        logThis("Max resolution reached", logLevel = 1L)
        if (iterReset != -1L) {
          logThis("Cannot clusterize anything more", logLevel = 2L)
          break
        } else {
          # try to recluster remaining cells from scratch
          logThis("Trying to recluster remaining cells from scratch",
                  logLevel = 2L)
          numClustersToRecluster <- 0L
          iterReset <- iter
          if (maxClusterSize >= minimumUTClusterSize) {
            resolutionStep <- resolutionStep + 0.3
          }
        }
      }
    } else {
      iterReset <- -1L
    }

    # Step 3: save the already uniform clusters keeping track of the iteration
    if (TRUE) {
      flagInUniformCl <- !allCells %in% cellsToRecluster
      outputClusters[allCells[flagInUniformCl]] <-
        paste0(str_pad(iter, width = 2L, pad = "0"), "_",
               str_pad(testClusters[flagInUniformCl], width = 4L, pad = "0"))
    }

    if (isTRUE(saveObj)) tryCatch({
        outFile <- file.path(splitOutDir,
                             paste0("partial_clusterization_", iter, ".csv"))
        write.csv(outputClusters, file = outFile)

        outFile <- file.path(splitOutDir,
                             paste0("all_check_results_", iter, ".csv"))
        write.csv(checkersToDF(allCheckResults), file = outFile, na = "NaN")
    },
      error = function(err) {
        logThis(paste("While saving current clusterization", err),
                logLevel = 0L)
      }
    )

    if (sum(is.na(outputClusters)) != length(cellsToRecluster)) {
      warning("Some problems in cells reclustering")
      break
    }

    if (length(cellsToRecluster) < 40L ||
        iter >= maxIterations + initialIteration - 1L) {
      logThis(ifelse(length(cellsToRecluster) < 40L,
                     "Stopping: too few cells left to cluster",
                     "Stopping: maximum number of iterations reached"),
              logLevel = 1L)
      logThis(paste("Unclustered cell left:", length(cellsToRecluster)),
              logLevel = 2L)
      break
    }

    rm(cellsToRecluster)
    gc()

    endLoopTime <- Sys.time()

    logThis(paste("Loop calculations elapsed time:",
                  difftime(endLoopTime, startLoopTime, units = "secs")),
            logLevel = 2L)
  } # End repeat

  logThis(paste("The final raw clusterization contains [",
                length(unique(outputClusters)), "] different clusters:",
                toString(unique(sort(outputClusters)))), logLevel = 3L)

  # replace the clusters' tags
  if (TRUE) {
    clTags <- unique(sort(outputClusters))

    clTagsMap <- paste0(seq_along(clTags))
    clTagsMap <- factorToVector(niceFactorLevels(clTagsMap))
    clTagsMap <- set_names(clTagsMap, clTags)

    unclusteredCells <- is.na(outputClusters)
    outputClusters[!unclusteredCells] <-
      clTagsMap[outputClusters[!unclusteredCells]]
    outputClusters[unclusteredCells] <- "-1"
    outputClusters <- set_names(outputClusters, getCells(objCOTAN))

    checksTokeep <- names(allCheckResults) %in% clTags
    allCheckResults <- allCheckResults[checksTokeep]
    names(allCheckResults) <- clTagsMap[names(allCheckResults)]
    if (any(unclusteredCells)) {
      checker@clusterSize <- sum(unclusteredCells)
      allCheckResults <- append(allCheckResults, checker)
      names(allCheckResults)[length(allCheckResults)] <- "-1"
    }
  }

  outputCoexDF <-
    tryCatch(DEAOnClusters(objCOTAN, clusters = outputClusters),
             error = function(err) {
               logThis(paste("Calling DEAOnClusters", err), logLevel = 0L)
               return(NULL)
             })

  c(outputClusters, outputCoexDF, permMap) %<-% tryCatch(
    reorderClusterization(objCOTAN, clusters = outputClusters,
                          coexDF = outputCoexDF, reverse = FALSE,
                          keepMinusOne = TRUE, useDEA = useDEA,
                          distance = distance, hclustMethod = hclustMethod),
    error = function(err) {
      logThis(paste("Calling reorderClusterization", err), logLevel = 0L)
      return(list(outputClusters, outputCoexDF))
    })
  names(allCheckResults) <- permMap[names(allCheckResults)]

  if (isTRUE(saveObj)) tryCatch({
      outFile <- file.path(outDirCond, "split_check_results.csv")
      write.csv(checkersToDF(allCheckResults), file = outFile, na = "NaN")

      outFile <- file.path(outDirCond, "split_clusterization.csv")
      write.csv(as.data.frame(list("split" = outputClusters)),
                file = outFile, na = "NaN")
    },
    error = function(err) {
      logThis(paste("While saving results csv", err), logLevel = 1L)
    }
  )

  endTime <- Sys.time()

  logThis(paste("Total calculations elapsed time:",
                difftime(endTime, startTime, units = "secs")),
          logLevel = 2L)

  logThis("Creating cells' uniform clustering: DONE", logLevel = 2L)

  return(list("clusters" = outputClusters, "coex" = outputCoexDF))
}

setGeneric(
  "proceedToCoex",
  function(objCOTAN, calcCoex = TRUE,
           optimizeForSpeed = TRUE, deviceStr = "cuda", cores = 1L,
           cellsCutoff = 0.003, genesCutoff = 0.002,
           cellsThreshold = 0.99, genesThreshold = 0.99,
           saveObj = FALSE, outDir = ".") {
    standardGeneric("proceedToCoex")
  }
)

# -------- calculate COEX --------

setGeneric(
  "calculateCoex",
  function(objCOTAN, actOnCells = FALSE, returnPPFract = FALSE,
           optimizeForSpeed = TRUE, deviceStr = "cuda") {
    standardGeneric("calculateCoex")
  }
)

# -------- getters --------

setGeneric(
  "getRawData",
  function(objCOTAN) standardGeneric("getRawData")
)

setGeneric(
  "getNumCells",
  function(objCOTAN) standardGeneric("getNumCells")
)

setGeneric(
  "getNumGenes",
  function(objCOTAN) standardGeneric("getNumGenes")
)

setGeneric(
  "getCells",
  function(objCOTAN) standardGeneric("getCells")
)

setGeneric(
  "getGenes",
  function(objCOTAN) standardGeneric("getGenes")
)

setGeneric(
  "getZeroOneProj",
  function(objCOTAN) standardGeneric("getZeroOneProj")
)

setGeneric(
  "getCellsSize",
  function(objCOTAN) standardGeneric("getCellsSize")
)

setGeneric(
  "getNumExpressedGenes",
  function(objCOTAN) standardGeneric("getNumExpressedGenes")
)

setGeneric(
  "getGenesSize",
  function(objCOTAN) standardGeneric("getGenesSize")
)

setGeneric(
  "getNumOfExpressingCells",
  function(objCOTAN) standardGeneric("getNumOfExpressingCells")
)

setGeneric(
  "getNu",
  function(objCOTAN) standardGeneric("getNu")
)

setGeneric(
  "getLambda",
  function(objCOTAN) standardGeneric("getLambda")
)

setGeneric(
  "getDispersion",
  function(objCOTAN) standardGeneric("getDispersion")
)

setGeneric(
  "getGDI",
  function(objCOTAN) standardGeneric("getGDI")
)

setGeneric(
  "getMetadataDataset",
  function(objCOTAN) standardGeneric("getMetadataDataset")
)

setGeneric(
  "getMetadataElement",
  function(objCOTAN, tag) standardGeneric("getMetadataElement")
)

setGeneric(
  "getMetadataGenes",
  function(objCOTAN) standardGeneric("getMetadataGenes")
)

setGeneric(
  "getMetadataCells",
  function(objCOTAN) standardGeneric("getMetadataCells")
)

setGeneric(
  "getClustersCoex",
  function(objCOTAN) standardGeneric("getClustersCoex")
)

setGeneric(
  "flagNotFullyExpressedGenes",
  function(objCOTAN) standardGeneric("flagNotFullyExpressedGenes")
)

setGeneric(
  "flagNotFullyExpressingCells",
  function(objCOTAN) standardGeneric("flagNotFullyExpressingCells")
)

setGeneric(
  "getFullyExpressedGenes",
  function(objCOTAN) standardGeneric("getFullyExpressedGenes")
)

setGeneric(
  "getFullyExpressingCells",
  function(objCOTAN) standardGeneric("getFullyExpressingCells")
)

setGeneric(
  "getGenesCoex",
  function(objCOTAN, genes = vector(mode = "character"),
           zeroDiagonal = TRUE, ignoreSync = FALSE) {
    standardGeneric("getGenesCoex")
  }
)

setGeneric(
  "getCellsCoex",
  function(objCOTAN, cells = vector(mode = "character"),
           zeroDiagonal = TRUE, ignoreSync = FALSE) {
    standardGeneric("getCellsCoex")
  }
)

setGeneric(
  "isCoexAvailable",
  function(objCOTAN, actOnCells = FALSE, ignoreSync = FALSE) {
    standardGeneric("isCoexAvailable")
  }
)

## ------- `COTAN` clusterization and conditions ------

setGeneric(
  "getClusterizations",
  function(objCOTAN, dropNoCoex = FALSE, keepPrefix = FALSE) {
    standardGeneric("getClusterizations")
  }
)

setGeneric(
  "getClusterizationName",
  function(objCOTAN, clName = "", keepPrefix = FALSE) {
    standardGeneric("getClusterizationName")
  }
)

setGeneric(
  "getClusterizationData",
  function(objCOTAN, clName = "") standardGeneric("getClusterizationData")
)

setGeneric(
  "getAllConditions",
  function(objCOTAN, keepPrefix = FALSE) standardGeneric("getAllConditions")
)

setGeneric(
  "getConditionName",
  function(objCOTAN, condName = "", keepPrefix = FALSE) {
    standardGeneric("getConditionName")
  }
)

setGeneric(
  "getCondition",
  function(objCOTAN, condName = "") standardGeneric("getCondition")
)

setGeneric(
  "getDims",
  function(objCOTAN) standardGeneric("getDims")
)

# -------- modifiers --------

setGeneric(
  "initializeMetaDataset",
  function(objCOTAN, GEO, sequencingMethod, sampleCondition) {
    standardGeneric("initializeMetaDataset")
  }
)

setGeneric(
  "addElementToMetaDataset",
  function(objCOTAN, tag, value) standardGeneric("addElementToMetaDataset")
)

setGeneric(
  "findFullyExpressedGenes",
  function(objCOTAN, cellsThreshold = 0.99) {
    standardGeneric("findFullyExpressedGenes")
  }
)

setGeneric(
  "findFullyExpressingCells",
  function(objCOTAN, genesThreshold = 0.99) {
    standardGeneric("findFullyExpressingCells")
  }
)

setGeneric(
  "setLambda",
  function(objCOTAN, lambda) standardGeneric("setLambda")
)

setGeneric(
  "setDispersion",
  function(objCOTAN, dispersion) standardGeneric("setDispersion")
)

setGeneric(
  "setNu",
  function(objCOTAN, nu) standardGeneric("setNu")
)

setGeneric(
  "dropGenesCells",
  function(objCOTAN, genes = vector(mode = "character"),
           cells = vector(mode = "character")) {
    standardGeneric("dropGenesCells")
  }
)

setGeneric(
  "clean",
  function(objCOTAN, cellsCutoff = 0.003, genesCutoff = 0.002,
           cellsThreshold = 0.99, genesThreshold = 0.99) {
    standardGeneric("clean")
  }
)

setGeneric(
  "addClusterization",
  function(objCOTAN, clName, clusters,
           coexDF = data.frame(), override = FALSE) {
    standardGeneric("addClusterization")
  }
)

setGeneric(
  "addClusterizationCoex",
  function(objCOTAN, clName, coexDF) standardGeneric("addClusterizationCoex")
)

setGeneric(
  "dropClusterization",
  function(objCOTAN, clName) standardGeneric("dropClusterization")
)

setGeneric(
  "addCondition",
  function(objCOTAN, condName, conditions, override = FALSE) {
    standardGeneric("addCondition")
  }
)

setGeneric(
  "dropCondition",
  function(objCOTAN, condName) standardGeneric("dropCondition")
)

setGeneric(
  "dropGenesCoex",
  function(objCOTAN) standardGeneric("dropGenesCoex")
)

setGeneric(
  "dropCellsCoex",
  function(objCOTAN) standardGeneric("dropCellsCoex")
)

# -------- estimators --------

setGeneric(
  "estimateLambdaLinear",
  function(objCOTAN) standardGeneric("estimateLambdaLinear")
)

setGeneric(
  "estimateNuLinear",
  function(objCOTAN) standardGeneric("estimateNuLinear")
)

setGeneric(
  "estimateNuLinearByCluster",
  function(objCOTAN, clName = "", clusters = NULL) {
    standardGeneric("estimateNuLinearByCluster")
  }
)

setGeneric(
  "estimateDispersionViaSolver",
  function(objCOTAN, threshold = 0.001, cores = 1L,
           maxIterations = 50L, chunkSize = 1024L) {
    standardGeneric("estimateDispersionViaSolver")
  }
)

setGeneric(
  "estimateNuBisection",
  function(objCOTAN, threshold = 0.001, cores = 1L,
           maxIterations = 50L, chunkSize = 1024L) {
    standardGeneric("estimateNuBisection")
  }
)

setGeneric(
  "estimateDispersionNuBisection",
  function(objCOTAN, threshold = 0.001, cores = 1L,
           maxIterations = 50L, chunkSize = 1024L,
           enforceNuAverageToOne = TRUE) {
    standardGeneric("estimateDispersionNuBisection")
  }
)

setGeneric(
  "estimateDispersionNuNlminb",
  function(objCOTAN, threshold = 0.001,
           maxIterations = 50L, chunkSize = 1024L,
           enforceNuAverageToOne = TRUE) {
    standardGeneric("estimateDispersionNuNlminb")
  }
)

setGeneric(
  "storeGDI",
  function(objCOTAN, genesGDI) standardGeneric("storeGDI")
)

# -------- Uniform Transcript Checks --------

setGeneric(
  "checkObjIsUniform",
  function(currentC, previousC = NULL, objCOTAN = NULL) {
    standardGeneric("checkObjIsUniform")
  }
)

setGeneric(
  "getCheckerThreshold",
  function(checker) standardGeneric("getCheckerThreshold")
)

setGeneric(
  "calculateThresholdShiftToUniformity",
  function(checker) standardGeneric("calculateThresholdShiftToUniformity")
)

setGeneric(
  "shiftCheckerThresholds",
  function(checker, shift) standardGeneric("shiftCheckerThresholds")
)

#' @details `clustersMarkersHeatmapPlot()` returns the heatmap plot of a summary
#'   score for each *cluster* and each gene marker in the given
#'   *clusterization*. It also returns the size and percentage of each
#'   *cluster* on the right and a *clusterization* `dendogram` on the left, as
#'   returned by the function [clustersTreePlot()]. The heatmap cells' colors
#'   express the **DEA**, that is whether a gene is enriched or depleted in the
#'   cluster, while the stars are aligned to the corresponding adjusted
#'   \eqn{p-}value: `***` for \eqn{p < 0.1\%}, `**` for \eqn{p < 1\%}, `*` for
#'   \eqn{p < 5\%}, `.` for \eqn{p < 10\%}
#'
#' @param objCOTAN a `COTAN` object
#' @param groupMarkers an optional named `list` with an element for each group
#'   comprised of one or more marker genes
#' @param clName The name of the *clusterization*. If not given the last
#'   available *clusterization* will be used, as it is probably the most
#'   significant!
#' @param clusters A *clusterization* to use. If given it will take precedence
#'   on the one indicated by `clName` that, in such a case, will only indicate
#'   the relevant column name in the returned `data.frame`
#' @param coexDF a `data.frame` where each column indicates the `COEX` for each
#'   of the *clusters* of the *clusterization*
#' @param kCuts the number of estimated *cluster* (this defines the height for
#'   the tree cut and the associated colors)
#' @param adjustmentMethod *p-value* multi-test adjustment method. Defaults to
#'   `"bonferroni"`; use `"none"` for no adjustment
#' @param condNameList a `list` of *conditions*' names to be used for additional
#'   columns in the final plot. When none are given no new columns will be added
#'   using data extracted via the function [clustersSummaryData()]
#' @param conditionsList a `list` of *conditions* to use. If given they will
#'   take precedence on the ones indicated by `condNameList`
#'
#' @returns `clustersMarkersHeatmapPlot()` returns a list with:
#'  * `"heatmapPlot"` the complete heatmap plot
#'  * `"dataScore"` the `data.frame` with the score values
#'  * `"pValueDF"`  the `data.frame` with the corresponding adjusted
#'   \eqn{p-}values
#'
#' @importFrom rlang is_empty
#' @importFrom rlang set_names
#'
#' @importFrom utils head
#' @importFrom utils tail
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom stats symnum
#'
#' @importFrom dendextend set
#'
#' @importFrom tidyr pivot_wider
#'
#' @importFrom grid unit
#' @importFrom grid gpar
#' @importFrom grid grid.text
#'
#' @importFrom ComplexHeatmap rowAnnotation
#' @importFrom ComplexHeatmap HeatmapAnnotation
#' @importFrom ComplexHeatmap anno_barplot
#' @importFrom ComplexHeatmap anno_numeric
#' @importFrom ComplexHeatmap anno_text
#' @importFrom ComplexHeatmap Legend
#' @importFrom ComplexHeatmap Heatmap
#'
#' @importFrom circlize colorRamp2
#'
#' @importFrom zeallot %<-%
#' @importFrom zeallot %->%
#'
#' @export
#'
#' @rdname HandlingClusterizations
#'
clustersMarkersHeatmapPlot <- function(objCOTAN, groupMarkers = list(),
                                       clName = "", clusters = NULL,
                                       coexDF = NULL, kCuts = 3L,
                                       adjustmentMethod = "bonferroni",
                                       condNameList = NULL,
                                       conditionsList = NULL) {
  assert_that(is_empty(conditionsList) ||
                length(conditionsList) == length(condNameList),
              msg = "Explicitly given conditions must have corresponding names")

  # picks up the last clusterization if none was given
  c(clName, clusters) %<-%
    normalizeNameAndLabels(objCOTAN, name = clName,
                           labels = clusters, isCond = FALSE)

  # these are empty datasets but with the right columns!
  genesGroupMap <- NULL
  scoreDF <- as.data.frame(matrix(nrow = 0L, ncol = nlevels(clusters),
                                  dimnames = list(NULL, levels(clusters))))
  pValueDF <- scoreDF

  if (!is_empty(groupMarkers)) {
    genesGroupMap <-
      unlist(lapply(
        names(groupMarkers),
        \(group) {
          genes <- groupMarkers[[group]]
          set_names(rep_len(group, length(genes)), genes)
        }
      ))

    genesGroupMap <- factor(genesGroupMap, levels = names(groupMarkers))

    if (is_empty(coexDF)) {
      if (clName %in% getClusterizations(objCOTAN)) {
        coexDF <- getClusterizationData(objCOTAN, clName = clName)[["coex"]]
      }
      if (is_empty(coexDF)) {
        coexDF <- DEAOnClusters(objCOTAN, clusters = clusters)
      }
    }

    scoreDF <- coexDF[names(genesGroupMap), , drop = FALSE]

    pValueDF <- pValueFromDEA(coexDF = coexDF, numCells = getNumCells(objCOTAN),
                              adjustmentMethod = adjustmentMethod)
    pValueDF <- pValueDF[names(genesGroupMap), , drop = FALSE]

    # row-names must be unique
    uniqueGeneNames <- make.unique(names = names(genesGroupMap), sep = "_")
    rownames(scoreDF)  <- uniqueGeneNames
    rownames(pValueDF) <- uniqueGeneNames
  }

  dend <- clustersTreePlot(objCOTAN, kCuts = kCuts, clName = clName)[["dend"]]
  dend <- set(dend, "branches_lwd", 2L)

  hbList <- NULL
  lgdList <- list()
  if (!is_empty(condNameList)) {
    allColors <- getColorsVector()

    for (i in seq_along(condNameList)) {
      # gets a dummy condition if none was given
      c(condName, conditions) %<-%
        normalizeNameAndLabels(objCOTAN, name = condNameList[[i]],
                               labels = conditionsList[[i]], isCond = TRUE)
      condDF <- clustersSummaryData(objCOTAN, clName = clName,
                                    clusters = clusters,
                                    condName = condName,
                                    conditions = conditions)

      cNames <- c(clName, condName, "CellNumber")

      condDF <- pivot_wider(condDF[, cNames],
                            names_from = condName,
                            values_from = cNames[[3L]])

      # Here we have a column per condition alternative plus 1
      nCols <- ncol(condDF)
      assert_that(nCols > 1L, msg = "Internal error: provided empty conditions")
      condDF[, 2L:nCols] <- condDF[, 2L:nCols] / rowSums(condDF[, 2L:nCols])

      condDF <- as.data.frame(condDF)
      rownames(condDF) <- condDF[[1L]]
      condDF <- condDF[levels(clusters), ]
      condDF[is.na(condDF)] <- 0L

      conds <- colnames(condDF)[2L:nCols]

      colrs <- set_names(head(allColors, nCols - 1L), conds)
      allColors <- tail(allColors, length(allColors) - nCols + 1L)

      hb <- HeatmapAnnotation(
        which = "row",
        condName = anno_barplot(condDF[, 2L:nCols],
                                width = unit(3.0, "cm"),
                                gp = gpar(fill = colrs, col = "black"),
                                align_to = "right",
                                labels_gp = gpar(fontsize = 12L)),
        annotation_label = condName,
        annotation_name_rot = 0L)
      hbList <- append(hbList, hb)

      lgd <- Legend(labels = conds, title = condName,
                    legend_gp = gpar(fill = colrs))
      lgdList <- append(lgdList, lgd)
    }
  }

  clustDF <- clustersSummaryData(objCOTAN, clName = clName, clusters = clusters)
  rownames(clustDF) <- clustDF[[1L]]
  clustDF <- clustDF[colnames(scoreDF), ]

  freq1 <- set_names(clustDF[["CellNumber"]], rownames(clustDF))

  freq2 <- set_names(paste0(clustDF[["CellPercentage"]], "%"),
                     rownames(clustDF))

  haList <- c(
    ha1 = rowAnnotation(
      cellNumber = anno_numeric(freq1,
                                rg = c(0L, max(freq1)),
                                bg_gp = gpar(fill = "orange", col = "black"),
                                labels_gp = gpar(fontsize = 10.0)),
      annotation_label = "CellNumber",
      annotation_name_rot = 0.0),

    ha2 = rowAnnotation(
      cellPerc = anno_text(freq2,
                           gp = gpar(fontsize = 10.0)),
      annotation_label = "CellPerc",
      annotation_name_rot = 0.0)
  )

  # Define the color function for the heatmap
  colExtr <- suppressWarnings(max(-min(scoreDF, na.rm = TRUE),
                                   max(scoreDF, na.rm = TRUE)))
  colorFunc <- colorRamp2(c(-colExtr, 0.0, colExtr),
                          c("#E64B35FF", "gray93", "#3C5488FF"))

  # nolint start: spaces_inside_linter
  cutPoints <- c(0.0,        0.001,       0.01,      0.05,      0.1,     1.0)
  marks     <- c(     "***",        "**",       "*",       ".",      " "    )
  # nolint end

  # Define the function to annotate each cell with its significance
  cellFunc <- function(j, i, x, y, width, height, fill) {
    pValue <- pValueDF[j, i]

    # Use symnum() to get the significance mark
    mark <- symnum(pValue, corr = FALSE, na = FALSE,
                   cutpoints = cutPoints, symbols = marks)

    # Display the mark in the cell
    grid.text(mark, x, y, gp = gpar(fontsize = 12L, fontface = "bold"))
  }

  heatMapPl <- Heatmap(
    t(scoreDF),
    name = "Score",
    rect_gp = gpar(col = "white", lwd = 1L),
    cluster_rows = dend,
    row_dend_width = unit(2.0, "cm"),
    cluster_columns = FALSE,  # Columns are not clustered but grouped
    col = colorFunc,
    column_split = genesGroupMap,        # Group columns by gene groups
    column_gap = unit(1.0, "mm"),        # Gap between gene groups
    column_names_gp = gpar(fontsize = 10L, angle = 45.0, hjust = 1.0),
    row_names_gp = gpar(fontsize = 10L),
    cell_fun = cellFunc,
    top_annotation = NULL,
    right_annotation = haList,
    left_annotation = hbList,
    heatmap_legend_param = list(title = "Score")
  )

  # If there are additional legends, add them
  if (!is.null(lgdList)) {
    heatMapPl <- heatMapPl + lgdList
  }

  return(list("heatmapPlot" = heatMapPl,
              "dataScore" = scoreDF,
              "pValues" = pValueDF))
}

# ---- Conversion to/from other classes ----

#' @title Data class conversions
#'
#' @description All functions to convert a [COTAN-class] object to/from other
#'   data classes used by the `BioConductor` analysis packages
#'
#' @name Conversions
#'
#' @examples
#'   data("test.dataset")
#'   obj <- COTAN(raw = test.dataset)
#'   obj <- proceedToCoex(obj, calcCoex = FALSE, saveObj = FALSE)
#'
#'   sce <- convertToSingleCellExperiment(objCOTAN = obj)
#'
#'   newObj <- convertFromSingleCellExperiment(sce)
#'
#'   stopifnot(identical(getDims(newObj)[-5:-6], getDims(obj)[-5:-6]),
#'             identical(unlist(getDims(newObj)[5:6]),
#'                       unlist(getDims(obj)[5:6]) + 1L))
#'
NULL

## ---- Convert to SingleCellExperiment ----

#' @details `convertToSingleCellExperiment()` converts a [COTAN-class] object
#'   into a [SingleCellExperiment::SingleCellExperiment-class] object. Stores
#'   the raw counts in the `"counts"` [SummarizedExperiment::Assays-class], the
#'   metadata for genes and cells as `rowData` and `colData` slots respectively
#'   and finally the genes' and cells' `COEX` along the dataset metadata into
#'   the `metadata` slot.
#'
#'   The function performs the following steps:
#'   * Extracts the raw counts matrix, gene metadata, cell metadata, gene
#'     and cell *co-expression* matrix from the `COTAN`
#'     object; the `clustersCoex` slot is not converted
#'   * Identifies *clusterizations* and *conditions* in the cell metadata by the
#'     prefixes `"CL_"` and `"COND_"`
#'   * Renames *clusterization* columns with the prefix `"COTAN_clusters_"` and
#'     *condition* columns with the prefix `"COTAN_conditions_"`
#'   * Constructs a `SingleCellExperiment` object with the counts matrix, gene
#'     metadata, updated cell metadata, and stores the *co-expression* matrices
#'     in the `metadata` slot.
#'
#'   The resulting `SingleCellExperiment` object is compatible with downstream
#'   analysis packages and workflows within the Bioconductor ecosystem
#'
#' @param objCOTAN a `COTAN` object
#'
#' @returns A [SingleCellExperiment::SingleCellExperiment-class] object
#'   containing the data from the input [COTAN-class] object, with
#'   *clusterizations* and *conditions* appropriately prefixed and stored in the
#'   cell metadata.
#'
#' @importFrom methods is
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom tibble rownames_to_column
#'
#' @importFrom SingleCellExperiment SingleCellExperiment
#'
#' @export
#'
#' @seealso [COTAN-class], [SingleCellExperiment::SingleCellExperiment]
#'
#' @rdname Conversions
#'

convertToSingleCellExperiment <- function(objCOTAN) {
  assert_that(is(objCOTAN, "COTAN"), validObject(objCOTAN),
              msg = "Input object should be of type `COTAN`.")

  # Handle genes names
  genesMeta <- getMetadataGenes(objCOTAN)

  if (is_empty(genesMeta)) {
    genesMeta <- data.frame("GenesNames" = getGenes(objCOTAN))
  }

  hasGenesNameCol <-
    !is_empty(grep(x = colnames(genesMeta), pattern = "Genes?[ -_]?Names?",
                   ignore.case = TRUE))
  if (!hasGenesNameCol) {
    genesMeta <- rownames_to_column(genesMeta, var = "GenesNames")
  }

  rownames(genesMeta) <- getGenes(objCOTAN)

  # Handle cells IDs

  cellsMeta <- getMetadataCells(objCOTAN)

  if (is_empty(cellsMeta)) {
    cellsMeta <- data.frame("CellsIDs" = getCells(objCOTAN))
  }

  hasCellsIDCol <-
    !is_empty(grep(colnames(cellsMeta), pattern = "Cells?[ -_]?IDs?",
                   ignore.case = TRUE))
  if (!hasCellsIDCol) {
    cellsMeta <- rownames_to_column(cellsMeta, var = "CellsIDs")
  }

  rownames(cellsMeta) <- getCells(objCOTAN)

  # Identify clustering and condition columns

  # Rename clustering columns replacing the 'CL_' prefix with 'COTAN_clusters_'
  colnames(cellsMeta) <-
    sub(x = colnames(cellsMeta), pattern = "^CL_",
        replacement = "COTAN_clusters_")

  # Rename conditions columns replacing the 'COND_' prefix with
  # 'COTAN_conditions_'
  colnames(cellsMeta) <-
    sub(x = colnames(cellsMeta), pattern = "^COND_",
        replacement = "COTAN_conditions_")

  # retrieves the genes' COEX if available
  genesCoex <- emptySymmetricMatrix()
  if (isCoexAvailable(objCOTAN, actOnCells = FALSE, ignoreSync = TRUE)) {
    genesCoex <- getGenesCoex(objCOTAN, zeroDiagonal = FALSE, ignoreSync = TRUE)
  }

  # retrieves the cells' COEX if available
  cellsCoex <- emptySymmetricMatrix()
  if (isCoexAvailable(objCOTAN, actOnCells = TRUE, ignoreSync = TRUE)) {
    cellsCoex <- getCellsCoex(objCOTAN, zeroDiagonal = FALSE, ignoreSync = TRUE)
  }

  # Create the SingleCellExperiment object
  objSCE <- SingleCellExperiment(
    assays = list(counts = getRawData(objCOTAN)),
    rowData = S4Vectors::DataFrame(genesMeta),
    colData = S4Vectors::DataFrame(cellsMeta),
    metadata = list(
      genesCoex = genesCoex,
      cellsCoex = cellsCoex,
      datasetMetadata = getMetadataDataset(objCOTAN)
    )
  )

  assert_that(identical(dim(objSCE),
                        c(getNumGenes(objCOTAN), getNumCells(objCOTAN))))

  return(objSCE)
}

## ---- Convert from SingleCellExperiment ----

#' @details `convertFromSingleCellExperiment()` converts a
#'   [SingleCellExperiment::SingleCellExperiment-class] object back into a
#'   [COTAN-class] object. It supports `SCE` objects that were originally
#'   created from either a `COTAN` object or a `Seurat` object. The function
#'   extracts the `"counts"` matrix, genes' metadata, cells' metadata,
#'   *co-expression* matrices (if available), and reconstructs the `COTAN`
#'   object accordingly.

#' The function performs the following steps:
#'   * Extracts the raw matrix from the `"counts"`
#' [SummarizedExperiment::Assays-class]
#'   * Extracts gene metadata from `rowData`
#'   * Extracts cell metadata from `colData`, excluding any *clusterizations* or
#'     *conditions* present
#'   * Attempts to retrieve *co-expression* matrices from the `metadata` slot if
#' they exist
#'   * Constructs a `COTAN` object using the extracted data
#'   * Adds back the *clusterizations* and *conditions* using `COTAN` methods
#' If the COEX is not present (e.g., in `SCE` objects created from `Seurat`),
#' the `genesCoex` and `cellsCoex` slots in the resulting `COTAN` object will be
#' empty matrices
#'
#' @param objSCE A [SingleCellExperiment::SingleCellExperiment-class] object to
#'   be converted
#' @param assayName Name of the assay in `objSCE` to be used as raw counts.
#'   Default is `"counts"`. If not found, the function falls back to `"X"` and
#'   then to the first available assay, emitting a warning in both cases.
#' @param clNamesPattern A regular expression pattern used to identify the
#'   clustering columns in `colData`. Default supports `Seurat` conventions:
#'   `"^(COTAN_clusters_|seurat_clusters$|.*_snn_res\\..*|wsnn_res\\..*)"`
#' @param condNamesPattern A regular expression pattern used to identify the
#'   condition columns in `colData`. Default supports `Seurat` conventions:
#'   `"^(COTAN_conditions_|condition$|orig.ident$)"`
#' @param genesNamesPattern A regular expression pattern (case insensitive) used
#'   to identify the genes' names column in `rowData`. It used only if no names
#'   are available from the data matrix or the genes' data-set. Default supports
#'   is: `"^((Gene|Feature)s?[ -_]?(Name|ID)s?|IDs?|Symbols?)$"`
#' @param cellsIDsPattern A regular expression pattern (case insensitive) used
#'   to identify the cells' names column in `colData`. It used only if no names
#'   are available from the data matrix or the cells' data-set. Default supports
#'   is: `"^(Cells?[ -_]?IDs?|Barcodes?|Cells?)$"`
#'
#' @returns A [COTAN-class] object containing the data extracted from the input
#'   [SingleCellExperiment::SingleCellExperiment-class] object
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom methods new
#' @importFrom methods is
#' @importFrom methods validObject
#'
#' @importFrom rlang is_empty
#'
#' @importClassesFrom Matrix dgCMatrix
#' @importClassesFrom Matrix dspMatrix
#'
#' @importFrom SingleCellExperiment counts
#' @importFrom SingleCellExperiment rowData
#' @importFrom SingleCellExperiment colData
#'
#' @importFrom SummarizedExperiment assay
#' @importFrom SummarizedExperiment assayNames
#' @importFrom SingleCellExperiment altExp
#' @importFrom SingleCellExperiment altExpNames
#' @importFrom SummarizedExperiment rowRanges
#' @importFrom SingleCellExperiment reducedDimNames
#'
#' @export
#'
#' @seealso [COTAN-class], [SingleCellExperiment::SingleCellExperiment]
#'
#' @rdname Conversions
#'
convertFromSingleCellExperiment <- function(
    objSCE,
    assayName = "counts",
    clNamesPattern = "",
    condNamesPattern = "",
    genesNamesPattern = "",
    cellsIDsPattern = ""
  ) {
  assert_that(is(objSCE, "SingleCellExperiment"),
              msg = "Input object should be of type `SingleCellExperiment`.")

  # ---- Choose assay and extract raw matrix ----
  chooseAssay <- function(sceObj, assayName) {
    avail <- SummarizedExperiment::assayNames(sceObj)
    if (length(avail) < 1L) {
      stop("No assays present in the SingleCellExperiment object.")
    }
    if (!isEmptyName(assayName) && assayName %in% avail) {
      return(assayName)
    }
    # common fallbacks (e.g. zellkonverter uses 'X')
    fallback <- intersect(c("counts", "X"), avail)
    if (length(fallback) > 0L) {
        warning(sprintf("Assay '%s' not found; using '%s'.",
                        assayName, fallback[[1L]]))
        return(fallback[[1L]])
    }
    warning(sprintf("Assay '%s' not found; using first assay '%s'.",
                    assayName, avail[[1L]]))
    return(avail[[1L]])
  }

  rawSourceSCE <- objSCE
  chosenAssay <- chooseAssay(rawSourceSCE, assayName)

  # If requested, try altExp 'raw' when the desired assay is absent at top-level
  if (TRUE) {
    topAvail <- assayNames(objSCE)
    if (!(chosenAssay %in% topAvail)) {
      altNames <- tryCatch(altExpNames(objSCE),
                           error = function(e) character())
      if ("raw" %in% altNames) {
        rawSourceSCE <- altExp(objSCE, "raw")
        chosenAssay <- chooseAssay(rawSourceSCE, assayName)
      }
    }
  }

  rawMatrix <- assay(rawSourceSCE, chosenAssay)
  rawMatrix <- coerceToDgCMatrix(rawMatrix)

  validateRawCounts(rawMatrix)

  if (TRUE) {
    if (!identical(rawSourceSCE, objSCE)) {
      topAssays <- assayNames(objSCE)
      if (length(topAssays) > 0L) {
        warning("Dropping top-level assays: ", toString(topAssays))
      }
    }

    # assays
    keptAssay <- chosenAssay
    droppedAssays <- setdiff(assayNames(rawSourceSCE), keptAssay)
    if (length(droppedAssays) > 0L) {
      warning("Dropping assays: ", toString(droppedAssays))
    }

    # reducedDims (if available)
    redNames <- tryCatch(reducedDimNames(objSCE),
                         error = function(e) character())
    if (length(redNames) > 0L) {
      warning("Dropping reducedDims: ", toString(redNames))
    }

    # altExps
    altNames <- tryCatch(altExpNames(objSCE),
                         error = function(e) character())
    # don't warn about 'raw' if you actually used it
    if (identical(rawSourceSCE, objSCE)) {
      usedAlt <- character()
    } else {
      usedAlt <- "raw"
    }
    droppedAlt <- setdiff(altNames, usedAlt)
    if (length(droppedAlt) > 0L) {
      warning("Dropping altExps: ", toString(droppedAlt))
    }
  }


  # Extract gene metadata
  genesMetaSCE <- rowData(rawSourceSCE)

  ftCol <- intersect(c("feature_type", "FeatureType", "Type", "type"),
                     colnames(genesMetaSCE))
  if (length(ftCol) > 0L) {
    ft <- as.character(genesMetaSCE[[ftCol[[1L]]]])
    ft <- ft[!is.na(ft)]
    if (length(unique(ft)) > 1L) {
      stop(
        "Multiple feature types detected in rowData ('", ftCol[[1L]],
        "'). Subset the SingleCellExperiment to RNA features before conversion."
      )
    }
  }

  # Sanity check: same order and length
  assert_that(is.null(rownames(genesMetaSCE)) || is.null(rownames(rawMatrix)) ||
                identical(rownames(rawMatrix), rownames(genesMetaSCE)),
              msg = "Row names of counts and gene metadata differ.")

  if (!is_empty(rownames(rawMatrix))) {
    genesNames <- rownames(rawMatrix)
  } else {
    genesNames <- rownames(genesMetaSCE)
  }

  # retrieve gene names from appropriate meta column
  if (is_empty(genesNames)) {
    genesNamesPattern <-
      ifelse(
        isEmptyName(genesNamesPattern),
        # broadened default for common SCE conventions
        # (10X / scater / zellkonverter)
        "^((Gene|Feature)s?[ -_]?(Name|ID)s?|IDs?|Symbols?)$",
        genesNamesPattern)

    colToUse <- grep(x = colnames(genesMetaSCE),
                     pattern = genesNamesPattern,
                     ignore.case = TRUE)

    if (!is_empty(colToUse)) {
      # use first match
      genesNames <- genesMetaSCE[, colToUse[[1L]], drop = TRUE]
    }
  }
  if (is_empty(genesNames)) {
    warning("Could not retrieve genes' names from the input")
  } else {
    genesNames <- make.unique(as.character(genesNames))
    rownames(rawMatrix)    <- genesNames
    rownames(genesMetaSCE) <- genesNames
  }
  genesMeta <- genesMetaSCE

  # Extract cell metadata
  cellsMetaSCE <- colData(rawSourceSCE)

  # Sanity check: same order and length
  assert_that(is.null(rownames(cellsMetaSCE)) ||
                identical(colnames(rawMatrix), rownames(cellsMetaSCE)),
              msg = "Column names of counts and cell metadata differ.")

  if (!is_empty(colnames(rawMatrix))) {
    cellsIDs <- colnames(rawMatrix)
  } else {
    cellsIDs <- rownames(cellsMetaSCE)
  }

  # retrieve cells IDs from appropriate meta column
  if (is_empty(cellsIDs)) {
    cellsIDsPattern <-
      ifelse(
        isEmptyName(cellsIDsPattern),
        # broadened default for common SCE conventions
        "^(Cells?[ -_]?IDs?|barcodes?|cells?)$",
        cellsIDsPattern)

    colToUse <- grep(x = colnames(cellsMetaSCE),
                     pattern = cellsIDsPattern,
                     ignore.case = TRUE)

    if (!is_empty(colToUse)) {
      cellsIDs <- cellsMetaSCE[, colToUse[[1L]], drop = TRUE]
    }
  }
  if (is_empty(cellsIDs)) {
    warning("Could not retrieve cells' IDs from the input")
  } else {
    cellsIDs <- make.unique(as.character(cellsIDs))
    colnames(rawMatrix)    <- cellsIDs
    rownames(cellsMetaSCE) <- cellsIDs
  }

  # Identify clustering columns according to given pattern
  # (e.g., 'COTAN_clusters_', 'seurat_clusters', ...)

  if (isEmptyName(clNamesPattern)) {
    clNamesPattern <- paste0("^(COTAN_clusters_|seurat_clusters$|",
                             ".*_snn_res\\..*|wsnn_res\\..*|leiden_res\\..*)")
  }
  clCols <- grep(clNamesPattern, names(cellsMetaSCE), value = FALSE)

  # Identify condition columns
  # (e.g., 'COTAN_conditions_', 'condition', 'orig.ident', etc.)

  if (isEmptyName(condNamesPattern)) {
    condNamesPattern <- "^(COTAN_conditions_|condition$|orig.ident$)"
  }
  condCols <- grep(condNamesPattern, names(cellsMetaSCE), value = FALSE)

  colsToKeep <- !(seq_len(ncol(cellsMetaSCE)) %in% union(clCols, condCols))
  cellsMeta <- cellsMetaSCE[, colsToKeep, drop = FALSE]

  # Attempt to retrieve co-expression matrices from metadata
  sceMetadataList <- S4Vectors::metadata(objSCE)

  keptMd <- c("genesCoex", "cellsCoex", "datasetMetadata", "project.name")
  droppedMd <- setdiff(names(sceMetadataList), keptMd)
  if (length(droppedMd) > 0L) {
    warning("Dropping metadata entries: ", toString(droppedMd))
  }

  genesCoex <- emptySymmetricMatrix()
  if ("genesCoex" %in% names(sceMetadataList)) {
    genesCoex <- sceMetadataList[["genesCoex"]]
  }

  if (!is_empty(genesCoex)) {
    gd <- dim(genesCoex)
    if (length(gd) != 2L ||
        gd[[1L]] != nrow(rawMatrix) ||
        gd[[2L]] != nrow(rawMatrix)) {
      warning(c("genesCoex dimensions do not match nrow(counts);",
                "dropping genesCoex."))
      genesCoex <- emptySymmetricMatrix()
    }
    genesCoex <-
      tryCatch(as(genesCoex, "dspMatrix"),
               error = function(e) {
                 warning("genesCoex cannot be made into a symmetric matrix")
                 emptySymmetricMatrix()
               })
  }

  cellsCoex <- emptySymmetricMatrix()
  if ("cellsCoex" %in% names(sceMetadataList)) {
    cellsCoex <- sceMetadataList[["cellsCoex"]]
  }

  if (!is_empty(cellsCoex)) {
    cd <- dim(cellsCoex)
    if (length(cd) != 2L ||
        cd[[1L]] != ncol(rawMatrix) ||
        cd[[2L]] != ncol(rawMatrix)) {
      warning(c("cellsCoex dimensions do not match ncol(counts);",
                "dropping cellsCoex."))
      cellsCoex <- emptySymmetricMatrix()
    }

    cellsCoex <-
      tryCatch(as(cellsCoex, "dspMatrix"),
               error = function(e) {
                 warning("cellsCoex cannot be made into a symmetric matrix")
                 emptySymmetricMatrix()
               })
  }

  # Extract dataset metadata if available
  datasetMeta <- data.frame()
  if ("datasetMetadata" %in% names(sceMetadataList)) {
    datasetMeta <- sceMetadataList[["datasetMetadata"]]
  } else if ("project.name" %in% names(sceMetadataList)) {
    # If the project name is stored directly in metadata
    datasetMeta <- data.frame(project.name = sceMetadataList[["project.name"]],
                              stringsAsFactors = FALSE)
  }

  # Create the COTAN object
  objCOTAN <- new(
    "COTAN",
    raw = rawMatrix,
    genesCoex = genesCoex,
    cellsCoex = cellsCoex,
    metaDataset = as.data.frame(datasetMeta),
    metaGenes = as.data.frame(genesMeta),
    metaCells = as.data.frame(cellsMeta),
    clustersCoex = list()
  )

  # Validate the COTAN object
  validObject(objCOTAN)

  if (!is_empty(clCols)) {
    logThis(paste("Clusterizations found:",
                  toString(names(cellsMetaSCE)[clCols])), logLevel = 2L)

    # Add clusterizations to the COTAN object
    for (col in names(cellsMetaSCE)[clCols]) {
      clusters <- getColumnFromDF(cellsMetaSCE, col)
      # Determine the clusterization name
      if (startsWith(col, "COTAN_clusters_")) {
        clName <- sub("^COTAN_clusters_", "", col)
      } else {
        clName <- col
      }
      # Add the clusterization using the method
      objCOTAN <- addClusterization(objCOTAN, clName = clName,
                                    clusters = clusters, override = FALSE)
    }
  }

  if (!is_empty(condCols)) {
    logThis(paste("Conditions found:",
                  toString(names(cellsMetaSCE)[condCols])), logLevel = 2L)

    # Add conditions to the COTAN object
    for (col in names(cellsMetaSCE)[condCols]) {
      conditions <- getColumnFromDF(cellsMetaSCE, col)
      # Determine the condition name
      if (startsWith(col, "COTAN_conditions_")) {
        condName <- sub("^COTAN_conditions_", "", col)
      } else {
        condName <- col
      }
      # Add the conditions using the method
      objCOTAN <- addCondition(objCOTAN, condName = condName,
                               conditions = conditions, override = FALSE)
    }
  }

  # Validate the COTAN object
  validObject(objCOTAN)

  return(objCOTAN)
}

# --------------------- Uniform Clusters ----------------------

#' @details `mergeUniformCellsClusters()` takes in a **uniform**
#'   *clusterization* and progressively checks whether *merging* two *near
#'   clusters* would form a **uniform** *cluster* still. Multiple thresholds
#'   will be used from \eqn{1.37} up to the given one in order to prioritize
#'   merge of the best fitting pairs.
#'
#'   This function uses the *cosine distance* to establish the *nearest clusters
#'   pairs*. It will use the [checkClusterUniformity()] function to check
#'   whether the merged *clusters* are **uniform**. The function will stop once
#'   no *tested pairs* of clusters can be *merged* after testing all pairs in a
#'   single batch
#'
#' @param objCOTAN a `COTAN` object
#' @param clusters The *clusterization* to merge. If not given the last
#'   available *clusterization* will be used, as it is probably the most
#'   significant!
#' @param checkers a `list` of objects that defines the method and the
#'   *increasing* thresholds to discriminate whether to merge two *clusters* if
#'   deemed *uniform transcript*. See [UniformTranscriptCheckers] for more
#'   details
#' @param GDIThreshold legacy. The threshold level that is used in a
#'   [SimpleGDIUniformityCheck-class]. It defaults to \eqn{1.43}
#' @param batchSize Number pairs to test in a single round. If none of them
#'   succeeds the merge stops. Defaults to \eqn{2 (\#cl)^{2/3}}
#' @param cores number of cores to use. Default is 1.
#' @param optimizeForSpeed Boolean; when `TRUE` `COTAN` tries to use the `torch`
#'   library to run the matrix calculations. Otherwise, or when the library is
#'   not available will run the slower legacy code
#' @param deviceStr On the `torch` library enforces which device to use to run
#'   the calculations. Possible values are `"cpu"` to us the system *CPU*,
#'   `"cuda"` to use the system *GPUs* or something like `"cuda:0"` to restrict
#'   to a specific device
#' @param useDEA Boolean indicating whether to use the *DEA* to define the
#'   distance; alternatively it will use the average *Zero-One* counts, that is
#'   faster but less precise.
#' @param distance type of distance to use. Default is `"cosine"` for *DEA* and
#'   `"euclidean"` for *Zero-One*. Can be chosen among those supported by
#'   [parallelDist::parDist()]
#' @param hclustMethod It defaults is `"ward.D2"` but can be any of the methods
#'   defined by the [stats::hclust()] function.
#' @param allCheckResults An optional `data.frame` with the results of previous
#'   checks about the merging of clusters. Useful to restart the *merging*
#'   process after an interruption.
#' @param initialIteration the number associated tot he first iteration; it
#'   defaults to 1. Useful in case of restart of the procedure to avoid
#'   intermediate data override
#' @param saveObj Boolean flag; when `TRUE` saves intermediate analyses and
#'   plots to file
#' @param outDir an existing directory for the analysis output. The effective
#'   output will be paced in a sub-folder.
#'
#' @returns a `list` with:
#'   * `"clusters"` the merged cluster labels array
#'   * `"coex"` the associated `COEX` `data.frame`
#'
#' @export
#'
#' @importFrom rlang is_empty
#' @importFrom rlang set_names
#' @importFrom rlang is_named2
#'
#' @importFrom assertthat assert_that
#'
#' @importFrom grDevices pdf
#' @importFrom grDevices dev.off
#' @importFrom grDevices dev.cur
#'
#' @importFrom Matrix t
#'
#' @importFrom stats hclust
#' @importFrom stats as.dendrogram
#' @importFrom stats cophenetic
#'
#' @importFrom stringr str_detect
#' @importFrom stringr fixed
#'
#' @importFrom dendextend get_nodes_attr
#'
#' @importFrom zeallot %<-%
#' @importFrom zeallot %->%
#'
#' @importFrom methods new
#'
#' @examples
#' data("test.dataset")
#'
#' objCOTAN <- automaticCOTANObjectCreation(raw = test.dataset,
#'                                          GEO = "S",
#'                                          sequencingMethod = "10X",
#'                                          sampleCondition = "Test",
#'                                          cores = 6L,
#'                                          saveObj = FALSE)
#'
#' objCOTAN <- storeGDI(objCOTAN, genesGDI = calculateGDI(objCOTAN, cores = 6L))
#'
#' groupMarkers <- list(G1 = c("g-000010", "g-000020", "g-000138"),
#'                      G2 = c("g-000300", "g-000330"),
#'                      G3 = c("g-000510", "g-000530", "g-000550",
#'                             "g-000570", "g-000590"))
#'
#' gdiPlot <- GDIPlot(objCOTAN, genes = groupMarkers, cond = "test")
#' plot(gdiPlot)
#'
#' ## Here we override the default checker as a way to reduce the number of
#' ## clusters as higher thresholds imply less stringent uniformity checks
#' ##
#' ## In real applications it might be appropriate to do so in the cases when
#' ## the wanted resolution is lower such as in the early stages of the analysis
#' ##
#'
#' checker <- new("AdvancedGDIUniformityCheck")
#' stopifnot(identical(
#'   checker |> methods::slot("firstCheck") |> methods::slot("GDIThreshold"),
#'   1.297
#' ))
#'
#' checker2 <- shiftCheckerThresholds(checker, 0.1)
#' stopifnot(identical(
#'   checker2 |> methods::slot("firstCheck") |> methods::slot("GDIThreshold"),
#'   1.397
#' ))
#'
#' splitList <- cellsUniformClustering(objCOTAN, cores = 6L,
#'                                     dataMethod = "LogLikelihood",
#'                                     useCoexEigen = TRUE,
#'                                     genesSel = "HGDI",
#'                                     numGenes = 2000L,
#'                                     numReducedComp = 50L,
#'                                     initialResolution = 0.8,
#'                                     checker = checker2,
#'                                     saveObj = FALSE)
#'
#' clusters <- splitList[["clusters"]]
#'
#' firstCluster <- getCells(objCOTAN)[clusters %in% clusters[[1L]]]
#'
#' checkerRes <-
#'   checkClusterUniformity(objCOTAN, checker = checker2,
#'                          clusterName = clusters[[1L]], cells = firstCluster,
#'                          cores = 6L, optimizeForSpeed = TRUE,
#'                          deviceStr = "cuda", saveObj = FALSE)
#'
#' objCOTAN <- addClusterization(objCOTAN,
#'                               clName = "split",
#'                               clusters = clusters,
#'                               coexDF = splitList[["coex"]],
#'                               override = FALSE)
#'
#' stopifnot(identical(reorderClusterization(objCOTAN)[["clusters"]], clusters))
#'
#' ## It is possible to pass a list of checkers tot the merge function that will
#' ## be applied each to the *resulting* merged *clusterization* obtained using
#' ## the previous checker. This ensures that the most similar clusters are
#' ## merged first improving the overall performance
#'
#' mergedList <- mergeUniformCellsClusters(objCOTAN,
#'                                         checkers = c(checker, checker2),
#'                                         clusters = clusters,
#'                                         cores = 6L,
#'                                         optimizeForSpeed = TRUE,
#'                                         deviceStr = "cpu",
#'                                         distance = "cosine",
#'                                         hclustMethod = "ward.D2",
#'                                         saveObj = FALSE)
#'
#' objCOTAN <- addClusterization(objCOTAN,
#'                               clName = "merged",
#'                               clusters = mergedList[["clusters"]],
#'                               coexDF = mergedList[["coex"]],
#'                               override = TRUE)
#'
#' stopifnot(identical(reorderClusterization(objCOTAN)[["clusters"]],
#'                     mergedList[["clusters"]]))
#'
#' @rdname UniformClusters
#'

mergeUniformCellsClusters <- function(objCOTAN,
                                      clusters = NULL,
                                      checkers = NULL,
                                      GDIThreshold = NaN,
                                      batchSize = 0L,
                                      cores = 1L,
                                      optimizeForSpeed = TRUE,
                                      deviceStr = "cuda",
                                      useDEA = TRUE,
                                      distance = NULL,
                                      hclustMethod = "ward.D2",
                                      allCheckResults = data.frame(),
                                      initialIteration = 1L,
                                      saveObj = TRUE,
                                      outDir = ".") {
  # returns merged name given underlying names
  toMergedName <- function(clName1, clName2) {
    return(paste0(min(clName1, clName2), "_", max(clName1, clName2), "-merge"))
  }

  # returns underlying names given merged name
  fromMergedName <- function(mergedClName, currentClNames) {
    partialMatch <-
      vapply(
        currentClNames,
        \(clName, mergedName) str_detect(mergedName, clName),
        FUN.VALUE = logical(1L),
        mergedClName
      )

    c(clName1, clName2) %<-% c("", "")
    if (sum(partialMatch) == 2L) {
      c(clName1, clName2) %<-% currentClNames[partialMatch]
    }

    return(c("clName1" = clName1, "clName2" = clName2))
  }

  # updates checker results with thresholds from current checker
  updateChecker <- function(mergedClName, checker, allCheckResults) {
    if (all(names(allCheckResults) != mergedClName)) {
      return(checker)
    } else {
      return(checkObjIsUniform(currentC = checker,
                               previousC = allCheckResults[[mergedClName]],
                               objCOTAN = NULL))
    }
  }

  # select all clusters pairings to be checked for this batch
  selectPairsList <- function(pList, batchSize, checker, allCheckResults) {
    # drop the already tested pairs
    pNamesList <- lapply(pList, \(p) toMergedName(p[[1L]], p[[2L]]))

    untestedPairs <-
      vapply(
        pNamesList,
        \(pName, check, allRes) {
          # we exploit the convention that
          # a non-available result is marked by a zero clusterSize
          updateChecker(pName, check, allRes)@clusterSize == 0L
        },
        FUN.VALUE = logical(1L),
        checker,
        allCheckResults
      )

    pList <- pList[untestedPairs]

    # take the first N remaining
    numPairsToTest <- min(batchSize, length(pList))
    return(pList[seq_len(numPairsToTest)])
  }

  # runs the UT check on all pairings of the batch
  testPairListMerge <- function(pList, outputClusters,
                                checker, allCheckResults) {
    logThis(paste("Updating check results for the", length(allCheckResults),
                  "already tested pairs to align to new checker"),
            logLevel = 1L)

    if (TRUE) {
      resNames <- names(allCheckResults)
      allCheckResults <-
        lapply(seq_along(allCheckResults),
               function(r, check, allRes) {
                 updateChecker(names(allCheckResults)[[r]], check, allRes)
               }, checker, allCheckResults)
      names(allCheckResults) <- resNames
      rm(resNames)
    }

    logThis(paste0(length(pList), " new clusters pairs to be tested for",
                   " merging:\n", paste(pList, collapse = " ")), logLevel = 1L)

    for (p in pList) {
      logThis("*", logLevel = 1L, appendLF = FALSE)

      c(cl1, cl2) %<-% p

      if (!(any(outputClusters %in% cl1) && any(outputClusters %in% cl2))) {
        logThis(paste0("Clusters ", cl1, " or ", cl2,
                       " is now missing due to previous merges: skip"),
                logLevel = 3L)
        next
      }

      mergedClName <- toMergedName(cl1, cl2)

      logThis(mergedClName, logLevel = 3L)

      checkResults <- updateChecker(mergedClName, checker, allCheckResults)
      if (checkResults@clusterSize != 0L) {
        logThis(paste("Clusters", cl1, "and", cl2, "already analyzed: skip"),
                logLevel = 3L)
        next
      }
      # else we have insufficient information about the pair [re]calculate

      mergedCluster <- names(outputClusters)[outputClusters %in% c(cl1, cl2)]

      checkResults <- tryCatch(
        checkClusterUniformity(objCOTAN,
                               clusterName = mergedClName,
                               cells = mergedCluster,
                               checker = checker,
                               cores = cores,
                               optimizeForSpeed = optimizeForSpeed,
                               deviceStr = deviceStr,
                               saveObj = saveObj,
                               outDir = mergeOutDir),
        error = function(err) {
          logThis(paste("While checking cluster uniformity", err),
                  logLevel = 0L)
          logThis("marking pair as not mergable", logLevel = 1L)
          return(checker)
        })

      gc()

      if (mergedClName %in% names(allCheckResults)) {
        # can happen if previous check information is insufficient to update the
        # result
        allCheckResults[[mergedClName]] <- checkResults
      } else {
        allCheckResults <- append(allCheckResults, checkResults)
        names(allCheckResults)[length(allCheckResults)] <- mergedClName
      }

      logThis(paste("Clusters", cl1, "and", cl2,
                    ifelse(checkResults@isUniform, "can", "cannot"),
                    "be merged"), logLevel = 1L)
    }

    return(allCheckResults)
  }

  # sorts all results by significance then merge all possible pairings in order
  mergeAllClusters <- function(outputClusters, allCheckResults) {
    # filters out missing clusters
    allClNames <- unique(outputClusters)
    assert_that(!any(vapply(allClNames, isEmptyName, logical(1L))),
                is_named2(allCheckResults))

    posToKeep <-
      vapply(seq_along(allCheckResults),
             function(r) {
               c(clName1, clName2) %<-%
                 fromMergedName(names(allCheckResults)[r],
                                allClNames)
               return(clName1 %in% allClNames && clName2 %in% allClNames)
             }, logical(1L))
    checkRes <- allCheckResults[posToKeep]

    # filter out non uniform pairs
    # it is assumed that the checkRes have been already
    # updated to align to current checker
    posToKeep <- vapply(seq_along(checkRes),
                        function(r) return(checkRes[[r]]@isUniform),
                        logical(1L))
    checkRes <- checkRes[posToKeep]

    if (is_empty(checkRes)) {
      logThis(paste("No clusters will be merged"), logLevel = 2L)

      return(outputClusters)
    }

    shifts <- vapply(checkRes, calculateThresholdShiftToUniformity, double(1L))
    checkRes <- checkRes[order(shifts)]

    #operate the merges
    for (mergedName in names(checkRes)) {
      allClNames <- unique(outputClusters)
      c(clName1, clName2) %<-%
        fromMergedName(mergedName, allClNames)
      if (!(clName1 %in% allClNames && clName2 %in% allClNames)) {
        logThis(paste0("One or both of the clusters ", clName1, ", ", clName2,
                       " is no more in the clusterization"), logLevel = 3L)
        next
      }
      logThis(paste("Clusters", clName1, "and", clName2, "will be merged"),
              logLevel = 2L)
      outputClusters <-
        mergeClusters(outputClusters,
                      names = c(clName1, clName2),
                      mergedName = toMergedName(clName1, clName2))
      outputClusters <- factorToVector(outputClusters)
    }
    return(outputClusters)
  }

  # start analysis

  startTime <- Sys.time()

  logThis("Merging cells' uniform clustering: START", logLevel = 2L)

  assert_that(estimatorsAreReady(objCOTAN),
              msg = paste("Estimators `lambda`, `nu`, `dispersion` are not",
                          "ready: Use proceedToCoex() to prepare them"))

  if (is_empty(checkers)) {
    GDIThreshold <- ifelse(is.finite(GDIThreshold), GDIThreshold, 1.43)

    # keep old behavior
    thresholdGap <- max(GDIThreshold - 1.37, 0.0)
    numThresholds <- ceiling(thresholdGap / 0.03)
    allThresholds <- 1.37 +
      c(0L, seq_len(numThresholds)) * thresholdGap / numThresholds

    checkers <-
      lapply(allThresholds,
             function(threshold) {
               new("SimpleGDIUniformityCheck",
                   check = new("GDICheck",
                               GDIThreshold = threshold,
                               maxRatioBeyond = 0.01))
             })

    rm(thresholdGap, numThresholds, allThresholds)
  } else {
    assert_that(!is.finite(GDIThreshold),
                msg = paste("Either `checker` object[s] or",
                            "a legacy `GDIThreshold` must be given"))
    if (!is(checkers, "list")) {
      checkers <- list(checkers)
    }
    assert_that(all(vapply(checkers, is, logical(1L), "BaseUniformityCheck")))
  }
  rm(GDIThreshold)
  logThis(paste("The merge algorithm will use", length(checkers), "passes"),
          logLevel = 1L)

  assert_that(isa(allCheckResults, "data.frame"),
              (is_empty(allCheckResults) ||
                 identical(colnames(allCheckResults),
                           colnames(checkersToDF(checkers[[1L]])))),
              msg = "Previous results passed in are of wrong type or columns")

  allCheckResults <- dfToCheckers(allCheckResults, class(checkers[[1L]]))

  if (is_empty(clusters)) {
    # pick the last clusterization
    clusters <- getClusters(objCOTAN)
  }
  outputClusters <-
    factorToVector(asClusterization(clusters, getCells(objCOTAN)))

  if (batchSize == 0L) {
    # default is twice the (2/3) power of the number of clusters
    numCl <- length(unique(outputClusters))
    batchSize <- as.integer(ceiling(1.2 * numCl^(2.0 / 3.0)))
    rm(numCl)
  }

  cond <- getMetadataElement(objCOTAN, datasetTags()[["cond"]])

  outDirCond <- file.path(outDir, cond)
  if (isTRUE(saveObj) && !dir.exists(outDirCond)) {
    dir.create(outDirCond)
  }

  mergeOutDir <- file.path(outDirCond, "leafs_merge")
  if (isTRUE(saveObj) && !dir.exists(mergeOutDir)) {
    dir.create(mergeOutDir)
  }

  iter <- initialIteration - 1L

  for (checker in checkers) {
    logThis(paste0("Start merging nearest clusters - the main threshold is: ",
                   getCheckerThreshold(checker)),
            logLevel = 2L)
    repeat {
      startLoopTime <- Sys.time()

      iter <- iter + 1L
      logThis(paste0("Start merging nearest clusters: iteration ", iter),
              logLevel = 3L)

      firstBatch <- is_empty(allCheckResults)
      oldNumClusters <- length(unique(outputClusters))

      clDist <- distancesBetweenClusters(objCOTAN, clusters = outputClusters,
                                         useDEA = useDEA, distance = distance)
      gc()

      if (isTRUE(saveObj)) tryCatch({
          pdf(file.path(mergeOutDir,
                        paste0("dend_iter_", iter, "_tau_",
                               getCheckerThreshold(checker), "_plot.pdf")))

          hcNorm <- hclust(clDist, method = hclustMethod)
          plot(as.dendrogram(hcNorm))
        }, error = function(err) {
          logThis(paste("While saving dendogram plot", err), logLevel = 0L)
        }, finally = {
          # Check for active device
          if (dev.cur() > 1L) {
            dev.off()
          }
        })

      # We will check whether it is possible to merge a list of cluster pairs.
      # These pairs correspond to N lowest distances as calculated before
      # If none of them can be merges, the loop stops

      allLabels <- labels(clDist)
      assert_that(length(allLabels) == oldNumClusters,
                  msg = "Internal error - distance has no labels")

      # create all pairings with different clusters
      pList <- rbind(rep((1L:oldNumClusters), each  = oldNumClusters),
                     rep((1L:oldNumClusters), times = oldNumClusters))
      pList <- pList[, pList[1L, ] < pList[2L, ], drop = FALSE]
      pList <- matrix(allLabels[pList], nrow = 2L)

      # reorder the pairings using the distance and pick only those necessary
      pList <- as.list(as.data.frame(pList))

      # reorder based on distance
      pList <- pList[order(clDist)]

      pList <- selectPairsList(pList, batchSize, checker, allCheckResults)

      allCheckResults <-
        testPairListMerge(pList, outputClusters, checker, allCheckResults)

      if (!firstBatch) {
        outputClusters <- mergeAllClusters(outputClusters, allCheckResults)
      }

      newNumClusters <- length(unique(outputClusters))
      if (newNumClusters == 1L) {
        # nothing left to do: stop!
        break
      }

      if (isTRUE(saveObj)) tryCatch({
          outFile <- file.path(mergeOutDir,
                               paste0("merge_clusterization_", iter, ".csv"))
          write.csv(outputClusters, file = outFile)

          outFile <- file.path(mergeOutDir,
                               paste0("all_check_results_", iter, ".csv"))
          write.csv(checkersToDF(allCheckResults), file = outFile, na = "NaN")
        },
        error = function(err) {
          logThis(paste("While saving current clusterization", err),
                  logLevel = 0L)
        })
      if (firstBatch) {
        logThis("Finished the first batch - no merges were executed",
                logLevel = 3L)
      } else if (newNumClusters == oldNumClusters) {
        logThis(paste("None of the remaining tested",
                      "cluster pairs could be merged"), logLevel = 3L)

        # No merges happened -> too low probability of new merges...
        break
      } else {
        logThis(paste("Executed", (oldNumClusters - newNumClusters), "merges"),
                logLevel = 3L)
      }

      endLoopTime <- Sys.time()

      logThis(paste("Loop calculations elapsed time:",
                    difftime(endLoopTime, startLoopTime, units = "secs")),
              logLevel = 2L)
    }
    logThis(paste0("Executed all merges for threshold ",
                   getCheckerThreshold(checker), " out of ",
                   length(allCheckResults), " checks"), logLevel = 3L)
  }

  logThis(paste0("The final merged clusterization contains [",
                 length(unique(outputClusters)), "] different clusters: ",
                 toString(sort(unique(outputClusters)))), logLevel = 1L)

  # replace the clusters' tags with completely new ones
  if (TRUE) {
    clTags <- sort(unique(outputClusters))

    clTagsMap <- paste0(seq_along(clTags))
    clTagsMap <- factorToVector(niceFactorLevels(clTagsMap))
    clTagsMap <- set_names(clTagsMap, clTags)

    # keep `-1` tag if it has not been merged
    if ("-1" %in% clTags) {
      clTagsMap[["-1"]] <- "-1"
    }

    outputClusters <- set_names(clTagsMap[outputClusters], getCells(objCOTAN))

    checksTokeep <- names(allCheckResults) %in% clTags
    allCheckResults <- allCheckResults[checksTokeep]
    names(allCheckResults) <- clTagsMap[names(allCheckResults)]
  }

  outputCoexDF <-
    tryCatch(DEAOnClusters(objCOTAN, clusters = outputClusters),
             error = function(err) {
               logThis(paste("Calling DEAOnClusters", err), logLevel = 0L)
               return(NULL)
             })

  c(outputClusters, outputCoexDF, permMap) %<-% tryCatch(
    reorderClusterization(objCOTAN, clusters = outputClusters,
                          coexDF = outputCoexDF, reverse = FALSE,
                          keepMinusOne = TRUE, useDEA = useDEA,
                          distance = distance, hclustMethod = hclustMethod),
    error = function(err) {
      logThis(paste("Calling reorderClusterization", err), logLevel = 0L)
      return(list(outputClusters, outputCoexDF))
    })
  names(allCheckResults) <- permMap[names(allCheckResults)]

  if (isTRUE(saveObj)) tryCatch({
    outFile <- file.path(outDirCond, "merge_check_results.csv")
    write.csv(checkersToDF(allCheckResults), file = outFile, na = "NaN")

    outFile <- file.path(outDirCond, "merge_clusterization.csv")
    write.csv(as.data.frame(list("merge" = outputClusters)),
              file = outFile, na = "NaN")
  })

  endTime <- Sys.time()

  logThis(paste("Total calculations elapsed time:",
                difftime(endTime, startTime, units = "secs")),
          logLevel = 2L)

  logThis("Merging cells' uniform clustering: DONE", logLevel = 2L)

  return(list("clusters" = outputClusters, "coex" = outputCoexDF))
}

---
title: "Guided tutorial to Uniform Transcript cells' clustering using COTAN"
author: 
- name: "Silvia Giulia Galfrè"
  affiliation: "Department of Computer Science, University of Pisa"
- name: "Marco Fantozzi"
  affiliation: "University of Parma"

package: COTAN
output:
  BiocStyle::html_document:
    keep_md: true
vignette: >
  %\VignetteIndexEntry{Uniform clustering using COTAN}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

## Preamble

```{r knitr options, echo = FALSE, include = FALSE}
plotDev <- if (requireNamespace("ragg", quietly = TRUE)) {
  "ragg_png"
} else if (requireNamespace("Cairo", quietly = TRUE)) {
  "cairo_png"
} else {
  "png"
}

knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  fig.width = 7L,
  fig.height = 5L,
  dev = plotDev,
  fig.crop = FALSE,
  dpi = 100L
)
```


```{r preamble, message=FALSE, warning=FALSE}
library(COTAN)
library(zeallot)

# necessary to solve precedence of overloads
conflicted::conflict_prefer("%<-%", "zeallot")

# enable multi-processing (not on Windows)
prevOptState <- options(parallelly.fork.enable = TRUE)
```

# Introduction

This tutorial shows the available tools in COTAN to help with genes' clustering

### Setup

Define a directory where the data and the output will be stored

```{r setup-and-log}
dataDir <- file.path(tempdir(), "COTAN_vignette_data")
dir.create(dataDir, recursive = TRUE, showWarnings = FALSE)

print(dataDir)

outDir <- dataDir

# Log-level 2 was chosen to showcase better how the package works
# In normal usage a level of 0 or 1 is more appropriate
setLoggingLevel(2L)

# This file will contain all the logs produced by the package
# as if at the highest logging level
setLoggingFile(file.path(outDir, "vignette_uniform_clustering.log"))
```


## Retrieving the data-set

Download the data-set for `r "mouse cortex E17.5"` from
`r "Yuzwa et al."` (2017)

```{r download-data}
GEO <- "GSM2861514"

dir.create(file.path(dataDir, GEO), showWarnings = FALSE)

datasetFileName <-
  file.path(dataDir, GEO, "GSM2861514_E175_All_Cells_DGE.txt.gz")


# retries up to 5 times to get the dataset
attempts <- 0L
maxAttempts <- 5L
ok <- FALSE

while (attempts < maxAttempts && !ok) {
  attempts <- attempts + 1L

  if (!file.exists(datasetFileName)) {
    res <- try(
      GEOquery::getGEOSuppFiles(
        GEO = GEO,
        makeDirectory = TRUE,
        baseDir = dataDir,
        filter_regex = base::basename(datasetFileName),
        fetch_files = TRUE
      ),
      silent = TRUE
    )
  }

  ok <- file.exists(datasetFileName)

  if (!ok && attempts < maxAttempts) {
    Sys.sleep(1)
  }
}

assertthat::assert_that(
  ok,
  msg = paste0(
    "Failed to retrieve file '", datasetFileName,
    "' after ", maxAttempts, " attempts."
  )
)

rawDataset <- read.csv(datasetFileName, sep = "\t", row.names = 1L)

print(dim(rawDataset))
```

### Create the COTAN object

Initialize the `COTAN` object with the row count table and
the metadata from the experiment.

```{r create-cotan-object}
cond <- "mouse_cortex_E17.5"

obj <- COTAN(raw = rawDataset)
obj <-
  initializeMetaDataset(
    obj,
    GEO = GEO,
    sequencingMethod = "Drop_seq",
    sampleCondition = cond
  )

logThis(paste0("Condition ", getMetadataElement(obj, datasetTags()[["cond"]])),
        logLevel = 1L)
```

Assign to each cell its origin

```{r add-origin-to-the-cotan-object}
# mark cells origin
data(vignette.cells.origin)
head(vignette.cells.origin, 18)

obj <- 
  addCondition(obj, condName = "origin", conditions = vignette.cells.origin)

rm(vignette.cells.origin)
```


### Drop low quality cells

```{r drop-low-quality-cells}
# use previously established results to determine
# which cells were dropped in the cleaning stage
data(vignette.split.clusters)

cellsToDrop <-
  getCells(obj)[!(getCells(obj) %in% names(vignette.split.clusters))]

obj <- dropGenesCells(obj, cells = cellsToDrop)

# Log the remaining number of cells

logThis(paste("n cells", getNumCells(obj)), logLevel = 1L)

table(getCondition(obj, condName = "origin"))

rm(vignette.split.clusters)
```

# Establish Uniform Transcript cells' clusters

## COTAN analysis

In this part, the `COTAN` model is calibrated:
all the contingency tables are computed and used to get
the statistics necessary to `COEX` evaluation and storing

The `COEX` coefficient between the two genes, measures the deviation between
the 2×2 contingency table of the joint occurrence of the genes in the cells,
and their expected co-expression assuming independence.

```{r calculate-and-store-coex-matrix}
obj <-
  proceedToCoex(
    obj,
    calcCoex = FALSE,
    optimizeForSpeed = TRUE,
    cores = 3L,
    deviceStr = "cuda"
  )
```

## Uniform Clustering

It is possible to obtain a cells' *clusterization* based on the concept of 
*uniformity* of expression of the genes across the cells in each cluster.
That is the clusters satisfy the null hypothesis of the `COTAN` model:
the genes expression is not dependent on the cell in consideration.

### First UT clusterization

There are two functions involved into obtaining a proper *clusterization*:
the first is `cellsUniformClustering`. This function uses standard tools
*clusterization* methods via a `COTAN` specific data input and reduction.
The function then discards and re-clusters any *non-uniform* cluster.

Please note that the most important parameters for the users are the
`GDIThreshold`s inside the **Uniform Transcript** checkers: they determine how 
strict is the check. Default constructed advance checks give a pretty strong
guarantee of uniformity for the *cluster*.

```{r create-ut-clusterization, eval=FALSE, include=TRUE}
# This code is a too computationally heavy to be used in a vignette [~20 min.]
# So the result was stored and will be re-loaded in the next chunk


initialClusters <- NULL

if (TRUE) {
  # read from the last file among those named all_check_results_XX.csv
  mergeDir <- file.path(outDir, cond, "reclustering")

  resFiles <-
    list.files(
      path = mergeDir,
      pattern = "partial_clusterization_.*csv",
      full.names = TRUE
    )

  if (length(resFiles) != 0L) {
    prevClustRes <-
      read.csv(resFiles[length(resFiles)], header = TRUE, row.names = 1L)
    initialClusters <- getColumnFromDF(prevClustRes, 1L)
    initialClusters[is.na(initialClusters)] <- "-1"
    initialClusters <- niceFactorLevels(initialClusters)
  }
}


# default constructed checker is OK
advChecker <- new("AdvancedGDIUniformityCheck")

c(splitClusters, splitCoexDF) %<-%
  cellsUniformClustering(
    obj,
    initialResolution = 0.8,
    checker = advChecker,
    dataMethod = "LogLikelihood", # of observed against expected data
    useCoexEigen = TRUE, # project on `COEX` eigenvectors instead doing a `PCA`
    numReducedComp = 50L,
    minimumUTClusterSize = 50L, # too large values imply many un-clustered cells
    initialClusters = initialClusters,
    initialIteration = 1L,
    optimizeForSpeed = TRUE,
    deviceStr = "cuda",
    cores = 3L,
    saveObj = TRUE, # save intermediate data for log and restart
    outDir = outDir
  )

# add the newly found clusterization to the `COTAN` object
obj <-
  addClusterization(
    obj,
    clName = "split",
    clusters = splitClusters,
    coexDF = splitCoexDF
  )

table(splitClusters)
```

Loading pre-calculated *clusterization* from data

```{r load-pre-calculated-clusterization_split}
data("vignette.split.clusters", package = "COTAN")
splitClusters <- vignette.split.clusters

# explicitly calculate the DEA of the clusterization to store it
splitCoexDF <- DEAOnClusters(obj, clusters = splitClusters)

obj <-
  addClusterization(
    obj,
    clName = "split",
    clusters = splitClusters,
    coexDF = splitCoexDF,
    override = FALSE
  )
```

### Extract `split` clusters' statistics

It is possible to extract some statistics about a stored *clusterization*:

```{r extract-clusterization-summary_split}
c(summaryData, summaryPlot) %<-%
  clustersSummaryPlot(
    obj,
    clName = "split",
    plotTitle = "split summary",
    condName = "origin"
  )

head(summaryData, n = 10L)
```
The `ExpGenes` column contains the number of genes that are expressed in any
cell of the relevant *cluster*, while the `ExpGenes25` column contains the
number of genes expressed in at the least 25% of the cells of the relevant
*cluster*

```{r summary-as-plot}
plot(summaryPlot)
```

### Relevance of marker genes for the `split` clusters

It is possible to visualize how relevant are some *marker genes* for the
*clusters* comprising a given *clusterization*

```{r define-layers-specific-genes}
# these are some genes associated to each cortical layer
layersGenes <- list(
  "L1"   = c("Reln",   "Lhx5"),
  "L2/3" = c("Cux1",   "Satb2"),
  "L4"   = c("Rorb",   "Sox5"),
  "L5/6" = c("Bcl11b", "Fezf2"),
  "Prog" = c("Hes1",    "Vim")
)
```

```{r clusterization-data-visualization_split}
c(splitHeatmap, splitScoreDF, splitPValueDF) %<-%
  clustersMarkersHeatmapPlot(
    obj,
    groupMarkers = layersGenes,
    clName = "split",
    kCuts = 2L,
    adjustmentMethod = "holm"
  )

ComplexHeatmap::draw(splitHeatmap)
```

In the above graph, it is possible to see that the found clusters align
well to the expression of the layers' genes.


### `UMAP` of the `split` clusterization

It is also possible to check how the *clusters* are spread in a `UMAP` plot
that uses the same data reduction methods as the one used in the creation of
the *clusterization*

```{r clusterization-umap-plot-via-drm_split, eval=FALSE, include=TRUE}
c(umapPlot, cellsRDM) %<-%
  cellsUMAPPlot(
    obj,
    clName = "split",
    clusters = NULL,
    useCoexEigen = TRUE, # Aligning these to `split` generation gives best res.
    dataMethod = "LogLikelihood", # "AdjBinarized" is also a good choice
    numComp = 50L, # number of components of the data reduced matrix
    colors = NULL, # a list of user defined colors for the various clusters
    numNeighbors = 30L, # UMAP related parameters
    minPointsDist = 0.3 # UMAP related parameters
  )

plot(umapPlot)
```

Unfortunately, due to build-timeout limits, the above plot cannot be displayed,
as no `COEX` matrix was calculated in the `COTAN` object,
but we can show that the *clusterization* is good even changing the
data reduction method, in this case the one from `Seurat`.

```{r clusterization-umap-plot-via-drm_split_as-seurat}
c(umapPlot, cellsRDM) %<-%
  cellsUMAPPlot(
    obj,
    clName = "split",
    clusters = NULL,
    useCoexEigen = FALSE,
    dataMethod = "LogNormalized", 
    numComp = 50L, # number of components of the data reduced matrix
    genesSel = "HVG_Seurat",
    numGenes = 500L,
    colors = NULL, # a list of user defined colors for the various clusters
    numNeighbors = 30L, # UMAP related parameters
    minPointsDist = 0.3 # UMAP related parameters
  )

plot(umapPlot)
```

### Merged UT clusterization

Since the algorithm that creates the *clusters* is not directly geared to
achieve cluster uniformity, there might be some *clusters* that can be merged
back together and still be **Uniform Transcript**.

This is the purpose of the function `mergeUniformCellsClusters()` that takes a
existing *clusterization* and tries to merge pairs of cluster.
If a pair forms a uniform cluster (via the uniformity check) the pair is
actually merged.

Since the number of possible pairs grows quadratically with the number of
clusters, in order to avoid running the totality of the possible checks,
the function relies on a *related cluster distance* to select the *a-priori*
most likely to be merged.

Again, here, the most important parameters for the users are the `GDIThreshold`s
inside the **Uniform Transcript** checkers: they define how strict is the
check. Default constructed advance check gives a pretty strong guarantee of
uniformity for the *cluster*.

If one wants to achieve a more *relaxed* merge, and thus less clusters overall,
it is possible to define a *sequence* of checkers, each less stringent than the
previous, that will be applied one after the other: this allows to execute first
the merges that result in the *most* uniform clusters and only later merge those
that satisfy only the relaxed checks.

```{r merge-clusters-if-ut, eval=FALSE, include=TRUE}

checkersList <-
  list(
    advChecker,
    shiftCheckerThresholds(advChecker, 0.01), # Sensible threshold shifts really
    shiftCheckerThresholds(advChecker, 0.03)  # depend on the dataset
  )

prevCheckRes <- data.frame()

# The following code shows the case when one wants to re-use the already
# calculated checks from the saved intermediate outputs.
# This can apply in cases one wants to add a new checker to the list above or
# in the cases the execution is interrupted prematurely.
#
# Note that a similar facility exists for the `cellsUniformClustering()`
# function above.
#
if (TRUE) {
  # read from the last file among those named all_check_results_XX.csv
  mergeDir <- file.path(outDir, cond, "leafs_merge")

  resFiles <-
    list.files(
      path = mergeDir,
      pattern = "all_check_results_.*csv",
      full.names = TRUE
    )

  if (length(resFiles) != 0L) {
    prevCheckRes <-
      read.csv(resFiles[length(resFiles)], header = TRUE, row.names = 1L)
  }
}

c(mergedClusters, mergedCoexDF) %<-%
  mergeUniformCellsClusters(
    obj,
    clusters = splitClusters,
    checkers = checkersList,
    allCheckResults = prevCheckRes,
    optimizeForSpeed = TRUE,
    deviceStr = "cuda",
    cores = 6L,
    useDEA = TRUE,
    saveObj = TRUE,
    outDir = outDir
  )

# add the newly found clusterization to the `COTAN` object
obj <-
  addClusterization(
    obj,
    clName = "merge",
    override = TRUE,
    clusters = mergedClusters,
    coexDF = mergedCoexDF
  )

table(mergedClusters)
```


Loading pre-calculated *clusterization* from data

```{r load-pre-calculated-clusterization_merge}
data("vignette.merge.clusters", package = "COTAN")
mergedClusters <- vignette.merge.clusters[getCells(obj)]

# explicitly calculate the DEA of the clusterization to store it
mergedCoexDF <- DEAOnClusters(obj, clusters = mergedClusters)

obj <-
  addClusterization(
    obj,
    clName = "merge",
    clusters = mergedClusters,
    coexDF = mergedCoexDF,
    override = FALSE
  )

# this gives immediate visual information about which clusters were merged
table(splitClusters, mergedClusters)
```

### Extract `merge` clusters' statistics

It is possible to extract some statistics about a stored *clusterization*:

```{r extract-clusterization-summary_merge}
c(summaryData, summaryPlot) %<-%
  clustersSummaryPlot(
    obj,
    clName = "merge",
    plotTitle = "merge summary",
    condName = "origin"
  )

head(summaryData, n = 10L)

plot(summaryPlot)
```

### Relevance of marker genes for the `merge` clusters

Again, it is possible to visualize how relevant are the *marker genes* from
above:

```{r  clusterization-data-visualization_merge}
c(mergeHeatmap, mergeScoresDF, mergePValuesDF) %<-%
  clustersMarkersHeatmapPlot(
    obj,
    groupMarkers = layersGenes,
    clName = "merge",
    condNameList = list("origin")
  )

ComplexHeatmap::draw(mergeHeatmap)
```

It is also possible to use any *clusterization* as if a condition:

```{r clusterization-data-visualization_merge-vs-split}}
c(mergeVsSplitHeatmap, ..) %<-%
  clustersMarkersHeatmapPlot(
    obj,
    clName = "merge",
    condNameList = list("split"),
    conditionsList = list(splitClusters)
  )

ComplexHeatmap::draw(mergeVsSplitHeatmap)
```

### `UMAP` of the `merge` clusterization

It is also possible to check how the *clusters* are spread in a `UMAP` plot
that uses the same (or other) data reduction methods as the one used in the
creation of the *clusterization*

Again it is possible to plot the *clusterization* on a `UMAP` plot

```{r clusterization-umap-plot-via-drm_merge, eval=FALSE, include=TRUE}
c(umapPlot, .) %<-%
  cellsUMAPPlot(
    obj,
    clName = "merge",
    clusters = NULL,
    useCoexEigen = TRUE,
    dataMethod = "LogLikelihood", # "AdjBinarized" is also a good choice
    numComp = 50L, # number of components of the data reduced matrix
    colors = NULL, # a list of user defined colors for the various clusters
    numNeighbors = 30L, # UMAP related parameters
    minPointsDist = 0.3 # UMAP related parameters
  )

plot(umapPlot)
```

Again, due to build-timeout limits, the above plot cannot be displayed,
as no `COEX` matrix was calculated in the `COTAN` object,
but we can show that the *clusterization* is good even changing the
data reduction method, in this case the one from `scanpy`.

```{r clusterization-umap-plot-via-drm_merge_as-seurat}
c(umapPlot, .) %<-%
  cellsUMAPPlot(
    obj,
    clName = "merge",
    clusters = NULL,
    useCoexEigen = FALSE,
    dataMethod = "LogNormalized", # "AdjBinarized" is also a good choice
    numComp = 50L, # number of components of the data reduced matrix
    genesSel = "HVG_Scanpy",
    numGenes = 500L,
    colors = NULL, # a list of user defined colors for the various clusters
    numNeighbors = 30L, # UMAP related parameters
    minPointsDist = 0.3 # UMAP related parameters
  )

plot(umapPlot)
```


## Vignette clean-up stage

The next few lines are just to clean.

```{r clean-up}
if (file.exists(file.path(outDir, paste0(cond, ".cotan.RDS")))) {
  # delete file if it exists
  file.remove(file.path(outDir, paste0(cond, ".cotan.RDS")))
}
if (file.exists(file.path(outDir, paste0(cond, "_times.csv")))) {
  # delete file if it exists
  file.remove(file.path(outDir, paste0(cond, "_times.csv")))
}
if (dir.exists(file.path(outDir, cond))) {
  unlink(file.path(outDir, cond), recursive = TRUE)
}
# if (dir.exists(file.path(outDir, GEO))) {
#   unlink(file.path(outDir, GEO), recursive = TRUE)
# }

# stop logging to file
setLoggingFile("")
file.remove(file.path(outDir, "vignette_uniform_clustering.log"))

options(prevOptState)
```

```{r closure}
Sys.time()

sessionInfo()
```

---
title: "Guided tutorial to genes' clustering using COTAN"
author: 
- name: "Silvia Giulia Galfrè"
  affiliation: "Department of Computer Science, University of Pisa"
- name: "Marco Fantozzi"
  affiliation: "University of Parma"

package: COTAN
output:
  BiocStyle::html_document:
    keep_md: true
vignette: >
  %\VignetteIndexEntry{Genes' clustering using COTAN}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

## Preamble

```{r knitr options, echo = FALSE, include = FALSE}
plotDev <- if (requireNamespace("ragg", quietly = TRUE)) {
  "ragg_png"
} else if (requireNamespace("Cairo", quietly = TRUE)) {
  "cairo_png"
} else {
  "png"
}

knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  fig.width = 7L,
  fig.height = 5L,
  dev = plotDev,
  fig.crop = FALSE,
  dpi = 100L
)
```


```{r preamble, message=FALSE, warning=FALSE}
library(COTAN)
library(zeallot)

# necessary to solve precedence of overloads
conflicted::conflict_prefer("%<-%", "zeallot")

# enable multi-processing (not on Windows)
prevOptState <- options(parallelly.fork.enable = TRUE)
```

# Introduction

This tutorial shows the available tools in COTAN to help with genes' clustering

### Setup

Define a directory where the data and the output will be stored

```{r setup-and-log}
dataDir <- file.path(tempdir(), "COTAN_vignette_data")
dir.create(dataDir, recursive = TRUE, showWarnings = FALSE)

print(dataDir)

outDir <- dataDir

# Log-level 2 was chosen to showcase better how the package works
# In normal usage a level of 0 or 1 is more appropriate
setLoggingLevel(2L)

# This file will contain all the logs produced by the package
# as if at the highest logging level
setLoggingFile(file.path(outDir, "vignette_genes_clustering.log"))
```


## Retrieving the data-set

Download the data-set for `r "mouse cortex E17.5"` from
`r "Yuzwa et al."` (2017)

```{r download-data}
GEO <- "GSM2861514"

dir.create(file.path(dataDir, GEO), showWarnings = FALSE)

datasetFileName <-
  file.path(dataDir, GEO, "GSM2861514_E175_All_Cells_DGE.txt.gz")


# retries up to 5 times to get the dataset
attempts <- 0L
maxAttempts <- 5L
ok <- FALSE

while (attempts < maxAttempts && !ok) {
  attempts <- attempts + 1L

  if (!file.exists(datasetFileName)) {
    res <- try(
      GEOquery::getGEOSuppFiles(
        GEO = GEO,
        makeDirectory = TRUE,
        baseDir = dataDir,
        filter_regex = base::basename(datasetFileName),
        fetch_files = TRUE
      ),
      silent = TRUE
    )
  }

  ok <- file.exists(datasetFileName)

  if (!ok && attempts < maxAttempts) {
    Sys.sleep(1)
  }
}

assertthat::assert_that(
  ok,
  msg = paste0(
    "Failed to retrieve file '", datasetFileName,
    "' after ", maxAttempts, " attempts."
  )
)

rawDataset <- read.csv(datasetFileName, sep = "\t", row.names = 1L)

print(dim(rawDataset))
```

### Create the COTAN object

Initialize the `COTAN` object with the row count table and
the metadata from the experiment.

```{r create-cotan-object}
cond <- "mouse_cortex_E17.5"

obj <- COTAN(raw = rawDataset)
obj <-
  initializeMetaDataset(
    obj,
    GEO = GEO,
    sequencingMethod = "Drop_seq",
    sampleCondition = cond
  )

logThis(paste0("Condition ", getMetadataElement(obj, datasetTags()[["cond"]])),
        logLevel = 1L)
```

Assign to each cell its origin

```{r add-origin-to-the-cotan-object}
# mark cells origin
data(vignette.cells.origin)
head(vignette.cells.origin, 18)

obj <- 
  addCondition(obj, condName = "origin", conditions = vignette.cells.origin)

rm(vignette.cells.origin)
```


### Drop low quality cells

```{r drop-low-quality-cells}
# use previously established results to determine
# which cells were dropped in the cleaning stage
data(vignette.split.clusters)

cellsToDrop <-
  getCells(obj)[!(getCells(obj) %in% names(vignette.split.clusters))]

obj <- dropGenesCells(obj, cells = cellsToDrop)

# Log the remaining number of cells

logThis(paste("n cells", getNumCells(obj)), logLevel = 1L)

table(getCondition(obj, condName = "origin"))

rm(vignette.split.clusters)
```

# Establish genes' clusters

## COTAN analysis

In this part, the `COTAN` model is calibrated:
all the contingency tables are computed and used to get
the statistics necessary to `COEX` evaluation and storing

```{r calculate-and-store-coex-matrix}
obj <-
  proceedToCoex(
    obj,
    calcCoex = TRUE,
    optimizeForSpeed = TRUE,
    cores = 3L,
    deviceStr = "cuda"
  )
```

### Get data tables and stored `COEX` 

Sometimes we can also be interested in the numbers present directly in the
contingency tables for two specific genes.

```{r contingency-tables-and-coex-for-gene-pair}
cat("Contingency Tables:")
print(contingencyTables(obj, g1 = "Satb2", g2 = "Bcl11b"))

cat(paste("Corresponding COEX value:",
          getGenesCoex(obj, zeroDiagonal = FALSE)["Satb2", "Bcl11b"]))
```

Another useful function is `getGenesCoex()`. This can be used to extract
the whole or a partial `COEX` matrix from a `COTAN` object.

```{r display-small-chunk-of-coex-matrix}
# Extract the whole matrix
coex <- getGenesCoex(obj, zeroDiagonal = FALSE)
coex[1000L:1005L, 1000L:1005L]
```

```{r get-coex-sub-matrix}
# For a partial matrix
coex_sm <- getGenesCoex(obj, genes = c("Satb2", "Bcl11b", "Fezf2"),
                        zeroDiagonal = FALSE)
coex_sm[2001:2010, ]
```

## Analysis of the elaborated data: `GDI`

To calculate and store the *Global Differentiation Index* (`GDI`)
use the following:

```{r calculate-and-store-gdi}
gdiDF <- calculateGDI(obj, cores = 3L)

# Show the most *differentially expressed* genes
perm <- order(gdiDF[["GDI"]], decreasing = TRUE)
head(gdiDF[perm, ], n = 10)

# This will store only the $GDI column
obj <- storeGDI(obj, genesGDI = gdiDF)
```

The other two columns return the sum of the normalized data rows
and the percentage of cells expressing the gene respectively.

### Define genes lists

```{r genes-list-definition}
genesLists <- list(
  # Neural Progenitor Genes
  "NPGs" = c("Nes", "Vim", "Sox2", "Sox1", "Notch1", "Hes1", "Hes5", "Pax6"),
  # Pan Neural Genes
  "PNGs" = c("Map2", "Tubb3", "Neurod1", "Nefm", "Nefl", "Dcx", "Tbr1"),
  # House Keeping
  "hk"   = c("Calm1", "Cox6b1", "Ppia", "Rpl18", "Cox7c", "Erh", "H3f3a",
             "Taf1", "Taf2", "Gapdh", "Actb", "Golph3", "Zfr", "Sub1",
             "Tars", "Amacr")
)
```

### `GDI` Plot

The next function can either plot the `GDI` from the dataset directly or
use the already stored data.

It marks the given threshold 1.40 (in red) and
the 50% and 75% quantiles (in blue).
We can also specify some gene sets (three in this case) that
we want to label explicitly in the `GDI` plot.

```{r gdi-plot-with-marked-genes}
GDIPlot(obj, genes = genesLists, GDIThreshold = 1.40)
```

In the picture above it is possible to see how, as expected,
the house-keeping genes (`hk`) have generally a low `GDI` value.


### Store the calibrated object for future analysis

```{r save-cotan-obj, eval=FALSE}
# saving the structure
saveRDS(obj, file = file.path(outDir, paste0(cond, ".cotan.RDS")))
```


## Heatmaps

To perform the Gene Pair Analysis, we can plot a heatmap of the `COEX` values
between two gene sets.

We have to define the different gene sets (`list.genes`) in a list.
The first set will be used to define the columns;
then we can choose which sets to use in the function parameter sets
(for example, from 1 to 3).

```{r coex-heatmap-plot-for-selected-genes}
plot(heatmapPlot(obj, genesLists = genesLists, sets = 1L:3L, cores = 3L))
```


```{r define-layers-specific-genes}
layersGenes <- list(
  "L1"   = c("Reln",   "Lhx5"),
  "L2/3" = c("Cux1",   "Satb2"),
  "L4"   = c("Rorb",   "Sox5"),
  "L5/6" = c("Bcl11b", "Fezf2"),
  "Prog" = c("Hes1",    "Vim", "Dummy")
)
```

We can also plot a general heatmap of `COEX` values based on some markers like
the following one.

```{r coex-heatmap-plot-for-primary-marker-genes}
layersMarkers <- c("Satb2", "Bcl11b", "Vim", "Hes1")

genesHeatmapPlot(
  obj,
  primaryMarkers = layersMarkers,
  pValueThreshold = 0.0001,
  symmetric = TRUE,
  cores = 3L
)
```

```{r coex-heatmap-plot-two-genes-sets, eval=FALSE, include=TRUE}
genesHeatmapPlot(
  obj,
  primaryMarkers = c("Satb2", "Bcl11b", "Fezf2"),
  secondaryMarkers = c("Gabra3", "Meg3", "Cux1", "Neurod6"),
  pValueThreshold = 0.001,
  symmetric = FALSE,
  cores = 3L
)
```

## Establishing genes' clusters

`COTAN` provides a way to establish genes' clusters given some lists of markers

```{r establish-genes-clusters}
c(gSpace, eigPlot, pcaGenesClDF, treePlot) %<-%
  establishGenesClusters(
    obj,
    groupMarkers = layersGenes,
    numGenesPerMarker = 25L,
    kCuts = 5L
  )

plot(eigPlot)
```

```{r genes-tree-plot}
plot(treePlot)
```

### `UMAP` plot

```{r genes-umap-plot}
colSelection <- vapply(pcaGenesClDF, is.numeric, logical(1L))

genesUmapPl <-
  UMAPPlot(
    pcaGenesClDF[, colSelection, drop = FALSE],
    clusters = getColumnFromDF(pcaGenesClDF, "hclust"),
    elements = layersGenes,
    title = "Genes' clusters UMAP Plot",
    numNeighbors = 32L,
    minPointsDist = 0.25
  )

plot(genesUmapPl)
```


## Vignette clean-up stage

The next few lines are just to clean.

```{r final-clean-up}
if (file.exists(file.path(outDir, paste0(cond, ".cotan.RDS")))) {
  # delete file if it exists
  file.remove(file.path(outDir, paste0(cond, ".cotan.RDS")))
}
if (file.exists(file.path(outDir, paste0(cond, "_times.csv")))) {
  # delete file if it exists
  file.remove(file.path(outDir, paste0(cond, "_times.csv")))
}
if (dir.exists(file.path(outDir, cond))) {
  unlink(file.path(outDir, cond), recursive = TRUE)
}
# if (dir.exists(file.path(outDir, GEO))) {
#   unlink(file.path(outDir, GEO), recursive = TRUE)
# }

# stop logging to file
setLoggingFile("")
file.remove(file.path(outDir, "vignette_genes_clustering.log"))

options(prevOptState)
```

```{r closure}
Sys.time()

sessionInfo()
```

---
title: "Guided tutorial to datasets cleaning using COTAN"
author: 
- name: "Silvia Giulia Galfrè"
  affiliation: "Department of Computer Science, University of Pisa"
- name: "Marco Fantozzi"
  affiliation: "University of Parma"

package: COTAN
output:
  BiocStyle::html_document:
    keep_md: true
vignette: >
  %\VignetteIndexEntry{Cleaning tutorial using COTAN}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

## Preamble

```{r knitr options, echo = FALSE, include = FALSE}
plotDev <- if (requireNamespace("ragg", quietly = TRUE)) {
  "ragg_png"
} else if (requireNamespace("Cairo", quietly = TRUE)) {
  "cairo_png"
} else {
  "png"
}

knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  fig.width = 7L,
  fig.height = 5L,
  dev = plotDev,
  fig.crop = FALSE,
  dpi = 100L
)
```


```{r preamble, message=FALSE, warning=FALSE}
library(COTAN)
library(zeallot)

# necessary to solve precedence of overloads
conflicted::conflict_prefer("%<-%", "zeallot")

# enable multi-processing (not on Windows)
prevOptState <- options(parallelly.fork.enable = TRUE)
```

# Introduction

This tutorial shows the available tools in COTAN to help with datasets cleaning

### Setup

Define a directory where the data and the output will be stored.

```{r setup-and-log}
dataDir <- file.path(tempdir(), "COTAN_vignette_data")
dir.create(dataDir, recursive = TRUE, showWarnings = FALSE)

print(dataDir)

outDir <- dataDir

# Log-level 2 was chosen to showcase better how the package works
# In normal usage a level of 0 or 1 is more appropriate
setLoggingLevel(2L)

# This file will contain all the logs produced by the package
# as if at the highest logging level
setLoggingFile(file.path(outDir, "vignette_dataset_cleaning.log"))
```

## Retrieving the data-set

Download the data-set for `r "mouse cortex E17.5"` from
`r "Yuzwa et al."` (2017)

```{r download-data}
GEO <- "GSM2861514"

dir.create(file.path(dataDir, GEO), showWarnings = FALSE)

datasetFileName <-
  file.path(dataDir, GEO, "GSM2861514_E175_All_Cells_DGE.txt.gz")

# retries up to 5 times to get the dataset
attempts <- 0L
maxAttempts <- 5L
ok <- FALSE

while (attempts < maxAttempts && !ok) {
  attempts <- attempts + 1L

  if (!file.exists(datasetFileName)) {
    res <- try(
      GEOquery::getGEOSuppFiles(
        GEO = GEO,
        makeDirectory = TRUE,
        baseDir = dataDir,
        filter_regex = base::basename(datasetFileName),
        fetch_files = TRUE
      ),
      silent = TRUE
    )
  }

  ok <- file.exists(datasetFileName)

  if (!ok && attempts < maxAttempts) {
    Sys.sleep(1)
  }
}

assertthat::assert_that(
  ok,
  msg = paste0(
    "Failed to retrieve file '", datasetFileName,
    "' after ", maxAttempts, " attempts."
  )
)

rawDataset <- read.csv(datasetFileName, sep = "\t", row.names = 1L)

print(dim(rawDataset))
```

### Create the COTAN object

Initialize the `COTAN` object with the row count table and
the metadata from the experiment.

```{r create-cotan-object}
cond <- "mouse_cortex_E17.5"

obj <- COTAN(raw = rawDataset)
obj <-
  initializeMetaDataset(
    obj,
    GEO = GEO,
    sequencingMethod = "Drop_seq",
    sampleCondition = cond
  )

logThis(paste0("Condition ", getMetadataElement(obj, datasetTags()[["cond"]])),
        logLevel = 1L)
```

#### Alternative ways to create a COTAN object

It is also possible to create a `COTAN` object starting from a
`SingleCellExperiment` object (and vice-versa).

Note that default patterns try to look-up in the most common locations...

```{r conversions-to-and-from-sce}
sceObj <- convertToSingleCellExperiment(obj)

obj2 <- convertFromSingleCellExperiment(
  sceObj,
  assayName = "counts",   # the assay that contains the raw counts
  genesNamesPattern = "", # reg-exp to identify genes' names column
  cellsIDsPattern = "",   # reg-exp to identify cells' ID column
  clNamesPattern = "",    # reg-exp to identify clusterizations columns
  condNamesPattern = ""   # reg-exp to identify cells' conditions columns
)

rm(sceObj, obj2)
```

### Assign to each cell its origin

```{r add-origin-to-the-cotan-object}
# mark cells origin
data(vignette.cells.origin)
head(vignette.cells.origin, 18)

obj <- 
  addCondition(obj, condName = "origin", conditions = vignette.cells.origin)

rm(vignette.cells.origin)

# Sometimes the condition is encoded in the cells ID using some separator
# so it is useful to use the following function to retrieve it
if (FALSE) { # This is not the case with the dataset currently in use
  batch <- COTAN::conditionsFromNames(
    names = getCells(obj), splitPattern = "_", fragmentNum = 2L)
  names(batch) <- getCells(obj)
  obj <- addCondition(obj, condName = "batch", conditions = batch)
}
```

# Data cleaning

Before proceeding with the analysis, it might be necessary to clean the data.

The analysis uses a matrix of raw `UMI` counts as the input.
However the given raw data might not satisfy the needed minimal quality
requirements: it is better to remove any potential cell doublets or
multiplets, as well as any low quality or dying cells.

## Plots from the raw counts

We can check the library size (`UMI` number) with an *Empirical Cumulative
Distribution* function discriminating the cells by their origin

Please note that in the following plots it is **not** necessary
to specify a *condition*

```{r ecd-plot}
plot(ECDPlot(obj, condName = "origin"))
```

The we can also plot directly the distribution of the library size

```{r cells-size-plot}
plot(cellSizePlot(obj, condName = "origin"))
```

and we can plot the distribution of the number of detected genes in each cell,
useful to identify possible doublets

```{r number-detected-genes}
plot(genesSizePlot(obj, condName = "origin"))
```

As last plot we can check the scatter plot between the library size and
the number of detected genes: cells far away from the main group are usually
problematic

```{r scatter-plot}
plot(scatterPlot(obj, condName = "origin"))
```

## Dropping problematic cells

During the cleaning, every time we want to remove cells or genes
we can use the `dropGenesCells()` function.

Drop cells with too many reads as they are probably doublets or multiplets
and show the updated plot 

```{r cull-probable-doublets}
# Store the used threshold in the COTAN object for later reference
cellsSizeThr <- 6000L
obj <- addElementToMetaDataset(obj, "Cells size threshold", cellsSizeThr)

cellsToRem <- getCells(obj)[getCellsSize(obj) > cellsSizeThr]
obj <- dropGenesCells(obj, cells = cellsToRem)

plot(cellSizePlot(obj, condName = "origin"))
```

To drop cells by gene number: high genes count might also indicate doublets...

```{r cull-probable-doublets_2}
# Store the used threshold in the COTAN object for later reference
genesSizeHighThr <- 3000L
obj <-
  addElementToMetaDataset(obj, "Num genes high threshold", genesSizeHighThr)

cellsToRem <- getCells(obj)[getNumExpressedGenes(obj) > genesSizeHighThr]
obj <- dropGenesCells(obj, cells = cellsToRem)

plot(genesSizePlot(obj, condName = "origin"))
```

Drop cells with too low genes expression as they are probably dead

```{r cull-probable-dead-cells}
# Store the used threshold in the COTAN object for later reference
genesSizeLowThr <- 500L
obj <- addElementToMetaDataset(obj, "Num genes low threshold", genesSizeLowThr)

cellsToRem <- getCells(obj)[getNumExpressedGenes(obj) < genesSizeLowThr]
obj <- dropGenesCells(obj, cells = cellsToRem)

plot(genesSizePlot(obj, condName = "origin"))
```


Cells with a too high percentage of mitochondrial genes are
likely dead (or at the last problematic) cells. So we drop them!

```{r calculate-mitochondrial-genes-percentage}
c(mitPlot, mitSizes) %<-%
  mitochondrialPercentagePlot(obj, genePrefix = "^mt-", condName = "origin")

plot(mitPlot)
```

```{r cull-probable-dead-cells_2}
# Store the used threshold in the COTAN object for later reference
mitPercThr <- 3.5
obj <- addElementToMetaDataset(obj, "Mitoc. perc. threshold", mitPercThr)

cellsToRem <- rownames(mitSizes)[mitSizes[["mit.percentage"]] > mitPercThr]
obj <- dropGenesCells(obj, cells = cellsToRem)

c(mitPlot, mitSizes) %<-%
  mitochondrialPercentagePlot(obj, genePrefix = "^mt-", condName = "origin")

plot(mitPlot)
```

As last plot we can check the scatter plot between the library size and
the number of detected genes: cells far away from the main group are usually
problematic

```{r scatter-plot_2}
plot(scatterPlot(obj, condName = "origin"))
```

We want also to log the current status.

```{r log-current-dataset-status}
logThis(paste("n cells", getNumCells(obj)), logLevel = 1L)

getDims(obj)
```

The `clean()` function estimates the `nu` parameters from the data and drops
genes/cells that do not satisfy the minimal expression thresholds.
Therefore, it need to be run again every time any genes or cells are dropped
from the data.

```{r calculate-b-group-from-pca}
obj <- addElementToMetaDataset(obj, "Num drop B group", 0L)

obj <- clean(obj)

c(pcaCellsPlot, pcaCellsData, genesPlot,
  UDEPlot, nuPlot, zoomedNuPlot) %<-% cleanPlots(obj)

plot(pcaCellsPlot)
```

The above plot shows a sub-group of cells `B` that is somewhat distinct from
the other cells
With the plot below it is possible to see the most expressed genes
in the cells of the `B` group

```{r show-most-expressed-genes-b-group}
plot(genesPlot)
```

To color the PCA based on `nu` (so the cells' efficiency)

```{r cells-efficiency-pca-plot}
plot(UDEPlot)
```

`UDE` (color) should **not** correlate with principal components!
This is very important.

The next part is used to remove the cells with efficiency too low.

```{r cells-efficiency-plot}
plot(nuPlot)
```

We can zoom on the smallest values and, if COTAN detects a clear elbow,
we can decide to remove the cells.

```{r cells-efficiency-plot_low-tail}
plot(zoomedNuPlot)
```

We can observe here that the `B` group cells are really enriched in hemoglobin
genes so we prefer to remove them.
They can be extracted from the `pcaCellsData` object and removed.

```{r cull-b-group-and-recalculate}
cellsToRem <- rownames(pcaCellsData)[pcaCellsData[["groups"]] == "B"]
obj <- dropGenesCells(obj, cells = cellsToRem)

# Store how many times the B group was dropped
obj <- addElementToMetaDataset(obj, "Num drop B group", 1L)
```

We also save the defined threshold in the metadata and re-run the estimation

```{r cull-low-efficiency-cells}
udeLowThr <- 0.34
obj <- addElementToMetaDataset(obj, "Low UDE cells' threshold", udeLowThr)

obj <- estimateNuLinear(obj)

cellsToRem <- getCells(obj)[getNu(obj) < udeLowThr]
obj <- dropGenesCells(obj, cells = cellsToRem)
```

### Check all good

We repeat all the plots now that the *low quality* cells are removed
In many practical cases the last few steps are repeated multiple times until 
deemed appropriate

```{r raw-plots}
plot(ECDPlot(obj, condName = "origin"))

plot(cellSizePlot(obj, condName = "origin"))

plot(genesSizePlot(obj, condName = "origin"))

plot(scatterPlot(obj, condName = "origin"))

c(mitPlot, mitSizes) %<-%
  mitochondrialPercentagePlot(obj, genePrefix = "^mt-", condName = "origin")

plot(mitPlot)
```

Then we rerun also the cleaning and associated plots and
notice that all is essentially fine

```{r recalculate-clean-plots}
obj <- clean(obj)

c(pcaCellsPlot, pcaCellsData, genesPlot,
  UDEPlot, nuPlot, zoomedNuPlot) %<-% cleanPlots(obj)
```

```{r show-clean-plots}
plot(pcaCellsPlot)

plot(genesPlot)

plot(UDEPlot)

plot(nuPlot)
plot(zoomedNuPlot)

# It is also possible to directly plot the PCA results
plot(pcaCellsData)
```

Log the remaining number of cells

```{r log-updated-dataset-status}
logThis(paste("n cells", getNumCells(obj)), logLevel = 1L)

table(getCondition(obj, condName = "origin"))
```

## Vignette clean-up stage

The next few lines are just to clean.

```{r final-clean-up}
if (file.exists(file.path(outDir, paste0(cond, ".cotan.RDS")))) {
  # delete file if it exists
  file.remove(file.path(outDir, paste0(cond, ".cotan.RDS")))
}
if (file.exists(file.path(outDir, paste0(cond, "_times.csv")))) {
  # delete file if it exists
  file.remove(file.path(outDir, paste0(cond, "_times.csv")))
}
if (dir.exists(file.path(outDir, cond))) {
  unlink(file.path(outDir, cond), recursive = TRUE)
}
# if (dir.exists(file.path(outDir, GEO))) {
#   unlink(file.path(outDir, GEO), recursive = TRUE)
# }

# stop logging to file
setLoggingFile("")
file.remove(file.path(outDir, "vignette_dataset_cleaning.log"))

options(prevOptState)
```

```{r closure}
Sys.time()

sessionInfo()
```

---
title: "Guided tutorial to Differential Expression Analysis using COTAN"
author: 
- name: "Silvia Giulia Galfrè"
  affiliation: "Department of Computer Science, University of Pisa"
- name: "Marco Fantozzi"
  affiliation: "University of Parma"

package: COTAN
output:
  BiocStyle::html_document:
    keep_md: true
vignette: >
  %\VignetteIndexEntry{DEA using COTAN}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

## Preamble

```{r knitr options, echo = FALSE, include = FALSE}
plotDev <- if (requireNamespace("ragg", quietly = TRUE)) {
  "ragg_png"
} else if (requireNamespace("Cairo", quietly = TRUE)) {
  "cairo_png"
} else {
  "png"
}

knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  fig.width = 7L,
  fig.height = 5L,
  dev = plotDev,
  fig.crop = FALSE,
  dpi = 100L
)
```

```{r preamble, message=FALSE, warning=FALSE}
library(COTAN)
library(zeallot)

# necessary to solve precedence of overloads
conflicted::conflict_prefer("%<-%", "zeallot")

# enable multi-processing (not on Windows)
prevOptState <- options(parallelly.fork.enable = TRUE)
```

# Introduction

This tutorial shows the available tools in COTAN to help with genes' clustering

### Setup

Define a directory where the data and the output will be stored

```{r setup-and-log}
dataDir <- file.path(tempdir(), "COTAN_vignette_data")
dir.create(dataDir, recursive = TRUE, showWarnings = FALSE)

print(dataDir)

outDir <- dataDir

# Log-level 2 was chosen to showcase better how the package works
# In normal usage a level of 0 or 1 is more appropriate
setLoggingLevel(2L)

# This file will contain all the logs produced by the package
# as if at the highest logging level
setLoggingFile(file.path(outDir, "vignette_DEA.log"))
```

## Retrieving the data-set

Download the data-set for `r "mouse cortex E17.5"` from
`r "Yuzwa et al."` (2017)

```{r download-data}
GEO <- "GSM2861514"

dir.create(file.path(dataDir, GEO), showWarnings = FALSE)

datasetFileName <-
  file.path(dataDir, GEO, "GSM2861514_E175_All_Cells_DGE.txt.gz")


# retries up to 5 times to get the dataset
attempts <- 0L
maxAttempts <- 5L
ok <- FALSE

while (attempts < maxAttempts && !ok) {
  attempts <- attempts + 1L

  if (!file.exists(datasetFileName)) {
    res <- try(
      GEOquery::getGEOSuppFiles(
        GEO = GEO,
        makeDirectory = TRUE,
        baseDir = dataDir,
        filter_regex = base::basename(datasetFileName),
        fetch_files = TRUE
      ),
      silent = TRUE
    )
  }

  ok <- file.exists(datasetFileName)

  if (!ok && attempts < maxAttempts) {
    Sys.sleep(1)
  }
}

assertthat::assert_that(
  ok,
  msg = paste0(
    "Failed to retrieve file '", datasetFileName,
    "' after ", maxAttempts, " attempts."
  )
)

rawDataset <- read.csv(datasetFileName, sep = "\t", row.names = 1L)

print(dim(rawDataset))
```

### Create the COTAN object

Initialize the `COTAN` object with the row count table and
the metadata from the experiment.

```{r create-cotan-object}
cond <- "mouse_cortex_E17.5"

obj <- COTAN(raw = rawDataset)
obj <-
  initializeMetaDataset(
    obj,
    GEO = GEO,
    sequencingMethod = "Drop_seq",
    sampleCondition = cond
  )

logThis(paste0("Condition ", getMetadataElement(obj, datasetTags()[["cond"]])),
        logLevel = 1L)
```

Assign to each cell its origin

```{r add-origin-to-the-cotan-object}
# mark cells origin
data(vignette.cells.origin)
head(vignette.cells.origin, 18)

obj <- 
  addCondition(obj, condName = "origin", conditions = vignette.cells.origin)

rm(vignette.cells.origin)
```

### Drop low quality cells

```{r drop-low-quality-cells}
# use previously established results to determine
# which cells were dropped in the cleaning stage
data(vignette.split.clusters)

cellsToDrop <-
  getCells(obj)[!(getCells(obj) %in% names(vignette.split.clusters))]

obj <- dropGenesCells(obj, cells = cellsToDrop)

# Log the remaining number of cells

logThis(paste("n cells", getNumCells(obj)), logLevel = 1L)

table(getCondition(obj, condName = "origin"))

rm(vignette.split.clusters)
```

## COTAN analysis

In this part, the `COTAN` model is calibrated, but the `COEX` matrix
is not evaluated as it is not strictly necessary

```{r calculate-and-store-coex-matrix}
obj <-
  proceedToCoex(
    obj,
    calcCoex = FALSE,
    optimizeForSpeed = TRUE,
    cores = 3L,
    deviceStr = "cuda"
  )
```

# Differential Expression Analysis

TODO:

### Existing clusterizations

Loading pre-calculated *clusterizations* from data and call the
`DEAOnClusters()`. This method estimates assess the differential expression of
genes when partitioning cells into two subsets: the cluster and all other cells
in the dataset.
For each cluster `COTAN` calculates a *correlation coefficient* based on
contingency tables that counts whether each gene occurs or not in cells inside
or outside of the cluster.

These numbers are organized as one column for each cluster with a row for each
gene and are a measure of the enrichment or depletion of the genes inside the
clusters.

```{r load-pre-calculated-clusterizations}
data("vignette.split.clusters", package = "COTAN")
data("vignette.merge.clusters", package = "COTAN")

vignette.split.clusters <-
  asClusterization(
    vignette.split.clusters, # a named vector/factor/data.frame
    allCells = getCells(obj) # used only to check names are coherent
  )
vignette.merge.clusters <-
  asClusterization(
    vignette.merge.clusters, # a named vector/factor/data.frame
    allCells = getCells(obj) # used only to check names are coherent
  )

# explicitly calculate the DEA of the clusterization to store it
vignette.split.coexDF <-
  DEAOnClusters(obj, clusters = vignette.split.clusters)
vignette.merge.coexDF <-
  DEAOnClusters(obj, clusters = vignette.merge.clusters)

obj <-
  addClusterization(
    obj,
    clName = "split",
    clusters = vignette.split.clusters,
    coexDF = vignette.split.coexDF,
    override = FALSE
  )

obj <-
  addClusterization(
    obj,
    clName = "merge",
    clusters = vignette.merge.clusters,
    coexDF = vignette.merge.coexDF,
    override = FALSE
  )

# these will be recovered from the COTAN obj as needed
rm(vignette.split.clusters, vignette.split.coexDF)
rm(vignette.merge.clusters, vignette.merge.coexDF)
```

## How to manipulate a clusterization

It is possible to improve on the labels in a *clusterization*, so that they
look nicer in plots and lists, for example to ensure all labels have
the **same** length.

Another improvement is to reorder the labels of the *clusterization* so that
*near* clusters have *near* labels

```{r extract-clusterizations}
# COTAn always stores clusterizations as factors.
splitClusters <- getClusters(obj, clName = "split")

# Use the utility factorToVector() to properly decay any named factor
# to a named char array
# splitClusters <- factorToVector(splitClusters)

# In this case the following calls are no-op since the clusterization
# were created by COTAN and so they already made nice and reordered

splitClusters <- niceFactorLevels(splitClusters)

c(splitClusters, splitCoexDF, perm) %<-% 
  reorderClusterization(
    obj,
    clName = "split",
    reverse = FALSE, 
    coexDF = NULL,
    useDEA = TRUE, # T: Cosine dist. on DEA, F: Eucl. dist. on avg. zero/one
    distance = NULL,
    hclustMethod = "ward.D2"
  )

mergeClusters <- getClusters(obj, clName = "merge")

table(splitClusters, mergeClusters)
```

`COTAN` provides also easy facility to convert a *clusterization* from a
*factor* to a *list* of *array* of cells and vice-versa.
This can come useful if one wants to iterate separately
on the cells of each cluster.

```{r clusterization-manipulation}
# this has an inverse `fromClustersList()`
splitClustersAsList <- toClustersList(splitClusters)

assertthat::assert_that(length(splitClustersAsList) == nlevels(splitClusters))

splitClustersOrigin <-
  rlang::set_names(
    rlang::rep_along(x = NA_character_, along = splitClustersAsList),
    names(splitClustersAsList)
  )

origin <- getCondition(obj, "origin")

for (clName in names(splitClustersAsList)) {
  cluster <- splitClustersAsList[[clName]]

  # assign most common origin to the cluster
  splitClustersOrigin[[clName]] <- names(which.max(table(origin[cluster])))

  # print the average non-zero expression in the cluster
  clRawData <- getRawData(obj)[, cluster, drop = FALSE]
  clRawData <- clRawData[clRawData > 0.0]

  cat(
    paste("Cluster", clName, "of", splitClustersOrigin[[clName]],
          "\torigin - average non-zero expression:", mean(clRawData)), "\n")

  rm(clRawData)
}

# If one needs to reorder the cells by cluster,
# labels are ordered as in the clusterization
orderCellsByMergeCluster <- groupByClusters(mergeClusters)

plot(getNumExpressedGenes(obj)[orderCellsByMergeCluster],
     ylab = "Num expressed genes", xlab = NA_character_)

mergeClustersAsList <- toClustersList(mergeClusters)

mergeClustersOrigin <- 
  vapply(
    mergeClustersAsList,
    \(cluster, origin) {
      names(which.max(table(origin[cluster])))
    },
    FUN.VALUE = character(1L),
    origin
  )
names(mergeClustersOrigin) <- names(mergeClustersAsList)


# It is also possible to reorder a subset of cells using
orderCellsBySomeMergeClusters <- 
  groupByClustersList(
    getCells(obj),
    mergeClustersAsList[c(2, 4, 6)]
  )

plot(getNumExpressedGenes(obj)[orderCellsBySomeMergeClusters],
     ylab = "Library Size", xlab = NA_character_)
```

### Clusters dendogram

It is possible to create a *dendogram* of the *clusterization* that uses
a cluster distance based on the clusters' `COEX`.

```{r clusters-in-a-tree}
treePlot <-
  clustersTreePlot(
    obj,
    kCuts = 2L,
    clName = "split",
    useDEA = TRUE  # T: Cosine dist. on DEA, F: Eucl. dist. on avg. zero/one
  )[["dend"]]

plot(treePlot)

# use origin to mark the clusters
dendextend::labels(treePlot) <- splitClustersOrigin[base::labels(treePlot)]

plot(treePlot)
```

It is easy to see that the dendogram splits according to origin except for
cluster `07` that is deemed more similar to the some of the non `cortical`
cells.

## Relevance of given marker genes

It is possible to visualize how relevant are some *marker genes* for the
clusters comprising a given *clusterization*

```{r define-specific-genes-lists}
# these are some genes associated to each cortical layer
layersGenes <- list(
  "L1"   = c("Reln",   "Lhx5"),
  "L2/3" = c("Cux1",   "Satb2"),
  "L4"   = c("Rorb",   "Sox5"),
  "L5/6" = c("Bcl11b", "Fezf2"),
  "Prog" = c("Hes1",    "Vim")
)

neuralTypeGenes <- list(
  # Neural Progenitor Genes
  "NPGs" = c("Nes", "Vim", "Sox2", "Sox1", "Notch1", "Hes1", "Hes5", "Pax6"),
  # Pan Neural Genes
  "PNGs" = c("Map2", "Tubb3", "Neurod1", "Nefm", "Nefl", "Dcx", "Tbr1"),
  # House Keeping
  "hk"   = c("Calm1", "Cox6b1", "Ppia", "Rpl18", "Cox7c", "Erh", "H3f3a",
             "Taf1", "Taf2", "Gapdh", "Actb", "Golph3", "Zfr", "Sub1",
             "Tars", "Amacr")
)
```

The following is one of the most comprehensive plot available in `COTAN` to
visually summarize whether any of the given genes is strongly over/under
expressed in the clusters. The heat-map shows the `COEX` score and the
characters signal the corresponding adjusted p-value:
`***` for *p* \< 0.001, `**` for *p* \< 0.01,
`*` for *p* \< 0.05, `.` for *p* \< 0.1.

On the left it also allows to see how much each cluster is characterized by the
passed conditions.

```{r clusterization-data-visualization, fig.height=8, fig.width=20}
c(splitHeatmap, splitScoreDF, splitPValueDF) %<-%
  clustersMarkersHeatmapPlot(
    obj,
    groupMarkers = layersGenes,
    clName = "split",
    kCuts = 2L,
    adjustmentMethod = "bonferroni",
    condNameList = list("origin")
  )

ComplexHeatmap::draw(splitHeatmap)

c(mergeHeatmap, mergeScoreDF, mergePValueDF) %<-%
  clustersMarkersHeatmapPlot(
    obj,
    groupMarkers = neuralTypeGenes,
    clName = "merge",
    kCuts = 3L,
    adjustmentMethod = "bonferroni",
    condNameList = list("origin")
  )

ComplexHeatmap::draw(mergeHeatmap)
```

In the above graph, it is possible to see that the found clusters align well to
the expression of the layers' genes. Again it is possible to see that cluster
`07` of the `"split"` *clusterization* (`05` of the `"merge"`) is likely
composed by a **progenitor** cells instead of **mature layers** cells, like it
happens for cluster `08` and `09` (`06` of the `"merge"`) even if they have
supposedly different *origin*.


## Find differentially expressed genes

The following function uses the calculated clusters' `COEX` to select, for
each cluster, the *n* genes that are over-expressed and the *n* genes that are
under-expressed with respect to a neutral model assumption.

For each gene found, the function returns the `COEX` value,
the adjusted *p-value* and the log-fold-change.
It also flags whether the found gene is one of the markers
provided by the user.

```{r find-marge-markers}
mergeClusterMarkers <-
  findClustersMarkers(
    obj,
    clName = "merge",
    n = 5L,
    markers = unlist(layersGenes),
    adjustmentMethod = "bonferroni"
  )

foundMarkers <- list()

# All relevant genes with strong `p-values`
geneIsEnriched <- mergeClusterMarkers[, "adjPVal"] < 1e-10

for (clName in levels(mergeClusters)) {
  geneIsInCluster <- mergeClusterMarkers[, "CL"] == clName
  foundMarkers[[clName]] <-
    mergeClusterMarkers[geneIsEnriched & geneIsInCluster, "Gene", drop = TRUE]
}

# number of genes per cluster
lengths(foundMarkers)
```


### Relevance of marker genes for the `merge` clusters

Again, it is possible to visualize how relevant are the *marker genes* from
above:

```{r cl-data-visualization_found-markers, fig.height=8, fig.width=20}
c(mergeHeatmap, ..) %<-%
  clustersMarkersHeatmapPlot(
    obj,
    groupMarkers = foundMarkers,
    clName = "merge",
    condNameList = list("origin")
  )

ComplexHeatmap::draw(mergeHeatmap)
```

## DEA cluster vs. cluster

Sometimes it is useful to compare the genes' expression of a pair of clusters.

In such cases the simplest thing to do is to *drop* all other cells so to
obtain a leaner `COTAN` object with just the 2 clusters and then use the
procedures shown above to analyze the resulting object.

```{r create-sub-object}
# We will focus on the clusters `03` (likely part of layers 5/6) and
# `05` (likely part of layers 2/3) of the `split` clusterization

cellsToDrop <- getCells(obj)[!(splitClusters %in% c("03", "05"))]

obj2 <- dropGenesCells(obj, cells = cellsToDrop)

obj2 <- proceedToCoex(obj2, calcCoex = FALSE)

table(getClusters(obj2, clName = "split"))
```

```{r plot-sub-object-cluster-data, eval=FALSE, include=TRUE}
# this does not give more information than the same full-plot above

c(splitHeatmap2, ., .) %<-%
  clustersMarkersHeatmapPlot(
    obj2,
    groupMarkers = layersGenes,
    clName = "split",
    kCuts = 2L,
    adjustmentMethod = "bonferroni"
  )

ComplexHeatmap::draw(splitHeatmap2)
```

In the case of only two clusters, over-expressed genes in a cluster correspond
exactly to under-expressed genes in the other,
so one can just look at the former 

```{r find-sub-object-markers}
deaMarkers <- findClustersMarkers(
  obj2,
  n = 10L,
  clName = "split",
  adjustmentMethod = "bonferroni",
  markers = layersGenes[c("L2/3", "L5/6")]
)

# over-expressed genes follow the under-expressed ones
deaMarkers[11:20, ]
deaMarkers[31:40, ]
```

We can see that in this case we recover the layers genes.


## Vignette clean-up stage

The next few lines are just to clean.

```{r clean-up}
if (file.exists(file.path(outDir, paste0(cond, ".cotan.RDS")))) {
  # delete file if it exists
  file.remove(file.path(outDir, paste0(cond, ".cotan.RDS")))
}
if (file.exists(file.path(outDir, paste0(cond, "_times.csv")))) {
  # delete file if it exists
  file.remove(file.path(outDir, paste0(cond, "_times.csv")))
}
if (dir.exists(file.path(outDir, cond))) {
  unlink(file.path(outDir, cond), recursive = TRUE)
}
# if (dir.exists(file.path(outDir, GEO))) {
#   unlink(file.path(outDir, GEO), recursive = TRUE)
# }

# stop logging to file
setLoggingFile("")
file.remove(file.path(outDir, "vignette_uniform_clustering.log"))

options(prevOptState)
```

```{r closure}
Sys.time()

sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/COTAN-estimators.R, R/COTAN-getters.R
\name{ParametersEstimations}
\alias{ParametersEstimations}
\alias{estimateLambdaLinear,COTAN-method}
\alias{estimateLambdaLinear}
\alias{estimateNuLinear,COTAN-method}
\alias{estimateNuLinear}
\alias{estimateDispersionViaSolver,COTAN-method}
\alias{estimateDispersionViaSolver}
\alias{estimateDispersionBisection}
\alias{estimateNuBisection,COTAN-method}
\alias{estimateNuBisection}
\alias{estimateDispersionNuBisection,COTAN-method}
\alias{estimateDispersionNuBisection}
\alias{estimateDispersionNuNlminb,COTAN-method}
\alias{estimateDispersionNuNlminb}
\alias{getNu,COTAN-method}
\alias{getNu}
\alias{getLambda,COTAN-method}
\alias{getLambda}
\alias{getDispersion,COTAN-method}
\alias{getDispersion}
\alias{estimatorsAreReady}
\alias{getNuNormData}
\alias{getLogNormData}
\alias{getNormalizedData}
\alias{getProbabilityOfZero}
\title{Estimation of the \code{COTAN} model's parameters}
\usage{
\S4method{estimateLambdaLinear}{COTAN}(objCOTAN)

\S4method{estimateNuLinear}{COTAN}(objCOTAN)

\S4method{estimateDispersionViaSolver}{COTAN}(
  objCOTAN,
  threshold = 0.001,
  cores = 1L,
  maxIterations = 100L,
  chunkSize = 1024L
)

\S4method{estimateNuBisection}{COTAN}(
  objCOTAN,
  threshold = 0.001,
  cores = 1L,
  maxIterations = 100L,
  chunkSize = 1024L
)

\S4method{estimateDispersionNuBisection}{COTAN}(
  objCOTAN,
  threshold = 0.001,
  cores = 1L,
  maxIterations = 100L,
  chunkSize = 1024L,
  enforceNuAverageToOne = TRUE
)

\S4method{estimateDispersionNuNlminb}{COTAN}(
  objCOTAN,
  threshold = 0.001,
  maxIterations = 50L,
  chunkSize = 1024L,
  enforceNuAverageToOne = TRUE
)

\S4method{getNu}{COTAN}(objCOTAN)

\S4method{getLambda}{COTAN}(objCOTAN)

\S4method{getDispersion}{COTAN}(objCOTAN)

estimatorsAreReady(objCOTAN)

getNuNormData(objCOTAN)

getLogNormData(objCOTAN)

getNormalizedData(objCOTAN, retLog = FALSE)

getProbabilityOfZero(objCOTAN)
}
\arguments{
\item{objCOTAN}{a \code{COTAN} object}

\item{threshold}{minimal solution precision}

\item{cores}{number of cores to use. Default is 1.}

\item{maxIterations}{max number of iterations (avoids infinite loops)}

\item{chunkSize}{number of elements to solve in batch in a single core.
Default is 1024.}

\item{enforceNuAverageToOne}{a Boolean on whether to keep the average \code{nu}
equal to 1}

\item{retLog}{When \code{TRUE} calls \code{\link[=getLogNormData]{getLogNormData()}}, calls \code{\link[=getNuNormData]{getNuNormData()}}}
}
\value{
\code{estimateLambdaLinear()} returns the updated \code{COTAN} object

\code{estimateNuLinear()} returns the updated \code{COTAN} object

\code{estimateDispersionViaSolver()} returns the updated \code{COTAN} object

\code{estimateNuBisection()} returns the updated \code{COTAN} object

\code{estimateDispersionNuBisection()} returns the updated \code{COTAN} object

\code{estimateDispersionNuNlminb()} returns the updated \code{COTAN} object

\code{getNu()} returns the \code{nu} array

\code{getLambda()} returns the \code{lambda} array

\code{getDispersion()} returns the \code{dispersion} array

\code{estimatorsAreReady()} returns a boolean specifying whether all
three arrays are non-empty

\code{getNuNormData()} returns the \eqn{\nu}\emph{-normalized} count
\code{data.frame}

\code{getLogNormData()} returns a \code{data.frame} after applying the formula
\eqn{\log_{10}{(10^4 * x + 1)}} to the raw counts normalized by
\emph{cells-size}

\code{getNormalizedData()} returns a \code{data.frame}

\code{getProbabilityOfZero()} returns a \code{data.frame} with the
probabilities of zero
}
\description{
These functions are used to estimate the \code{COTAN} model's
parameters. That is the average count for each gene (\code{lambda}) the average
count for each cell (\code{nu}) and the \code{dispersion} parameter for each gene to
match the probability of zero.

The estimator methods are named \code{Linear} if they can be calculated as a
linear statistic of the raw data or \code{Bisection} if they are found via a
parallel bisection solver.
}
\details{
\code{estimateLambdaLinear()} does a linear estimation of \code{lambda}
(genes' counts averages)

\code{estimateNuLinear()} does a linear estimation of \code{nu} (normalized
cells' counts averages)

\code{estimateDispersionViaSolver()} estimates the negative binomial
dispersion factor for each gene (\code{dispersion}). Determines the value such
that, for each gene, the probability of zero count matches the number of
observed zeros. It assumes \code{\link[=estimateNuLinear]{estimateNuLinear()}} being already run.

\code{estimateNuBisection()} estimates the \code{nu} vector of a \code{COTAN}
object by bisection. It determines the \code{nu} parameters such that, for each
cell, the probability of zero counts matches the number of observed zeros.
It assumes \code{\link[=estimateDispersionViaSolver]{estimateDispersionViaSolver()}} being already run. Since this
breaks the assumption that the average \code{nu} is one, it is recommended not
to run this in isolation but use \code{\link[=estimateDispersionNuBisection]{estimateDispersionNuBisection()}} instead.

\code{estimateDispersionNuBisection()} estimates the \code{dispersion} and
\code{nu} field of a \code{COTAN} object by running sequentially a bisection for each
parameter.

\code{estimateDispersionNuNlminb()} estimates the \code{nu} and
\code{dispersion} parameters to minimize the discrepancy between the observed
and expected probability of zero. It uses the \code{\link[stats:nlminb]{stats::nlminb()}} solver,
but since the joint parameters have too high dimensionality, it converges
too slowly to be actually useful in real cases.

\code{getNu()} extracts the \code{nu} array (normalized cells' counts
averages)

\code{getLambda()} extracts the \code{lambda} array (mean expression for each
gene)

\code{getDispersion()} extracts the \code{dispersion} array (one value for
each gene)

\code{estimatorsAreReady()} checks whether the estimators arrays
\code{lambda}, \code{nu}, \code{dispersion} are available

\code{getNuNormData()} extracts the \eqn{\nu}\emph{-normalized} count table
(i.e. where each column is divided by \code{nu}) and returns it

\code{getLogNormData()} extracts the \emph{log-normalized} count table (i.e.
where each column is divided by the \code{\link[=getCellsSize]{getCellsSize()}}), takes its \code{log10}
and returns it.

\code{getNormalizedData()} is deprecated: please use \code{\link[=getNuNormData]{getNuNormData()}} or
\code{\link[=getLogNormData]{getLogNormData()}} directly as appropriate

\code{getProbabilityOfZero()} gives for each cell and each gene the
probability of observing zero reads
}
\examples{
data("test.dataset")
objCOTAN <- COTAN(raw = test.dataset)

objCOTAN <- estimateLambdaLinear(objCOTAN)
lambda <- getLambda(objCOTAN)

objCOTAN <- estimateNuLinear(objCOTAN)
nu <- getNu(objCOTAN)

objCOTAN <- estimateDispersionViaSolver(objCOTAN, cores = 6L)
dispersion <- getDispersion(objCOTAN)

objCOTAN <- estimateDispersionNuBisection(objCOTAN, cores = 6L,
                                          enforceNuAverageToOne = TRUE)
nu <- getNu(objCOTAN)
dispersion <- getDispersion(objCOTAN)

nuNorm <- getNuNormData(objCOTAN)

logNorm <- getLogNormData(objCOTAN)

logNorm <- getNormalizedData(objCOTAN, retLog = TRUE)

probZero <- getProbabilityOfZero(objCOTAN)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R, R/automaticCOTANObjectCreation.R
\name{COTAN_ObjectCreation}
\alias{COTAN_ObjectCreation}
\alias{COTAN}
\alias{proceedToCoex,COTAN-method}
\alias{proceedToCoex}
\alias{automaticCOTANObjectCreation}
\title{\code{COTAN} shortcuts}
\usage{
COTAN(raw = "ANY")

\S4method{proceedToCoex}{COTAN}(
  objCOTAN,
  calcCoex = TRUE,
  optimizeForSpeed = TRUE,
  deviceStr = "cuda",
  cores = 1L,
  cellsCutoff = 0.003,
  genesCutoff = 0.002,
  cellsThreshold = 0.99,
  genesThreshold = 0.99,
  saveObj = FALSE,
  outDir = "."
)

automaticCOTANObjectCreation(
  raw,
  GEO,
  sequencingMethod,
  sampleCondition,
  calcCoex = TRUE,
  optimizeForSpeed = TRUE,
  deviceStr = "cuda",
  cores = 1L,
  cellsCutoff = 0.003,
  genesCutoff = 0.002,
  cellsThreshold = 0.99,
  genesThreshold = 0.99,
  saveObj = FALSE,
  outDir = "."
)
}
\arguments{
\item{raw}{a matrix or dataframe with the raw counts}

\item{objCOTAN}{a newly created \code{COTAN} object}

\item{calcCoex}{a Boolean to determine whether to calculate the genes' \code{COEX}
or stop just after the \code{\link[=estimateDispersionViaSolver]{estimateDispersionViaSolver()}} step}

\item{optimizeForSpeed}{Boolean; when \code{TRUE} \code{COTAN} tries to use the \code{torch}
library to run the matrix calculations. Otherwise, or when the library is
not available will run the slower legacy code}

\item{deviceStr}{On the \code{torch} library enforces which device to use to run
the calculations. Possible values are \code{"cpu"} to us the system \emph{CPU},
\code{"cuda"} to use the system \emph{GPUs} or something like \code{"cuda:0"} to restrict
to a specific device}

\item{cores}{number of cores to use. Default is 1.}

\item{cellsCutoff}{\code{clean()} will delete from the \code{raw} data any gene that is
expressed in less cells than threshold times the total number of cells.
Default cutoff is \eqn{0.003 \; (0.3\%)}}

\item{genesCutoff}{\code{clean()} will delete from the \code{raw} data any cell that is
expressing less genes than threshold times the total number of genes.
Default cutoff is \eqn{0.002 \; (0.2\%)}}

\item{cellsThreshold}{any gene that is expressed in more cells than threshold
times the total number of cells will be marked as \strong{fully-expressed}.
Default threshold is \eqn{0.99 \; (99.0\%)}}

\item{genesThreshold}{any cell that is expressing more genes than threshold
times the total number of genes will be marked as \strong{fully-expressing}.
Default threshold is \eqn{0.99 \; (99.0\%)}}

\item{saveObj}{Boolean flag; when \code{TRUE} saves intermediate analyses and
plots to file}

\item{outDir}{an existing directory for the analysis output.}

\item{GEO}{a code reporting the GEO identification or other specific dataset
code}

\item{sequencingMethod}{a string reporting the method used for the sequencing}

\item{sampleCondition}{a string reporting the specific sample condition or
time point.}
}
\value{
a \code{COTAN} object

\code{proceedToCoex()} returns the updated \code{COTAN} object with genes'
\code{COEX} calculated. If asked to, it will also store the object, along all
relevant clean-plots, in the output directory.

\code{automaticCOTANObjectCreation()} returns the new \code{COTAN} object with
genes' \code{COEX} calculated. When asked, it will also store the object, along
all relevant clean-plots, in the output directory.
}
\description{
These functions create a \linkS4class{COTAN} object and/or also run
all the necessary steps until the genes' \code{COEX} matrix is calculated.
}
\details{
Constructor of the class \code{COTAN}

\code{proceedToCoex()} takes a newly created \code{COTAN} object (or the
result of a call to \code{dropGenesCells()}) and runs \code{\link[=calculateCoex]{calculateCoex()}}

\code{automaticCOTANObjectCreation()} takes a raw dataset, creates and
initializes a \code{COTAN} object and runs \code{\link[=proceedToCoex]{proceedToCoex()}}
}
\examples{
data("test.dataset")
obj <- COTAN(raw = test.dataset)

options(parallelly.fork.enable = TRUE)

#
# In case one needs to run more steps to clean the datatset
# the following might apply
if (FALSE) {
  objCOTAN <- initializeMetaDataset(objCOTAN,
                                    GEO = "test",
                                    sequencingMethod = "artificial",
                                    sampleCondition = "test dataset")
#
# doing all the cleaning...
#
# in case the genes' `COEX` is not needed it can be skipped
# (e.g. when calling [cellsUniformClustering()])
  objCOTAN <- proceedToCoex(objCOTAN, calcCoex = FALSE,
                            cores = 6L, optimizeForSpeed = TRUE,
                            deviceStr = "cuda", saveObj = FALSE)
}


## Otherwise it is possible to run all at once.
objCOTAN <- automaticCOTANObjectCreation(
  raw = test.dataset,
  GEO = "code",
  sequencingMethod = "10X",
  sampleCondition = "mouse_dataset",
  calcCoex = TRUE,
  saveObj = FALSE,
  outDir = tempdir(),
  cores = 6L)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R, R/UTCheckers.R
\docType{class}
\name{UniformTranscriptCheckers}
\alias{UniformTranscriptCheckers}
\alias{BaseUniformityCheck-class}
\alias{GDICheck-class}
\alias{SimpleGDIUniformityCheck-class}
\alias{AdvancedGDIUniformityCheck-class}
\alias{checkObjIsUniform,SimpleGDIUniformityCheck-method}
\alias{checkObjIsUniform}
\alias{checkObjIsUniform,AdvancedGDIUniformityCheck-method}
\alias{checkersToDF}
\alias{dfToCheckers}
\alias{getCheckerThreshold,SimpleGDIUniformityCheck-method}
\alias{getCheckerThreshold}
\alias{getCheckerThreshold,AdvancedGDIUniformityCheck-method}
\alias{calculateThresholdShiftToUniformity,SimpleGDIUniformityCheck-method}
\alias{calculateThresholdShiftToUniformity}
\alias{calculateThresholdShiftToUniformity,AdvancedGDIUniformityCheck-method}
\alias{shiftCheckerThresholds,SimpleGDIUniformityCheck,numeric-method}
\alias{shiftCheckerThresholds}
\alias{shiftCheckerThresholds,AdvancedGDIUniformityCheck,numeric-method}
\title{Definition of the \strong{Transcript Uniformity Checker} classes}
\usage{
\S4method{checkObjIsUniform}{SimpleGDIUniformityCheck}(currentC, previousC = NULL, objCOTAN = NULL)

\S4method{checkObjIsUniform}{AdvancedGDIUniformityCheck}(currentC, previousC = NULL, objCOTAN = NULL)

checkersToDF(checkers)

dfToCheckers(df, checkerClass = "")

\S4method{getCheckerThreshold}{SimpleGDIUniformityCheck}(checker)

\S4method{getCheckerThreshold}{AdvancedGDIUniformityCheck}(checker)

\S4method{calculateThresholdShiftToUniformity}{SimpleGDIUniformityCheck}(checker)

\S4method{calculateThresholdShiftToUniformity}{AdvancedGDIUniformityCheck}(checker)

\S4method{shiftCheckerThresholds}{SimpleGDIUniformityCheck,numeric}(checker, shift)

\S4method{shiftCheckerThresholds}{AdvancedGDIUniformityCheck,numeric}(checker, shift)
}
\arguments{
\item{currentC}{the object that defines the method and the threshold to
discriminate whether a \emph{cluster} is \emph{uniform transcript}.}

\item{previousC}{the optional result object of an already done check}

\item{objCOTAN}{an optional \code{COTAN} object}

\item{checkers}{a \code{list} of objects that defines the method, the thresholds
and the results of the checks to discriminate whether a \emph{cluster} is deemed
\emph{uniform transcript}.}

\item{df}{a \code{data.frame} with col-names being the member names and row-names
the names attached to each checker}

\item{checkerClass}{the type of the checker to be reconstructed from the
given \code{data.frame}}

\item{checker}{An checker object that defines how to check for \emph{uniform
transcript}. It is derived from \linkS4class{BaseUniformityCheck}}

\item{shift}{The amount by which to shift the \code{GDI} thresholds in the checker}
}
\value{
a copy of \code{currentC} with the results of the check. Note that the
slot \code{clusterSize} will be set to zero if it is not possible to get the
result of the check

a \code{data.frame} with col-names being the member names and row-names
the names attached to each checker

\code{dfToCheckers()} returns a \code{list} of checkers of the requested type,
each created from one of \code{data.frame} rows

\code{getCheckerThreshold()} returns the appropriate member of the
checker object representing the main \code{GDI} threshold

\code{calculateThresholdShiftToUniformity()} returns the positive shift
that would make the \verb{@isUniform} slot \code{TRUE} in the checker. It returns
zero if the result is already \code{TRUE} and \code{NaN} in case no such shift can
exist (e.g. the check have been not done yet)

\code{shiftCheckerThresholds()} returns a copy of the checker object
where all \code{GDI} thresholds have been shifted by the same given \code{shift}
amount
}
\description{
A hierarchy of classes to specify the method for checking
whether a \strong{cluster} has the \emph{Uniform Transcript} property. It also
doubles as result object.

\code{getCheckerThreshold()} extracts the main \code{GDI} threshold
from the given checker object

\code{calculateThresholdShiftToUniformity()} calculates by how much
the \code{GDI} thresholds in the given checker must be increased in order to
have that the relevant cluster is deemed \strong{uniform transcript}

\code{shiftCheckerThresholds()} returns a new checker object where
the \code{GDI} thresholds where increased in order to \emph{relax} the conditions to
achieve \strong{uniform transcript}
}
\details{
\code{BaseUniformityCheck} is the base class of the check methods

\code{GDICheck} represents a single unit check using \code{GDI} data. It
defaults to an \emph{above} check with threshold \eqn{1.4} and ratio \eqn{1\%}

\code{SimpleGDIUniformityCheck} represents the simplified (and legacy)
mechanism to determine whether a cluster has the \emph{Uniform Transcript}
property

The method is based on checking whether the fraction of the genes' \code{GDI}
below the given \emph{threshold} is less than the given \emph{ratio}

\code{AdvancedGDIUniformityCheck} represents the more precise and
advanced mechanism to determine whether a cluster has the \emph{Uniform
Transcript} property

The method is based on checking the genes' \code{GDI} against three
\emph{thresholds}: if a cluster fails the first \strong{below} check is deemed not
\emph{uniform}. Otherwise if it passes either of the other two checks (one above
and one below) it is deemed \emph{uniform}.

\code{checkObjIsUniform()} performs the check whether the given object is
uniform according to the given checker

\code{checkersToDF()} converts a \code{list} of checkers (i.e. objects that
derive from \code{BaseUniformityCheck}) into a \code{data.frame} with the values of
the members

\code{dfToCheckers()} converts a \code{data.frame} of checkers values into an
array of checkers ensuring given \code{data.frame} is compatible with member
types
}
\section{Slots}{

\describe{
\item{\code{isUniform}}{Logical. Output. The result of the check}

\item{\code{clusterSize}}{Integer. Output. The number of cells in the checked
cluster. When zero implies no check has been run yet}

\item{\code{isCheckAbove}}{Logical. Determines how to compare quantiles against given
thresholds. It is deemed passed if the relevant quantile is above/below the
given threshold}

\item{\code{GDIThreshold}}{Numeric. The level of \code{GDI} beyond which the \strong{cluster}
is deemed not uniform. Defaults}

\item{\code{maxRatioBeyond}}{Numeric. The maximum fraction of the empirical \code{GDI}
distribution that sits beyond the \code{GDI} threshold}

\item{\code{maxRankBeyond}}{Integer. The minimum rank in the empirical \code{GDI}
distribution for the \code{GDI} threshold}

\item{\code{fractionBeyond}}{Numeric. Output. The fraction of genes whose \code{GDI} is
above the threshold}

\item{\code{thresholdRank}}{Integer. Output. The rank that the \code{GDI} threshold would
have in the genes' \code{GDI} \code{vector}}

\item{\code{quantileAtRatio}}{Numeric. Output. The quantile in the genes' \code{GDI}
corresponding at the given ratio}

\item{\code{quantileAtRatio}}{Numeric. Output. The quantile in the genes' \code{GDI}
corresponding at the given rank}

\item{\code{check}}{\code{GDICheck}. The single threshold check used to determine whether
the \strong{cluster} is deemed not \emph{uniform}. Threshold defaults to \eqn{1.4},
\code{maxRatioBeyond} to \eqn{1\%}}

\item{\code{firstCheck}}{\code{GDICheck}. Single threshold below check used to determine
whether the \strong{cluster} is deemed not \emph{uniform}. Threshold defaults to
\eqn{1.297}, \code{maxRatioBeyond} to \eqn{5\%}}

\item{\code{secondCheck}}{\code{GDICheck}. Single threshold above check used to determine
whether the \strong{cluster} is deemed \emph{uniform}. Threshold defaults to
\eqn{1.307}, \code{maxRatioBeyond} to \eqn{2\%}}

\item{\code{thirdCheck}}{\code{GDICheck}. Single threshold below check used to determine
whether the \strong{cluster} is deemed \emph{uniform}. Threshold defaults to
\eqn{1.4},   \code{maxRatioBeyond} to \eqn{1\%}}

\item{\code{fourthCheck}}{\code{GDICheck}. Single threshold below check used to determine
whether the \strong{cluster} is deemed \emph{uniform}. Threshold defaults to
\eqn{1.4},   \code{maxRankBeyond} to \eqn{2}}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{Datasets}
\alias{Datasets}
\alias{raw.dataset}
\alias{ERCCraw}
\alias{test.dataset}
\alias{test.dataset.clusters1}
\alias{test.dataset.clusters2}
\alias{vignette.cells.origin}
\alias{vignette.split.clusters}
\alias{vignette.merge.clusters}
\title{Data-sets}
\format{
\code{raw.dataset} is a data frame with \eqn{2000} genes and \eqn{815}
cells

\code{ERCCraw} is a \code{data.frame}

\code{test.dataset} is a \code{data.frame} with \eqn{600} genes and \eqn{1200}
cells

\code{test.dataset.clusters1} is a \verb{character array}

\code{test.dataset.clusters2} is a \verb{character array}

\code{vignette.cells.origin} is a \code{factor}

\code{vignette.split.clusters} is a \code{factor}

\code{vignette.merge.clusters} is a \code{factor}
}
\source{
\code{GEO} \code{GSM2861514}

\code{ERCC}
}
\usage{
data(raw.dataset)

data(ERCCraw)

data(test.dataset)

data(test.dataset.clusters1)

data(test.dataset.clusters2)

data(vignette.cells.origin)

data(vignette.split.clusters)

data(vignette.merge.clusters)
}
\value{
Objects loaded by \code{data()}:
\itemize{
\item \code{raw.dataset}, \code{ERCCraw}, \code{test.dataset}: \code{data.frame}s
\item \code{test.dataset.clusters1}, \code{test.dataset.clusters2}:
character vectors of cluster labels
\item \code{vignette.split.clusters}, \code{vignette.merge.clusters},
\code{vignette.cells.origin}: factors of cluster labels
}
}
\description{
Simple data-sets included in the package
}
\details{
\code{raw.dataset} is a sub-sample of a real \emph{scRNA-seq} data-set

\code{ERCCraw} dataset

\code{test.dataset} is an artificial data set obtained by sampling target
negative binomial distributions on a set of \eqn{600} genes on \eqn{2} two
cells \emph{clusters} of \eqn{600} cells each. Each \emph{clusters} has its own set
of parameters for the distributions even, but a fraction of the genes has
the same expression in both \emph{clusters}.

\code{test.dataset.clusters1} is the \emph{clusterization} obtained running
\code{cellsUniformClustering()} on the \code{test.dataset}

\code{test.dataset.clusters2} is the \emph{clusterization} obtained running
\code{mergeUniformCellsClusters()} on the \code{test.dataset} using the previous
\emph{clusterization}

\code{vignette.cells.origin} is the factor discriminating between the
\emph{cortical} cells and the \emph{other} cells. This was constructed from the
following dataset: Mouse Cortex E17.5, \code{GEO}: \code{GSM2861514}
\url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSM2861514}

\code{vignette.split.clusters} is the clusterization obtained running
\code{cellsUniformClustering()} on the vignette dataset (mouse cortex E17.5,
\code{GEO}: \code{GSM2861514})

\code{vignette.merge.clusters} is the clusterization obtained running
\code{mergeUniformCellsClusters()} on the vignette dataset (mouse cortex E17.5,
\code{GEO}: \code{GSM2861514}) starting from the \code{vignette.split.clusters}
\emph{clusterization}, with a sequence of progressively relaxed \emph{UT} checks
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R, R/clustersDeltaExpression.R,
%   R/numericUtilities.R
\docType{class}
\name{COTAN_Legacy}
\alias{COTAN_Legacy}
\alias{scCOTAN-class}
\alias{scCotan_coerce_to_COTAN}
\alias{COTAN_coerce_to_scCOTAN}
\alias{clustersDeltaExpression}
\alias{vec2mat_rfast}
\alias{mat2vec_rfast}
\title{Handle legacy \code{scCOTAN}-class and related symmetric matrix <-> vector
conversions}
\usage{
clustersDeltaExpression(objCOTAN, clName = "", clusters = NULL)

vec2mat_rfast(x, genes = "all")

mat2vec_rfast(mat)
}
\arguments{
\item{objCOTAN}{a \code{COTAN} object}

\item{clName}{The name of the \emph{clusterization}. If not given the last
available \emph{clusterization} will be used, as it is probably the most
significant!}

\item{clusters}{A \emph{clusterization} to use. If given it will take precedence
on the one indicated by \code{clName}}

\item{x}{a \code{list} formed by two arrays: \code{genes} with the unique gene names
and \code{values} with all the values.}

\item{genes}{an array with all wanted genes or the string \code{"all"}. When equal
to \code{"all"} (the default), it recreates the entire matrix.}

\item{mat}{a square (possibly symmetric) matrix with all genes as row and
column names.}
}
\value{
a \code{scCOTAN} object

\code{clustersDeltaExpression()} returns a \code{data.frame} with the
\eqn{\nu} weighted discrepancy of the expression of each gene within the
\emph{cluster} against the corresponding model expectations

\code{mat2vec_rfast} returns a \code{list} formed by two arrays:
\itemize{
\item \code{"genes"} with the unique gene names,
\item \code{"values"} with all the values.
}

\code{vec2mat_rfast} returns the reconstructed symmetric matrix
}
\description{
A class and some functions related to the \code{V1} version of the
\code{COTAN} package
}
\details{
Define the legacy \code{scCOTAN}-class

Automatically converts an object from class \code{scCOTAN} into \code{COTAN}

Explicitly converts an object from class \code{COTAN} into \code{scCOTAN}

\code{clustersDeltaExpression()} is a legacy function now superseded by
\code{\link[=DEAOnClusters]{DEAOnClusters()}}. It estimates the change in genes' expression inside the
\emph{cluster} compared to the average situation in the data set.

This is a deprecated function related to old \code{scCOTAN} objects. Use
the more appropriate \code{Matrix::dspMatrix} type for similar functionality.

\code{mat2vec_rfast} converts a compacted symmetric matrix (that is an array)
into a symmetric matrix.

This is a deprecated function related to old \code{scCOTAN} objects. Use
the more appropriate \code{Matrix::dspMatrix} type for similar functionality.

\code{vec2mat_rfast} converts a symmetric matrix into a compacted symmetric
matrix. It will forcibly make its argument symmetric.
}
\section{Slots}{

\describe{
\item{\code{raw}}{\code{ANY}. To store the raw data matrix}

\item{\code{raw.norm}}{\code{ANY}. To store the raw data matrix divided for the cell
efficiency estimated (nu)}

\item{\code{coex}}{\code{ANY}. The \code{COEX} matrix}

\item{\code{nu}}{\code{vector}.}

\item{\code{lambda}}{\code{vector}.}

\item{\code{a}}{\code{vector}.}

\item{\code{hk}}{\code{vector}.}

\item{\code{n_cells}}{\code{numeric}.}

\item{\code{meta}}{\code{data.frame}.}

\item{\code{yes_yes}}{\code{ANY}. Unused and deprecated. Kept for backward compatibility
only}

\item{\code{clusters}}{\code{vector}.}

\item{\code{cluster_data}}{\code{data.frame}.}
}}

\examples{
v <- list("genes" = paste0("gene_", c(1:9)), "values" = c(1:45))

M <- vec2mat_rfast(v)
all.equal(rownames(M), v[["genes"]])
all.equal(colnames(M), v[["genes"]])

genes <- paste0("gene_", sample.int(ncol(M), 3))

m <- vec2mat_rfast(v, genes)
all.equal(rownames(m), v[["genes"]])
all.equal(colnames(m), genes)

v2 <- mat2vec_rfast(M)
all.equal(v, v2)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllConversions.R
\name{Conversions}
\alias{Conversions}
\alias{convertToSingleCellExperiment}
\alias{convertFromSingleCellExperiment}
\title{Data class conversions}
\usage{
convertToSingleCellExperiment(objCOTAN)

convertFromSingleCellExperiment(
  objSCE,
  assayName = "counts",
  clNamesPattern = "",
  condNamesPattern = "",
  genesNamesPattern = "",
  cellsIDsPattern = ""
)
}
\arguments{
\item{objCOTAN}{a \code{COTAN} object}

\item{objSCE}{A \link[SingleCellExperiment:SingleCellExperiment]{SingleCellExperiment::SingleCellExperiment} object to
be converted}

\item{assayName}{Name of the assay in \code{objSCE} to be used as raw counts.
Default is \code{"counts"}. If not found, the function falls back to \code{"X"} and
then to the first available assay, emitting a warning in both cases.}

\item{clNamesPattern}{A regular expression pattern used to identify the
clustering columns in \code{colData}. Default supports \code{Seurat} conventions:
\code{"^(COTAN_clusters_|seurat_clusters$|.*_snn_res\\\\..*|wsnn_res\\\\..*)"}}

\item{condNamesPattern}{A regular expression pattern used to identify the
condition columns in \code{colData}. Default supports \code{Seurat} conventions:
\code{"^(COTAN_conditions_|condition$|orig.ident$)"}}

\item{genesNamesPattern}{A regular expression pattern (case insensitive) used
to identify the genes' names column in \code{rowData}. It used only if no names
are available from the data matrix or the genes' data-set. Default supports
is: \code{"^((Gene|Feature)s?[ -_]?(Name|ID)s?|IDs?|Symbols?)$"}}

\item{cellsIDsPattern}{A regular expression pattern (case insensitive) used
to identify the cells' names column in \code{colData}. It used only if no names
are available from the data matrix or the cells' data-set. Default supports
is: \code{"^(Cells?[ -_]?IDs?|Barcodes?|Cells?)$"}}
}
\value{
A \link[SingleCellExperiment:SingleCellExperiment]{SingleCellExperiment::SingleCellExperiment} object
containing the data from the input \linkS4class{COTAN} object, with
\emph{clusterizations} and \emph{conditions} appropriately prefixed and stored in the
cell metadata.

A \linkS4class{COTAN} object containing the data extracted from the input
\link[SingleCellExperiment:SingleCellExperiment]{SingleCellExperiment::SingleCellExperiment} object
}
\description{
All functions to convert a \linkS4class{COTAN} object to/from other
data classes used by the \code{BioConductor} analysis packages
}
\details{
\code{convertToSingleCellExperiment()} converts a \linkS4class{COTAN} object
into a \link[SingleCellExperiment:SingleCellExperiment]{SingleCellExperiment::SingleCellExperiment} object. Stores
the raw counts in the \code{"counts"} \link[SummarizedExperiment:Assays-class]{SummarizedExperiment::Assays}, the
metadata for genes and cells as \code{rowData} and \code{colData} slots respectively
and finally the genes' and cells' \code{COEX} along the dataset metadata into
the \code{metadata} slot.

The function performs the following steps:
\itemize{
\item Extracts the raw counts matrix, gene metadata, cell metadata, gene
and cell \emph{co-expression} matrix from the \code{COTAN}
object; the \code{clustersCoex} slot is not converted
\item Identifies \emph{clusterizations} and \emph{conditions} in the cell metadata by the
prefixes \code{"CL_"} and \code{"COND_"}
\item Renames \emph{clusterization} columns with the prefix \code{"COTAN_clusters_"} and
\emph{condition} columns with the prefix \code{"COTAN_conditions_"}
\item Constructs a \code{SingleCellExperiment} object with the counts matrix, gene
metadata, updated cell metadata, and stores the \emph{co-expression} matrices
in the \code{metadata} slot.
}

The resulting \code{SingleCellExperiment} object is compatible with downstream
analysis packages and workflows within the Bioconductor ecosystem

\code{convertFromSingleCellExperiment()} converts a
\link[SingleCellExperiment:SingleCellExperiment]{SingleCellExperiment::SingleCellExperiment} object back into a
\linkS4class{COTAN} object. It supports \code{SCE} objects that were originally
created from either a \code{COTAN} object or a \code{Seurat} object. The function
extracts the \code{"counts"} matrix, genes' metadata, cells' metadata,
\emph{co-expression} matrices (if available), and reconstructs the \code{COTAN}
object accordingly.
The function performs the following steps:
\itemize{
\item Extracts the raw matrix from the \code{"counts"}
\link[SummarizedExperiment:Assays-class]{SummarizedExperiment::Assays}
\item Extracts gene metadata from \code{rowData}
\item Extracts cell metadata from \code{colData}, excluding any \emph{clusterizations} or
\emph{conditions} present
\item Attempts to retrieve \emph{co-expression} matrices from the \code{metadata} slot if
they exist
\item Constructs a \code{COTAN} object using the extracted data
\item Adds back the \emph{clusterizations} and \emph{conditions} using \code{COTAN} methods
If the COEX is not present (e.g., in \code{SCE} objects created from \code{Seurat}),
the \code{genesCoex} and \code{cellsCoex} slots in the resulting \code{COTAN} object will be
empty matrices
}
}
\examples{
  data("test.dataset")
  obj <- COTAN(raw = test.dataset)
  obj <- proceedToCoex(obj, calcCoex = FALSE, saveObj = FALSE)

  sce <- convertToSingleCellExperiment(objCOTAN = obj)

  newObj <- convertFromSingleCellExperiment(sce)

  stopifnot(identical(getDims(newObj)[-5:-6], getDims(obj)[-5:-6]),
            identical(unlist(getDims(newObj)[5:6]),
                      unlist(getDims(obj)[5:6]) + 1L))

}
\seealso{
\linkS4class{COTAN}, \link[SingleCellExperiment:SingleCellExperiment]{SingleCellExperiment::SingleCellExperiment}

\linkS4class{COTAN}, \link[SingleCellExperiment:SingleCellExperiment]{SingleCellExperiment::SingleCellExperiment}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/numericUtilities.R
\name{NumericUtilities}
\alias{NumericUtilities}
\alias{funProbZero}
\alias{dispersionBisection}
\alias{parallelDispersionBisection}
\alias{dispersionNewton}
\alias{parallelDispersionNewton}
\alias{nuBisection}
\alias{parallelNuBisection}
\alias{calcDist}
\title{Numeric Utilities}
\usage{
funProbZero(dispersion, mu)

dispersionBisection(
  sumZeros,
  lambda,
  nu,
  threshold = 0.001,
  maxIterations = 100L
)

parallelDispersionBisection(
  genes,
  sumZeros,
  lambda,
  nu,
  threshold = 0.001,
  maxIterations = 100L
)

dispersionNewton(sumZeros, lambda, nu, threshold = 0.001, maxIterations = 100L)

parallelDispersionNewton(
  genes,
  sumZeros,
  lambda,
  nu,
  threshold = 0.001,
  maxIterations = 100L
)

nuBisection(
  sumZeros,
  lambda,
  dispersion,
  initialGuess,
  threshold = 0.001,
  maxIterations = 100L
)

parallelNuBisection(
  cells,
  sumZeros,
  lambda,
  dispersion,
  initialGuess,
  threshold = 0.001,
  maxIterations = 100L
)

calcDist(data, method, diag = FALSE, upper = FALSE)
}
\arguments{
\item{dispersion}{the estimated \code{dispersion} (a \eqn{n}-sized vector)}

\item{mu}{the \code{lambda} times \code{nu} values (a \eqn{n \times m} matrix)}

\item{sumZeros}{the number of genes not expressed in the relevant cell (a
\eqn{m}-sized vector)}

\item{lambda}{the estimated \code{lambda} (a \eqn{n}-sized vector)}

\item{nu}{the estimated \code{nu} (a \eqn{m}-sized vector)}

\item{threshold}{minimal solution precision}

\item{maxIterations}{max number of iterations (avoids infinite loops)}

\item{genes}{names of the relevant genes}

\item{initialGuess}{the initial guess for \code{nu}  (a \eqn{m}-sized vector)}

\item{cells}{names of the relevant cells}

\item{data}{a matrix or a data.frame of which we want to calculate the
distance between columns}

\item{method}{type of distance to use. Can be chosen among those supported by
\code{\link[parallelDist:parDist]{parallelDist::parDist()}}}

\item{diag}{logical value indicating whether the diagonal of the distance
matrix should be printed by print.dist.upper}

\item{upper}{logical value indicating whether the upper triangle of the
distance matrix should be printed by print.dist}
}
\value{
the probability \code{matrix} that a \emph{read count} is identically zero

the \code{dispersion} value

the dispersion values

the \code{dispersion} value

the dispersion values

the nu value

the dispersion values

a \code{dist} object with all distances
}
\description{
A set of function helper related to the statistical model
underlying the \code{COTAN} package
}
\details{
\code{funProbZero} is a private function that gives the probability that
a sample gene's reads are zero, given the \code{dispersion} and \code{mu} parameters.

Using \eqn{d}{`disp`} for \code{disp} and \eqn{\mu}{`mu`} for \code{mu},
it returns:
\eqn{(1 + d \mu)^{-\frac{1}{d}}}{(1 + `disp` * `mu`)^(-1 / `disp`)}
when \eqn{d > 0}{`disp > 0`} and
\eqn{\exp{((d - 1) \mu)}}{exp((`disp` - 1) * `mu`)} otherwise.
The function is continuous in \eqn{d = 0}{`disp = 0`},
increasing in \eqn{d}{`disp`} and decreasing in \eqn{\mu}{`mu`}.
It returns 0 when \eqn{d = -\infty}{`disp = -Inf`} or
\eqn{\mu = \infty}{`mu = Inf`}.
It returns 1 when \eqn{\mu = 0}{`mu = 0`}.

\code{dispersionBisection} is a private function for the estimation of
\code{dispersion} slot of a \code{COTAN} object via a bisection solver

The goal is to find a \code{dispersion} value that reduces to zero the
difference between the number of estimated and counted zeros

\code{parallelDispersionBisection} is a private function that was invoked
by \code{\link[=estimateDispersionViaSolver]{estimateDispersionViaSolver()}} for the estimation of the \code{dispersion}
slot of a \code{COTAN} object via a parallel bisection solver. It is now
deprecated

The goal is to find a \code{dispersion} \code{array} that reduces to zero the
difference between the number of estimated and counted zeros

\code{dispersionNewton} is a private function for the estimation of
\code{dispersion} slot of a \code{COTAN} object via a Newton-Raphson solver

The goal is to find a \code{dispersion} value that reduces to zero the
difference between the number of estimated and counted zeros

\code{parallelDispersionNewton} is a private function invoked by
\code{\link[=parallelDispersionNewton]{parallelDispersionNewton()}} for the estimation of the \code{dispersion} slot
of a \code{COTAN} object via a parallel Newton-Raphson solver

The goal is to find a \code{dispersion} \code{array} that reduces to zero the
difference between the number of estimated and counted zeros

\code{nuBisection} is a private function for the estimation of \code{nu} slot
of a \code{COTAN} object via a bisection solver

The goal is to find a \code{nu} value that reduces to zero the difference
between the number of estimated and counted zeros

\code{parallelNuBisection} is a private function invoked by
\code{\link[=estimateNuBisection]{estimateNuBisection()}} for the estimation of \code{nu} slot of a \code{COTAN} object
via a parallel bisection solver

The goal is to find a \code{nu} \code{array} that reduces to zero the
difference between the number of estimated and counted zeros

\code{calcDist} is a wrapper function that invokes
\code{\link[parallelDist:parDist]{parallelDist::parDist()}}: the main goal is to recover and finish the
calculations via a fallback when there is a problem with the main algorithm
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/COTAN-getters.R, R/COTAN-modifiers.R,
%   R/ECD-plot.R, R/clean-method.R, R/clean-plot.R, R/librarySize-plot.R,
%   R/mitochondrialPercentage-plot.R, R/scatter-plot.R
\name{RawDataCleaning}
\alias{RawDataCleaning}
\alias{flagNotFullyExpressedGenes,COTAN-method}
\alias{flagNotFullyExpressedGenes}
\alias{flagNotFullyExpressingCells,COTAN-method}
\alias{flagNotFullyExpressingCells}
\alias{getFullyExpressedGenes,COTAN-method}
\alias{getFullyExpressedGenes}
\alias{getFullyExpressingCells,COTAN-method}
\alias{getFullyExpressingCells}
\alias{findFullyExpressedGenes,COTAN-method}
\alias{findFullyExpressedGenes}
\alias{findFullyExpressingCells,COTAN-method}
\alias{findFullyExpressingCells}
\alias{setLambda,COTAN-method}
\alias{setLambda}
\alias{setDispersion,COTAN-method}
\alias{setDispersion}
\alias{setNu,COTAN-method}
\alias{setNu}
\alias{dropGenesCells,COTAN-method}
\alias{dropGenesCells}
\alias{ECDPlot}
\alias{clean,COTAN-method}
\alias{clean}
\alias{cleanPlots}
\alias{screePlot}
\alias{cellSizePlot}
\alias{genesSizePlot}
\alias{genesPercentagePlot}
\alias{mitochondrialPercentagePlot}
\alias{scatterPlot}
\title{Raw data cleaning}
\usage{
\S4method{flagNotFullyExpressedGenes}{COTAN}(objCOTAN)

\S4method{flagNotFullyExpressingCells}{COTAN}(objCOTAN)

\S4method{getFullyExpressedGenes}{COTAN}(objCOTAN)

\S4method{getFullyExpressingCells}{COTAN}(objCOTAN)

\S4method{findFullyExpressedGenes}{COTAN}(objCOTAN, cellsThreshold = 0.99)

\S4method{findFullyExpressingCells}{COTAN}(objCOTAN, genesThreshold = 0.99)

\S4method{setLambda}{COTAN}(objCOTAN, lambda)

\S4method{setDispersion}{COTAN}(objCOTAN, dispersion)

\S4method{setNu}{COTAN}(objCOTAN, nu)

\S4method{dropGenesCells}{COTAN}(
  objCOTAN,
  genes = vector(mode = "character"),
  cells = vector(mode = "character")
)

ECDPlot(objCOTAN, yCut = NaN, condName = "", conditions = NULL)

\S4method{clean}{COTAN}(
  objCOTAN,
  cellsCutoff = 0.003,
  genesCutoff = 0.002,
  cellsThreshold = 0.99,
  genesThreshold = 0.99
)

cleanPlots(objCOTAN, includePCA = TRUE)

screePlot(pcaStdDev)

cellSizePlot(objCOTAN, condName = "", conditions = NULL)

genesSizePlot(objCOTAN, condName = "", conditions = NULL)

genesPercentagePlot(
  objCOTAN,
  genes,
  title = "Genes' percentage of reads",
  condName = "",
  conditions = NULL
)

mitochondrialPercentagePlot(
  objCOTAN,
  genePrefix = "^MT-",
  condName = "",
  conditions = NULL
)

scatterPlot(objCOTAN, condName = "", conditions = NULL, splitSamples = TRUE)
}
\arguments{
\item{objCOTAN}{a \code{COTAN} object}

\item{cellsThreshold}{any gene that is expressed in more cells than threshold
times the total number of cells will be marked as \strong{fully-expressed}.
Default threshold is \eqn{0.99 \; (99.0\%)}}

\item{genesThreshold}{any cell that is expressing more genes than threshold
times the total number of genes will be marked as \strong{fully-expressing}.
Default threshold is \eqn{0.99 \; (99.0\%)}}

\item{lambda}{a named array that gives the values for lambda}

\item{dispersion}{a named array that gives the values for the dispersion}

\item{nu}{A named array that gives}

\item{genes}{an array of gene names}

\item{cells}{an array of cell names}

\item{yCut}{y threshold of library size to drop. Default is \code{NaN}}

\item{condName}{The name of a condition in the \code{COTAN} object to further
separate the cells in more sub-groups. When no condition is given it is
assumed to be the same for all cells (no further sub-divisions)}

\item{conditions}{The \emph{conditions} to use. If given it will take precedence
on the one indicated by \code{condName} that will only indicate the relevant
column name in the returned \code{data.frame}}

\item{cellsCutoff}{\code{clean()} will delete from the \code{raw} data any gene that is
expressed in less cells than threshold times the total number of cells.
Default cutoff is \eqn{0.003 \; (0.3\%)}}

\item{genesCutoff}{\code{clean()} will delete from the \code{raw} data any cell that is
expressing less genes than threshold times the total number of genes.
Default cutoff is \eqn{0.002 \; (0.2\%)}}

\item{includePCA}{a \code{Boolean} flag to determine whether to calculate the
\emph{PCA} associated with the normalized matrix. When \code{TRUE} the first four
elements of the returned list will be \code{NULL}}

\item{pcaStdDev}{a \code{vector} with the standard deviations of the various
components}

\item{title}{The title of the plot; it defaults to \code{"Genes' percentage of reads"}}

\item{genePrefix}{Prefix for the mitochondrial genes; use \code{"^MT-"} for
Human (default) and \code{"^mt-"} for Mouse}

\item{splitSamples}{Boolean. Whether to plot each sample in a different panel
(default \code{FALSE})}
}
\value{
\code{flagNotFullyExpressedGenes()} returns a Booleans array with TRUE
for genes that are not fully-expressed

\code{flagNotFullyExpressingCells()} returns an array of Booleans with
TRUE for cells that are not expressing all genes

\code{getFullyExpressedGenes()} returns an array containing all genes
that are expressed in all cells

\code{getFullyExpressingCells()} returns an array containing all cells
that express all genes

\code{findFullyExpressedGenes()} returns the given \code{COTAN} object with
updated \strong{fully-expressed} genes' information

\code{findFullyExpressingCells()} returns the given \code{COTAN} object  with
updated \strong{fully-expressing} cells' information

\code{setLambda()} returns the updated \code{COTAN} object

\code{setDispersion()} returns the updated \code{COTAN} object

\code{setNu()} returns the updated \code{COTAN} object

\code{dropGenesCells()} returns a completely new \code{COTAN} object with the
new raw data obtained after the indicated genes/cells were expunged. All
remaining data is dropped too as no more relevant with the restricted
matrix. Exceptions are:
\itemize{
\item the meta-data for the data-set that gets kept unchanged
\item the meta-data of genes/cells that gets restricted to the remaining
elements. The columns calculated via \code{estimate} and \code{find} methods are
dropped too
}

\code{ECDPlot()} returns an \code{ECD} plot

\code{clean()} returns the updated \code{COTAN} object

\code{cleanPlots()} returns a \code{list} of \code{ggplot2} plots:
\itemize{
\item \code{"pcaCells"} is for \code{PCA} cells
\item \code{"pcaCellsData"} is the data of the \code{PCA} cells (can be plotted)
\item \code{"genes"} is for \code{B} group cells' genes
\item \code{"UDE"} is for cells' \code{UDE} against their \code{PCA}
\item \code{"nu"} is for cell \code{nu}
\item \code{"zoomedNu"} is the same but zoomed on the left and with an estimate
for the low \code{nu} threshold that defines problematic cells
}

\code{screePlot()} returns a \code{ggplot2} plot for the explained variances

\code{cellSizePlot()} returns a \code{half-violin-boxplot} object

\code{genesSizePlot()} returns a \code{half-violin-boxplot} object

\code{genesPercentagePlot()} returns a \code{list} with:
\itemize{
\item \code{"plot"} a \code{half-violin-boxplot} object
\item \code{"sizes"} a sizes \code{data.frame}
}

\code{mitochondrialPercentagePlot()} returns a \code{list} with:
\itemize{
\item \code{"plot"} a \code{half-violin-boxplot} object
\item \code{"sizes"} a sizes \code{data.frame}
}

\code{scatterPlot()} returns the scatter plot
}
\description{
These methods are to be used to clean the raw data. That is drop
any number of genes/cells that are too sparse or too present to allow
proper calibration of the \code{COTAN} model.

We call genes that are expressed in all cells \emph{Fully-Expressed} while cells
that express all genes in the data are called \emph{Fully-Expressing}. In case
it has been made quite easy to exclude the flagged genes/cells in the user
calculations.
}
\details{
\code{flagNotFullyExpressedGenes()} returns a Boolean array with TRUE for
those genes that are not fully-expressed.

\code{flagNotFullyExpressingCells()}returns a Boolean vector with TRUE
for those cells that are not expressing all genes

\code{getFullyExpressedGenes()} returns the genes expressed in all cells
of the dataset

\code{getFullyExpressingCells()} returns the cells that did express
all genes of the dataset

\code{findFullyExpressedGenes()} determines the fully-expressed genes
inside the raw data

\code{findFullyExpressingCells()} determines the cells that are
expressing all genes in the dataset

\code{setLambda()} adds a column to the genes' metadata with the lambda
(genes' counts averages) for the given batch

\code{setDispersion()} adds a column to the genes' metadata with the
negative binomial dispersion factor for the given batch

\code{setNu()}

\code{dropGenesCells()} removes an array of genes and/or cells from the
current \code{COTAN} object.

\code{ECDPlot()} plots the \emph{Empirical Cumulative Distribution} function
of library sizes (\code{UMI} number). It helps to define where to drop "cells"
that are simple background signal.

\code{clean()} is the main method that can be used to check and clean the
dataset. It will discard any genes that has less than 3 non-zero counts per
thousand cells and all cells expressing less than 2 per thousand genes.
also produces and stores the estimators for \code{nu}

\code{cleanPlots()} creates the plots associated to the output of the
\code{\link[=clean]{clean()}} method.

\code{screePlot()} creates a plots showing the explained variance of the
components of a PCA

\code{cellSizePlot()} plots the raw library size for each cell and
sample.

\code{genesSizePlot()} plots the raw gene number (reads > 0) for each
cell and sample

\code{genesPercentagePlot()} plots the percentage of expression of the
passed-in genes against the overall cell's library size

\code{mitochondrialPercentagePlot()} plots the percentage of expression
of the mitochondrial genes against the overall cell's library size

\code{scatterPlot()} creates a plot that check the relation between the
library size and the number of genes detected.
}
\examples{
library(zeallot)

data("test.dataset")
objCOTAN <- COTAN(raw = test.dataset)

genes.to.rem <- getGenes(objCOTAN)[grep('^MT', getGenes(objCOTAN))]
cells.to.rem <- getCells(objCOTAN)[which(getCellsSize(objCOTAN) == 0)]
objCOTAN <- dropGenesCells(objCOTAN, genes.to.rem, cells.to.rem)

objCOTAN <- clean(objCOTAN)

objCOTAN <- findFullyExpressedGenes(objCOTAN)
goodPos <- flagNotFullyExpressedGenes(objCOTAN)

objCOTAN <- findFullyExpressingCells(objCOTAN)
goodPos <- flagNotFullyExpressingCells(objCOTAN)

feGenes <- getFullyExpressedGenes(objCOTAN)

feCells <- getFullyExpressingCells(objCOTAN)

## These plots might help to identify genes/cells that need to be dropped
ecdPlot <- ECDPlot(objCOTAN, yCut = 100.0)
plot(ecdPlot)

# This creates many infomative plots useful to determine whether
# there is still something to drop...
# Here we use the tuple-like assignment feature of the `zeallot` package
clPlots <- cleanPlots(objCOTAN)
plot(clPlots[["pcaCells"]])
plot(clPlots[["UDE"]])
plot(clPlots[["zoomedNu"]])

lsPlot <- cellSizePlot(objCOTAN)
plot(lsPlot)

gsPlot <- genesSizePlot(objCOTAN)
plot(gsPlot)

genes <- getGenes(objCOTAN)[1:30]
genesPercPlot <-
  genesPercentagePlot(objCOTAN, genes = genes)[["plot"]]
plot(genesPercPlot)

mitPercPlot <-
  mitochondrialPercentagePlot(objCOTAN, genePrefix = "g-0000")[["plot"]]
plot(mitPercPlot)

scPlot <- scatterPlot(objCOTAN)
plot(scPlot)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/COTAN-getters.R, R/COTAN-modifiers.R,
%   R/calculateCoex-method.R
\name{getMu}
\alias{getMu}
\alias{calculateMu}
\alias{CalculatingCOEX}
\alias{getGenesCoex,COTAN-method}
\alias{getGenesCoex}
\alias{getCellsCoex,COTAN-method}
\alias{getCellsCoex}
\alias{isCoexAvailable,COTAN-method}
\alias{isCoexAvailable}
\alias{dropGenesCoex,COTAN-method}
\alias{dropGenesCoex}
\alias{dropCellsCoex,COTAN-method}
\alias{dropCellsCoex}
\alias{calculateLikelihoodOfObserved}
\alias{getDataMatrix}
\alias{observedContingencyTablesYY}
\alias{observedPartialContingencyTablesYY}
\alias{observedContingencyTables}
\alias{observedPartialContingencyTables}
\alias{expectedContingencyTablesNN}
\alias{expectedPartialContingencyTablesNN}
\alias{expectedContingencyTables}
\alias{expectedPartialContingencyTables}
\alias{contingencyTables}
\alias{calculateCoex,COTAN-method}
\alias{calculateCoex}
\alias{calculatePartialCoex}
\alias{calculateS}
\alias{calculateG}
\alias{getSelectedGenes}
\alias{calculateReducedDataMatrix}
\title{Calculating the COEX matrix for genes and cells}
\usage{
getMu(objCOTAN)

\S4method{getGenesCoex}{COTAN}(
  objCOTAN,
  genes = vector(mode = "character"),
  zeroDiagonal = TRUE,
  ignoreSync = FALSE
)

\S4method{getCellsCoex}{COTAN}(
  objCOTAN,
  cells = vector(mode = "character"),
  zeroDiagonal = TRUE,
  ignoreSync = FALSE
)

\S4method{isCoexAvailable}{COTAN}(objCOTAN, actOnCells = FALSE, ignoreSync = FALSE)

\S4method{dropGenesCoex}{COTAN}(objCOTAN)

\S4method{dropCellsCoex}{COTAN}(objCOTAN)

calculateLikelihoodOfObserved(objCOTAN, formula = "raw")

getDataMatrix(objCOTAN, dataMethod = "")

observedContingencyTablesYY(
  objCOTAN,
  actOnCells = FALSE,
  asDspMatrices = FALSE
)

observedPartialContingencyTablesYY(
  objCOTAN,
  columnsSubset,
  zeroOne = NULL,
  actOnCells = FALSE
)

observedContingencyTables(objCOTAN, actOnCells = FALSE, asDspMatrices = FALSE)

observedPartialContingencyTables(
  objCOTAN,
  columnsSubset,
  zeroOne = NULL,
  actOnCells = FALSE
)

expectedContingencyTablesNN(
  objCOTAN,
  actOnCells = FALSE,
  asDspMatrices = FALSE,
  optimizeForSpeed = TRUE
)

expectedPartialContingencyTablesNN(
  objCOTAN,
  columnsSubset,
  probZero = NULL,
  actOnCells = FALSE,
  optimizeForSpeed = TRUE
)

expectedContingencyTables(
  objCOTAN,
  actOnCells = FALSE,
  asDspMatrices = FALSE,
  optimizeForSpeed = TRUE
)

expectedPartialContingencyTables(
  objCOTAN,
  columnsSubset,
  probZero = NULL,
  actOnCells = FALSE,
  optimizeForSpeed = TRUE
)

contingencyTables(objCOTAN, g1, g2)

\S4method{calculateCoex}{COTAN}(
  objCOTAN,
  actOnCells = FALSE,
  returnPPFract = FALSE,
  optimizeForSpeed = TRUE,
  deviceStr = "cuda"
)

calculatePartialCoex(
  objCOTAN,
  columnsSubset,
  probZero = NULL,
  zeroOne = NULL,
  actOnCells = FALSE,
  optimizeForSpeed = TRUE
)

calculateS(
  objCOTAN,
  geneSubsetCol = vector(mode = "character"),
  geneSubsetRow = vector(mode = "character")
)

calculateG(
  objCOTAN,
  geneSubsetCol = vector(mode = "character"),
  geneSubsetRow = vector(mode = "character")
)

getSelectedGenes(objCOTAN, genesSel = "", numGenes = 2000L)

calculateReducedDataMatrix(
  objCOTAN,
  useCoexEigen = FALSE,
  dataMethod = "",
  numComp = 25L,
  genesSel = "",
  numGenes = 2000L
)
}
\arguments{
\item{objCOTAN}{a \code{COTAN} object}

\item{genes}{The given genes' names to select the wanted \code{COEX} columns. If
missing all columns will be returned. When not empty a proper result is
provided by calculating the partial \code{COEX} matrix on the fly}

\item{zeroDiagonal}{When \code{TRUE} sets the diagonal to zero.}

\item{ignoreSync}{When \code{TRUE} ignores whether the \code{lambda}/\code{nu}/\code{dispersion}
have been updated since the \code{COEX} matrix was calculated.}

\item{cells}{The given cells' names to select the wanted \code{COEX} columns. If
missing all columns will be returned. When not empty a proper result is
provided by calculating the partial \code{COEX} matrix on the fly}

\item{actOnCells}{Boolean; when \code{TRUE} the function works for the cells,
otherwise for the genes}

\item{formula}{a string indicating which function of the likelihood is
actually returned. Supported formulas are:
\itemize{
\item \code{"raw"} just the likelihood (default):
\eqn{p^{(1-z)} \times (1-p)^z = (1.0 - z) p + z (1.0 - p)}
\item \code{"log"} the log of the likelihood:
\eqn{(1.0 - z) \log(p) + z \log(1.0 - p)}
\item \code{"der"} the derivative of the log of the likelihood:
\eqn{(1.0 - z) / p - z / (1.0 - p)}
\item \code{"sLog"} the \emph{signed} log of the likelihood:
\eqn{(1.0 - z) \log(p) - z \log(1.0 - p)}
}

where \eqn{z} is the \emph{binarized projection} and \eqn{p} is the \emph{probability
of zero}}

\item{dataMethod}{selects the method to use to create the \code{data.frame} to
pass to the \code{\link[=UMAPPlot]{UMAPPlot()}}. To calculate, for each cell, a statistic for each
gene based on available data/model, the following methods are supported:
\itemize{
\item \verb{"RW", "Raw", "RawData"} uses the \emph{raw} counts
\item \verb{"NN", "NuNorm", "Normalized"} uses the \eqn{\nu}\emph{-normalized} counts
\item \verb{"LN", "LogNorm", "LogNormalized"} uses the \emph{log-normalized} counts
(default)
\item \verb{"BI", "Bin", "Binarized"} uses the \emph{binarized} data matrix
\item \verb{"BD", "BinDiscr", "BinarizedDiscrepancy"} uses the \emph{difference} between
the \emph{binarized} data matrix and the estimated \emph{probability of one}
\item \verb{"AB", "AdjBin", "AdjBinarized"} uses the absolute value of
the \emph{binarized discrepancy} above
\item \verb{"LH", "Like", "Likelihood"} uses the \emph{likelihood} of \emph{binarized}
data matrix
\item \verb{"LL", "LogLike", "LogLikelihood"} uses the \emph{log-likelihood}
of \emph{binarized} data matrix
\item \verb{"DL", "DerLogL", "DerivativeLogLikelihood"} uses the \emph{derivative} of
the \emph{log-likelihood} of \emph{binarized} data matrix
\item \verb{"SL", "SignLogL", "SignedLogLikelihood"} uses the \emph{signed
log-likelihood} of \emph{binarized} data matrix
}

For the last four options see \code{\link[=calculateLikelihoodOfObserved]{calculateLikelihoodOfObserved()}} for more
details}

\item{asDspMatrices}{Boolean; when \code{TRUE} the function will return only
packed dense symmetric matrices}

\item{columnsSubset}{a sub-set of the columns of the matrices that will be
returned}

\item{zeroOne}{the raw count matrix projected to \code{0} or \code{1}. If not given the
appropriate one will be calculated on the fly}

\item{optimizeForSpeed}{Boolean; deprecated: always TRUE}

\item{probZero}{is the expected \strong{probability of zero} for each gene/cell
pair. If not given the appropriate one will be calculated on the fly}

\item{g1}{a gene}

\item{g2}{another gene}

\item{returnPPFract}{Boolean; when \code{TRUE} the function returns the fraction
of genes/cells pairs for which the \emph{expected contingency table} is smaller
than \eqn{0.5}. Default is FALSE}

\item{deviceStr}{On the \code{torch} library enforces which device to use to run
the calculations. Possible values are \code{"cpu"} to us the system \emph{CPU},
\code{"cuda"} to use the system \emph{GPUs} or something like \code{"cuda:0"} to restrict
to a specific device}

\item{geneSubsetCol}{an array of genes. It will be put in columns. If left
empty the function will do it genome-wide.}

\item{geneSubsetRow}{an array of genes. It will be put in rows. If left empty
the function will do it genome-wide.}

\item{genesSel}{Decides whether and how to perform the gene-selection. used
for the clustering and the \code{UMAP}. It is a string indicating one of the
following selection methods:
\itemize{
\item \code{"HGDI"} Will pick-up the genes with highest \code{GDI} (default)
\item \code{"HVG_Seurat"} Will pick-up the genes with the highest variability
via the \pkg{Seurat} package
\item \code{"HVG_Scanpy"} Will pick-up the genes with the highest variability
according to the \code{Scanpy} package (using the \pkg{Seurat} implementation)
}}

\item{numGenes}{the number of genes to select using the above method. Will be
ignored when an explicit list of genes has been passed in}

\item{useCoexEigen}{Boolean to determine whether to project the data \code{matrix}
onto the first eigenvectors of the \strong{COEX} \code{matrix} or instead restrict
the data \code{matrix} to the selected genes before applying the \code{PCA} reduction}

\item{numComp}{Number of components of the reduced \code{matrix}, it defaults to
25L.}
}
\value{
\code{getMu()} returns the \code{mu} matrix

\code{getGenesCoex()} returns the genes' \code{COEX} values

\code{getCellsCoex()} returns the cells' \code{COEX} values

\code{isCoexAvailable()} returns whether relevant \code{COEX} matrix has been
calculated and, in case, if it is still aligned to the estimators.

\code{dropGenesCoex()} returns the updated \code{COTAN} object

\code{dropCellsCoex()} returns the updated \code{COTAN} object

\code{calculateLikelihoodOfObserved()} returns a \code{matrix} with the
selected \emph{formula} of the likelihood of the observed zero/one

\code{getDataMatrix()} returns a \code{matrix} with the same shape as the
\emph{raw} data

\code{observedContingencyTablesYY()} returns a \code{list} with:
\itemize{
\item \code{observedYY} the \emph{Yes/Yes} observed contingency table as \code{matrix}
\item \code{observedY}  the full \emph{Yes} observed \code{vector}
}

\code{observedPartialContingencyTablesYY()} returns a \code{list} with:
\itemize{
\item \code{observedYY} the \emph{Yes/Yes} observed contingency table as \code{matrix},
restricted to the selected columns as named \code{list} with elements
\item \code{observedY}  the full \emph{Yes} observed \code{vector}
}

\code{observedContingencyTables()} returns the observed contingency
tables as named \code{list} with elements:
\itemize{
\item \code{"observedNN"}
\item \code{"observedNY"}
\item \code{"observedYN"}
\item \code{"observedYY"}
}

\code{observedPartialContingencyTables()} returns the observed
contingency tables, restricted to the selected columns, as named \code{list}
with elements:
\itemize{
\item \code{"observedNN"}
\item \code{"observedNY"}
\item \code{"observedYN"}
\item \code{"observedYY"}
}

\code{expectedContingencyTablesNN()} returns a \code{list} with:
\itemize{
\item \code{expectedNN} the \emph{No/No} expected contingency table as \code{matrix}
\item \code{expectedN}  the \emph{No} expected \code{vector}
}

\code{expectedPartialContingencyTablesNN()} returns a \code{list} with:
\itemize{
\item \code{expectedNN} the \emph{No/No} expected contingency table as \code{matrix},
restricted to the selected columns, as named \code{list} with elements
\item \code{expectedN}  the full \emph{No} expected \code{vector}
}

\code{expectedContingencyTables()} returns the expected contingency tables
as named \code{list} with elements:
\itemize{
\item \code{"expectedNN"}
\item \code{"expectedNY"}
\item \code{"expectedYN"}
\item \code{"expectedYY"}
}

\code{expectedPartialContingencyTables()} returns the expected contingency
tables, restricted to the selected columns, as named \code{list} with elements:
\itemize{
\item \code{"expectedNN"}
\item \code{"expectedNY"}
\item \code{"expectedYN"}
\item \code{"expectedYY"}
}

\code{contingencyTables()} returns a list containing the observed and
expected contingency tables

\code{calculateCoex()} returns the updated \code{COTAN} object

\code{calculatePartialCoex()} returns the asked section of the \code{COEX}
matrix

\code{calculateS()} returns the \code{S} matrix

\code{calculateG()} returns the G matrix

\code{getSelectedGenes()} returns an array with the genes' names

\code{calculateReducedDataMatrix()} returns the reduced matrix. The
returned \code{matrix} has dimensions: (number of cells, number of components)
}
\description{
These are the functions and methods used to calculate the
\code{COEX} matrices according to the \code{COTAN} model. From there it is possible
to calculate the associated \code{p-value} and the \code{GDI} (\emph{Global Differential
Expression})

The \code{COEX} matrix is defined by following formula:

\deqn{\frac{\sum_{i,j \in \{\text{Y, N}\}}{
                    (-1)^{\#\{i,j\}}\frac{O_{ij}-E_{ij}}{1 \vee E_{ij}}}}
             {\sqrt{n \sum_{i,j \in \{\text{Y, N}\}}{
                            \frac{1}{1 \vee E_{ij}}}}}}

where \eqn{O} and \eqn{E} are the observed and expected contingency tables
and \eqn{n} is the relevant number of genes/cells (depending on given
\code{actOnCells} flag).

The formula can be more effectively implemented as:

\deqn{\sqrt{\frac{1}{n}\sum_{i,j \in \{\text{Y, N}\}}{
                               \frac{1}{1 \vee E_{ij}}}}
        \, \bigl(O_\text{YY}-E_\text{YY}\bigr)}

once one notices that \eqn{O_{ij} - E_{ij} = (-1)^{\#\{i,j\}} \, r} for
some constant \eqn{r} for all \eqn{i,j \in \{\text{Y, N}\}}.

The latter follows from the fact that the relevant marginal sums of the
expected contingency tables were enforced to match the marginal sums of the
observed ones.

The new implementation of the function relies on the \code{torch}
package. This implies that it is potentially able to use the system \code{GPU}
to run the heavy duty calculations required by this method. However
installing the \code{torch} package on a system can be \emph{finicky}, so we
tentatively provide a short help page \link{Installing_torch} hoping that it
will help...
}
\details{
\code{getMu()} calculates the vector \eqn{\mu = \lambda \times
  \nu^T}

\code{getGenesCoex()} extracts a complete (or a partial after genes
dropping) genes' \code{COEX} matrix from the \code{COTAN} object.

\code{getCellsCoex()} extracts a complete (or a partial after cells
dropping) cells' \code{COEX} matrix from the \code{COTAN} object.

\code{isCoexAvailable()} allows to query whether the relevant \code{COEX}
matrix from the \code{COTAN} object is available to use

\code{dropGenesCoex()} drops the \code{genesCoex} member from the given
\code{COTAN} object

\code{dropCellsCoex()} drops the \code{cellsCoex} member from the given
\code{COTAN} object

\code{calculateLikelihoodOfObserved()} gives for each cell and each gene
the likelihood of the observed zero/one data

\code{getDataMatrix()} gives for each cell and each gene the result of
the selected formula as function of the observed counts and their expected
value

\code{observedContingencyTablesYY()} calculates observed \emph{Yes/Yes} field
of the contingency table

\code{observedPartialContingencyTablesYY()} calculates observed \emph{Yes/Yes}
field of the contingency table

\code{observedContingencyTables()} calculates the observed contingency
tables. When the parameter \code{asDspMatrices == TRUE}, the method will
effectively throw away the lower half from the returned \code{observedYN} and
\code{observedNY} matrices, but, since they are transpose one of another, the
full information is still available.

\code{observedPartialContingencyTables()} calculates the observed
contingency tables.

\code{expectedContingencyTablesNN()} calculates the expected \emph{No/No}
field of the contingency table

\code{expectedPartialContingencyTablesNN()} calculates the expected
\emph{No/No} field of the contingency table

\code{expectedContingencyTables()} calculates the expected values of
contingency tables. When the parameter \code{asDspMatrices == TRUE}, the method
will effectively throw away the lower half from the returned \code{expectedYN}
and \code{expectedNY} matrices, but, since they are transpose one of another,
the full information is still available.

\code{expectedPartialContingencyTables()} calculates the expected values
of contingency tables, restricted to the specified column sub-set

\code{contingencyTables()} returns the observed and expected contingency
tables for a given pair of genes. The implementation runs the same
algorithms used to calculate the full observed/expected contingency tables,
but restricted to only the relevant genes and thus much faster and less
memory intensive

\code{calculateCoex()} estimates and stores the \code{COEX} matrix in the
\code{cellCoex} or \code{genesCoex} field depending on given \code{actOnCells} flag. It
also calculates the percentage of \emph{problematic} genes/cells pairs. A pair
is \emph{problematic} when one or more of the expected counts were significantly
smaller than 1 (\eqn{< 0.5}). These small expected values signal that scant
information is present for such a pair.

\code{calculatePartialCoex()} estimates a sub-section of the \code{COEX}
matrix in the \code{cellCoex} or \code{genesCoex} field depending on given
\code{actOnCells} flag. It also calculates the percentage of \emph{problematic}
genes/cells pairs. A pair is \emph{problematic} when one or more of the expected
counts were significantly smaller than 1 (\eqn{< 0.5}). These small
expected values signal that scant information is present for such a pair.

\code{calculateS()} calculates the statistics \strong{S} for genes contingency
tables. It always has the diagonal set to zero.

\code{calculateG()} calculates the statistics \emph{G-test} for genes
contingency tables. It always has the diagonal set to zero. It is
proportional to the genes' presence mutual information.

\code{getSelectedGenes()} selects the \emph{most representative} genes of the
\code{data.set}

\code{calculateReducedDataMatrix()} calculates the reduced data-matrix to
be used for \emph{clusterizations} or \code{UMAP} plots.

It uses the given \code{dataMethod} to determine with which data to start, then,
depending on the value of \code{useCoexEigen}, either uses the \code{genesSel} to
restrict evaluation to the relevant genes' before the \code{PCA} is run, or it
calculates the first \strong{COEX} eigenvectors and projects the data matrix to
their sub-space.
}
\note{
The sum of the matrices returned by the function
\code{observedContingencyTables()} and \code{expectedContingencyTables()} will have
the same value on all elements. This value is the number of genes/cells
depending on the parameter \code{actOnCells} being \code{TRUE/FALSE}.
}
\examples{
options(parallelly.fork.enable = TRUE)

data("test.dataset")
objCOTAN <- COTAN(raw = test.dataset)
objCOTAN <- initializeMetaDataset(objCOTAN, GEO = "test_GEO",
                                  sequencingMethod = "distribution_sampling",
                                  sampleCondition = "reconstructed_dataset")
objCOTAN <- clean(objCOTAN)

objCOTAN <- estimateLambdaLinear(objCOTAN)
objCOTAN <- estimateDispersionViaSolver(objCOTAN, cores = 6L)

## Now the `COTAN` object is ready to calculate the genes' `COEX`

## mu <- getMu(objCOTAN)
## observedY <- observedContingencyTablesYY(objCOTAN, asDspMatrices = TRUE)
obs <- observedContingencyTables(objCOTAN, asDspMatrices = TRUE)

## expectedN <- expectedContingencyTablesNN(objCOTAN, asDspMatrices = TRUE)
exp <- expectedContingencyTables(objCOTAN, asDspMatrices = TRUE)

objCOTAN <- calculateCoex(objCOTAN, actOnCells = FALSE)

stopifnot(isCoexAvailable(objCOTAN))
genesCoex <- getGenesCoex(objCOTAN)
genesSample <- sample(getNumGenes(objCOTAN), 10)
partialGenesCoex <- calculatePartialCoex(objCOTAN, genesSample,
                                         actOnCells = FALSE)

stopifnot(all(5.0e-6 >
                abs(partialGenesCoex -
                      getGenesCoex(objCOTAN,
                                   getGenes(objCOTAN)[sort(genesSample)],
                                   zeroDiagonal = FALSE))))

## S <- calculateS(objCOTAN)
## G <- calculateG(objCOTAN)
## pValue <- calculatePValue(objCOTAN)
gdiDF <- calculateGDI(objCOTAN)
objCOTAN <- storeGDI(objCOTAN, genesGDI = gdiDF)

## Touching any of the `lambda`/`nu`/`dispersion` parameters invalidates the
## `COEX` matrix and derivatives, so it can be dropped it from the `COTAN`
## object
objCOTAN <- dropGenesCoex(objCOTAN)
stopifnot(!isCoexAvailable(objCOTAN))


objCOTAN <- estimateDispersionNuBisection(objCOTAN, cores = 6L)

## Now the `COTAN` object is ready to calculate the cells' `COEX`
## In case one needs to calculate both, it is more sensible to run the above
## before any `COEX` evaluation

g1 <- getGenes(objCOTAN)[sample(getNumGenes(objCOTAN), 1)]
g2 <- getGenes(objCOTAN)[138L]
tables <- contingencyTables(objCOTAN, g1 = g1, g2 = g2)
tables

objCOTAN <- calculateCoex(objCOTAN, actOnCells = TRUE,
                          optimizeForSpeed = FALSE)
stopifnot(isCoexAvailable(objCOTAN, actOnCells = TRUE, ignoreSync = TRUE))
cellsCoex <- getCellsCoex(objCOTAN, zeroDiagonal = FALSE)

cellsSample <- sample(getNumCells(objCOTAN), 10)
partialCellsCoex <- calculatePartialCoex(objCOTAN, cellsSample,
                                         actOnCells = TRUE)

stopifnot(all(1e-6 >
                abs(partialCellsCoex - cellsCoex[, sort(cellsSample)])))

objCOTAN <- dropCellsCoex(objCOTAN)
stopifnot(!isCoexAvailable(objCOTAN, actOnCells = TRUE))

signedLikelhood <- calculateLikelihoodOfObserved(objCOTAN, formula = "sLog")

}
\seealso{
\link{ParametersEstimations} for more details.

\link{Installing_torch} about the \code{torch} package
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utilities.R
\name{getColorsVector}
\alias{getColorsVector}
\title{\code{getColorsVector}}
\usage{
getColorsVector(numNeededColors = 0L)
}
\arguments{
\item{numNeededColors}{The number of returned colors. If omitted it returns
all available colors}
}
\value{
an array of \code{RGB} colors of the wanted size
}
\description{
This function returns a list of colors based on the
\code{\link[RColorBrewer:ColorBrewer]{RColorBrewer::brewer.pal()}} function
}
\details{
The colors are taken from the \code{\link[RColorBrewer:ColorBrewer]{RColorBrewer::brewer.pal.info()}} sets
with \code{Set1}, \code{Set2}, \code{Set3} placed first.
}
\examples{
colorsVector <- getColorsVector(17)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utilities.R
\name{MultiThreading}
\alias{MultiThreading}
\alias{handleMultiCore}
\alias{canUseTorch}
\title{Handling Multi-Core and GPU environments}
\usage{
handleMultiCore(cores)

canUseTorch(optimizeForSpeed, deviceStr)
}
\arguments{
\item{cores}{the number of cores asked for}

\item{optimizeForSpeed}{A Boolean to indicate whether to try to use the
faster torch library}

\item{deviceStr}{The name of the device to be used by torch}
}
\value{
\code{handleMultiCore()} returns the maximum sensible number of cores to
use

\code{canUseTorch()} returns a list with 2 elements:
\itemize{
\item \code{"useTorch"}: a Boolean indicating whether the torch library can be used
\item \code{"deviceStr"}: the updated name of the device to be used: if no \code{cuda} GPU
is available it will fallback to CPU calculations
}
}
\description{
Check whether session supports multi-core and/or GPU evaluation
and utilities about their activation
}
\details{
\code{handleMultiCore()} uses \code{\link[parallelly:supportsMulticore]{parallelly::supportsMulticore()}} and
\code{\link[parallelly:availableCores]{parallelly::availableCores()}} to actually check whether the session
supports multi-core evaluation. Provides an effective upper bound to the
number of cores.

\code{canUseTorch()} is an internal function to handle the torch library:
it returns whether \pkg{torch} is ready to be used. It obeys the opt-out
flag set via the \code{COTAN.UseTorch} option
}
\seealso{
the help page of \code{\link[parallelly:supportsMulticore]{parallelly::supportsMulticore()}} about the flags
influencing the multi-core support; e.g. the usage of \code{R} option
\code{parallelly.fork.enable}.

\code{\link[torch:install_torch]{torch::install_torch()}} and \code{\link[torch:torch_is_installed]{torch::torch_is_installed()}} for
installation. Note the \code{\link[torch:threads]{torch::torch_set_num_threads()}} has effect also on
the \pkg{Rfast} package methods
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/COTAN-getters.R
\name{RawDataGetters}
\alias{RawDataGetters}
\alias{getRawData,COTAN-method}
\alias{getRawData}
\alias{getNumCells,COTAN-method}
\alias{getNumCells}
\alias{getNumGenes,COTAN-method}
\alias{getNumGenes}
\alias{getCells,COTAN-method}
\alias{getCells}
\alias{getGenes,COTAN-method}
\alias{getGenes}
\alias{getZeroOneProj,COTAN-method}
\alias{getZeroOneProj}
\alias{getCellsSize,COTAN-method}
\alias{getCellsSize}
\alias{getNumExpressedGenes,COTAN-method}
\alias{getNumExpressedGenes}
\alias{getGenesSize,COTAN-method}
\alias{getGenesSize}
\alias{getNumOfExpressingCells,COTAN-method}
\alias{getNumOfExpressingCells}
\title{Raw data \code{COTAN} accessors}
\usage{
\S4method{getRawData}{COTAN}(objCOTAN)

\S4method{getNumCells}{COTAN}(objCOTAN)

\S4method{getNumGenes}{COTAN}(objCOTAN)

\S4method{getCells}{COTAN}(objCOTAN)

\S4method{getGenes}{COTAN}(objCOTAN)

\S4method{getZeroOneProj}{COTAN}(objCOTAN)

\S4method{getCellsSize}{COTAN}(objCOTAN)

\S4method{getNumExpressedGenes}{COTAN}(objCOTAN)

\S4method{getGenesSize}{COTAN}(objCOTAN)

\S4method{getNumOfExpressingCells}{COTAN}(objCOTAN)
}
\arguments{
\item{objCOTAN}{a \code{COTAN} object}
}
\value{
\code{getRawData()} returns the raw count sparse matrix

\code{getNumCells()} returns the number of cells in the sample (\eqn{m})

\code{getNumGenes()} returns the number of genes in the sample (\eqn{n})

\code{getCells()} returns a character array with the cells' names

\code{getGenes()} returns a character array with the genes' names

\code{getZeroOneProj()} returns the raw count matrix projected to \code{0} or
\code{1}

\code{getCellsSize()} returns an array with the library sizes

\code{getNumExpressedGenes()} returns an array with the library sizes

\code{getGenesSize()} returns an array with the library sizes

\code{getNumOfExpressingCells()} returns an array with the library sizes
}
\description{
These methods extract information out of a just created \code{COTAN}
object. The accessors have \strong{read-only} access to the object.
}
\details{
\code{getRawData()} extracts the raw count table.

\code{getNumCells()} extracts the number of cells in the sample (\eqn{m})

\code{getNumGenes()} extracts the number of genes in the sample (\eqn{n})

\code{getCells()} extract all cells in the dataset.

\code{getGenes()} extract all genes in the dataset.

\code{getZeroOneProj()} extracts the raw count table where any
positive number has been replaced with \code{1}

\code{getCellsSize()} extracts the cell raw library size.

\code{getNumExpressedGenes()} extracts the number of genes expressed for
each cell. Exploits a feature of \link[Matrix:CsparseMatrix-class]{Matrix::CsparseMatrix}

\code{getGenesSize()} extracts the genes raw library size.

\code{getNumOfExpressingCells()} extracts, for each gene, the number of
cells that are expressing it. Exploits a feature of
\link[Matrix:CsparseMatrix-class]{Matrix::CsparseMatrix}
}
\examples{
data("test.dataset")
objCOTAN <- COTAN(raw = test.dataset)

rawData <- getRawData(objCOTAN)

numCells <- getNumCells(objCOTAN)

numGenes <- getNumGenes(objCOTAN)

cellsNames <- getCells(objCOTAN)

genesNames <- getGenes(objCOTAN)

zeroOne <- getZeroOneProj(objCOTAN)

cellsSize <- getCellsSize(objCOTAN)

numExpGenes <- getNumExpressedGenes(objCOTAN)

genesSize <- getGenesSize(objCOTAN)

numExpCells <- getNumOfExpressingCells(objCOTAN)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utilities.R
\name{ClustersList}
\alias{ClustersList}
\alias{asClusterization}
\alias{toClustersList}
\alias{fromClustersList}
\alias{groupByClustersList}
\alias{groupByClusters}
\alias{mergeClusters}
\alias{multiMergeClusters}
\title{\emph{Clusters} utilities}
\usage{
asClusterization(clusters, allCells = NULL)

toClustersList(clusters)

fromClustersList(
  clustersList,
  elemNames = vector(mode = "character"),
  throwOnOverlappingClusters = TRUE
)

groupByClustersList(elemNames, clustersList, throwOnOverlappingClusters = TRUE)

groupByClusters(clusters)

mergeClusters(clusters, names, mergedName = "")

multiMergeClusters(clusters, namesList, mergedNames = NULL)
}
\arguments{
\item{clusters}{A named \code{vector} or \code{factor} that defines the \emph{clusters}}

\item{allCells}{A \code{vector} of cells' names that should list the same names in
the \code{clusters} in any order}

\item{clustersList}{A named \code{list} whose elements define the various clusters}

\item{elemNames}{A \code{list} of names to which associate a cluster}

\item{throwOnOverlappingClusters}{When \code{TRUE}, in case of overlapping
clusters, the function \code{fromClustersList} and \code{groupByClustersList} will
throw. This is the default. When FALSE, instead, in case of overlapping
clusters, \code{fromClustersList} will return the last cluster to which each
element belongs, while \code{groupByClustersList} will return a vector of
positions that is longer than the given \code{elemNames}}

\item{names}{A list of \emph{clusters} names to be merged}

\item{mergedName}{The name of the new merged clusters}

\item{namesList}{A \code{list} of \code{list}s of \emph{clusters} names to be respectively
merged}

\item{mergedNames}{The names of the new merged \emph{clusters}}
}
\value{
\code{asClusterization()} returns the \emph{clusterization} as a named
\code{factor}

\code{toClustersList()} returns a \code{list} of clusters

\code{fromClustersList()} returns a clusterization. If the given
\code{elemNames} contain values not present in the \code{clustersList}, those will be
marked as \code{"-1"}

\code{groupByClusters()} and \code{groupByClustersList()} return a permutation
that groups the clusters together. For each cluster the positions are
guaranteed to be in increasing order. In case, all elements not
corresponding to any cluster are grouped together as the last group

\code{mergeClusters()} returns a new \emph{clusterization} with the wanted
\emph{clusters} being merged. If less than 2 \emph{cluster} names were passed the
function will emit a warning and return the initial \emph{clusterization}

\code{multiMergeClusters()} returns a new \emph{clusterization} with the
wanted \emph{clusters} being merged by consecutive iterations of
\code{\link[=mergeClusters]{mergeClusters()}} on the given \code{namesList}
}
\description{
Handle \emph{clusterization} <-> \emph{clusters} \code{list} conversions,
\emph{clusters} grouping and merge
}
\details{
\code{asClusterization()} given a \emph{clusterization} in the form of a
\code{data.frame} or a \code{vector} or a \code{factor}, returns a named \code{factor}

\code{toClustersList()} given a \emph{clusterization}, creates a \code{list} of
\emph{clusters} (i.e. for each \emph{cluster}, which elements compose the \emph{cluster})

\code{fromClustersList()} given a \code{list} of \emph{clusters} returns a
\emph{clusterization} (i.e. a named \code{vector} that for each element indicates to
which cluster it belongs)

\code{groupByClusters()} given a \emph{clusterization} returns a permutation,
such that using the permutation on the input the \emph{clusters} are grouped
together

\code{groupByClustersList()} given the elements' names and a \code{list} of
\emph{clusters} returns a permutation, such that using the permutation on the
given names the \emph{clusters} are grouped together.

\code{mergeClusters()} given a \emph{clusterization}, creates a new one where
the given \emph{clusters} are merged.

\code{multiMergeClusters()} given a \emph{clusterization}, creates a new one
where the given sets of \emph{clusters} are merged.
}
\examples{
## create a clusterization
clusters <- paste0("",sample(7, 100, replace = TRUE))
names(clusters) <- paste0("E_",formatC(1:100,  width = 3, flag = "0"))

## create a clusters list from a clusterization
clustersList <- toClustersList(clusters)
head(clustersList, 1)

## recreate the clusterization from the cluster list
clusters2 <- fromClustersList(clustersList, names(clusters))
all.equal(factor(clusters), clusters2)

cl1Size <- length(clustersList[["1"]])

## establish the permutation that groups clusters together
perm <- groupByClusters(clusters)
!is.unsorted(head(names(clusters)[perm],cl1Size))
head(clusters[perm], cl1Size)

## it is possible to have the list of the element names different
## from the names in the clusters list
selectedNames <- paste0("E_",formatC(11:110,  width = 3, flag = "0"))
perm2 <- groupByClustersList(selectedNames, toClustersList(clusters))
all.equal(perm2[91:100], c(91:100))

## is is possible to merge a few clusters together
clustersMerged <- mergeClusters(clusters, names = c("7", "2"),
                                mergedName = "7__2")
sum(table(clusters)[c(2, 7)]) == table(clustersMerged)[["7__2"]]

## it is also possible to do multiple merges at once!
## Note the default new clusters' names
clustersMerged2 <-
  multiMergeClusters(clusters2, namesList = list(c("2", "7"),
                                                 c("1", "3", "5")))
table(clustersMerged2)


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{Installing_torch}
\alias{Installing_torch}
\title{Installing \code{torch} \code{R} library (on \code{WSL-Linux})}
\value{
No return value. This topic is documentation-only.
}
\description{
A brief explanation of how to install the torch package on
\code{WSL2} (\verb{Windows Subsystem for Linux}), but it might work the same for
other \code{Linux} systems. Naturally it makes a difference whether one wants to
install support only for the \code{CPU} or also have the system \code{GPU} at the
ready!

These are just \emph{suggestions}, no guarantees are given:
\strong{try at your own peril!}

The main resources to install \code{torch} is
\url{https://torch.mlverse.org/docs/articles/installation.html} or
\url{https://cran.r-project.org/web/packages/torch/vignettes/installation.html}
}
\details{
For the \code{CPU}-only support one need to ensure that also numeric
libraries are installed, like \code{BLAS} and \code{LAPACK} and/or \code{MKL} if your
\code{CPU} is from \emph{Intel}. Otherwise \code{torch} will be stuck at using a single
core for all computations.

For the \code{GPU}, currently only \code{cuda} devices are supported. Moreover
only some specific versions of \code{cuda} (and corresponding \code{cudnn}) are
effectively usable, so one needs to install them to actually use the \code{GPU}.

At the time of writing only \code{cuda} 12.8 is supported, but check the \code{torch}
documentation for more up-to-date information. Before downgrading your
\code{cuda} version, please be aware that it is possible to maintain separate
main versions of \code{cuda} at the same time on the system.

Below a link to install \code{cuda} 12.8 for \code{WSL2} given: use a local installer
to be sure the wanted \code{cuda} version is being installed, and not the latest
one: \href{https://developer.nvidia.com/cuda-12-8-0-download-archive?target_os=Linux&target_arch=x86_64&Distribution=WSL-Ubuntu&target_version=2.0&target_type=deb_local}{\code{cuda} 12.8 for \code{WSL2}}

It can happen that after the installation of the new \code{torch} version,
including the dependencies, \code{torch} actually fails to run claiming that
\code{lantern} dependency was not installed.
This can happen due to presence of old cache files, so one can simply
delete the relevant cache folder as in the example below...
}
\examples{
\dontshow{if (FALSE) withAutoprint(\{ # examplesIf}
  # find the relevant cache folder and delete it
  folder <- tools::R_user_dir("torch","cache")
  print(folder)
  unlink(folder, recursive = TRUE, force = TRUE)

  # reinstall explicitly for the toolchain you want
  torch::install_torch(cuda_version = "12.8", reinstall = TRUE)

  # run this only **AFTER** restarting `R`
  COTAN::canUseTorch(TRUE, "cuda")
\dontshow{\}) # examplesIf}
}
\references{
\itemize{
\item \code{torch} installation guide:
\url{https://torch.mlverse.org/docs/articles/installation.html}
\item CRAN \code{torch} installation vignette:
\url{https://cran.r-project.org/web/packages/torch/vignettes/installation.html}
\item NVIDIA \verb{CUDA 12.8} for \code{WSL2} download archive:
\url{https://developer.nvidia.com/cuda-12-8-0-download-archive?target_os=Linux&target_arch=x86_64&Distribution=WSL-Ubuntu&target_version=2.0&target_type=deb_local}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utilities.R
\name{HandleStrings}
\alias{HandleStrings}
\alias{handleNamesSubsets}
\alias{conditionsFromNames}
\alias{isEmptyName}
\alias{niceFactorLevels}
\alias{factorToVector}
\title{Handle names and factors' levels}
\usage{
handleNamesSubsets(names, subset = vector(mode = "character"))

conditionsFromNames(names, splitPattern = " ", fragmentNum = 2L)

isEmptyName(name)

niceFactorLevels(v)

factorToVector(f)
}
\arguments{
\item{names}{The full \code{list} of the names to handle}

\item{subset}{The names' subset. When empty all names are returned instead!}

\item{splitPattern}{the pattern to use to split the names}

\item{fragmentNum}{the string fragment to use as condition from the split
names}

\item{name}{the name to check}

\item{v}{an \code{array} or \code{factor} object}

\item{f}{a \code{factor} object}
}
\value{
\code{handleNamesSubsets()} returns the updated list of names' subset,
reordered according to the given names' list

\code{conditionsFromNames()} returns the extracted conditions

\code{isEmptyName()} returns whether the passed name is equivalent to an
empty string

\code{niceFactorLevels()} returns a \code{factor} that is preserving the
\emph{names} of the input with the new nicer levels

\code{factorToVector()} returns a \verb{character vector} that preserves the
\emph{names} of the input factor
}
\description{
Internal functions dedicated to solve strings or factors related
simple tasks
}
\details{
\code{handleNamesSubsets()} returns the given subset or the full \code{list}
of names if none were specified

\code{conditionsFromNames()} retrieves a condition from the given names
by picking the asked fragment after having them split according to the
given pattern

\code{isEmptyName()} returns whether the passed name is not null and has
non-zero characters

\code{niceFactorLevels()} provides \strong{nicer} \code{factor} labels that have
all the same number of characters

\code{factorToVector()} converts a \emph{named} \code{factor} to a \emph{named}
\verb{character vector}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/COTAN-estimators.R, R/COTAN-getters.R,
%   R/COTAN-modifiers.R, R/DEAOnClusters.R, R/UMAP-plot.R,
%   R/clustersMarkersHeatmapPlot.R, R/clustersSummaryPlot.R,
%   R/findClustersMarkers.R, R/geneSetEnrichment.R, R/reorderClusterization.R
\name{HandlingClusterizations}
\alias{HandlingClusterizations}
\alias{estimateNuLinearByCluster,COTAN-method}
\alias{estimateNuLinearByCluster}
\alias{getClusterizations,COTAN-method}
\alias{getClusterizations}
\alias{getClusterizationName,COTAN-method}
\alias{getClusterizationName}
\alias{getClusterizationData,COTAN-method}
\alias{getClusterizationData}
\alias{getClusters}
\alias{getClustersCoex,COTAN-method}
\alias{getClustersCoex}
\alias{addClusterization,COTAN-method}
\alias{addClusterization}
\alias{addClusterizationCoex,COTAN-method}
\alias{addClusterizationCoex}
\alias{dropClusterization,COTAN-method}
\alias{dropClusterization}
\alias{DEAOnClusters}
\alias{clusterGeneContingencyTables}
\alias{pValueFromDEA}
\alias{logFoldChangeOnClusters}
\alias{distancesBetweenClusters}
\alias{UMAPPlot}
\alias{cellsUMAPPlot}
\alias{clustersMarkersHeatmapPlot}
\alias{clustersSummaryData}
\alias{clustersSummaryPlot}
\alias{clustersTreePlot}
\alias{findClustersMarkers}
\alias{geneSetEnrichment}
\alias{reorderClusterization}
\title{Handling cells' \emph{clusterization} and related functions}
\usage{
\S4method{estimateNuLinearByCluster}{COTAN}(objCOTAN, clName = "", clusters = NULL)

\S4method{getClusterizations}{COTAN}(objCOTAN, dropNoCoex = FALSE, keepPrefix = FALSE)

\S4method{getClusterizationName}{COTAN}(objCOTAN, clName = "", keepPrefix = FALSE)

\S4method{getClusterizationData}{COTAN}(objCOTAN, clName = "")

getClusters(objCOTAN, clName = "")

\S4method{getClustersCoex}{COTAN}(objCOTAN)

\S4method{addClusterization}{COTAN}(
  objCOTAN,
  clName,
  clusters,
  coexDF = data.frame(),
  override = FALSE
)

\S4method{addClusterizationCoex}{COTAN}(objCOTAN, clName, coexDF)

\S4method{dropClusterization}{COTAN}(objCOTAN, clName)

DEAOnClusters(objCOTAN, clName = "", clusters = NULL)

clusterGeneContingencyTables(objCOTAN, gene, cells)

pValueFromDEA(coexDF, numCells, adjustmentMethod)

logFoldChangeOnClusters(
  objCOTAN,
  clName = "",
  clusters = NULL,
  floorLambdaFraction = 0.05
)

distancesBetweenClusters(
  objCOTAN,
  clName = "",
  clusters = NULL,
  coexDF = NULL,
  useDEA = TRUE,
  distance = NULL
)

UMAPPlot(
  dataIn,
  clusters = NULL,
  elements = NULL,
  title = "",
  colors = NULL,
  numNeighbors = 0L,
  minPointsDist = NaN
)

cellsUMAPPlot(
  objCOTAN,
  clName = "",
  clusters = NULL,
  useCoexEigen = FALSE,
  dataMethod = "",
  numComp = 25L,
  genesSel = "",
  numGenes = 200L,
  colors = NULL,
  numNeighbors = 0L,
  minPointsDist = NA
)

clustersMarkersHeatmapPlot(
  objCOTAN,
  groupMarkers = list(),
  clName = "",
  clusters = NULL,
  coexDF = NULL,
  kCuts = 3L,
  adjustmentMethod = "bonferroni",
  condNameList = NULL,
  conditionsList = NULL
)

clustersSummaryData(
  objCOTAN,
  clName = "",
  clusters = NULL,
  condName = "",
  conditions = NULL
)

clustersSummaryPlot(
  objCOTAN,
  clName = "",
  clusters = NULL,
  condName = "",
  conditions = NULL,
  plotTitle = ""
)

clustersTreePlot(
  objCOTAN,
  kCuts,
  clName = "",
  clusters = NULL,
  useDEA = TRUE,
  distance = NULL,
  hclustMethod = "ward.D2"
)

findClustersMarkers(
  objCOTAN,
  n = 10L,
  markers = NULL,
  clName = "",
  clusters = NULL,
  coexDF = NULL,
  adjustmentMethod = "bonferroni"
)

geneSetEnrichment(clustersCoex, groupMarkers = list())

reorderClusterization(
  objCOTAN,
  clName = "",
  clusters = NULL,
  coexDF = NULL,
  reverse = FALSE,
  keepMinusOne = TRUE,
  useDEA = TRUE,
  distance = NULL,
  hclustMethod = "ward.D2"
)
}
\arguments{
\item{objCOTAN}{a \code{COTAN} object}

\item{clName}{The name of the \emph{clusterization}. If not given the last
available \emph{clusterization} will be used, as it is probably the most
significant!}

\item{clusters}{A \emph{clusterization} to use. If given it will take precedence
on the one indicated by \code{clName}}

\item{dropNoCoex}{When \code{TRUE} drops the names from the \emph{clusterizations} with
empty associated \code{COEX} \code{data.frame}}

\item{keepPrefix}{When \code{TRUE} returns the internal name of the
\emph{clusterization}: the one with the \code{CL_} prefix.}

\item{coexDF}{a \code{data.frame} where each column indicates the \code{COEX} for each
of the \emph{clusters} of the \emph{clusterization}}

\item{override}{When \code{TRUE} silently allows overriding data for an existing
\emph{clusterization} name. Otherwise the default behavior will avoid potential
data losses}

\item{gene}{a gene}

\item{cells}{a sub-set of the cells}

\item{numCells}{the number of overall cells in all \emph{clusters}}

\item{adjustmentMethod}{\emph{p-value} multi-test adjustment method, see
\code{\link[stats:p.adjust]{stats::p.adjust.methods()}}. Defaults to \code{"bonferroni"}; use \code{"none"} for
no adjustment}

\item{floorLambdaFraction}{Indicates the lower bound to the average count
sums inside or outside the cluster for each gene as fraction of the
relevant \code{lambda} parameter. Default is \eqn{5\%}}

\item{useDEA}{Boolean indicating whether to use the \emph{DEA} to define the
distance; alternatively it will use the average \emph{Zero-One} counts, that is
faster but less precise.}

\item{distance}{type of distance to use. Default is \code{"cosine"} for \emph{DEA} and
\code{"euclidean"} for \emph{Zero-One}. Can be chosen among those supported by
\code{\link[parallelDist:parDist]{parallelDist::parDist()}}}

\item{dataIn}{The \code{matrix} to plot. It must have a row names containing the
given elements (the columns are features)}

\item{elements}{a named \code{list} of elements to label. Each array in the list
will be shown with a different color}

\item{title}{a string giving the plot title. Will default to \code{UMAP} Plot if
not specified}

\item{colors}{an \code{array} of colors to use in the plot. If not sufficient
colors are given it will complete the list using colors from
\code{\link[=getColorsVector]{getColorsVector()}}}

\item{numNeighbors}{Overrides the default \code{n_neighbors} value}

\item{minPointsDist}{Overrides the default \code{min_dist} value}

\item{useCoexEigen}{Boolean to determine whether to project the data \code{matrix}
onto the first eigenvectors of the \strong{COEX} \code{matrix} or instead restrict
the data \code{matrix} to the selected genes before applying the \code{PCA} reduction}

\item{dataMethod}{selects the method to use to create the \code{data.frame} to
pass to the \code{\link[=UMAPPlot]{UMAPPlot()}}. See \code{\link[=getDataMatrix]{getDataMatrix()}} for more details.}

\item{numComp}{Number of components of the reduced \code{matrix}, it defaults to
25L.}

\item{genesSel}{Decides whether and how to perform gene-selection. See
\code{\link[=getSelectedGenes]{getSelectedGenes()}} for more details.}

\item{numGenes}{the number of genes to select using the above method. Will be
ignored when an explicit list of genes has been passed in}

\item{groupMarkers}{an optional named \code{list} with an element for each group
comprised of one or more marker genes}

\item{kCuts}{the number of estimated \emph{cluster} (this defines the height for
the tree cut)}

\item{condNameList}{a \code{list} of \emph{conditions}' names to be used for additional
columns in the final plot. When none are given no new columns will be added
using data extracted via the function \code{\link[=clustersSummaryData]{clustersSummaryData()}}}

\item{conditionsList}{a \code{list} of \emph{conditions} to use. If given they will
take precedence on the ones indicated by \code{condNameList}}

\item{condName}{The name of a condition in the \code{COTAN} object to further
separate the cells in more sub-groups. When no condition is given it is
assumed to be the same for all cells (no further sub-divisions)}

\item{conditions}{The \emph{conditions} to use. If given it will take precedence
on the one indicated by \code{condName} that will only indicate the relevant
column name in the returned \code{data.frame}}

\item{plotTitle}{The title to use for the returned plot}

\item{hclustMethod}{It defaults is \code{"ward.D2"} but can be any of the methods
defined by the \code{\link[stats:hclust]{stats::hclust()}} function.}

\item{n}{the number of extreme \code{COEX} values to return}

\item{markers}{a \code{list} of marker genes}

\item{clustersCoex}{the \code{COEX} \code{data.frame}}

\item{reverse}{a flag to the output order}

\item{keepMinusOne}{a flag to decide whether to keep the cluster \code{"-1"}
(representing the non-clustered cells) untouched}
}
\value{
\code{estimateNuLinearByCluster()} returns the updated \code{COTAN} object

\code{getClusterizations()} returns a vector of \emph{clusterization} names,
usually without the \code{CL_} prefix

\code{getClusterizationName()} returns the normalized \emph{clusterization}
name or \code{NULL} if no \emph{clusterizations} are present

\code{getClusterizationData()} returns a \code{list} with 2 elements:
\itemize{
\item \code{"clusters"} the named cluster labels array
\item \code{"coex"} the associated \code{COEX} \code{data.frame}. This will be an \strong{empty}
\code{data.frame} when not specified for the relevant \emph{clusterization}
}

\code{getClusters()} returns the named cluster labels array

\code{getClustersCoex()} returns the list with a \code{COEX} \code{data.frame} for
each \emph{clusterization}. When not empty, each \code{data.frame} contains a \code{COEX}
column for each \emph{cluster}.

\code{addClusterization()} returns the updated \code{COTAN} object

\code{addClusterizationCoex()} returns the updated \code{COTAN} object

\code{dropClusterization()} returns the updated \code{COTAN} object

\code{DEAOnClusters()} returns the co-expression \code{data.frame} for the
genes in each \emph{cluster}

\code{clusterGeneContingencyTables()} returns a list containing the
observed and expected contingency tables

\code{pValueFromDEA()} returns a \code{data.frame} containing the \emph{p-values}
corresponding to the given \code{COEX} adjusted for \emph{multi-test}

\code{logFoldChangeOnClusters()} returns the log-expression-change
\code{data.frame} for the genes in each \emph{cluster}

\code{distancesBetweenClusters()} returns a \code{dist} object

\code{UMAPPlot()} returns a \code{ggplot2} object

\code{cellsUMAPPlot()} returns a list with 2 objects:
\itemize{
\item \code{"plot"} a \code{ggplot2} object representing the \code{umap} plot
\item \code{"cellsRDM"} the \emph{Reduced Data Matrix} used to create the plot
}

\code{clustersMarkersHeatmapPlot()} returns a list with:
\itemize{
\item \code{"heatmapPlot"} the complete heatmap plot
\item \code{"dataScore"} the \code{data.frame} with the score values
\item \code{"pValueDF"}  the \code{data.frame} with the corresponding adjusted
\eqn{p-}values
}

\code{clustersSummaryData()} returns a \code{data.frame}  with the following
statistics: The calculated statistics are:
\itemize{
\item \code{"clName"} the \emph{cluster} \strong{labels}
\item \code{"condName"} the relevant condition (that sub-divides the \emph{clusters})
\item \code{"CellNumber"} the number of cells in the group
\item \code{"MeanUDE"} the average \code{UDE} in the group of cells
\item \code{"MedianUDE"} the median \code{UDE} in the group of cells
\item \code{"ExpGenes25"} the number of genes expressed in at the least 25\% of the
cells in the group
\item \code{"ExpGenes"} the number of genes expressed at the least once in any of
the cells in the group
\item \code{"CellPercentage"} fraction of the cells with respect to the total cells
}

\code{clustersSummaryPlot()} returns a \code{list} with a \code{data.frame} and a
\code{ggplot} objects
\itemize{
\item \code{"data"} contains the data,
\item \code{"plot"} is the returned plot
}

\code{clustersTreePlot()} returns a list with 2 objects:
\itemize{
\item \code{"dend"} a \code{ggplot2} object representing the \code{dendrogram} plot
\item \code{"objCOTAN"} the updated \code{COTAN} object
}

\code{findClustersMarkers()} returns a \code{data.frame} containing \code{n} genes
for each \emph{cluster} scoring top/bottom \code{COEX} scores. The \code{data.frame} also
contains:
\itemize{
\item \code{"CL"} the cluster
\item \code{"Gene"} the gene
\item \code{"Score"} the \code{COEX} score of the gene
\item \code{"adjPVal"} the \emph{p-values} associated to the \code{COEX}
adjusted for \emph{multi-testing}
\item \code{"DEA"} the differential expression of the gene
\item \code{"IsMarker"} whether the gene is among the given markers
\item \code{"logFoldCh"} the \emph{log-fold-change} of the gene expression inside versus
outside the cluster from \code{\link[=logFoldChangeOnClusters]{logFoldChangeOnClusters()}}
}

\code{geneSetEnrichment()} returns a \code{data.frame} with the cumulative
score

\code{reorderClusterization()} returns a \code{list} with 3 elements:
\itemize{
\item \code{"clusters"} the newly reordered cluster labels array
\item \code{"coex"} the associated \code{COEX} \code{data.frame}
\item \code{"permMap"} the reordering mapping
}
}
\description{
These functions manage the \emph{clusterizations} and their
associated \emph{cluster} \code{COEX} \code{data.frame}s.

A \emph{clusterization} is any partition of the cells where to each cell it is
assigned a \strong{label}; a group of cells with the same label is called
\emph{cluster}.

For each \emph{cluster} is also possible to define a \code{COEX} value for each gene,
indicating its increased or decreased expression in the \emph{cluster} compared
to the whole background. A \code{data.frame} with these values listed in a
column for each \emph{cluster} is stored separately for each \emph{clusterization} in
the \code{clustersCoex} member.

The formulae for this \emph{In/Out} \code{COEX} are similar to those used in the
\code{\link[=calculateCoex]{calculateCoex()}} method, with the \strong{role} of the second gene taken by the
\emph{In/Out} status of the cells with respect to each \emph{cluster}.
}
\details{
\code{estimateNuLinearByCluster()} does a linear estimation of \code{nu}:
cells' counts averages normalized \emph{cluster} by \emph{cluster}

\code{getClusterizations()} extracts the list of the \emph{clusterizations}
defined in the \code{COTAN} object.

\code{getClusterizationName()} normalizes the given \emph{clusterization} name
or, if none were given, returns the name of last available \emph{clusterization}
in the \code{COTAN} object. It can return the \emph{clusterization} \strong{internal name}
if needed

\code{getClusterizationData()} extracts the asked \emph{clusterization} and
its associated \code{COEX} \code{data.frame} from the \code{COTAN} object

\code{getClusters()} extracts the asked \emph{clusterization} from the \code{COTAN}
object

\code{getClustersCoex()} extracts the full \code{clusterCoex} member \code{list}

\code{addClusterization()} adds a \emph{clusterization} to the current \code{COTAN}
object, by adding a new column in the \code{metaCells} \code{data.frame} and adding a
new element in the \code{clustersCoex} \code{list} using the passed in \code{COEX}
\code{data.frame} or an empty \code{data.frame} if none were passed in.

\code{addClusterizationCoex()} adds a \emph{clusterization} \code{COEX}
\code{data.frame} to the current \code{COTAN} object. It requires the named
\emph{clusterization} to be already present.

\code{dropClusterization()} drops a \emph{clusterization} from the current
\code{COTAN} object, by removing the corresponding column in the \code{metaCells}
\code{data.frame} and the corresponding \code{COEX} \code{data.frame} from the
\code{clustersCoex} \code{list}.

\code{DEAOnClusters()} is used to run the Differential Expression
analysis using the \code{COTAN} contingency tables on each \emph{cluster} in the
given \emph{clusterization}

\code{clusterGeneContingencyTables()} returns the observed and expected
contingency tables for a given gene and a given set of cells (a cluster).
The implementation runs the same algorithms used to calculate the full
observed/expected contingency tables used for DEA, but restricted to only
the relevant gene and cluster, thus much faster and less memory intensive

\code{pValueFromDEA()} is used to convert to \emph{p-value} the Differential
Expression analysis using the \code{COTAN} contingency tables on each \emph{cluster}
in the given \emph{clusterization}

\code{logFoldChangeOnClusters()} is used to get the log difference of the
expression levels for each \emph{cluster} in the given \emph{clusterization} against
the rest of the data-set

\code{distancesBetweenClusters()} is used to obtain a distance between
the clusters. Depending on the value of the \code{useDEA} flag will base the
distance on the \emph{DEA} columns or the averages of the \emph{Zero-One} matrix.

\code{UMAPPlot()} plots the given \code{data.frame} containing genes
information related to clusters after applying the \code{umap} transformation
via \code{\link[Seurat:RunUMAP]{Seurat::RunUMAP()}}

\code{cellsUMAPPlot()} returns a \code{ggplot2} plot where the given
\emph{clusters} are placed on the base of their relative distance. Also if
needed calculates and stores the \code{DEA} of the relevant \emph{clusterization}.

\code{clustersMarkersHeatmapPlot()} returns the heatmap plot of a summary
score for each \emph{cluster} and each gene marker in the given
\emph{clusterization}. It also returns the size and percentage of each
\emph{cluster} on the right and a \emph{clusterization} \code{dendogram} on the left, as
returned by the function \code{\link[=clustersTreePlot]{clustersTreePlot()}}. The heatmap cells' colors
express the \strong{DEA}, that is whether a gene is enriched or depleted in the
cluster, while the stars are aligned to the corresponding adjusted
\eqn{p-}value: \verb{***} for \eqn{p < 0.1\%}, \verb{**} for \eqn{p < 1\%}, \code{*} for
\eqn{p < 5\%}, \code{.} for \eqn{p < 10\%}

\code{clustersSummaryData()} calculates various statistics about each
cluster (with an optional further \code{condition} to separate the cells).

\code{clustersSummaryPlot()} calculates various statistics about each
cluster via \code{\link[=clustersSummaryData]{clustersSummaryData()}} and puts them together into a plot.

\code{clustersTreePlot()} returns the \code{dendogram} plot where the given
\emph{clusters} are placed on the base of their relative distance. Also if
needed calculates and stores the \code{DEA} of the relevant \emph{clusterization}.

\code{findClustersMarkers()} takes in a \code{COTAN} object and a
\emph{clusterization} and produces a \code{data.frame} with the \code{n} most positively
enriched and the \code{n} most negatively enriched genes for each \emph{cluster}. The
function also provides whether and the found genes are in the given
\code{markers} list or not. It also returns the \emph{adjusted p-value} for
multi-tests using the \code{\link[stats:p.adjust]{stats::p.adjust()}}

\code{geneSetEnrichment()} returns a cumulative score of enrichment in a
\emph{cluster} over a gene set. In formulae it calculates
\eqn{\frac{1}{n}\sum_i(1-e^{-\theta X_i})}, where the \eqn{X_i} are the
positive values from \code{\link[=DEAOnClusters]{DEAOnClusters()}} and \eqn{\theta = -\frac{1}{0.1}
  \ln(0.25)}

\code{reorderClusterization()} takes in a \emph{clusterizations} and reorder
its labels so that in the new order near labels indicate near clusters
according to a \emph{DEA} (or \emph{Zero-One}) based distance
}
\examples{
data("test.dataset")
objCOTAN <- COTAN(raw = test.dataset)
objCOTAN <- proceedToCoex(objCOTAN, cores = 6L, calcCoex = TRUE,
                          optimizeForSpeed = TRUE, saveObj = FALSE)

data("test.dataset.clusters1")
clusters <- test.dataset.clusters1

coexDF <- DEAOnClusters(objCOTAN, clusters = clusters)

groupMarkers <- list(G1 = c("g-000010", "g-000020", "g-000138",
                            "g-000150", "g-000160", "g-000170"),
                     G2 = c("g-000300", "g-000330", "g-000450",
                            "g-000460", "g-000470"),
                     G3 = c("g-000510", "g-000530", "g-000550",
                            "g-000570", "g-000590"))

geneClusters <- rep(1:3, each = 240)[1:600]
names(geneClusters) <- getGenes(objCOTAN)

umapPlot <- UMAPPlot(coexDF, clusters = NULL, elements = groupMarkers)
plot(umapPlot)

objCOTAN <- addClusterization(objCOTAN, clName = "first_clusterization",
                              clusters = clusters, coexDF = coexDF)

lfcDF <- logFoldChangeOnClusters(objCOTAN, clusters = clusters)
umapPlot2 <- UMAPPlot(lfcDF, clusters = geneClusters)
plot(umapPlot2)

if (FALSE) {
  objCOTAN <- estimateNuLinearByCluster(objCOTAN, clusters = clusters)
}

clSummaryPlotAndData <-
  clustersSummaryPlot(objCOTAN, clName = "first_clusterization",
                      plotTitle = "first clusterization")
plot(clSummaryPlotAndData[["plot"]])

if (FALSE) {
  objCOTAN <- dropClusterization(objCOTAN, "first_clusterization")
}

clusterizations <- getClusterizations(objCOTAN, dropNoCoex = TRUE)
stopifnot(length(clusterizations) == 1)

cellsUmapPlotAndDF <- cellsUMAPPlot(objCOTAN, dataMethod = "LogLikelihood",
                                    useCoexEigen = TRUE, numComp = 25L,
                                    clName = "first_clusterization")
plot(cellsUmapPlotAndDF[["plot"]])

enrichment <- geneSetEnrichment(clustersCoex = coexDF,
                                groupMarkers = groupMarkers)

clHeatmapPlotAndData <- clustersMarkersHeatmapPlot(objCOTAN, groupMarkers)
clHeatmapPlotAndData[["heatmapPlot"]]

conditions <- as.integer(substring(getCells(objCOTAN), 3L))
conditions <- factor(ifelse(conditions <= 600, "L", "H"))
names(conditions) <- getCells(objCOTAN)

objCOTAN <- addCondition(objCOTAN, condName = "High/Low",
                         conditions = conditions)

clHeatmapPlotAndData2 <-
  clustersMarkersHeatmapPlot(objCOTAN, groupMarkers, kCuts = 2,
                             condNameList = list("High/Low"))
clHeatmapPlotAndData2[["heatmapPlot"]]

clName <- getClusterizationName(objCOTAN)

clusterDataList <- getClusterizationData(objCOTAN, clName = clName)

clusters <- getClusters(objCOTAN, clName = clName)

allClustersCoexDF <- getClustersCoex(objCOTAN)

summaryData <- clustersSummaryData(objCOTAN)

treePlotAndObj <- clustersTreePlot(objCOTAN, 2)
objCOTAN <- treePlotAndObj[["objCOTAN"]]
plot(treePlotAndObj[["dend"]])

clMarkers <- findClustersMarkers(objCOTAN, markers = list(),
                                 clusters = clusters)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GDI-plot.R, R/cellsUniformClustering.R,
%   R/checkClusterUniformity.R, R/mergeUniformCellsClusters.R
\name{UniformClusters}
\alias{UniformClusters}
\alias{GDIPlot}
\alias{cellsUniformClustering}
\alias{checkClusterUniformity}
\alias{mergeUniformCellsClusters}
\title{Uniform Clusters}
\usage{
GDIPlot(
  objCOTAN,
  genes,
  condition = "",
  statType = "S",
  GDIThreshold = 1.43,
  GDIIn = NULL
)

cellsUniformClustering(
  objCOTAN,
  checker = NULL,
  GDIThreshold = NaN,
  initialResolution = 0.8,
  maxIterations = 25L,
  cores = 1L,
  optimizeForSpeed = TRUE,
  deviceStr = "cuda",
  useDEA = TRUE,
  distance = NULL,
  useCoexEigen = FALSE,
  dataMethod = "",
  genesSel = "HVG_Seurat",
  numGenes = 2000L,
  numReducedComp = 25L,
  hclustMethod = "ward.D2",
  initialClusters = NULL,
  minimumUTClusterSize = 50L,
  initialIteration = 1L,
  saveObj = TRUE,
  outDir = "."
)

checkClusterUniformity(
  objCOTAN,
  clusterName,
  cells,
  checker,
  cores = 1L,
  optimizeForSpeed = TRUE,
  deviceStr = "cuda",
  saveObj = TRUE,
  outDir = "."
)

mergeUniformCellsClusters(
  objCOTAN,
  clusters = NULL,
  checkers = NULL,
  GDIThreshold = NaN,
  batchSize = 0L,
  cores = 1L,
  optimizeForSpeed = TRUE,
  deviceStr = "cuda",
  useDEA = TRUE,
  distance = NULL,
  hclustMethod = "ward.D2",
  allCheckResults = data.frame(),
  initialIteration = 1L,
  saveObj = TRUE,
  outDir = "."
)
}
\arguments{
\item{objCOTAN}{a \code{COTAN} object}

\item{genes}{a named \code{list} of genes to label. Each array will have different
color.}

\item{condition}{a string corresponding to the condition/sample (it is used
only for the title).}

\item{statType}{type of statistic to be used. Default is "S": Pearson's
chi-squared test statistics. "G" is G-test statistics}

\item{GDIThreshold}{legacy. The threshold level that is used in a
\linkS4class{SimpleGDIUniformityCheck}. It defaults to \eqn{1.43}}

\item{GDIIn}{when the \code{GDI} data frame was already calculated, it can be put
here to speed up the process (default is \code{NULL})}

\item{checker}{the object that defines the method and the threshold to
discriminate whether a \emph{cluster} is \emph{uniform transcript}. See
\link{UniformTranscriptCheckers} for more details}

\item{initialResolution}{a number indicating how refined are the clusters
before checking for \strong{uniformity}. It defaults to \eqn{0.8}, the same as
\code{\link[Seurat:FindClusters]{Seurat::FindClusters()}}}

\item{maxIterations}{max number of re-clustering iterations. It defaults to
\eqn{25}}

\item{cores}{number of cores to use. Default is 1.}

\item{optimizeForSpeed}{Boolean; when \code{TRUE} \code{COTAN} tries to use the \code{torch}
library to run the matrix calculations. Otherwise, or when the library is
not available will run the slower legacy code}

\item{deviceStr}{On the \code{torch} library enforces which device to use to run
the calculations. Possible values are \code{"cpu"} to us the system \emph{CPU},
\code{"cuda"} to use the system \emph{GPUs} or something like \code{"cuda:0"} to restrict
to a specific device}

\item{useDEA}{Boolean indicating whether to use the \emph{DEA} to define the
distance; alternatively it will use the average \emph{Zero-One} counts, that is
faster but less precise.}

\item{distance}{type of distance to use. Default is \code{"cosine"} for \emph{DEA} and
\code{"euclidean"} for \emph{Zero-One}. Can be chosen among those supported by
\code{\link[parallelDist:parDist]{parallelDist::parDist()}}}

\item{useCoexEigen}{Boolean to determine whether to project the data \code{matrix}
onto the first eigenvectors of the \strong{COEX} \code{matrix} or instead restrict
the data \code{matrix} to the selected genes before applying the \code{PCA} reduction}

\item{dataMethod}{selects the method to use to create the \code{data.frame} to
pass to the \code{\link[=UMAPPlot]{UMAPPlot()}}. See \code{\link[=getDataMatrix]{getDataMatrix()}} for more details.}

\item{genesSel}{Decides whether and how to perform the gene-selection
(defaults to \code{"HVG_Seurat"}). See \code{\link[=getSelectedGenes]{getSelectedGenes()}} for more details.}

\item{numGenes}{the number of genes to select using the above method. Will be
ignored when an explicit list of genes has been passed in}

\item{numReducedComp}{the number of calculated \strong{RDM} components}

\item{hclustMethod}{It defaults is \code{"ward.D2"} but can be any of the methods
defined by the \code{\link[stats:hclust]{stats::hclust()}} function.}

\item{initialClusters}{an existing \emph{clusterization} to use as starting point:
the \emph{clusters} deemed \strong{uniform} will be kept and the remaining cells will
be processed as normal}

\item{minimumUTClusterSize}{the minimum number of cells for a cluster to be
deemed potentially \emph{uniform transcript}}

\item{initialIteration}{the number associated tot he first iteration; it
defaults to 1. Useful in case of restart of the procedure to avoid
intermediate data override}

\item{saveObj}{Boolean flag; when \code{TRUE} saves intermediate analyses and
plots to file}

\item{outDir}{an existing directory for the analysis output. The effective
output will be paced in a sub-folder.}

\item{clusterName}{the tag of the \emph{cluster}}

\item{cells}{the cells belonging to the \emph{cluster}}

\item{clusters}{The \emph{clusterization} to merge. If not given the last
available \emph{clusterization} will be used, as it is probably the most
significant!}

\item{checkers}{a \code{list} of objects that defines the method and the
\emph{increasing} thresholds to discriminate whether to merge two \emph{clusters} if
deemed \emph{uniform transcript}. See \link{UniformTranscriptCheckers} for more
details}

\item{batchSize}{Number pairs to test in a single round. If none of them
succeeds the merge stops. Defaults to \eqn{2 (\#cl)^{2/3}}}

\item{allCheckResults}{An optional \code{data.frame} with the results of previous
checks about the merging of clusters. Useful to restart the \emph{merging}
process after an interruption.}
}
\value{
\code{GDIPlot()} returns a \code{ggplot2} object with a point got each gene,
where on the ordinates are the \code{GDI} levels and on the abscissa are the
average gene expression (log scaled). Also marked are the given \emph{threshold}
(in red) and the \eqn{50\%} and \eqn{75\%} quantiles (in blue).

\code{cellsUniformClustering()} returns a \code{list} with 2 elements:
\itemize{
\item \code{"clusters"} the newly found cluster labels array
\item \code{"coex"} the associated \code{COEX} \code{data.frame}
}

\code{checkClusterUniformity} returns a checker object of the same type
as the input one, that contains both threshold and results of the check:
see \link{UniformTranscriptCheckers} for more details

a \code{list} with:
\itemize{
\item \code{"clusters"} the merged cluster labels array
\item \code{"coex"} the associated \code{COEX} \code{data.frame}
}
}
\description{
This group of functions takes in input a \code{COTAN} object and
handle the task of dividing the dataset into \strong{Uniform Clusters}, that is
\emph{clusters} that have an homogeneous genes' expression. This condition is
checked by calculating the \code{GDI} of the \emph{cluster} and verifying that no
more than a small fraction of the genes have their \code{GDI} level above the
given \code{GDIThreshold}
}
\details{
\code{GDIPlot()} directly evaluates and plots the \code{GDI} for a sample.

\code{cellsUniformClustering()} finds a \strong{Uniform} \emph{clusterizations} by
means of the \code{GDI}. Once a preliminary \emph{clusterization} is obtained from
the \code{Seurat-package} methods, each \emph{cluster} is checked for \strong{uniformity}
via the function \code{\link[=checkClusterUniformity]{checkClusterUniformity()}}. Once all \emph{clusters} are
checked, all cells from the \strong{non-uniform} clusters are pooled together
for another iteration of the entire process, until all \emph{clusters} are
deemed \strong{uniform}. In the case only a few cells are left out (\eqn{\leq
  50}), those are flagged as \code{"-1"} and the process is stopped.

\code{checkClusterUniformity()} takes a \code{COTAN} object and a cells'
\emph{cluster} and checks whether the latter is \strong{uniform} by looking at the
genes' \code{GDI} distribution. The function runs \code{\link[=checkObjIsUniform]{checkObjIsUniform()}} on the
given input checker

\code{mergeUniformCellsClusters()} takes in a \strong{uniform}
\emph{clusterization} and progressively checks whether \emph{merging} two \emph{near
clusters} would form a \strong{uniform} \emph{cluster} still. Multiple thresholds
will be used from \eqn{1.37} up to the given one in order to prioritize
merge of the best fitting pairs.

This function uses the \emph{cosine distance} to establish the \emph{nearest clusters
pairs}. It will use the \code{\link[=checkClusterUniformity]{checkClusterUniformity()}} function to check
whether the merged \emph{clusters} are \strong{uniform}. The function will stop once
no \emph{tested pairs} of clusters can be \emph{merged} after testing all pairs in a
single batch
}
\examples{
data("test.dataset")

objCOTAN <- automaticCOTANObjectCreation(raw = test.dataset,
                                         GEO = "S",
                                         sequencingMethod = "10X",
                                         sampleCondition = "Test",
                                         cores = 6L,
                                         saveObj = FALSE)

objCOTAN <- storeGDI(objCOTAN, genesGDI = calculateGDI(objCOTAN, cores = 6L))

groupMarkers <- list(G1 = c("g-000010", "g-000020", "g-000138"),
                     G2 = c("g-000300", "g-000330"),
                     G3 = c("g-000510", "g-000530", "g-000550",
                            "g-000570", "g-000590"))

gdiPlot <- GDIPlot(objCOTAN, genes = groupMarkers, cond = "test")
plot(gdiPlot)

## Here we override the default checker as a way to reduce the number of
## clusters as higher thresholds imply less stringent uniformity checks
##
## In real applications it might be appropriate to do so in the cases when
## the wanted resolution is lower such as in the early stages of the analysis
##

checker <- new("AdvancedGDIUniformityCheck")
stopifnot(identical(
  checker |> methods::slot("firstCheck") |> methods::slot("GDIThreshold"),
  1.297
))

checker2 <- shiftCheckerThresholds(checker, 0.1)
stopifnot(identical(
  checker2 |> methods::slot("firstCheck") |> methods::slot("GDIThreshold"),
  1.397
))

splitList <- cellsUniformClustering(objCOTAN, cores = 6L,
                                    dataMethod = "LogLikelihood",
                                    useCoexEigen = TRUE,
                                    genesSel = "HGDI",
                                    numGenes = 2000L,
                                    numReducedComp = 50L,
                                    initialResolution = 0.8,
                                    checker = checker2,
                                    saveObj = FALSE)

clusters <- splitList[["clusters"]]

firstCluster <- getCells(objCOTAN)[clusters \%in\% clusters[[1L]]]

checkerRes <-
  checkClusterUniformity(objCOTAN, checker = checker2,
                         clusterName = clusters[[1L]], cells = firstCluster,
                         cores = 6L, optimizeForSpeed = TRUE,
                         deviceStr = "cuda", saveObj = FALSE)

objCOTAN <- addClusterization(objCOTAN,
                              clName = "split",
                              clusters = clusters,
                              coexDF = splitList[["coex"]],
                              override = FALSE)

stopifnot(identical(reorderClusterization(objCOTAN)[["clusters"]], clusters))

## It is possible to pass a list of checkers tot the merge function that will
## be applied each to the *resulting* merged *clusterization* obtained using
## the previous checker. This ensures that the most similar clusters are
## merged first improving the overall performance

mergedList <- mergeUniformCellsClusters(objCOTAN,
                                        checkers = c(checker, checker2),
                                        clusters = clusters,
                                        cores = 6L,
                                        optimizeForSpeed = TRUE,
                                        deviceStr = "cpu",
                                        distance = "cosine",
                                        hclustMethod = "ward.D2",
                                        saveObj = FALSE)

objCOTAN <- addClusterization(objCOTAN,
                              clName = "merged",
                              clusters = mergedList[["clusters"]],
                              coexDF = mergedList[["coex"]],
                              override = TRUE)

stopifnot(identical(reorderClusterization(objCOTAN)[["clusters"]],
                    mergedList[["clusters"]]))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/COTAN-getters.R, R/COTAN-modifiers.R
\name{HandlingConditions}
\alias{HandlingConditions}
\alias{getAllConditions,COTAN-method}
\alias{getAllConditions}
\alias{getConditionName,COTAN-method}
\alias{getConditionName}
\alias{getCondition,COTAN-method}
\alias{getCondition}
\alias{normalizeNameAndLabels}
\alias{addCondition,COTAN-method}
\alias{addCondition}
\alias{dropCondition,COTAN-method}
\alias{dropCondition}
\title{Handling cells' \emph{conditions} and related functions}
\usage{
\S4method{getAllConditions}{COTAN}(objCOTAN, keepPrefix = FALSE)

\S4method{getConditionName}{COTAN}(objCOTAN, condName = "", keepPrefix = FALSE)

\S4method{getCondition}{COTAN}(objCOTAN, condName = "")

normalizeNameAndLabels(objCOTAN, name = "", labels = NULL, isCond = FALSE)

\S4method{addCondition}{COTAN}(objCOTAN, condName, conditions, override = FALSE)

\S4method{dropCondition}{COTAN}(objCOTAN, condName)
}
\arguments{
\item{objCOTAN}{a \code{COTAN} object}

\item{keepPrefix}{When \code{TRUE} returns the internal name of the
\emph{condition}: the one with the \code{COND_} prefix.}

\item{condName}{the name of an existing \emph{condition}.}

\item{name}{the name of the \emph{clusterization}/\emph{condition}. If not given the
last available \emph{clusterization} will be used, or no \emph{conditions}}

\item{labels}{a \emph{clusterization}/\emph{condition} to use. If given it will take
precedence on the one indicated by \code{name}}

\item{isCond}{a Boolean to indicate whether the function is dealing with
\emph{clusterizations} \code{\link{FALSE}} or \emph{conditions} \code{\link{TRUE}}}

\item{conditions}{a (factors) array of \emph{condition} \strong{labels}}

\item{override}{When \code{TRUE} silently allows overriding data for an existing
\emph{condition} name. Otherwise the default behavior will avoid potential
data losses}
}
\value{
\code{getAllConditions()} returns a vector of \emph{conditions} names,
usually without the \code{COND_} prefix

\code{getConditionName()} returns the normalized \emph{condition} name or
\code{NULL} if no \emph{conditions} are present

\code{getCondition()} returns a named \code{factor} with the \emph{condition}

\code{normalizeNameAndLabels()} returns a \code{list} with:
\itemize{
\item \code{"name"} the relevant name
\item \code{"labels"} the relevant \emph{clusterization}/\emph{condition}
}

\code{addCondition()} returns the updated \code{COTAN} object

\code{dropCondition()} returns the updated \code{COTAN} object
}
\description{
These functions manage the \emph{conditions}.

A \emph{condition} is a set of \strong{labels} that can be assigned to cells:
one \strong{label} per cell. This is especially useful in cases when the
\code{data-set} is the result of merging multiple experiments' raw data
}
\details{
\code{getAllConditions()} extracts the list of the \emph{conditions} defined
in the \code{COTAN} object.

\code{getConditionName()} normalizes the given \emph{condition} name or, if
none were given, returns the name of last available \emph{condition} in the
\code{COTAN} object. It can return the \emph{condition} \strong{internal name} if needed

\code{getCondition()} extracts the asked \emph{condition} from the \code{COTAN}
object

\code{normalizeNameAndLabels()} takes a pair of name/labels and
normalize them based on the available information in the \code{COTAN} object

\code{addCondition()} adds a \emph{condition} to the current \code{COTAN} object,
by adding a new column in the \code{metaCells} \code{data.frame}

\code{dropCondition()} drops a \emph{condition} from the current \code{COTAN}
object, by removing the corresponding column in the \code{metaCells}
\code{data.frame}
}
\examples{
data("test.dataset")
objCOTAN <- COTAN(raw = test.dataset)

cellLine <- rep(c("A", "B"), getNumCells(objCOTAN) / 2)
names(cellLine) <- getCells(objCOTAN)
objCOTAN <- addCondition(objCOTAN, condName = "Line", conditions = cellLine)

if (FALSE) {
  objCOTAN <- dropCondition(objCOTAN, "Genre")
}

conditionsNames <- getAllConditions(objCOTAN)

condName <- getConditionName(objCOTAN)

condition <- getCondition(objCOTAN, condName = condName)
isa(condition, "factor")

nameAndCond <- normalizeNameAndLabels(objCOTAN, name = condName,
                                      isCond = TRUE)
isa(nameAndCond[["labels"]], "factor")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/COTAN-getters.R, R/COTAN-modifiers.R,
%   R/utilities.R
\name{HandleMetaData}
\alias{HandleMetaData}
\alias{getMetadataDataset,COTAN-method}
\alias{getMetadataDataset}
\alias{getMetadataElement,COTAN-method}
\alias{getMetadataElement}
\alias{getMetadataGenes,COTAN-method}
\alias{getMetadataGenes}
\alias{getMetadataCells,COTAN-method}
\alias{getMetadataCells}
\alias{getDims,COTAN-method}
\alias{getDims}
\alias{datasetTags}
\alias{initializeMetaDataset,COTAN-method}
\alias{initializeMetaDataset}
\alias{addElementToMetaDataset,COTAN-method}
\alias{addElementToMetaDataset}
\alias{getColumnFromDF}
\alias{setColumnInDF}
\alias{getMetaInfoRow}
\alias{updateMetaInfo}
\title{Handling \emph{meta-data} in \code{COTAN} objects}
\usage{
\S4method{getMetadataDataset}{COTAN}(objCOTAN)

\S4method{getMetadataElement}{COTAN}(objCOTAN, tag)

\S4method{getMetadataGenes}{COTAN}(objCOTAN)

\S4method{getMetadataCells}{COTAN}(objCOTAN)

\S4method{getDims}{COTAN}(objCOTAN)

datasetTags()

\S4method{initializeMetaDataset}{COTAN}(objCOTAN, GEO, sequencingMethod, sampleCondition)

\S4method{addElementToMetaDataset}{COTAN}(objCOTAN, tag, value)

getColumnFromDF(df, colName)

setColumnInDF(df, colToSet, colName, rowNames = vector(mode = "character"))

getMetaInfoRow(meta, tag)

updateMetaInfo(meta, tag, value)
}
\arguments{
\item{objCOTAN}{a \code{COTAN} object}

\item{tag}{The tag associated to the wanted value}

\item{GEO}{a code reporting the GEO identification or other specific data-set
code}

\item{sequencingMethod}{a string reporting the method used for the sequencing}

\item{sampleCondition}{a string reporting the specific sample condition or
time point}

\item{value}{The value or the values to associate to the tag}

\item{df}{the \code{data.frame}}

\item{colName}{the name of the new or existing column in the \code{data.frame}}

\item{colToSet}{the column to add}

\item{rowNames}{when not empty, if the input \code{data.frame} has no real row
names, the new row names of the resulting \code{data.frame}}

\item{meta}{The information \code{data.frame} to update}
}
\value{
\code{getMetadataDataset()} returns the meta-data \code{data.frame}

\code{getMetadataElement()} returns a string with the relevant value

\code{getMetadataGenes()} returns the genes' meta-data \code{data.frame}

\code{getMetadataCells()} returns the cells' meta-data \code{data.frame}

\code{getDims()} returns a named \code{list} with the sizes of the slots

\code{datasetTags()} a named \verb{character array} with the standard labels
used in the \code{metaDataset} of the \code{COTAN} objects

\code{initializeMetaDataset()} returns the given \code{COTAN} object with the
updated \code{metaDataset}

\code{addElementToMetaDataset()} returns the updated \code{COTAN} object

\code{getColumnFromDF()} returns the column in the \code{data.frame} as named
\code{array}, \code{NULL} if the wanted column is not available

\code{setColumnInDF()} returns the updated, or the newly created,
\code{data.frame}

\code{getMetaInfoRow()} returns the last relevant row position if any or
zero otherwise.

\code{updateMetaInfo()} returns the updated \code{data.frame}
}
\description{
Much of the information stored in the \code{COTAN} object is
compacted into three \code{data.frame}s:
\itemize{
\item \code{"metaDataset"} - contains all general information about the data-set
\item \code{"metaGenes"} - contains genes' related information along the \code{lambda}
and \code{dispersion} vectors and the fully-expressed flag
\item \code{"metaCells"} - contains cells' related information along the \code{nu}
vector, the fully-expressing flag, the \emph{clusterizations} and the
\emph{conditions}
}
}
\details{
\code{getMetadataDataset()} extracts the meta-data stored for the
current data-set.

\code{getMetadataElement()} extracts the value associated with the
given tag if present or an empty string otherwise.

\code{getMetadataGenes()} extracts the meta-data stored for the genes

\code{getMetadataCells()} extracts the meta-data stored for the cells

\code{getDims()} extracts the sizes of all slots of the \code{COTAN} object

\code{datasetTags()} defines a list of short names associated to an
enumeration. It also defines the relative long names as they appear in the
meta-data

\code{initializeMetaDataset()} initializes meta-data data-set

\code{addElementToMetaDataset()} is used to add a line of information to
the meta-data \code{data.frame}. If the tag was already used it will update the
associated value(s) instead

\code{getColumnFromDF()} is a function to extract a column from a
\code{data.frame}, while keeping the \code{rowNames} as \code{vector} names

\code{setColumnInDF()} is a function to append, if missing, or resets, if
present, a column into a \code{data.frame}, whether the \code{data.frame} is empty or
not. The given \code{rowNames} are used only in the case the \code{data.frame} has
only the default row numbers, so this function cannot be used to override
row names

\code{getMetaInfoRow()} is an internal function: it extracts the row\
associated with the given tag if present or zero otherwise.

\code{updateMetaInfo()} is an internal function: updates an information
\code{data.frame}
}
\examples{
options(parallelly.fork.enable = TRUE)

data("test.dataset")
objCOTAN <- COTAN(raw = test.dataset)

objCOTAN <- initializeMetaDataset(objCOTAN, GEO = "test_GEO",
                                  sequencingMethod = "distribution_sampling",
                                  sampleCondition = "reconstructed_dataset")

objCOTAN <- addElementToMetaDataset(objCOTAN, "Test",
                                    c("These are ", "some values"))

dataSetInfo <- getMetadataDataset(objCOTAN)

numInitialCells <- getMetadataElement(objCOTAN, datasetTags()[["cells"]])

metaGenes <- getMetadataGenes(objCOTAN)

metaCells <- getMetadataCells(objCOTAN)

allSizes <- getDims(objCOTAN)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utilities.R
\name{LoggingFunctions}
\alias{LoggingFunctions}
\alias{setLoggingLevel}
\alias{setLoggingFile}
\alias{logThis}
\title{Logging in the \code{COTAN} package}
\usage{
setLoggingLevel(newLevel = 1L)

setLoggingFile(logFileName)

logThis(msg, logLevel = 2L, appendLF = TRUE)
}
\arguments{
\item{newLevel}{the new default logging level. It defaults to 1}

\item{logFileName}{the log file.}

\item{msg}{the message to print}

\item{logLevel}{the logging level of the current message. It defaults to 2}

\item{appendLF}{whether to add a new-line character at the end of the message}
}
\value{
\code{setLoggingLevel()} returns the old logging level or default level
if not set yet.

\code{logThis()} returns TRUE if the message has been printed on the
terminal
}
\description{
Logging is currently supported for all \code{COTAN} functions. It is
possible to see the output on the terminal and/or on a log file. The level
of output on terminal is controlled by the  \code{COTAN.LogLevel} option while
the logging on file is always at its maximum verbosity
}
\details{
\code{setLoggingLevel()} sets the \code{COTAN} logging level. It set the
\code{COTAN.LogLevel} options to one of the following values:
\itemize{
\item 0 - Always on log messages
\item 1 - Major log messages
\item 2 - Minor log messages
\item 3 - All log messages
}

\code{setLoggingFile()} sets the log file for all \code{COTAN} output logs. By
default no logging happens on a file (only on the console). Using this
function \code{COTAN} will use the indicated file to dump the logs produced by
all \code{\link[=logThis]{logThis()}} commands, independently from the log level. It stores the
\code{connection} created by the call to \code{\link[=bzfile]{bzfile()}} in the option:
\code{COTAN.LogFile}

\code{logThis()} prints the given message string if the current log level
is greater or equal to the given log level (it always prints its message on
file if active). It uses \code{\link[=message]{message()}} to actually print the messages on the
\code{\link[=stderr]{stderr()}} connection, so it is subject to \code{\link[=suppressMessages]{suppressMessages()}}
}
\examples{
setLoggingLevel(3) # for debugging purposes only

logFile <- file.path(".", "COTAN_Test1.log")
setLoggingFile(logFile)
logThis("Some log message")
setLoggingFile("") # closes the log file
file.remove(logFile)

logThis("LogLevel 0 messages will always show, ",
        logLevel = 0, appendLF = FALSE)
suppressMessages(logThis("unless all messages are suppressed",
                         logLevel = 0))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/heatmap-plot.R, R/utilities.R
\name{HeatmapPlots}
\alias{HeatmapPlots}
\alias{singleHeatmapDF}
\alias{heatmapPlot}
\alias{genesHeatmapPlot}
\alias{cellsHeatmapPlot}
\alias{plotTheme}
\title{Heatmap Plots}
\usage{
singleHeatmapDF(objCOTAN, genesLists, sets, pValueThreshold = 0.01, cores = 1L)

heatmapPlot(
  objCOTAN = NULL,
  genesLists,
  sets = NULL,
  pValueThreshold = 0.01,
  cores = 1L,
  conditions = NULL,
  dir = "."
)

genesHeatmapPlot(
  objCOTAN,
  primaryMarkers,
  secondaryMarkers = vector(mode = "character"),
  pValueThreshold = 0.01,
  symmetric = TRUE,
  cores = 1L
)

cellsHeatmapPlot(objCOTAN, cells = NULL, clusters = NULL)

plotTheme(plotKind = "common", textSize = 14L)
}
\arguments{
\item{objCOTAN}{a \code{COTAN} object}

\item{genesLists}{A \code{list} of genes' \code{array}s. The first \code{array} defines the
genes in the columns}

\item{sets}{A numeric array indicating which fields in the previous \code{list}
should be used. Defaults to all fields}

\item{pValueThreshold}{The p-value threshold. Default is 0.01}

\item{cores}{number of cores to use. Default is 1.}

\item{conditions}{An \code{array} of prefixes indicating the different files}

\item{dir}{The directory in which are all \code{COTAN} files (corresponding to the
previous prefixes)}

\item{primaryMarkers}{A set of genes plotted as rows}

\item{secondaryMarkers}{A set of genes plotted as columns}

\item{symmetric}{A Boolean: default \code{TRUE}. When \code{TRUE} the union of
\code{primaryMarkers} and \code{secondaryMarkers} is used for both rows and column
genes}

\item{cells}{Which cells to plot (all if no argument is given)}

\item{clusters}{Use this clusterization to select/reorder the cells to plot}

\item{plotKind}{a string indicating the plot kind}

\item{textSize}{axes and strip text size (default=14)}
}
\value{
\code{singleHeatmapDF()} returns a \code{data.frame}

\code{heatmapPlot()} returns a \code{ggplot2} object

\code{genesHeatmapPlot()} returns a \code{ggplot2} object

\code{cellsHeatmapPlot()} returns the cells' \code{COEX} \emph{heatmap} plot

\code{plotTheme()} returns a \code{ggplot2::theme} object
}
\description{
These functions create heatmap \code{COEX} plots.
}
\details{
\code{singleHeatmapDF()} creates the \code{heatmap} \code{data.frame} of one
\code{COTAN} object

\code{heatmapPlot()} creates the \code{heatmap} of one or more \code{COTAN} objects

\code{genesHeatmapPlot()} is used to plot an \emph{heatmap} made using only
some genes, as markers, and collecting all other genes correlated with
these markers with a p-value smaller than the set threshold. Than all
relations are plotted. Primary markers will be plotted as groups of rows.
Markers list will be plotted as columns.

\code{cellsHeatmapPlot()} creates the heatmap plot of the cells' \code{COEX}
matrix

\code{plotTheme()} returns the appropriate theme for the selected plot
kind. Supported kinds are:  \code{"common"}, \code{"pca"}, \code{"genes"}, \code{"UDE"},
\code{"heatmap"}, \code{"GDI"}, \code{"UMAP"}, \code{"size-plot"}
}
\examples{
data("test.dataset")
objCOTAN <- COTAN(raw = test.dataset)
objCOTAN <- clean(objCOTAN)
objCOTAN <- estimateLambdaLinear(objCOTAN)
objCOTAN <- estimateDispersionNuBisection(objCOTAN, cores = 6L)
objCOTAN <- calculateCoex(objCOTAN, actOnCells = FALSE)
objCOTAN <- calculateCoex(objCOTAN, actOnCells = TRUE,
                          optimizeForSpeed = FALSE)

## some genes
primaryMarkers <- c("g-000010", "g-000020", "g-000138")

## an example of named list of different gene set
groupMarkers <- list(G1 = primaryMarkers,
                     G2 = c("g-000300", "g-000330"),
                     G3 = c("g-000510", "g-000530", "g-000550",
                            "g-000570", "g-000590"))

hPlot <- heatmapPlot(objCOTAN, pValueThreshold = 0.05, cores = 3L,
                     genesLists = groupMarkers, sets = 2L:3L)
plot(hPlot)

ghPlot <- genesHeatmapPlot(objCOTAN, primaryMarkers = primaryMarkers,
                           secondaryMarkers = groupMarkers, cores = 3L,
                           pValueThreshold = 0.05, symmetric = FALSE)
plot(ghPlot)

clusters <- c(rep_len("1", getNumCells(objCOTAN)/2),
              rep_len("2", getNumCells(objCOTAN)/2))
names(clusters) <- getCells(objCOTAN)

chPlot <- cellsHeatmapPlot(objCOTAN, clusters = clusters)
## plot(chPlot)

theme <- plotTheme("pca")

}
\seealso{
\code{\link[ggplot2:theme]{ggplot2::theme()}} and \code{\link[ggplot2:ggplot]{ggplot2::ggplot()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\docType{class}
\name{COTAN-class}
\alias{COTAN-class}
\title{The \code{COTAN} class}
\value{
A \code{\linkS4class{COTAN}} object.
}
\description{
Definition of the \code{COTAN} class
}
\section{Slots}{

\describe{
\item{\code{raw}}{\code{dgCMatrix} - the raw \code{UMI} count matrix \eqn{n \times m} (gene
number × cell number)}

\item{\code{genesCoex}}{\code{dspMatrix} - the correlation of \code{COTAN} between genes,
\eqn{n \times n}}

\item{\code{cellsCoex}}{\code{dspMatrix} - the correlation of \code{COTAN} between cells,
\eqn{m \times m}}

\item{\code{metaDataset}}{\code{data.frame}}

\item{\code{metaCells}}{\code{data.frame}}

\item{\code{clustersCoex}}{a \code{list} of \code{COEX} \code{data.frames} for each clustering in
the \code{metaCells}}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/COTAN-getters.R, R/COTAN-modifiers.R,
%   R/establishGenesClusters.R, R/genesStatistics.R
\name{getGDI,COTAN-method}
\alias{getGDI,COTAN-method}
\alias{getGDI}
\alias{storeGDI,COTAN-method}
\alias{storeGDI}
\alias{GenesStatistics}
\alias{genesCoexSpace}
\alias{establishGenesClusters}
\alias{calculateGenesCE}
\alias{calculateGDIGivenS}
\alias{calculateGDIGivenCorr}
\alias{calculateGDI}
\alias{calculatePValue}
\alias{calculatePDI}
\title{Calculations of genes statistics}
\usage{
\S4method{getGDI}{COTAN}(objCOTAN)

\S4method{storeGDI}{COTAN}(objCOTAN, genesGDI)

genesCoexSpace(objCOTAN, primaryMarkers, numGenesPerMarker = 25L)

establishGenesClusters(
  objCOTAN,
  groupMarkers,
  numGenesPerMarker = 25L,
  kCuts = 6L,
  distance = "cosine",
  hclustMethod = "ward.D2"
)

calculateGenesCE(objCOTAN)

calculateGDIGivenS(S, rowsFraction = 0.05, cores = 1L, chunkSize = 1024L)

calculateGDIGivenCorr(corr, numDegreesOfFreedom, rowsFraction = 0.05)

calculateGDI(
  objCOTAN,
  statType = "S",
  rowsFraction = 0.05,
  cores = 1L,
  chunkSize = 1024L
)

calculatePValue(
  objCOTAN,
  statType = "S",
  geneSubsetCol = vector(mode = "character"),
  geneSubsetRow = vector(mode = "character"),
  cores = 1L,
  chunkSize = 1024L
)

calculatePDI(
  objCOTAN,
  statType = "S",
  geneSubsetCol = vector(mode = "character"),
  geneSubsetRow = vector(mode = "character")
)
}
\arguments{
\item{objCOTAN}{a \code{COTAN} object}

\item{genesGDI}{the named genes' \code{GDI} \code{array} to store or the output
\code{data.frame} of the function \code{\link[=calculateGDI]{calculateGDI()}}}

\item{primaryMarkers}{A vector of primary marker names.}

\item{numGenesPerMarker}{the number of correlated genes to keep as other
markers (default 25)}

\item{groupMarkers}{a named \code{list} with an element for each group comprised
of one or more marker genes}

\item{kCuts}{the number of estimated \emph{cluster} (this defines the height for
the tree cut)}

\item{distance}{type of distance to use. Default is \code{"cosine"}. Can be chosen
among those supported by \code{\link[parallelDist:parDist]{parallelDist::parDist()}}}

\item{hclustMethod}{default is "ward.D2" but can be any method defined by
\code{\link[stats:hclust]{stats::hclust()}} function}

\item{S}{a \code{matrix} object}

\item{rowsFraction}{The fraction of rows that will be averaged to calculate
the \code{GDI}. Defaults to \eqn{5\%}}

\item{cores}{number of cores to use. Default is 1.}

\item{chunkSize}{number of elements to solve in batch in a single core.
Default is 1024.}

\item{corr}{a \code{matrix} object, possibly a subset of the columns of the full
symmetric matrix}

\item{numDegreesOfFreedom}{a \code{int} that determines the number of degree of
freedom to use in the \eqn{\chi^{2}} test}

\item{statType}{Which statistics to use to compute the p-values. By default
it will use the "S" (Pearson's \eqn{\chi^{2}} test) otherwise the "G"
(G-test)}

\item{geneSubsetCol}{an array of genes. It will be put in columns. If left
empty the function will do it genome-wide.}

\item{geneSubsetRow}{an array of genes. It will be put in rows. If left empty
the function will do it genome-wide.}
}
\value{
\code{getGDI()} returns the genes' \verb{GDI`` array if available or }NULL`
otherwise

\code{storeGDI()} returns the given \code{COTAN} object  with updated \code{GDI}
genes' information

\code{genesCoexSpace()} returns a \code{list} with:
\itemize{
\item \code{"SecondaryMarkers"} a named \code{list} that for each secondary marker,
gives the \code{list} of primary markers that selected for it
\item \code{"GCS"} the relevant subset of \code{COEX} \code{matrix}
\item \code{"rankGenes"} a \code{data.frame} with the rank of each gene according to its
\emph{p-value}
}

\code{establishGenesClusters()} a \code{list} of:
\itemize{
\item \code{"g.space"} the genes' \code{COEX} space \code{data.frame}
\item \code{"plot.eig"} the eigenvalues plot
\item \code{"pca_clusters"} the \code{PCA} components \code{data.frame}
\item \code{"tree_plot"} the tree plot for the genes' \code{COEX} space
}

\code{calculateGenesCE()} returns a named \code{array} with the \emph{cross-entropy}
of each gene

\code{calculateGDIGivenS()} returns a \code{vector} with the \code{GDI} data for
each column of the input

\code{calculateGDIGivenCorr()} returns a \code{vector} with the \code{GDI} data for
each column of the input

\code{calculateGDI()} returns a \code{data.frame} with:
\itemize{
\item \code{"sum.raw.norm"} the sum of the normalized data rows
\item \code{"GDI"} the \code{GDI} data
\item \code{"exp.cells"} the percentage of cells expressing the gene
}

\code{calculatePValue()} returns a \emph{p-value} \code{matrix} as \code{dspMatrix}

\code{calculatePDI()} returns a \emph{Pair Differential Index} \code{matrix} as
\code{dspMatrix}
}
\description{
A collection of functions returning various statistics
associated to the genes. In particular the \emph{discrepancy} between the
expected probabilities of zero and their actual occurrences, both at single
gene level or looking at genes' pairs

To make the \code{GDI} more specific, it may be desirable to restrict
the set of genes against which \code{GDI} is computed to a selected subset, with
the recommendation to include a consistent fraction of cell-identity genes,
and possibly focusing on markers specific for the biological question of
interest (for instance neural cortex layering markers). In this case we
denote it as \emph{Local Differentiation Index} (\code{LDI}) relative to the selected
subset.
}
\details{
\code{getGDI()} extracts the genes' \code{GDI} array as it was stored by the
method \code{\link[=storeGDI]{storeGDI()}}

\code{storeGDI()} stored and already calculated genes' \code{GDI} \code{array} in a
\code{COTAN} object. It can be retrieved using the method \code{\link[=getGDI]{getGDI()}}

\code{genesCoexSpace()} calculates genes groups based on the primary
markers and uses them to prepare the genes' \code{COEX} space \code{data.frame}.

\code{establishGenesClusters()} perform the genes' clustering based on a
pool of gene markers, using the genes' \code{COEX} space

\code{calculateGenesCE()} is used to calculate the discrepancy between
the expected probability of zero and the observed zeros across all cells
for each gene as \emph{cross-entropy}: \eqn{-\sum_{c}{\mathbb{1}_{X_c == 0}
   \log(p_c) - \mathbb{1}_{X_c != 0} \log(1 - p_c)}} where \eqn{X_c} is the
observed count and \eqn{p_c} the probability of zero

\code{calculateGDIGivenS()} produces a \code{vector} with the \code{GDI} for each
column based on the \code{S} matrix (\emph{Pearson's \emph{\eqn{\chi^{2}}} test})

\code{calculateGDIGivenCorr()} produces a \code{vector} with the \code{GDI} for
each column based on the given correlation matrix, using the \emph{Pearson's
\emph{\eqn{\chi^{2}}} test}

\code{calculateGDI()} produces a \code{data.frame} with the \code{GDI} for each
gene based on the \code{COEX} matrix

\code{calculatePValue()} computes the p-values for genes in the \code{COTAN}
object. It can be used genome-wide or by setting some specific genes of
interest. By default it computes the \emph{p-values} using the \code{S} statistics
(\eqn{\chi^{2}})

\code{calculatePDI()} computes the p-values for genes in the \code{COTAN}
object using \code{\link[=calculatePValue]{calculatePValue()}} and takes their
\eqn{\log{({-\log{(\cdot)}})}} to calculate the genes' \emph{Pair Differential
Index}
}
\examples{
data("test.dataset")
objCOTAN <- COTAN(raw = test.dataset)
objCOTAN <- proceedToCoex(objCOTAN, cores = 6L, saveObj = FALSE)

markers <- getGenes(objCOTAN)[sample(getNumGenes(objCOTAN), 10)]
gCS <- genesCoexSpace(objCOTAN, primaryMarkers = markers,
                      numGenesPerMarker = 15)

groupMarkers <- list(G1 = c("g-000010", "g-000020", "g-000138"),
                     G2 = c("g-000300"),
                     G3 = c("g-000510", "g-000530", "g-000550",
                            "g-000570", "g-000590"))

resList <-  establishGenesClusters(objCOTAN, groupMarkers = groupMarkers,
                                   numGenesPerMarker = 11)

}
